<!DOCTYPE html>
<html>
<head>
	<meta http-equiv="X-UA-Compatible" content="IE=Edge" />
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />		
	<?php include_once(dirname(__FILE__)."/tools/all_header.php"); global $c_scheme, $timezone, $rel_path; ?>
	<script>
		var js_debug = false;
		$data_changed = false;	
	</script>
	
    <title>Cycle Times</title>
	
	<link rel="stylesheet" href="./css/qb.php" />
	<link rel="stylesheet" type="text/css" href="./jqplot/jquery.jqplot.css" />		
		
	<script src="./jquery/jquery.min.js"></script>
	<script src="./jquery/jquery-migrate-1.2.1.min.js"></script>	
	<script src="./jquery/jquery-ui.min.js"></script>
	<script src="./jquery/qb_js.js"></script>
	
	<script src="./jqplot/jquery.jqplot.min.js"></script>
	<script src="./jqplot/plugins/jqplot.barRenderer.min.js"></script>
	<script src="./jqplot/plugins/jqplot.pieRenderer.min.js"></script>
	<script src="./jqplot/plugins/jqplot.categoryAxisRenderer.min.js"></script>
	<script src="./jqplot/plugins/jqplot.boxplotRenderer.js"></script>
	<script src="./jqplot/plugins/jqplot.highlighter.min.js"></script>
	<script src="./jqplot/plugins/jqplot.pointLabels.min.js"></script>
    <script src="./jqplot/plugins/jqplot.canvasTextRenderer.min.js"></script>
    <script src="./jqplot/plugins/jqplot.canvasAxisLabelRenderer.min.js"></script>
	<script src="./jqplot/plugins/jqplot.enhancedLegendRenderer.min.js"></script>
    <script src="./jqplot/plugins/jqplot.canvasAxisTickRenderer.min.js"></script>
	<script src="./jqplot/plugins/jqplot.canvasOverlay.min.js"></script>

	<?php
		$query = "
			SELECT 
				DATE_FORMAT(NOW(), '%Y-%m-%d'), 
				DATEDIFF(MAX(QBREGDATE), NOW()), 
				DATEDIFF(MIN(QBREGDATE), NOW()),
				MIN(QBREGDATE),
				MAX(QBREGDATE),
				IF (DATEDIFF(MAX(QBREGDATE), MIN(QBREGDATE)) > 365, DATE_SUB(MAX(QBREGDATE), INTERVAL 365 DAY), MIN(QBREGDATE))
			FROM 
				qbi 
			WHERE 
				QBSTATUS NOT IN ('M', 'D')
		";
		$stmt = $db->query($query);
		list($now, $diffmax, $diffmin, $min, $max, $lmin) = $stmt->fetch(PDO::FETCH_NUM );
	?>
	<script>
	// load translation and save in localTranslation
		<?php	
			$ini_adlz = parse_ini_file($rel_path.'i18n/a_dlz.ini', true);	
			echo "localTranslation = {};";
			foreach($ini_adlz as $key=>$value){
				$add = "";
				foreach($value AS $lan=>$trans){
					$add .= "'".$lan."':'".$trans."',";
				}
				echo "localTranslation['".$key."']={".rtrim($add, ',')."};";
			}
			$ini_class = parse_ini_file($rel_path.'xml/class.ini', true);
			$ini_class['all']=$ini_adlz['all'];
			echo "classTranslation = {};";
			foreach($ini_class as $key=>$value){
				$add = "";
				foreach($value AS $lan=>$trans){
					$add .= "'".$lan."':'".$trans."',";
				}
				echo "classTranslation['".$key."']={".rtrim($add, ',')."};";
			}			
			$cal = parse_ini_file($rel_path.'i18n/calendar.ini', true);
			echo "calTranslation = {};";
			foreach($cal as $key=>$value){
				$add = "";
				if ($value['tpe'] == "S") {
					foreach($value AS $lan=>$trans){
						if ($lan != "tpe") $add .= "'".$lan."':'".$trans."',";
					}
				} else {
					foreach($value AS $lan=>$trans){
						if ($lan != "tpe") {
							$tar = explode(",", $trans);
							$tar = implode("','", $tar);
							$add .= "'".$lan."': ['".$tar."'],";
						}
					}				
				}
				echo "calTranslation['".$key."']={".rtrim($add, ',')."};";
			}
		?>
	</script>
</head>
<body>
	<div id="container">
		<?php 
			include_once($rel_path.'tools/header.php');
		?> 
		<div id="contents">
			<?php 
				echo "<div id='mainnav'>". $qb_support->get_main_menu(2) . "</div>";
			?>
			<div class="dtop">
				<span class="icn3_arraoleft_w_n clckbtn" style="float: left; font-size: 30px; margin-left: 5px;" data-type="title" data-lan="prev" title="<?php echo $ini_adlz['prev'][$_SESSION['lng']]; ?>" onclick="backtoanalysis()"></span>
				<span data-type="text" data-lan="dlz"><?php echo $ini_adlz['dlz'][$_SESSION['lng']]; ?></span>
			</div>
			<div id="btn_div" class="btn_div">
				<p>
					<label class="dlabel vam w50" data-type="text" data-lan="start" ><?php echo $ini_adlz['start'][$_SESSION['lng']]; ?></label>
					<input type="text" id="sdat" data-type="date" data-lan="#sdat_org" class="dinputw vam w80" value="" onchange="update_chart()" readonly />
					<input type="hidden" id="sdat_org" value="" />
					<input type="hidden" id="sdat_i" value="" />
				</p>
				<p style="margin: 5px 0;">
					<label class="dlabel vam w50" data-type="text" data-lan="ende" ><?php echo $ini_adlz['ende'][$_SESSION['lng']]; ?></label>
					<input type="text" id="edat" data-type="date" data-lan="#edat_org" class="dinputw vam w80" value="" onchange="update_chart()" readonly />
					<input type="hidden" id="edat_org" value="" />
					<input type="hidden" id="edat_i" value="" />
				</p>
				<p style="margin-top: 15px; padding-bottom: 10px; border-bottom: 2px solid;"<?php echo $c_scheme['RN']; ?>";">
					<select id="clss" data-type="select" data-lan="clss" onchange="update_chart()" >
						<?php
							foreach($ini_class as $key=>$value){
								echo "<option value='$key'>".$value[$_SESSION['lng']]."</option>";
							}
						?>
					</select>
				</p>
				<div style="text-align: center; margin-top: 30px;">
          <span class="spanbuttonps" id="n2ab" data-type="text" data-lan="n2a" onclick="draw_chart('n2a')"><?php echo $ini_adlz['n2a'][$_SESSION['lng']]; ?></span>
					<span class="spanbuttonps" id="n2tb" data-type="text" data-lan="n2t" onclick="draw_chart('n2t')"><?php echo $ini_adlz['n2t'][$_SESSION['lng']]; ?></span>
					<span class="spanbuttonp" id="t2cb" data-type="text" data-lan="t2c" onclick="draw_chart('t2c')"><?php echo $ini_adlz['t2c'][$_SESSION['lng']]; ?></span>
					<span class="spanbuttonp" id="n2cb" data-type="text" data-lan="n2c" onclick="draw_chart('n2c')"><?php echo $ini_adlz['n2c'][$_SESSION['lng']]; ?></span>
					<?php if ($qb_support->getoptions('qblight', 'set') == "yes") { ?>
						<span class="spanbuttonp" id="n2clb" data-type="text" data-lan="n2cl" onclick="draw_chart('n2cl')"><?php echo $ini_adlz['n2cl'][$_SESSION['lng']]; ?></span>
					<?php } ?>
				</div>
			</div>
		<!-- container for chart -->				
			<div style="border: 0px solid green; display: inline-block; vertical-align: top; margin: 0; padding: 0; padding-top: 25px;">
				<div id="chartdiv" style="display: inline-block; vertical-align: top; height:560px; width:710px; margin: 0;"></div>
				<div id="boxplotdiv" style="display: inline-block; vertical-align: top; height:530px; width:100px; margin: auto;"></div>
			</div>
		</div>
		<?php include_once($rel_path.'footer.php'); ?> 
	</div>
	<script>
		pickerOpts = {
			closeText: "X",		
			dateFormat: "yy-M-dd",
			altField: '#sdat_org',
			altFormat: 'yy-mm-dd',
			firstDay: 1,
			isRTL: false,
			showButtonPanel: true,
			displayClose: true,
			showOn: "button",  
			buttonImage: "./img/dummy_img.png", 
			buttonImageOnly: true,
			buttonText: localTranslation["cal"][$globlan],
			changeYear: true,
			changeMonth: true,
			maxDate: "+<?php echo $diffmax;?>d",
			minDate: "-<?php echo $diffmin;?>d"		
		}
		pickerOpts_2 = {
			closeText: "X",		
			dateFormat: "yy-M-dd",
			altField: '#edat_org',
			altFormat: 'yy-mm-dd',
			firstDay: 1,
			isRTL: false,
			showButtonPanel: true,
			displayClose: true,
			showOn: "button",  
			buttonImage: "./img/dummy_img.png", 
			buttonImageOnly: true,
			buttonText: localTranslation["cal"][$globlan],
			changeYear: true,
			changeMonth: true,
			maxDate: "+<?php echo $diffmax;?>d",
			minDate: "-<?php echo $diffmin;?>d"	
		}		
				
	// fix um bei klicken auf "Heute" den Kalender zu schliessen	
		var old_goToToday = $.datepicker._gotoToday;
		$.datepicker._gotoToday = function(id) {
			old_goToToday.call(this,id);   
			this._selectDate(id);
			$heute = true;
		};

		$.datepicker._defaults['currentText'] = calTranslation['currentText'][$globlan];
		$.datepicker._defaults['monthNames'] = calTranslation['monthNames'][$globlan];
		$.datepicker._defaults['monthNamesShort'] = calTranslation['monthNamesShort'][$globlan];
		$.datepicker._defaults['dayNamesMin'] = calTranslation['dayNamesMin'][$globlan];
		
		$("#sdat").datepicker(pickerOpts);
		clkevnt = $("#sdat").next().data('events').click[0].handler;
		$("#sdat").next().replaceWith('<span class="ui-datepicker-trigger icn_calendar_b_n clckbtn vam" data-type="title" data-lan="cal" title="<?php echo $ini_adlz['cal'][$_SESSION['lng']]; ?>"> </span>');
		$("#sdat").next().bind('click', clkevnt);		
		$("#edat").datepicker(pickerOpts_2);
		clkevnt = $("#edat").next().data('events').click[0].handler;
		$("#edat").next().replaceWith('<span class="ui-datepicker-trigger icn_calendar_b_n clckbtn vam" data-type="title" data-lan="cal" title="<?php echo $ini_adlz['cal'][$_SESSION['lng']]; ?>"> </span>');
		$("#edat").next().bind('click', clkevnt);
		
		$('#clss').val("T");
		$('#clss').width(175).customSelect({customClass: "cSelect_wht"});
		
		function load_page() {
      if (location.search.length == 0) {
        $("#sdat").val(localizedate("<?php echo $lmin; ?>"));
        $("#edat").val(localizedate("<?php echo $max; ?>"));
        $("#sdat_org").val("<?php echo $lmin; ?>");
        $("#edat_org").val("<?php echo $max; ?>");
        $("#sdat_i").val("<?php echo $lmin; ?>");			// min start date
        $("#edat_i").val("<?php echo $max; ?>");			// max end date	
        draw_chart("n2t");
      } else {
        urlParams = new URLSearchParams(location.search);
        $("#sdat").val(localizedate(urlParams.get('s')));
        $("#edat").val(localizedate(urlParams.get('e')));
        $("#sdat_org").val(urlParams.get('s'));
        $("#edat_org").val(urlParams.get('e'));
        $("#sdat_i").val("<?php echo $lmin; ?>");			// min start date
        $("#edat_i").val("<?php echo $max; ?>");			// max end date
        $('#clss').val(urlParams.get('cl'));
        $('#clss').trigger('render');
        draw_chart(urlParams.get('bt'));
      }
		}
	// switch language
		function c_lan() {
			translate_header($globlan);	
			translate_mainmenu($globlan);
			$.each($('#container *').filter(function(){return $(this).data('lan') !== undefined;}), function() {	
				switch ($(this).data("type")) {
					case "text":		
						$(this).text(localTranslation[$(this).data("lan")][$globlan]);
						break;
					case "title":				
						$(this).attr("title", localTranslation[$(this).data("lan")][$globlan]);
						break;
					case "date":
						$(this).val(localizedate($($(this).data("lan")).val()));
						break;
					case "select":
						if ($(this).data("lan") == "clss") {
							$(this).find("option").each(function() {
								$(this).text(classTranslation[$(this).val()][$globlan]);
							});
							$('#clss').trigger('render');
						}
						break;						
				}
			});
			plot1.replot({
				axes:{
					yaxis:{
						label: localTranslation['count'][$globlan]
					},
					xaxis:{
						label: localTranslation['days'][$globlan]
					}
				}						
			});	
			$.datepicker._defaults['currentText'] = calTranslation['currentText'][$globlan];
			$.datepicker._defaults['monthNames'] = calTranslation['monthNames'][$globlan];
			$.datepicker._defaults['monthNamesShort'] = calTranslation['monthNamesShort'][$globlan];
			$.datepicker._defaults['dayNamesMin'] = calTranslation['dayNamesMin'][$globlan];			
		}
		function backtoanalysis() {
			window.location.href = "./analysis.php";
		}
		function getmax2(loc) {	
			var t = loc[0];
			$(loc).each (function (i,n){		
				if ((n[1]*1)>(t[1]*1)) t=n;			
			});
			return t[1];
		}
		function n2cl() {
			$("#loading").show();
		// change highlighted button
			$("#btn_div span[data-type='text']").removeClass("spanbuttonps").addClass("spanbuttonp");
			$("#n2clb").addClass("spanbuttonps");
			$("#chartdiv").empty().attr("data-chart", "n2cl");
			$.ajax({
				type: "GET",
				cache: false,
				url:  "./tools/a_dlz_api.php",
				data: { 
					routine: "n2cl",
					from: $("#sdat_org").val(),
					to: $("#edat_org").val(),
					clss: $("#clss").val()
				},
				dataType: "json",
				success: function(qbresult)
				{
					$marker = 0;
					$.each(qbresult, function(i){			
						if (qbresult[i][0] <= 14) $marker = (i + 1);
					});				
					optionObj = {
						captureRightClick: true,
						axes:{
							yaxis:{
								min:0, 
								max: (getmax2(qbresult)*1)*1.2,
								tickOptions: {formatString: '%d'},
								label: localTranslation['count'][$globlan],
								labelRenderer: $.jqplot.CanvasAxisLabelRenderer,
								labelOptions:{
									angel: 90,
									textColor: "<?php echo $c_scheme['GT']; ?>"
								}							
							},
							xaxis:{
								min:0, 
								max: qbresult.length,
								tickOptions: {formatString: '%d'},					
								renderer:$.jqplot.CategoryAxisRenderer,
								label: localTranslation['days'][$globlan]
							}
						},
						highlighter: { show: false },
						grid: 
						{         
							gridLineWidth: 2.5,         
							gridLineColor: "<?php echo $c_scheme['GG']; ?>",         
							drawGridlines: true,
							shadow:false, 
							borderWidth:1.0,
							background: "<?php echo $c_scheme['GB']; ?>"
						},					
						seriesDefaults:{
							renderer:$.jqplot.BarRenderer,
							rendererOptions: {
								highlightMouseOver: false,
								barWidth: 30,
								shadowDepth: 0,
								varyBarColor: true
							},
							pointLabels: { 
								show: true, 
								location: 'n', 
								ypadding: 2 
							}					
						},
						seriesColors: [ "<?php echo $c_scheme['G1']; ?>", "<?php echo $c_scheme['G2']; ?>"]
					};
					plot1 = $.jqplot('chartdiv', [qbresult], optionObj);
					$("#loading").hide();
				}
			});	
			
			$("#boxplotdiv").empty();		
			$.ajax({
				type: "GET",
				cache: false,
				url:  "./tools/a_dlz_api.php",
				data: { 
					routine: "n2cl_box",
					from: $("#sdat_org").val(),
					to: $("#edat_org").val(),
					clss: $("#clss").val()
				},
				success: function(result)
				{
					var bwresult = JSON.parse(result);				
					optionObj2 = {
						captureRightClick: true,
						axes:{
							yaxis:{
								min: 0,
								max: Math.ceil(bwresult[0][5]*1.1),
								tickOptions: {formatString: '%d'}
							},
							xaxis:{
								min: 0,
								max: 2,
								showTicks: false
							}
						},
						highlighter: { 
							show: true,
							tooltipContentEditor: function (str, seriesIndex, pointIndex, plot) {
								var p05 = plot.data[seriesIndex][pointIndex][1];
								var p25 = plot.data[seriesIndex][pointIndex][2];
								var p50 = plot.data[seriesIndex][pointIndex][3];
								var p75 = plot.data[seriesIndex][pointIndex][4];
								var p95 = plot.data[seriesIndex][pointIndex][5];

								var html = '<table class="jqplot-highlighter">';
								html += '<tr><td>95% </td><td>'+p95+'</td></tr>';
								html += '<tr><td>75% </td><td>'+p75+'</td></tr>';
								html += '<tr><td>med:</td><td>'+p50+'</td></tr>';
								html += '<tr><td>25% </td><td>'+p25+'</td></tr>';
								html += '<tr><td>5% </td><td>'+p05+'</td></tr>';
								html += '</table>';
								return html;
							}
						},
						series: [
							{
								renderer:$.jqplot.BoxplotRenderer,
								rendererOptions: {
									boxWidth: 30
								}
							}
						]
					};
					var plot2 = $.jqplot('boxplotdiv', [bwresult], optionObj2);				
				}
			});		
		}
		function update_chart(){
			fn = $(".spanbuttonps").attr("id").substr(0, $(".spanbuttonps").attr("id").length-1);
			draw_chart(fn);		
		}
		function draw_chart(loc) {
			$("#loading").show();
		// change highlighted button
			$("#btn_div span[data-type='text']").removeClass("spanbuttonps").addClass("spanbuttonp");
			$("#"+loc+"b").addClass("spanbuttonps");
			$("#chartdiv").empty();
			$("#boxplotdiv").empty();			
			$.ajax({
				type: "GET",
				cache: false,
				url:  "./tools/a_dlz_api.php",
				data: {
					routine: loc,
					from: $("#sdat_org").val(),
					to: $("#edat_org").val(),
					clss: $("#clss").val()
				},
				dataType: "json",
				success: function(result)
				{
					qbresult = result[0];
					sumresult = result[2];
          chartmax = result[3]*1.1;
					if (qbresult.length == 0) {
						$("#chartdiv").html("<label class='dlabel' style='text-align: center; margin-top: 200px; width: 100%; font: bold 14pt Arial; color: <?php echo $c_scheme['XW']; ?>;' data-type='text' data-lan='no_data'>"+localTranslation['no_data'][$globlan]+"</label>");
						$("#loading").hide();
						return false;
					}					
					optionObj = {
						captureRightClick: true,
						axes:{
							yaxis:{
								min:0,
                max: chartmax,
								tickOptions: {formatString: '%d'},
								label: localTranslation['count'][$globlan],
								labelRenderer: $.jqplot.CanvasAxisLabelRenderer,
								labelOptions:{
									angel: 90,
									textColor: "<?php echo $c_scheme['GT']; ?>"
								}							
							},
							xaxis:{
								min:0, 
								tickOptions: {formatString: '%d'},					
								renderer:$.jqplot.CategoryAxisRenderer,
								label: localTranslation['days'][$globlan]
							}
						},
						highlighter: { show: false },
						grid: 
						{         
							gridLineWidth: 1,         
							gridLineColor: "<?php echo $c_scheme['GG']; ?>",         
							drawGridlines: true,
							shadow:false, 
							borderWidth:1.0,
							background: "<?php echo $c_scheme['GB']; ?>"
						},					
						seriesDefaults:{
							renderer:$.jqplot.BarRenderer,
							rendererOptions: {
								highlightMouseOver: false,
								shadowDepth: 0,
								varyBarColor: true,
								barMargin: 2,
								barPadding:2								
							},
							pointLabels: { 
								show: true, 
								location: 'n', 
								ypadding: 2 
							}					
						},
						seriesColors: [ "<?php echo $c_scheme['G1']; ?>", "<?php echo $c_scheme['G2']; ?>"],
						title: {
							text: "# "+sumresult,
							show: true
						}						
					};
					plot1 = $.jqplot('chartdiv', [qbresult], optionObj);
				// box whisker plot
					bwresult = result[1];
					optionObj2 = {
						captureRightClick: true,
						axes:{
							yaxis:{
								min: 0,
								max: Math.ceil(bwresult[0][5]*1.1),
								tickOptions: {formatString: '%d'}
							},
							xaxis:{
								min: 0,
								max: 2,
								showTicks: false
							}
						},
						highlighter: { 
							show: true,
							tooltipContentEditor: function (str, seriesIndex, pointIndex, plot) {
								var p05 = plot.data[seriesIndex][pointIndex][1];
								var p25 = plot.data[seriesIndex][pointIndex][2];
								var p50 = plot.data[seriesIndex][pointIndex][3];
								var p75 = plot.data[seriesIndex][pointIndex][4];
								var p95 = plot.data[seriesIndex][pointIndex][5];

								var html = '<table class="jqplot-highlighter">';
								html += '<tr><td>95% </td><td>'+p95+'</td></tr>';
								html += '<tr><td>75% </td><td>'+p75+'</td></tr>';
								html += '<tr><td>med:</td><td>'+p50+'</td></tr>';
								html += '<tr><td>25% </td><td>'+p25+'</td></tr>';
								html += '<tr><td>5% </td><td>'+p05+'</td></tr>';
								html += '</table>';
								return html;
							}	
						},
						series: [
							{
								renderer:$.jqplot.BoxplotRenderer,
								rendererOptions: {
									boxWidth: 30
								}
							}
						]
					};
          $('#chartdiv').unbind('jqplotMouseDown').bind('jqplotMouseDown', function (ev, seriesIndex, pointIndex, data) {
            if (data == null) return;        
            window.location.href = "a_dlz_table.php?cc="+qbresult[data['pointIndex']][0]+"&s="+$("#sdat_org").val()+"&e="+$("#edat_org").val()+"&cl="+$("#clss").val()+"&bt="+loc;
          });
					var plot2 = $.jqplot('boxplotdiv', [bwresult], optionObj2);						
					$("#loading").hide();
				}
			});	
		}		
		load_page();
	</script>
</body>
</html>
