<!DOCTYPE html>
<html>
<head>
	<meta http-equiv="X-UA-Compatible" content="IE=Edge" />
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />		
	<?php include_once(dirname(__FILE__)."/tools/all_header.php"); global $c_scheme, $timezone, $rel_path; ?>
	<script>
		var js_debug = false;
		$data_changed = false;		
	</script>
	
    <title>DLZ2</title>
	
	<link rel="stylesheet" href="./css/qb.php" />
	<link rel="stylesheet" type="text/css" href="./jqplot/jquery.jqplot.css" />
	
	<script src="./jquery/jquery.min.js"></script>
	<script src="./jquery/jquery-migrate-1.2.1.min.js"></script>	
	<script src="./jquery/jquery-ui.min.js"></script>
	<script src="./jquery/qb_js.js"></script>
	
	<script src="./jqplot/jquery.jqplot.min.js"></script>
	<script src="./jqplot/plugins/jqplot.barRenderer.min.js"></script>
	<script src="./jqplot/plugins/jqplot.pieRenderer.min.js"></script>
	<script src="./jqplot/plugins/jqplot.categoryAxisRenderer.min.js"></script>
	<script src="./jqplot/plugins/jqplot.boxplotRenderer.js"></script>
	<script src="./jqplot/plugins/jqplot.highlighter.min.js"></script>
	<script src="./jqplot/plugins/jqplot.pointLabels.min.js"></script>
    <script src="./jqplot/plugins/jqplot.canvasTextRenderer.min.js"></script>
    <script src="./jqplot/plugins/jqplot.canvasAxisLabelRenderer.min.js"></script>
	<script src="./jqplot/plugins/jqplot.enhancedLegendRenderer.min.js"></script>
    <script src="./jqplot/plugins/jqplot.canvasAxisTickRenderer.min.js"></script>
	<script src="./jqplot/plugins/jqplot.canvasOverlay.min.js"></script>

	<script>
	// load translation and save in localTranslation
		<?php	
			$ini_adlz2 = parse_ini_file($rel_path.'i18n/a_dlz2.ini', true);	
			echo "localTranslation = {};";
			foreach($ini_adlz2 as $key=>$value){
				$add = "";
				foreach($value AS $lan=>$trans){
					$add .= "'".$lan."':'".$trans."',";
				}
				echo "localTranslation['".$key."']={".rtrim($add, ',')."};";
			}
			$ini_class = parse_ini_file($rel_path.'xml/class.ini', true);
			$ini_class['all']=$ini_adlz2['all'];
			echo "classTranslation = {};";
			foreach($ini_class as $key=>$value){
				$add = "";
				foreach($value AS $lan=>$trans){
					$add .= "'".$lan."':'".$trans."',";
				}
				echo "classTranslation['".$key."']={".rtrim($add, ',')."};";
			}				
			$cal = parse_ini_file($rel_path.'i18n/calendar.ini', true);
			echo "calTranslation = {};";
			foreach($cal as $key=>$value){
				$add = "";
				if ($value['tpe'] == "S") {
					foreach($value AS $lan=>$trans){
						if ($lan != "tpe") $add .= "'".$lan."':'".$trans."',";
					}
				} else {
					foreach($value AS $lan=>$trans){
						if ($lan != "tpe") {
							$tar = explode(",", $trans);
							$tar = implode("','", $tar);
							$add .= "'".$lan."': ['".$tar."'],";
						}
					}				
				}
				echo "calTranslation['".$key."']={".rtrim($add, ',')."};";
			}
		?>
	</script>
</head>
<body>
	<div id="container">
		<?php 
			include_once($rel_path.'tools/header.php');
		?> 
		<div id="contents">
			<?php 
				echo "<div id='mainnav'>". $qb_support->get_main_menu(2) . "</div>";
			?>
			<div class="dtop">
				<span class="icn3_arraoleft_w_n clckbtn" style="float: left; font-size: 30px; margin-left: 5px;" data-type="title" data-lan="prev" title="<?php echo $ini_adlz2['prev'][$_SESSION['lng']]; ?>" onclick="backtoanalysis()"></span>
				<span data-type="span" data-lan="dlz"></span>
			</div>
			<div id="btn_div" class="btn_div" style="width: 230px;" >
				<p>
					<label class="dlabel vam w100" data-type="text" data-lan="offset" ><?php echo $ini_adlz2['offset'][$_SESSION['lng']]; ?></label>
					<select id="off" onchange="update_chart()">
						<option selected value="0">0</option>
						<option value="1">1</option>
						<option value="2">2</option>
						<option value="2">3</option>
						<option value="4">4</option>
						<option value="5">5</option>
						<option value="6">6</option>
						<option value="7">7</option>
						<option value="8">8</option>
						<option value="9">9</option>
						<option value="10">10</option>
						<option value="11">11</option>
						<option value="12">12</option>							
					</select>
					<label class="dlabel vam w75" data-type="text" data-lan="monate" ><?php echo $ini_adlz2['monate'][$_SESSION['lng']]; ?></label>
				</p>
				<p style="margin: 5px 0;">
					<label class="dlabel vam w100" data-type="text" data-lan="average" ><?php echo $ini_adlz2['average'][$_SESSION['lng']]; ?></label>
					<select id="avg" onchange="update_chart()">
						<option value="1">1</option>
						<option selected value="3">3</option>
						<option value="6">6</option>
						<option value="12">12</option>
					</select>
					<label class="dlabel vam w75" data-type="text" data-lan="monate" ><?php echo $ini_adlz2['monate'][$_SESSION['lng']]; ?></label>
				</p>
				<p style="margin-top: 15px; padding-bottom: 10px; border-bottom: 2px solid "<?php echo $c_scheme['RN']; ?>";">
					<select id="clss" data-type="select" data-lan="clss" onchange="update_chart()" >
						<?php
							foreach($ini_class as $key=>$value){
								echo "<option value='$key'>".$value[$_SESSION['lng']]."</option>";
							}
						?>
					</select>
				</p>
				<div style="text-align: center; margin-top: 30px;">
					<span class="spanbuttonps" id="n2tb" data-type="text" data-lan="n2t" onclick="update_chart('n2t')"><?php echo $ini_adlz2['n2t'][$_SESSION['lng']]; ?></span>
					<span class="spanbuttonp" id="t2cb" data-type="text" data-lan="t2c" onclick="update_chart('t2c')"><?php echo $ini_adlz2['t2c'][$_SESSION['lng']]; ?></span>
					<span class="spanbuttonp" id="n2cb" data-type="text" data-lan="n2c" onclick="update_chart('n2c')"><?php echo $ini_adlz2['n2c'][$_SESSION['lng']]; ?></span>
					<?php if ($qb_support->getoptions('qblight', 'set') == "yes") { ?>
						<span class="spanbuttonp" id="n2clb" data-type="text" data-lan="n2cl" onclick="update_chart('n2cl')"><?php echo $ini_adlz2['n2cl'][$_SESSION['lng']]; ?></span>
					<?php } ?>
					<br /><br />
					<label class="dlabel vam w150" style="font-weight: bold;" data-type="text" data-lan="depts" ><?php echo $ini_adlz2['depts'][$_SESSION['lng']]; ?></label>				
					<select id="depts" class="sselect vam w150" onchange="update_chart()" size="10" style="margin: 5px 0px; height: 100px; border: 1px solid #CCCCCC;" multiple >
						<option value="all" selected><?php echo $ini_adlz2['all'][$_SESSION['lng']]; ?></option>
						<?php
							$sd = date("Y-m", strtotime(date('Y-m-d', time()) . "-2 year"));
							$ed = date('Y-m', time());
							$query = "
								SELECT 
									DEPARTMENT
								FROM 
									qbi 
								LEFT JOIN 
									qb_team 
								ON 
									qbi.QBN=qb_team.QBN 
								LEFT JOIN 
									qb_user 
								ON 
									NAME=LOGIN 
								WHERE 
									ROLLE='PL' AND 
									QBSTATUS NOT IN ('M', 'D') AND
									QBREGDATE>=:sdat AND
									QBREGDATE<=:edat
								GROUP BY 
									DEPARTMENT
							";
							$stmt = $db->prepare($query);
							$stmt->execute(
								array(
									':sdat' => $sd,
									':edat' => $ed
								)
							);
							while($r = $stmt->fetch(PDO::FETCH_NUM)) {		
								echo "<option value='".$r[0]."'>".$r[0]."</option>";
							}								
						?>
					</select>
				</div>
			</div>			
	<!-- container for chart -->
			<div id="chartdiv" style="display: inline-block; height:500px; width:760px; margin: auto; margin-top: 70px;"></div>
		</div>
		<?php include_once($rel_path.'footer.php'); ?> 
	</div>
	<script>
		$('#off').width(30).customSelect({customClass: "cSelect_wht"});	
		$('#avg').width(30).customSelect({customClass: "cSelect_wht"});
		$('#clss').val("T");
		$('#clss').width(220).customSelect({customClass: "cSelect_wht"});		
		
		function load_page() {
			update_chart('n2t');	
		}
	// switch language
		function c_lan(loc) {
			translate_header($globlan);	
			translate_mainmenu($globlan);
			$.each($('#container *').filter(function(){return $(this).data('lan') !== undefined;}), function() {	
				switch ($(this).data("type")) {
					case "text":		
						$(this).text(localTranslation[$(this).data("lan")][$globlan]);
						break;
					case "title":				
						$(this).attr("title", localTranslation[$(this).data("lan")][$globlan]);
						break;
					case "select":
						if ($(this).data("lan") == "clss") {
							$(this).find("option").each(function() {
								$(this).text(classTranslation[$(this).val()][$globlan]);
							});
							$('#clss').trigger('render');
						}
						break;						
				}
			});	
			$("#depts option").eq(0).text(localTranslation["all"][$globlan]);
			plot1.replot({
				axes:{
					yaxis:{
						label: localTranslation['days'][$globlan]
					},
					xaxis:{
						label: localTranslation['month_txt'][$globlan]
					}
				},						
			});
		}
		function backtoanalysis() {
			window.location.href="./analysis.php";
		}
		function load_chart() {
			$("#loading").show();
		// change highlighted button
			$("#btn_div span[data-type='text']").removeClass("spanbuttonps").addClass("spanbuttonp");
			$("#"+$("#chartdiv").attr("name")+"b").addClass("spanbuttonps");	
			$("#chartdiv").empty();
			$.ajax({
				type: "GET",
				cache: false,
				url:  "./tools/a_dlz2_api.php",
				data: { 
					routine: $("#chartdiv").attr("name"),
					avg: $("#avg").val(),
					off: $("#off").val(),
					clss: $("#clss").val(),
					depts: "'"+$("#depts").val().join("','")+"'"
				},
				dataType: "json",
				success: function(qbresult)
				{
					var sum = 0;
					$.each(qbresult[1],function(){sum+=parseFloat(this) || 0;});			
					if (sum > 0) {
						optionObj = {
							captureRightClick: true,
							grid:{shadow:false, borderWidth:1.0},
							axes:{
								yaxis:{
									min:0, 
									max: Math.max.apply(Math,qbresult[1])*1.1,
									tickOptions: {formatString: '%d'},
									label: localTranslation['days'][$globlan],
									labelRenderer: $.jqplot.CanvasAxisLabelRenderer,
									labelOptions:{
										angel: 90,
										textColor: "<?php echo $c_scheme['GT']; ?>"
									}							
								},
								xaxis:{
									min:0, 
									max: qbresult[0].length,
									tickOptions: {
										formatString: '%d',
										angle: -30,
										fontSize: '8pt',
										fontFamily:'Helvetica'
									},							
									tickRenderer:$.jqplot.CanvasAxisTickRenderer, 
									renderer:$.jqplot.CategoryAxisRenderer,
									ticks: qbresult[0],
									label: localTranslation['month_txt'][$globlan]
								}
							},
							highlighter: { show: false },
							grid: 
							{         
								gridLineWidth: 2.5,         
								gridLineColor: "<?php echo $c_scheme['GG']; ?>",         
								drawGridlines: true,
								shadow:false, 
								borderWidth:1.0,
								background: "<?php echo $c_scheme['GB']; ?>"
							},						
							seriesDefaults:{
								renderer: $.jqplot.LineRenderer,
								rendererOptions: {
									highlightMouseOver: false,
									barWidth: 20
								},
								pointLabels: { 
									show: true, 
									location: 'n', 
									ypadding: 2,
									hideZeros: true
								}					
							},				
							series:[
								{
									lineWidth: 4, 
									color: "<?php echo $c_scheme['G1']; ?>",
									markerOptions: { 
										size: 12
									}
								}
							]
						};
						plot1 = $.jqplot('chartdiv', [qbresult[1]], optionObj);	
					} else {
						$("#chartdiv").append("<p style='color: <?php echo $c_scheme['IW']; ?>; font: bold 12pt Arial; margin: auto; width: 400px; margin-top: 200px; text-align: center;'>"+localTranslation['not_data'][$globlan]+"</p>");
					}
					$("#loading").hide();				
				}
			});
		}
		function update_chart(loc){
			crt = loc || "x";
			if (crt != "x") {
				$("#chartdiv").attr("name", loc)
			}
			load_chart();		
		}
		load_page();
	</script>
</body>
</html>
