<!DOCTYPE html>
<html>
<head>
	<meta http-equiv="X-UA-Compatible" content="IE=Edge" />
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />		
	<?php include_once(dirname(__FILE__)."/tools/all_header.php"); global $c_scheme, $timezone, $rel_path; ?>
	<script>
		var js_debug = false;
		$data_changed = false;		
	</script>
	
    <title>FFU supplier spot location</title>
	
	<link rel="stylesheet" href="./css/qb.php" />
	<link rel="stylesheet" href="./jqplot/jquery.jqplot.css" />
	
	<script src="./jquery/jquery.min.js"></script>
	<script src="./jquery/jquery-migrate-1.2.1.min.js"></script>	
	<script src="./jquery/jquery-ui.min.js"></script>
	<script src="./jquery/qb_js.js"></script>
	
	<script src="./jqplot/jquery.jqplot.min.js"></script>
	<script src="./jqplot/plugins/jqplot.barRenderer.min.js"></script>
	<script src="./jqplot/plugins/jqplot.pieRenderer.min.js"></script>
	<script src="./jqplot/plugins/jqplot.categoryAxisRenderer.min.js"></script>
	<script src="./jqplot/plugins/jqplot.boxplotRenderer.js"></script>
	<script src="./jqplot/plugins/jqplot.pointLabels.min.js"></script>
    <script src="./jqplot/plugins/jqplot.canvasTextRenderer.min.js"></script>
    <script src="./jqplot/plugins/jqplot.canvasAxisLabelRenderer.min.js"></script>
	<script src="./jqplot/plugins/jqplot.enhancedLegendRenderer.min.js"></script>
    <script src="./jqplot/plugins/jqplot.canvasAxisTickRenderer.min.js"></script>
	<script src="./jqplot/plugins/jqplot.canvasOverlay.min.js"></script>	

	<?php
		$query = "
			SELECT 
				DATE_FORMAT(NOW(), '%Y-%m-%d'), 
				DATEDIFF(MAX(QBREGDATE), NOW()), 
				DATEDIFF(MIN(QBREGDATE), NOW()),
				MIN(QBREGDATE),
				MAX(QBREGDATE),
				IF (DATEDIFF(MAX(QBREGDATE), MIN(QBREGDATE)) > 365, DATE_SUB(MAX(QBREGDATE), INTERVAL 365 DAY), MIN(QBREGDATE))
			FROM 
				qbi 
			WHERE 
				QBSTATUS NOT IN ('M', 'D')
		";
		$stmt = $db->query($query);
		list($now, $diffmax, $diffmin, $min, $max, $lmin) = $stmt->fetch(PDO::FETCH_NUM );
	?>
	<script>
	// load translation and save in localTranslation
		<?php	
			$ini_affusup = parse_ini_file($rel_path.'i18n/a_ffusup.ini', true);	
			echo "localTranslation = {};";
			foreach($ini_affusup as $key=>$value){
				$add = "";
				foreach($value AS $lan=>$trans){
					$add .= "'".$lan."':'".$trans."',";
				}
				echo "localTranslation['".$key."']={".rtrim($add, ',')."};";
			}
			$ini_class = parse_ini_file($rel_path.'xml/class.ini', true);
			$ini_class['all']=$ini_affusup['all'];
			echo "classTranslation = {};";
			foreach($ini_class as $key=>$value){
				$add = "";
				foreach($value AS $lan=>$trans){
					$add .= "'".$lan."':'".$trans."',";
				}
				echo "classTranslation['".$key."']={".rtrim($add, ',')."};";
			}				
			$cal = parse_ini_file($rel_path.'i18n/calendar.ini', true);
			echo "calTranslation = {};";
			foreach($cal as $key=>$value){
				$add = "";
				if ($value['tpe'] == "S") {
					foreach($value AS $lan=>$trans){
						if ($lan != "tpe") $add .= "'".$lan."':'".$trans."',";
					}
				} else {
					foreach($value AS $lan=>$trans){
						if ($lan != "tpe") {
							$tar = explode(",", $trans);
							$tar = implode("','", $tar);
							$add .= "'".$lan."': ['".$tar."'],";
						}
					}				
				}
				echo "calTranslation['".$key."']={".rtrim($add, ',')."};";
			}
		?>
	</script>
</head>
<body>
	<div id="container">
		<?php 
			include_once($rel_path.'tools/header.php');
		?> 
		<div id="contents">
			<?php 
				echo "<div id='mainnav'>". $qb_support->get_main_menu(2) . "</div>";
			?>
			<div class="dtop">
				<span class="icn3_arraoleft_w_n clckbtn" style="float: left; font-size: 30px; margin-left: 5px;" data-type="title" data-lan="prev" title="<?php echo $ini_affusup['prev'][$_SESSION['lng']]; ?>" onclick="backtoanalysis()"></span>
				<span data-type="text" data-lan="ffusup"><?php echo $ini_affusup['ffusup'][$_SESSION['lng']]; ?></span>
			</div>
			<div id="btn_div" class="btn_div">
				<p>
					<label class="dlabel vam w50" data-type="text" data-lan="start" ><?php echo $ini_affusup['start'][$_SESSION['lng']]; ?></label>
					<input type="text" id="sdat" data-type="date" data-lan="#sdat_org" class="dinputw vam w75" value="" onchange="doplot()" readonly />
					<input type="hidden" id="sdat_org" value="" />
					<input type="hidden" id="sdat_i" value="" />
				</p>
				<p style="margin: 5px 0;">
					<label class="dlabel vam w50" data-type="text" data-lan="ende" ><?php echo $ini_affusup['ende'][$_SESSION['lng']]; ?></label>
					<input type="text" id="edat" data-type="date" data-lan="#edat_org" class="dinputw vam w75" value="" onchange="doplot()" readonly />
					<input type="hidden" id="edat_org" value="" />
					<input type="hidden" id="edat_i" value="" />
				</p>
				<p style="margin-top: 15px; padding-bottom: 10px; border-bottom: 2px solid "<?php echo $c_scheme['RN']; ?>";">
					<select id="clss" data-type="select" data-lan="clss" onchange="doplot()" >
						<?php
							foreach($ini_class as $key=>$value){
								echo "<option value='$key'>".$value[$_SESSION['lng']]."</option>";
							}
						?>
					</select>
				</p>
				<p>
					<label class="dlabel vam w150" data-type="text" data-lan="auswertung"><?php echo $ini_affusup['auswertung'][$_SESSION['lng']]; ?></label>
					<br style="margin: 5px 0;" />
					<select id="ausw" data-type="select" data-lan="auswsel" onchange="doplot()" >
						<option selected value="Q"><?php echo $ini_affusup['quarterly'][$_SESSION['lng']]; ?></option>
						<option value="M"><?php echo $ini_affusup['monthly'][$_SESSION['lng']]; ?></option>
					</select>
				</p>
			</div>			
	<!-- container for chart -->
			<div id="chartdiv" style="display: inline-block; height:500px; width:760px; margin-top: 50px; margin-left: 25px;"></div>
		</div>
		<?php include_once($rel_path.'footer.php'); ?> 		
	</div>
	<script>
		pickerOpts = {
			closeText: "X",		
			dateFormat: "yy-M-dd",
			altField: '#sdat_org',
			altFormat: 'yy-mm-dd',
			firstDay: 1,
			isRTL: false,
			showButtonPanel: true,
			displayClose: true,
			showOn: "button",  
			buttonImage: "./img/dummy_img.png", 
			buttonImageOnly: true,
			buttonText: localTranslation["cal"][$globlan],
			changeYear: true,
			changeMonth: true,
			maxDate: "+<?php echo $diffmax;?>d",
			minDate: "-<?php echo $diffmin;?>d"		
		}
		pickerOpts_2 = {
			closeText: "X",		
			dateFormat: "yy-M-dd",
			altField: '#edat_org',
			altFormat: 'yy-mm-dd',
			firstDay: 1,
			isRTL: false,
			showButtonPanel: true,
			displayClose: true,
			showOn: "button",  
			buttonImage: "./img/dummy_img.png", 
			buttonImageOnly: true,
			buttonText: localTranslation["cal"][$globlan],
			changeYear: true,
			changeMonth: true,
			maxDate: "+<?php echo $diffmax;?>d",
			minDate: "-<?php echo $diffmin;?>d"	
		}		
				
	// fix um bei klicken auf "Heute" den Kalender zu schliessen	
		var old_goToToday = $.datepicker._gotoToday;
		$.datepicker._gotoToday = function(id) {
			old_goToToday.call(this,id);   
			this._selectDate(id);
			$heute = true;
		};
		
		$.datepicker._defaults['currentText'] = calTranslation['currentText'][$globlan];
		$.datepicker._defaults['monthNames'] = calTranslation['monthNames'][$globlan];
		$.datepicker._defaults['monthNamesShort'] = calTranslation['monthNamesShort'][$globlan];
		$.datepicker._defaults['dayNamesMin'] = calTranslation['dayNamesMin'][$globlan];
		
		$("#sdat").datepicker(pickerOpts);
		clkevnt = $("#sdat").next().data('events').click[0].handler;
		$("#sdat").next().replaceWith('<span class="ui-datepicker-trigger icn_calendar_b_n clckbtn vam" data-type="title" data-lan="cal" title="<?php echo $ini_affusup['cal'][$_SESSION['lng']]; ?>"> </span>');
		$("#sdat").next().bind('click', clkevnt);		
		$("#edat").datepicker(pickerOpts_2);
		clkevnt = $("#edat").next().data('events').click[0].handler;
		$("#edat").next().replaceWith('<span class="ui-datepicker-trigger icn_calendar_b_n clckbtn vam" data-type="title" data-lan="cal" title="<?php echo $ini_affusup['cal'][$_SESSION['lng']]; ?>"> </span>');
		$("#edat").next().bind('click', clkevnt);
		
		$('#clss').val("T");
		$('#clss').width(175).customSelect({customClass: "cSelect_wht"});		
		$('#ausw').width(150).customSelect({customClass: "cSelect_wht"});
		
		function load_page() {
			$("#sdat").val(localizedate("<?php echo $lmin; ?>"));
			$("#edat").val(localizedate("<?php echo $max; ?>"));
			$("#sdat_org").val("<?php echo $lmin; ?>");
			$("#edat_org").val("<?php echo $max; ?>");
			$("#sdat_i").val("<?php echo $lmin; ?>");			// min start date
			$("#edat_i").val("<?php echo $max; ?>");			// max end date	
			doplot();
		}
	// switch language
		function c_lan() {
			translate_header($globlan);	
			translate_mainmenu($globlan);
			$.each($('#container *').filter(function(){return $(this).data('lan') !== undefined;}), function() {	
				switch ($(this).data("type")) {
					case "text":		
						$(this).text(localTranslation[$(this).data("lan")][$globlan]);
						break;
					case "title":				
						$(this).attr("title", localTranslation[$(this).data("lan")][$globlan]);
						break;
					case "date":
						$(this).val(localizedate($($(this).data("lan")).val()));
						break;
					case "select":
						if ($(this).data("lan") == "auswsel") {
							$(this).find("option").each(function(idx, obj) {
								if ($(this).val() == "M") {
									$(this).text(localTranslation["monthly"][$globlan]);
								} else {
									$(this).text(localTranslation["quarterly"][$globlan]);
								}
							});
							$('#ausw').trigger('render');
						}
						if ($(this).data("lan") == "clss") {
							$(this).find("option").each(function() {
								$(this).text(classTranslation[$(this).val()][$globlan]);
							});
							$('#clss').trigger('render');
						}
						break;						
				}
			});
			$cs0 = rgb2hex($(".jqplot-series-0").css("color"));
			$cs1 = rgb2hex($(".jqplot-series-1").css("color"));
			$cs2 = rgb2hex($(".jqplot-series-2").css("color"));	
			plot1.replot({
				legend: {
					labels: [localTranslation["W"][$globlan],localTranslation["I"][$globlan],localTranslation["C"][$globlan]]
				},
				axes:{
					yaxis:{
						label: localTranslation['count'][$globlan]
					},
					xaxis:{
						label: ($("#ausw").val()=='M')?localTranslation['month_txt'][$globlan]:localTranslation['quarter'][$globlan]
					}
				},						
			});
			$(".jqplot-series-0").css("color", $cs0);
			$(".jqplot-series-1").css("color", $cs1);
			$(".jqplot-series-2").css("color", $cs2);
		
			$.datepicker._defaults['currentText'] = calTranslation['currentText'][$globlan];
			$.datepicker._defaults['monthNames'] = calTranslation['monthNames'][$globlan];
			$.datepicker._defaults['monthNamesShort'] = calTranslation['monthNamesShort'][$globlan];
			$.datepicker._defaults['dayNamesMin'] = calTranslation['dayNamesMin'][$globlan];			
		}
		function backtoanalysis() {
			window.location.href = "./analysis.php";
		}
		function doplot() {
			$("#loading").show();
			$("#chartdiv").empty();
			$.ajax({
				type: "GET",
				cache: false,
				url:  "./tools/a_ffusup_api.php",
				data: { 
					routine: "getdata",
					art: $("#ausw").val(),
					from: $("#sdat_org").val(),
					to: $("#edat_org").val(),
					clss: $("#clss").val()					
				},
				dataType: 'json',
				success: function(chartresult)
				{		
					optionObj = {
						captureRightClick: true,
						stackSeries: true,
						grid:{shadow:false, borderWidth:1.0},
						axes:{
							yaxis:{
								min:0, 
								tickOptions: {formatString: '%d'},
								label: localTranslation['count'][$globlan],
								labelRenderer: $.jqplot.CanvasAxisLabelRenderer,
								labelOptions:{
									angel: 90,
									textColor: "<?php echo $c_scheme['GT']; ?>"
								}							
							},
							xaxis:{
								min:0, 
								ticks: chartresult[0],
								tickRenderer:$.jqplot.CanvasAxisTickRenderer, 
								tickOptions: {
									formatString: '%d'
								},					
								renderer:$.jqplot.CategoryAxisRenderer,
								label: ($("#ausw").val()=='M')?localTranslation['month_txt'][$globlan]:localTranslation['quarter'][$globlan]
							}
						},			
						seriesDefaults:{
							renderer:$.jqplot.BarRenderer,
							rendererOptions: {
								barMargin: 25,
								highlightMouseOver: false
							},
							pointLabels: { 
								show: true, 
								location: 'n', 
								ypadding: 10,
								hideZeros: true
							},
						},
						legend:{
							labels: [localTranslation["W"][$globlan],localTranslation["I"][$globlan],localTranslation["C"][$globlan]],
							show:true,
							placement: 'outside',
							renderer: $.jqplot.EnhancedLegendRenderer,
							rendererOptions: {                 
								numberRows: 1,
								numberColumns: 3
							},
							location:'n'
						},
						grid: 
						{         
							gridLineWidth: 2.5,         
							gridLineColor: "<?php echo $c_scheme['GG']; ?>",         
							drawGridlines: true,
							shadow:false, 
							borderWidth:1.0,
							background: "<?php echo $c_scheme['GB']; ?>"
						},		
						seriesColors:["<?php echo $c_scheme['G1']; ?>", "<?php echo $c_scheme['G2']; ?>", "<?php echo $c_scheme['G3']; ?>"]

						
					};	
					plot1 = $.jqplot('chartdiv', 
						[
							$.map(chartresult[1],function(val,i){return parseInt(val);}), 
							$.map(chartresult[2],function(val,i){return parseInt(val);}), 
							$.map(chartresult[3],function(val,i){return parseInt(val);})
						], 
						optionObj);
					$(".jqplot-series-0").css("color", "<?php echo $c_scheme['GI']; ?>");
					$(".jqplot-series-1").css("color", "<?php echo $c_scheme['GI']; ?>");
					$(".jqplot-series-2").css("color", "<?php echo $c_scheme['GI']; ?>");				
					$('#chartdiv').on('jqplotMouseDown', function (ev, seriesIndex, pointIndex, data) {
						if (data == null) return;
						window.location.href = "a_ffusup_table.php?cc="+chartresult[0][data['pointIndex']]+"&s="+$("#ausw").val();
					});
					$("#loading").hide();
				}
			});			
		}
		load_page();
	</script>
</body>
</html>
