<!DOCTYPE html>
<html>
	<head>
		<meta http-equiv="X-UA-Compatible" content="IE=Edge" />
		<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />		
		<?php include_once(dirname(__FILE__)."/tools/all_header.php"); global $c_scheme, $timezone, $rel_path; ?>
	
    <title>Analysis no activities</title>

		<link rel="stylesheet" href="./css/qb.php" />
		<link rel="stylesheet" href="./jqGrid_5.2.1/css/ui.jqgrid.css" />

		<style>
			.ui-jqgrid tr.jqgrow td{
				white-space:nowrap;
				height: 18px !important;
			}
			#pager_left
			{
				padding-top: 5px;
			}		
		</style>
		
		<script src="./jquery/jquery.min.js"></script>
		<script src="./jquery/jquery-migrate-1.2.1.min.js"></script>	
		<script src="./jquery/jquery-ui.min.js"></script>
		<script src="./jquery/qb_js.js"></script>
		
		<?php 
			foreach(explode(":", $qb_support->getLanOnly()) as $key=>$value) {
				echo '<script src="./jqGrid_5.2.1/js/i18n/grid.locale-' . $value . '.js"></script>';
			}
		?>
		<script src="./jqGrid_5.2.1/js/jquery.jqGrid.min.js"></script>	
		<?php
			$query = "
				SELECT 
					DATE_FORMAT(NOW(), '%Y-%m-%d'), 
					DATEDIFF(MAX(QBREGDATE), NOW()), 
					DATEDIFF(MIN(QBREGDATE), NOW()),
					MIN(QBREGDATE),
					MAX(QBREGDATE),
					IF (DATEDIFF(MAX(QBREGDATE), MIN(QBREGDATE)) > 365, DATE_SUB(MAX(QBREGDATE), INTERVAL 365 DAY), MIN(QBREGDATE))
				FROM 
					qbi 
				WHERE 
					QBSTATUS NOT IN ('M', 'D')
			";
			$stmt = $db->query($query);
			list($now, $diffmax, $diffmin, $min, $max, $lmin) = $stmt->fetch(PDO::FETCH_NUM );
		?>
		<script>
		// load translation and save in localTranslation
			<?php	
				$ini_linksummary = parse_ini_file($rel_path.'i18n/a_linksummary.ini', true);	
				echo "localTranslation = {};";
				foreach($ini_linksummary as $key=>$value){
					$add = "";
					foreach($value AS $lan=>$trans){
						$add .= "'".$lan."':'".$trans."',";
					}
					echo "localTranslation['".$key."']={".rtrim($add, ',')."};";
				}
				$cal = parse_ini_file($rel_path.'i18n/calendar.ini', true);
				echo "calTranslation = {};";
				foreach($cal as $key=>$value){
					$add = "";
					if ($value['tpe'] == "S") {
						foreach($value AS $lan=>$trans){
							if ($lan != "tpe") $add .= "'".$lan."':'".$trans."',";
						}
					} else {
						foreach($value AS $lan=>$trans){
							if ($lan != "tpe") {
								$tar = explode(",", $trans);
								$tar = implode("','", $tar);
								$add .= "'".$lan."': ['".$tar."'],";
							}
						}				
					}
					echo "calTranslation['".$key."']={".rtrim($add, ',')."};";
				}
				$ini_class = parse_ini_file($rel_path.'xml/class.ini', true);
				$ini_class['all']=$ini_linksummary['all'];
				echo "classTranslation = {};";
				foreach($ini_class as $key=>$value){
					$add = "";
					foreach($value AS $lan=>$trans){
						$add .= "'".$lan."':'".$trans."',";
					}
					echo "classTranslation['".$key."']={".rtrim($add, ',')."};";
				}	
			?>
		</script>
	</head>
	<body>
		<div id="container">
			<?php 
				include_once($rel_path.'tools/header.php');
			?> 
			<div id="contents">
				<?php 
					echo "<div id='mainnav'>". $qb_support->get_main_menu(2) . "</div>";
				?>
				<div class="dtop">
					<span class="icn3_arraoleft_w_n clckbtn" style="float: left; font-size: 30px; margin-left: 5px;" data-type="title" data-lan="prev" title="<?php echo $ini_linksummary['prev'][$_SESSION['lng']]; ?>" onclick="backtoanalysis()"></span>
					<span data-type="text" data-lan="linksummary"><?php echo $ini_linksummary['linksummary'][$_SESSION['lng']]; ?></span>
				</div>
				<div id="btn_div" class="btn_div">
					<p>
						<label class="dlabel vam w50" data-type="text" data-lan="start" ><?php echo $ini_linksummary['start'][$_SESSION['lng']]; ?></label>
						<input type="text" id="sdat" data-type="date" data-lan="#sdat_org" class="dinputw vam w75" value="" onchange="update_grid()" readonly />
						<input type="hidden" id="sdat_org" value="" />
						<input type="hidden" id="sdat_i" value="" />
						<br style="margin: 10px 0;" />
						<label class="dlabel vam w50" data-type="text" data-lan="ende" ><?php echo $ini_linksummary['ende'][$_SESSION['lng']]; ?></label>
						<input type="text" id="edat" data-type="date" data-lan="#edat_org" class="dinputw vam w75" value="" onchange="update_grid()" readonly />
						<input type="hidden" id="edat_org" value="" />
						<input type="hidden" id="edat_i" value="" />
					</p>
					<p style="margin-top: 15px; text-align: center; padding-bottom: 10px; border-bottom: 2px solid <?php echo $c_scheme['RN']; ?>;">
						<select id="clss" data-type="select" data-lan="clss" onchange="update_grid()" >
							<?php
								foreach($ini_class as $key=>$value){
									echo "<option value='$key'>".$value[$_SESSION['lng']]."</option>";
								}
							?>
						</select>
					</p>
					<p style="text-align: center; margin-top: 30px;">
						<span class="spanbuttonp" id="export" data-type="text" data-lan="excel_export" onclick="ExportDataToExcel('list')"><?php echo $ini_linksummary['excel_export'][$_SESSION['lng']]; ?></span>
					</p>
				</div>
				<div style="display: inline-block; margin-left: 5px;">
					<table id="list"></table> 
					<div id="pager"></div> 
				</div>
			</div>
			<?php include_once($rel_path.'/footer.php'); ?>
			<form name="lsxls" method="post" target="_blank" action = "./tools/a_linksummary_excel.php">
				<input type="hidden" name="titles" id="titles" value="" />
				<input type="hidden" name="filters" id="filters" value="" />
			</form>
		</div>
		<script>
			var $ov;
			pickerOpts = {
				closeText: "X",		
				dateFormat: "yy-M-dd",
				altField: '#sdat_org',
				altFormat: 'yy-mm-dd',
				firstDay: 1,
				isRTL: false,
				showButtonPanel: true,
				displayClose: true,
				showOn: "button",  
				buttonImage: "./img/dummy_img.png", 
				buttonImageOnly: true,
				buttonText: localTranslation["cal"][$globlan],
				changeYear: true,
				changeMonth: true,
				maxDate: "+<?php echo $diffmax;?>d",
				minDate: "-<?php echo $diffmin;?>d"		
			}
			pickerOpts_2 = {
				closeText: "X",		
				dateFormat: "yy-M-dd",
				altField: '#edat_org',
				altFormat: 'yy-mm-dd',
				firstDay: 1,
				isRTL: false,
				showButtonPanel: true,
				displayClose: true,
				showOn: "button",  
				buttonImage: "./img/dummy_img.png", 
				buttonImageOnly: true,
				buttonText: localTranslation["cal"][$globlan],
				changeYear: true,
				changeMonth: true,
				maxDate: "+<?php echo $diffmax;?>d",
				minDate: "-<?php echo $diffmin;?>d"	
			}		
					
		// fix um bei klicken auf "Heute" den Kalender zu schliessen	
			var old_goToToday = $.datepicker._gotoToday;
			$.datepicker._gotoToday = function(id) {
				old_goToToday.call(this,id);   
				this._selectDate(id);
				$heute = true;
			};
			
			$.datepicker._defaults['currentText'] = calTranslation['currentText'][$globlan];
			$.datepicker._defaults['monthNames'] = calTranslation['monthNames'][$globlan];
			$.datepicker._defaults['monthNamesShort'] = calTranslation['monthNamesShort'][$globlan];
			$.datepicker._defaults['dayNamesMin'] = calTranslation['dayNamesMin'][$globlan];
			
			$("#sdat").datepicker(pickerOpts);
			clkevnt = $("#sdat").next().data('events').click[0].handler;
			$("#sdat").next().replaceWith('<span class="ui-datepicker-trigger icn_calendar_b_n clckbtn vam" data-type="title" data-lan="cal" title="<?php echo $ini_linksummary['cal'][$_SESSION['lng']]; ?>"> </span>');
			$("#sdat").next().bind('click', clkevnt);		
			$("#edat").datepicker(pickerOpts_2);
			clkevnt = $("#edat").next().data('events').click[0].handler;
			$("#edat").next().replaceWith('<span class="ui-datepicker-trigger icn_calendar_b_n clckbtn vam" data-type="title" data-lan="cal" title="<?php echo $ini_linksummary['cal'][$_SESSION['lng']]; ?>"> </span>');
			$("#edat").next().bind('click', clkevnt);
			
			function load_page() {
				$("#sdat").val(localizedate("<?php echo $lmin; ?>"));
				$("#edat").val(localizedate("<?php echo $max; ?>"));
				$("#sdat_org").val("<?php echo $lmin; ?>");
				$("#edat_org").val("<?php echo $max; ?>");
				$("#sdat_i").val("<?php echo $lmin; ?>");			// min start date
				$("#edat_i").val("<?php echo $max; ?>");			// max end date
				start_search();
			}
		// switch language
			function c_lan(loc) {
				translate_header($globlan);	
				translate_mainmenu($globlan);
				$.each($('#container *').filter(function(){return $(this).data('lan') !== undefined;}), function() {	
					switch ($(this).data("type")) {
						case "text":		
							$(this).text(localTranslation[$(this).data("lan")][$globlan]);
							break;
						case "title":				
							$(this).attr("title", localTranslation[$(this).data("lan")][$globlan]);
							break;
						case "date":
							$(this).val(localizedate($($(this).data("lan")).val()));
							break;	
						case "select":
							if ($(this).data("lan") == "clss") {
								$(this).find("option").each(function() {
									$(this).text(classTranslation[$(this).val()][$globlan]);
								});
								$('#clss').trigger('render');
							}
							break;								
					}
				});	
			// save filter
				$ov = {};
				$.each($(".ui-search-toolbar input[role='textbox']"), function(k,v) {
					$ov[$(v).attr("name")] = $("#gs_"+$(v).attr("name")).val();
				});
				$.each($(".ui-search-toolbar select[role='select']"), function(k,v) {
					$ov[$(v).attr("name")] = $("#gs_"+$(v).attr("name")).val();
				});					
				$.jgrid.setRegional('list',{regional: $globlan});
				$("#list").jqGrid('setLabel', "qbn", localTranslation["qbn"][$globlan])
					.jqGrid('setLabel', "svt", localTranslation["svt"][$globlan])
					.jqGrid('setLabel', "cnt", localTranslation["cnt"][$globlan])
					.jqGrid('setLabel', "imat", localTranslation["imat"][$globlan])
					.jqGrid('setLabel', "des", localTranslation["des"][$globlan]);
					
				$("#list").jqGrid('setLabel', "qbno", localTranslation["qbno"][$globlan])
					.jqGrid('setLabel', "qbn", localTranslation["qbn"][$globlan])
					.jqGrid('setLabel', "svt", localTranslation["svt"][$globlan])
					.jqGrid('setLabel', "status", localTranslation["status"][$globlan])
					.jqGrid('setLabel', "des", localTranslation["des"][$globlan]);
				$("#list").trigger("reloadGrid");

				$.datepicker._defaults['currentText'] = calTranslation['currentText'][$globlan];
				$.datepicker._defaults['monthNames'] = calTranslation['monthNames'][$globlan];
				$.datepicker._defaults['monthNamesShort'] = calTranslation['monthNamesShort'][$globlan];
				$.datepicker._defaults['dayNamesMin'] = calTranslation['dayNamesMin'][$globlan];
			}	
			function backtoanalysis() {
				window.location.href="./analysis.php";
			}
			function DescFormatter (cellvalue, options, rowObject)
			{	
				return cellvalue;
			}	
			function start_search() {
				cmTemplate = {
					editable: false,		
					sorttype:'string',		
					searchoptions: {
						sopt:['cn'],
						clearSearch: false
					}
				};
				obj = {
					url:  "./tools/a_linksummary_api.php",
					postData: {
						routine : "search",
						sdat: $("#sdat_org").val(),
						edat: $("#edat_org").val(),
						clss: $("#clss").val()
					},
					contentType: "application/json",
					datatype: "json",
					jsonReader: {
						id: "id",
						repeatitems: true
					},
					mtype: "POST",
					colNames: [
						localTranslation["qbn"][$globlan],
						localTranslation["svt"][$globlan],
						localTranslation["cnt"][$globlan],
						localTranslation["imat"][$globlan],
						localTranslation["des"][$globlan]
					],
					colModel: [
						{ 
							name: "qbn", 
							width: 80,
							template: cmTemplate
						},
						{ 
							name: "svt", 
							width: 150, 
							template: cmTemplate
						},
						{
							name: "qbsum", 
							width: 100,
							template: cmTemplate,
							search: false
						},
						{ 
							name: "imat", 
							width: 120,
							template: cmTemplate				
						},
						{ 
							name: "des", 
							width: 290 , 
							template: cmTemplate,
							formatter: DescFormatter
						}
					],
					regional: $globlan,
					storeNavOptions : true,			
					loadonce: false,
					pager: "#pager",
					recordpos: "left",
					height: 510,
					rowNum: 100,
					rowList: [10, 100, 500, 1000, 1500],
					hoverrows: false,
					rownumbers: true,
					sortname: "qbsum",
					sortorder: "desc",
					viewrecords: true,
					gridview: true,
					autoencode: true,
					ignoreCase:true,
					loadui: "block",
					onRightClickRow: function (rowid, iRow, iCol, e) {
						window.localStorage.setItem("qb", $("#list").jqGrid('getRowData', rowid).qbn);
						$.ajax({
							url: "./tools/general_api.php",
							data: {
								routine: "get_qbs",
								qbn: $("#list").jqGrid('getRowData', rowid).qbn
							},
							success: function(result) {
								window.localStorage.setItem("qbn", result.substring(1, result.length-1));				
								window.open(
									'./basic.php',
									'_blank'
								);
								return false;
							}		
						});
						return false;
					},			
					loadComplete: function() {
					},
					gridComplete: function(data) {
						$("th[role='columnheader']")
							.unbind("mouseenter")
							.unbind("mouseleave");
						$(".ui-search-toolbar input[role='textbox']")
							.css("width", "92%")
							.css("background", "<?php echo $c_scheme['M5']; ?>")
							.css("padding", "2px");	
						$(".ui-search-toolbar select[role='select']")
							.removeClass("ui-corner-all")
							.css("background", "<?php echo $c_scheme['M5']; ?>")
							.css("padding", "2px");
					// restore filter (if set)
						if (typeof $ov !== 'undefined') {
								$.each($ov, function(k,v) {$("#gs_"+k).val(v);});
						}					
					}			
				};
				list1 = $("#list").jqGrid(obj)
					.jqGrid('filterToolbar',{searchOperators : false, searchOnEnter: false})
					.jqGrid('navGrid', '#pager', {refresh: false, search: false, edit: false, del: false, add: false});	
				$("#loading").hide();
			}

			function ExportDataToExcel() {
			// save filter
				$ov = {};
				$.each($(".ui-search-toolbar input[role='textbox']"), function(k,v) {
					$ov[$(v).attr("name")] = $("#gs_"+$(v).attr("name")).val();
				});
				$.each($(".ui-search-toolbar select[role='select']"), function(k,v) {
					$ov[$(v).attr("name")] = $("#gs_"+$(v).attr("name")).val();
				});	
				$ov['sdat'] = $("#sdat_org").val();
				$ov['edat'] = $("#edat_org").val();
				$ov['clss'] = $("#clss").val();
				$ov['qblan'] = $globlan;
				$("#filters").val(JSON.stringify($ov));
				$("#titles").val(JSON.stringify(obj.colNames));
				document.lsxls.submit();
			}	
			function update_grid() {
				$("#list").setGridParam({
					datatype: "json", 
					postData: {
						routine: "getlist",
						sdat: $("#sdat_org").val(),
						edat: $("#edat_org").val(),
						clss: $("#clss").val(),
						qblan: $globlan
					} 
				}).trigger("reloadGrid");
			}	
			load_page();
		</script>
	</body>
</html>