<!DOCTYPE html>
<html>
<head>
	<meta http-equiv="X-UA-Compatible" content="IE=Edge" />
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />		
	<?php include_once(dirname(__FILE__)."/tools/all_header.php"); global $c_scheme, $timezone, $rel_path; ?>
	<script>
		var js_debug = false;
		$data_changed = false;		
	</script>
	
    <title>NOCs per Month</title>
	
	<link rel="stylesheet" href="./css/qb.php" />
	<link rel="stylesheet" type="text/css" href="./jqplot/jquery.jqplot.css" />	
	
	<script src="./jquery/jquery.min.js"></script>
	<script src="./jquery/jquery-migrate-1.2.1.min.js"></script>	
	<script src="./jquery/jquery-ui.min.js"></script>
	<script src="./jquery/qb_js.js"></script>
	
	<script src="./jqplot/jquery.jqplot.min.js"></script>
	<script src="./jqplot/plugins/jqplot.barRenderer.min.js"></script>
	<script src="./jqplot/plugins/jqplot.pieRenderer.min.js"></script>
	<script src="./jqplot/plugins/jqplot.categoryAxisRenderer.min.js"></script>
	<script src="./jqplot/plugins/jqplot.boxplotRenderer.js"></script>
	<script src="./jqplot/plugins/jqplot.pointLabels.min.js"></script>
    <script src="./jqplot/plugins/jqplot.canvasTextRenderer.min.js"></script>
    <script src="./jqplot/plugins/jqplot.canvasAxisLabelRenderer.min.js"></script>
	<script src="./jqplot/plugins/jqplot.enhancedLegendRenderer.min.js"></script>
    <script src="./jqplot/plugins/jqplot.canvasAxisTickRenderer.min.js"></script>
	<script src="./jqplot/plugins/jqplot.canvasOverlay.min.js"></script>

	<?php
		$query = "
			SELECT 
				DATE_FORMAT(NOW(), '%Y-%m-%d'), 
				DATEDIFF(MAX(QBREGDATE), NOW()), 
				DATEDIFF(MIN(QBREGDATE), NOW()),
				MIN(QBREGDATE),
				MAX(QBREGDATE),
				IF (DATEDIFF(MAX(QBREGDATE), MIN(QBREGDATE)) > 365, DATE_SUB(MAX(QBREGDATE), INTERVAL 365 DAY), MIN(QBREGDATE))
			FROM 
				qbi 
			WHERE 
				QBSTATUS NOT IN ('M', 'D')
		";
		$stmt = $db->query($query);
		list($now, $diffmax, $diffmin, $min, $max, $lmin) = $stmt->fetch(PDO::FETCH_NUM );
	?>
	<script>
	// load translation and save in localTranslation
		<?php	
			$ini_anocomonth = parse_ini_file($rel_path.'i18n/a_nocomonth.ini', true);	
			echo "localTranslation = {};";
			foreach($ini_anocomonth as $key=>$value){
				$add = "";
				foreach($value AS $lan=>$trans){
					$add .= "'".$lan."':'".$trans."',";
				}
				echo "localTranslation['".$key."']={".rtrim($add, ',')."};";
			}
			$cal = parse_ini_file($rel_path.'i18n/calendar.ini', true);
			echo "calTranslation = {};";
			foreach($cal as $key=>$value){
				$add = "";
				if ($value['tpe'] == "S") {
					foreach($value AS $lan=>$trans){
						if ($lan != "tpe") $add .= "'".$lan."':'".$trans."',";
					}
				} else {
					foreach($value AS $lan=>$trans){
						if ($lan != "tpe") {
							$tar = explode(",", $trans);
							$tar = implode("','", $tar);
							$add .= "'".$lan."': ['".$tar."'],";
						}
					}				
				}
				echo "calTranslation['".$key."']={".rtrim($add, ',')."};";
			}
		?>
	</script>
</head>
<body>
	<div id="container">
		<?php 
			include_once($rel_path.'tools/header.php');
		?> 
		<div id="contents">
			<?php 
				echo "<div id='mainnav'>". $qb_support->get_main_menu(2) . "</div>";
			?>
			<div class="dtop">
				<span class="icn3_arraoleft_w_n clckbtn" style="float: left; font-size: 30px; margin-left: 5px;" data-type="title" data-lan="prev" title="<?php echo $ini_anocomonth['prev'][$_SESSION['lng']]; ?>" onclick="backtoanalysis()"></span>
				<span data-type="text" data-lan="noc_month"><?php echo $ini_anocomonth['noc_month'][$_SESSION['lng']]; ?></span>
			</div>
			<div id="btn_div" class="btn_div">
				<label class="dlabel vam w50" data-type="text" data-lan="start" ><?php echo $ini_anocomonth['start'][$_SESSION['lng']]; ?></label>
				<input type="text" id="sdat" data-type="date" data-lan="#sdat_org" class="dinputw vam w75" value="" onchange="update_chart()" readonly />
				<input type="hidden" id="sdat_org" value="" />
				<input type="hidden" id="sdat_i" value="" />
				<br style="margin: 10px 0;" />
				<label class="dlabel vam w50" data-type="text" data-lan="ende" ><?php echo $ini_anocomonth['ende'][$_SESSION['lng']]; ?></label>
				<input type="text" id="edat" data-type="date" data-lan="#edat_org" class="dinputw vam w75" value="" onchange="update_chart()" readonly />
				<input type="hidden" id="edat_org" value="" />
				<input type="hidden" id="edat_i" value="" />		
			</div>			
	<!-- container for chart -->
			<div id="chartdiv" style="display: inline-block; height:500px; width:760px; margin-top: 70px; margin-left: 30px;"></div>
		</div>
		<?php include_once($rel_path.'footer.php'); ?> 		
	</div>
	<script>
		pickerOpts = {
			closeText: "X",		
			dateFormat: "yy-M-dd",
			altField: '#sdat_org',
			altFormat: 'yy-mm-dd',
			firstDay: 1,
			isRTL: false,
			showButtonPanel: true,
			displayClose: true,
			showOn: "button",  
			buttonImage: "./img/dummy_img.png", 
			buttonImageOnly: true,
			buttonText: localTranslation["cal"][$globlan],
			changeYear: true,
			changeMonth: true,
			maxDate: "+<?php echo $diffmax;?>d",
			minDate: "-<?php echo $diffmin;?>d"		
		}
		pickerOpts_2 = {
			closeText: "X",		
			dateFormat: "yy-M-dd",
			altField: '#edat_org',
			altFormat: 'yy-mm-dd',
			firstDay: 1,
			isRTL: false,
			showButtonPanel: true,
			displayClose: true,
			showOn: "button",  
			buttonImage: "./img/dummy_img.png", 
			buttonImageOnly: true,
			buttonText: localTranslation["cal"][$globlan],
			changeYear: true,
			changeMonth: true,
			maxDate: "+<?php echo $diffmax;?>d",
			minDate: "-<?php echo $diffmin;?>d"	
		}		
				
	// fix um bei klicken auf "Heute" den Kalender zu schliessen	
		var old_goToToday = $.datepicker._gotoToday;
		$.datepicker._gotoToday = function(id) {
			old_goToToday.call(this,id);   
			this._selectDate(id);
			$heute = true;
		};
			
		$("#sdat").datepicker(pickerOpts);
		clkevnt = $("#sdat").next().data('events').click[0].handler;
		$("#sdat").next().replaceWith('<span class="ui-datepicker-trigger icn_calendar_b_n clckbtn vam" data-type="title" data-lan="cal" title="<?php echo $ini_anocomonth['cal'][$_SESSION['lng']]; ?>"> </span>');
		$("#sdat").next().bind('click', clkevnt);		
		$("#edat").datepicker(pickerOpts_2);
		clkevnt = $("#edat").next().data('events').click[0].handler;
		$("#edat").next().replaceWith('<span class="ui-datepicker-trigger icn_calendar_b_n clckbtn vam" data-type="title" data-lan="cal" title="<?php echo $ini_anocomonth['cal'][$_SESSION['lng']]; ?>"> </span>');
		$("#edat").next().bind('click', clkevnt);
		
		function load_page() {
			$("#sdat").val(localizedate("<?php echo $lmin; ?>"));
			$("#edat").val(localizedate("<?php echo $max; ?>"));
			$("#sdat_org").val("<?php echo $lmin; ?>");
			$("#edat_org").val("<?php echo $max; ?>");
			$("#sdat_i").val("<?php echo $lmin; ?>");			// min start date
			$("#edat_i").val("<?php echo $max; ?>");			// max end date	
			update_chart();
		}
		
	// switch language
		function c_lan() {
			translate_header($globlan);	
			translate_mainmenu($globlan);
			$.each($('#container *').filter(function(){return $(this).data('lan') !== undefined;}), function() {	
				switch ($(this).data("type")) {
					case "text":		
						$(this).text(localTranslation[$(this).data("lan")][$globlan]);
						break;
					case "title":				
						$(this).attr("title", localTranslation[$(this).data("lan")][$globlan]);
						break;
					case "date":
						$(this).val(localizedate($($(this).data("lan")).val()));
						break;						
				}
			});		
		}
		function backtoanalysis() {
			window.location.href = "./analysis.php";
		}
		function update_chart() {
			$("#chartdiv").empty();
			$.ajax({
				type: "POST",
				cache: false,
				url:  "./tools/a_nocomonth_api.php",
				data: { 
					routine: "getdata",
					from: $("#sdat_org").val(),
					to: $("#edat_org").val()
				},
				dataType: "json",
				success: function(regresult)
				{
					qbresult = new Array();				
					regval = regresult[1];
					regnam = regresult[0];
					for($i=0; $i < regval.length; $i++) {
						qbresult[$i] = Array(regnam[$i], parseInt(regval[$i]));
					}
					$max = 0;
					$.each(qbresult, function(i){
						if (qbresult[i][1] > $max) $max = qbresult[i][1];
					});
					optionObj = {
						captureRightClick: true,
						grid:{shadow:false, borderWidth:1.0},
						axesDefaults: {
							tickRenderer: $.jqplot.CanvasAxisTickRenderer ,
							tickOptions: {
							  fontSize: '9pt'
							}
						},					
						axes:{
							yaxis:{
								min:0, 
								max: $max*1.1,
								tickOptions: {formatString: '%d'},
								label: "ppm",
								labelRenderer: $.jqplot.CanvasAxisLabelRenderer,
								labelOptions:{
									angel: 90,
									textColor: "<?php echo $c_scheme['GT']; ?>"
								}							
							},
							xaxis:{
								min:0,
								max: regnam.length,
								tickOptions: {
									angle: -30
								},
								renderer: $.jqplot.CategoryAxisRenderer,
								ticks: regnam
							}
						},
						seriesColors: [ "<?php echo $c_scheme['G1']; ?>", "<?php echo $c_scheme['G2']; ?>"],
						seriesDefaults:{
							renderer:$.jqplot.BarRenderer,
							rendererOptions: {
								highlightMouseOver: false,
								barMargin: 5,
								shadowDepth: 0,
								varyBarColor: true
							},
							pointLabels: { 
								show: true, 
								location: 'n', 
								ypadding: 2,
								color: "<?php echo $c_scheme['GI']; ?>"
							}
						},
						legend:{
							show:false
						},
						grid: 
						{         
							gridLineWidth: 2.5,         
							gridLineColor: "<?php echo $c_scheme['GG']; ?>",         
							drawGridlines: true,
							shadow:false, 
							borderWidth:1.0,
							background: "<?php echo $c_scheme['GB']; ?>"
						}						
					};				
					plot1 = $.jqplot('chartdiv', [regval], optionObj);
					$(".jqplot-point-label").css("color", "<?php echo $c_scheme['GT']; ?>");				
				}
			});	
		}
		load_page();
	</script>	
</body>
</html>
