<!DOCTYPE html>
<html>
<head>
	<meta http-equiv="X-UA-Compatible" content="IE=Edge" />
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />	
	<?php include_once(dirname(__FILE__)."/tools/all_header.php"); global $c_scheme, $timezone, $rel_path; ?>
	<script>
		var js_debug = false;
		$data_changed = false;		
	</script>
	
    <title>TOP 10</title>

	<link rel="stylesheet" href="./css/qb.php" />
	<link rel="stylesheet" type="text/css" href="./jqplot/jquery.jqplot.css" />
	
	<script src="./jquery/jquery.min.js"></script>
	<script src="./jquery/jquery-migrate-1.2.1.min.js"></script>	
	<script src="./jquery/jquery-ui.min.js"></script>
	<script src="./jquery/qb_js.js"></script>	
	
	<script src="./jqplot/jquery.jqplot.min.js"></script>
	<script src="./jqplot/plugins/jqplot.barRenderer.min.js"></script>
	<script src="./jqplot/plugins/jqplot.pieRenderer.min.js"></script>
	<script src="./jqplot/plugins/jqplot.categoryAxisRenderer.min.js"></script>
	<script src="./jqplot/plugins/jqplot.boxplotRenderer.js"></script>
	<script src="./jqplot/plugins/jqplot.pointLabels.min.js"></script>
    <script src="./jqplot/plugins/jqplot.canvasTextRenderer.min.js"></script>
    <script src="./jqplot/plugins/jqplot.canvasAxisLabelRenderer.min.js"></script>
	<script src="./jqplot/plugins/jqplot.enhancedLegendRenderer.min.js"></script>
    <script src="./jqplot/plugins/jqplot.canvasAxisTickRenderer.min.js"></script>
	<script src="./jqplot/plugins/jqplot.canvasOverlay.min.js"></script>
	
	<?php
		$query = "
			SELECT 
				DATE_FORMAT(NOW(), '%Y-%m-%d'), 
				DATEDIFF(MAX(QBREGDATE), NOW()), 
				DATEDIFF(MIN(QBREGDATE), NOW()),
				MIN(QBREGDATE),
				MAX(QBREGDATE),
				IF (DATEDIFF(MAX(QBREGDATE), MIN(QBREGDATE)) > 365, DATE_SUB(MAX(QBREGDATE), INTERVAL 365 DAY), MIN(QBREGDATE))
			FROM 
				qbi 
			WHERE 
				QBSTATUS NOT IN ('M', 'D')
		";
		$stmt = $db->query($query);
		list($now, $diffmax, $diffmin, $min, $max, $lmin) = $stmt->fetch(PDO::FETCH_NUM );
	?>
	<script>
	// load translation and save in localTranslation
		<?php	
			$ini_atopten = parse_ini_file($rel_path.'i18n/a_topten.ini', true);	
			echo "localTranslation = {};";
			foreach($ini_atopten as $key=>$value){
				$add = "";
				foreach($value AS $lan=>$trans){
					$add .= "'".$lan."':'".$trans."',";
				}
				echo "localTranslation['".$key."']={".rtrim($add, ',')."};";
			}
			$ini_class = parse_ini_file($rel_path.'xml/class.ini', true);
			$ini_class['all']=$ini_atopten['all'];
			echo "classTranslation = {};";
			foreach($ini_class as $key=>$value){
				$add = "";
				foreach($value AS $lan=>$trans){
					$add .= "'".$lan."':'".$trans."',";
				}
				echo "classTranslation['".$key."']={".rtrim($add, ',')."};";
			}			
			$cal = parse_ini_file($rel_path.'i18n/calendar.ini', true);
			echo "calTranslation = {};";
			foreach($cal as $key=>$value){
				$add = "";
				if ($value['tpe'] == "S") {
					foreach($value AS $lan=>$trans){
						if ($lan != "tpe") $add .= "'".$lan."':'".$trans."',";
					}
				} else {
					foreach($value AS $lan=>$trans){
						if ($lan != "tpe") {
							$tar = explode(",", $trans);
							$tar = implode("','", $tar);
							$add .= "'".$lan."': ['".$tar."'],";
						}
					}				
				}
				echo "calTranslation['".$key."']={".rtrim($add, ',')."};";
			}	
			$ini_ffu = parse_ini_file($rel_path.'xml/ffu.ini', true);	
			echo "ffuTranslation = {};";
			foreach($ini_ffu as $key=>$value){
				$add = "";
				foreach($value AS $lan=>$trans){
					$add .= "'".$lan."':'".$trans."',";
				}
				echo "ffuTranslation['".$key."']={".rtrim($add, ',')."};";
			}
		?>	
	</script>
</head>
<body>
	<div id="container">
		<?php 
			include_once($rel_path.'tools/header.php');
		?> 
		<div id="contents">
			<?php 
				echo "<div id='mainnav'>". $qb_support->get_main_menu(2) . "</div>";
			?>
			<div class="dtop">
				<span class="icn3_arraoleft_w_n clckbtn" style="float: left; font-size: 30px; margin-left: 5px;" data-type="title" data-lan="prev" title="<?php echo $ini_atopten['prev'][$_SESSION['lng']]; ?>" onclick="backtoanalysis()"></span>
				<span data-type="text" data-lan="top_ten"><?php echo $ini_atopten['top_ten'][$_SESSION['lng']]; ?></span>
			</div>
			<div id="btn_div" class="btn_div">
				<p>
					<label class="dlabel vam w50" data-type="text" data-lan="start" ><?php echo $ini_atopten['start'][$_SESSION['lng']]; ?></label>
					<input type="text" id="sdat" data-type="date" data-lan="#sdat_org" class="dinputw vam w75" value="" onchange="update_chart()" readonly />
					<input type="hidden" id="sdat_org" value="" />
					<input type="hidden" id="sdat_i" value="" />
				</p>
				<p style="margin: 5px 0;">
					<label class="dlabel vam w50" data-type="text" data-lan="ende" ><?php echo $ini_atopten['ende'][$_SESSION['lng']]; ?></label>
					<input type="text" id="edat" data-type="date" data-lan="#edat_org" class="dinputw vam w75" value="" onchange="update_chart()" readonly />
					<input type="hidden" id="edat_org" value="" />
					<input type="hidden" id="edat_i" value="" />
				</p>
				<p style="margin-top: 15px; padding-bottom: 10px; border-bottom: 2px solid "<?php echo $c_scheme['RN']; ?>";">
					<select id="clss" data-type="select" data-lan="clss" onchange="update_chart()" >
						<?php
							foreach($ini_class as $key=>$value){
								echo "<option value='$key'>".$value[$_SESSION['lng']]."</option>";
							}
						?>
					</select>
				</p>		
				<div style="text-align: center; margin-top: 30px;">
					<span class="spanbuttonps" id="ttmb" data-type="text" data-lan="imat" onclick="ttm()"><?php echo $ini_atopten['imat'][$_SESSION['lng']]; ?></span>
					<br />
					<span class="icn_checkboxempty_c_n clckbtn vam" id="o_xxx" style="background-color:<?php echo $c_scheme['M5'];?>" onclick="ttm1(this);"></span>
					<label style="width: 90px;" class="vam" data-type="text" data-lan="o_xxx"><?php echo $ini_atopten['o_xxx'][$_SESSION['lng']]; ?></label>
					<span class="spanbuttonp" id="ttsb" data-type="text" data-lan="supplier" onclick="tts()"><?php echo $ini_atopten['supplier'][$_SESSION['lng']]; ?></span>
					<span class="spanbuttonp" id="ttffub" data-type="text" data-lan="ffus" onclick="ttffu()"><?php echo $ini_atopten['ffus'][$_SESSION['lng']]; ?></span>
				</div>
			</div>			
	<!-- container for chart -->
			<div id="chartdiv" style="display: inline-block; height:500px; width:760px; margin-top: 50px; margin-left: 25px;"></div>
		</div>
		<?php include_once($rel_path.'footer.php'); ?>
	</div>
	<script>
		pickerOpts = {
			closeText: "X",		
			dateFormat: "yy-M-dd",
			altField: '#sdat_org',
			altFormat: 'yy-mm-dd',
			firstDay: 1,
			isRTL: false,
			showButtonPanel: true,
			displayClose: true,
			showOn: "button",  
			buttonImage: "./img/dummy_img.png", 
			buttonImageOnly: true,
			buttonText: localTranslation["cal"][$globlan],
			changeYear: true,
			changeMonth: true,
			maxDate: "+<?php echo $diffmax;?>d",
			minDate: "-<?php echo $diffmin;?>d"		
		}
		pickerOpts_2 = {
			closeText: "X",		
			dateFormat: "yy-M-dd",
			altField: '#edat_org',
			altFormat: 'yy-mm-dd',
			firstDay: 1,
			isRTL: false,
			showButtonPanel: true,
			displayClose: true,
			showOn: "button",  
			buttonImage: "./img/dummy_img.png", 
			buttonImageOnly: true,
			buttonText: localTranslation["cal"][$globlan],
			changeYear: true,
			changeMonth: true,
			maxDate: "+<?php echo $diffmax;?>d",
			minDate: "-<?php echo $diffmin;?>d"			
		}		
		
	// fix um bei klicken auf "Heute" den Kalender zu schliessen	
		var old_goToToday = $.datepicker._gotoToday;
		$.datepicker._gotoToday = function(id) {
			old_goToToday.call(this,id);   
			this._selectDate(id);
		};
		
		$.datepicker._defaults['currentText'] = calTranslation['currentText'][$globlan];
		$.datepicker._defaults['monthNames'] = calTranslation['monthNames'][$globlan];
		$.datepicker._defaults['monthNamesShort'] = calTranslation['monthNamesShort'][$globlan];
		$.datepicker._defaults['dayNamesMin'] = calTranslation['dayNamesMin'][$globlan];
		
		$("#sdat").datepicker(pickerOpts);
		clkevnt = $("#sdat").next().data('events').click[0].handler;
		$("#sdat").next().replaceWith('<span class="ui-datepicker-trigger icn_calendar_b_n clckbtn vam" data-type="title" data-lan="cal" title="<?php echo $ini_atopten['cal'][$_SESSION['lng']]; ?>"> </span>');
		$("#sdat").next().bind('click', clkevnt);		
		$("#edat").datepicker(pickerOpts_2);
		clkevnt = $("#edat").next().data('events').click[0].handler;
		$("#edat").next().replaceWith('<span class="ui-datepicker-trigger icn_calendar_b_n clckbtn vam" data-type="title" data-lan="cal" title="<?php echo $ini_atopten['cal'][$_SESSION['lng']]; ?>"> </span>');
		$("#edat").next().bind('click', clkevnt);
			
		$('#clss').val("T");
		$('#clss').width(175).customSelect({customClass: "cSelect_wht"});
		
		function load_page() {
			$("#sdat").val(localizedate("<?php echo $lmin; ?>"));
			$("#edat").val(localizedate("<?php echo $max; ?>"));
			$("#sdat_org").val("<?php echo $lmin; ?>");
			$("#edat_org").val("<?php echo $max; ?>");
			$("#sdat_i").val("<?php echo $lmin; ?>");			// min start date
			$("#edat_i").val("<?php echo $max; ?>");			// max end date	
			ttm();
		}
		function c_lan() {
			translate_header($globlan);	
			translate_mainmenu($globlan);
			$.each($('#container *').filter(function(){return $(this).data('lan') !== undefined;}), function() {	
				switch ($(this).data("type")) {
					case "text":		
						$(this).text(localTranslation[$(this).data("lan")][$globlan]);
						break;
					case "title":				
						$(this).attr("title", localTranslation[$(this).data("lan")][$globlan]);
						break;
					case "date":
						$(this).val(localizedate($($(this).data("lan")).val()));
						break;
					case "select":
						if ($(this).data("lan") == "clss") {
							$(this).find("option").each(function() {
								$(this).text(classTranslation[$(this).val()][$globlan]);
							});
							$('#clss').trigger('render');
						}
						break;						
				}
			});
			switch ($("#chartdiv").attr("data-chart")) {
				case "ttm":
					plot1.replot({
						axes:{
							yaxis:{
								label: localTranslation['count'][$globlan]
							}
						}
					});
					break;
				case "tts":
					plot1.replot({
						axes:{
							yaxis:{
								label: localTranslation['count'][$globlan]
							}
						}
					});
					break;
				case "ttffu":
					ticknames = Array();
					$.each(qbticks, function(key, value) {
						ticknames.push(ffuTranslation[value][$globlan]);
					});
					plot1.replot({
						axes:{
							yaxis:{
								label: localTranslation['count'][$globlan]
							},
							xaxis:{
								ticks: ticknames
							}						
						}
					});
					break;			
			}
			$.datepicker._defaults['currentText'] = calTranslation['currentText'][$globlan];
			$.datepicker._defaults['monthNames'] = calTranslation['monthNames'][$globlan];
			$.datepicker._defaults['monthNamesShort'] = calTranslation['monthNamesShort'][$globlan];
			$.datepicker._defaults['dayNamesMin'] = calTranslation['dayNamesMin'][$globlan];			
		}
		function backtoanalysis() {
			window.location.href="./analysis.php";
		}
		function ttffu() {
		// change highlighted button
			$("#btn_div span[data-type='text']").removeClass("spanbuttonps").addClass("spanbuttonp");
			$("#ttffub").addClass("spanbuttonps");
			$("#chartdiv").empty().attr("data-chart", "ttffu");	
			$.ajax({
				type: "POST",
				cache: false,
				url:  "./tools/a_topten_api.php",
				data: { 
					routine: "toptenffu",
					sdate: $("#sdat_org").val(),
					edate: $("#edat_org").val(),
					clss: $("#clss").val()
				},
				dataType: "json",
				success: function(result)
				{
					qbticks = result[0];
					qbresult = result[1];
					ticknames = Array();
					var i;
					for (i = 0; i < qbticks.length; ++i) {
						ticknames.push(ffuTranslation[qbticks[i]][$globlan]);
					}
					optionObj = {
						captureRightClick: true,
						grid:{shadow:false, borderWidth:1.0},
						axes:{
							yaxis:{
								min:0, 
								max: Math.max.apply(Math,qbresult)*1.1,
								tickOptions: {formatString: '%d'},
								label: localTranslation['count'][$globlan],
								labelRenderer: $.jqplot.CanvasAxisLabelRenderer,
								labelOptions:{
									angel: 90
								}							
							},
							xaxis:{
								min:0, 
								max: qbresult.length,
								tickOptions: {
									formatString: '%d',
									angle: -30,
									fontSize: '8pt',
									fontFamily:'Helvetica'
								},
								tickRenderer:$.jqplot.CanvasAxisTickRenderer, 
								renderer:$.jqplot.CategoryAxisRenderer,
								ticks: ticknames
							}
						},
						seriesDefaults:{
							renderer:$.jqplot.BarRenderer,
							rendererOptions: {
								highlightMouseOver: false,
								barWidth: 50,
								varyBarColor: true
							},
							pointLabels: { 
								show: true, 
								location: 'n', 
								ypadding: 2 
							}					
						},					
						grid: 
						{         
							gridLineWidth: 2.5,         
							gridLineColor: "<?php echo $c_scheme['GG']; ?>",         
							drawGridlines: true,
							shadow:false, 
							borderWidth:1.0,
							background: "<?php echo $c_scheme['GB']; ?>"
						},						
						seriesColors:["<?php echo $c_scheme['G1']; ?>", "<?php echo $c_scheme['G2']; ?>"]
					};
					plot1 = $.jqplot('chartdiv', [qbresult], optionObj);
				}
			});			
		}		
		function tts() {
		// change highlighted button
			$("#btn_div span[data-type='text']").removeClass("spanbuttonps").addClass("spanbuttonp");
			$("#ttsb").addClass("spanbuttonps");
			$("#chartdiv").empty().attr("data-chart", "tts");	
			$.ajax({
				type: "POST",
				cache: false,
				url:  "./tools/a_topten_api.php",
				data: { 
					routine: "toptensup",
					sdate: $("#sdat_org").val(),
					edate: $("#edat_org").val(),
					clss: $("#clss").val()
				},
				dataType: "json",
				success: function(result)
				{
					ticknames = result[0];
					qbresult = result[1];			
					optionObj = {
						captureRightClick: true,
						grid:{shadow:false, borderWidth:1.0},
						axes:{
							yaxis:{
								min:0, 
								max: Math.max.apply(Math,qbresult)*1.1,
								tickOptions: {formatString: '%d'},
								label: localTranslation['count'][$globlan],
								labelRenderer: $.jqplot.CanvasAxisLabelRenderer,
								labelOptions:{
									angel: 90
								}							
							},
							xaxis:{
								min:0, 
								tickOptions: {
									formatString: '%d',
									angle: -30,
									fontSize: '8pt',
									fontFamily:'Helvetica'
								},
								tickRenderer:$.jqplot.CanvasAxisTickRenderer, 
								renderer:$.jqplot.CategoryAxisRenderer,
								ticks: ticknames
							}
						},
						seriesDefaults:{
							renderer:$.jqplot.BarRenderer,
							rendererOptions: {
								highlightMouseOver: false,
								barWidth: 50,
								varyBarColor: true
							},
							pointLabels: { 
								show: true, 
								location: 'n', 
								ypadding: 2 
							}					
						},					
						grid: 
						{         
							gridLineWidth: 2.5,         
							gridLineColor: "<?php echo $c_scheme['GG']; ?>",         
							drawGridlines: true,
							shadow:false, 
							borderWidth:1.0,
							background: "<?php echo $c_scheme['GB']; ?>"
						},						
						seriesColors:["<?php echo $c_scheme['G1']; ?>", "<?php echo $c_scheme['G2']; ?>"]
					};
					plot1 = $.jqplot('chartdiv', [qbresult], optionObj);
				}
			});			
		}
		function ttm1(loc) {
			if ($(loc).data("checked")) {
				$(loc).data("checked", false);
				$(loc).removeClass("icn_checkboxchecked_c_n").addClass("icn_checkboxempty_c_n");
			} else {		
				$(loc).data("checked", true);
				$(loc).removeClass("icn_checkboxempty_c_n").addClass("icn_checkboxchecked_c_n");	
			}	
			ttm();
		}
		function ttm() {
		// change highlighted button
			$("#btn_div span[data-type='text']").removeClass("spanbuttonps").addClass("spanbuttonp");
			$("#ttmb").addClass("spanbuttonps");
			$("#chartdiv").empty().attr("data-chart", "ttm");	
			$.ajax({
				type: "GET",
				cache: false,
				url:  "./tools/a_topten_api.php",
				data: { 
					routine: "toptenmat",
					sdate: $("#sdat_org").val(),
					edate: $("#edat_org").val(),
					o_xxx: $("#o_xxx").data("checked")?0:1,
					clss: $("#clss").val()
				},
				dataType: "json",
				success: function(result)
				{
					ticknames = result[0];
					qbresult = result[1];				
					optionObj = {
						captureRightClick: true,
						grid:{shadow:false, borderWidth:1.0},
						axes:{
							yaxis:{
								min:0, 
								max: Math.max.apply(Math,qbresult)*1.1,
								tickOptions: {formatString: '%d'},
								label: localTranslation['count'][$globlan],
								labelRenderer: $.jqplot.CanvasAxisLabelRenderer,
								labelOptions:{
									angel: 90
								}							
							},
							xaxis:{
								min:0, 
								tickOptions: {
									formatString: '%d',
									angle: -30,
									fontSize: '8pt',
									fontFamily:'Helvetica'
								},
								tickRenderer:$.jqplot.CanvasAxisTickRenderer, 
								renderer:$.jqplot.CategoryAxisRenderer,
								ticks: ticknames
							}
						},
						seriesDefaults:{
							renderer:$.jqplot.BarRenderer,
							rendererOptions: {
								highlightMouseOver: false,
								barWidth: 50,
								shadowDepth: 0,
								varyBarColor: true							
							},
							pointLabels: { 
								show: true, 
								location: 'n', 
								ypadding: 2 
							}					
						},
						grid: 
						{         
							gridLineWidth: 2.5,         
							gridLineColor: "<?php echo $c_scheme['GG']; ?>",         
							drawGridlines: true,
							shadow:false, 
							borderWidth:1.0,
							background: "<?php echo $c_scheme['GB']; ?>"
						},						
						seriesColors:["<?php echo $c_scheme['G1']; ?>", "<?php echo $c_scheme['G2']; ?>"]
					};
					plot1 = $.jqplot('chartdiv', [qbresult], optionObj);
				}
			});			
		}
		function update_chart(){
			switch($("#chartdiv").attr("data-chart")) {
				case "ttm":
					ttm();
				break;
				case "tts":
					tts();
				break;
				case "ttffu":
					ttffu();
				break;		
			}			
		}
		load_page();
	</script>
</body>
</html>
