<!DOCTYPE html>
<html>
<head>
	<meta http-equiv="X-UA-Compatible" content="IE=Edge" />
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
	<?php include_once(dirname(__FILE__)."/tools/all_header.php"); global $c_scheme, $timezone, $rel_path; ?>
	
    <title>Analysis WGR</title>
	
	<link rel="stylesheet" href="./css/qb.php" />
	<link rel="stylesheet" href="./jqGrid_5.2.1/css/ui.jqgrid.css" />
	
	<style>
		.ui-jqgrid tr.jqgrow td{
			white-space:nowrap;
			height: 18px !important;
		}
		#pager_left{
			padding-top: 5px;
		}			
	</style>
	
	<script src="./jquery/jquery.min.js"></script>
	<script src="./jquery/jquery-migrate-1.2.1.min.js"></script>	
	<script src="./jquery/jquery-ui.min.js"></script>
	<script src="./jquery/qb_js.js"></script>	
	
	<?php 
		foreach(explode(":", $qb_support->getLanOnly()) as $key=>$value) {
			echo '<script src="./jqGrid_5.2.1/js/i18n/grid.locale-' . $value . '.js"></script>';
		}
	?>
	<script src="./jqGrid_5.2.1/js/jquery.jqGrid.min.js"></script>

	<?php
		$query = "
			SELECT 
				DATE_FORMAT(NOW(), '%Y-%m-%d'), 
				DATEDIFF(MAX(QBREGDATE), NOW()), 
				DATEDIFF(MIN(QBREGDATE), NOW()),
				MIN(QBREGDATE),
				MAX(QBREGDATE),
				IF (DATEDIFF(MAX(QBREGDATE), MIN(QBREGDATE)) > 365, DATE_SUB(MAX(QBREGDATE), INTERVAL 365 DAY), MIN(QBREGDATE))
			FROM 
				qbi 
			WHERE 
				QBSTATUS NOT IN ('M', 'D')
		";
		$stmt = $db->query($query);
		list($now, $diffmax, $diffmin, $min, $max, $lmin) = $stmt->fetch(PDO::FETCH_NUM );
	?>

	<script>
	// load translation and save in localTranslation
		<?php	
			$ini_awgr = parse_ini_file($rel_path.'i18n/a_wgr.ini', true);	
			echo "localTranslation = {};";
			foreach($ini_awgr as $key=>$value){
				$add = "";
				foreach($value AS $lan=>$trans){
					$add .= "'".$lan."':'".$trans."',";
				}
				echo "localTranslation['".$key."']={".rtrim($add, ',')."};";
			}
			$ini_class = parse_ini_file($rel_path.'xml/class.ini', true);
			$ini_class['all']=$ini_awgr['all'];
			echo "classTranslation = {};";
			foreach($ini_class as $key=>$value){
				$add = "";
				foreach($value AS $lan=>$trans){
					$add .= "'".$lan."':'".$trans."',";
				}
				echo "classTranslation['".$key."']={".rtrim($add, ',')."};";
			}				
			$cal = parse_ini_file($rel_path.'i18n/calendar.ini', true);
			echo "calTranslation = {};";
			foreach($cal as $key=>$value){
				$add = "";
				if ($value['tpe'] == "S") {
					foreach($value AS $lan=>$trans){
						if ($lan != "tpe") $add .= "'".$lan."':'".$trans."',";
					}
				} else {
					foreach($value AS $lan=>$trans){
						if ($lan != "tpe") {
							$tar = explode(",", $trans);
							$tar = implode("','", $tar);
							$add .= "'".$lan."': ['".$tar."'],";
						}
					}				
				}
				echo "calTranslation['".$key."']={".rtrim($add, ',')."};";
			}
			$ini_qbstatus = parse_ini_file($rel_path.'xml/qb_status.ini', true);
			$ddr = ":".$ini_awgr['all'][$_SESSION['lng']];			
			echo "qbstatusTranslation = {};";
			foreach($ini_qbstatus as $key=>$value){
				$add = "";
				foreach($value AS $lan=>$trans){
					$add .= "'".$lan."':'".$trans."',";
				}
				echo "qbstatusTranslation['".$key."']={".rtrim($add, ',')."};";
				if (in_array($key, array('N','O','S','C'))) {
					$ddr .= ";".$key.":".$value[$_SESSION['lng']];
				}				
			}
			echo "var ddr = '".$ddr."';";
		?>
	</script>
</head>
<body>
	<div id="container">
		<?php 
			include_once($rel_path.'tools/header.php');
		?> 
		<div id="contents">
			<?php 
				echo "<div id='mainnav'>". $qb_support->get_main_menu(2) . "</div>";
			?>
			<div class="dtop">
				<span class="icn3_arraoleft_w_n clckbtn" style="float: left; font-size: 30px; margin-left: 5px;" data-type="title" data-lan="prev" title="<?php echo $ini_awgr['prev'][$_SESSION['lng']]; ?>" onclick="backtoanalysis()"></span>
				<span data-type="text" data-lan="wgrs"><?php echo $ini_awgr['wgrs'][$_SESSION['lng']]; ?></span>
			</div>
			<div id="btn_div" class="btn_div">
				<p>
					<label class="dlabel vam w50" data-type="text" data-lan="start" ><?php echo $ini_awgr['start'][$_SESSION['lng']]; ?></label>
					<input type="text" id="sdat" data-type="date" data-lan="#sdat_org" class="dinputw vam w75" value="" onchange="update_grid()" readonly />
					<input type="hidden" id="sdat_org" value="" />
					<input type="hidden" id="sdat_i" value="" />
				</p>
				<p style="margin: 5px 0;">
					<label class="dlabel vam w50" data-type="text" data-lan="ende" ><?php echo $ini_awgr['ende'][$_SESSION['lng']]; ?></label>
					<input type="text" id="edat" data-type="date" data-lan="#edat_org" class="dinputw vam w75" value="" onchange="update_grid()" readonly />
					<input type="hidden" id="edat_org" value="" />
					<input type="hidden" id="edat_i" value="" />
				</p>
				<p style="margin-top: 15px; padding-bottom: 10px; border-bottom: 2px solid "<?php echo $c_scheme['RN']; ?>";">
					<select id="clss" data-type="select" data-lan="clss" onchange="update_grid()" >
						<?php
							foreach($ini_class as $key=>$value){
								echo "<option value='$key'>".$value[$_SESSION['lng']]."</option>";
							}
						?>
					</select>
				</p>				
				<div style="text-align: center; margin-top: 30px;">
					<label class="dlabel vam w150" style="font-weight: bold; text-align: center; " data-type="text" data-lan="wgrs" ><?php echo $ini_awgr['wgrs'][$_SESSION['lng']]; ?></label>
					<br />
					<select id="wgrs" class="vam " data-lan="wgrselect" onchange="update_grid()" size="10" style="width: 130px; margin: 5px 0px; height: 100px; border: 1px solid #CCCCCC;" multiple >
						<option value="all" selected><?php echo $ini_awgr['all'][$_SESSION['lng']]; ?></option>
						<?php 
							$query = "
								SELECT
									WGR
								FROM
									qb_material
								LEFT JOIN
									qbbasic
								ON
									TGR=MNR
								LEFT JOIN
									qbi
								ON
									qbi.QBN=qbbasic.QBN
								WHERE
									QBSTATUS NOT IN ('D', 'M') AND 
									WGR <> ''
								GROUP BY
									WGR
								ORDER BY WGR
							";
							$stmt = $db->query($query);
							while($r = $stmt->fetch(PDO::FETCH_NUM)) {		
								echo "<option value='".$r[0]."'>".$r[0]."</option>";
							}								
						?>
					</select>
					<br />
					<div style="text-align: center; margin-top: 30px;">	
						<span class="spanbuttonp" id="excel" data-type="text" data-lan="excel_export" onclick="ExportDataToExcel();"><?php echo $ini_awgr['excel_export'][$_SESSION['lng']]; ?></span>	
					</div>
				</div>
			</div>				
			<div style="display: inline-block; width: 810px; text-align: center; overflow: scroll;">
				<table id="list"></table> 
				<div id="pager"></div> 
			</div>
		</div>
		<?php include_once($rel_path.'footer.php'); ?> 				
	</div>
	<form name="anqbxls" method="post" target="_blank" action = "./tools/a_wgr_excel.php";>
		<input type="hidden" name="titles" id="titles" value="" />
		<input type="hidden" name="filters" id="filters" value="" />
		<input type="hidden" name="qblan" id="qblan" value="" />
		<input type="hidden" name="sdate" id="sdate" value="" />
		<input type="hidden" name="edate" id="edate" value="" />
		<input type="hidden" name="qbclss" id="qbclss" value="" />
		<input type="hidden" name="qbwgr" id="qbwgr" value="" />
	</form>	
	<script>
		pickerOpts = {
			closeText: "X",		
			dateFormat: "yy-M-dd",
			altField: '#sdat_org',
			altFormat: 'yy-mm-dd',
			firstDay: 1,
			isRTL: false,
			showButtonPanel: true,
			displayClose: true,
			showOn: "button",  
			buttonImage: "./img/dummy_img.png", 
			buttonImageOnly: true,
			buttonText: localTranslation["cal"][$globlan],
			changeYear: true,
			changeMonth: true,
			maxDate: "+<?php echo $diffmax;?>d",
			minDate: "-<?php echo $diffmin;?>d"		
		}
		pickerOpts_2 = {
			closeText: "X",		
			dateFormat: "yy-M-dd",
			altField: '#edat_org',
			altFormat: 'yy-mm-dd',
			firstDay: 1,
			isRTL: false,
			showButtonPanel: true,
			displayClose: true,
			showOn: "button",  
			buttonImage: "./img/dummy_img.png", 
			buttonImageOnly: true,
			buttonText: localTranslation["cal"][$globlan],
			changeYear: true,
			changeMonth: true,
			maxDate: "+<?php echo $diffmax;?>d",
			minDate: "-<?php echo $diffmin;?>d"	
		}		
				
	// fix um bei klicken auf "Heute" den Kalender zu schliessen	
		var old_goToToday = $.datepicker._gotoToday;
		$.datepicker._gotoToday = function(id) {
			old_goToToday.call(this,id);   
			this._selectDate(id);
			$heute = true;
		};
		
		$.datepicker._defaults['currentText'] = calTranslation['currentText'][$globlan];
		$.datepicker._defaults['monthNames'] = calTranslation['monthNames'][$globlan];
		$.datepicker._defaults['monthNamesShort'] = calTranslation['monthNamesShort'][$globlan];
		$.datepicker._defaults['dayNamesMin'] = calTranslation['dayNamesMin'][$globlan];
		
		$("#sdat").datepicker(pickerOpts);
		clkevnt = $("#sdat").next().data('events').click[0].handler;
		$("#sdat").next().replaceWith('<span class="ui-datepicker-trigger icn_calendar_b_n clckbtn vam" data-type="title" data-lan="cal" title="<?php echo $ini_awgr['cal'][$_SESSION['lng']]; ?>"> </span>');
		$("#sdat").next().bind('click', clkevnt);		
		$("#edat").datepicker(pickerOpts_2);
		clkevnt = $("#edat").next().data('events').click[0].handler;
		$("#edat").next().replaceWith('<span class="ui-datepicker-trigger icn_calendar_b_n clckbtn vam" data-type="title" data-lan="cal" title="<?php echo $ini_awgr['cal'][$_SESSION['lng']]; ?>"> </span>');
		$("#edat").next().bind('click', clkevnt);
			
		$('#clss').val("T");
		$('#clss').width(175).customSelect({customClass: "cSelect_wht"});
		
		function load_page() {
			$("#sdat").val(localizedate("<?php echo $lmin; ?>"));
			$("#edat").val(localizedate("<?php echo $max; ?>"));
			$("#sdat_org").val("<?php echo $lmin; ?>");
			$("#edat_org").val("<?php echo $max; ?>");
			$("#sdat_i").val("<?php echo $lmin; ?>");			// min start date
			$("#edat_i").val("<?php echo $max; ?>");			// max end date	
			start_search();
		}
	// switch language
		function c_lan() {
			translate_header($globlan);	
			translate_mainmenu($globlan);
			$.each($('#container *').filter(function(){return $(this).data('lan') !== undefined;}), function() {	
				switch ($(this).data("type")) {
					case "text":		
						$(this).text(localTranslation[$(this).data("lan")][$globlan]);
						break;
					case "title":				
						$(this).attr("title", localTranslation[$(this).data("lan")][$globlan]);
						break;
					case "date":
						$(this).val(localizedate($($(this).data("lan")).val()));
						break;
					case "select":
						if ($(this).data("lan") == "clss") {
							$(this).find("option").each(function() {
								$(this).text(classTranslation[$(this).val()][$globlan]);
							});
							$('#clss').trigger('render');
						}
						break;						
				}
			});	
			$("#wgrs").find("option[value='all']").text(localTranslation["all"][$globlan]);
			$.jgrid.setRegional('list',{regional: $globlan});
			$("#list").jqGrid('setLabel', "qbn", localTranslation["qbn"][$globlan])
				.jqGrid('setLabel', "qbdat", localTranslation["date"][$globlan])
				.jqGrid('setLabel', "wgr", localTranslation["wgr"][$globlan])
				.jqGrid('setLabel', "mat", localTranslation["imat"][$globlan])
				.jqGrid('setLabel', "des", localTranslation["des"][$globlan]);						
			$("#gs_status").find("option").each(function(idx, obj) {
				if ($(this).val() == "") {
					$(this).text(localTranslation["all"][$globlan]);
				} else {
					$(this).text(qbstatusTranslation[$(this).val()][$globlan]);
				}
			});
			$("#list").trigger("reloadGrid");
			$.datepicker._defaults['currentText'] = calTranslation['currentText'][$globlan];
			$.datepicker._defaults['monthNames'] = calTranslation['monthNames'][$globlan];
			$.datepicker._defaults['monthNamesShort'] = calTranslation['monthNamesShort'][$globlan];
			$.datepicker._defaults['dayNamesMin'] = calTranslation['dayNamesMin'][$globlan];			
		}
		function backtoanalysis() {
			window.location.href="./analysis.php";
		}	
		
		function StatusFormatter (cellvalue, options, rowObject)
		{
			var ctext = qbstatusTranslation[cellvalue][$globlan];
			return ctext;
		}
		function DescFormatter (cellvalue, options, rowObject)
		{	
			return cellvalue;
		}		
		function update_grid() {
			$("#list").setGridParam({
				datatype: "json", 
				postData: {
					routine: "search",
					sdate: $("#sdat_org").val(),
					edate: $("#edat_org").val(),
					wgr1:"'"+$("#wgrs").val().join("','")+"'",
					clss: $("#clss").val()
				} 
			}).trigger("reloadGrid");
		}
		function start_search() {
			$("#loading").show();		
			cmTemplate = {
				sorttype:'string',
				editable: false,
				searchoptions: {
					sopt:['cn'], 
					clearSearch: false
				}
			};			
			obj = {
				url:  "./tools/a_wgr_api.php",
				postData: {
					routine: "search",
					sdate: $("#sdat_org").val(),
					edate: $("#edat_org").val(),
					wgr1: "'"+$("#wgrs").val().join("','")+"'",
					clss: $("#clss").val()
				},
				contentType: "application/json",
				datatype: "json",
				jsonReader: {
					id: "id",
					repeatitems: true
				},
				mtype: "POST",
				colNames: [
					localTranslation["qbn"][$globlan],
					localTranslation["date"][$globlan],
					localTranslation["wgr"][$globlan], 
					localTranslation["imat"][$globlan],
					localTranslation["status"][$globlan],
					localTranslation["des"][$globlan],
					localTranslation["svt"][$globlan],
					localTranslation["department"][$globlan],
					""
				],
				colModel: [
					{ 
						name: "qbn", 
						width: 70, 
						template: cmTemplate
					},				
					{
						name: "qbdat", 
						width: 70,
						template: cmTemplate
					},
					{ 
						name: "wgr", 
						width: 100,
						template: cmTemplate,
						search: false
					},
					{
						name: "mat", 
						width: 120,
						template: cmTemplate
					},
					{
						name: "status", 
						width: 120,
						template: cmTemplate,
						stype: 'select',					
						searchoptions:
						{
							value: ddr,
							clearSearch: false,
							searchOperators: false
						},	
						formatter: StatusFormatter
					},				
					{ 
						name: "des", 
						width: 255, 
						editable: false,			
						sorttype:'string', 
						searchoptions:
						{
							sopt:['cn','nc','bw','eq','bn','ew','en'],
							clearSearch: false
						},
						formatter: DescFormatter
					},
					{
						name: "svt", 
						width: 130,
						template: cmTemplate
					},
					{
						name: "dep", 
						width: 70,
						template: cmTemplate
					},
					{
						name: "sts", 
						hidden: true
					}				
				],
				regional: $globlan,
				storeNavOptions : true,			
				loadonce: false,
				pager: "#pager",
				recordpos: "left",
				height: 500,
				rowNum: 100,
				rowList: [10, 100, 500, 1000, 1500],
				hoverrows: false,
				rownumbers:true,
				sortname: "qbn",
				sortorder: "desc",
				viewrecords: true,
				gridview: true,
				autoencode: true,
				ignoreCase:true,
				loadui: "block",
				onRightClickRow: function (rowid, iRow, iCol, e) {
					window.localStorage.setItem("qb", $("#list").jqGrid('getRowData', rowid).qbn);
					$.ajax({
						url: "./tools/general_api.php",
						data: {
							routine: "get_qbs",
							qbn: $("#list").jqGrid('getRowData', rowid).qbn
						},
						success: function(result) {
							window.localStorage.setItem("qbn", result.substring(1, result.length-1));				
							window.open(
								'./basic.php',
								'_blank'
							);
							return false;
						}		
					});
					return false;
				},			
				loadComplete: function() {
					$.each($(".soptclass"), function(key, value) {
						if ($(this).attr("colname") != "des") {
							$(this).hide();
							$(this).parent().css("width", "0");
						}
					});	
					$("th[role='columnheader']")
						.unbind("mouseenter")
						.unbind("mouseleave");
					$(".ui-search-toolbar input[role='textbox']")
						.css("width", "92%")
						.css("background", "<?php echo $c_scheme['M5']; ?>")
						.css("padding", "2px");	
					$(".ui-search-toolbar select[role='select']")
						.removeClass("ui-corner-all")
						.css("background", "<?php echo $c_scheme['M5']; ?>")
						.css("padding", "2px");						
					$("#gs_status").css("width", "115px");		
					var rows = $("#list").getDataIDs();
					for(a=0;a<rows.length;a++)
					{
						row = $("#list").getRowData(rows[a]);
						switch(row.sts) {
							case "N":
								$("#list").setCell (rows[a], "status","",{"background":"<?php echo $c_scheme['SN']; ?>"});
								break;					
							case "O":
								$("#list").setCell (rows[a], "status","",{"background":"<?php echo $c_scheme['SO']; ?>"});
								break;
							case "S":
								$("#list").setCell (rows[a], "status","",{"background":"<?php echo $c_scheme['ST']; ?>"});
								break;
							case "C":
								$("#list").setCell (rows[a], "status","",{"background":"<?php echo $c_scheme['SC']; ?>"});
								break;
						}
					}
				}			
			};
			list1 = $("#list").jqGrid(obj)
				.jqGrid('filterToolbar',{searchOperators : true, searchOnEnter: false})
				.jqGrid('navGrid', '#pager', {refresh: false, search: false, edit: false, del: false, add: false});
			$("#loading").hide();	
		}
		function ExportDataToExcel() {
		// create output object
			out = Array();
		// define columns to be exported
			var exp_cols = Array("qbn", "qbdat", "wgr", "mat", "status", "des", "svt", "dep");
		// first get all column titles
			var col_titles_all = obj.colNames;
		// now filter those which should be used
			out['titles'] = {};
			$.each(obj.colModel, function(key, value){
				if ($.inArray(value['name'], exp_cols) > -1) out['titles'][value['name']] = col_titles_all[key];
			});
		// get filter
			out['filter'] = {};
			$fltr = $(".ui-search-toolbar input");
			var fltr_set = Array();
			$.each($fltr, function(key, value) {
				if ($.inArray(value['name'], exp_cols) > -1) out['filter'][value['name']] = $(value).val();
			});
			$fltr = $(".ui-search-toolbar select");
			$.each($fltr, function(key, value) {
				if ($.inArray(value['name'], exp_cols) > -1) out['filter'][value['name']] = $(value).val();
			});			
			$("#titles").val(JSON.stringify(out['titles']));
			$("#filters").val(JSON.stringify(out['filter']));
			$("#qblan").val($globlan);
			var $ttt = {};
			$ttt[$('#clss').val()] = $("#clss option:selected").text();
			$("#qbclss").val(JSON.stringify($ttt));
			$("#qbwgr").val("'"+$("#wgrs").val().join("','")+"'");
			$("#sdate").val($("#sdat_org").val());
			$("#edate").val($("#edat_org").val());
			document.anqbxls.submit();
		}		
		load_page();
	</script>
</body>
</html>