<!DOCTYPE html>
<html>
<head>
	<meta http-equiv="X-UA-Compatible" content="IE=Edge" />
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />	
	<?php include_once(dirname(__FILE__)."/tools/all_header.php"); global $c_scheme, $timezone, $rel_path; ?>
	<script>
		var js_debug = false;
		$data_changed = false;		
	</script>
	
    <title>Analysis Immediate Closure Graph</title>

	<link rel="stylesheet" href="./css/qb.php" />
	<link rel="stylesheet" type="text/css" href="./jqplot/jquery.jqplot.css" />
	
	<script src="./jquery/jquery.min.js"></script>
	<script src="./jquery/jquery-migrate-1.2.1.min.js"></script>	
	<script src="./jquery/jquery-ui.min.js"></script>
	<script src="./jquery/qb_js.js"></script>
	
	<script src="./jqplot/jquery.jqplot.min.js"></script>
	<script src="./jqplot/plugins/jqplot.barRenderer.min.js"></script>
	<script src="./jqplot/plugins/jqplot.pieRenderer.min.js"></script>
	<script src="./jqplot/plugins/jqplot.categoryAxisRenderer.min.js"></script>
	<script src="./jqplot/plugins/jqplot.boxplotRenderer.js"></script>
	<script src="./jqplot/plugins/jqplot.highlighter.min.js"></script>
	<script src="./jqplot/plugins/jqplot.pointLabels.min.js"></script>
    <script src="./jqplot/plugins/jqplot.canvasTextRenderer.min.js"></script>
    <script src="./jqplot/plugins/jqplot.canvasAxisLabelRenderer.min.js"></script>
	<script src="./jqplot/plugins/jqplot.enhancedLegendRenderer.min.js"></script>
    <script src="./jqplot/plugins/jqplot.canvasAxisTickRenderer.min.js"></script>
	<script src="./jqplot/plugins/jqplot.canvasOverlay.min.js"></script>	
	
	<script>
	// load translation and save in localTranslation
		<?php	
			$ini_axx = parse_ini_file($rel_path.'i18n/a_xx.ini', true);	
			echo "localTranslation = {};";
			foreach($ini_axx as $key=>$value){
				$add = "";
				foreach($value AS $lan=>$trans){
					$add .= "'".$lan."':'".$trans."',";
				}
				echo "localTranslation['".$key."']={".rtrim($add, ',')."};";
			}
			$cal = parse_ini_file($rel_path.'i18n/calendar.ini', true);
			echo "calTranslation = {};";
			foreach($cal as $key=>$value){
				$add = "";
				if ($value['tpe'] == "S") {
					foreach($value AS $lan=>$trans){
						if ($lan != "tpe") $add .= "'".$lan."':'".$trans."',";
					}
				} else {
					foreach($value AS $lan=>$trans){
						if ($lan != "tpe") {
							$tar = explode(",", $trans);
							$tar = implode("','", $tar);
							$add .= "'".$lan."': ['".$tar."'],";
						}
					}				
				}
				echo "calTranslation['".$key."']={".rtrim($add, ',')."};";
			}
		?>
	</script>
</head>
<body>
	<div id="container">
		<?php 
			include_once($rel_path.'tools/header.php');
		?> 
		<div id="contents">
			<?php 
				echo "<div id='mainnav'>". $qb_support->get_main_menu(2) . "</div>";
			?>
			<div class="dtop">
				<span class="icn3_arraoleft_w_n clckbtn" style="float: left; font-size: 30px; margin-left: 5px;" data-type="title" data-lan="prev" title="<?php echo $ini_axx['prev'][$_SESSION['lng']]; ?>" onclick="backtoanalysis()"></span>
				<span data-type="text" data-lan="imm_close"><?php echo $ini_axx['imm_close'][$_SESSION['lng']]; ?></span>
			</div>
			<div id="btn_div" class="btn_div">
				<label class="dlabel vam w50" data-type="text" data-lan="start" ><?php echo $ini_axx['start'][$_SESSION['lng']]; ?></label>
				<input type="text" id="sdat" data-type="date" data-lan="#sdat_org" class="dinputw vam w75" value="" readonly />
				<input type="hidden" id="sdat_org" value="<?php echo $_REQUEST['sd_org1g']; ?>" />
				<br style="margin: 10px 0;" />
				<label class="dlabel vam w50" data-type="text" data-lan="ende" ><?php echo $ini_axx['ende'][$_SESSION['lng']]; ?></label>
				<input type="text" id="edat" data-type="date" data-lan="#edat_org" class="dinputw vam w75" value="" readonly />
				<input type="hidden" id="edat_org" value="<?php echo $_REQUEST['ed_org1g']; ?>" />
			</div>
		<!-- container for chart -->				
			<div style="border: 0px solid green; display: inline-block; vertical-align: top; margin: 0; padding: 0; padding-top: 25px;">
				<div id="chartdiv" style="display: inline-block; vertical-align: top; height:560px; width:710px; margin: 0;"></div>
				<div id="boxplotdiv" style="display: inline-block; vertical-align: top; height:530px; width:100px; margin: auto;"></div>
			</div>
		</div>
		<?php include_once($rel_path.'footer.php'); ?>
	</div>
	<script>
		function load_page() {
			$("#sdat").val("<?php echo $_REQUEST['sd_og']; ?>");
			$("#edat").val("<?php echo $_REQUEST['ed_og']; ?>");
			start_search();
		}
		function c_lan() {
			translate_header($globlan);	
			translate_mainmenu($globlan);
			$.each($('#container *').filter(function(){return $(this).data('lan') !== undefined;}), function() {			
				switch ($(this).data("type")) {
					case "text":		
						$(this).text(localTranslation[$(this).data("lan")][$globlan]);
						break;
					case "title":				
						$(this).attr("title", localTranslation[$(this).data("lan")][$globlan]);
						break;
					case "date":
						$(this).val(localizedate($($(this).data("lan")).val()));
						break;						
				}
			});
			plot1.replot({
				axes:{
					yaxis:{
						label: localTranslation['count'][$globlan]
					},
					xaxis:{
						label: localTranslation['month_txt'][$globlan]
					}
				},						
			});	
		}
		function backtoanalysis() {
			window.location.href="a_xx.php";
		}
		function start_search() {
			$("#loading").show();
			$.ajax({
				type: "GET",
				cache: false,
				url:  "./tools/a_xx_api.php",
				data: { 
					routine: "graphics",
					sdate: '<?php echo $_REQUEST['sd_org1g']; ?>',
					edate: '<?php echo $_REQUEST['ed_org1g']; ?>',
					filter: '<?php echo $_REQUEST['filtersg']; ?>'
				},
				dataType: "json",
				success: function(qbresult)
				{			
					optionObj = {
						captureRightClick: true,
						axes:{
							yaxis:{
								autoscale: true,
								min:0, 
								tickOptions: {formatString: '%d'},
								label: localTranslation['count'][$globlan],
								labelRenderer: $.jqplot.CanvasAxisLabelRenderer,
								labelOptions:{
									angel: 90,
									textColor: "<?php echo $c_scheme['GT']; ?>"
								}							
							},
							xaxis:{
								tickRenderer:$.jqplot.CanvasAxisTickRenderer, 
								tickOptions: {
									formatString: '%d',
									angle: 0,
									showGridline: false,
									fontSize: '9pt',
									fontFamily:'Arial'
								},
								ticks: qbresult[1],
								renderer:$.jqplot.CategoryAxisRenderer,
								label: localTranslation['month_txt'][$globlan]
							}
						},
						highlighter: { show: false },
						grid: 
						{         
							gridLineWidth: 2.5,         
							gridLineColor: "<?php echo $c_scheme['GG']; ?>",         
							drawGridlines: true,
							shadow:false, 
							borderWidth:1.0,
							background: "<?php echo $c_scheme['GB']; ?>"
						},
						seriesDefaults:{
							renderer:$.jqplot.BarRenderer,
							rendererOptions: {
								barMargin: 5,
								shadowDepth: 0,
								highlightMouseOver: false,
								varyBarColor: true
							},
							pointLabels: { 
								show: true, 
								location: 'n', 
								ypadding: 2
							}
						},
						seriesColors: [ "<?php echo $c_scheme['G1']; ?>", "<?php echo $c_scheme['G2']; ?>"]
					};
					plot1 = $.jqplot('chartdiv', [qbresult[0]], optionObj);
					$("#loading").hide();
				}
			});		
		}
		load_page();
	</script>
</body>
</html>