<?php
// open log file
	$myFile = dirname(__FILE__) . "/log_del_qblogs.txt";	
	$fh = fopen($myFile, 'a');	
	$stringData = "*** Checking for log files to be deleted  @ " . date("Y-m-d H:i:s") . " ***\r\n";	
	fwrite($fh, $stringData);	
	if ($qb_support->getoptions("writelogfiles", "set") == "no") {
// run code only if log files are activated
			fwrite($fh, "// log files not enabled - exiting \r\n");
			fclose($fh);
			return;
	}
	$deldays = $qb_support->getoptions("writelogfiles", "deleteafter");
	if ($deldays == "0") {
// never delete log files
			fwrite($fh, "// option 'never delete log files' selected - exiting \r\n");
			fclose($fh);
			return;
	}
	$files = "('";
	foreach (new DirectoryIterator(dirname(__FILE__).'/../log') as $file) {
			if ($file->isFile()) {
					$files .= substr($file->getFilename(),0, -4) . "','";
			}
	}
	$files = substr($files, 0, -2) .")";
	$stmt = $db->query("SELECT qbi.QBN, GQ_DATE FROM qbi LEFT JOIN qb_close ON qbi.QBN=qb_close.QBN WHERE QBSTATUS='C' AND qbi.QBN IN " . $files);
	$result = $stmt->fetchAll(PDO::FETCH_NUM);
	$today = new DateTime("now");
	$cnt = 0;
	$stringData = "";
	foreach ($result as $key=>$value) {
			$date2 = new DateTime($value[1]);
			$diff = $today->diff($date2)->format("%d");
			if ($diff > $deldays) {
					unlink(dirname(__FILE__).'/../log'.$ds.$value[0].'.log');
					fwrite($fh, "File " . $value[0].".log deleted\r\n");
					$cnt++;
			}
	}
// write log file
	fwrite($fh, "// ". $cnt . " log files deleted\r\n");
	fclose($fh);
// write updates
	$stmt = $db->query("SELECT ACT FROM qb_bw ORDER BY ACT DESC LIMIT 0,1");
	$row = $stmt->fetchAll(PDO::FETCH_COLUMN, 0);
	$act = (count($row)==0)?'2000-01-01 00:00:00':$row[0];
	$query = "SELECT QBN FROM qbi WHERE ACT > :act";
	$stmt = $db->prepare($query);
	$stmt->execute(array(':act' => $act));
	$array1 = $stmt->fetchAll(PDO::FETCH_COLUMN, 0);
	$query = "SELECT QBN FROM qbbasic WHERE ACT > :act";
	$stmt = $db->prepare($query);
	$stmt->execute(array(':act' => $act));
	$array2 = $stmt->fetchAll(PDO::FETCH_COLUMN, 0);
	$query = "SELECT QBN FROM qb_imp WHERE ACT > :act";
	$stmt = $db->prepare($query);
	$stmt->execute(array(':act' => $act));
	$array3 = $stmt->fetchAll(PDO::FETCH_COLUMN, 0);
	$query = "SELECT QBN FROM qb_close WHERE ACT > :act";
	$stmt = $db->prepare($query);
	$stmt->execute(array(':act' => $act));
	$array4 = $stmt->fetchAll(PDO::FETCH_COLUMN, 0);
	$final = array_unique(array_merge($array1, $array2, $array3, $array4), SORT_REGULAR);
	if (count($final) != 0) {
		$f1 = "'".join("','", $final)."'";
/* original query 
		$query = "
			INSERT INTO qb_bw (QBN, DAT, CLS, RTP, MNR, STS, CUS, FFU, CLD, IMP, WGR, DEP, REG, QTY, UPD)
			SELECT 
				qbi.QBN AS qbn, 
				QBREGDATE AS dat, 
				CLSS AS cls, 
				RTYPE AS rtp, 
				COALESCE(MNR, "") AS mnr, 
				QBSTATUS AS sts, 
				COALESCE(CUSTOMER, "") AS cus, 
				COALESCE(FFU, '') AS ffu, 
				COALESCE(CL_DATE, '') AS cld, 
				COALESCE(DATE_ACC_BY_SVT, '') AS imp, 
				COALESCE((SELECT WGR FROM qb_material WHERE TGR=MNR), "") AS wgr, 
				(SELECT DEPARTMENT FROM qb_user WHERE SVT=LOGIN) AS dep, 
				COALESCE((SELECT REGION FROM qb_user WHERE REQ=LOGIN), "") AS reg,
				(IF(CLSS='T', (IF(RTYPE='C', 'EXTERNAL', 'INTERNAL')), '')) AS qty,
				'0'
			FROM 
				qbi 
			LEFT JOIN 
				qbbasic 
			ON 
				qbi.QBN=qbbasic.QBN 
			LEFT JOIN 
				qb_close 
			ON 
				qbi.QBN=qb_close.QBN 
			LEFT JOIN 
				qb_imp 
			ON 
				qbi.QBN=qb_imp.QBN 
			WHERE 
				qbi.QBN IN (".$f1.")
			HAVING
				mnr <> '0'
		";
*/
		$query = "
			INSERT INTO qb_bw (QBN, DAT, CLS, RTP, MNR, STS, CUS, FFU, CLD, IMP, WGR, DEP, REG, QTY, UPD)
			SELECT 
				qbi.QBN AS qbn, 
				QBREGDATE AS dat, 
				CLSS AS cls, 
				RTYPE AS rtp, 
				COALESCE(MNR, '') AS mnr, 
				QBSTATUS AS sts, 
				COALESCE(CUSTOMER, '') AS cus, 
				COALESCE(FFU, '') AS ffu, 
				COALESCE(CL_DATE, '') AS cld, 
				COALESCE(DATE_ACC_BY_SVT, '') AS imp, 
				COALESCE((SELECT WGR FROM qb_material WHERE TGR=MNR), '') AS wgr, 
				(SELECT DEPARTMENT FROM qb_user WHERE SVT=LOGIN) AS dep, 
				COALESCE((SELECT REGION FROM qb_user WHERE REQ=LOGIN), '') AS reg,
				(IF(CLSS='T', (IF(RTYPE='C', 'EXTERNAL', 'INTERNAL')), '')) AS qty,
				'0'
			FROM 
				qbi 
			LEFT JOIN 
				qbbasic 
			ON 
				qbi.QBN=qbbasic.QBN 
			LEFT JOIN 
				qb_close 
			ON 
				qbi.QBN=qb_close.QBN 
			LEFT JOIN 
				qb_imp 
			ON 
				qbi.QBN=qb_imp.QBN 
			WHERE 
				qbi.QBN IN (".$f1.")
		";
		$stmt = $db->query($query);
		$query = "UPDATE qb_bw SET CLS=:txt WHERE CLS=:ind AND UPD=0 AND CLS<>''";
		$stmt = $db->prepare($query);
		$stmt->bindParam(':txt', $txt);		
		$stmt->bindParam(':ind', $ind);
		$ini_class = parse_ini_file(dirname(__FILE__).'/../xml/class.ini', true);
		foreach($ini_class as $key=>$value){
			$ind = $key;
			$txt = $value['en'];
			$stmt->execute();
		}
		$query = "UPDATE qb_bw SET RTP=:txt WHERE RTP=:ind AND UPD=0 AND RTP<>''";
		$stmt = $db->prepare($query);
		$stmt->bindParam(':txt', $txt);		
		$stmt->bindParam(':ind', $ind);
		$ini_rtype = parse_ini_file(dirname(__FILE__).'/../xml/r_type.ini', true);
		foreach($ini_rtype as $key=>$value){
			$ind = $key;
			$txt = $value['en'];
			$stmt->execute();
		}
		$query = "UPDATE qb_bw SET STS=:txt WHERE STS=:ind AND UPD=0 AND STS<>''";
		$stmt = $db->prepare($query);
		$stmt->bindParam(':txt', $txt);		
		$stmt->bindParam(':ind', $ind);
		$ini_status = parse_ini_file(dirname(__FILE__).'/../xml/qb_status.ini', true);
		foreach($ini_status as $key=>$value){
			$ind = $key;
			$txt = $value['en'];
			$stmt->execute();
		}
		$query = "UPDATE qb_bw SET FFU=:txt WHERE FFU=:ind AND UPD=0 AND FFU<>''";
		$stmt = $db->prepare($query);
		$stmt->bindParam(':txt', $txt);		
		$stmt->bindParam(':ind', $ind);
		$ini_ffu = parse_ini_file(dirname(__FILE__).'/../xml/ffu.ini', true);
		foreach($ini_ffu as $key=>$value){
			$ind = $key;
			$txt = $value['en'];
			$stmt->execute();
		}
		$stmt = $db->query("UPDATE qb_bw SET UPD=1 WHERE UPD=0");
	// delete duplicates (if other than monitored values changed)
		$query = "SELECT qbn, MAX(IDX) as max FROM qb_bw GROUP BY qbn having count(*) > 1";
		$stmt = $db->query($query);
		$rows = $stmt->fetchAll(PDO::FETCH_ASSOC);
		$query = "DELETE FROM qb_bw WHERE QBN=:qbn AND IDX<>:idx";
		$stmt = $db->prepare($query);
		$stmt->bindParam(':qbn', $qbn);		
		$stmt->bindParam(':idx', $idx);
		foreach($rows as $k=>$v) {
			$idx = $v['max'];
			$qbn = $v['qbn'];
			$stmt->execute();
		}
	// delete deleted Q-Cases from table
		$query = "DELETE FROM qb_bw WHERE STS='DELETED'";
		$stmt = $db->query($query);
	}
?>