<?php
	$cal = parse_ini_file(dirname(__FILE__) . '/../i18n/calendar.ini', true);	
// open log file
	$myFile = dirname(__FILE__) . "/log_overdue_imm_ai.txt";	
	$fh = fopen($myFile, 'a');	
	$stringData = "*** Checking for overdue immediate actions  @ " . date("Y-m-d H:i:s") . " ***\r\n";		
// check for reminders for immediate action items
//
// get reminder intervals
	$query = "SELECT REMINDER3 FROM qb_conf";
	$stmt = $db->query($query);
	$row = $stmt->fetch(PDO::FETCH_NUM );	
// check immediate actions
	$query = "
		SELECT 
			QBN, 
			UNTIL, 
			VORNAME, 
			EMAIL, 
			LANG, 
			qb_docimm.IDX, 
			NACHNAME, 
			WHT 
		FROM 
			qb_docimm 
		LEFT JOIN 
			qb_user 
		ON 
			VISUM=LOGIN 
		WHERE 
			STAT='OPEN' AND 
			DATEDIFF(UNTIL, NOW())<:rem AND 
			INFO<>CURDATE() AND 
			QBN IN (SELECT QBN FROM qbi WHERE QBSTATUS NOT IN ('D', 'M')) AND 
			NACHNAME IS NOT NULL
      LIMIT 30
	";
	$stmt = $db->prepare($query);
	$stmt->execute(array(':rem' => $row[0]));
	while($row = $stmt->fetch(PDO::FETCH_NUM)) {
// resolve language
		list($qbn, $due, $vn, $email, $lang, $imidx, $nn, $what) = $row;
		if ($lang == "") $lang = $qb_support->getOptions('fallbacklang', 'set');
// localize date
		$calloc = explode(",", $cal['monthNamesShort'][$lang]);
		$h1 = explode("-", $due);
		$due = $h1[0] . "-" . $calloc[$h1[1]-1] . "-" . $h1[2];
// generate message
		$template = file_get_contents(dirname(__FILE__) . "/../mail/".$lang.".cron.immediate_ai_overdue.html");
		$template = str_replace('{{qbnummer}}', $qbn, $template);
		$template = str_replace('{{username}}', $vn, $template);
		$template = str_replace('{{termin}}', $due, $template);
		$template = str_replace('{{task}}', $what, $template);
		$template = str_replace('{{qblink}}', $relili . $qbn . "&page=immediate", $template);
		preg_match('/<title>(.*)<\/title>/iU', $template, $subject);
		$subject = "QB".$qbn.": ".$subject[1];					
		$qb_support->templatemail($email, $subject, $template, "", "cron:definitive_ai_overdue");	
// update database
		$query = "UPDATE qb_docimm SET INFO=CURDATE() WHERE IDX=:idx";
		$stmt2 = $db->prepare($query);
		$stmt2->execute(
			array(
				':idx' => $imidx
			)
		);
		$stringData .= "overdue immediate action on QB" . $qbn . " - AI-owner: " . $nn . ", " . $vn . ", due: " . $due . "\r\n";
	}
// write log file
	if (strlen($stringData) > 0) {
		fwrite($fh, $stringData);
		fwrite($fh, "//\r\n");
		$stringData = "";
	}
	fclose($fh);	
?>