<?php
  class SysSession implements SessionHandlerInterface
  {
    private $sdb = '';

    public function __construct() 
    {
      global $db;
      $this->sdb = $db;
    }

    public function open($savePath, $sessionName)
    {
      return true;
    }
    
    public function close()
    {
      $this->gc(get_cfg_var("session.gc_maxlifetime"));
      return true;
    }
    
    public function read($id)
    {
      $stmt = $this->sdb->prepare("SELECT data FROM qb_sessions WHERE id=:id");
      $stmt->execute(
        array(
          ':id' => $id
        )
      );
      $row = $stmt->fetch();
      if ($row) {
        return $row['data'];
      } else {
        return '';
      }	
    }
    
    public function write($id, $data)
    {
      $access = time();
      $stmt = $this->sdb->prepare('REPLACE INTO qb_sessions VALUES (:id, :access, :data)');
      $stmt->execute(
        array(
          ':id' => $id,
          ':access' => $access,
          ':data' => $data
        )
      );		
      return true;
    }
    
      public function destroy($id)
      {
        $stmt = $this->sdb->prepare('DELETE FROM qb_sessions WHERE id = :id');
        $stmt->execute(
          array(
            ':id' => $id
          )
        );
        $this->gc(get_cfg_var("session.gc_maxlifetime"));
        return true;
      }
      
      public function gc($maxlifetime)
      {
    // $max lifetime in seconds
        $maxlifetime = 10*60*60;	// 10h
        $old = time() - $maxlifetime;
        $stmt = $this->sdb->prepare('DELETE FROM qb_sessions WHERE access < :old');
        $stmt->execute(
          array(
            ':old' => $old
          )
        );
        return true;
      } 
  }
  $handler = new SysSession();
  session_set_save_handler($handler, true);
?>