(function($) {
	$.widget("ui.checkList", {	
		options: {
			col2: '',					// width of 2nd column
			listItems : [],
			selectedItems: [],
			effect: 'blink',
			filtertxt: 'filter',		// descrition text for filter box
			tfilter: false,				// show filter box
			colopts: 1,					// amount of data columns
			radio: false,				// behave like radio boxes
			tdback: '#FFFFFF',			// backgroundcolor normal
			tdhigh: '#CCCCCC',			// backgroundcolor highlight
			headertxt: '',				// Text as headline
			onChange: {},
			objTable: '',
			icount: 0,
			r_cb: true,					// should checkboxes / radioboxes been added?
			prefix: "",
			altrows: false,				// alternate colors for rows?
			evenrow: "#B3B3B3",			// background for even rows
			oddrow: "#E6E6E6",			// background for even rows
			cbbgr: "transparent",		// background for checkboxes - default is transparent
			locked: false				// is functionality disabled?
		},
		_create: function() {
			var self = this, o = self.options, el = self.element;

		// generate outer div
			var container = $('<div/>').addClass('checkList');
		// generate list table object
			o.objTable = $('<table/>').addClass('table');
			
		// generate toolbar with search field if enabled and add to list
			if (o.tfilter) {
				var toolbar = $('<div/>').addClass('toolbar');
				var txtfilter = $('<input/>').attr('type','text').addClass('txtFilter').keyup(function(){
					self._filter($(this).val());
				});
				toolbar.append($('<div/>').addClass('filterbox').text(o.filtertxt).append(txtfilter));
				container.append(toolbar);				
			}

			container.append(o.objTable);
			el.append(container);
		// generate list
			self.loadList();
		},

		_addItem: function(listItem){
			var self = this, o = self.options, el = self.element;

			var itemId = o.prefix+'itm' + (o.icount++);	// generate item id
			var itm = $('<tr/>');
			
			var chk = $('<span />').attr('id',itemId).css("margin-right", "5px").css("background-color", o.cbbgr)
				.addClass('icn_checkboxempty_c_n clckbtn chk')
				.attr('data-text',listItem.text)
				.attr('data-value',listItem.value)
				.attr('data-help',listItem.help)
				.attr('data-checked',false);

			if (!o.r_cb) chk.css("visibility", "hidden");
			itm.append($('<td/>').append(chk));

			var label = $('<label/>').attr('for',itemId).text(listItem.text);
			itm.append($('<td/>').append(label));
			if (o.colopts == 2) {
				var label = $('<label/>').attr('for',itemId).text(listItem.text2);
				if (typeof(col2) == undefined) {
					itm.append($('<td style="border-left: 1px solid black; padding-left: 5px;" />').append(label));					
				} else {
					itm.append($('<td style="border-left: 1px solid black; padding-left: 5px;" class="col2" />').append(label));	
				}
			}
			o.objTable.append(itm);

			// bind selection-change
			el.delegate('#'+itemId,'click', function(){self._selChange('#'+itemId)});
		},

		loadList: function(){
			var self = this, o = self.options, el = self.element;

			o.objTable.empty();
			$.each(o.listItems,function(){
				self._addItem(this);
			});
		},

		_selChange: function(loc){	
			var self = this, o = self.options, el = self.element;
		// if locked do not change
			if (o.locked) return false;
		// option the change behaviour to radio		
			if (o.radio) {
				if ($(loc).data("checked") == true) return false;
				sts = o.objTable.find(loc).data('checked');
				o.objTable.find('.chk').data('checked', false).removeClass("icn_checkboxchecked_c_n").addClass("icn_checkboxempty_c_n");
				o.objTable.find(loc).data('checked', !sts);			
				if (sts) {
					o.objTable.find(loc).removeClass("icn_checkboxchecked_c_n").addClass("icn_checkboxempty_c_n");
				} else {
					o.objTable.find(loc).removeClass("icn_checkboxempty_c_n").addClass("icn_checkboxchecked_c_n");
				}				
			} else {				
				if (loc !== undefined) {
					sts = $(loc).data('checked');
					if (sts) {			// old value was "set" -> reset
						$(loc).data('checked', false).removeClass("icn_checkboxchecked_c_n").addClass("icn_checkboxempty_c_n");
					} else {
						$(loc).data('checked', true).removeClass("icn_checkboxempty_c_n").addClass("icn_checkboxchecked_c_n");
					}
				}		
			}
			// empty selection
			o.selectedItems = [];			
			// scan elements, find checked ones
			o.objTable.find('.chk').each(function(){			
				if($(this).data('checked'))
				{			
					o.selectedItems.push({
						text: $(this).attr('data-text'),
						value: $(this).attr('data-value')
					});
					$(this).parent().css('background-color', o.tdhigh).siblings().css('background-color', o.tdhigh);
				} else	{
					// settings for alternate rows
					if (o.altrows) {					
						if (($(this).attr("id").split("itm")[1] % 2) == 0) {
							$(this).parent().css('background-color', o.evenrow).siblings().css('background-color', o.evenrow);
						} else {
							$(this).parent().css('background-color', o.oddrow).siblings().css('background-color', o.oddrow);
						}
					} else {				
						$(this).parent().css('background-color', o.tdback).siblings().css('background-color', o.tdback);
					}
				}
			});
			// fire onChange event
			o.onChange.call(undefined, loc);
		},

		_filter: function(filter){
			var self = this, o = self.options, el = self.element;

			o.objTable.find('.chk').each(function(){	
				if($(this).attr('data-text').toLowerCase().indexOf(filter.toLowerCase())>-1)
				{
					$(this).parent().parent().show((o.effect=='none'?null:o.effect));
				}
				else{
					$(this).parent().parent().hide((o.effect=='none'?null:o.effect));
				}
			});
		},

		getSelection: function(){
			var self = this, o = self.options, el = self.element;
			return o.selectedItems;
		},
// return all option
		getOptions: function(){
			var self = this, o = self.options;
			return o;
		},
// return specific option
		getOption: function(loc){
			var self = this, o = self.options;
			return o[loc];
		},
// set specific option (loc = option:value)	
		setOption: function(loc){
			var self = this, o = self.options, el = self.element;
			loc = loc.split(":");
			var optn = loc[0];
			var newval = loc[1];
		// work around for true & false
			if (newval == "true") newval = true;
			if (newval == "false") newval = false;
			self.options[optn] = newval;
			return o[optn];
		},
		
// sets single selection indentified by data-value	$('#checklist').checkList("setSelection", data-value)
		setSelection: function(loc){
			var self = this, o = self.options, el = self.element;
			if (loc == '' ) return;
			$tdimg = $(el).find("span[data-value='"+loc+"']");
			$tdimg.data("checked", true).removeClass("icn_checkboxempty_c_n").addClass("icn_checkboxchecked_c_n");
			$($tdimg).parent().css('background-color', o.tdhigh).siblings().css('background-color', o.tdhigh);	
			return;
		},		
// resets single selection indentified by data-value	$('#checklist').checkList("resetSelection", data-value)
		resetSelection: function(loc){
			var self = this, o = self.options, el = self.element;
			if (loc == '' ) return;
			$tdimg = $(el).find("span[data-value='"+loc+"']");
			$tdimg.data("checked", false).removeClass("icn_checkboxchecked_c_n").addClass("icn_checkboxempty_c_n");
			// settings for alternate rows
			if (o.altrows) {
				if (($($tdimg).attr("id").split("itm")[1] % 2) == 0) {
					$($tdimg).parent().css('background-color', o.evenrow).siblings().css('background-color', o.evenrow);
				} else {
					$($tdimg).parent().css('background-color', o.oddrow).siblings().css('background-color', o.oddrow);
				}
			} else {				
				$($tdimg).parent().css('background-color', o.tdback).siblings().css('background-color', o.tdback);
			}			
			return;
		},
// resets all checkboxes to unset 		$('#checklist').checkList("resetAll")
		resetAll: function(){
			var self = this, o = self.options, el = self.element;
			$(el).find("span").each(function() {
				$(this).data('checked', false).removeClass("icn_checkboxchecked_c_n").addClass("icn_checkboxempty_c_n")
				if (o.altrows) {
					if (($(this).attr("id").split("itm")[1] % 2) == 0) {
						$(this).parent().css('background-color', o.evenrow).siblings().css('background-color', o.evenrow);
					} else {
						$(this).parent().css('background-color', o.oddrow).siblings().css('background-color', o.oddrow);
					}
				} else {				
					$(this).parent().css('background-color', o.tdback).siblings().css('background-color', o.tdback);
				}					
			});		
			return;
		},
		setData: function(dataModel){
			var self = this, o = self.options, el = self.element;
			o.listItems = dataModel;
			self.loadList();
			self._selChange();
		}
	});
})(jQuery); 