<!DOCTYPE html>
<html>
<head>
	<meta http-equiv="X-UA-Compatible" content="IE=Edge" />
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
	<?php
		include_once(dirname(__FILE__)."/tools/all_header.php"); 
		global $c_scheme, $timezone, $rel_path;
		if (!$qb_support->checkflag("YW")) header("Location: basic.php");
	?>
	
    <title>LOGFILES</title>
	
	<link rel="stylesheet" href="./css/qb.php" />
	<link rel="stylesheet" href="./jqGrid_5.2.1/css/ui.jqgrid.css" />
	
	<style>
		.ui-jqgrid tr.jqgrow td{
			white-space:nowrap;
			height: 18px !important;
		}
		#pager_left{
			padding-top: 5px;
		}			
	</style>
	
	<script src="./jquery/jquery.min.js"></script>
	<script src="./jquery/jquery-migrate-1.2.1.min.js"></script>	
	<script src="./jquery/jquery-ui.min.js"></script>
	<script src="./jquery/qb_js.js"></script>	
	
	<?php 
		foreach(explode(":", $qb_support->getLanOnly()) as $key=>$value) {
			echo '<script src="./jqGrid_5.2.1/js/i18n/grid.locale-' . $value . '.js"></script>';
		}
	?>
	<script src="./jqGrid_5.2.1/js/jquery.jqGrid.min.js"></script>

	<script>
	// load translation and save in localTranslation
		<?php	
			$ini_logs = parse_ini_file($rel_path.'i18n/logfiles.ini', true);	
			echo "localTranslation = {};";
			foreach($ini_logs as $key=>$value){
				$add = "";
				foreach($value AS $lan=>$trans){
					$add .= "'".$lan."':'".$trans."',";
				}
				echo "localTranslation['".$key."']={".rtrim($add, ',')."};";
			}
			$ini_logtype = parse_ini_file($rel_path.'xml/logs.ini', true);
			$ddr = ":".$ini_logs['all'][$_SESSION['lng']];			
			echo "logtypeTranslation = {};";
			foreach($ini_logtype as $key=>$value){
				$add = "";
				foreach($value AS $lan=>$trans){
					$add .= "'".$lan."':'".$trans."',";
				}
				echo "logtypeTranslation['".$key."']={".rtrim($add, ',')."};";
				$ddr .= ";".$key.":".$value[$_SESSION['lng']];		
			}
			echo "var ddr = '".$ddr."';";			
		?>
	</script>
</head>
<body>
	<div id="container">
		<?php 
			include_once($rel_path.'tools/header.php');
		?> 
		<div id="contents">
			<?php 
				echo "<div id='mainnav'>". $qb_support->get_main_menu(4) . "</div>";
			?>
			<div class="dtop">
				<?php include_once($rel_path.'html/systemmenu.php');	?>		
				<span data-type="text" data-lan="logfiles"><?php echo $ini_logs['logfiles'][$_SESSION['lng']]; ?></span>
			</div>
			<p style="background: <?php echo $c_scheme['M4']; ?>; padding: 2px; text-align: center;">
				<label class="dlabel vam w75" style="font-weight: bold;" data-type="text" data-lan="qbn" ><?php echo $ini_logs['qbn'][$_SESSION['lng']]; ?></label>
				<select id="logfiles" style="text-align: left;" onchange="update_grid()">
					<option selected value="">...</option>
					<?php 
						$path = $relpath.'log';
						$files = scandir($path);
						$files = array_diff(scandir($path), array('.', '..'));
						foreach($files as $file) {
							$name = explode(".", $file);
							echo "<option value='".$file."'>".$name[0]."</option>";
							}								
						?>
				</select>
			</p>				
				<table id="list"></table> 
				<div id="pager"></div> 
		</div>
		<?php include_once($rel_path.'footer.php'); ?> 				
	</div>	
	<script>
		$('#logfiles').width(100).customSelect({customClass: "cSelect_wht"});

		function StatusFormatter (cellvalue, options, rowObject)
		{
			var ctext = logtypeTranslation[cellvalue][$globlan];
			return ctext;
		}		
	// switch language
		function c_lan() {
			translate_header($globlan);	
			translate_mainmenu($globlan);
			translate_system($globlan);
			$.each($('#container *').filter(function(){return $(this).data('lan') !== undefined;}), function() {	
				switch ($(this).data("type")) {
					case "text":		
						$(this).text(localTranslation[$(this).data("lan")][$globlan]);
						break;
					case "title":				
						$(this).attr("title", localTranslation[$(this).data("lan")][$globlan]);
						break;					
				}
			});	
			$.jgrid.setRegional('list',{regional: $globlan});
			$("#list").jqGrid('setLabel', "dat", localTranslation["dat"][$globlan])
				.jqGrid('setLabel', "tpe", localTranslation["tpe"][$globlan])
				.jqGrid('setLabel', "who", localTranslation["who"][$globlan])
				.jqGrid('setLabel', "wht", localTranslation["wht"][$globlan])
				.jqGrid('setLabel', "form", localTranslation["form"][$globlan])
				.jqGrid('setLabel', "neu", localTranslation["neu"][$globlan])
				.jqGrid('setLabel', "old", localTranslation["old"][$globlan]);				
			$("#list").trigger("reloadGrid");			
		}
	
		function update_grid() {
			$("#list").setGridParam({
				datatype: "json", 
				postData: {
					routine: "list",
					qbn: $("#logfiles").val()
				} 
			}).trigger("reloadGrid");
		}
		function load_page() {
			$("#loading").show();		
			cmTemplate = {
				sorttype:'string',
				editable: false,
				searchoptions: {
					sopt:['cn'], 
					clearSearch: false
				}
			};			
			obj = {
				url:  "./tools/logfiles_api.php",
				postData: {
					routine: "list",
					qbn: $("#logfiles").val()
				},
				contentType: "application/json",
				datatype: "json",
				jsonReader: {
					id: "id",
					repeatitems: true
				},
				mtype: "POST",
				colNames: [
					localTranslation["dat"][$globlan],
					localTranslation["tpe"][$globlan],
					localTranslation["form"][$globlan], 
					localTranslation["who"][$globlan], 
					localTranslation["wht"][$globlan],
					localTranslation["neu"][$globlan],
					localTranslation["old"][$globlan]
				],
				colModel: [
					{ 
						name: "dat", 
						width: 120, 
						search: true,
						datefmt: 'yy-mm-dd',
						searchrules: {
							date: true
						},
						searchoptions: {
							sopt: ['ge', 'le'],
							clearSearch: false,
							dataInit: function (elem) {
								$(elem).datepicker({
									dateFormat: 'yy-mm-dd',
									changeYear: true,
									changeMonth: true,
									showButtonPanel: true,
									onSelect: function () {
										$(this).keydown();
									}
								});
							}
						}
					},
					{ 
						name: "tpe", 
						width: 80,
						template: cmTemplate,
						stype: 'select',
						searchoptions:
						{
							value: ddr,
							clearSearch: false,
							searchOperators: false
						},	
						formatter: StatusFormatter
					},
					{
						name: "form", 
						width: 70,
						template: cmTemplate
					},					
					{
						name: "who", 
						width: 70,
						template: cmTemplate
					},
					{ 
						name: "wht", 
						width: 290,
						template: cmTemplate
					},
					{
						name: "neu", 
						width: 170,
						template: cmTemplate
					},
					{
						name: "old", 
						width: 170,
						template: cmTemplate
					}				
				],
				regional: $globlan,
				storeNavOptions: true,			
				loadonce: true,
				pager: "#pager",
				recordpos: "left",
				height: 490,
				rowNum: 500,
				rowList: [10, 100, 500, 1000, 1500],
				hoverrows: false,
				rownumbers: false,
				sortname: "dat",
				sortorder: "desc",
				viewrecords: true,
				gridview: true,
				autoencode: true,
				ignoreCase:true,
				loadui: "block",		
				loadComplete: function() {
					$("th[role='columnheader']")
						.unbind("mouseenter")
						.unbind("mouseleave");
					$(".ui-search-toolbar input[role='textbox']")
						.css("width", "92%")
						.css("background", "<?php echo $c_scheme['M5']; ?>")
						.css("padding", "2px");	
					$(".ui-search-toolbar select[role='select']")
						.removeClass("ui-corner-all")
						.css("background", "<?php echo $c_scheme['M5']; ?>")
						.css("padding", "2px");						
				}			
			};
			list1 = $("#list").jqGrid(obj)
				.jqGrid('filterToolbar',{searchOperators : false, searchOnEnter: false})
				.jqGrid('navGrid', '#pager', {refresh: false, search: false, edit: false, del: false, add: false});
			$("#loading").hide();	
		}
		load_page();
	</script>
</body>
</html>