<!DOCTYPE html>
<html>
<head>
	<meta http-equiv="X-UA-Compatible" content="IE=Edge" />
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />	
	<?php 
		include_once(dirname(__FILE__)."/tools/all_header.php"); 
		global $c_scheme, $timezone, $rel_path;
		if (!$qb_support->checkflag("YW")) header("Location: basic.php");
	?>	
	<script>
		var js_debug = false;
		$data_changed = false;
	</script>
	
    <title>Materials</title>
	
	<link rel="stylesheet" href="./css/qb.php" />
	<link rel="stylesheet" href="./jqGrid_5.2.1/css/ui.jqgrid.css" />
	
	<style>
		.highlightrow {
			background: <?php echo $c_scheme['M2']; ?> url(./img/del.png) center repeat-x;
			display: inline-block;
			width: 100%;
		}
		.ui-jqgrid tr.jqgrow td{
			white-space:nowrap;
			height: 18px !important;
		}
		.ui-state-hover, .ui-widget-content .ui-state-hover, .ui-widget-header .ui-state-hover,
		.ui-state-focus, .ui-widget-content .ui-state-focus, .ui-widget-header .ui-state-focus
		{
			border: 0 none;
		}
	</style>
	
	<script src="./jquery/jquery.min.js"></script>
	<script src="./jquery/jquery-migrate-1.2.1.min.js"></script>	
	<script src="./jquery/jquery-ui.min.js"></script>
	<script src="./jquery/qb_js.js"></script>
	
	<?php 
		foreach(explode(":", $qb_support->getLanOnly()) as $key=>$value) {
			echo '<script src="./jqGrid_5.2.1/js/i18n/grid.locale-' . $value . '.js"></script>';
		}
	?>
	<script src="./jqGrid_5.2.1/js/jquery.jqGrid.min.js"></script>		

	<script>
	// load translation and save in localTranslation
		<?php	
			$ini_material = parse_ini_file($rel_path.'i18n/material.ini', true);	
			echo "localTranslation = {};";
			foreach($ini_material as $key=>$value){
				$add = "";
				foreach($value AS $lan=>$trans){
					$add .= "'".$lan."':'".$trans."',";
				}
				echo "localTranslation['".$key."']={".rtrim($add, ',')."};";
			}
			$ini_sortimente = parse_ini_file($rel_path.'xml/sortimente.ini', true);	
			echo "sortiTranslation = {};";
			foreach($ini_sortimente as $key=>$value){
				$add = "";
				foreach($value AS $lan=>$trans){
					$add .= "'".$lan."':'".$trans."',";
				}
				echo "sortiTranslation['".$key."']={".rtrim($add, ',')."};";
			}
			$ini_mstatus = parse_ini_file($rel_path.'xml/m_status.ini', true);	
			echo "mstatTranslation = {};";
			foreach($ini_mstatus as $key=>$value){
				$add = "";
				foreach($value AS $lan=>$trans){
					$add .= "'".$lan."':'".$trans."',";
				}
				echo "mstatTranslation['".$key."']={".rtrim($add, ',')."};";
			}				
		?>
	</script>
</head>
<body>
	<div id="container">
		<?php 
			include_once($rel_path.'tools/header.php');
		?> 
		<div id="contents">
			<?php 
				echo "<div id='mainnav'>". $qb_support->get_main_menu(4) . "</div>";
			?>
			<div class="dtop">
				<?php include_once($rel_path.'html/systemmenu.php');	?>		
				<span data-type="text" data-lan="na_mat"><?php echo $ini_material['na_mat'][$_SESSION['lng']]; ?></span>
			</div>
			<div class="tabs_container">
				<div style="margin-left: 5px;" >
					<table id="list"></table> 
					<div id="pager"></div> 
				</div>
			</div>
		</div>
		<?php include_once($rel_path.'footer.php'); ?> 
	</div>
	<script>
		function load_page() {
			loaddata();
		}
		function c_lan() {
			translate_header($globlan);	
			translate_mainmenu($globlan);
			translate_system($globlan);
			$.each($('#container *').filter(function(){return $(this).data('lan') !== undefined;}), function() {			
				switch ($(this).data("type")) {
					case "text":		
						$(this).text(localTranslation[$(this).data("lan")][$globlan]);
						break;
					case "title":				
						$(this).attr("title", localTranslation[$(this).data("lan")][$globlan]);
						break;
					case "date":
						$(this).val(localizedate($($(this).data("lan")).val()));
						break;						
				}
			});	
			$.jgrid.setRegional('list',{regional: $globlan});
			$("#list").jqGrid('setLabel', "tgr", localTranslation["imat"][$globlan])
				.jqGrid('setLabel', "tgr_nde", localTranslation["tgr_n_de"][$globlan])
				.jqGrid('setLabel', "tgr_nen", localTranslation["tgr_n_en"][$globlan])
				.jqGrid('setLabel', "resp", localTranslation["resp"][$globlan])
				.jqGrid('setLabel', "wgr", localTranslation["wgr"][$globlan])
				.jqGrid('setLabel', "sortiment", localTranslation["sortiment"][$globlan]);
			$("#add_list").attr("title", localTranslation["add_row"][$globlan]);	
			$("#edit_list").attr("title", localTranslation["edit_row"][$globlan]);
			$("#del_list").attr("title", localTranslation["del_row"][$globlan]);				
		}	
		function delFormatter (cellvalue, options, rowObject)
		{
			if (rowObject['active'] == "0") {
				return "<span class='highlightrow'>"+cellvalue+"</span>";
			} else {
				return cellvalue;
			}
		}
		function undelFormatter (cellvalue, options, rowObject)
		{
			return cellvalue;
		}
		function custbtns() {
			$("#add_list div").empty().html("<span class='icn_add_b_n clckbtn'></span>");
			$("#add_list").removeClass("ui-pg-button");
			$("#edit_list div").empty().html("<span class='icn_edit_b_n clckbtn' style='margin: 0 10px;'></span>");
			$("#edit_list").removeClass("ui-pg-button");
			$("#del_list div").empty().html("<span class='icn_delete_b_n clckbtn'></span>");
			$("#del_list").removeClass("ui-pg-button");
			$("#pager_left .ui-separator").remove();		
		}
		function loaddata() {
			cmTemplate = {
				editable: true,
				edittype:'text', 
				editrules:
				{
					required:true,
				},
				editoptions:
				{
					size:"30"
				}, 			
				sorttype:'string',		
				searchoptions: {
					sopt:['cn'], 
					clearSearch: false
				}
			};	
			obj = {
				url:  "./tools/material_api.php",
				postData: {routine : "readmaterial"},
				contentType: "application/json",
				datatype: "json",
				jsonReader: {
					id: "id",
					repeatitems: false
				},
				mtype: "POST",
				colNames: [
					localTranslation["imat"][$globlan],
					localTranslation["tgr_n_de"][$globlan],
					localTranslation["tgr_n_en"][$globlan],
					localTranslation["mstat"][$globlan],
					localTranslation["wgr"][$globlan],
					""
				],
		// create column definitions
				colModel: [
					{ 
						name: "tgr", 
						width: 100, 
						template: cmTemplate,
						formatter: delFormatter,
						unformat: undelFormatter					
					},
					{ 
						name: "tgr_n1", 
						width: 320 , 
						template: cmTemplate, 
						formatter: delFormatter,
						unformat: undelFormatter
					},
					{
						name: "tgr_n2", 
						width: 320,
						template: cmTemplate,
						formatter: delFormatter,
						unformat: undelFormatter
					},
					{	
						name: "mstat",
						width: 100,	
						align: "center",						
						edittype:'select', 
						editoptions:
						{
							size: "1",
							value:
							{
							},							
							dataInit: function(elem)
							{
								$.each(mstatTranslation, function(idx, optn) {							
									$(elem).append(
										$('<option></option>').val(idx).html(optn[$globlan])
									);								
								});
								$(elem).val($("#list").jqGrid ('getCell', $("#list").jqGrid ('getGridParam', 'selrow'), 'mstat'));
								$(elem).width(230);								
							}
						},
						formatter: delFormatter,
						unformat: undelFormatter,
						template: cmTemplate
					},
					{ 
						name: "wgr",
						width: 100,
						align: "center",
						edittype:'text', 
						editoptions: 
						{
							size:"20"
						}, 
						formatter: delFormatter,
						unformat: undelFormatter,
						template: cmTemplate
					},
					{ 
						name: "active", 
						hidden: true, 
						editable: false
					}
				],
				regional: $globlan,
				storeNavOptions: true,			
				loadonce: false,
				pager: "#pager",
				height: 510,
				rowNum: 50,
				rowList: [10, 100, 500, 1000, 1500],
				hoverrows: false,
				rownumbers: true,
				sortname: "tgr",
				sortorder: "asc",
				viewrecords: true,
				gridview: true,
				autoencode: true,
				ignoreCase:true,
				loadui: "block",
				ondblClickRow: function(id, ri, ci) {
					$("#list").jqGrid('editGridRow', id, editSettings);
				},
				loadComplete: function() {
					$("th[role='columnheader']")
						.unbind("mouseenter")
						.unbind("mouseleave");		
				},
				gridComplete: function(data) {
					$(".ui-search-toolbar input[role='textbox']")
						.css("width", "92%")
						.css("background", "<?php echo $c_scheme['M5']; ?>")
						.css("padding", "2px");	
					custbtns();
				},			
				editurl: "./tools/material_api.php"		
			};
			editSettings = {
				recreateForm:true,
				jqModal:true,
				modal: true,
				reloadAfterSubmit:false,
				closeOnEscape:false,
				savekey: [false,13],
				closeAfterEdit:true,
				zIndex:1000,
				width: 400,
				viewPagerButtons:false,
				beforeShowForm: function(form) {
			// center edit form
					var parentWidth = $(window).width();
					var parentHeight = $(window).height();
					var dlgDiv = $("#editmodlist");
					var dlgWidth = dlgDiv.width();
					var dlgHeight = dlgDiv.height();
					dlgDiv[0].style.top = Math.round((parentHeight-dlgHeight)/2) + "px";
					dlgDiv[0].style.left = Math.round((parentWidth-dlgWidth)/2) + "px";
					$('#tgr').attr('readonly','readonly').addClass("logininput");
					$(".EditButton")
						.empty()
						.append("<span id='sData' class='spanbutton w100'>"+localTranslation["save"][$globlan]+"</span>")
						.append("<span id='cData' style='margin: 0 10px;' class='spanbutton w100'>"+localTranslation["cancel"][$globlan]+"</span>");				
				},
				ajaxEditOptions:{ contentType:"application/json" },
				mtype:'POST',
				serializeEditData:function (data) {
					data["routine"] = "editmaterial";
					return JSON.stringify(data);
				}			
			};	
			addSettings = {
				recreateForm:true,
				jqModal:true,
				modal: true,
				reloadAfterSubmit:false,
				closeOnEscape:false,
				savekey: [false,13],
				closeAfterAdd:true,
				zIndex:1000,
				width: 400,
				viewPagerButtons:true,
				beforeShowForm: function(form) {
			// center edit form
					var parentWidth = $(window).width();
					var parentHeight = $(window).height();
					var dlgDiv = $("#editmodlist");
					var dlgWidth = dlgDiv.width();
					var dlgHeight = dlgDiv.height();
					dlgDiv[0].style.top = Math.round((parentHeight-dlgHeight)/2) + "px";
					dlgDiv[0].style.left = Math.round((parentWidth-dlgWidth)/2) + "px";
					$('#tgr').removeAttr('readonly').removeClass("logininput");
					$(".EditButton")
						.empty()
						.append("<span id='sData' class='spanbutton w100'>"+localTranslation["save"][$globlan]+"</span>")
						.append("<span id='cData' style='margin: 0 10px;' class='spanbutton w100'>"+localTranslation["cancel"][$globlan]+"</span>");				
				},
				ajaxEditOptions:{ contentType:"application/json" },
				mtype:'POST',
				postData: {routine : "addmaterial"},
				serializeEditData:function (data) {
					data["routine"] = "addmaterial";
					return JSON.stringify(data);
				},
				onClose: function(sel, o) {
					$("#list").setGridParam({datatype:'json'}).trigger('reloadGrid');
				},
				errorTextFormat: function (e) {
					if (e['status'] == 409) {
						return '<span class="ui-icon ui-icon-alert" style="float: left; margin-right: .3em;"></span>'+localTranslation["tgr_is_av"][$globlan];
					} else if (e['status'] == 405) {
						return '<span class="ui-icon ui-icon-alert" style="float: left; margin-right: .3em;"></span>'+localTranslation["tgr_is_del"][$globlan];	
					}
				}
			};
			deleteSettings = {
				recreateForm:true,
				jqModal:true,
				modal: true,
				reloadAfterSubmit:true,
				closeOnEscape:false,
				savekey: [false,13],
				closeAfterEdit:true,
				zIndex:1000,
				width: 300,
				viewPagerButtons:false,
				caption: localTranslation["rem"][$globlan],
				beforeShowForm: function(form) {
			// center edit form
					var parentWidth = $(window).width();
					var parentHeight = $(window).height();
					var dlgDiv = $("#delmodlist")||$("#alertmod_list");
					$(dlgDiv).css("width", "400px");
					var dlgWidth = dlgDiv.width();
					var dlgHeight = dlgDiv.height();
					dlgDiv[0].style.top = Math.round((parentHeight-dlgHeight)/2) + "px";
					dlgDiv[0].style.left = Math.round((parentWidth-dlgWidth)/2) + "px";
					$deluser = $("#list").jqGrid('getRowData',$("#list").jqGrid('getGridParam','selrow'));
					$("td.delmsg",form).html(localTranslation["confirm_del_mat"][$globlan]+"<br /><center><span style='color: <?php echo $c_scheme['IW']; ?>; font-weight: bold;'>"+
						$deluser['tgr']+"</span></center>");
					$(".EditButton a").css("display", "none");
					$(".EditButton")
						.append("<span id='dData1' class='spanbutton w100' onclick='$(\"#dData\").click();'>"+localTranslation["rem"][$globlan]+"</span>")
						.append("<span id='eData1' style='margin: 0 10px;' class='spanbutton w100' onclick='$(\"#eData\").click();'>"+localTranslation["cancel"][$globlan]+"</span>");					
				},
				mtype:'POST',
				serializeDelData:function (data) {
					$deluser = $("#list").jqGrid('getRowData',$("#list").jqGrid('getGridParam','selrow'));
					data["tgr"] = $deluser['tgr'];
					data["routine"] = "deletematerial";
					return JSON.stringify(data);
				}
			};		
			list1 = $("#list").jqGrid(obj)
				.jqGrid('filterToolbar',{searchOperators : false, searchOnEnter: false})	
				.navGrid('#pager', {refresh: false, search: false}, editSettings, addSettings, deleteSettings);
		}
		load_page();
	</script>
</body>
</html>
