<!DOCTYPE html>
<html>
<head>
	<meta http-equiv="X-UA-Compatible" content="IE=Edge" />
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />		
	<?php 
		include_once(dirname(__FILE__)."/tools/all_header.php"); 
		global $c_scheme, $timezone, $rel_path;
		if (!$qb_support->checkflag("YW")) header("Location: basic.php");
	?>	
	<script>
		var js_debug = false;
		$data_changed = false;		
	</script>
	
    <title>5WHY Rating</title>
	
	<link rel="stylesheet" href="./css/qb.php" />
	<link rel="stylesheet" href="./jqplot/jquery.jqplot.css" />	
	
	<script src="./jquery/jquery.min.js"></script>
	<script src="./jquery/jquery-migrate-1.2.1.min.js"></script>	
	<script src="./jquery/jquery-ui.min.js"></script>
	<script src="./jquery/qb_js.js"></script>
	
	<script src="./jqplot/jquery.jqplot.min.js"></script>
	<script src="./jqplot/plugins/jqplot.barRenderer.min.js"></script>
	<script src="./jqplot/plugins/jqplot.pieRenderer.min.js"></script>
	<script src="./jqplot/plugins/jqplot.categoryAxisRenderer.min.js"></script>
	<script src="./jqplot/plugins/jqplot.boxplotRenderer.js"></script>
	<script src="./jqplot/plugins/jqplot.pointLabels.min.js"></script>
  <script src="./jqplot/plugins/jqplot.canvasTextRenderer.min.js"></script>
  <script src="./jqplot/plugins/jqplot.canvasAxisLabelRenderer.min.js"></script>
	<script src="./jqplot/plugins/jqplot.enhancedLegendRenderer.min.js"></script>
  <script src="./jqplot/plugins/jqplot.canvasAxisTickRenderer.min.js"></script>
	<script src="./jqplot/plugins/jqplot.canvasOverlay.min.js"></script>	

	<?php
		$query = "
			SELECT 
				DATE_FORMAT(NOW(), '%Y-%m-%d'), 
				DATEDIFF(MAX(QBREGDATE), NOW()), 
				DATEDIFF(MIN(QBREGDATE), NOW()),
				MIN(QBREGDATE),
				MAX(QBREGDATE),
				IF (DATEDIFF(MAX(QBREGDATE), MIN(QBREGDATE)) > 365, DATE_SUB(MAX(QBREGDATE), INTERVAL 365 DAY), MIN(QBREGDATE))
			FROM 
				qbi 
			WHERE 
				QBSTATUS NOT IN ('M', 'D')
		";
		$stmt = $db->query($query);
		list($now, $diffmax, $diffmin, $min, $max, $lmin) = $stmt->fetch(PDO::FETCH_NUM );
	?>
	<script>
	// load translation and save in localTranslation
		<?php	
			$ini_rating = parse_ini_file($rel_path.'i18n/rating.ini', true);	
			echo "localTranslation = {};";
			foreach($ini_rating as $key=>$value){
				$add = "";
				foreach($value AS $lan=>$trans){
					$add .= "'".$lan."':'".$trans."',";
				}
				echo "localTranslation['".$key."']={".rtrim($add, ',')."};";
			}
			$ini_class = parse_ini_file($rel_path.'xml/class.ini', true);
			$ini_class['all']=$ini_rating['all'];
			echo "classTranslation = {};";
			foreach($ini_class as $key=>$value){
				$add = "";
				foreach($value AS $lan=>$trans){
					$add .= "'".$lan."':'".$trans."',";
				}
				echo "classTranslation['".$key."']={".rtrim($add, ',')."};";
			}			
			$cal = parse_ini_file($rel_path.'i18n/calendar.ini', true);
			echo "calTranslation = {};";
			foreach($cal as $key=>$value){
				$add = "";
				if ($value['tpe'] == "S") {
					foreach($value AS $lan=>$trans){
						if ($lan != "tpe") $add .= "'".$lan."':'".$trans."',";
					}
				} else {
					foreach($value AS $lan=>$trans){
						if ($lan != "tpe") {
							$tar = explode(",", $trans);
							$tar = implode("','", $tar);
							$add .= "'".$lan."': ['".$tar."'],";
						}
					}				
				}
				echo "calTranslation['".$key."']={".rtrim($add, ',')."};";
			}
			$ratings = parse_ini_file($rel_path.'xml/ratings.ini', true);
			$ini_ratings = array();
			foreach($ratings as $lan=>$value){
				$rate = $value['rate'];
				foreach($rate AS $key=>$value1) {
					$det = explode(":", $value1);
					if (!array_key_exists($det[0], $ini_ratings)) $ini_ratings[$det[0]] = array();
					$ini_ratings[$det[0]][$lan] = $det[1];
				}
			}
			echo "ratingsTranslation = {};";
			foreach($ini_ratings as $key=>$value){
				$add = "";
				foreach($value AS $lan=>$trans){
					$add .= "'".$lan."':'".$trans."',";
				}
				echo "ratingsTranslation['".$key."']={".rtrim($add, ',')."};";
			}	
		?>
	</script>
</head>
<body>
	<div id="container">
		<?php 
			include_once($rel_path.'tools/header.php');
		?> 
		<div id="contents">
			<?php 
				echo "<div id='mainnav'>". $qb_support->get_main_menu(4) . "</div>";
			?>
			<div class="dtop">
				<?php include_once($rel_path.'html/systemmenu.php');	?>		
				<span data-type="text" data-lan="rating"><?php echo $ini_rating['rating'][$_SESSION['lng']]; ?></span>
			</div>
			<div id="btn_div" class="btn_div">
				<p>
					<label class="dlabel vam w50" data-type="text" data-lan="start" ><?php echo $ini_rating['start'][$_SESSION['lng']]; ?></label>
					<input type="text" id="sdat" data-type="date" data-lan="#sdat_org" class="dinputw vam w75" value="" onchange="rating()" readonly />
					<input type="hidden" id="sdat_org" value="" />
					<input type="hidden" id="sdat_i" value="" />
				</p>
				<p style="margin: 5px 0;">
					<label class="dlabel vam w50" data-type="text" data-lan="ende" ><?php echo $ini_rating['ende'][$_SESSION['lng']]; ?></label>
					<input type="text" id="edat" data-type="date" data-lan="#edat_org" class="dinputw vam w75" value="" onchange="rating()" readonly />
					<input type="hidden" id="edat_org" value="" />
					<input type="hidden" id="edat_i" value="" />
				</p>
				<p style="margin-top: 15px; padding-bottom: 10px; border-bottom: 2px solid <?php echo $c_scheme['RN']; ?>;">
					<select id="clss" data-type="select" data-lan="clss" onchange="rating()" >
						<?php
							foreach($ini_class as $key=>$value){
								echo "<option value='$key'>".$value[$_SESSION['lng']]."</option>";
							}
						?>
					</select>
				</p>
				<p style="border: 2px solid <?php echo $c_scheme['R1']; ?>; background-color: <?php echo $c_scheme['M5']; ?>; padding: 5px; margin-top: 10px;">
					<label class="dlabel vam w100" data-type="text" data-lan="avg" ><?php echo $ini_rating['avg'][$_SESSION['lng']]; ?></label>
					<label style="font-weight: bold;" class="dlabel vam w50" id="avg" ></label>
				</p>
			</div>			
	<!-- container for chart -->
			<div id="chartdiv" style="display: inline-block; height:400px; width:805px; margin-top: 5px; margin-left: 5px;"></div>
			<input type="hidden" id="stamp" value="" />
		</div>
		<?php include_once($rel_path.'footer.php'); ?> 		
	</div>
	<script>
		pickerOpts = {
			closeText: "X",		
			dateFormat: "yy-M-dd",
			altField: '#sdat_org',
			altFormat: 'yy-mm-dd',
			firstDay: 1,
			isRTL: false,
			showButtonPanel: true,
			displayClose: true,
			showOn: "button",  
			buttonImage: "./img/dummy_img.png", 
			buttonImageOnly: true,
			buttonText: localTranslation["cal"][$globlan],
			changeYear: true,
			changeMonth: true,
			maxDate: "+<?php echo $diffmax;?>d",
			minDate: "-<?php echo $diffmin;?>d"		
		}
		pickerOpts_2 = {
			closeText: "X",		
			dateFormat: "yy-M-dd",
			altField: '#edat_org',
			altFormat: 'yy-mm-dd',
			firstDay: 1,
			isRTL: false,
			showButtonPanel: true,
			displayClose: true,
			showOn: "button",  
			buttonImage: "./img/dummy_img.png", 
			buttonImageOnly: true,
			buttonText: localTranslation["cal"][$globlan],
			changeYear: true,
			changeMonth: true,
			maxDate: "+<?php echo $diffmax;?>d",
			minDate: "-<?php echo $diffmin;?>d"	
		}		
				
	// fix um bei klicken auf "Heute" den Kalender zu schliessen	
		var old_goToToday = $.datepicker._gotoToday;
		$.datepicker._gotoToday = function(id) {
			old_goToToday.call(this,id);   
			this._selectDate(id);
			$heute = true;
		};
		
		$.datepicker._defaults['currentText'] = calTranslation['currentText'][$globlan];
		$.datepicker._defaults['monthNames'] = calTranslation['monthNames'][$globlan];
		$.datepicker._defaults['monthNamesShort'] = calTranslation['monthNamesShort'][$globlan];
		$.datepicker._defaults['dayNamesMin'] = calTranslation['dayNamesMin'][$globlan];
		
		$("#sdat").datepicker(pickerOpts);
		clkevnt = $("#sdat").next().data('events').click[0].handler;
		$("#sdat").next().replaceWith('<span class="ui-datepicker-trigger icn_calendar_b_n clckbtn vam" data-type="title" data-lan="cal" title="<?php echo $ini_rating['cal'][$_SESSION['lng']]; ?>"> </span>');
		$("#sdat").next().bind('click', clkevnt);		
		$("#edat").datepicker(pickerOpts_2);
		clkevnt = $("#edat").next().data('events').click[0].handler;
		$("#edat").next().replaceWith('<span class="ui-datepicker-trigger icn_calendar_b_n clckbtn vam" data-type="title" data-lan="cal" title="<?php echo $ini_rating['cal'][$_SESSION['lng']]; ?>"> </span>');
		$("#edat").next().bind('click', clkevnt);
		<?php 
			if (isset($_REQUEST['clss'])) { 
				echo "$('#clss').val('".$_REQUEST['clss']."');";
			} else {
				echo "$('#clss').val('T');";
			}
		?>
		$('#clss').width(175).customSelect({customClass: "cSelect_wht"});
		
		$('#chartdiv').bind('jqplotDataClick',
			function (ev, seriesIndex, pointIndex, data) {
				if ($("#chartdiv").attr("data-chart") == "qbqbl") {
					(plot1.options.seriesDefaults.rendererOptions.dataLabels == 'percent')?qbqbl('value'):qbqbl('percent');
				}
			}
		);
		function load_page() {
			$("#sdat").val(localizedate("<?php echo $lmin; ?>"));
			$("#edat").val(localizedate("<?php echo $max; ?>"));
			$("#sdat_org").val("<?php echo $lmin; ?>");
			$("#edat_org").val("<?php echo $max; ?>");
			$("#sdat_i").val("<?php echo $lmin; ?>");			// min start date
			$("#edat_i").val("<?php echo $max; ?>");			// max end date	
			rating();
		}
	// switch language
		function c_lan(loc) {
			translate_header($globlan);	
			translate_mainmenu($globlan);
			translate_system($globlan);
			$.each($('#container *').filter(function(){return $(this).data('lan') !== undefined;}), function() {			
				switch ($(this).data("type")) {
					case "text":		
						$(this).text(localTranslation[$(this).data("lan")][$globlan]);
						break;
					case "title":				
						$(this).attr("title", localTranslation[$(this).data("lan")][$globlan]);
						break;
					case "date":
						$(this).val(localizedate($($(this).data("lan")).val()));
						break;						
				}
			});
		
			$.datepicker._defaults['currentText'] = calTranslation['currentText'][$globlan];
			$.datepicker._defaults['monthNames'] = calTranslation['monthNames'][$globlan];
			$.datepicker._defaults['monthNamesShort'] = calTranslation['monthNamesShort'][$globlan];
			$.datepicker._defaults['dayNamesMin'] = calTranslation['dayNamesMin'][$globlan];
			$nfc = Array();
			$.each(plot1.axes.yaxis.ticks, function(key, value) {
				$nfc.push(ratingsTranslation[key][$globlan]);
			});			
			plot1.replot({
				axes:{
					yaxis:{
						ticks: $nfc
					}
				}						
			});				
		}
		function rating() {
			$("#loading").show();
			$("#chartdiv").empty();
			$.ajax({
				type: "GET",
				cache: false,
				url:  "./tools/rating_a_api.php",
				data: { 
					routine: "getlist",
					sdate: $("#sdat_org").val(),
					edate: $("#edat_org").val(),
					clss: $("#clss").val()
				},
				dataType: 'json',
				success: function(result)
				{
          if (result[0].length == 0) return false;
					qbresult = result;
					optionObj = {
						captureRightClick: true,
						axes:{
							yaxis:{
								renderer: $.jqplot.CategoryAxisRenderer,
								ticks: qbresult[1], 
								tickOptions: {
									fontSize: '8pt',
									fontFamily:'Helvetica'
								}							
							}
						},
						seriesDefaults:{
							renderer:$.jqplot.BarRenderer,
							rendererOptions: {
								varyBarColor: true,
								shadow: false, 
								barWidth: 30,
								barDirection: 'horizontal',
								highlightMouseOver: false
							},
							pointLabels: { 
								show: true, 
								location: 'e', 
								hideZeros: true,
								formatString: '%d'
							}				
						},
						grid: 
						{         
							gridLineWidth: 1.5,  
							gridLineColor: "<?php echo $c_scheme['GG']; ?>",         
							drawGridlines: true,
							shadow: false, 
							borderWidth:1.0,
							background: "<?php echo $c_scheme['GB']; ?>"
						},						
						seriesColors: [ "<?php echo $c_scheme['G1']; ?>", "<?php echo $c_scheme['G2']; ?>"]
					};
					$('#chartdiv').bind('jqplotDataClick',
						function (ev, seriesIndex, pointIndex, data) {                
							window.location.href = "rating_table.php?cc="+(data[1]-1)+"&s="+$("#sdat_org").val()+"&e="+$("#edat_org").val()+"&clss="+$("#clss").val();
							return false;
						}
					);					
					plot1 = $.jqplot('chartdiv', [qbresult[0]], optionObj);
					$avg = 0;
					$dta = 0;
					$.each(qbresult[0], function(k,v) {
						if (k != 0) {
							$avg += (k*v);
							$dta += v;
						}
					});
					$res = (Math.floor(($avg/$dta)*100))/100;
					$("#avg").text($res);
					$("#loading").hide();
				}
			});			
		}
		load_page();
	</script>
</body>
</html>
