<!DOCTYPE html>
<html>
<head>
	<meta http-equiv="X-UA-Compatible" content="IE=Edge" />
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />	
	<?php 
		include_once(dirname(__FILE__)."/tools/all_header.php"); 
		global $c_scheme, $timezone, $rel_path;
		if ($qb_support->checkflag("WY") === false) header("Location: basic.php");
	?>	
	<script>
		var js_debug = false;
		$data_changed = false;	
	</script>
	
    <title>Roles</title>
	
	<link rel="stylesheet" href="./css/qb.php" />
	<style>

		.table-header-rotated td{
			width: 30px;
			border: 1px solid <?php echo $c_scheme['RN']; ?>;
			vertical-align: middle;
			text-align: center;
		}

		.table-header-rotated th.rotate-45{
			height: 200px;
			width: 30px;
			min-width: 30px;
			max-width: 30px;
			position: relative;
			vertical-align: bottom;
			padding: 0;
			font-size: 12px;
			line-height: 0.8;
		}

		.table-header-rotated th.rotate-45 > div{
			height: 200px;
			border: 1px solid <?php echo $c_scheme['RN']; ?>;
			color: <?php echo $c_scheme['XW']; ?>;
		}

		.table-header-rotated th.rotate-45 span {
		  -ms-transform:rotate(270deg);
		  -moz-transform:rotate(270deg);
		  -webkit-transform:rotate(270deg);
		  -o-transform:rotate(270deg);
		  transform:rotate(270deg);
		  position: absolute;
		  bottom: 42px;
		  left: -25px; /*Because it looked good, but there is probably a mathematical link here as well*/
		  display: inline-block;
		  // width: 100%;
		  width: 85px; /* 80 / cos(45) - 40 cos (45) = 85 where 80 is the height of the cell, 40 the width of the cell and 45 the transform angle*/
		  text-align: left;
		  white-space: nowrap; /*whether to display in one line or not*/
		}
		.row-header
		{
			font: bold 10pt Arial;
			color: <?php echo $c_scheme['XH']; ?>;
			text-align: left;
			width: 100px !important;
			border: 1px solid <?php echo $c_scheme['RN']; ?>;
			border-left: 0px;
		}
	</style>
	
	<script src="./jquery/jquery.min.js"></script>
	<script src="./jquery/jquery-migrate-1.2.1.min.js"></script>	
	<script src="./jquery/jquery-ui.min.js"></script>
	<script src="./jquery/qb_js.js"></script>

	<script>
	// load translation and save in localTranslation
		<?php	
			$ini_roles = parse_ini_file($rel_path.'i18n/roles.ini', true);	
			echo "localTranslation = {};";
			foreach($ini_roles as $key=>$value){
				$add = "";
				foreach($value AS $lan=>$trans){
					$add .= "'".$lan."':'".$trans."',";
				}
				echo "localTranslation['".$key."']={".rtrim($add, ',')."};";
			}
			$ini_flags = parse_ini_file($rel_path.'xml/flags.ini', true);
			echo "roleTranslation = {};";
			foreach($ini_flags as $key=>$value){
				if ($value['rights'] == "Y") {
					$add = "";
					foreach($value AS $lan=>$trans){
						if ($lan != "rights") {
							$add .= "'".$lan."':'".$trans."',";
						}
					}
					echo "roleTranslation['".$key."']={".rtrim($add, ',')."};";
				}
			}			
		?>
	</script>
</head>
<body>
	<div id="container">
		<?php 
			include_once($rel_path.'tools/header.php');
		?> 
		<div id="contents">
			<?php 
				echo "<div id='mainnav'>". $qb_support->get_main_menu(4) . "</div>";
			?>
			<div class="dtop">
				<?php include_once($rel_path.'html/systemmenu.php');	?>		
				<span data-type="text" data-lan="roles"><?php echo $ini_roles['roles'][$_SESSION['lng']]; ?></span>
			</div>
			<div class="tabs_container">
				<div style="height: 540px; width: 880px; font-family: Arial; padding: 5px; margin: auto; overflow-y: auto;">
					<table class="table table-striped table-header-rotated" style="margin: auto;" id="roletable">
						<thead>
							<tr>
							<!-- First column header is not rotated -->
								<th></th>
								<th></th>
							<!-- Following headers are rotated -->
								<?php
									$flags = parse_ini_file($rel_path.'xml/flags.ini', true);
									foreach ($flags as $key => $value)
									{
										$start[$key]  = $value['order'];
									}								
									array_multisort($start, SORT_ASC, $flags);									
									foreach ($flags as $key => $value) {
										if ($value['rights'] == "Y") {
											if ($key == "B") continue;
											if ($key == "C") continue;
											if (!$qb_support->checkflag("Y") AND ($key == "Y")) continue;
											echo '<th class="rotate-45"><div><span data-lan="'.$key.'" data-type="tableheader">'.$value[$_SESSION['lng']].'</span></div></th>';
										}
									}
								?>
								<th></th>
							</tr>
						</thead>
						<tbody>
							<?php
								$query = "SELECT IDX, ROLE, FLAGS, MASTER, DFLT FROM qb_roles WHERE MASTER != 3 ORDER BY ORDR ASC";		// master ==3 means "no show"
								$stmt = $db->query($query);
								$i = 0;
								while($r = $stmt->fetch(PDO::FETCH_NUM)) {									
							// alternating background color
									if ($i % 2 != 0) {
										echo "<tr id='r".$r[0]."'>";
									} else {
										echo "<tr id='r".$r[0]."' style='background-color: ".$c_scheme['IE'].";'>";
									}
							// only roles with master == 0 are cusomized roles and can be deleted
									if ($r[3] == 0) {
										echo "<th style='background-color: ".$c_scheme['M5'].";'><span class='icn_delete_b_n clckbtn' data-type='title' data-lan='rem' onclick='del_role(this)' title=''></span></th>";
									} else {
										echo "<th style='background-color: ".$c_scheme['M5'].";'><span style='display:inline-block; width: 16px;'></span></th>";
									}
									echo "<th class='row-header'>".$r[1]."</th>";
							// cycle trough flags
									foreach ($flags as $key => $value) {
										if ($r[3] == 0) {
											if ($value['rights'] == "Y") {
									// customized role -> allow edit on all flags
												if ($key == "B") continue;						// special handling for reports
												if ($key == "C") continue;					// special handling for costs
												if (!$qb_support->checkflag("Y") AND ($key == "Y")) continue;	// admin rights only for admins
												echo "<td>";
												if (in_array($key, str_split($r[2]))) {
													echo "<span id='r".$r[0]."_c".$key."' data-checked='true' style='cursor: pointer;' class='icn_checkboxchecked_c_n clckbtn vam' onclick='change_box(this)'></span>";
												} else {
													echo "<span id='r".$r[0]."_c".$key."' data-checked='false' style='cursor: pointer;' class='icn_checkboxempty_c_n clckbtn vam' onclick='change_box(this)'></span>";
												}
												echo "</td>";
											}
										} else {
											if ($value['rights'] == "Y") {									
									// default role -> allow edit on flags only which are not default
												if ($key == "B") continue;						// special handling for reports
												if ($key == "C") continue;					// special handling for costs
												if (!$qb_support->checkflag("Y") AND ($key == "Y")) continue;	// admin rights only for admins
												echo "<td>";
												if (in_array($key, str_split($r[2]))) {
											// if default value disable box
													if (in_array($key, str_split($r[4]))) {
														echo "<span id='r".$r[0]."_c".$key."' data-checked='true' style='cursor: default;' class='icn_checkboxchecked_r3_n clckbtn vam'></span>";
													} else {
														echo "<span id='r".$r[0]."_c".$key."' data-checked='true' style='cursor: pointer;' class='icn_checkboxchecked_c_n clckbtn vam' onclick='change_box(this)'></span>";
													}
												} else {
													echo "<span id='r".$r[0]."_c".$key."' data-checked='false' style='cursor: pointer;' class='icn_checkboxempty_c_n clckbtn vam' onclick='change_box(this)'></span>";
												}
												echo "</td>";
											}
										}
									}
									echo "<td style='background-color: ".$c_scheme['M5']."; border: 0px;'><span class='icn_loop_b_n clckbtn' data-type='title' data-lan='apply' onclick='apply_role(this)' title='".$ini_roles['apply'][$_SESSION['lng']]."'></span></td>";
									echo "</tr>";
									$i++;
								}
							?>					  
						</tbody>
					</table>
				</div>			
				<center style="border-top: 1px solid black;">
					<label data-type="text" data-lan="newrole" class="dlabel" ><?php echo $ini_roles['newrole'][$_SESSION['lng']]; ?></label>
					<input type="text" class="dinput w150" id="newrole" value="" />	
					<span data-type="text" data-lan="save" class="spanbutton w100" onclick="save();" style="margin-top: 15px; margin-left: 10px;" ><?php echo $ini_roles['save'][$_SESSION['lng']]; ?></span>
				</center>
			</div>
		</div>
		<?php include_once($rel_path.'/footer.php'); ?> 		
	</div>
	<script>
		function apply_role(loc) {
			$delrow = $($(loc).parent().parent()).attr("id").substr(1);
			$.alerts.cancelButton = localTranslation["cancel"][$globlan];
			$.alerts.okButton = localTranslation["apply"][$globlan];
			jConfirm(localTranslation["confirmapply"][$globlan], localTranslation["attention"][$globlan], function(r) {
				if (r) {
					$.ajax({
						type: "POST",
						cache: false,
						url:  "./tools/roles_api.php",
						data: { 
							routine: "applyrole",
							idx: $delrow
						},
						success: function(result)
						{
							$.alerts.okButton = localTranslation["ok"][$globlan];
							jAlert($.trim(result)+localTranslation["success"][$globlan], localTranslation["attention"][$globlan]);
						}
					});
				}
			});				
		}
		function del_role(loc) {
			$delrow = $($(loc).parent().parent()).attr("id").substr(1);
			$.alerts.cancelButton = localTranslation["cancel"][$globlan];
			$.alerts.okButton = localTranslation["rem"][$globlan];
			jConfirm(localTranslation["confirmdelete"][$globlan], localTranslation["attention"][$globlan], function(r) {
				if (r) {
					$.ajax({
						type: "POST",
						cache: false,
						url:  "./tools/roles_api.php",
						data: { 
							routine: "delrole",
							idx: $delrow
						},
						success: function(result)
						{
							if ($.trim(result) == "NOK") {
								jAlert(localTranslation["roleinuse"][$globlan], localTranslation["attention"][$globlan]);
								return false								
							} else {
								$("tbody").empty().html(result);
							}
						}
					});
				}
			});				
		}
		function save() {
			$found = 0;		
			$.each($(".row-header"), function() {		
				if ($("#newrole").val().toUpperCase() == $(this).text()) $found = 1;
			});
			if ($found == 1) {
				jAlert(localTranslation["roleavailable"][$globlan], localTranslation["attention"][$globlan]);
				return false
			} else {
				$.ajax({
					type: "POST",
					cache: false,
					url:  "./tools/roles_api.php",
					data: { 
						routine: "newrole",
						nme: $("#newrole").val().toUpperCase()
					},
					success: function(result)
					{
						$("tbody").empty().html(result);
						$("#newrole").val("");
					}
				});
			};
		}
	// switch language
		function c_lan() {		
			translate_header($globlan);	
			translate_mainmenu($globlan);
			translate_system($globlan) 
			$.each($('#container *').filter(function(){return $(this).data('lan') !== undefined;}), function() {			
				switch ($(this).data("type")) {
					case "text":		
						$(this).text(localTranslation[$(this).data("lan")][$globlan]);
						break;
					case "title":				
						$(this).attr("title", localTranslation[$(this).data("lan")][$globlan]);
						break;
					case "date":
						$(this).val(localizedate($($(this).data("lan")).val()));
						break;						
				}
			});
			$.each($('*').filter(function(){return $(this).data('type') == "tableheader";}), function() {
				$(this).text(roleTranslation[$(this).data("lan")][$globlan]);
			});
		}
		function change_box(loc) {	
			if ($(loc).data("checked")) {		
				$(loc).data("checked", false).removeClass("icn_checkboxchecked_c_n").addClass("icn_checkboxempty_c_n");
			} else {
				$(loc).data("checked", true).removeClass("icn_checkboxempty_c_n").addClass("icn_checkboxchecked_c_n");	
			}
			$idx = $(loc).attr("id").split("_")[0].substr(1);			
			$selrow = $("#"+$(loc).attr("id").split("_")[0]+" span");
			$flags = "";
			$.each($selrow, function () {
				if ($(this).data("checked")) {
					$flags+=$(this).attr("id").split("_")[1].substr(1);
				}
			});		
			$.ajax({
				type: "POST",
				cache: false,
				url:  "./tools/roles_api.php",
				data: { 
					routine: "saveflags",
					id: $idx,
					flags: $flags
				},
				success: function()
				{
				}
			});
        }
	</script>	
</body>
</html>
