<!DOCTYPE html>
<html>
<head>
	<meta http-equiv="X-UA-Compatible" content="IE=Edge" />
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />	
	<?php 
		include_once(dirname(__FILE__)."/tools/all_header.php"); 
		global $c_scheme, $timezone, $rel_path;
		if ($qb_support->checkflag("Y") === false) header("Location: basic.php");
	?>	
	<script>
		var js_debug = false;
		$data_changed = false;	
	</script>
	
    <title>Setup</title>
	
	<link rel="stylesheet" href="./css/qb.php" />
	
	<script src="./jquery/jquery.min.js"></script>
	<script src="./jquery/jquery-migrate-1.2.1.min.js"></script>	
	<script src="./jquery/jquery-ui.min.js"></script>
	<script src="./jquery/qb_js.js"></script>
	<?php
		$query = "SELECT DEFAULTPW, COMPANY, SENDERMAIL, COMPANYLOGO, SERVER, DEBUGGING FROM qb_conf";
		$stmt = $db->query($query);
		list($defaultpw, $company, $sendermail, $companylogo, $server, $debugon) = $stmt->fetch(PDO::FETCH_NUM );
	?>
	<script>
	// load translation and save in localTranslation
		<?php	
			$ini_setup = parse_ini_file($rel_path.'i18n/setup.ini', true);	
			echo "localTranslation = {};";
			foreach($ini_setup as $key=>$value){
				$add = "";
				foreach($value AS $lan=>$trans){
					$add .= "'".$lan."':'".$trans."',";
				}
				echo "localTranslation['".$key."']={".rtrim($add, ',')."};";
			}
		?>
	</script>
</head>
<body>
	<div id="container">
		<?php 
			include_once($rel_path.'tools/header.php');
		?> 
		<div id="contents">
			<?php 
				echo "<div id='mainnav'>". $qb_support->get_main_menu(4) . "</div>";
			?>
			<div class="dtop">
				<?php include_once($rel_path.'html/systemmenu.php');	?>		
				<span data-type="text" data-lan="setup"><?php echo $ini_setup['setup'][$_SESSION['lng']]; ?></span>
			</div>
			<div class="tabs_container">
				<p>
					<label data-type='text' data-lan='stdpw' class='dlabel w300'><?php echo $ini_setup['stdpw'][$_SESSION['lng']]; ?></label>
					<input type='text' class='dinput w300' id='pwkpi' value='<?php echo $defaultpw; ?>' />
					<span data-type='text' data-lan='save' class='spanbutton w100' onclick='save_pw()'><?php echo $ini_setup['save'][$_SESSION['lng']]; ?></span>
				</p>
				<p>
					<label data-type='text' data-lan='stdsender' class='dlabel w300'><?php echo $ini_setup['stdsender'][$_SESSION['lng']]; ?></label>
					<input type='text' class='dinput w300' id='stdm' value='<?php echo $sendermail; ?>' />
					<span data-type='text' data-lan='save' class='spanbutton w100' onclick='save_mail()'><?php echo $ini_setup['save'][$_SESSION['lng']]; ?></span>
				</p>						
				<hr />		
				<p>
					<label data-type='text' data-lan='companyname' class='dlabel w300'><?php echo $ini_setup['companyname'][$_SESSION['lng']]; ?></label>
					<input type='text' class='dinput w300' id='company' value='<?php echo $company; ?>' />
					<span data-type='text' data-lan='save' class='spanbutton w100' onclick='save_company()'><?php echo $ini_setup['save'][$_SESSION['lng']]; ?></span>
				</p>
				<p>
					<label data-type='text' data-lan='companylogo' class='dlabel w300'><?php echo $ini_setup['companylogo'][$_SESSION['lng']]; ?></label>
					<input type='text' class='dinput w300' id='logo' value='<?php echo $companylogo; ?>' />
					<span data-type='text' data-lan='save' class='spanbutton w100' onclick='save_logo()'><?php echo $ini_setup['save'][$_SESSION['lng']]; ?></span>
				</p>
				<p>
					<label data-type='text' data-lan='server' class='dlabel w300'><?php echo $ini_setup['server'][$_SESSION['lng']]; ?></label>
					<input type='text' class='dinput w300' id='server' value='<?php echo $server; ?>' />
					<span data-type='text' data-lan='save' class='spanbutton w100' onclick='save_server()'><?php echo $ini_setup['save'][$_SESSION['lng']]; ?></span>
				</p>						
				<hr />
				<p>
					<label data-type='text' data-lan='debug' class='dlabel w300'><?php echo $ini_setup['debug'][$_SESSION['lng']]; ?></label>
					<?php
						if ($debugon) {
							echo '<span id="tracking" data-checked="true" class="icn_checkboxchecked_c_n clckbtn vam" style="color: '.$c_scheme["XN"].';" onclick="change_box(this);"></span>';
						} else {
							echo '<span id="tracking" data-checked="false" class="icn_checkboxempty_c_n clckbtn vam" style="color: '.$c_scheme["XN"].';" onclick="change_box(this);" ></span>';
						}
					?>
				</p>						
				<hr />
			</div>
		</div>
		<?php include_once($rel_path.'/footer.php'); ?> 
	</div>
	<script>
		$("#dialog-master").keypress(function(e) {
			  if (e.keyCode == $.ui.keyCode.ENTER) {
				$(this).parent().find("button:eq(1)").trigger("click");
			  }
		});	
	// switch language
		function c_lan() {	
			translate_header($globlan);	
			translate_mainmenu($globlan);
			translate_system($globlan) 
			$.each($('#container *').filter(function(){return $(this).data('lan') !== undefined;}), function() {			
				switch ($(this).data("type")) {
					case "text":		
						$(this).text(localTranslation[$(this).data("lan")][$globlan]);
						break;
					case "title":				
						$(this).attr("title", localTranslation[$(this).data("lan")][$globlan]);
						break;
					case "date":
						$(this).val(localizedate($($(this).data("lan")).val()));
						break;						
				}
			});
		}
		function save_logo() {
			if  (!$.trim($('#logo').val())) {
				return false;
			} else {
				$.ajax({
					type: 'POST',
					cache: false,
					url:  './tools/setup_api.php',
					data: { 
						routine: 'upd_logo',
						wert: $('#logo').val()
					},
					success: function(result)
					{
						jAlert(localTranslation['data_upate'][$globlan], localTranslation['attention'][$globlan]);
					}
				});	
			}
		}
		function save_company() {
			if  (!$.trim($('#company').val())) {
				return false;
			} else {
				$.ajax({
					type: 'POST',
					cache: false,
					url:  './tools/setup_api.php',
					data: { 
						routine: 'upd_company',
						wert: $('#company').val()
					},
					success: function(result)
					{
						jAlert(localTranslation['data_upate'][$globlan], localTranslation['attention'][$globlan]);
					}
				});	
			}
		}
		function change_box(loc) {		
			if ($(loc).data("checked")) {
				$(loc).data("checked", false).removeClass("icn_checkboxchecked_c_n").addClass("icn_checkboxempty_c_n");
			} else {		
				$(loc).data("checked", true).removeClass("icn_checkboxempty_c_n").addClass("icn_checkboxchecked_c_n");	
			}
			$.ajax({
				type: 'POST',
				cache: false,
				url:  './tools/setup_api.php',
				data: { 
					routine: 'debugbox',
					wert: $(loc).data('checked')*1
				},
				success: function(result)
				{
					jAlert(localTranslation['data_upate'][$globlan], localTranslation['attention'][$globlan]);
				}
			});	
		}	
		function save_mail() {
			if  (!$.trim($('#stdm').val())) {
				return false;
			} else {
				$.ajax({
					type: 'POST',
					cache: false,
					url:  './tools/setup_api.php',
					data: { 
						routine: 'upd_mail',
						wert: $('#stdm').val()
					},
					success: function(result)
					{
						jAlert(localTranslation['data_upate'][$globlan], localTranslation['attention'][$globlan]);
					}
				});	
			}
		}
		function save_pw() {
			if  (!$.trim($('#pwkpi').val())) {
				return false;
			} else {
				$.ajax({
					type: 'POST',
					cache: false,
					url:  './tools/setup_api.php',
					data: { 
						routine: 'upd_pw',
						wert: $('#pwkpi').val()
					},
					success: function(result)
					{
						jAlert(localTranslation['data_upate'][$globlan], localTranslation['attention'][$globlan]);
					}
				});	
			}
		}
		function save_server() {
			if  (!$.trim($('#server').val())) {
				return false;
			} else {
				$.ajax({
					type: 'POST',
					cache: false,
					url:  './tools/setup_api.php',
					data: { 
						routine: 'upd_server',
						wert: $('#server').val()
					},
					success: function(result)
					{
						jAlert(localTranslation['data_upate'][$globlan], localTranslation['attention'][$globlan]);
					}
				});	
			}
		}	
	</script>
</body>
</html>
