<!DOCTYPE html>
<html>
<head>
	<meta http-equiv="X-UA-Compatible" content="IE=Edge" />
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />	
	<?php 
		include_once(dirname(__FILE__)."/tools/all_header.php"); 
		global $c_scheme, $timezone, $rel_path;
		if (!$qb_support->checkflag("YW")) header("Location: basic.php");
	?>	
	<script>
		var js_debug = false;
		$data_changed = false;	
	</script>
  <title>Standard Text</title>
	
	<link rel="stylesheet" href="./css/qb.php" />
	<link rel="stylesheet" href="./trumbowyg/dist/ui/trumbowyg.css">
	<link rel="stylesheet" href="./trumbowyg/dist/plugins/colors/ui/trumbowyg.colors.min.css">
	<link rel="stylesheet" href="./trumbowyg/dist/plugins/specialchars/ui/trumbowyg.specialchars.min.css">

	<style>
		.editbox {
			background: #FFFFFF;
		}		
		.trumbowyg-box, .trumbowyg-editor {
			width: 900px; 
			max-height: 260px;
			min-height: 220px;
			margin: 0;
			margin-top: 5px;
			display: inline-block;
		}
		.trumbowyg-textarea {
			max-height: 260px;
			min-height: 220px;
			padding: 2px;
			font-family: Arial;
		}
		.trumbowyg-editor {
			padding: 2px;
			font-family: Arial;
		}
		.trumbowyg-fullscreen {
			margin: 0;
			padding: 0;
			top: 0px;
			left: 0px;
			width: 100%;
			height: 100%;
		}
	</style>
	
	<script src="./jquery/jquery.min.js"></script>
	<script src="./jquery/jquery-migrate-1.2.1.min.js"></script>	
	<script src="./jquery/jquery-ui.min.js"></script>
	<script src="./jquery/qb_js.js"></script>
	<script src="./trumbowyg/dist/trumbowyg.js"></script>
	<script src="./trumbowyg/dist/plugins/colors/trumbowyg.colors.min.js"></script>
	<script src="./trumbowyg/dist/plugins/specialchars/trumbowyg.specialchars.min.js"></script>
	<?php 
		foreach(explode(":", $qb_support->getLanOnly()) as $key=>$value) {
			if ($value != "en") echo '<script src="./trumbowyg/dist/langs/'.$value.'.min.js"></script>';
		}
	?>

	<script>
	// load translation and save in localTranslation
		<?php	
			$ini_stdtxt = parse_ini_file($rel_path.'i18n/stdtxt.ini', true);	
			echo "localTranslation = {};";
			foreach($ini_stdtxt as $key=>$value){
				$add = "";
				foreach($value AS $lan=>$trans){
					$add .= "'".$lan."':'".$trans."',";
				}
				echo "localTranslation['".$key."']={".rtrim($add, ',')."};";
			}	
		?>
	</script>
</head>
<body>
	<div id="container">
		<?php 
			include_once($rel_path.'tools/header.php');
		?> 
		<div id="contents">
			<?php 
				echo "<div id='mainnav'>". $qb_support->get_main_menu(4) . "</div>";
			?>
			<div class="dtop">
				<?php include_once($rel_path.'html/systemmenu.php');	?>		
				<span data-type="text" data-lan="stdtxt"><?php echo $ini_stdtxt['stdtxt'][$_SESSION['lng']]; ?></span>
			</div>
			<div class="container" style="padding: 5px;">
				<div style="vertical-align: top; margin-left: 10px; border: 1px solid <?php echo $c_scheme['IO']; ?>; height: 290px; padding: 2px; width: 975px; ">
					<p>
						<label class="dlabel" style='font: bold 11pt Arial;' data-type="text" data-lan="LPSG48"><?php echo $ini_stdtxt['LPSG48'][$_SESSION['lng']]; ?></label>
					</p>
					<div id="wysiwyg" class="editbox"></div>
					<span data-type='title' data-lan='save' id='save_LPSG48' style='float: right; margin: 110px 10px 0 0;' class='icn5_save_b_n clckbtn vam' title='<?php echo $ini_stdtxt['save'][$_SESSION['lng']]; ?>' onclick='save_lpsg48()'></span>
				</div>
				<div style="vertical-align: top; margin-left: 10px; border: 1px solid <?php echo $c_scheme['IO']; ?>; height: 290px; padding: 2px; width: 975px;">
					<p>
						<label class="dlabel" style='font: bold 11pt Arial;' data-type="text" data-lan="LPSK48"><?php echo $ini_stdtxt['LPSK48'][$_SESSION['lng']]; ?></label>
					</p>
					<div id="wysiwyg1" class="editbox"></div>
					<span data-type='title' data-lan='save' id='save_LPSK48' style='float: right; margin: 110px 10px 0 0;' class='icn5_save_b_n clckbtn vam' title='<?php echo $ini_stdtxt['save'][$_SESSION['lng']]; ?>' onclick='save_lpsk48()'></span>
				</div>
			</div>
		</div>
		<?php include_once($rel_path.'/footer.php'); ?>
	</div>
	<script>
		window.sessionStorage.removeItem("qb");
		window.sessionStorage.removeItem("qbn");
		init_wysiwyg_editor('#wysiwyg');
		init_wysiwyg_editor('#wysiwyg1');

		function init_wysiwyg_editor(id) {
			$(id).trumbowyg('destroy');
			$(id).trumbowyg({
				lang: $globlan,
				removeformatPasted: true,
				semantic: true,
				tagsToRemove: ['script'],
				btns: [
					['viewHTML'],
					['specialChars'],
					['formatting'],
					['|', 'foreColor', 'backColor'],
					['strong', 'em', 'del'],
					['superscript', 'subscript'],
					['link'],
					['justifyLeft', 'justifyCenter', 'justifyRight', 'justifyFull'],
					['unorderedList', 'orderedList'],
					['horizontalRule'],
					['removeformat'],
					['fullscreen']
				]
			});
		}
		function load_page() {
			$.ajax({
				type: "GET",
				cache: false,
				url:  "./tools/stdtxt_api.php",
				dataType: 'json',
				data: { 
					routine: "gettxt",
					lang: $globlan
				},
				success: function(result)
				{
					$('#wysiwyg').trumbowyg('html', result[0]);
					$('#wysiwyg1').trumbowyg('html', result[1]);
				}
			});			
		}
		function c_lan(loc) {
			translate_header($globlan);	
			translate_mainmenu($globlan);
			translate_system($globlan);
			$.each($('#container *').filter(function(){return $(this).data('lan') !== undefined;}), function() {			
				switch ($(this).data("type")) {
					case "text":		
						$(this).text(localTranslation[$(this).data("lan")][$globlan]);
						break;
					case "title":				
						$(this).attr("title", localTranslation[$(this).data("lan")][$globlan]);
						break;					
				}
			});
			$('#wysiwyg').trumbowyg('destroy');
			$('#wysiwyg').trumbowyg({
				lang: $globlan,
				removeformatPasted: true,
				semantic: false,
				btns: [
					'btnGrp-design',
					['|', 'foreColor', 'backColor'],
					'btnGrp-justify',
					'btnGrp-lists',
					['horizontalRule'],
					['removeformat'],
					['fullscreen']
				]
			});
			$('#wysiwyg1').trumbowyg('destroy');
			$('#wysiwyg1').trumbowyg({
				lang: $globlan,
				removeformatPasted: true,
				semantic: false,
				btns: [
					'btnGrp-design',
					['|', 'foreColor', 'backColor'],
					'btnGrp-justify',
					'btnGrp-lists',
					['horizontalRule'],
					['removeformat'],
					['fullscreen']
				]
			});
			load_page();
		}
		function save_lpsg48() {
			var h = $("#wysiwyg").trumbowyg('html').trim();
			while (h.match(/^<br ?\/?>/gi)) h = h.replace(/^<br ?\/?>/gi, '').trim();
			while (h.match(/<br ?\/?>$/gi)) h = h.replace(/<br ?\/?>$/gi, '').trim();
			$.ajax({
				type: "POST",
				cache: false,
				url:  "./tools/stdtxt_api.php",
				data: { 
					routine: "save_lpsg48",
					lang: $globlan,
					txt: h
				},
				success: function(result)
				{
					jAlert(localTranslation["datasaved"][$globlan], localTranslation["attention"][$globlan]);
				}
			});	
		}
		function save_lpsk48() {
			var h = $("#wysiwyg1").trumbowyg('html').trim();
			while (h.match(/^<br ?\/?>/gi)) h = h.replace(/^<br ?\/?>/gi, '').trim();
			while (h.match(/<br ?\/?>$/gi)) h = h.replace(/<br ?\/?>$/gi, '').trim();
			$.ajax({
				type: "POST",
				cache: false,
				url:  "./tools/stdtxt_api.php",
				data: { 
					routine: "save_lpsk48",
					lang: $globlan,
					txt: h
				},
				success: function(result)
				{
					jAlert(localTranslation["datasaved"][$globlan], localTranslation["attention"][$globlan]);
				}
			});	
		}
		load_page();
	</script>
</body>
</html>
