<!DOCTYPE html>
<html>
<head>
	<meta http-equiv="X-UA-Compatible" content="IE=Edge" />
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />	
	<?php 
		include_once(dirname(__FILE__)."/tools/all_header.php"); 
		global $c_scheme, $timezone, $rel_path;
		if (!$qb_support->checkflag("YW")) header("Location: basic.php");
	?>	
	<script>
		var js_debug = false;
		$data_changed = false;	
	</script>
	
    <title>Supplier</title>
		
	<link rel="stylesheet" href="./css/qb.php" />
	<link rel="stylesheet" href="./jqGrid_5.2.1/css/ui.jqgrid.css" />
	
	<style>
		.highlightrow {
			background: <?php echo $c_scheme['MB']; ?> url(./img/del.png) center repeat-x;
			display: inline-block;
			width: 100%;
		}
		.logininput {
			background: <?php echo $c_scheme['MB']; ?>;
		}
		.ui-pager-control {
			height: 32px !important;
		}	
		.ui-jqgrid tr.jqgrow td{
			white-space:nowrap;
			height: 18px !important;
		}
		.ui-state-hover, .ui-widget-content .ui-state-hover, .ui-widget-header .ui-state-hover,
		.ui-state-focus, .ui-widget-content .ui-state-focus, .ui-widget-header .ui-state-focus
		{
			border: 0 none;
		}	
	</style>
	
	<script src="./jquery/jquery.min.js"></script>
	<script src="./jquery/jquery-migrate-1.2.1.min.js"></script>	
	<script src="./jquery/jquery-ui.min.js"></script>
	<script src="./jquery/qb_js.js"></script>
	
	<?php 
		foreach(explode(":", $qb_support->getLanOnly()) as $key=>$value) {
			echo '<script src="./jqGrid_5.2.1/js/i18n/grid.locale-' . $value . '.js"></script>';
		}
	?>
	<script src="./jqGrid_5.2.1/js/jquery.jqGrid.min.js"></script>	

	<script>
	// load translation and save in localTranslation
		<?php	
			$ini_supplier = parse_ini_file($rel_path.'i18n/supplier.ini', true);	
			echo "localTranslation = {};";
			foreach($ini_supplier as $key=>$value){
				$add = "";
				foreach($value AS $lan=>$trans){
					$add .= "'".$lan."':'".$trans."',";
				}
				echo "localTranslation['".$key."']={".rtrim($add, ',')."};";
			}
      $sklasse = parse_ini_file($rel_path.'xml/s_cats.ini', true);
      echo "sklasse = {};";
      foreach($sklasse as $key=>$value){
        $add = "";
        foreach($value AS $lan=>$trans){
          $add .= "'".$lan."':'".$trans."',";
        }
        echo "sklasse['".$key."']={".rtrim($add, ',')."};";
      }
		?>		
	</script>
</head>
<body>
	<div id="container">
		<?php 
			include_once($rel_path.'tools/header.php');
		?> 
		<div id="contents">
			<?php 
				echo "<div id='mainnav'>". $qb_support->get_main_menu(4) . "</div>";
			?>
			<div class="dtop">
				<?php include_once($rel_path.'html/systemmenu.php');	?>		
				<span data-type="text" data-lan="suppliers"><?php echo $ini_supplier['suppliers'][$_SESSION['lng']]; ?></span>
			</div>
			<div class="tabs_container">
				<div style="margin-left: 5px;" >
					<table id="list"></table> 
					<div id="pager"></div> 
				</div>
			</div>			
		</div>
		<?php include_once($rel_path.'/footer.php'); ?> 
	</div>
	<script>
		function load_page() {
			loaddata();
		}	
		function c_lan() {
			translate_header($globlan);	
			translate_mainmenu($globlan);
			translate_system($globlan);
			$.each($('#container *').filter(function(){return $(this).data('lan') !== undefined;}), function() {			
				switch ($(this).data("type")) {
					case "text":		
						$(this).text(localTranslation[$(this).data("lan")][$globlan]);
						break;
					case "title":				
						$(this).attr("title", localTranslation[$(this).data("lan")][$globlan]);
						break;
					case "date":
						$(this).val(localizedate($($(this).data("lan")).val()));
						break;						
				}
			});			
			$.jgrid.setRegional('list',{regional: $globlan});
			$("#list").jqGrid('setLabel', "creditnr", localTranslation["credit_nr"][$globlan])
				.jqGrid('setLabel', "suppliername", localTranslation["nname"][$globlan])
				.jqGrid('setLabel', "country", localTranslation["country"][$globlan])
        .jqGrid('setLabel', "sclass", localTranslation["sclass"][$globlan]);
			$("#add_list").attr("title", localTranslation["add_row"][$globlan]);	
			$("#edit_list").attr("title", localTranslation["edit_row"][$globlan]);
			$("#del_list").attr("title", localTranslation["del_row"][$globlan]);
			$("#edit_creditor").attr("title", localTranslation["edit_creditor"][$globlan]);				
		}
		function delFormatter (cellvalue, options, rowObject)
		{
			if (rowObject['rshort'] == "0") {
				return "<span class='highlightrow'>"+cellvalue+"</span>";
			} else {
				return cellvalue;
			}
		}
		function undelFormatter (cellvalue, options, rowObject)
		{
			return cellvalue;
		}
		function SCdelFormatter (cellvalue, options, rowObject)
		{
      if (cellvalue == "") return "";
			if (rowObject['rshort'] == "0") {
				return "<span class='highlightrow'>"+cellvalue+":"+sklasse[cellvalue][$globlan]+"</span>";
			} else {
				return cellvalue+":"+sklasse[cellvalue][$globlan];
			}
		}
		function SCundelFormatter (cellvalue, options, rowObject)
		{
      if (cellvalue == "") return "";
			return cellvalue+":"+sklasse[cellvalue][$globlan];
		}	
		function loaddata() {
			cmTemplate = {
				editable: true,
				edittype:'text', 
				editrules:
				{
					required:true,
				},
				editoptions:
				{
					size:"30"
				}, 			
				sorttype:'string',		
				searchoptions: {
					sopt:['cn'], 
					clearSearch: false
				}
			};		
			obj = {
				url:  "./tools/supplier_api.php",
				postData: {routine : "readsupplier"},
				contentType: "application/json",
				datatype: "json",
				jsonReader: {
					id: "id",
					repeatitems: false
				},
				mtype: "POST",
				colNames: [
					localTranslation["credit_nr"][$globlan],
					localTranslation["nname"][$globlan],
					localTranslation["country"][$globlan],
          localTranslation["sclass"][$globlan],
					"rshort"
				],
		// create column definitions	
				colModel: [
					{ 
						name: "creditnr", 
						width: 110,
						template: cmTemplate,
						formatter: delFormatter,
						unformat: undelFormatter
					},
					{ 
						name: "suppliername", 
						width: 500,
						template: cmTemplate,
						formatter: delFormatter,
						unformat: undelFormatter
					},
					{
						name: "country", 
						width: 200,
						template: cmTemplate,
						edittype:'select',
						editoptions:
						{
							size: "1",
							value:{
								<?php
									$query = "SELECT CODE, COUNTRY FROM qb_ccode ORDER BY COUNTRY";
									$stmt = $db->query($query);
									$selopt = "";
									while($row = $stmt->fetch(PDO::FETCH_NUM)) {
										$selopt.=$row[0].":'".addslashes($row[1])."',";
									}
									echo trim($selopt, ",");
								?>
							},
							dataInit: function(elem) {
								$(elem).width(150);
							}
						}, 
						formatter: delFormatter,
						unformat: undelFormatter
					},
					{
						name: "sclass", 
						width: 130,
						template: cmTemplate,
						edittype:'select',
						editoptions:
						{
							size: "1",
							value:{
								<?php
                	$sclass = "";
                  foreach($sklasse as $key=>$value) {
										$sclass.=$key.":'".$key.":".$value[$_SESSION['lng']]."',";
									}
									echo trim($sclass, ",");
								?>
							},
							dataInit: function(elem) {
								$(elem).width(150);
							}
						}, 
						formatter: SCdelFormatter,
						unformat: SCundelFormatter
					},
					{ name: "rshort", hidden: true , editable: false }
				],
				regional: $globlan,
				storeNavOptions: true,			
				loadonce: false,
				pager: "#pager",
				height: 510,
				rowNum: 100,
				rowList: [10, 100, 500, 1000, 1500],
				hoverrows: false,
				rownumbers: true,
				sortname: "suppliername",
				sortorder: "asc",
				viewrecords: true,
				gridview: true,
				autoencode: true,
				ignoreCase:true,
				loadui: "block",
				ondblClickRow: function(id, ri, ci) {
					$("#list").jqGrid('editGridRow', id, editSettings);
				},
				loadComplete: function() {
					$("th[role='columnheader']")
						.unbind("mouseenter")
						.unbind("mouseleave");
				},
				gridComplete: function(data) {
					$(".ui-search-toolbar input[role='textbox']")
						.css("width", "92%")
						.css("background", "<?php echo $c_scheme['M5']; ?>")
						.css("padding", "2px");	
					custbtns();
				},			
				editurl: "./tools/supplier_api.php"		
			};	
			editSettings = {
				recreateForm:true,
				jqModal:true,
				modal: true,
				reloadAfterSubmit: true,
				closeOnEscape:false,
				savekey: [false,13],
				closeAfterEdit: true,
				zIndex:1000,
				width: 450,
				viewPagerButtons:false,
				beforeShowForm: function(form) {
			// center edit form
					var parentWidth = $(window).width();
					var parentHeight = $(window).height();
					var dlgDiv = $("#editmodlist");
					var dlgWidth = dlgDiv.width();
					var dlgHeight = dlgDiv.height();
					dlgDiv[0].style.top = Math.round((parentHeight-dlgHeight)/2) + "px";
					dlgDiv[0].style.left = Math.round((parentWidth-dlgWidth)/2) + "px";
					$('#creditnr').attr('readonly','readonly').addClass("logininput");
					$(".EditButton")
						.empty()
						.append("<span id='sData' class='spanbutton w100'>"+localTranslation["save"][$globlan]+"</span>")
						.append("<span id='cData' style='margin: 0 10px;' class='spanbutton w100'>"+localTranslation["cancel"][$globlan]+"</span>");												
				},
				ajaxEditOptions:{ contentType:"application/json" },
				mtype:'POST',
				serializeEditData:function (data) {
					data["routine"] = "updatesupplier";
					return JSON.stringify(data);
				},
				onClose: function() {
					$("#list").setGridParam({datatype:'json'}).trigger('reloadGrid');
				}
			};
			$old_creditnr = "";
			editSettings2 = {
				recreateForm:true,
				jqModal:true,
				modal: true,
				reloadAfterSubmit: true,
				closeOnEscape:false,
				savekey: [false,13],
				closeAfterEdit:true,
				zIndex:1000,
				width: 450,
				viewPagerButtons:false,
				beforeShowForm: function(form) {
			// center edit form
					var parentWidth = $(window).width();
					var parentHeight = $(window).height();
					var dlgDiv = $("#editmodlist");
					var dlgWidth = dlgDiv.width();
					var dlgHeight = dlgDiv.height();
					dlgDiv[0].style.top = Math.round((parentHeight-dlgHeight)/2) + "px";
					dlgDiv[0].style.left = Math.round((parentWidth-dlgWidth)/2) + "px";
					$old_creditnr = $('#creditnr').val();
					$('#login').removeAttr('readonly').removeClass("logininput");
					$('#tr_suppliername').hide();
					$('#tr_country').hide();
					$('#tr_werk').hide();
					$(".EditButton")
						.empty()
						.append("<span id='sData' class='spanbutton w100'>"+localTranslation["save"][$globlan]+"</span>")
						.append("<span id='cData' style='margin: 0 10px;' class='spanbutton w100'>"+localTranslation["cancel"][$globlan]+"</span>");												
				},
				ajaxEditOptions:{ contentType:"application/json" },
				mtype:'POST',
				serializeEditData:function (data) {
					data["routine"] = "adminupdate";
					data["old"] = $old_creditnr;
					return JSON.stringify(data);
				},
				errorTextFormat: function (e) {
					if (e['status'] == 409) {
						return '<span class="ui-icon ui-icon-alert" style="float: left; margin-right: .3em;"></span>'+localTranslation["crn_used"][$globlan];
					}
				},
				onClose: function() {
					$("#gs_login").val("");
					$("#list").setGridParam({datatype:'json'}).trigger('reloadGrid');
				}	
			};		
			addSettings = {
				recreateForm:true,
				jqModal:true,
				modal: true,
				reloadAfterSubmit: true,
				closeOnEscape:false,
				savekey: [false,13],
				closeAfterAdd: true,
				zIndex:1000,
				width: 450,
				viewPagerButtons:true,
				beforeShowForm: function(form) {
			// center edit form
					var parentWidth = $(window).width();
					var parentHeight = $(window).height();
					var dlgDiv = $("#editmodlist");
					var dlgWidth = dlgDiv.width();
					var dlgHeight = dlgDiv.height();
					dlgDiv[0].style.top = Math.round((parentHeight-dlgHeight)/2) + "px";
					dlgDiv[0].style.left = Math.round((parentWidth-dlgWidth)/2) + "px";
					$('#creditnr').removeAttr('readonly').removeClass("logininput");
					$(".EditButton")
						.empty()
						.append("<span id='sData' class='spanbutton w100'>"+localTranslation["save"][$globlan]+"</span>")
						.append("<span id='cData' style='margin: 0 10px;' class='spanbutton w100'>"+localTranslation["cancel"][$globlan]+"</span>");												
				},
				ajaxEditOptions:{ contentType:"application/json" },
				mtype:'POST',
				postData: {routine : "adduser"},
				serializeEditData:function (data) {
					data["routine"] = "addsupplier";
					return JSON.stringify(data);
				},
				errorTextFormat: function (e) {
					if (e['status'] == 409) {
						return '<span class="ui-icon ui-icon-alert" style="float: left; margin-right: .3em;"></span>'+localTranslation["crn_used"][$globlan];
					}
				},
				onClose: function() {
					$("#list").setGridParam({datatype:'json'}).trigger('reloadGrid');
				}			
			};
			deleteSettings = {
				recreateForm:true,
				jqModal:true,
				modal: true,
				reloadAfterSubmit:true,
				closeOnEscape:false,
				savekey: [false,13],
				closeAfterEdit:true,
				zIndex:1000,
				width: 450,
				viewPagerButtons:false,
				caption: localTranslation["rem"][$globlan],
				beforeShowForm: function(form) {
			// center edit form
					var parentWidth = $(window).width();
					var parentHeight = $(window).height();
					var dlgDiv = $("#delmodlist")||$("#alertmod_list");
					var dlgWidth = dlgDiv.width();
					var dlgHeight = dlgDiv.height();
					dlgDiv[0].style.top = Math.round((parentHeight-dlgHeight)/2) + "px";
					dlgDiv[0].style.left = Math.round((parentWidth-dlgWidth)/2) + "px";
					$deluser = $("#list").jqGrid('getRowData',$("#list").jqGrid('getGridParam','selrow'));
					$("td.delmsg",form).html("<center>"+localTranslation["confirm_del_supplier"][$globlan]+"</center><br /><center><span style='color: <?php echo $c_scheme['XH']; ?>; font-weight: bold;'>"+
						$deluser['suppliername']+" ("+$deluser['creditnr']+")</span></center>");
					$(".EditButton a").css("display", "none");
					if (!$("#dData1" ).length) {
						$(".EditButton")
							.append("<span id='dData1' class='spanbutton w100' onclick='$(\"#dData\").click();'>"+localTranslation["rem"][$globlan]+"</span>")
							.append("<span id='eData1' style='margin: 0 10px;' class='spanbutton w100' onclick='$(\"#eData\").click();'>"+localTranslation["cancel"][$globlan]+"</span>");
						}
				},
				mtype:'POST',
				serializeDelData:function (data) {
					$deluser = $("#list").jqGrid('getRowData',$("#list").jqGrid('getGridParam','selrow'));
					data["creditor"] = $deluser['creditnr'];
					data["routine"] = "deletesupplier";
					return JSON.stringify(data);
				},
				onClose: function() {
					$("#list").setGridParam({datatype:'json'}).trigger('reloadGrid');
				}
			};
			list1 = $("#list").jqGrid(obj)
				.jqGrid('filterToolbar',{searchOperators : false, searchOnEnter: false})
				.navGrid('#pager', {refresh: false, search: false}, editSettings, addSettings, deleteSettings);		
		}
		function custbtns() {
		// special buttons for admins
			<?php if ($qb_support->checkflag("Y")) { ?>
				$("#list").jqGrid('navButtonAdd',"#pager",{
					caption:"",
					id:"edit_creditor",
					buttonicon:"ui-icon-wrench", 
					onClickButton: function(){
						if($("#list").jqGrid('getGridParam','selrow') === null) {
							jAlert(localTranslation["select_supplier_first"][$globlan], localTranslation["attention"][$globlan]);
							return false;
						} else {
							$("#list").jqGrid('editGridRow', $("#list").jqGrid('getGridParam','selrow'), editSettings2);
						}
					},
					position: "last", 
					title: localTranslation["edit_creditor"][$globlan],
					cursor: "default"
				});	
				$("#list").jqGrid('navButtonAdd',"#pager",{
					caption:"",
					id:"admin_del",
					buttonicon:"ui-icon-alert", 
					onClickButton: function(){
						if ($("#list").jqGrid('getGridParam','selrow') === null) {
							jAlert(localTranslation["select_supplier_first"][$globlan], localTranslation["attention"][$globlan]);
							return false;
						} else {
							$deluser = $("#list").jqGrid('getRowData',$("#list").jqGrid('getGridParam','selrow'));
							if ($deluser['rshort'] != "0") {
								jAlert(localTranslation["del_supplier_first"][$globlan], localTranslation["attention"][$globlan]);
								return false;							
							} else {
								$.alerts.cancelButton = localTranslation["cancel"][$globlan];
								jConfirm(localTranslation["confirm_del_supplier"][$globlan], localTranslation["attention"][$globlan], function(r) {
									if (r) {
										$("#loading").show();								
										$.ajax({
											type: "POST",
											cache: false,
											url:  "./tools/supplier_api.php",
											data: { 
												routine: "erasesupplier",
												creditnr: $deluser['creditnr']
											},
											success: function(result)
											{
												$("#loading").hide();
												if ($.trim(result) == "Fail") {
													jAlert(localTranslation["supplier_not_erased"][$globlan], localTranslation["attention"][$globlan]);
													return false;
												} else {										
													$("#gs_login").val("");
													$("#list").setGridParam({datatype:'json'}).trigger('reloadGrid');
													jAlert(localTranslation["supplier_erased"][$globlan], localTranslation["attention"][$globlan]);
												}
											}
										});
									} else {
										return false;
									}
								});
							}
						}					
					},
					position: "last", 
					title: localTranslation["admin_del"][$globlan],
					cursor: "default"
				});
				$("#edit_creditor div").empty().html("<span class='icn_suppliereditcreditor_b_n clckbtn' style='margin: 0 5px 0 10px;'></span>");
				$("#edit_creditor").removeClass("ui-pg-button");			
				$("#admin_del div").empty().html("<span class='icn_supplierdeleteadmin_b_n clckbtn'></span>");
				$("#admin_del").removeClass("ui-pg-button");
			<?php } ?>
			$("#add_list div").empty().html("<span class='icn_add_b_n clckbtn'></span>");
			$("#add_list").removeClass("ui-pg-button");
			$("#edit_list div").empty().html("<span class='icn_edit_b_n clckbtn' style='margin: 0 2px;'></span>");
			$("#edit_list").removeClass("ui-pg-button");
			$("#del_list div").empty().html("<span class='icn_delete_b_n clckbtn'></span>");
			$("#del_list").removeClass("ui-pg-button");
			$("#pager_left .ui-separator").parent().remove();	
		}
		load_page();
	</script>
</body>
</html>
