<?php
	class QBSupport {
		const BLOWFISH_PRE = '$2y$05$';			//This string tells crypt to use blowfish for 5 rounds.
		const BLOWFISH_END = '$';
      
		public function __construct() 
		{
			if (!isset($_SESSION)) session_start();
		}
    function emptydb() 
    {
// check if brandnew database
      global $db;
      $stmt = $db->query("SELECT * FROM qbi WHERE QBSTATUS<>'D'");
      $row = $stmt->fetch(PDO::FETCH_NUM);
      return ($row)?false:true;
    }
    
		function setdefaultpw($user) 
    {
			global $db;
// reset password to default password
			$pwd = $this->generatepw(base64_encode($this->defaultpw()));
			$salt = $pwd[0];
			$pwd = $pwd[1];				
			$query = "UPDATE qb_user SET PASSWORD=:pwd, SALT=:salt WHERE LOGIN=:usr";
			$stmt = $db->prepare($query);
			$stmt->execute(
				array(
					':usr' => $user,
					':pwd' => $pwd,
					':salt' => $salt
				)
			);    
		}
    // mode = 0 -> initial password / mode=1 change password with check of old password
		function changepw($password, $opassword, $mode) {
      global $db;            
      // function for changing password
      if ($mode == 0) {
        if (base64_decode($password) == $this->defaultpw()) {
    // initial passwort -> return error
          return json_encode(array(0, "initial_pw"));
        } else {
    // password ok, add to database
          $pwd = $this->generatepw($password);
          $salt = $pwd[0];
          $pwd = $pwd[1];				
          $query = "UPDATE qb_user SET PASSWORD=:pwd, SALT=:salt WHERE LOGIN=:usr";
          $stmt = $db->prepare($query);
          $stmt->execute(
            array(
              ':usr' => $_SESSION['lg'],
              ':pwd' => $pwd,
              ':salt' => $salt
            )
          );
      // set missing session variables
          $query = "SELECT USR, FLAGS FROM qb_user WHERE LOGIN=:lgi";
          $stmt = $db->prepare($query);
          $stmt->execute(array(':lgi' => $_SESSION['lg']));				
          $row = $stmt->fetch(PDO::FETCH_NUM );                    
          $_SESSION['rl'] = $row[0];
          $_SESSION['fg'] = $row[1];                    
          return json_encode(array(1, "ok"));
        }
      } else if ($mode == 1) {
  // check for correct old password
          $query = "SELECT PASSWORD, SALT FROM qb_user WHERE LOGIN=:lgi";
          $stmt = $db->prepare($query);
          $stmt->execute(array(':lgi' => $_SESSION['lg']));				
          $row = $stmt->fetch(PDO::FETCH_NUM );
          $hashed_pass = crypt(base64_decode($opassword), self::BLOWFISH_PRE . $row[1] . self::BLOWFISH_END);
          if ($hashed_pass == $row[0]) {
      // old password OK, set new password
            $pwd = $this->generatepw($password);
            $salt = $pwd[0];
            $pwd = $pwd[1];				
            $query = "UPDATE qb_user SET PASSWORD=:pwd, SALT=:salt WHERE LOGIN=:usr";
            $stmt = $db->prepare($query);
            $stmt->execute(
                array(
                    ':usr' => $_SESSION['lg'],
                    ':pwd' => $pwd,
                    ':salt' => $salt
                )
            );
            return json_encode(array(1, "pw_changed"));                    
          } else {
      // old password not ok, issue erroe message
            return json_encode(array(0, "wrong_pw"));
          }                    
      }
		}
		function checklogin($password, $user) {
      global $db;
    // check for correct password and return link (force change password if initial password)
      $query = "SELECT PASSWORD, SALT, VORNAME, NACHNAME, USR, FLAGS FROM qb_user WHERE LOGIN=:lgi";
      $stmt = $db->prepare($query);
      $stmt->execute(array(':lgi' => $user));				
      $row = $stmt->fetch(PDO::FETCH_NUM );
      $hashed_pass = crypt(base64_decode($password), self::BLOWFISH_PRE . $row[1] . self::BLOWFISH_END);
      if ($hashed_pass == $row[0]) {
    // password is correct, now check if initial password
        if (base64_decode($password) == $this->defaultpw()) {
     // yes, initial password -> set only name and login and redirect to cpw.php
          $_SESSION['fn'] = $row[2]." ".$row[3];
          $_SESSION['lg'] = $user;
          $_SESSION['rl'] = $row[4];
          return json_encode(Array(1, "./cpw.php"));
      } else {
   // no, normal login -> set all variables
          $_SESSION['fn'] = $row[2]." ".$row[3];
          $_SESSION['lg'] = $user;
          $_SESSION['rl'] = $row[4];
          $_SESSION['fg'] = $row[5];
          $url = parse_url($_SERVER['HTTP_REFERER'])['path'];
          return json_encode(Array(2, $url));
        }
      } else {
  // wronge password
        return json_encode(Array(0));
      }
    }
	// function for changing password        
		function generatepw($password) 		// password must be base64 encoded
		{
		// Blowfish accepts these characters for salts.
			$Allowed_Chars ='ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789./';
			$Chars_Len = 63;
		// 18 would be secure as well.
			$Salt_Length = 21;
			$salt = "";
			for($i=0; $i<$Salt_Length; $i++)
			{
				$salt .= $Allowed_Chars[mt_rand(0,$Chars_Len)];
			}
			$bcrypt_salt = self::BLOWFISH_PRE . $salt . self::BLOWFISH_END;
			$pwd = crypt(base64_decode($password), $bcrypt_salt);
			return array($salt, $pwd);
		}		
		function checkpw($password, $user, $mode) 	// $mode==0 -> check only, $mode==1 -> login
		{	
			global $db;
			$query = "SELECT PASSWORD, VORNAME, NACHNAME, LOGIN, USR, FLAGS, SALT FROM qb_user WHERE LOGIN = :lgi";
			$stmt = $db->prepare($query);
			$stmt->execute(
				array(
					':lgi' => $user
				)
			);				
			$row = $stmt->fetch(PDO::FETCH_NUM );
			$hashed_pass = crypt(base64_decode($password), self::BLOWFISH_PRE . $row[6] . self::BLOWFISH_END);
			if ($hashed_pass == $row[0]) {
	// password is correct
				if ($mode == 0) {					// check only
					return json_encode(Array(1));
				} else if ($mode == 1) {			// real login
					if (crypt($this->defaultpw(), self::BLOWFISH_PRE . $row[6] . self::BLOWFISH_END) == $row[0]) {
			// default passwort -> force change
						$_SESSION['fn'] = $row[1]." ".$row[2];
						$_SESSION['lg'] = $row[3];				
						$_SESSION['rl'] = "_";
						$_SESSION['fg'] = $row[5];
						return json_encode(Array($_SESSION['lg'], "./cpw.php"));			
					} else {
						$_SESSION['fn'] = $row[1]." ".$row[2];
						$_SESSION['lg'] = $row[3];				
						$_SESSION['rl'] = $row[4];
						$_SESSION['fg'] = $row[5];
						$url = parse_url($_SERVER['HTTP_REFERER'])['path'];
						return json_encode(Array($_SESSION['lg'], $url));						
					}
				} else {
				}
			} else {
	// wrong password
				return json_encode(Array(0));
			}
		}
	// write log file	
		function writelog($qbn, $tpe, $frm, $txt, $new='', $old='') {
			if ($this->getoptions("writelogfiles", "set") =="yes") {
				global $rel_path;
	/*
	$qbn: Qcase number
	$tpe: log type (A=newly added, C=changed, D=deleted)
	$frm: input form
	$usr: who did the change, if not loged in use "SYSTEM"
	$txt: log text
	$new: new value or ""
	$old: old value or ""
	old and new are optional (have to be last in function call to be omitted
	**/	
				$myFile = $rel_path."log/".$qbn.".log";	
				$fh = fopen($myFile, 'a');
				$usr = (isset($_SESSION['lg']))?$_SESSION['lg']:"SYSTEM";
				fwrite($fh, date("Y-m-d H:i:s")."|".$tpe."|".$frm."|".$usr."|".$txt."|".$new."|".$old."\r\n");
				fclose($fh);
			}
		}		
	// return options array
		function saveoptions($loc) 
    {
      global $rel_path;
      $this->write_ini_file($rel_path.'templates/options.ini', $loc);
      return "Done";
    }
    
    function write_ini_file($file, $array = []) 
    {
      // process array
      $data = array();
      foreach ($array as $key => $val) {
        if (is_array($val)) {
          $data[] = "[$key]";
          foreach ($val as $skey => $sval) {
            if (is_array($sval)) {
              foreach ($sval as $_skey => $_sval) {
                if (is_numeric($_skey)) {
                  $data[] = $skey.'[] = '.(is_numeric($_sval) ? $_sval : (ctype_upper($_sval) ? $_sval : '"'.$_sval.'"'));
                } else {
                  $data[] = $skey.'['.$_skey.'] = '.(is_numeric($_sval) ? $_sval : (ctype_upper($_sval) ? $_sval : '"'.$_sval.'"'));
                }
              }
            } else {
              $data[] = $skey.' = '.(is_numeric($sval) ? $sval : (ctype_upper($sval) ? $sval : '"'.$sval.'"'));
            }
          }
        } else {
          $data[] = $key.' = '.(is_numeric($val) ? $val : (ctype_upper($val) ? $val : '"'.$val.'"'));
        }
        // empty line
        $data[] = null;
      }
      // open file pointer, init flock options
      $fp = fopen($file, 'w');
      $retries = 0;
      $max_retries = 100;

      if (!$fp) {
          return false;
      }

      // loop until get lock, or reach max retries
      do {
        if ($retries > 0) {
          usleep(rand(1, 5000));
        }
        $retries += 1;
      } while (!flock($fp, LOCK_EX) && $retries <= $max_retries);

      // couldn't get the lock
      if ($retries == $max_retries) {
        return false;
      }

      // got lock, write data
      fwrite($fp, implode(PHP_EOL, $data).PHP_EOL);

      // release lock
      flock($fp, LOCK_UN);
      fclose($fp);
      return true;
    }	
	// return options array
		function optionsarray() {
			global $rel_path;		
		// check if options available
			if (!(file_exists ($rel_path."templates/options.ini"))) {
				header("Location: ./error.php?r=nooptions");	// no options file available
			} else {
				$options = parse_ini_file($rel_path.'templates/options.ini', true);
				return $options;
			}
		}
	// return complete language settings
		function getLanguages() {
			global $rel_path;		
      $data = parse_ini_file($rel_path.'xml/languages.ini', true);
      return $data;
		}
	// return a colon separated string with all lang keys
		function getLanOnly() {
			global $rel_path;		
      $data = parse_ini_file($rel_path.'xml/languages.ini', true);
      $keys = array_keys($data);
      $data = implode(":", $keys);
      return $data;
		}
	// return material name field for language $opt
		function getLanMat($opt) {
			global $rel_path;		
      $data = parse_ini_file($rel_path.'xml/languages.ini', true);
      return $data[$opt]['mname'];
		}
	// return options settings
		function getoptions($opt, $opt1) {
			global $rel_path;		
		// check if options available
			if (!(file_exists ($rel_path."templates/options.ini"))) {
				header("Location: ./error.php?r=nooptions");	// no options file available
			} else {
        $options = parse_ini_file($rel_path.'templates/options.ini', true);
				return $options[$opt][$opt1]['value'];
			}
		}
		function checkteam($loc) {
			global $rel_path, $db;
			if ($this->getoptions("forceteam", "set") =="yes") {
				if ($this->getoptions('mandatoryteam', 'set') == "yes") {
					$query = "SELECT MANDARRAY FROM qb_man WHERE QBN=:qbn";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $loc
						)
					);			
					$mnd = json_decode($stmt->fetchColumn(), true);
					$status = 0;
					$newmnd = array();
					foreach ($mnd[0] as $key=>$value) {
						if ($value != 0) {
							$query = "SELECT IF (:key IN (SELECT SHORT FROM qb_user, qb_team, qb_mantrans WHERE NAME=LOGIN AND qb_user.DEPARTMENT=qb_mantrans.DEPARTMENT AND QBN=:qbn), 2, 1)";
							$stmt = $db->prepare($query);
							$stmt->execute(
								array(
									':qbn' => $loc,
									':key' => $key
								)
							);
							$status = $stmt->fetchColumn();
						}
						if ($status != 0) {
							$newmnd[] = $status;
							$status = 0;
						}
					}			
					$counts = array_count_values($newmnd);
					if (isset($counts['1'])) {
		// not all team members defined -> return false
						return false;
					} else {
		// not all team members defined -> check if they were informed
						$query = "SELECT COUNT(*) FROM qb_team WHERE QBN=:qbn AND ROLLE='MEMBER' AND INFORMED='0000-00-00 00:00:00'";
						$stmt = $db->prepare($query);
						$stmt->execute(
							array(
								':qbn' => $loc
							)
						);
						$count = $stmt->fetchColumn();
				// no, not all informed
						if ($count > 0) {
							return false;
				// yes, all informed
						} else {
							return true;
						}
					}
		// no mandatory team configured -> return true
				} else {
					return true;
				}
		// force team not set -> return true
			} else {
				return true;
			}
		}
		function makequery($jsonquery, $jsonrequest) {
	// restore original arrays
			$arrquery = json_decode($jsonquery, true);
			$arrrequest = json_decode($jsonrequest, true);		
			$querystr = "";
		// check if search
			if ($arrrequest['_search'] == "true") {
			// check if multifilter		
				if (isset($arrrequest['filters'])) {					
				// yes - assemble filter
					$reqarray = json_decode($arrrequest['filters'], true);			
					$conn = $reqarray['groupOp'];		// AND or OR ?
					$fltr = $reqarray['rules'];		// filtersettings
					
				// generate filter string
					$fltr2 = " HAVING ";					
					foreach ($fltr as $key=>$value) {
						switch ($value['op']) {
							case "cn":
								$fltr2 .= $value['field'] . " LIKE '%" . $value['data'] . "%' " . $conn . " ";
								break;
							case "nc":
								$fltr2 .= $value['field'] . " NOT LIKE '%" . $value['data'] . "%' " . $conn . " ";
								break;
							case "eq":
								$fltr2 .= $value['field'] . " = '" . $value['data'] . "' " . $conn . " ";
								break;
							case "ne":
								$fltr2 .= $value['field'] . " != '" . $value['data'] . "' " . $conn . " ";
								break;
							case "bw":
								$fltr2 .= $value['field'] . " LIKE '" . $value['data'] . "%' " . $conn . " ";
								break;
							case "bn":
								$fltr2 .= $value['field'] . " NOT LIKE '" . $value['data'] . "%' " . $conn . " ";
								break;
							case "ew":
								$fltr2 .= $value['field'] . " LIKE '%" . $value['data'] . "' " . $conn . " ";
								break;
							case "en":
								$fltr2 .= $value['field'] . " NOT LIKE '%" . $value['data'] . "' " . $conn . " ";
								break;											
						}								
					}
					$fltr2 = ($conn == "OR")?substr($fltr2, 0, -4):substr($fltr2, 0, -5);
				} else {
				// no -> remove overhead data
					$fltr = $arrrequest;
					unset ($fltr['routine']);
					unset ($fltr['_search']);
					unset ($fltr['rows']);
					unset ($fltr['page']);
					unset ($fltr['sidx']);
					unset ($fltr['sord']);
					unset ($fltr['nd']);
					unset ($fltr['sdat']);
					unset ($fltr['edat']);
					unset ($fltr['qblan']);
				// generate filter string
					$fltr2 = " HAVING ";					
					foreach ($fltr as $key=>$value) {
						$fltr2 .= $key . " LIKE '%" . $value . "%' AND ";
					}
					$fltr2 = substr($fltr2, 0, -5);
				}
			// assemble new query
				foreach($arrquery as $key=>$value) {
					$querystr .= $value . $fltr2 . " ";
				}				
			} else {
				foreach($arrquery as $key=>$value) {
					$querystr .= $value . " ";
				}
			}
			return $querystr;			// $querystr is bare query without limit ond order
		}
	// return default password
		function defaultpw() {
			global $db;
			$query = "SELECT DEFAULTPW FROM qb_conf";
			$stmt = $db->query($query);
			$row = $stmt->fetchColumn();
			return $row;
		}
	// check flags against parameter list
		function checkflag($request) 
		{	
			if (!isset($_SESSION['fg'])) return false;
			$checkagainst = str_split($_SESSION['fg']);
			$sumroles = str_split($request);
			return (count(array_intersect($sumroles, $checkagainst))) ? true : false;
		}
	// return main menu html
		function get_main_menu($active_menu) 
		{		
			global $db, $rel_path;
			$ini_mmenu = parse_ini_file($rel_path.'i18n/main_menu.ini', true);
			$ret = "<script>";
			$ret .= "mainmenuTranslation = {};";
			foreach($ini_mmenu as $key=>$value){
				$add = "";
				foreach($value AS $lan=>$trans){
					$add .= "'".$lan."':'".$trans."',";
				}
				$ret .= "mainmenuTranslation['".$key."']={".rtrim($add, ',')."};";
			}
			$ret .= "
				function translate_mainmenu(loc) {
					$.each($('#mainnav').find('li'), function() {
						var lichild = $(this).children()[0];
						if (lichild.tagName =='SPAN') {
							$(lichild).text(mainmenuTranslation[$(lichild).data('lan')][loc]);
						}
						if (lichild.tagName =='A') {
							$(lichild).text(mainmenuTranslation[$(lichild).data('lan')][loc]);
						}
					});
				}
			";
			$ret .= "</script>";
			$ret .= "<ul style='margin-left: 20px;'>";
	// check if no data in database
			$query = "SELECT * FROM qbi WHERE QBSTATUS<>'D' LIMIT 1";
		// yes, brand new database
			if ($this->emptydb()) {
				if ( $active_menu == 0) { 
					$ret .= "<li class='acl'><span data-type='span' data-lan='new_qb' data-nr='0' id='sel'>".$ini_mmenu['new_qb'][$_SESSION['lng']]."</span></li>";
				} else {
					$ret .= "<li><a data-type='a' data-lan='new_qb' data-nr='0' href='index.php'>".$ini_mmenu['new_qb'][$_SESSION['lng']]."</a></li>";
				}
			// admin menu for flag "YW"
				if ($this->checkflag("YW")) {
					if ( $active_menu == 4) {
						$ret .= "<li class='acl'><span data-type='span' data-lan='verwaltung' data-sr='1' data-nr='4' id='sel'>".$ini_mmenu['verwaltung'][$_SESSION['lng']]."</span></li>";
					} else {
						$ret .= "<li><a href='tasks.php' data-type='a' data-lan='verwaltung' data-sr='1' data-nr='4'>".$ini_mmenu['verwaltung'][$_SESSION['lng']]."</a></li>";
					}
				}
		// no, datasets available			
			} else {
			// data-sr: 1 = special menu
			// data-nr: active menu
				if ( $active_menu == 0) { 
					$ret .= "<li class='acl'><span data-type='span' data-lan='new_qb' data-sr='0' data-nr='0' id='sel'>".$ini_mmenu['new_qb'][$_SESSION['lng']]."</span></li>";
				} else {
					$ret .= "<li><a data-type='a' data-lan='new_qb' data-sr='0' data-nr='0' href='index.php'>".$ini_mmenu['new_qb'][$_SESSION['lng']]."</a></li>";
				} 
				if ( $active_menu == 1) { 
					$ret .= "<li class='acl'><span data-type='span' data-lan='edit_qb' data-sr='0' data-nr='1' id='sel'>".$ini_mmenu['edit_qb'][$_SESSION['lng']]."</span></li>";
				} else {
					$ret .= "<li><a data-type='a' data-lan='edit_qb' data-sr='0' data-nr='1' href='basic.php'>".$ini_mmenu['edit_qb'][$_SESSION['lng']]."</a></li>";
				}	
        if ( $active_menu == 2) { 
          $ret .= "<li class='acl'><span data-type='span' data-lan='reporting' data-sr='0' data-nr='2' id='sel'>".$ini_mmenu['reporting'][$_SESSION['lng']]."</span></li>";
        } else {
          $ret .= "<li><a href='analysis.php' data-type='a' data-lan='reporting' data-sr='0' data-nr='2' >".$ini_mmenu['reporting'][$_SESSION['lng']]."</a></li>";
        }
        if ($this->checkflag("C")) {
          if ( $active_menu == 3) { 
            $ret .= "<li class='acl'><span data-type='span' data-lan='costs' data-sr='1' data-nr='3' id='sel'>".$ini_mmenu['costs'][$_SESSION['lng']]."</span></li>";
          } else {
            $ret .= "<li><a href='a_costcont.php' data-type='a' data-lan='costs' data-sr='1' data-nr='3'>".$ini_mmenu['costs'][$_SESSION['lng']]."</a></li>";
          }					
        }
		// check for admin menu	
				if ($this->checkflag("YW")) {
					if ( $active_menu == 4) {
						$ret .= "<li class='acl'><span data-type='span' data-lan='verwaltung' data-sr='1' data-nr='4' id='sel'>".$ini_mmenu['verwaltung'][$_SESSION['lng']]."</span></li>";
					} else {
						$ret .= "<li><a href='tasks.php' data-type='a' data-lan='verwaltung' data-sr='1' data-nr='4'>".$ini_mmenu['verwaltung'][$_SESSION['lng']]."</a></li>";
					}
				}
		// check for svt / deputy menu
				if ($this->checkflag("VD")) {
					if ( $active_menu == 5) {
						$ret .= "<li class='acl'><span data-type='span' data-lan='s_conf' data-sr='1' data-nr='5' id='sel'>".$ini_mmenu['s_conf'][$_SESSION['lng']]."</span></li>";
					} else {
						$ret .= "<li><a href='svtcont.php' data-type='a' data-lan='s_conf' data-sr='1' data-nr='5'>".$ini_mmenu['s_conf'][$_SESSION['lng']]."</a></li>";
					}
				}
			}
			$ret .="</ul>";
			$ret .= "
				<script>
					$('#mainnav li').on('click', 'a', function(e){
						e.preventdefault;
            e.stopPropagation();
						\$hlink = $(this).attr('href');	
						if ($(this).attr('target')) {
							window.open(\$hlink, '_blank');
							return false;
						}
						if (\$data_changed) {
							$.alerts.okButton = mainmenuTranslation['next'][\$globlan];
							$.alerts.cancelButton = mainmenuTranslation['cancel'][\$globlan];
							jConfirm(mainmenuTranslation['break2'][\$globlan], mainmenuTranslation['attention'][\$globlan], function(r) {
								if (r) {
									window.location.href = \$hlink;
								}
							});
							return false;	
						} else {                           
							window.location.href = \$hlink;
							return false;	
						}
					});
				</script>
			";			
			return $ret;
		}
		function get_svt_menu($loc)
		{
	// return submenu
			global $rel_path;
			$ini_svtmenu = parse_ini_file($rel_path.'i18n/svt_menu.ini', true);
			$ret = "<script>";
			$ret .= "svtmenuTranslation = {};";
			foreach($ini_svtmenu as $key=>$value){
				$add = "";
				foreach($value AS $lan=>$trans){
					$add .= "'".$lan."':'".$trans."',";
				}
				$ret .= "svtmenuTranslation['".$key."']={".rtrim($add, ',')."};";
			}
			$ret .= "
				function translate_svtmenu(loc) {
					$.each($('#svtnav').find('li'), function() {	
						var lichild = $(this).children()[0];	
						$(lichild).text(svtmenuTranslation[$(lichild).data('lan')][loc]);
					});
				}
			";
			$ret .= "</script>";			
			$ret .= "<div id='svtnav'>";
			$ret .= "
				<ul class='qb_tabs'>
					<li><a data-pos='0' data-type='a' data-lan='sortimentscontrolling' href='svtcont' class='l'>".$ini_svtmenu['sortimentscontrolling'][$_SESSION['lng']]."</a></li>
					";
			if ($this->checkflag("V")) {
				$ret .= "
					<li><a data-pos='1' data-type='a' data-lan='my_svt' href='mysvt'>".$ini_svtmenu['my_svt'][$_SESSION['lng']]."</a></li>
					<li><a data-pos='2' data-type='a' data-lan='mail' href='svtmail'>".$ini_svtmenu['mail'][$_SESSION['lng']]."</a></li>
					<li><a data-pos='3' data-type='a' data-lan='my_dlz' href='svtdlz' class='l'>".$ini_svtmenu['my_dlz'][$_SESSION['lng']]."</a></li>
				";
			}				
			$ret .= "
				</ul>
			";
			$ret .= "
				<script>
					$('#svtnav ul.qb_tabs a[data-pos=\"".$loc."\"]').addClass('active');
					$('#svtnav ul.qb_tabs').each(function(){
					// click handling
						$(this).on('click', 'a', function(e){
							if ($(this).attr('href')+'.php' == '".basename($_SERVER["SCRIPT_FILENAME"])."') return false;
							window.location.href = $(this).attr('href')+'.php';
							return false;
						});
					});						
				</script>
			";
			return $ret;
		}		
		function get_sub_menu($loc)
		{
	// return submenu
			global $rel_path;
			$ini_mmenu = parse_ini_file($rel_path.'i18n/sub_menu.ini', true);
			$ret = "<script>";
			$ret .= "submenuTranslation = {};";
			foreach($ini_mmenu as $key=>$value){
				$add = "";
				foreach($value AS $lan=>$trans){
					$add .= "'".$lan."':'".$trans."',";
				}
				$ret .= "submenuTranslation['".$key."']={".rtrim($add, ',')."};";
			}
			$ret .= "
				function translate_submenu(loc) {
					$.each($('.qb_tabs').find('li'), function() {	
						var lichild = $(this).children()[0];	
						$(lichild).text(submenuTranslation[$(lichild).data('lan')][loc]);
					});
				}
			";
			$ret .= "</script>";
			$ret .= "
				<ul class='qb_tabs'>
					<li data-light='1'><a href='basic' data-type='a' data-lan='grunddaten' class='m' >".$ini_mmenu['grunddaten'][$_SESSION['lng']]."</a></li>
					<li data-light='1'><a href='team' data-type='a' data-lan='team' class='s'>".$ini_mmenu['team'][$_SESSION['lng']]."</a></li>
					<li data-light='0'><a href='immediate' data-type='a' data-lan='sofort' class='l'>".$ini_mmenu['sofort'][$_SESSION['lng']]."</a></li>
					<li data-light='0'><a href='fivewhy' data-type='a' data-lan='five_why' class='s'>".$ini_mmenu['five_why'][$_SESSION['lng']]."</a></li>
					<li data-light='1'><a href='definitive' data-type='a' data-lan='definitiv' >".$ini_mmenu['definitiv'][$_SESSION['lng']]."</a></li>
					<li data-light='0'><a href='implement' data-type='a' data-lan='umsetzung' class='m' >".$ini_mmenu['umsetzung'][$_SESSION['lng']]."</a></li>
					<li data-light='0'><a href='validate' data-type='a' data-lan='pruefung' >".$ini_mmenu['pruefung'][$_SESSION['lng']]."</a></li>
					<li data-light='1'><a href='close' data-type='a' data-lan='abschluss' class='m' >".$ini_mmenu['abschluss'][$_SESSION['lng']]."</a></li>	
					<li data-light='1'><a href='docmet' data-type='a' data-lan='documentation' class='s'>".$ini_mmenu['documentation'][$_SESSION['lng']]."</a></li>
				</ul>
			";
			$ret .= "
				<script>
					$('ul.qb_tabs').find('a').eq(".$loc.").addClass('active');
					$('ul.qb_tabs').each(function(){
					// click handling
						$(this).on('click', 'a', function(e){
							e.preventDefault();
							if ($(this).attr('href')+'.php' == '".basename($_SERVER["SCRIPT_FILENAME"])."') return false;
							\$hlink = $(this).attr('href')+'.php';
						// check if data was entered but not saved
							if (\$data_changed) {
								$.alerts.okButton = submenuTranslation['next'][\$globlan];
								$.alerts.cancelButton = submenuTranslation['cancel'][\$globlan];
								jConfirm(submenuTranslation['break2'][\$globlan], submenuTranslation['attention'][\$globlan], function(r) {
									if (r) {
										window.location.href = \$hlink;
									}
								});
								return false;	
							} else {
								window.location.href = \$hlink;
								return false;						
							}
						});
					});						
				</script>
			";
			return $ret;
		}
	// return doc menu html
		function get_doc_menu($loc) 
		{
			global $rel_path;
			$ini_docmenu = parse_ini_file($rel_path.'i18n/doc_menu.ini', true);
			$ret = "<script>";
			$ret .= "docmenuTranslation = {};";
			foreach($ini_docmenu as $key=>$value){
				$add = "";
				foreach($value AS $lan=>$trans){
					$add .= "'".$lan."':'".$trans."',";
				}
				$ret .= "docmenuTranslation['".$key."']={".rtrim($add, ',')."};";
			}
			$ret .= "
				function translate_docmenu(loc) {
					$.each($('#docnav').find('li'), function() {
						var lichild = $(this).children()[0];
						if (lichild.tagName =='A') {
							$(lichild).text(docmenuTranslation[$(lichild).data('lan')][loc]);
						}
					});
				}
			";			
			$ret .= "</script>";
			$ret .= "<div id='docnav'>";
			$ret .= "<ul class='qb_doc_tabs'>";
			$ret .= "<li><a data-type='a' data-lan='meetings' data-sr='0' href='docmet' id='l1' class='s'>".$ini_docmenu['meetings'][$_SESSION['lng']]."</a></li>";
			$ret .= "<li><a data-type='a' data-lan='doc_com' data-sr='0' href='doccom' id='l2'>".$ini_docmenu['doc_com'][$_SESSION['lng']]."</a></li>";
			$ret .= "<li><a data-type='a' data-lan='nacharbeit' data-sr='0' href='docrew' id='l3' >".$ini_docmenu['nacharbeit'][$_SESSION['lng']]."</a></li>";
			$ret .= "<li><a data-type='a' data-lan='meta' data-sr='0' href='docmeta' id='l4' >".$ini_docmenu['meta'][$_SESSION['lng']]."</a></li>";		
    // check if user has cost role		
      if ($this->checkflag("C")) {				
        $ret .= "<li><a data-type='a' data-lan='costs' data-sr='1' href='doccost' id='l6' class='s'>".$ini_docmenu['costs'][$_SESSION['lng']]."</a></li>";
      }
			$ret .= "</ul>";
			$ret .= "</div>";
			$ret .= "
				<script>
					$('ul.qb_doc_tabs #l".$loc."').addClass('active');				
					$('ul.qb_doc_tabs').each(function(){	
					// click handling
						$(this).on('click', 'a', function(e){
							if ($(this).attr('href')+'.php' == '".basename($_SERVER["SCRIPT_FILENAME"])."') return false;
							window.location.href = $(this).attr('href')+'.php';
							return false;
						});
					});
				</script>
			";
			return $ret;
		}						
	// return newest qb
		function getnewestqb() 
		{
			global $db;
			$stmt = $db->query("SELECT COUNT(*) FROM qbi WHERE QBSTATUS<>'D' AND QBSTATUS<>'M'");
			if ($stmt->fetchColumn() == 0) {
				return "";
			} else {
				$stmt = $db->query("SELECT QBN FROM qbi WHERE QBSTATUS<>'D' AND QBSTATUS<>'M' ORDER BY QBN DESC LIMIT 1");
				return $stmt->fetchColumn();
			}		
		}
	// return all qb data at once
		function getqbdata($loc) 
		{
			if ($loc == "") {
				$rows = array('id'=>'', 'text'=>'', 'status'=>'', 'bc'=>'', 'light'=>'', 'rtype'=>'', 'clss'=>'');
				return json_encode($rows);
			}			
			global $db;		
			$query = "
				SELECT 
					QBN, 
					QBSTATUS, 
					IF(LIGHT=1,' *',IF(TOP=1,' !','')), 
					IF(LIGHT=1,'L',IF(TOP=1,'T',IF(RTYPE='V','V',IF(RTYPE='R','R','N')))) AS BC, 
					LIGHT,
					RTYPE,
					CLSS
				FROM 
					qbi 
				WHERE 
					QBN=:qbn
			";	
			$stmt = $db->prepare($query);
			$stmt->execute(
				array(
					':qbn' => $loc
				)
			);
			$r = $stmt->fetch(PDO::FETCH_NUM);			
			$rows = array("id"=>$r[0], "text"=>$r[0] . $r[2], "status"=>$r[1], "bc"=>$r[3], "light"=>$r[4], "rtype"=>$r[5], "clss"=>$r[6]);
			return json_encode($rows);
		}			
	// return browser language or default
		function getbrowserlanguage() 
		{
      $browserlang = isset($_SERVER["HTTP_ACCEPT_LANGUAGE"])?substr($_SERVER["HTTP_ACCEPT_LANGUAGE"],0,2):$this->getOptions("fallbacklang", "set");
			$found = false;
			foreach(explode(":", $this->getLanOnly()) as $key=>$value) {
				if ($browserlang == $value) $found = true;
			}
			return (!$found)?$this->getOptions("fallbacklang", "set"):$browserlang;
		}	
    // mailing with templates
		function templatemail($mailtos, $subject, $message, $sender="", $source="", $cc="") 
		{
			global $timezone, $rel_path, $db, $Mail_Settings;
			date_default_timezone_set($timezone);
      
      require_once(PHPMAILERPATH.'Exception.php');   /* Exception class. */
      require_once(PHPMAILERPATH.'PHPMailer.php');   /* The main PHPMailer class. */
      require_once(PHPMAILERPATH.'SMTP.php');        /* SMTP class. */
      
    // prepare mailing class
      $mail = new PHPMailer();
      $mail->IsSMTP();                          // use SMTP
      $mail->SMTPDebug = 0;                     // debug level = 3 if needed
      $mail->SMTPAuth = true;                   // enable SMTP authentication
      $mail->SMTPOptions = array(               // settings needed for authenticated mailing
        'ssl' => array(
          'verify_peer' => false,
          'verify_peer_name' => false,
          'allow_self_signed' => true
        )
      );
      $mail->Host = $Mail_Settings['host'];
      $mail->Username = $Mail_Settings['username'];
      $mail->Password = $Mail_Settings['password'];
      $mail->Port = $Mail_Settings['mailport'];
    // if no sender is set get standard sender			
			if ($sender == "") {
				$query = "SELECT SENDERMAIL FROM qb_conf";
				$stmt = $db->query($query);
				$sender = $stmt->fetchColumn();
			}
      $mail->From = $sender;
      $mail->FromName = $sender;
      $mail->CharSet = 'utf-8';
      $mail->isHTML(true);
      $mail->AddAddress($mailtos);
      if ($cc != "") {
        foreach($cc as $key=>$value) {
          $mail->addCC($value);
        }
      }
      $mail->Subject = $subject;
      $mail->Body = $message;
//    $mail->AddAttachment("images/phpmailer.gif");             // attachment
      $error = "";
      if ($this->getoptions('mailing', 'useit') != "yes") {
        $mail->preSend();
      } else {
        if(!$mail->send()) {
          $error = 'Message could not be sent. Mailer Error: ' . $mail->ErrorInfo;
        } else {
          $error = 'Message has been sent';
        }
      }
			if ($this->getoptions('mailing', 'log') == "yes") {			
		// log mail for debugging
				$myFile2 = $rel_path."mail.txt";	
				$fh = fopen($myFile2, 'a');
				fwrite($fh, "********************************** @ " . date("Y-m-d H:i:s") . "**********************************\r\n");
        fwrite($fh, 'Status: ' . $error."\r\n");
				fwrite($fh, "Calling script: ".$source."\r\n");
				fwrite($fh, "To: ".$mailtos."\r\n");
				fwrite($fh, "Subject: ".$subject."\r\n");
				fwrite($fh, $message."\r\n");
				fclose($fh);
			} 
    }		
		function qbactivity($loc) {
			global $db;
			$query = "UPDATE qbi SET LAST=NOW() WHERE QBN=:qbn";
			$stmt = $db->prepare($query);
			$stmt->execute(
				array(
					':qbn' => $loc
				)
			);	
		}
		function ifplrej($loc) {
			global $db, $rel_path, $relili;
			$ini = parse_ini_file($rel_path.'i18n/implement.ini', true);	
		// inform pl that technical closure is not accepted by all team members
			$link = $relili . $loc;
			$query = "SELECT EMAIL, VORNAME, LANG FROM qb_user LEFT JOIN qb_team ON NAME=LOGIN WHERE QBN=:qbn AND ROLLE='PL'";
			$stmt = $db->prepare($query);
			$stmt->execute(array(':qbn' => $loc));
			$result = $stmt->fetch(PDO::FETCH_NUM );
		// load template file
			if ($result[2] == "") $result[2] = $this->getOptions('fallbacklang', 'set');
			$template = file_get_contents($rel_path."mail/".$result[2].".support.infoplrej.html");
			$template = str_replace('{{username}}', $result[1], $template);
			$template = str_replace('{{qbnummer}}', $loc, $template);
			$template = str_replace('{{qblink}}', $link, $template);
			preg_match('/<title>(.*)<\/title>/iU', $template, $subject);
			$subject = $ini["qbshort"][$result[2]].$loc.": ".$subject[1];
			$this->templatemail($result[0], $subject, $template, "", "support:ifplrej");
		}
		function stsvt($loc, $evnt) {		//$evnt is always E5 (at the moment)	
			global $db, $relili, $rel_path;
			$ini = parse_ini_file($rel_path.'i18n/implement.ini', true);	
		// load event text
			$ini_events = parse_ini_file($rel_path.'xml/events.ini', true);
			$link = $relili . $loc;
		// inform svt that a technical closure is requested
			$query = "SELECT EMAIL, VORNAME, LANG FROM qb_user, qbi WHERE QBN=:qbn AND SVT=LOGIN";
			$stmt = $db->prepare($query);
			$stmt->execute(array(':qbn' => $loc));
			$result = $stmt->fetch(PDO::FETCH_NUM );
		// load template file
			if ($result[2] == "") $result[2] = $this->getOptions('fallbacklang', 'set');
			$template = file_get_contents($rel_path."mail/".$result[2].".support.infosvt_tc.html");
			$template = str_replace('{{username}}', $result[1], $template);
			$template = str_replace('{{qbnummer}}', $loc, $template);
			$template = str_replace('{{qblink}}', $link, $template);
			preg_match('/<title>(.*)<\/title>/iU', $template, $subject);
			$subject = $ini["qbshort"][$result[2]].$loc.": ".$subject[1];
			$this->templatemail($result[0], $subject, $template, "", "support:infosvt_tc");	
		}
		function qb_weight($loc) {
			global $db;
	// return QB weight
	// L - light
	// T - Top
	// N - Normal
	//
			$query = "SELECT IF(LIGHT=1,'L',IF(TOP=1,'T',IF(RTYPE='V','V','N'))) FROM qbi WHERE QBN=:qbn";	
			$query = "SELECT LIGHT FROM qbi WHERE QBN=:qbn";
			$stmt = $db->prepare($query);
			$stmt->execute(
				array(
					':qbn' => $loc
				)
			);
			$row = $stmt->fetch(PDO::FETCH_NUM );
			return $row[0];
		}
		function progress($qbn) {
			global $db, $debug;
		// return width for progress bar (in % )
			$query = "SELECT QBSTATUS, SVT FROM qbi WHERE QBN=:qbn";
			$stmt = $db->prepare($query);
			$stmt->execute(
				array(
					':qbn' => $qbn
				)
			);	
			$row = $stmt->fetch(PDO::FETCH_NUM );
			switch($row[0]) {
				case "N":
					if ($row[1] == 0) {
		// new QB and no SVT assigned --> 5% green
						return 5;
					} else {
		// new QB and SVT assigned -> 15% green
						return 15;
					}
				break;
				case "O":
		// SVT & PL assigned but not technically closed yet, 25% green
					return 25;
				break;
				case "S":
		// case solved check if closure request sent to GQ
					$query = "SELECT CL_DATE FROM qb_close WHERE QBN=:qbn";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $qbn
						)
					);	
					$row_count = $stmt->rowCount();	
					if ($row_count > 0) {
		// entry in close table, check if closure was accepted by SVT
						$result = $stmt->fetchAll(PDO::FETCH_NUM );		
						$row = $result[0];
						if ($row[0] == "0000-00-00") {
			// no, not accepted, return 55%
							return 55;
						} else {
			// yes, accepted, waitung for closure by GQ, return 95%
							return 95;
						}
					} else {
		// no entry in close table -> 55% green
						return 55;
					}
				break;
				case "C":
		// case closed, 100% green
					return 100;
				break;
			}
		}
		function event_mail2($evnt, $qbn) {			// $evnt = event; $qbn = QB number
			global $db, $relili, $rel_path;		
			$ini = parse_ini_file($rel_path.'i18n/implement.ini', true);
		// load event text
			$ini_events = parse_ini_file($rel_path.'xml/events.ini', true);
			$link = $relili . $qbn;	
		// check if admins want to receive mails
			$query = "SELECT COUNT(*) FROM qb_mail";	
			$stmt = $db->query($query);
			$result = $stmt->fetch(PDO::FETCH_NUM );		
			$row = $result[0];
			$mailto = array();
		// yes
			if ($row > 0) {			
				$query = "
					SELECT
						EMAIL, 
						REGIONS, 
						EVENTS, 
						LANG 
					FROM 
						qb_mail 
					LEFT JOIN 
						qb_user 
					ON 
						ADDRESS=LOGIN
				";
				$stmt = $db->query($query);
				while($row = $stmt->fetch(PDO::FETCH_NUM)) {		
				// check if event mail is requested
					$evtmp = explode(":", $row[2]);					
					if (in_array($evnt, $evtmp)) {				
				// define regions array
						$regarray = explode(":", $row[1]);
				// yes, get region of requestor
						$query2 = "SELECT REGION FROM qb_user, qbbasic WHERE REQ=LOGIN AND QBN=:qbn";
						$stmt2 = $db->prepare($query2);
						$stmt2->execute(array(':qbn' => $qbn));
						$row2 = $stmt2->fetch(PDO::FETCH_NUM );		
						$result2 = $row2[0];					
					// check if region is included in mail request
						if (in_array($result2, $regarray)) {
							if ($row[3] == "") $row[3] = $this->getOptions('fallbacklang', 'set');
							if (!array_key_exists($row[3], $mailto)) $mailto[$row[3]] = "";
							$mailto[$row[3]] .= $row[0].", ";
						}				
					}
				}		
			}			
	// special mailing for SVTs which have deputies
		// 1st check if case was delegated
			$query = "SELECT DELEGATE FROM qbi WHERE QBN=:qbn";
			$stmt = $db->prepare($query);
			$stmt->execute(array(':qbn' => $qbn));
			$row = $stmt->fetch(PDO::FETCH_NUM );
			if ($row[0] != '') {
		// so this SVT is a deputy - check if SVT wants to have an extra mailing
				$query = "SELECT COUNT(*), COALESCE(EVENTS, '') FROM qb_svtmail WHERE SVT=:svt";
				$stmt = $db->prepare($query);
				$stmt->execute(array(':svt' => $row[0]));	
				$row2 = $stmt->fetch(PDO::FETCH_NUM );
				if ($row2[0] > 0) {
					$evtmp = explode(":", $row2[1]);
					if (in_array($evnt, $evtmp)) {
			// yes, SVT want mailing for this event						
						$query = "SELECT EMAIL, LANG from qb_user WHERE LOGIN=:lgi";
						$stmt = $db->prepare($query);
						$stmt->execute(array(':lgi' => $row[0]));
						$row3 = $stmt->fetch(PDO::FETCH_NUM );
						if ($row3[1] == "") $row3[1] = $this->getOptions('fallbacklang', 'set');
						if (!array_key_exists($row3[1], $mailto)) $mailto[$row3[1]] = "";
						$mailto[$row3[1]] .= $row[0].", ";
					}
				}
			}			
	// check if requestor wants to keep track
			$query = "SELECT REQINFO, REQ FROM qbbasic WHERE QBN=:qbn";		
			$stmt = $db->prepare($query);
			$stmt->execute(array(':qbn' => $qbn));
			$row = $stmt->fetch(PDO::FETCH_NUM );
		// yes he want, check if he is interested in this event
			if (strlen($row[0]) > 0) {
				$info = explode(":", $row[0]);				
		// yes -> inform him
				if (in_array($evnt, $info)) {
					$query = "SELECT EMAIL, LANG from qb_user WHERE LOGIN=:lgi";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':lgi' => $row[1]
						)
					);					
					$row = $stmt->fetch(PDO::FETCH_NUM );
					if ($row[1] == "") $row[1] = $this->getOptions('fallbacklang', 'set');
					if (!array_key_exists($row[1], $mailto)) $mailto[$row[1]] = "";
					$mailto[$row[1]] .= $row[0].", ";
				}
			}		
	// check if anyone else wants to keep track	
			$query = "
				SELECT 
					(SELECT EMAIL FROM qb_user WHERE LOGIN=qb_trackmail.EMAIL) AS EMAIL, 
					EVENTS, 
					(SELECT LANG FROM qb_user WHERE LOGIN=qb_trackmail.EMAIL) AS LANG
				FROM 
					qb_trackmail 
				WHERE 
					QBN=:qbn
			";	
			$stmt = $db->prepare($query);
			$stmt->execute(array(':qbn' => $qbn));
			$row_count = $stmt->rowCount();			
			if ($row_count > 0) {
				while($row = $stmt->fetch(PDO::FETCH_NUM)) {
					$info = explode(":", $row[1]);
					if (in_array($evnt, $info)) {
						if ($row[2] == "") $row[2] = $this->getOptions('fallbacklang', 'set');
						if (!array_key_exists($row[2], $mailto)) $mailto[$row[2]] = "";
						$mailto[$row[2]] .= $row[0].", ";
					}
				}
			}		
			foreach($mailto as $key=>$value) {
			// load template file
				$template = file_get_contents($rel_path."mail/".$key.".support.eventmail.html");
				$template = str_replace('{{qbnummer}}', $qbn, $template);
				$template = str_replace('{{qblink}}', $link, $template);
				$template = str_replace('{{event}}', $ini_events[$evnt][$key], $template);
				$title = $qbn.": ".$ini_events[$evnt][$key];
				$subject = $ini["qbshort"][$key].$title;
				$recipients = rtrim($value, ", ");
				$this->templatemail($recipients, $subject, $template, "", "support:eventmail:".$evnt);
			}
		}
	// returns QB status
		function qb_status($loc) {
			global $db;		
			$query = "SELECT QBSTATUS FROM qbi WHERE QBN=:qbn";
			$stmt = $db->prepare($query);
			$stmt->execute(
				array(
					':qbn' => $loc
				)
			);
			$result = $stmt->fetchColumn();
			return $result;
		}
	// returns QB r_type
		function qb_rtype($loc) {
			global $db;		
			$query = "SELECT RTYPE FROM qbi WHERE QBN=:qbn";
			$stmt = $db->prepare($query);
			$stmt->execute(
				array(
					':qbn' => $loc
				)
			);
			$result = $stmt->fetchColumn();
			return $result;
		}
	}
?>