<!DOCTYPE html>
<html>
<head>
	<meta http-equiv="X-UA-Compatible" content="IE=Edge" />
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />	
	<?php include_once(dirname(__FILE__)."/tools/all_header.php"); global $c_scheme, $timezone, $rel_path; ?>
	<script>
		var js_debug = false;
		$data_changed = false;		
	</script>
	
    <title>Supplier Tracking</title>

	<link rel="stylesheet" href="./css/qb.php" />
	<link rel="stylesheet" href="./jqGrid_5.2.1/css/ui.jqgrid.css" />	
	
	<style>
		.ui-jqgrid tr.jqgrow td{
			white-space:nowrap;
			height: 18px !important;
		}
		#pager_left{
			padding-top: 5px;
		}			

		.ui-state-hover, .ui-widget-content .ui-state-hover, .ui-widget-header .ui-state-hover,
		.ui-state-focus, .ui-widget-content .ui-state-focus, .ui-widget-header .ui-state-focus
		{
			border: 0 none;
		}			
	</style>
	
	<script src="./jquery/jquery.min.js"></script>
	<script src="./jquery/jquery-migrate-1.2.1.min.js"></script>	
	<script src="./jquery/jquery-ui.min.js"></script>
	<script src="./jquery/qb_js.js"></script>
	
	<?php 
		foreach(explode(":", $qb_support->getLanOnly()) as $key=>$value) {
			echo '<script src="./jqGrid_5.2.1/js/i18n/grid.locale-' . $value . '.js"></script>';
		}
	?>
	<script src="./jqGrid_5.2.1/js/jquery.jqGrid.min.js"></script>	

	<script>
	// load translation and save in localTranslation
		<?php	
			$ini_suptrack = parse_ini_file($rel_path.'i18n/suptrack.ini', true);	
			echo "localTranslation = {};";
			foreach($ini_suptrack as $key=>$value){
				$add = "";
				foreach($value AS $lan=>$trans){
					$add .= "'".$lan."':'".$trans."',";
				}
				echo "localTranslation['".$key."']={".rtrim($add, ',')."};";
			}
		?>
	</script>
</head>
<body>
	<div id="container">
		<?php 
			include_once($rel_path.'tools/header.php');
		?> 
		<div id="contents">
			<?php 
				echo "<div id='mainnav'>". $qb_support->get_main_menu(2) . "</div>";
			?>
			<div class="dtop">
				<span class="icn3_arraoleft_w_n clckbtn" style="float: left; font-size: 30px; margin-left: 5px;" data-type="title" data-lan="prev" title="<?php echo $ini_suptrack['prev'][$_SESSION['lng']]; ?>" onclick="backtoanalysis()"></span>
				<span data-type="text" data-lan="supplier_track"><?php echo $ini_suptrack['supplier_track'][$_SESSION['lng']]; ?></span>
			</div>
			<div style="display: inline-block; margin-left: 10px;">
				<table id="list"></table> 
				<div id="pager"></div> 
			</div>
		</div>
		<?php include_once($rel_path.'/footer.php'); ?>
	</div>
	<script>
		var rowsToColor = [];

		function load_page() {	
			start_search();
		}
		function c_lan() {
			translate_header($globlan);	
			translate_mainmenu($globlan);
			$.each($('#container *').filter(function(){return $(this).data('lan') !== undefined;}), function() {	
				switch ($(this).data("type")) {
					case "text":		
						$(this).text(localTranslation[$(this).data("lan")][$globlan]);
						break;
					case "title":				
						$(this).attr("title", localTranslation[$(this).data("lan")][$globlan]);
						break;
					case "date":
						$(this).val(localizedate($($(this).data("lan")).val()));
						break;						
				}
			});		
			$.jgrid.setRegional('list',{regional: $globlan});
			$("#list").jqGrid('setLabel', "creditor", localTranslation["creditor"][$globlan])
				.jqGrid('setLabel', "supplier", localTranslation["supplier"][$globlan])
				.jqGrid('setLabel', "track", localTranslation["set"][$globlan]);

			$("#toggle_track_list").attr("title", localTranslation["toggle"][$globlan]);
			$("#gs_track").find("option").each(function(idx, obj) {	
				if ($(this).val() == "") {
					$(this).text(localTranslation["all"][$globlan]);
				} else if ($(this).val() == "1") {
					$(this).text(localTranslation["set"][$globlan]);
				} else {
					$(this).text(localTranslation["notset"][$globlan]);
				}
			});			
		}
		function backtoanalysis() {
			window.location.href="analysis.php";
		}
		function TrackFormatter(cellvalue, options, rowObject) {
			if (cellvalue == "1") {
				rowsToColor[rowsToColor.length] = options.rowId;
				return "<span class='icn_warning_r_n'></span>";
			} else {
				return "";
			}
		}
		function start_search() {
			$("#loading").show();
			cmTemplate = {
				editable: false,			
				sorttype:'string',
				searchoptions: {
					sopt:['cn'], 
					clearSearch: false
				}
			};
			obj = {
				url:  "./tools/suptrack_api.php",
				postData: {routine : "getlist"},
				contentType: "application/json",
				datatype: "json",
				jsonReader: {
					id: "id",
					repeatitems: true
				},
				mtype: "POST",
				colNames: [
					localTranslation["creditor"][$globlan],
					localTranslation["supplier"][$globlan],
					localTranslation["set"][$globlan]
				],
				colModel: [
					{ 
						name: "creditor", 
						template: cmTemplate,
						width: 150
					},
					{ 
						name: "supplier",
						template: cmTemplate,
						width: 700
					},
					{ 
						name: "track", 
						template: cmTemplate,
						width: 90,
						stype: 'select',
						searchoptions:
						{
							value: ":"+localTranslation['all'][$globlan]+";1:"+localTranslation['set'][$globlan]+";0:"+localTranslation['notset'][$globlan]
						},
						formatter: TrackFormatter,
						align: "center"
					}					
				],
				regional: $globlan,
				storeNavOptions: true,			
				loadonce: false,
				pager: "#pager",
				height: 510,
				rowNum: 100,
				rowList: [10, 100, 500, 1000, 1500],
				hoverrows: false,
				rownumbers: true,
				sortname: "track",
				sortorder: "desc",
				viewrecords: true,
				gridview: true,
				autoencode: true,
				ignoreCase:true,
				loadui: "block",
				loadComplete: function() {
					$("th[role='columnheader']")
						.unbind("mouseenter")
						.unbind("mouseleave");
						
					for (var i = 0; i < rowsToColor.length; i++) {
						$("#" + rowsToColor[i]).find("td").css("color", "<?php echo $c_scheme['IW']; ?>").css("font-weight", "bold");
					}			
				},
				gridComplete: function(data) {
					$(".ui-search-toolbar input[role='textbox']")
						.css("width", "92%")
						.css("background", "<?php echo $c_scheme['M5']; ?>")
						.css("padding", "2px");
					$(".ui-search-toolbar select[role='select']")
						.removeClass("ui-corner-all")
						.css("background", "<?php echo $c_scheme['M5']; ?>")
						.css("padding", "2px");						
					 custbtns();
				}			
			};
			list1 = $("#list").jqGrid(obj)
				.jqGrid('filterToolbar',{searchOperators : false, searchOnEnter: false})
				.jqGrid('navGrid', '#pager', {refresh: false, search: false, edit: false, del: false, add: false});
			$("#loading").hide();
		}
		function custbtns() {
			$("#list").jqGrid('navButtonAdd',"#pager",{	
					caption:"",
					id:"toggle_track_list",
					buttonicon:"ui-icon-transferthick-e-w", 
					onClickButton: function(){
						selRowId = $("#list").jqGrid ('getGridParam', 'selrow');
						if (selRowId == null) {
							jAlert(localTranslation["alerttext"][$globlan], localTranslation["attention"][$globlan]);	
							return false;							
						} else {			
							$.ajax({
								type: "POST",
								cache: false,
								url:  "./tools/suptrack_api.php",
								data: { 
									routine: "track",
									track: ($("#list").jqGrid ('getCell', selRowId, 'track').length == 0)?1:0,
									creditor: $.trim($("#list").jqGrid ('getCell', selRowId, 'creditor'))
								},
								success: function(result)
								{
									rowsToColor = [];
									$("#list").setGridParam({datatype:'json'}).trigger('reloadGrid');
								}
							});
						}
					}, 
					position: "last", 
					title: localTranslation["toggle"][$globlan], 
					cursor: "default"
				});
			$("#toggle_track_list div").empty().html("<span class='icn_exchange_b_n clckbtn'></span>");
			$("#toggle_track_list").removeClass("ui-pg-button");
			
			$("#pager_left .ui-separator").parent().remove();				
		}
		load_page();
	</script>
</body>
</html>