<!DOCTYPE html>
<html>
<head>
	<meta http-equiv="X-UA-Compatible" content="IE=Edge" />
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />	
	<?php 
		include_once(dirname(__FILE__)."/tools/all_header.php"); 
		global $c_scheme, $timezone, $rel_path;
		if (!$qb_support->checkflag("YW")) header("Location: basic.php");
	?>	
	<script>
		var js_debug = false;
		$data_changed = false;		
	</script>
	
    <title>SVT History</title>
	
	<link rel="stylesheet" href="./css/qb.php" />
	<link rel="stylesheet" href="./jqGrid_5.2.1/css/ui.jqgrid.css" />
	
	<style>
		.ui-jqgrid tr.jqgrow td{
			white-space:nowrap;
			height: 18px !important;
		}
		#pager_left{
			padding-top: 5px;
		}
	</style>
	
	<script src="./jquery/jquery.min.js"></script>
	<script src="./jquery/jquery-migrate-1.2.1.min.js"></script>	
	<script src="./jquery/jquery-ui.min.js"></script>
	<script src="./jquery/qb_js.js"></script>
	
	<?php 
		foreach(explode(":", $qb_support->getLanOnly()) as $key=>$value) {
			echo '<script src="./jqGrid_5.2.1/js/i18n/grid.locale-' . $value . '.js"></script>';
		}
	?>
	<script src="./jqGrid_5.2.1/js/jquery.jqGrid.min.js"></script>	

	<script>
	// load translation and save in localTranslation
		<?php	
			$ini_svtschange = parse_ini_file($rel_path.'i18n/svtchange.ini', true);	
			echo "localTranslation = {};";
			foreach($ini_svtschange as $key=>$value){
				$add = "";
				foreach($value AS $lan=>$trans){
					$add .= "'".$lan."':'".$trans."',";
				}
				echo "localTranslation['".$key."']={".rtrim($add, ',')."};";
			}
		?>
	</script>
</head>
<body>
	<div id="container">
		<?php 
			include_once($rel_path.'tools/header.php');
		?> 
		<div id="contents">
			<?php 
				echo "<div id='mainnav'>". $qb_support->get_main_menu(4) . "</div>";
			?>
			<div class="dtop">
				<?php include_once($rel_path.'html/systemmenu.php');	?>		
				<span data-type="sspan" data-lan="history"><?php echo $ini_svtschange['history'][$_SESSION['lng']]." ".$ini_svtschange['svt'][$_SESSION['lng']]; ?></span>
			</div>
			<div class="tabs_container">
				<div style="margin-left: 5px;" >
					<table id="list"></table> 
					<div id="pager"></div>
				</div>
			</div>
		</div>
		<?php include_once($rel_path.'/footer.php'); ?> 
	</div>
	<script>
		function load_page() {
			fill_grid();
		}	
	// switch language
		function c_lan() {
			translate_header($globlan);	
			translate_mainmenu($globlan);
			translate_system($globlan);
			$.each($('#container *').filter(function(){return $(this).data('lan') !== undefined;}), function() {			
				switch ($(this).data("type")) {
					case "text":		
						$(this).text(localTranslation[$(this).data("lan")][$globlan]);
						break;
					case "title":				
						$(this).attr("title", localTranslation[$(this).data("lan")][$globlan]);
						break;
					case "date":
						$(this).val(localizedate($($(this).data("lan")).val()));
						break;
					case "sspan":
						$(this).text(localTranslation["history"][$globlan]+" "+localTranslation["svt"][$globlan]);
						break;			
				}
			});	
			$.jgrid.setRegional('list',{regional: $globlan});
			$("#list").jqGrid('setLabel', "qbn", localTranslation["qbn"][$globlan])
				.jqGrid('setLabel', "changedate", localTranslation["date"][$globlan])
				.jqGrid('setLabel', "oldsvt", localTranslation["old_svt"][$globlan])
				.jqGrid('setLabel', "newsvt", localTranslation["new_svt"][$globlan])
				.jqGrid('setLabel', "changer", localTranslation["changed_by"][$globlan]);				
		}	
		function fill_grid() {
			$("#loading").show();
			cmTemplate = {
				editable: false,
				sorttype:'string',
				searchoptions: {
					sopt:['cn'], 
					clearSearch: false
				}
			};
			obj = {
				url:  "./tools/svtchange_api.php",
				postData: {routine : "show"},
				contentType: "application/json",
				datatype: "json",
				jsonReader: {
					id: "id",
					repeatitems: true
				},
				mtype: "POST",
				colNames: [
					localTranslation["qbn"][$globlan],
					localTranslation["date"][$globlan],
					localTranslation["old_svt"][$globlan],
					localTranslation["new_svt"][$globlan],
					localTranslation["changed_by"][$globlan]
				],
				colModel: [
					{ 
						name: "qbn", 
						template: cmTemplate,
						width: 100
					},
					{ 
						name: "changedate", 
						template: cmTemplate,
						width: 150
					},
					{
						name: "oldsvt", 
						template: cmTemplate,
						width: 230
					},
					{ 
						name: "newsvt",
						template: cmTemplate,
						width: 230
					},
					{ 
						name: "changer", 
						template: cmTemplate,
						width: 230
					}					
				],
				regional: $globlan,
				storeNavOptions: true,			
				loadonce: false,
				pager: "#pager",
				recordpos: "left",
				height: 510,
				rowNum: 100,
				rowList: [10, 100, 500, 1000, 1500],
				hoverrows: false,
				rownumbers: true,
				sortname: "qbn",
				sortorder: "desc",
				viewrecords: true,
				gridview: true,
				autoencode: true,
				ignoreCase:true,
				loadui: "block",
				loadComplete: function() {
					$("th[role='columnheader']")
						.unbind("mouseenter")
						.unbind("mouseleave");
				},
				gridComplete: function(data) {
					$(".ui-search-toolbar input[role='textbox']")
						.css("width", "92%")
						.css("background", "<?php echo $c_scheme['M5']; ?>")
						.css("padding", "2px");	
				}			
			};
			list1 = $("#list").jqGrid(obj)
				.jqGrid('filterToolbar',{searchOperators : false, searchOnEnter: false})
				.navGrid('#pager', {refresh: false, search: false, edit: false, del: false, add: false});
			$("#loading").hide();
		}
		load_page();
	</script>
</body>
</html>
