<!DOCTYPE html>
<html>
<head>
	<meta http-equiv="X-UA-Compatible" content="IE=Edge" />
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />	
	<?php 
		include_once(dirname(__FILE__)."/tools/all_header.php"); 
		global $c_scheme, $timezone, $rel_path;
		if ($qb_support->checkflag("V") === false) header("Location: basic.php");
	?>
	<script>
		var js_debug = false;
		$data_changed = false;	
	</script>
	
    <title>SVT DLZ</title>
	
	<link rel="stylesheet" href="./css/qb.php" />
	<link rel="stylesheet" href="./jqplot/jquery.jqplot.css" />	
	
	<script src="./jquery/jquery.min.js"></script>
	<script src="./jquery/jquery-migrate-1.2.1.min.js"></script>	
	<script src="./jquery/jquery-ui.min.js"></script>
	<script src="./jquery/qb_js.js"></script>
	
	<script src="./jqplot/jquery.jqplot.min.js"></script>
	<script src="./jqplot/plugins/jqplot.barRenderer.min.js"></script>
	<script src="./jqplot/plugins/jqplot.pieRenderer.min.js"></script>
	<script src="./jqplot/plugins/jqplot.categoryAxisRenderer.min.js"></script>
	<script src="./jqplot/plugins/jqplot.boxplotRenderer.js"></script>
	<script src="./jqplot/plugins/jqplot.highlighter.min.js"></script>
	<script src="./jqplot/plugins/jqplot.pointLabels.min.js"></script>
    <script src="./jqplot/plugins/jqplot.canvasTextRenderer.min.js"></script>
    <script src="./jqplot/plugins/jqplot.canvasAxisLabelRenderer.min.js"></script>
	<script src="./jqplot/plugins/jqplot.enhancedLegendRenderer.min.js"></script>
    <script src="./jqplot/plugins/jqplot.canvasAxisTickRenderer.min.js"></script>
	<script src="./jqplot/plugins/jqplot.canvasOverlay.min.js"></script>

	<?php
		$query = "
			SELECT 
				DATE_FORMAT(NOW(), '%Y-%m-%d'), 
				DATEDIFF(MAX(QBREGDATE), NOW()), 
				DATEDIFF(MIN(QBREGDATE), NOW()),
				MIN(QBREGDATE),
				MAX(QBREGDATE),
				IF (DATEDIFF(MAX(QBREGDATE), MIN(QBREGDATE)) > 365, DATE_SUB(MAX(QBREGDATE), INTERVAL 365 DAY), MIN(QBREGDATE))
			FROM 
				qbi 
			WHERE 
				QBSTATUS NOT IN ('M', 'D')
		";
		$stmt = $db->query($query);
		list($now, $diffmax, $diffmin, $min, $max, $lmin) = $stmt->fetch(PDO::FETCH_NUM );
	?>
	<script>
	// load translation and save in localTranslation
		<?php	
			$ini_svtdlz = parse_ini_file($rel_path.'i18n/svtdlz.ini', true);	
			echo "localTranslation = {};";
			foreach($ini_svtdlz as $key=>$value){
				$add = "";
				foreach($value AS $lan=>$trans){
					$add .= "'".$lan."':'".$trans."',";
				}
				echo "localTranslation['".$key."']={".rtrim($add, ',')."};";
			}
			$cal = parse_ini_file($rel_path.'i18n/calendar.ini', true);
			echo "calTranslation = {};";
			foreach($cal as $key=>$value){
				$add = "";
				if ($value['tpe'] == "S") {
					foreach($value AS $lan=>$trans){
						if ($lan != "tpe") $add .= "'".$lan."':'".$trans."',";
					}
				} else {
					foreach($value AS $lan=>$trans){
						if ($lan != "tpe") {
							$tar = explode(",", $trans);
							$tar = implode("','", $tar);
							$add .= "'".$lan."': ['".$tar."'],";
						}
					}				
				}
				echo "calTranslation['".$key."']={".rtrim($add, ',')."};";
			}
		?>
	</script>
</head>
<body>
	<div id="container">
		<?php 
			include_once($rel_path.'tools/header.php');
		?> 
		<div id="contents">
			<?php 
				echo "<div id='mainnav'>". $qb_support->get_main_menu(5) . "</div>";
			?>
			<div class="dtop">
				<span data-type="text" data-lan="dlz"><?php echo $ini_svtdlz['dlz'][$_SESSION['lng']]; ?></span>
			</div>
			<?php echo $qb_support->get_svt_menu(3); ?>
			<div id="docscontainer" style="margin: 2px; margin-top: 0; height: 560px;">
				<div id="btn_div" class="btn_div" style="height: 555px;">
					<label class="dlabel vam w50" data-type="text" data-lan="start" ><?php echo $ini_svtdlz['start'][$_SESSION['lng']]; ?></label>
					<input type="text" id="sdat" data-type="date" data-lan="#sdat_org" class="dinputw vam w75" value="" onchange="update_chart()" readonly />
					<input type="hidden" id="sdat_org" value="" />
					<input type="hidden" id="sdat_i" value="" />
					<br style="margin: 10px 0;" />
					<label class="dlabel vam w50" data-type="text" data-lan="ende" ><?php echo $ini_svtdlz['ende'][$_SESSION['lng']]; ?></label>
					<input type="text" id="edat" data-type="date" data-lan="#edat_org" class="dinputw vam w75" value="" onchange="update_chart()" readonly />
					<input type="hidden" id="edat_org" value="" />
					<input type="hidden" id="edat_i" value="" />
					<br />
					<div style="text-align: center; margin-top: 30px;">
						<span class="spanbuttonps" id="n2tb" data-type="text" data-lan="n2t" onclick="n2t()"><?php echo $ini_svtdlz['n2t'][$_SESSION['lng']]; ?></span>
						<span class="spanbuttonp" id="t2cb" data-type="text" data-lan="t2c" onclick="t2c()"><?php echo $ini_svtdlz['t2c'][$_SESSION['lng']]; ?></span>
						<span class="spanbuttonp" id="n2cb" data-type="text" data-lan="n2c" onclick="n2c()"><?php echo $ini_svtdlz['n2c'][$_SESSION['lng']]; ?></span>
						<?php if ($qb_support->getoptions('qblight', 'set') == "yes") { ?>
							<span class="spanbuttonp" id="n2clb" data-type="text" data-lan="n2cl" onclick="n2cl()"><?php echo $ini_svtdlz['n2cl'][$_SESSION['lng']]; ?></span>
						<?php } ?>
					</div>
				</div>						
				<div style="border: 0px solid green; display: inline-block; vertical-align: top; margin: 0; padding: 0; padding-top: 25px;">
					<div id="chartdiv" style="display: inline-block; vertical-align: top; height:530px; width:800px; margin: 0;"></div>
				</div>
			</div>
		</div>
		<?php include_once($rel_path.'footer.php'); ?> 
	</div>
	<script>
		pickerOpts = {
			closeText: "X",		
			dateFormat: "yy-M-dd",
			altField: '#sdat_org',
			altFormat: 'yy-mm-dd',
			firstDay: 1,
			isRTL: false,
			showButtonPanel: true,
			displayClose: true,
			showOn: "button",  
			buttonImage: "./img/dummy_img.png", 
			buttonImageOnly: true,
			buttonText: localTranslation["cal"][$globlan],
			changeYear: true,
			changeMonth: true,
			maxDate: "+<?php echo $diffmax;?>d",
			minDate: "-<?php echo $diffmin;?>d"		
		}
		pickerOpts_2 = {
			closeText: "X",		
			dateFormat: "yy-M-dd",
			altField: '#edat_org',
			altFormat: 'yy-mm-dd',
			firstDay: 1,
			isRTL: false,
			showButtonPanel: true,
			displayClose: true,
			showOn: "button",  
			buttonImage: "./img/dummy_img.png", 
			buttonImageOnly: true,
			buttonText: localTranslation["cal"][$globlan],
			changeYear: true,
			changeMonth: true,
			maxDate: "+<?php echo $diffmax;?>d",
			minDate: "-<?php echo $diffmin;?>d"	
		}		
				
	// fix um bei klicken auf "Heute" den Kalender zu schliessen	
		var old_goToToday = $.datepicker._gotoToday;
		$.datepicker._gotoToday = function(id) {
			old_goToToday.call(this,id);   
			this._selectDate(id);
			$heute = true;
		};
			
		$("#sdat").datepicker(pickerOpts);
		clkevnt = $("#sdat").next().data('events').click[0].handler;
		$("#sdat").next().replaceWith('<span class="ui-datepicker-trigger icn_calendar_b_n clckbtn vam" data-type="title" data-lan="cal" title="<?php echo $ini_svtdlz['cal'][$_SESSION['lng']]; ?>"> </span>');
		$("#sdat").next().bind('click', clkevnt);		
		$("#edat").datepicker(pickerOpts_2);
		clkevnt = $("#edat").next().data('events').click[0].handler;
		$("#edat").next().replaceWith('<span class="ui-datepicker-trigger icn_calendar_b_n clckbtn vam" data-type="title" data-lan="cal" title="<?php echo $ini_svtdlz['cal'][$_SESSION['lng']]; ?>"> </span>');
		$("#edat").next().bind('click', clkevnt);
	
		$('#chartdiv').bind('jqplotDataClick',
			function (ev, seriesIndex, pointIndex, data) {
				(plot1.options.seriesDefaults.rendererOptions.dataLabels == 'percent')?qbqbl('value'):qbqbl('percent');
			}
		);
		
		function load_page() {
			$("#sdat").val(localizedate("<?php echo $lmin; ?>"));
			$("#edat").val(localizedate("<?php echo $max; ?>"));
			$("#sdat_org").val("<?php echo $lmin; ?>");
			$("#edat_org").val("<?php echo $max; ?>");
			$("#sdat_i").val("<?php echo $lmin; ?>");			// min start date
			$("#edat_i").val("<?php echo $max; ?>");			// max end date	
			n2t();
		}
	// switch language
		function c_lan() {
			translate_header($globlan);	
			translate_mainmenu($globlan);
			translate_svtmenu($globlan);
			$.each($('#container *').filter(function(){return $(this).data('lan') !== undefined;}), function() {	
				switch ($(this).data("type")) {
					case "text":		
						$(this).text(localTranslation[$(this).data("lan")][$globlan]);
						break;
					case "title":				
						$(this).attr("title", localTranslation[$(this).data("lan")][$globlan]);
						break;
					case "date":
						$(this).val(localizedate($($(this).data("lan")).val()));
						break;						
				}
			});
			if (typeof(plot1) !== 'undefined') {
				plot1.replot({
					axes:{
						yaxis:{
							label: localTranslation['count'][$globlan]
						},
						xaxis:{
							label: localTranslation['days'][$globlan]
						}
					}
				});
			}
		}
		function getmax2(loc) {	
			var t = loc[0];
			$(loc).each (function (i,n){		
				if ((n[1]*1)>(t[1]*1)) t=n;			
			});
			return t[1];
		}
		function n2cl() {
			$("#loading").show();
		// change highlighted button
			$("#btn_div span[data-type='text']").removeClass("spanbuttonps").addClass("spanbuttonp");
			$("#n2clb").addClass("spanbuttonps");
			$("#chartdiv").empty().attr("data-chart", "n2cl");
			$.ajax({
				type: "GET",
				cache: false,
				url:  "./tools/svtdlz_api.php",
				data: { 
					routine: "n2cl",
					from: $("#sdat_org").val(),
					to: $("#edat_org").val(),
					login: $("#aroleinfo").data("login")
				},
				dataType: "json",
				success: function(qbresult)
				{
					if (qbresult.length == 0) {
						$("#chartdiv").append('<p data-type="text" data-lan="no_data" style="text-align: center; font: bold 11pt Arial; color: <?php echo $c_scheme['IW']; ?>;margin-top: 130px;">'+localTranslation["no_data"][$globlan]+'</p>');
						$("#loading").hide();
					} else {			
						$marker = 0;
						$.each(qbresult, function(i){			
							if (qbresult[i][0] <= 14) $marker = (i + 1);
						});				
						optionObj = {
							captureRightClick: true,
							axes:{
								yaxis:{
									min:0, 
									max: (getmax2(qbresult)*1)*1.2,
									tickOptions: {formatString: '%d'},
									label: localTranslation['count'][$globlan],
									labelRenderer: $.jqplot.CanvasAxisLabelRenderer,
									labelOptions:{
										angel: 90,
										textColor: "<?php echo $c_scheme['GT']; ?>"
									}							
								},
								xaxis:{
									min:0, 
									max: qbresult.length,
									tickOptions: {formatString: '%d'},					
									renderer:$.jqplot.CategoryAxisRenderer,
									label: localTranslation['days'][$globlan]
								}
							},
							highlighter: { show: false },
							grid: 
							{         
								gridLineWidth: 2.5,         
								gridLineColor: '<?php echo $c_scheme['GG']; ?>',         
								drawGridlines: true,
								shadow:false, 
								borderWidth:1.0,
								background: '<?php echo $c_scheme['GB']; ?>'
							},					
							seriesDefaults:{
								renderer:$.jqplot.BarRenderer,
								rendererOptions: {
									highlightMouseOver: false,
									barWidth: 30,
									shadowDepth: 0,
									varyBarColor: true
								},
								pointLabels: { 
									show: true, 
									location: 'n', 
									ypadding: 2 
								}					
							},
							canvasOverlay: {             
								show: true,             
								objects: [ 
									{dashedVerticalLine: {                     
										name: 'limit1',                     
										x: $marker,                     
										lineWidth: 3,                     
										yOffset: '14',
										xOffset: '14',
										color: '<?php echo $c_scheme['GT']; ?>',
										shadow: false                
									}}, 								
								]
							},						
							seriesColors: [ "<?php echo $c_scheme['G1']; ?>", "<?php echo $c_scheme['G2']; ?>"]
						};
						plot1 = $.jqplot('chartdiv', [qbresult], optionObj);
						$("#loading").hide();
					}
				}
			});			
		}	
		function t2c() {
			$("#loading").show();
		// change highlighted button
			$("#btn_div span[data-type='text']").removeClass("spanbuttonps").addClass("spanbuttonp");
			$("#t2cb").addClass("spanbuttonps");	
			$("#chartdiv").empty().attr("data-chart", "t2c");
			$.ajax({
				type: "GET",
				cache: false,
				url:  "./tools/svtdlz_api.php",
				data: { 
					routine: "t2c",
					from: $("#sdat_org").val(),
					to: $("#edat_org").val(),
					login: $("#aroleinfo").data("login")
				},
				dataType: "json",
				success: function(qbresult)
				{
					if (qbresult.length == 0) {
						$("#chartdiv").append('<p data-type="text" data-lan="no_data" style="text-align: center; font: bold 11pt Arial; color: <?php echo $c_scheme['IW']; ?>;margin-top: 130px;">'+localTranslation["no_data"][$globlan]+'</p>');
						$("#loading").hide();
					} else {
						optionObj = {
							captureRightClick: true,
							axes:{
								yaxis:{
									autoscale: true,
									min:0, 
									max: getmax2(qbresult)*1.2,
									tickOptions: {formatString: '%d'},
									label: localTranslation['count'][$globlan],
									labelRenderer: $.jqplot.CanvasAxisLabelRenderer,
									labelOptions:{
										angel: 90,
										textColor: "<?php echo $c_scheme['GT']; ?>"
									}							
								},
								xaxis:{
									min:0, 
									max: qbresult.length,
									tickOptions: {formatString: '%d'},					
									renderer:$.jqplot.CategoryAxisRenderer,
									label: localTranslation['days'][$globlan]
								}
							},
							highlighter: { show: false },
							grid: 
							{         
								gridLineWidth: 2.5,         
								gridLineColor: '<?php echo $c_scheme['GG']; ?>',         
								drawGridlines: true,
								shadow:false, 
								borderWidth:1.0,
								background: '<?php echo $c_scheme['GB']; ?>'
							},					
							seriesDefaults:{
								renderer:$.jqplot.BarRenderer,
								rendererOptions: {
									highlightMouseOver: false,
									barWidth: 30,
									shadowDepth: 0,
									varyBarColor: true
								},
								pointLabels: { 
									show: true, 
									location: 'n', 
									ypadding: 2 
								}					
							},
							seriesColors: [ "<?php echo $c_scheme['G1']; ?>", "<?php echo $c_scheme['G2']; ?>"]
						};
						plot1 = $.jqplot('chartdiv', [qbresult], optionObj);
						$("#loading").hide();
					}
				}
			});			
		}		
		function n2c() {
			$("#loading").show();
		// change highlighted button
			$("#btn_div span[data-type='text']").removeClass("spanbuttonps").addClass("spanbuttonp");
			$("#n2cb").addClass("spanbuttonps");
			$("#chartdiv").empty().attr("data-chart", "n2c");
			$.ajax({
				type: "GET",
				cache: false,
				url:  "./tools/svtdlz_api.php",
				data: { 
					routine: "n2c",
					from: $("#sdat_org").val(),
					to: $("#edat_org").val(),
					login: $("#aroleinfo").data("login")
				},
				dataType: "json",
				success: function(qbresult)
				{
					if (qbresult.length == 0) {
						$("#chartdiv").append('<p data-type="text" data-lan="no_data" style="text-align: center; font: bold 11pt Arial; color: <?php echo $c_scheme['IW']; ?>;margin-top: 130px;">'+localTranslation["no_data"][$globlan]+'</p>');
						$("#loading").hide();
					} else {					
						optionObj = {
							captureRightClick: true,
							axes:{
								yaxis:{
									min:0, 
									max: (getmax2(qbresult)*1)*1.2,
									tickOptions: {formatString: '%d'},
									label: localTranslation['count'][$globlan],
									labelRenderer: $.jqplot.CanvasAxisLabelRenderer,
									labelOptions:{
										angel: 90,
										textColor: "<?php echo $c_scheme['GT']; ?>"
									}							
								},
								xaxis:{
									min:0, 
									max: qbresult.length,
									tickOptions: {formatString: '%d'},					
									renderer:$.jqplot.CategoryAxisRenderer,
									label: localTranslation['days'][$globlan]
								}
							},
							highlighter: { show: false },
							grid: 
							{         
								gridLineWidth: 2.5,         
								gridLineColor: '<?php echo $c_scheme['GG']; ?>',         
								drawGridlines: true,
								shadow:false, 
								borderWidth:1.0,
								background: '<?php echo $c_scheme['GB']; ?>'
							},					
							seriesDefaults:{
								renderer:$.jqplot.BarRenderer,
								rendererOptions: {
									highlightMouseOver: false,
									barWidth: 30,
									shadowDepth: 0,
									varyBarColor: true
								},
								pointLabels: { 
									show: true, 
									location: 'n', 
									ypadding: 2 
								}					
							},
							seriesColors: [ "<?php echo $c_scheme['G1']; ?>", "<?php echo $c_scheme['G2']; ?>"]
						};
						plot1 = $.jqplot('chartdiv', [qbresult], optionObj);
						$("#loading").hide();
					}
				}
			});			
		}	
		function n2t() {
			$("#loading").show();
		// change highlighted button
			$("#btn_div span[data-type='text']").removeClass("spanbuttonps").addClass("spanbuttonp");
			$("#n2tb").addClass("spanbuttonps");	
			$("#chartdiv").empty().attr("data-chart", "n2t");
			$.ajax({
				type: "GET",
				cache: false,
				url:  "./tools/svtdlz_api.php",
				data: { 
					routine: "n2t",
					from: $("#sdat_org").val(),
					to: $("#edat_org").val(),
					login: $("#aroleinfo").data("login")
				},
				dataType: "json",
				success: function(qbresult)
				{
					if (qbresult.length == 0) {
						$("#chartdiv").append('<p data-type="text" data-lan="no_data" style="text-align: center; font: bold 11pt Arial; color: <?php echo $c_scheme['IW']; ?>;margin-top: 130px;">'+localTranslation["no_data"][$globlan]+'</p>');
						$("#loading").hide();
					} else {
						$marker = 0;
						$.each(qbresult, function(i){			
							if (qbresult[i][0] <= 14) $marker = (i + 1);
						});
						max_y = Math.max.apply(Math,qbresult); 				
						optionObj = {
							captureRightClick: true,
							axes:{
								yaxis:{
									autoscale: true,
									min:0, 
									max: getmax2(qbresult)*1.1,
									tickOptions: {formatString: '%d'},
									label:  localTranslation['count'][$globlan],
									labelRenderer: $.jqplot.CanvasAxisLabelRenderer,
									labelOptions:{
										angel: 90,
										textColor: "<?php echo $c_scheme['GT']; ?>"
									}							
								},
								xaxis:{
									min:0, 
									max: qbresult.length,
									tickOptions: {formatString: '%d'},					
									renderer:$.jqplot.CategoryAxisRenderer,
									label: localTranslation['days'][$globlan]
								}
							},
							highlighter: { show: false },
							grid: 
							{         
								gridLineWidth: 2.5,         
								gridLineColor: '<?php echo $c_scheme['GG']; ?>',         
								drawGridlines: true,
								shadow:false, 
								borderWidth:1.0,
								background: '<?php echo $c_scheme['GB']; ?>'
							},
							canvasOverlay: {             
								show: true,             
								objects: [ 
									{dashedVerticalLine: {                     
										name: 'limit1',                     
										x: $marker,                     
										lineWidth: 3,                     
										yOffset: '14',
										xOffset: '14',
										color: '<?php echo $c_scheme['XN']; ?>',
										shadow: false                
									}}, 								
								]
							},
							seriesDefaults:{
								renderer:$.jqplot.BarRenderer,
								rendererOptions: {
									highlightMouseOver: false,
									barWidth: 30,
									shadowDepth: 0,
									varyBarColor: true
								},
								pointLabels: { 
									show: true, 
									location: 'n', 
									ypadding: 2 
								}					
							},
							seriesColors: [ "<?php echo $c_scheme['G1']; ?>", "<?php echo $c_scheme['G2']; ?>"]
						};
						plot1 = $.jqplot('chartdiv', [qbresult], optionObj);
						$("#loading").hide();
					}
				}
			});			
		}
		function update_chart(){
			fn = $("#chartdiv").data("chart");
			switch (fn) {
				case "n2t":
					n2t();
				break;
				case "t2c":
					n2t();
				break;
				case "t2cl":
					n2cl();
				break;
				case "n2c":
					n2c();
				break;			
			}			
		}
		load_page();
	</script>		
</body>
</html>