<!DOCTYPE html>
<html>
<head>
	<meta http-equiv="X-UA-Compatible" content="IE=Edge" />
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />	
	<?php 
		include_once(dirname(__FILE__)."/tools/all_header.php"); 
		global $c_scheme, $timezone, $rel_path;
		if ($qb_support->checkflag("V") === false) header("Location: basic.php");
	?>	
	<script>
		var js_debug = false;
		$data_changed = false;	
	</script>
	
    <title>SVT Mail</title>
	
	<link rel="stylesheet" href="./css/qb.php" />
	
	<style>
		#evnts > div.checkList {
			height:auto !important;
		}
	</style>
	
	<script src="./jquery/jquery.min.js"></script>
	<script src="./jquery/jquery-migrate-1.2.1.min.js"></script>	
	<script src="./jquery/jquery-ui.min.js"></script>
	<script src="./jquery/qb_js.js"></script>

	<script>
	// load translation and save in localTranslation
		<?php	
			$ini_svtmail = parse_ini_file($rel_path.'i18n/svtmail.ini', true);	
			echo "localTranslation = {};";
			foreach($ini_svtmail as $key=>$value){
				$add = "";
				foreach($value AS $lan=>$trans){
					$add .= "'".$lan."':'".$trans."',";
				}
				echo "localTranslation['".$key."']={".rtrim($add, ',')."};";
			}
			$ini_events = parse_ini_file($rel_path.'xml/events.ini', true);	
			echo "eventTranslation = {};";
			foreach($ini_events as $key=>$value){
				$add = "";
				foreach($value AS $lan=>$trans){
					$add .= "'".$lan."':'".$trans."',";
				}
				echo "eventTranslation['".$key."']={".rtrim($add, ',')."};";
			}			
		?>
	</script>
</head>
<body>
	<div id="container">
		<?php 
			include_once($rel_path.'tools/header.php');
		?> 
		<div id="contents">
			<?php 
				echo "<div id='mainnav'>". $qb_support->get_main_menu(5) . "</div>";
			?>
			<div class="dtop">
				<span data-type="text" data-lan="mail"><?php echo $ini_svtmail['mail'][$_SESSION['lng']]; ?></span>
			</div>
			<?php echo $qb_support->get_svt_menu(2); ?>
			<div id="docscontainer" style="margin: 2px; margin-top: 0; height: 560px;">
				<p data-type="text" data-lan="svt_event" style="margin: 0; margin-top: 20px; padding: 0; background-color: <?php echo $c_scheme['M1']; ?>; padding: 2px; text-align: center; font: bold 12pt Arial; color: <?php echo $c_scheme['M5']; ?>;"><?php echo $ini_svtmail['svt_event'][$_SESSION['lng']]; ?></p>
				<p data-type="text" data-lan="svt_sense" style="text-align: center; font: normal 8pt Arial; margin: 0; padding: 4px 0px 10px 0px;;"><?php echo $ini_svtmail['svt_sense'][$_SESSION['lng']]; ?></p>
<!--  section for events -->
				<div style="width: 480px; margin: auto;">
					<div id="evnts" style="display: inline-block; vertical-align: top; margin: auto; margin-top: 20px; border: 1px solid <?php echo $c_scheme['IO']; ?>; overflow-y: scroll; height: 350px; padding: 2px; width: 470px; font: normal 9pt Arial;'"></div>	
				</div>
			</div>
		</div>
		<?php include_once($rel_path.'footer.php'); ?>		
	</div>
	<script>
		$('#evnts').checkList({
			effect: 'none',
			ckall: false,
			tfilter: false,
			colopts: 1,
			altrows: true,
			prefix: "ev",
			tdhigh: "<?php echo $c_scheme['I3']; ?>",
			evenrow: "<?php echo $c_scheme['IE']; ?>",
			oddrow: "<?php echo $c_scheme['IO']; ?>",
			cbbgr: "<?php echo $c_scheme['XI']; ?>",
			onChange: function(loc) {
				if (typeof loc != "undefined") {
					$sellist = $('#evnts').checkList("getSelection");
					$newevnt = "";
					$.each($sellist, function(key, value) {
						$newevnt += value['value'] + ":";
					});
					$newevnt = $newevnt.slice(0, -1);
					$.ajax({
						type: "POST",
						cache: false,
						url:  "./tools/svtmail_api.php",
						data: { 
							routine: "setevents",
							login: $("#aroleinfo").data("login"),
							evnt: $newevnt
						},
						success: function(result)
						{
						}
					});
				}
				return false;			
			}				
		});	
		function c_lan() {
			translate_header($globlan);	
			translate_mainmenu($globlan);
			translate_svtmenu($globlan);
			$.each($('#container *').filter(function(){return $(this).data('lan') !== undefined;}), function() {			
				switch ($(this).data("type")) {
					case "text":		
						$(this).text(localTranslation[$(this).data("lan")][$globlan]);
						break;
					case "title":				
						$(this).attr("title", localTranslation[$(this).data("lan")][$globlan]);
						break;
					case "date":
						$(this).val(localizedate($($(this).data("lan")).val()));
						break;						
				}
			});
			$.each($("#evnts").find("tr"), function() {
				$(this).find("td:eq(1) label").text(eventTranslation[$(this).find("td:eq(0) span").data("help")][$globlan]);
			});		
		}
		function load_page() {
			fill_events();		
		}
	// fill event list
		function fill_events() {
			var $evtlist = new Array();
			var $i = 0;
			$.each(eventTranslation, function($key, $value) {
				$evtlist[$i] = {'text': $value[$globlan], 'value': $key, 'help': $key};
				$i++;
			});
			$('#evnts').checkList('setData', $evtlist);	
			$("#loading").show();
			$.ajax({
				type: "GET",
				cache: false,
				url:  "./tools/svtmail_api.php",
				data: { 
					routine: "getdetails",
					login: $("#aroleinfo").data("login")
				},
				dataType: "json",
				success: function(result)
				{
					if (result) {
						var $evts = result['EVENTS'].split(":");
					// work on events
						$('#evnts').checkList("resetAll");
						$.each($evts, function(key, value) {
							$('#evnts').checkList("setSelection", value);
						});	
					}
					$("#loading").hide();				
				}
			});
		}
		load_page();
	</script>
</body>
</html>