<!DOCTYPE html>
<html>
<head>
	<meta http-equiv="X-UA-Compatible" content="IE=Edge" />
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />	
	<?php 
		include_once(dirname(__FILE__)."/tools/all_header.php"); 
		global $c_scheme, $timezone, $rel_path;
		if ($qb_support->checkflag("YW") === false) header("Location: basic.php");
	?>	
	<script>
		var js_debug = false;
		$data_changed = false;
	</script>
	
    <title>Tasks</title>
	
	<link rel="stylesheet" href="./css/qb.php" />
	<link rel="stylesheet" href="./jqGrid_5.2.1/css/ui.jqgrid.css" />

	<style>
		.highlight
		{
			background: <?php echo $c_scheme['I2']; ?> !important;
		}
		.highlight td
		{
			color: <?php echo $c_scheme['M5']; ?> !important;
		}
		.ui-jqgrid tr.jqgrow td {
			white-space:nowrap;
			height: 18px !important;
		}
		.ui-state-hover, .ui-widget-content .ui-state-hover, .ui-widget-header .ui-state-hover,
		.ui-state-focus, .ui-widget-content .ui-state-focus, .ui-widget-header .ui-state-focus
		{
			border: 0 none;
		}
	</style>
	
	<script src="./jquery/jquery.min.js"></script>
	<script src="./jquery/jquery-migrate-1.2.1.min.js"></script>	
	<script src="./jquery/jquery-ui.min.js"></script>
	<script src="./jquery/qb_js.js"></script>
	
	<?php 
		foreach(explode(":", $qb_support->getLanOnly()) as $key=>$value) {
			echo '<script src="./jqGrid_5.2.1/js/i18n/grid.locale-' . $value . '.js"></script>';
		}
	?>
	<script src="./jqGrid_5.2.1/js/jquery.jqGrid.min.js"></script>

	<script>
	// load translation and save in localTranslation
		<?php	
			$ini_tasks = parse_ini_file($rel_path.'i18n/tasks.ini', true);	
			echo "localTranslation = {};";
			foreach($ini_tasks as $key=>$value){
				$add = "";
				foreach($value AS $lan=>$trans){
					$add .= "'".$lan."':'".$trans."',";
				}
				echo "localTranslation['".$key."']={".rtrim($add, ',')."};";
			}
		?>
	</script>		
</head>
<body>
	<div id="container">
		<?php 
			include_once($rel_path.'tools/header.php');
		?> 
		<div id="contents">
			<?php 
				echo "<div id='mainnav'>". $qb_support->get_main_menu(4) . "</div>";
			?>
			<div class="dtop">
				<?php include_once($rel_path.'html/systemmenu.php'); ?>
				<span data-type="text" data-lan="tasks"><?php echo $ini_tasks['tasks'][$_SESSION['lng']]; ?></span>
			</div>
			<div class="tabs_container">
				<div style="margin: 0;">
					<table id="list"></table> 
					<div id="pager"></div>
				</div>
				<hr />
				<div style="width: 500px; margin: auto;">			
					<table id="list2"></table> 
					<div id="pager2"></div>
				</div>
				<hr />
				<div style="width: 100%;">
					<label data-type="text" data-lan="next_update" class="dlabel"><?php echo $ini_tasks['next_update'][$_SESSION['lng']]; ?></label>
					<label class="dlabel w20" style="text-align: right; font-weight: bold; color:<?php echo $c_scheme['XH']; ?>;" id="to">60</label>
					<label data-type="text" data-lan="sec" class="dlabel"><?php echo $ini_tasks['sec'][$_SESSION['lng']]; ?></label>
				</div>				
			</div>
		</div>
		<?php include_once($rel_path.'footer.php'); ?> 
	</div>
	<script>
		var rowsToColor = [];
		
		function load_page() {
			fill_grid();
			fill_grid1();
		}
		function c_lan(loc) {
			translate_header($globlan);	
			translate_mainmenu($globlan);
			translate_system($globlan) 
			$.each($('#container *').filter(function(){return $(this).data('lan') !== undefined;}), function() {			
				switch ($(this).data("type")) {
					case "text":		
						$(this).text(localTranslation[$(this).data("lan")][$globlan]);
						break;
					case "title":				
						$(this).attr("title", localTranslation[$(this).data("lan")][$globlan]);
						break;
					case "date":
						$(this).val(localizedate($($(this).data("lan")).val()));
						break;						
				}
			});

			$.jgrid.setRegional('list',{regional: $globlan});
			$("#list").jqGrid('setLabel', "qbn", localTranslation["qbn"][$globlan])
				.jqGrid('setLabel', "svt", localTranslation["svt"][$globlan])
				.jqGrid('setLabel', "req", localTranslation["ireq"][$globlan])
				.jqGrid('setLabel', "tgr", localTranslation["imat"][$globlan])
				.jqGrid('setLabel', "tgrbz", localTranslation["imatname"][$globlan]);
			$("#edit_list").attr("title", localTranslation["asis"][$globlan]);
			$("#mail_list").attr("title", localTranslation["nfsvt"][$globlan]);
			
			$.jgrid.setRegional('list2',{regional: $globlan});
			$("#list2").jqGrid('setLabel', "qbn", localTranslation["qbn"][$globlan])
				.jqGrid('setLabel', "svt", localTranslation["svt"][$globlan])
				.jqGrid('setLabel', "clss", localTranslation["clss"][$globlan]);	
			$("#goto_list").attr("title", localTranslation["fcz"][$globlan]);
		}
		function ToolTipCellFormatter (cellvalue, options, rowObject) {
			if (cellvalue == "") {
				return "";
			} else {
				return "<span class='icn_info_be_n hlpcrsr' title='"+$("<span>"+cellvalue+"</span>").text()+"'></span>";
			}
		}	
		function custbtns() {
			$("#edit_list div").empty().html("<span class='icn_edit_b_n clckbtn'></span>");
			$("#edit_list").removeClass("ui-pg-button");
			$("#edit_list").next().removeClass("ui-pg-button ui-state-disabled");		
		}
		function fill_grid() {
			oldsvt = "";
			$("#loading").show();
			cmTemplate = {
				editable: false,		
				sorttype:'string',		
				searchoptions: {
					sopt:['cn'], 
					clearSearch: false
				}
			};
			obj = {
				url:  "./tools/tasks_api.php",
				postData: {
					routine : "listsvt",
					qblan: $globlan
				},
				contentType: "application/json",
				datatype: "json",
				jsonReader: {
					id: "id",
					repeatitems: false
				},
				mtype: "POST",
				colNames: [
					localTranslation["qbn"][$globlan],
					localTranslation["svt"][$globlan],
					localTranslation["ireq"][$globlan],
					localTranslation["imat"][$globlan],
					localTranslation["imatname"][$globlan],
					"",
					""
				],
				colModel: [
					{ 
						name: "qbn", 
						width: 100, 
						template: cmTemplate
					},
					{ 
						name: "svt", 
						width: 170 , 
						template: cmTemplate,
						editable: true,
						edittype:'select',
						editoptions:
						{
							size: "1",
							value:
							{
								<?php
									$query = "
										SELECT 
											LOGIN,
											CONCAT(NACHNAME, ', ', VORNAME) AS NAME
										FROM 
											qb_user 
										WHERE 
											FLAGS LIKE '%V%' 
										ORDER BY 
											NACHNAME
									";
									$stmt = $db->query($query);	
									$selopt = "'':'',";
									while($row = $stmt->fetch(PDO::FETCH_NUM)) {
										$selopt.="'".$row[0]."':'".addslashes($row[1])."',";
									}
									echo trim($selopt, ",");
								?>
							},
							dataInit: function(elem) {
								$(elem).width(150);
							}
						},					
					},
					{
						name: "req", 
						width: 170,
						template: cmTemplate
					},
					{ 
						name: "tgr", 
						width: 170, 
						template: cmTemplate
					},
					{ 
						name: "tgrbz", 
						width: 300 , 
						template: cmTemplate
					},
					{
						name: "des", 
						width: 25,
						template: cmTemplate,
						search: false,
						formatter: ToolTipCellFormatter,
						align: "center"
					},
					{ 
						name: "lgin",  
						template: cmTemplate,
						hidden: true
						
					},				
				],
				regional: $globlan,
				storeNavOptions: true,			
				loadonce: true,
				pager: "#pager",
				height: 200,
				rowNum: 100,
				rownumbers:true,
				sortname: "qbn",
				sortorder: "asc",
				viewrecords: true,
				pgbuttons: false,
				pginput: false,
				rowList: [],
				hoverrows: false,
				gridview: true,
				autoencode: true,
				ignoreCase:true,
				loadui: "block",
				onRightClickRow: function (rowid, iRow, iCol, e) {
					$deluser = $("#list").jqGrid('getRowData',$("#list").jqGrid('getGridParam','selrow'));
					window.sessionStorage.setItem("qb", $deluser['qbn']);
					$.ajax({
						url: "./tools/general_api.php",
						data: {
							routine: "get_qbs",
							qbn: $deluser['qbn']
						},
						success: function(result) {
							window.sessionStorage.setItem("qbn", result.substring(1, result.length-1));				
							window.location.href="basic.php";
							return false;
						}		
					});					
					return false;
				},
				loadComplete: function() {
					$("th[role='columnheader']")
						.unbind("mouseenter")
						.unbind("mouseleave");

					$(".ui-separator").remove();
				},
				gridComplete: function(data) {
					custbtns();
				},
				editurl: "./tools/tasks_api.php"		
			};	
			editSettings = {
				recreateForm:true,
				jqModal:true,
				modal: true,
				reloadAfterSubmit: true,
				closeOnEscape:false,
				savekey: [false,13],
				closeAfterEdit:true,
				zIndex:1000,
				width: 400,
				viewPagerButtons:false,
				beforeShowForm: function(form) {
			// center edit form
					var parentWidth = $(window).width();
					var parentHeight = $(window).height();
					var dlgDiv = $("#editmodlist");
					var dlgWidth = dlgDiv.width();
					var dlgHeight = dlgDiv.height();
					dlgDiv[0].style.top = Math.round((parentHeight-dlgHeight)/2) + "px";
					dlgDiv[0].style.left = Math.round((parentWidth-dlgWidth)/2) + "px";
					$deluser = $("#list").jqGrid('getRowData',$("#list").jqGrid('getGridParam','selrow'));
					oldsvt = $deluser['lgin'];
				},
				ajaxEditOptions:{ contentType:"application/json" },
				mtype:'POST',
				beforeSubmit: function (postdata, formid) {
					if (oldsvt == postdata["svt"]) {
						return[false, localTranslation["same_svt"]][$globlan];
					} else {
						window.sessionStorage.setItem("qb", $("#list").jqGrid ('getCell', $("#list").jqGrid ('getGridParam', 'selrow'), 'qbn'));
						return[true, ""]; 
					}
				},
				serializeEditData:function (data) {
					$deluser = $("#list").jqGrid('getRowData',$("#list").jqGrid('getGridParam','selrow'));
					data["routine"] = "savesvt";
					data["osvt"] = oldsvt;
					data["qbn"] = $deluser['qbn'];
					return JSON.stringify(data);
				},
				onClose: function() {
					$("#list").setGridParam({datatype:'json'}).trigger('reloadGrid');
				}	
			};			
			list1 = $("#list").jqGrid(obj)
				.navGrid('#pager', 
					{
						refresh: false, 
						search: false, 
						add: false, 
						del: false,
						edittitle: localTranslation["asis"][$globlan]
					}, editSettings, {}, {});			
			$("#loading").hide();
		}
		function InfoCellFormatter (cellvalue, options, rowObject) {
			if (cellvalue == "0") {
				return "";
			} else if (cellvalue == "1") {
				rowsToColor[rowsToColor.length] = options.rowId;
				return "<span class='icn_warning_r_n hlpcrsr' title='"+rowObject['trackcom'].replace(/'/g,"")+"'></span>";
			} else if (cellvalue == "2") {
				rowsToColor[rowsToColor.length] = options.rowId;
				return "<span class='icn_warning_r_n hlpcrsr' title='"+localTranslation['supplier_track'][$globlan]+"'></span>";
			}
		}
		function custbtns2() {
			$("#list2").jqGrid('navButtonAdd',"#pager2",{
				caption:"", 
				id:"goto_list",
				buttonicon:"ui-icon-copy", 
				onClickButton: function(){
					selRowId = $("#list2").jqGrid ('getGridParam', 'selrow');
					if (selRowId == null) {
						jAlert(localTranslation["alerttext"][$globlan], localTranslation["attention"][$globlan]);	
						return false;							
					} else {
						$deluser = $("#list2").jqGrid('getRowData',$("#list2").jqGrid('getGridParam','selrow'));
						window.sessionStorage.setItem("qb", $deluser['qbn']);
						window.location.href="close.php";	
					}
				}, 
				position: "last", 
				title: localTranslation["fcz"][$globlan], 
				cursor: "default"
			});
			$("#goto_list div").empty().html("<span class='icn_goto_b_n clckbtn'></span>");
			$("#goto_list").removeClass("ui-pg-button");		
		}
		function fill_grid1() {
			$("#loading").show();
			cmTemplate2 = {
				sorttype:'string',
				editable: false,
				search: true,
				searchoptions: {
					clearSearch: false
				}				
			};				
			obj2 = {
				url:  "./tools/tasks_api.php",
				postData: {routine : "listfc"},
				contentType: "application/json",
				datatype: "json",
				jsonReader: {
					id: "id",
					repeatitems: false
				},
				mtype: "POST",
				colNames: [
					localTranslation["qbn"][$globlan],
					localTranslation["svt"][$globlan],
					localTranslation["clss"][$globlan],
					"",
					""
				],
				colModel: [
					{ 
						name: "qbn", 
						width: 90, 
						template: cmTemplate2					
					},
					{ 
						name: "svt", 
						width: 200 , 
						template: cmTemplate2				
					},
					{
						name:"clss",
						width: 100,
						template: cmTemplate2,
						searchoptions: {
							sopt:['cn', 'nc']
						}
					},					
					{
						name: "track", 
						width: 25,
						template: cmTemplate2,
						search: false,
						formatter: InfoCellFormatter,
						align: "center"
					},
					{ 
						name: "trackcom", 
						hidden: true
					}
				],
				regional: $globlan,
				storeNavOptions : true,			
				loadonce: false,
				pager: "#pager2",
				height: 200,
				rowNum: 150,
				hoverrows: false,
				rownumbers:true,
				sortname: "qbn",
				sortorder: "asc",
				viewrecords: true,
				pgbuttons: false,
				pginput: false,
				rowList: [],
				gridview: true,
				autoencode: true,
				ignoreCase:true,
				loadui: "block",
				onRightClickRow: function (rowid, iRow, iCol, e) {
					$deluser = $("#list2").jqGrid('getRowData',$("#list2").jqGrid('getGridParam','selrow'));
					window.sessionStorage.setItem("qb", $deluser['qbn']);
					$.ajax({
						url: "./tools/general_api.php",
						data: {
							routine: "get_qbs",
							qbn: $deluser['qbn']
						},
						success: function(result) {
							window.sessionStorage.setItem("qbn", result.substring(1, result.length-1));				
							window.location.href="close.php";
							return false;
						}		
					});
					return false;
				},
				loadComplete: function() {
					for (var i = 0; i < rowsToColor.length; i++) {
						$("#list2").find("#" + rowsToColor[i]).find("td").css("color", "<?php echo $c_scheme['I1']; ?>").css("font-weight", "bold");;
					}				
				},
				onSelectRow: function(id){
					var rows = $("#list2").getDataIDs();
					for(a=0;a<rows.length;a++)
					{
						$("#list2").find("#" + (a+1)).removeClass("highlight");
					}
					$("#list2").find("#" + id).addClass("highlight");
				},
				gridComplete: function(data) {
					custbtns2();
				}
			};
			list3 = $("#list2").jqGrid(obj2)
				.jqGrid('filterToolbar',{searchOperators : true, searchOnEnter: false})
				.navGrid('#pager2', {refresh: false, search: false, add: false, del: false, edit: false}, {}, {}, {});
				
			columns = list3.jqGrid ('getGridParam', 'colModel');
			filterToolbar = $(list3[0].grid.hDiv).find("tr.ui-search-toolbar");

			filterToolbar.find("th").each(function(index) {
				var $searchOper = $(this).find(".ui-search-oper");	
				if (!columns[index].searchoptions.sopt) {
					$searchOper.hide();
				}
			});			

			$("#loading").hide();
		}
		load_page();
		setInterval(function(){
			$tme = $("#to").text()*1;
			$tme--;
			if ($tme < 0) {
				$tme = 60;
				$("#list").setGridParam({datatype:'json', postData: {routine : "listsvt", qblan: $globlan}}).trigger('reloadGrid');
				$("#list2").setGridParam({datatype:'json', postData: {routine : "listfc"}}).trigger('reloadGrid');
			}
			$("#to").text($tme);	
		}, 1000);		
	</script>
</body>
</html>
