<?php 
// this generates the excel
	include_once (dirname(__FILE__)."/../templates/db-def.php");
	global $rel_path;	
	require_once ($rel_path."support.php");
	$qb_support = new QBSupport;
	$lng = $_REQUEST['qblan'];
	
// general translations
	$ini_aactqb = parse_ini_file($rel_path.'i18n/a_actqb.ini', true);	
// extract data
	$filters = (json_decode($_REQUEST['filters'], true));
	$datas = (json_decode($_REQUEST['datas'], true));
	$titles = (json_decode($_REQUEST['titles'], true));
	
/** Include PhpSpreadsheet */
  require $rel_path.'phpspreadsheet/autoload.php';

  use PhpOffice\PhpSpreadsheet\Spreadsheet;
  use PhpOffice\PhpSpreadsheet\Style\Border;
  use PhpOffice\PhpSpreadsheet\Style\Color;
  use PhpOffice\PhpSpreadsheet\Style\Font;
  use PhpOffice\PhpSpreadsheet\Writer\Xlsx;

  $spreadsheet = new Spreadsheet();
  $spreadsheet->getActiveSheet()->getPageSetup()->setOrientation(\PhpOffice\PhpSpreadsheet\Worksheet\PageSetup::ORIENTATION_LANDSCAPE);
  $spreadsheet->getActiveSheet()->getPageSetup()->setPaperSize(\PhpOffice\PhpSpreadsheet\Worksheet\PageSetup::PAPERSIZE_A4);
  $spreadsheet->getProperties()->setCreator("QB-oot")->setTitle("TOP Qb");
  $spreadsheet->getDefaultStyle()->getFont()->setName('Arial')->setSize(11);
  $sheet = $spreadsheet->getActiveSheet();
	
// define formats
  $styleThinBlackBorderOutline = [
    'borders' => [
      'borderStyle' => \PhpOffice\PhpSpreadsheet\Style\Border::BORDER_THIN,
      'color' => ['argb' => 'FF000000']
    ]
  ];  
  $styleThickBlackBorderOutline = [
    'borders' => [
      'borderStyle' => \PhpOffice\PhpSpreadsheet\Style\Border::BORDER_MEDIUM,
      'color' => ['argb' => 'FF000000']
    ]
  ]; 
  $styleGreyBackground = [
    'fill' => [
      'fillType' => \PhpOffice\PhpSpreadsheet\Style\Fill::FILL_SOLID,
      'color' => ['argb' => 'FFCCCCCC']
    ]
  ];
  $styleFilterBackground = [
    'fill' => [
      'fillType' => \PhpOffice\PhpSpreadsheet\Style\Fill::FILL_SOLID,
      'color' => ['argb' => 'FFEBF1DE']
    ]
  ]; 
  $styleHyperlink = [
    'font' => [
      'alignment' => ['horizontal' => \PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER],
      'color' => ['argb' => 'FF0000FF'],
      'underline' => Font::UNDERLINE_SINGLE
    ]
  ];

// insert filter settings
	$sheet->setCellValue("A1", "Filter");
	$sheet->getStyle('A1')->getFont()->setBold(true)->setSize(12);
	$sheet->mergeCells('A1:B1');
	$sheet->getStyle('A1:B1')->applyFromArray($styleThickBlackBorderOutline);
	$sheet->setCellValue("A2", $ini_aactqb['qbn'][$lng]);
	$sheet->setCellValue("B2", $filters['qbn']);
	$sheet->setCellValue("A3", $ini_aactqb['type'][$lng]);
	$sheet->setCellValue("B3", $filters['qbl']);
	$sheet->setCellValue("A4", $ini_aactqb['svt'][$lng]);
	$sheet->setCellValue("B4", $filters['svt']);
	$sheet->setCellValue("A5", $ini_aactqb['pl'][$lng]);
	$sheet->setCellValue("B5", $filters['pl']);
	$sheet->setCellValue("A6", $ini_aactqb['status'][$lng]);
	$sheet->setCellValue("B6", $filters['status']);
	$sheet->setCellValue("A7", $ini_aactqb['no_activity'][$lng]);
	$sheet->setCellValue("B7", $filters['last']);
	$sheet->setCellValue("A8", $ini_aactqb['generated'][$lng]);	
	$sheet->setCellValue("B8", date('Y-M-d H:i:s', time()));
	$sheet->setCellValue("A9", $ini_aactqb['found_datasets'][$lng]);
	$sheet->getStyle('B9')->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_LEFT);	
	$sheet->getStyle('B9')->getFont()->setBold(true);	
	$sheet->getStyle('B2:B9')->getFont()->setItalic(true);
// format filter box
	$sheet->getStyle('A1:B9')->applyFromArray($styleFilterBackground)->applyFromArray($styleThickBlackBorderOutline);
// generate headlines
	$i = 1;
	$start_row = 11;

	foreach ($titles as $title) {
		$sheet->setCellValue(chr(64+$i).$start_row, $title);
		$i++;
	}
// format headlines
	$sheet->getStyle('A'.$start_row.':'.chr(64+count($titles)).$start_row)->applyFromArray($styleThinBlackBorderOutline);
	$sheet->getStyle('A'.$start_row.':'.chr(64+count($titles)).$start_row)->applyFromArray($styleGreyBackground);
	$sheet->getStyle('A'.$start_row.':'.chr(64+count($titles)).$start_row)->getFont()->setBold(true)->setName('Arial')->setSize(10)->getColor()->setARGB('FF0000FF');
	$sheet->getStyle('A'.$start_row.':'.chr(64+count($titles)).$start_row)->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_LEFT);	

	$total_rows = count($datas);
// result is there, add amount of rows
	$sheet->setCellValue("B".($start_row-2), $total_rows);
	
	$f = -1;
	$data_row = $start_row + 1;
	global $relili;
	foreach ($datas as $row) {
		$i = 1;
		foreach($row as $key => $value) {	
			$sheet->setCellValue(chr(64+$i).$data_row, $value);
			if ($key == "qbn") {
				$sheet->getCell(chr(64+$i).$data_row)->getHyperlink()->setUrl('http://' . $relili . $value);
				$sheet->getStyle(chr(64+$i).$data_row)->applyFromArray($styleHyperlink);
			}
			$i++;
		}
		$data_row++;
	}
	// if QBN was selected format column
	if ($f != -1) {
		$sheet->getStyle(chr(64+$f).($start_row+1).":".chr(64+$f).($start_row+1+$total_rows))->getFont()->setUnderline(\PhpOffice\PhpSpreadsheet\Style\Font::UNDERLINE_SINGLE);
		$sheet->getStyle(chr(64+$f).($start_row+1).":".chr(64+$f).($start_row+1+$total_rows))->getFont()->getColor()->setARGB('FF0000FF');
		$sheet->getStyle(chr(64+$f).($start_row+1).":".chr(64+$f).($start_row+1+$total_rows))->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER);
	}

// set autofilter
	$sheet->setAutoFilter('A'.$start_row.':'.chr(64+count($titles)).$start_row);
	
// format columns
	$i = 1;
	foreach ($titles as $title) {
		$sheet->getColumnDimension(chr(64+$i))->setAutoSize(true);
		$i++;	
	}
	
// Rename worksheet
	$sheet->setTitle($ini_aactqb['no_activity'][$lng]);

// Set active sheet index to the first sheet, so Excel opens this as the first sheet
	$spreadsheet->setActiveSheetIndex(0);

// Redirect output to a client's web browser (Excel2007)
	header('Content-Type: application/vnd.openxmlformats-officedocument.spreadsheetml.sheet');
	header('Content-Disposition: attachment;filename="last_activity.xlsx"');
	header('Cache-Control: max-age=0');

  $writer = new Xlsx($spreadsheet);
  $writer->save('php://output');
	exit;
?>
