<?php
// this generates the excel
	include_once (dirname(__FILE__)."/../templates/db-def.php");
	global $rel_path;	
	require_once ($rel_path."support.php");
	$qb_support = new QBSupport;
	
	$lng = $_REQUEST['qblan'];
// general translations
	$ini_afuvsco = parse_ini_file($rel_path.'i18n/a_fuvsco.ini', true);	
	$ini_ffu = parse_ini_file($rel_path.'xml/ffu.ini', true);	
// extract data
	$filters = json_decode($_REQUEST['filters'], true);
	$detfilter = " HAVING ";
	foreach($filters as $key=>$value) {
		if ($value != "") {
			$detfilter .= $key." LIKE '%".$value."%' AND ";
		}
	}
	if ($detfilter == " HAVING ") {
		$detfilter = "";
	} else {
		$detfilter = substr($detfilter, 0, -5);
	}
	$titles = json_decode($_REQUEST['titles'], true);
	$clss = json_decode($_REQUEST['qbclss'], true);
	$clss_key = array_keys($clss)[0];
	$clss_txt = $clss[$clss_key];
	$fltr = ($clss_key == 'all')?"":" AND CLSS='".$clss_key."' ";
	$ymds = $_REQUEST['sdate'];
	$ymde = $_REQUEST['edate'];
	if ($ymds > $ymde) {
		$tmp = $ymds;
		$ymds = $ymde;
		$ymde = $tmp;
	}
	$query = "
		SELECT 
			qbi.QBN AS qbn,
			FFU as ffu,
			FU as fu, 
			VB as vb
		FROM 
			qb_close 
		LEFT JOIN 
			qbi ON qb_close.QBN=qbi.QBN 
		WHERE 
			QBREGDATE>=:sdat AND 
			QBREGDATE<=:edat AND
			FFU <> ''
	".$fltr.$detfilter;
	$stmt = $db->prepare($query);
	$stmt->execute(
		array(
			':sdat' => $ymds,
			':edat' => $ymde
		)
	);				
	$num_records = $stmt->rowCount();
	
/** Include PhpSpreadsheet */
  require $rel_path.'phpspreadsheet/autoload.php';

  use PhpOffice\PhpSpreadsheet\Spreadsheet;
  use PhpOffice\PhpSpreadsheet\Style\Border;
  use PhpOffice\PhpSpreadsheet\Style\Color;
  use PhpOffice\PhpSpreadsheet\Style\Font;
  use PhpOffice\PhpSpreadsheet\Writer\Xlsx;

  $spreadsheet = new Spreadsheet();
  $spreadsheet->getActiveSheet()->getPageSetup()->setOrientation(\PhpOffice\PhpSpreadsheet\Worksheet\PageSetup::ORIENTATION_LANDSCAPE);
  $spreadsheet->getActiveSheet()->getPageSetup()->setPaperSize(\PhpOffice\PhpSpreadsheet\Worksheet\PageSetup::PAPERSIZE_A4);
  $spreadsheet->getProperties()->setCreator("QB-oot")->setTitle("TOP Qb");
  $spreadsheet->getDefaultStyle()->getFont()->setName('Arial')->setSize(11);
  $sheet = $spreadsheet->getActiveSheet();
	
// define formats
  $styleThinBlackBorderOutline = [
    'borders' => [
      'borderStyle' => \PhpOffice\PhpSpreadsheet\Style\Border::BORDER_THIN,
      'color' => ['argb' => 'FF000000']
    ]
  ];  
  $styleThickBlackBorderOutline = [
    'borders' => [
      'borderStyle' => \PhpOffice\PhpSpreadsheet\Style\Border::BORDER_MEDIUM,
      'color' => ['argb' => 'FF000000']
    ]
  ]; 
  $styleGreyBackground = [
    'fill' => [
      'fillType' => \PhpOffice\PhpSpreadsheet\Style\Fill::FILL_SOLID,
      'color' => ['argb' => 'FFCCCCCC']
    ]
  ];
  $styleFilterBackground = [
    'fill' => [
      'fillType' => \PhpOffice\PhpSpreadsheet\Style\Fill::FILL_SOLID,
      'color' => ['argb' => 'FFEBF1DE']
    ]
  ]; 
  $styleHyperlink = [
    'font' => [
      'alignment' => ['horizontal' => \PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER],
      'color' => ['argb' => 'FF0000FF'],
      'underline' => Font::UNDERLINE_SINGLE
    ]
  ];

// insert filter settings
	$sheet->setCellValue("A1", $ini_afuvsco['filter'][$lng]);
	$sheet->getStyle('A1')->getFont()->setBold(true)->setSize(12);
	$sheet->mergeCells('A1:B1');
	$sheet->getStyle('A1:B1')->applyFromArray($styleThickBlackBorderOutline);
	$sheet->setCellValue("A2", $ini_afuvsco['qbn'][$lng]);
	$sheet->setCellValue("B2", $filters['qbn']);
	$sheet->setCellValue("A3", $ini_afuvsco['ffus'][$lng]);
	$sheet->setCellValue("B3", $filters['ffu']);
	$sheet->setCellValue("A4", $ini_afuvsco['fu'][$lng]);
	$sheet->setCellValue("B4", $filters['fu']);
	$sheet->setCellValue("A5", $ini_afuvsco['vb'][$lng]);
	$sheet->setCellValue("B5", $filters['vb']);
	$sheet->setCellValue("A6", $ini_afuvsco['clss'][$lng]);
	$sheet->setCellValue("B6", $clss_txt);	
	$sheet->setCellValue("A7", $ini_afuvsco['generated'][$lng]);
	$sheet->setCellValue("B7", date('Y-M-d H:i:s', time()));
	$sheet->setCellValue("A8", $ini_afuvsco['found_datasets'][$lng]);
	$sheet->setCellValue("B8", $num_records);
	$sheet->getStyle('B8')->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_LEFT);	
	$sheet->getStyle('B8')->getFont()->setBold(true);	
	$sheet->getStyle('B2:B8')->getFont()->setItalic(true);
// format filter box
	$sheet->getStyle('A1:B8')->applyFromArray($styleFilterBackground)->applyFromArray($styleThickBlackBorderOutline);

// generate headlines
	$i = 1;
	$start_row = 10;
	
	foreach ($titles as $title) {
		$sheet->setCellValue(chr(64+$i).$start_row, $title);
		$i++;
	}	
// format headlines
	$sheet->getStyle('A'.$start_row.':'.chr(64+count($titles)).$start_row)->applyFromArray($styleThinBlackBorderOutline);
	$sheet->getStyle('A'.$start_row.':'.chr(64+count($titles)).$start_row)->applyFromArray($styleGreyBackground);
	$sheet->getStyle('A'.$start_row.':'.chr(64+count($titles)).$start_row)->getFont()->setBold(true)->setName('Arial')->setSize(10)->getColor()->setARGB('FF0000FF');
	$sheet->getStyle('A'.$start_row.':'.chr(64+count($titles)).$start_row)->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_LEFT);	
	
	$data_row = $start_row + 1;
	global $relili;
	while ($row = $stmt->fetch(PDO::FETCH_ASSOC)) {
		$i = 1;
		foreach($row as $key => $value) {
			switch ($key) {
				case "ffu":
					$sheet->setCellValue(chr(64+$i).$data_row, $ini_ffu[$value][$lng]);
					break;
				case "qbn":
					$sheet->setCellValue(chr(64+$i).$data_row, $value);
					$sheet->getCell(chr(64+$i).$data_row)->getHyperlink()->setUrl('http://' . $relili . $value);
					$sheet->getStyle(chr(64+$i).$data_row)->applyFromArray($styleHyperlink);
					break;
				case "fu":
          $richText = new \PhpOffice\PhpSpreadsheet\RichText\RichText();
          $richText->createText($value);
          $sheet->setCellValue(chr(64+$i).$data_row, $richText);
					break;
				case "vb":
          $richText = new \PhpOffice\PhpSpreadsheet\RichText\RichText();
          $richText->createText($value);
          $sheet->setCellValue(chr(64+$i).$data_row, $richText);
					break;					
			}
			$i++;
		}
		$data_row++;
	}

// set autofilter
	$sheet->setAutoFilter('A'.$start_row.':'.chr(64+count($titles)).$start_row);

// format columns
	$i = 1;
	foreach ($titles as $key=>$title) {
		if (($key == "fu") OR ($key == "vb")) {	
			$sheet->getColumnDimension(chr(64+$i))->setWidth(50);			
			$sheet->getStyle(chr(64+$i).($start_row + 1).":".chr(64+$i).$sheet->getHighestRow())->getAlignment()->setWrapText(true); 
		} else {
			$sheet->getColumnDimension(chr(64+$i))->setAutoSize(true);
		}
		$i++;	
	}
	
// Rename worksheet
	$sheet->setTitle('fuvsco');

// Set active sheet index to the first sheet, so Excel opens this as the first sheet
	$spreadsheet->setActiveSheetIndex(0);

	header('Content-Type: application/vnd.openxmlformats-officedocument.spreadsheetml.sheet');
	header('Content-Disposition: attachment;filename="qb-fuvsco.xlsx"');
	header('Cache-Control: max-age=0');

  $writer = new Xlsx($spreadsheet);
  $writer->save('php://output');
?>
