<?php
// this generates the excel
	include_once (dirname(__FILE__)."/../templates/db-def.php");
	global $rel_path;	
	require_once ($rel_path."support.php");
	$qb_support = new QBSupport;
// general translations
	$ini_linksummary = parse_ini_file($rel_path.'i18n/a_linksummary.ini', true);	
	$cal = parse_ini_file($rel_path.'i18n/calendar.ini', true);
	$ini_class = parse_ini_file($rel_path.'xml/class.ini', true);
// extract data
	$titles = json_decode($_REQUEST['titles'], true);

	$filters = json_decode($_REQUEST['filters'], true);
	$lng = $filters['qblan'];
	unset ($filters['qblan']);
	$clss = $filters['clss'];
	unset ($filters['clss']);
	$ymds = $filters['sdat'];
	unset ($filters['sdat']);
	$ymde = $filters['edat'];
	unset ($filters['edat']);
	if ($ymds > $ymde) {
		$tmp = $ymds;
		$ymds = $ymde;
		$ymde = $tmp;
	}
	$fltr = ($clss == "all")?"":" AND CLSS='".$clss."' ";
	
	$detfilter = " HAVING ";
	foreach($filters as $key=>$value) {
		if ($value != "") {
			$detfilter .= $key." LIKE '%".$value."%' AND ";
		}
	}
	if ($detfilter == " HAVING ") {
		$detfilter = "";
	} else {
		$detfilter = substr($detfilter, 0, -5);
	}
	
	$query = "
		SELECT 
			qbi.QBN AS qbn, 
			COALESCE((SELECT CONCAT(NACHNAME, ', ', VORNAME) FROM qb_user WHERE SVT=LOGIN), 'N/A')  AS svt,							
			(SELECT COUNT(*) FROM qb_qbref WHERE qb_qbref.QBN=qbi.QBN) as qbsum,
			MNR AS imat,
			DESCRIPTION AS des
		FROM 
			qbi
		LEFT JOIN
			qbbasic
		ON
			qbi.QBN=qbbasic.QBN
		WHERE
			QBREGDATE>=:sdat AND 
			QBREGDATE<=:edat
	".$fltr.$detfilter." ORDER BY qbsum DESC";
	$stmt = $db->prepare($query);
	$stmt->execute(
		array(
			':sdat' => $ymds,
			':edat' => $ymde
		)
	);
	$num_records = $stmt->rowCount();	
  
/** Include PhpSpreadsheet */
  require $rel_path.'phpspreadsheet/autoload.php';

  use PhpOffice\PhpSpreadsheet\Spreadsheet;
  use PhpOffice\PhpSpreadsheet\Style\Border;
  use PhpOffice\PhpSpreadsheet\Style\Color;
  use PhpOffice\PhpSpreadsheet\Style\Font;
  use PhpOffice\PhpSpreadsheet\Writer\Xlsx;

  $spreadsheet = new Spreadsheet();
  $spreadsheet->getActiveSheet()->getPageSetup()->setOrientation(\PhpOffice\PhpSpreadsheet\Worksheet\PageSetup::ORIENTATION_LANDSCAPE);
  $spreadsheet->getActiveSheet()->getPageSetup()->setPaperSize(\PhpOffice\PhpSpreadsheet\Worksheet\PageSetup::PAPERSIZE_A4);
  $spreadsheet->getProperties()->setCreator("QB-oot")->setTitle("TOP Qb");
  $spreadsheet->getDefaultStyle()->getFont()->setName('Arial')->setSize(11);
  $sheet = $spreadsheet->getActiveSheet();
	
// define formats
  $styleThinBlackBorderOutline = [
    'borders' => [
      'borderStyle' => \PhpOffice\PhpSpreadsheet\Style\Border::BORDER_THIN,
      'color' => ['argb' => 'FF000000']
    ]
  ];  
  $styleThickBlackBorderOutline = [
    'borders' => [
      'borderStyle' => \PhpOffice\PhpSpreadsheet\Style\Border::BORDER_MEDIUM,
      'color' => ['argb' => 'FF000000']
    ]
  ]; 
  $styleGreyBackground = [
    'fill' => [
      'fillType' => \PhpOffice\PhpSpreadsheet\Style\Fill::FILL_SOLID,
      'color' => ['argb' => 'FFCCCCCC']
    ]
  ];
  $styleFilterBackground = [
    'fill' => [
      'fillType' => \PhpOffice\PhpSpreadsheet\Style\Fill::FILL_SOLID,
      'color' => ['argb' => 'FFEBF1DE']
    ]
  ]; 
  $styleHyperlink = [
    'font' => [
      'alignment' => ['horizontal' => \PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER],
      'color' => ['argb' => 'FF0000FF'],
      'underline' => Font::UNDERLINE_SINGLE
    ]
  ];

// insert filter settings
	$sheet->setCellValue("A1", $ini_linksummary['filter'][$lng]);
	$sheet->getStyle('A1')->getFont()->setBold(true)->setSize(12);
	$sheet->mergeCells('A1:B1');
	$sheet->getStyle('A1:B1')->applyFromArray($styleThickBlackBorderOutline);
	$sheet->setCellValue("A2", $ini_linksummary['qbn'][$lng]);
	$sheet->setCellValue("B2", $filters['qbn']);
	$sheet->setCellValue("A3", $ini_linksummary['date'][$lng]);
	$sheet->setCellValue("B3", $ymds." - ".$ymde);
	$sheet->setCellValue("A4", $ini_linksummary['svt'][$lng]);
	$sheet->setCellValue("B4", "%".$filters['svt']."%");
	$sheet->setCellValue("A5", $ini_linksummary['clss'][$lng]);
	$sheet->setCellValue("B5", $ini_class[$clss][$lng]);
	$sheet->setCellValue("A6", $ini_linksummary['imat'][$lng]);
	$sheet->setCellValue("B6", "%".$filters['imat']."%");
	$sheet->setCellValue("A7", $ini_linksummary['des'][$lng]);
	$sheet->setCellValue("B7", "%".$filters['des']."%");
	$sheet->setCellValue("A8", $ini_linksummary['generated'][$lng]);
	$sheet->setCellValue("B8", date('Y-M-d H:i:s', time()));
	$sheet->setCellValue("A9", $ini_linksummary['found_datasets'][$lng]);
	$sheet->setCellValue("B9", $num_records);
	$sheet->getStyle('B9')->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_LEFT);	
	$sheet->getStyle('B9')->getFont()->setBold(true);	
	$sheet->getStyle('B2:B9')->getFont()->setItalic(true);
// format filter box
	$sheet->getStyle('A1:B9')->applyFromArray($styleFilterBackground)->applyFromArray($styleThickBlackBorderOutline);

// generate headlines
	$i = 1;
	$start_row = 11;
	
	foreach ($titles as $title) {
		$sheet->setCellValue(chr(64+$i).$start_row, $title);
		$i++;
	}	
// format headlines
	$sheet->getStyle('A'.$start_row.':'.chr(64+count($titles)).$start_row)->applyFromArray($styleThinBlackBorderOutline);
	$sheet->getStyle('A'.$start_row.':'.chr(64+count($titles)).$start_row)->applyFromArray($styleGreyBackground);
	$sheet->getStyle('A'.$start_row.':'.chr(64+count($titles)).$start_row)->getFont()->setBold(true)->setName('Arial')->setSize(10)->getColor()->setARGB('FF0000FF');
	$sheet->getStyle('A'.$start_row.':'.chr(64+count($titles)).$start_row)->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_LEFT);	
	
	$data_row = $start_row + 1;
	global $relili;
	while ($row = $stmt->fetch(PDO::FETCH_ASSOC)) {
		$i = 1;
		foreach($row as $key => $value) {
			switch ($key) {
				case "clss":
					break;
				case "qbn":
					$sheet->setCellValue(chr(64+$i).$data_row, $value);
					$sheet->getCell(chr(64+$i).$data_row)->getHyperlink()->setUrl('http://' . $relili . $value);
					$sheet->getStyle(chr(64+$i).$data_row)->applyFromArray($styleHyperlink);
					$sheet->getColumnDimension(chr(64+$i))->setAutoSize(true);
					break;
				case "des":
          $richText = new \PhpOffice\PhpSpreadsheet\RichText\RichText();
          $richText->createText($value);
          $sheet->setCellValue(chr(64+$i).$data_row, $richText);
					$sheet->getColumnDimension(chr(64+$i))->setWidth(100);
					$sheet->getStyle(chr(64+$i).$data_row)->getAlignment()->setWrapText(true);
					break;
				default:
					$sheet->setCellValue(chr(64+$i).$data_row, $value);
					$sheet->getColumnDimension(chr(64+$i))->setAutoSize(true);
					break;
			}
			$sheet->getStyle(chr(64+$i).$data_row)->getAlignment()->setVertical(\PhpOffice\PhpSpreadsheet\Style\Alignment::VERTICAL_TOP);
			$i++;
		}
		$data_row++;
	}
// set autofilter
	$sheet->setAutoFilter('A'.$start_row.':'.chr(64+count($titles)).$start_row);
// Rename worksheet
	$sheet->setTitle('Link Summary Report');

// Set active sheet index to the first sheet, so Excel opens this as the first sheet
	$spreadsheet->setActiveSheetIndex(0);

// Redirect output to a client’s web browser (Excel2007)
	header('Content-Type: application/vnd.openxmlformats-officedocument.spreadsheetml.sheet');
	header('Content-Disposition: attachment;filename="LinkSummaryReport.xlsx"');
	header('Cache-Control: max-age=0');

  $writer = new Xlsx($spreadsheet);
  $writer->save('php://output');
	exit;
?>
