<?php
	include_once (dirname(__FILE__)."/../templates/db-def.php");
	require_once ($rel_path."support.php");
	$qb_support = new QBSupport;
	
	$lng = $_REQUEST['lng'];
// translation for calender
	$cal = parse_ini_file($rel_path.'i18n/calendar.ini', true);
	$cal = explode(",", $cal['monthNamesShort'][$_SESSION['lng']]);

/** Include PhpSpreadsheet */
  require $rel_path.'phpspreadsheet/autoload.php';

  use PhpOffice\PhpSpreadsheet\Spreadsheet;
  use PhpOffice\PhpSpreadsheet\Style\Border;
  use PhpOffice\PhpSpreadsheet\Style\Color;
  use PhpOffice\PhpSpreadsheet\Style\Font;
  use PhpOffice\PhpSpreadsheet\Writer\Xlsx;

// define template
	$inputFileName = '../templates/8D_SCAR.xlsx'; 
	
// Load template to a PhpSpreadsheet Object
  $spreadsheet = \PhpOffice\PhpSpreadsheet\IOFactory::load($inputFileName);
  $spreadsheet->getProperties()->setCreator("QB-oot")->setTitle("8D/SCAR");
  $sheet = $spreadsheet->getActiveSheet();
	
// define formats
  $styleThinBlackBorderOutline = [
    'borders' => [
      'borderStyle' => \PhpOffice\PhpSpreadsheet\Style\Border::BORDER_THIN,
      'color' => ['argb' => 'FF000000']
    ]
  ];  
  $styleThickBlackBorderOutline = [
    'borders' => [
      'borderStyle' => \PhpOffice\PhpSpreadsheet\Style\Border::BORDER_MEDIUM,
      'color' => ['argb' => 'FF000000']
    ]
  ]; 
  $styleGreyBackground = [
    'fill' => [
      'fillType' => \PhpOffice\PhpSpreadsheet\Style\Fill::FILL_SOLID,
      'color' => ['argb' => 'FFCCCCCC']
    ]
  ];
  $styleFilterBackground = [
    'fill' => [
      'fillType' => \PhpOffice\PhpSpreadsheet\Style\Fill::FILL_SOLID,
      'color' => ['argb' => 'FFEBF1DE']
    ]
  ]; 
  $styleHyperlink = [
    'font' => [
      'alignment' => ['horizontal' => \PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER],
      'color' => ['argb' => 'FF0000FF'],
      'underline' => Font::UNDERLINE_SINGLE
    ]
  ];

// define sender address
	$xmlstring = file_get_contents($rel_path."templates/8d_sender.xml");
	$sender_file = json_decode(json_encode((array) simplexml_load_string($xmlstring)), true);
	$sender_file = $sender_file['site'];
	foreach($sender_file as $key=>$value){
		if ($value['name'] == $_GET['site']) {
			$CellB2 = $value['zeile'][0];
			$CellB3 = $value['zeile'][1];
			$CellB4 = $value['zeile'][2];
		}
	}
// get materialname index
	$mncol = $qb_support->getLanMat($lng);
// get supplier and part number
	$query = "SELECT (SELECT SUPPLIERNAME FROM qb_supplier WHERE SUPPLIER=SUPPLIERNR), MNR AS TGR, (SELECT IF(MNR='0', 'xxxxx-xxxxx', TGRBZ_" . 
		$mncol . ") AS TGRBZ FROM qb_material WHERE TGR=MNR), LFS_NR, DEL_COUNT, TEST_FAIL, DESCRIPTION FROM qbbasic WHERE QBN=:qbn";	
	$stmt = $db->prepare($query);
	$stmt->execute(
		array(
			':qbn' => $_REQUEST['qb']
		)
	);	
	$row = $stmt->fetch(PDO::FETCH_NUM );
	list($supplier, $tgr, $tgrbz, $lfsnr, $delcount, $testfail, $docdesc) = $row;
	$query = "SELECT COMPANY FROM qb_conf";
	$stmt = $db->query($query);
	$comp = $stmt->fetchColumn();
// define language
	switch($_REQUEST['lng']) {
		case "en":
			$header8d = "Supplier Corrective Action Request Form (8D Report)";
			$footer8d = "&RPage &P of &N";
			$CellA7 = " The material / process detailed below has been classified as defective by " . $comp . ".";
			$CellA8 = new \PhpOffice\PhpSpreadsheet\RichText\RichText();
			$CellA8->createText('You are required to complete the ');
			$objBlue = $CellA8->createTextRun('blue');
			$objBlue->getFont()->setName('Arial')->setSize(10)->getColor()->setARGB('FF244061'); 
			$objBlue->getFont()->setUnderline(true)->setBold(true);
			$objRest = $CellA8->createTextRun(' sections of this form and respond within 10 business days.');
			$objRest->getFont()->setName('Arial')->setSize(10);
			$CellA11 = " Supplier Information:";
			$CellA12 = "Supplier:";
			$CellA13 = "Contact Name:";
			$CellA14 = "Contact e-mail:";
			$CellA15 = "Contact phone:";
			
			$CellG3 = "Date:";
			$CellE11 = " Part Number Information:";
			$CellE12 = "Part Name:";
			$CellE13 = $comp . " Part #:";
			$CellE14 = "Supplier Part #:";
			$CellE15 = "PO Number:";
			$CellE16 = "Qty Received:";
			$CellE17 = "Qty Rejected:"; 
			$CellA20 = $comp . "'s problem description:";
			$CellC25 = " 2. Problem description";
			$CellA25 = " 1. Team";
			$CellA26 = "Name";
			$CellB26 = "Role";
			$CellA32 = " 3. Immediate action(s)";
			$CellG32 = "implemented on";
			$CellA38 = " 4. Root cause(s)";
			$CellD38 = " First occurrence";
			$CellG38 = " Repetitive defect";
			$CellA45 = " 5. Chosen corrective action(s)";
			$CellG45 = "Verification check by method of";
			$CellA51 = " 6. Implemented corrective action(s)";
			$CellG51 = "implemented on";
			$CellA57 = " 7. Action(s) to prevent recurrence";
			$CellG57 = "implemented on";
			$CellA58 = "Update of:";
			$CellA59 = " Process Flow";
			$CellA60 = " Process/Design-FMEA";
			$CellA61 = " Control Plan (No)";
			$CellA62 = " Work Instruction (No)";
			$CellA63 = " Drawing (No)";
			$CellA66 = " 8. Summary & Congratulations";
			$CellA71 = "Signature:";
			$CellA73 = "Date:";
			$CellG71 = " Credit Note";
			$CellG73 = " Replacement";
      $CellA76 = new \PhpOffice\PhpSpreadsheet\RichText\RichText();
      $CellA76->createText('Decision ');
      $objCompany = $CellA76->createTextRun($comp.':');
      $objCompany->getFont()->setName('Arial')->setSize(10)->setBold(true)->getColor()->setARGB('FFFF6600'); 
			$CellD76 = " 8D-Report accepted";
			$CellG76 = " 8D-Report rejected";
			$CellA78 = "Date:";
			$CellD78 = "Signature:";
			break;
		case "de":
			$header8d = "Lieferanten 8D Bericht";
			$footer8d = "&RSeite &P von &N";
			$CellA7 = "Das unten beschriebene Material / der Prozess wurde von " . $comp . " als defekt klassifiziert.";
			$CellA8 = new \PhpOffice\PhpSpreadsheet\RichText\RichText();
			$CellA8->createText('Bitte füllen Sie alle ');
			$objBlue = $CellA8->createTextRun('blau');
			$objBlue->getFont()->setName('Arial')->setSize(10)->getColor()->setARGB(PhpOffice\PhpSpreadsheet\Style\Color::COLOR_BLUE); 
			$objBlue->getFont()->setUnderline(true)->setBold(true);
			$objRest = $CellA8->createTextRun(' markieten Bereiche dieses Berichtes aus und retournieren ihn innerhalb von 10 Arbeitstagen.');
			$objRest->getFont()->setName('Arial')->setSize(10);
			$CellA11 = " Lieferanten-Information:";
			$CellA12 = "Lieferant:";
			$CellA13 = "Kontakt-Name:";
			$CellA14 = "Kontakt Email:";
			$CellA15 = "Kontakt Telefon:";
			
			$CellG3 = "Datum:";
			$CellE11 = " Material-Information:";
			$CellE12 = "Material-Bezeichnung:";
			$CellE13 = $comp . " Material#:";
			$CellE14 = "Lieferant Material #:";
			$CellE15 = "Bestell-Nummer:";
			$CellE16 = "Menge geliefert:";
			$CellE17 = "zurückgew. Menge:";
			$CellA20 = $comp . "'s Problembeschreibung:";
			$CellC25 = " 2. Problembeschreibung";
			$CellA25 = " 1. Team";
			$CellA26 = "Name";
			$CellB26 = "Rolle";
			$CellA32 = " 3. Sofortmassnahme(n)";
			$CellG32 = "eingeführt am";
			$CellA38 = " 4. Fehlerursache(n)";
			$CellD38 = " erstmaliger Fehler";
			$CellG38 = " Wiederholfehler";
			$CellA45 = " 5. Geplante Abstellmassnahme(n)";
			$CellG45 = "Wirksamkeitsprüfung mit Methode";
			$CellA51 = " 6. Eingeführte Abstellmassnahme(n)";
			$CellG51 = "eingeführt am";
			$CellA57 = " 7. Massnahme(n) gegen Wiederholfehler";
			$CellG57 = "eingeführt am";
			$CellA58 = "Anpassung von:";
			$CellA59 = " Prozessablauf";
			$CellA60 = " Prozess/Design-FMEA";
			$CellA61 = " Prozesslenkungsplan (Nummer)";
			$CellA62 = " Arbeitsanweisung (Nummer)";
			$CellA63 = " Zeichnung (Nummer)";
			$CellA66 = " 8. Zusammenfassung & Teamerfolg";
			$CellA71 = "Unterschrift:";	
			$CellA73 = "Datum:";
			$CellG71 = " Gutschrift";
			$CellG73 = " Ersatzlieferung";
      $CellA76 = "Entscheid ".$comp.":";
			$CellD76 = " 8D-Report akzeptiert";
			$CellG76 = " 8D-Report zurückgewiesen";
			$CellA78 = "Datum:";
			$CellD78 = "Unterschrift:";
			break;			
	} 
	
	$sheet->getHeaderFooter()->setOddHeader($header8d); 
	$sheet->getHeaderFooter()->setOddFooter('&L&B' . $spreadsheet->getProperties()->getTitle() . $footer8d);
	
// fill cells

	$sheet->setCellValue("B12", $supplier);
	$sheet->setCellValue("G12", $tgrbz);
	$sheet->setCellValue("G13", $tgr);
	$sheet->setCellValue("G15", $lfsnr);
	$sheet->setCellValue("G16", ($delcount==0)?"":$delcount);
	$sheet->setCellValue("G17", ($testfail==0)?"":$testfail);	
	
	$sheet->setCellValue("G3", $CellG3);

	$sheet->setCellValue("B2", $CellB2);
	$sheet->setCellValue("B3", $CellB3);
	$sheet->setCellValue("B4", $CellB4);

	$sheet->getCell('A20')->setValue($CellA20);
  $richText = new \PhpOffice\PhpSpreadsheet\RichText\RichText();
  $richText->createText($docdesc);
	$sheet->getCell('A22')->setValue($richText);
	
	$sheet->setCellValue("H2", "QB " . $_GET['qb']);
	$sheet->getStyle('H2')->getFont()->setName('Arial')->setSize(11)->getColor()->setARGB(PhpOffice\PhpSpreadsheet\Style\Color::COLOR_RED); 
	$sheet->setCellValue("H3", date('Y', time()) . "-" . utf8_decode($cal[date('n', time())-1]) . "-" . date('d', time()));
	$sheet->getStyle('H3')->getFont()->setName('Arial')->setSize(11)->getColor()->setARGB(PhpOffice\PhpSpreadsheet\Style\Color::COLOR_BLUE); 	
	$sheet->setCellValue("A7", $CellA7);
	$sheet->setCellValue("A8", $CellA8);
	
	$sheet->getCell('A11')->setValue($CellA11);
	$sheet->getCell('A12')->setValue($CellA12);
	$sheet->getCell('A13')->setValue($CellA13);
	$sheet->getCell('A14')->setValue($CellA14);
	$sheet->getCell('A15')->setValue($CellA15);
	$sheet->getCell('E11')->setValue($CellE11);
	$sheet->getCell('E12')->setValue($CellE12);
	$sheet->getCell('E13')->setValue($CellE13);
	$sheet->getCell('E14')->setValue($CellE14);
	$sheet->getCell('E15')->setValue($CellE15);
	$sheet->getCell('E16')->setValue($CellE16);
	$sheet->getCell('E17')->setValue($CellE17);

	$sheet->getCell('A25')->setValue($CellA25)->getStyle('A25')->getFont()->getColor()->setARGB(PhpOffice\PhpSpreadsheet\Style\Color::COLOR_BLUE); 
	$sheet->getCell('A26')->setValue($CellA26);
	$sheet->getCell('B26')->setValue($CellB26);
	$sheet->getCell('C25')->setValue($CellC25)->getStyle('A25')->getFont()->getColor()->setARGB(PhpOffice\PhpSpreadsheet\Style\Color::COLOR_BLUE); 
	
	$sheet->getCell('A32')->setValue($CellA32)->getStyle('A25')->getFont()->getColor()->setARGB(PhpOffice\PhpSpreadsheet\Style\Color::COLOR_BLUE); 
	$sheet->getCell('G32')->setValue($CellG32);
	
	$sheet->getCell('A38')->setValue($CellA38)->getStyle('A25')->getFont()->getColor()->setARGB(PhpOffice\PhpSpreadsheet\Style\Color::COLOR_BLUE); ;
	$sheet->getCell('D38')->setValue($CellD38);
	$sheet->getCell('G38')->setValue($CellG38);
	
	$sheet->getCell('A45')->setValue($CellA45)->getStyle('A25')->getFont()->getColor()->setARGB(PhpOffice\PhpSpreadsheet\Style\Color::COLOR_BLUE); ;
	$sheet->getCell('G45')->setValue($CellG45);
	
	$sheet->getCell('A51')->setValue($CellA51)->getStyle('A25')->getFont()->getColor()->setARGB(PhpOffice\PhpSpreadsheet\Style\Color::COLOR_BLUE); ;
	$sheet->getCell('G51')->setValue($CellG51);	
	
	$sheet->getCell('A57')->setValue($CellA57)->getStyle('A25')->getFont()->getColor()->setARGB(PhpOffice\PhpSpreadsheet\Style\Color::COLOR_BLUE); ;
	$sheet->getCell('G57')->setValue($CellG57);
	
	$sheet->getCell('A58')->setValue($CellA58);
	$sheet->getCell('A59')->setValue($CellA59);
	$sheet->getCell('A60')->setValue($CellA60);
	$sheet->getCell('A61')->setValue($CellA61);
	$sheet->getCell('A62')->setValue($CellA62);
	$sheet->getCell('A63')->setValue($CellA63);
	
	$sheet->getCell('A66')->setValue($CellA66)->getStyle('A25')->getFont()->getColor()->setARGB(PhpOffice\PhpSpreadsheet\Style\Color::COLOR_BLUE); ;
	$sheet->getCell('A71')->setValue($CellA71)->getStyle('A25')->getFont()->getColor()->setARGB(PhpOffice\PhpSpreadsheet\Style\Color::COLOR_BLUE); ;
	$sheet->getCell('A73')->setValue($CellA73)->getStyle('A25')->getFont()->getColor()->setARGB(PhpOffice\PhpSpreadsheet\Style\Color::COLOR_BLUE); ;
	$sheet->getCell('G71')->setValue($CellG71);
	$sheet->getCell('G73')->setValue($CellG73);	
	
	$sheet->getCell('A76')->setValue($CellA76);	
	$sheet->getCell('D76')->setValue($CellD76);	
	$sheet->getCell('G76')->setValue($CellG76);	
	
	$sheet->getCell('A78')->setValue($CellA78);	
	$sheet->getCell('D78')->setValue($CellD78);		
	
// Rename worksheet
	$sheet->setTitle("QB" . $_GET['qb']);

// Set active sheet index to the first sheet, so Excel opens this as the first sheet
	$spreadsheet->setActiveSheetIndex(0);

// Redirect output to a client's web browser (Excel2007)
	header('Content-Type: application/vnd.openxmlformats-officedocument.spreadsheetml.sheet');
	header('Content-Disposition: attachment;filename="8D/SCAR.xlsx"');
	header('Cache-Control: max-age=0');

  $writer = new Xlsx($spreadsheet);
  $writer->save('php://output');
	exit;
?>
