<?php
// this generates the excel
	include_once (dirname(__FILE__)."/../templates/db-def.php");
	global $rel_path;	
	require_once ($rel_path."support.php");
	$qb_support = new QBSupport;
	
	$lng = $_REQUEST['qblan'];

	// prepare translations
		$ini_axx = parse_ini_file($rel_path.'i18n/a_xx.ini', true);	
		$ini_rekart = parse_ini_file($rel_path.'xml/r_type.ini', true);	
		
// extract data
	$colnames = json_decode($_REQUEST['colnames'], true);
	$filters = json_decode($_REQUEST['filters'], true);	
// prepare query
	$query = "
		SELECT 
			QBN AS qbn, 
			COALESCE((SELECT CONCAT(VORNAME, ', ', NACHNAME) FROM qb_user WHERE LOGIN=SVT), 'N/A') AS svt,
			RTYPE AS rtype,
			(SELECT FU FROM qb_CLOSE WHERE qb_close.QBN=qbi.QBN) AS fu
		FROM 
			qbi 
	";

	$fstr = " 
		WHERE 
			BB='XX' AND
			QBREGDATE>=:sdat AND 
			QBREGDATE<=:edat 
	";
	if (count($filters) > 0) {
		$fstr .= " HAVING  ";
		$rules = $filters['rules'];
		foreach($rules as $key=>$value) {
			$fstr .= " " . $value['field'] . " LIKE '%" . $value['data'] . "%' ";
			if ($key < (count($rules)-1)) $fstr .= " AND ";
		}
	}
	$fstr .= "	
		ORDER BY 
			QBN DESC
	";	
	$query .= $fstr;
	$stmt = $db->prepare($query);
	$stmt->execute(
		array(
			':sdat' => $_REQUEST['s_d'],
			':edat' => $_REQUEST['e_d']
		)
	);	

/** Include PhpSpreadsheet */
  require $rel_path.'phpspreadsheet/autoload.php';

  use PhpOffice\PhpSpreadsheet\Spreadsheet;
  use PhpOffice\PhpSpreadsheet\Style\Border;
  use PhpOffice\PhpSpreadsheet\Style\Color;
  use PhpOffice\PhpSpreadsheet\Style\Font;
  use PhpOffice\PhpSpreadsheet\Writer\Xlsx;

  $spreadsheet = new Spreadsheet();
  $spreadsheet->getActiveSheet()->getPageSetup()->setOrientation(\PhpOffice\PhpSpreadsheet\Worksheet\PageSetup::ORIENTATION_LANDSCAPE);
  $spreadsheet->getActiveSheet()->getPageSetup()->setPaperSize(\PhpOffice\PhpSpreadsheet\Worksheet\PageSetup::PAPERSIZE_A4);
  $spreadsheet->getProperties()->setCreator("QB-oot")->setTitle("TOP Qb");
  $spreadsheet->getDefaultStyle()->getFont()->setName('Arial')->setSize(11);
  $sheet = $spreadsheet->getActiveSheet();
	
// define formats
  $styleThinBlackBorderOutline = [
    'borders' => [
      'borderStyle' => \PhpOffice\PhpSpreadsheet\Style\Border::BORDER_THIN,
      'color' => ['argb' => 'FF000000']
    ]
  ];  
  $styleThickBlackBorderOutline = [
    'borders' => [
      'borderStyle' => \PhpOffice\PhpSpreadsheet\Style\Border::BORDER_MEDIUM,
      'color' => ['argb' => 'FF000000']
    ]
  ]; 
  $styleGreyBackground = [
    'fill' => [
      'fillType' => \PhpOffice\PhpSpreadsheet\Style\Fill::FILL_SOLID,
      'color' => ['argb' => 'FFCCCCCC']
    ]
  ];
  $styleFilterBackground = [
    'fill' => [
      'fillType' => \PhpOffice\PhpSpreadsheet\Style\Fill::FILL_SOLID,
      'color' => ['argb' => 'FFEBF1DE']
    ]
  ]; 
  $styleHyperlink = [
    'font' => [
      'alignment' => ['horizontal' => \PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER],
      'color' => ['argb' => 'FF0000FF'],
      'underline' => Font::UNDERLINE_SINGLE
    ]
  ];
	
// insert filter settings
	$sheet->setCellValue("A1", "Filter");
	$sheet->getStyle('A1')->getFont()->setBold(true)->setSize(12);
	$sheet->mergeCells('A1:B1');
	$sheet->getStyle('A1:B1')->applyFromArray($styleThickBlackBorderOutline);
	$off = 1;	
	
	if (count($filters) > 0) {
		foreach($rules as $key=>$value) {
			$off++;
			$sheet->setCellValue("A".$off, $colnames[$value['field']]);
			if ($value['field'] == "rtype") {
				$sheet->setCellValue("B".$off, $r_type[$value['data']]);					
			} else {
				$sheet->setCellValue("B".$off, $value['data']);
			}
		}
	}
	$off++;
	$sheet->setCellValue("A".$off, $ini_axx['date_range'][$lng]);	
	$sheet->setCellValue("B".$off, $_REQUEST['sd_org1'] . " : " . $_REQUEST['ed_org1']);
	$off++;	
	$sheet->setCellValue("A".$off, $ini_axx['generated'][$lng]);	
	$sheet->setCellValue("B".$off, date('Y-M-d H:i:s', time()));
	$off++;
	$total_rows = $stmt->rowCount();
	$sheet->setCellValue("A".$off, $ini_axx['found_datasets'][$lng]);
	$sheet->setCellValue("B".$off, $total_rows);
	
	$sheet->getStyle('B'.$off)->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_LEFT);	
	$sheet->getStyle('B'.$off)->getFont()->setBold(true);	
	$sheet->getStyle('B2:B'.$off)->getFont()->setItalic(true);
// format filter box
	$sheet->getStyle('A1:B'.$off)->applyFromArray($styleFilterBackground)->applyFromArray($styleThickBlackBorderOutline);
// generate headlines
	$i = 1;
	$start_row = $off + 1;
	foreach ($colnames as $key=>$title) {
		$sheet->setCellValue(chr(64+$i).$start_row, $title);
		$i++;
	}
// format headlines
	$sheet->getStyle('A'.$start_row.':'.chr(64+count($colnames)).$start_row)->applyFromArray($styleThinBlackBorderOutline);
	$sheet->getStyle('A'.$start_row.':'.chr(64+count($colnames)).$start_row)->applyFromArray($styleGreyBackground);
	$sheet->getStyle('A'.$start_row.':'.chr(64+count($colnames)).$start_row)->getFont()->setBold(true)->setName('Arial')->setSize(10)->getColor()->setARGB('FF0000FF');
	$sheet->getStyle('A'.$start_row.':'.chr(64+count($colnames)).$start_row)->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_LEFT);	

// result is there, add amount of rows
	$i = 1;
	$data_row = $start_row + 1;
	global $relili;
	while($row = $stmt->fetch(PDO::FETCH_ASSOC)) {
		$i = 1;
		foreach($row as $key => $value) {	
			if ($key == "rtype") {
				$sheet->setCellValue(chr(64+$i).$data_row, $ini_rekart[$value][$lng]);
			} else {
        $richText = new \PhpOffice\PhpSpreadsheet\RichText\RichText();
        $richText->createText($value);
				$sheet->setCellValue(chr(64+$i).$data_row, $richText);
			}
			if ($key == "qbn") {
				$sheet->getCell(chr(64+$i).$data_row)->getHyperlink()->setUrl('http://' . $relili . $value);
        $sheet->getStyle(chr(64+$i).$data_row)->applyFromArray($styleHyperlink);		
			}
			$i++;
		}
		$data_row++;
	}

// set autofilter
	$sheet->setAutoFilter('A'.$start_row.':'.chr(64+count($colnames)).$start_row);
	
// format columns
	$i = 1;
	foreach ($colnames as $title=>$value) {
	// set column width for description including line break
		if ($title == "fu") {
			$sheet->getColumnDimension(chr(64+$i))->setWidth(100);			
			$sheet->getStyle(chr(64+$i).($start_row + 1).":".chr(64+$i).$sheet->getHighestRow())->getAlignment()->setWrapText(true); 
		} else {
			$sheet->getColumnDimension(chr(64+$i))->setAutoSize(true);
		}
		$i++;	
	}
	
// Rename worksheet
	$sheet->setTitle("overview");

// Set active sheet index to the first sheet, so Excel opens this as the first sheet
	$spreadsheet->setActiveSheetIndex(0);

// Redirect output to a client’s web browser (Excel2007)
	header('Content-Type: application/vnd.openxmlformats-officedocument.spreadsheetml.sheet');
	header('Content-Disposition: attachment;filename="qb-xx.xlsx"');
	header('Cache-Control: max-age=0');

  $writer = new Xlsx($spreadsheet);
  $writer->save('php://output');
	exit;
?>
