<?php
	include_once (dirname(__FILE__)."/../templates/db-def.php");
	require_once ($rel_path."support.php");
	$qb_support = new QBSupport;

	$routine = new Basic();
	echo $routine->execute();
	
	class Basic {
		
		public function __construct() 
		{
		}
		
		public function execute()
		{	
			global $db, $debug, $qb_support, $rel_path, $c_scheme;
	// called routine
			if (isset($_REQUEST['routine'])) {
				$sub_routine = $_REQUEST["routine"];
			} else {
				$json = file_get_contents('php://input');
				$obj = json_decode($json, true);
				$sub_routine = $obj["routine"];
			}
			switch ($sub_routine)
			{
				case "savevko":
			// save new supplier
					$query = "UPDATE qbbasic set SALESORG=:cre WHERE QBN=:qbn";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn'],
							':cre' => $_REQUEST['cre']
						)
					);						
			// write log
					$qb_support->writelog($_REQUEST['qbn'], "C", "BASIC", "Sales organization changed", $_REQUEST['nw'], $_REQUEST['old']);	
					break;				
				case "savesupplier":
			// save new supplier
					$query = "UPDATE qbbasic set SUPPLIER=:cre WHERE QBN=:qbn";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn'],
							':cre' => $_REQUEST['cre']
						)
					);						
			// write log
					$qb_support->writelog($_REQUEST['qbn'], 'C', "BASIC", 'Supplier changed', $_REQUEST['nw'], $_REQUEST['old']);	
					break;
//
// defect / delivered / checked handling
//
				case "save_stat":
					if ($_REQUEST['w'] == "def") {
						$query = "
							UPDATE
								qbbasic
							SET
								TEST_FAIL=:qty
							WHERE
								QBN=:qbn
						";
					} else if ($_REQUEST['w'] == "ins") {
						$query = "
							UPDATE
								qbbasic
							SET
								TEST_COUNT=:qty
							WHERE
								QBN=:qbn
						";						
					} else if ($_REQUEST['w'] == "del") {
						$query = "
							UPDATE
								qbbasic
							SET
								DEL_COUNT=:qty
							WHERE
								QBN=:qbn
						";						
					}
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn'],
							':qty' => $_REQUEST['q']
						)
					);							
					$result = "Done";
					return $result;		
					break;				
//
// Linked QB handling
//
// addqbref 	- 	add new reference to list
// selectqbref 	- 	generate list of possible references
// del_ref		- 	delete reference from list
//		
				case "addqbref":
					$qb_support->qbactivity($_REQUEST['qbn']);
					$_REQUEST['qbref'] = substr($_REQUEST['qbref'], 0, 9);
			// check if referenced QB has already references
					$query = "
						SELECT 
							QBREF 
						FROM 
							qb_qbref 
						WHERE 
							QBN=:qbl
						";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbl' => $_REQUEST['qbref']
						)
					);
			// write log
					$qb_support->writelog($_REQUEST['qbn'], "A", "BASIC", "Linked Q-Case added", $_REQUEST['qbref']);						
					while($row = $stmt->fetch(PDO::FETCH_NUM)) {		
						$query = "INSERT INTO qb_qbref (QBN, QBREF) VALUES (:qbn, :qbr)";
						$stmt2 = $db->prepare($query);
						$stmt2->execute(
							array(
								':qbn' => $_REQUEST['qbn'],
								':qbr' => $row[0]
							)
						);				
						$query = "INSERT INTO qb_qbref (QBN, QBREF) VALUES (:qbr, :qbn)";
						$stmt2 = $db->prepare($query);
						$stmt2->execute(
							array(
								':qbn' => $_REQUEST['qbn'],
								':qbr' => $row[0]
							)
						);					
					}
					$query = "INSERT INTO qb_qbref (QBN, QBREF) VALUES (:qbn, :qbr)";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn'],
							':qbr' => $_REQUEST['qbref']
						)
					);				
					$query = "INSERT INTO qb_qbref (QBN, QBREF) VALUES (:qbr, :qbn)";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn'],
							':qbr' => $_REQUEST['qbref']
						)
					);
					$lnk = array();
					$query = "
						SELECT 
							QBREF, 
							QBSTATUS,
							(SELECT IF(LIGHT=1,' *',''))
						FROM
							qb_qbref
						LEFT JOIN
							qbi
						ON
							qbi.QBN=qb_qbref.QBREF
						WHERE 
							qb_qbref.QBN=:qbi 
						ORDER BY 
							QBREF DESC
					";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbi' => $_REQUEST['qbn']
						)
					);
					while($row = $stmt->fetch(PDO::FETCH_NUM))
					{
						$lnk[] = $row;
					}						
					$result = json_encode($lnk);
					return $result;					
					break;
				case "selectqbref":
					if ($_REQUEST['fltr'] == "fall") {
						$query = "
							SELECT 
								QBN, 
								QBSTATUS,
								IF(LIGHT=1,' *',IF(TOP=1,' !',''))
							FROM 
								qbi 
							WHERE 
								QBSTATUS NOT IN ('D', 'M') AND 
								QBN NOT IN (SELECT QBREF FROM qb_qbref WHERE QBN=:noqb) AND 
								QBN!=:noqb AND 
								QBN LIKE '%" . $_REQUEST['q'] . "%'
							ORDER BY 
								QBN DESC
						";
						$stmt = $db->prepare($query);
						$stmt->execute(
							array(
								':noqb' => $_REQUEST['qbn']
							)
						);
					} else {
						$query = "
							SELECT 
								qbi.QBN, 
								QBSTATUS,
								IF(LIGHT=1,' *',IF(TOP=1,' !',''))
							FROM 
								qbi
							LEFT JOIN
								qbbasic
							ON
								qbi.QBN=qbbasic.QBN
							WHERE 
								QBSTATUS NOT IN ('D', 'M') AND 
								qbi.QBN NOT IN (SELECT QBREF FROM qb_qbref WHERE QBN=:noqb) AND 
								qbi.QBN!=:noqb AND 
								qbi.QBN LIKE '%" . $_REQUEST['q'] . "%' AND
								MNR=:mat
							ORDER BY 
								qbi.QBN DESC
						";
						$stmt = $db->prepare($query);
						$stmt->execute(
							array(
								':noqb' => $_REQUEST['qbn'],
								':mat' => $_REQUEST['mat']
							)
						);	
					}
					$rows = array();
					while($r = $stmt->fetch(PDO::FETCH_NUM)) {
						$rows[] = $r;
					}
					$result = json_encode($rows);
					return $result;	
					break;
				case "delref":
					$query = "DELETE FROM qb_qbref WHERE QBN=:qbn AND QBREF=:qbr";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn'],
							':qbr' => $_REQUEST['qbref']
						)
					);				
					$query = "DELETE FROM qb_qbref WHERE QBN=:qbr AND QBREF=:qbn";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn'],
							':qbr' => $_REQUEST['qbref']
						)
					);				
					$qb_support->qbactivity($_REQUEST['qbn']);
			// write log
					$qb_support->writelog($_REQUEST['qbn'], "D", "BASIC", "Linked Q-Case deleted", "", $_REQUEST['qbref']);	
					break;
// general form handling
//
// getdata	-	get page body data
// change	-	save changes in form
// savepdate - save production date
//				
				case "getdata":
					$ret = array();	
					$query = "
						SELECT 
							DESCRIPTION, 
							COALESCE(SUPPLIER, ''),
							CUSTOMER, 
							SALESORG, 
							LFS_NR, 
							DEL_COUNT, 
							TEST_COUNT, 
							TEST_FAIL, 
							PROD_DAT, 
							PROD_NR,
							(SELECT RTYPE FROM qbi WHERE QBN = :qbn) AS RTYPE,
							COALESCE((SELECT SUPPLIERNAME FROM qb_supplier WHERE SUPPLIERNR=SUPPLIER), '')
						FROM 
							qbbasic 
						WHERE 
							QBN=:qbn
					";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn']
						)
					);
					$row = $stmt->fetch(PDO::FETCH_NUM );
					list($ret["description"], $ret["supplier"], $ret["customer"], $ret["sales_org"], $ret["lfs_nr"], $ret["del_cnt"],
						$ret["test_cnt"], $ret["test_fail"], $ret["prod_dat"], $ret["prod_nr"], $ret["r_type"], $ret["supname"]) = $row;
					
					if (($ret["test_cnt"] > 0) AND ($ret["test_fail"] > 0)) {
						$ret["def_per"] = (floor(($ret["test_fail"] / $ret["test_cnt"]) * 10000) / 100 ) . "%";
					} else {
						$ret["def_per"] = "";
					}
					$ret["prod_dat"] = (($ret["prod_dat"] == "0000-00-00") OR ($ret["prod_dat"] == ""))?"":$ret["prod_dat"];
				// get attached files
					$query = "
						SELECT
							IDX AS id, 
							LINK AS link, 
							substring_index(LINK, '/', -1) AS lname 
						FROM 
							qbbasic_files 
						WHERE 
							QBN=:qbi 
						ORDER BY 
							IDX DESC
					";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbi' => $_REQUEST['qbn']
						)
					);
					$fls = array();
					while($row = $stmt->fetch(PDO::FETCH_NUM))
					{
						$fls[] = $row;
					}
					$lnk = array();
					$query = "
						SELECT 
							QBREF, 
							QBSTATUS,
							(SELECT IF(LIGHT=1,' *',''))
						FROM
							qb_qbref
						LEFT JOIN
							qbi
						ON
							qbi.QBN=qb_qbref.QBREF
						WHERE 
							qb_qbref.QBN=:qbi 
						ORDER BY 
							QBREF DESC
					";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbi' => $_REQUEST['qbn']
						)
					);
					while($row = $stmt->fetch(PDO::FETCH_NUM))
					{
						$lnk[] = $row;
					}						
					$result = json_encode(Array($ret, $qb_support->qb_status($_REQUEST['qbn']), $fls, $lnk));
					return $result;		
					break;		
				case "change":
					$query = "
						UPDATE 
							qbbasic 
						SET 
							CUSTOMER=:cus,
							LFS_NR=:lfs, 
							DESCRIPTION=:des, 
							DEL_COUNT=:lm, 
							TEST_COUNT=:tm, 
							TEST_FAIL=:tf, 
							PROD_NR=:pn
						WHERE 
							QBN=:qbn
					";			
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':cus' => $_REQUEST['cus'],
							':lfs' => $_REQUEST['lfs'],
							':des' => $_REQUEST['des'],
							':lm' => $_REQUEST['lm'],
							':tm' => $_REQUEST['tm'],
							':tf' => $_REQUEST['tf'],
							':pn' => $_REQUEST['pn'],
							':qbn' => $_REQUEST['qbn']
						)
					);
					$qb_support->qbactivity($_REQUEST['qbn']);
			// write log
					$qb_support->writelog($_REQUEST['qbn'], 'C', 'BASIC', 'Basic data saved');					
					return "Done";		
					break;
				case "savepdate":
					$query = "UPDATE qbbasic SET PROD_DAT=:dat WHERE QBN = :qbn";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn'],
							':dat' => $_REQUEST['dat']
						)
					);					
					$qb_support->qbactivity($_REQUEST['qbn']);
			// write log
					$qb_support->writelog($_REQUEST['qbn'], 'C', 'BASIC', 'Production date changed', $_REQUEST['nw'], $_REQUEST['old']);
					break;
//
// Linked files handling
//
// savelink 	- 	save new attachment(s)
// dellink		-	delete attachment
// filelist		-	load list of links into #file_list div
				case "savelink":			
					$fpath = "./files/" . $_REQUEST['qbn'] . "/";
					$files = json_decode($_REQUEST['fn'], true);
					$insid = array();
					foreach ($files AS $key=>$file) {
						$query = "INSERT INTO qbbasic_files (QBN, LINK) VALUES (:qbn, :fin)";
						$stmt = $db->prepare($query);
						$stmt->execute(
							array(
								':qbn' => $_REQUEST['qbn'],
								':fin' => $fpath.$file
							)
						);
						$insid[] = array($db->lastInsertId(),$fpath.$file, $file);
				// write log
						$qb_support->writelog($_REQUEST['qbn'], "A", "BASIC", "File added", $file);							
					}
					$qb_support->qbactivity($_REQUEST['qbn']);
					$result = json_encode($insid);
					return $result;		
					break;
				case "dellink":
				// delete file
					unlink("../files/" . $_REQUEST['qbn'] . '/' . $_REQUEST['fn']);
				// delete entry from database
					$query = "DELETE FROM qbbasic_files WHERE IDX=:idx";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':idx' => $_REQUEST['idx']
						)
					);
					$qb_support->qbactivity($_REQUEST['qbn']);
				// write log
					$qb_support->writelog($_REQUEST['qbn'], "D", "BASIC", "File deleted", "",$_REQUEST['fn']);
					break;
				case "filelist":
					$ini_basic = parse_ini_file($rel_path.'i18n/basic.ini', true);
					$lc = array($c_scheme['IE'], $c_scheme['IO']);
					$query = "
						SELECT 
							IDX AS id, 
							LINK AS link, 
							substring_index(LINK, '/', -1) AS lname 
						FROM 
							qbbasic_files 
						WHERE 
							QBN=:qbi 
						ORDER BY 
							IDX DESC
					";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbi' => $_REQUEST['qbn']
						)
					);
					$ret = "";
					$cc = 0;
					while($row = $stmt->fetch(PDO::FETCH_NUM))
					{
						$ret.="<p id='bsc_".$row[0]."' style='padding: 0px; margin: 0px; background-color: ".$lc[$cc%2].";' >";	
						$ret.="<span class='lspn' style='width: 470px; line-height: 16px;' onclick='window.open(\"".$row[1]."\", \"_blank\")'>".$row[2]."</span>";
						$ret.="<span class='icn_delete_b_n clckbtn' onclick='del_att(this)' data-type='title' data-lan='rem' title='".$ini_basic['rem'][$_SESSION['lng']]."'></span>";
						$ret.="</p>";
						$cc++;
					}						
					return $ret;		
					break;
			}
		}
	}
?>