<?php
	include_once (dirname(__FILE__)."/../templates/db-def.php");
	global $rel_path;
	require_once ($rel_path."support.php");
	$qb_support = new QBSupport;

	$routine = new Def();
	echo $routine->execute();
	
	class Def {
		
		public function __construct() 
		{
		}
		
		public function execute()
		{	
			global $db, $debug, $qb_support, $rel_path, $relili;
			$ini_mmenu = parse_ini_file($rel_path.'i18n/sub_menu.ini', true);
	// called routine
			$sub_routine = $_REQUEST["routine"];
			switch ($sub_routine)
			{
				case "newrecord":
					if ($qb_support->checkteam($_REQUEST['qbn'])) {
						return '$("#dialog-form").data("action", "N").dialog("open");';
					} else {					
				// check if any dataset is already available
						$query = "
							SELECT 
								SUM(
									(SELECT COUNT(*) FROM qb_docimm WHERE QBN=:qbn) +
									(SELECT COUNT(*) FROM qb_docdef WHERE QBN=:qbn)
								)
						";
						$stmt = $db->prepare($query);
						$stmt->execute(
							array(
								':qbn' => $_REQUEST['qbn']
							)
						);
						$r = $stmt->fetchColumn();						
					// no record yet, check team
						if (($r*1) >= ($qb_support->getoptions("forceteam", "tolerance")*1)) {
							return '
								jAlert(localTranslation["teammustbeinformed"][$globlan], localTranslation["attention"][$globlan]);
							';
					// record available, just continue
						} else {
							return '$("#dialog-form").data("action", "N").dialog("open");';
						}
					}
					break;					
				case "remcrecord":
			// write log
					$qb_support->writelog($_REQUEST['qbn'], "D", "DEFINITIVE", "8D acceptance date deleted");					
					$query = "
						DELETE FROM
							qb_8d
						WHERE
							TPE='A' AND
							QBN=:qbn
					";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn']
						)
					);
					$query = "
						UPDATE
							qb_def
						SET
							8D_ERH='0000-00-00'
						WHERE
							QBN=:qbn
					";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn']
						)
					);						
					$result = "Done";
					return $result;
					break;					
				case "checkadtrack":
				// plausi check for 8D accepted date
				// 1) check if (any) report is attached
					$query = "
						SELECT
							(SELECT COUNT(*) FROM qb_8d WHERE TPE='F' AND QBN=:qbn),
							(SELECT COUNT(*) FROM qb_8d WHERE TPE='R' AND QBN=:qbn),
							(SELECT COUNT(*) FROM qb_8d WHERE TPE='A' AND QBN=:qbn)
						FROM
							qb_8d
					";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn']
						)
					);
					$row = $stmt->fetch(PDO::FETCH_NUM);
					if ($row[0] == 0) {
				// no 8d report uploaded -> return error
						$result = "nofiles";
					} else if (($row[1] > 0) && ($row[2] == 0)) {
				// records entered but not assessment
						$result = "noassessment";
					} else {
						$result = "OK";
					}
					return $result;
					break;						
				case "delachtdtrack":
					$qb_support->qbactivity($_REQUEST['qbn']);
					if ($_REQUEST['tpe'] == "F") {
				// delete type is file -> delete file before removing database entry
						$query = "
							SELECT 
								8D_LINK 
							FROM 
								qb_8d 
							WHERE 
								IDX=:idx
						";
						$stmt = $db->prepare($query);
						$stmt->execute(
							array(
								':idx' => $_REQUEST['idx']
							)
						);
						$row = $stmt->fetch(PDO::FETCH_NUM);
						unlink("." . $row[0]);
					}
					$query = "
						DELETE FROM 
							qb_8d 
						WHERE
							IDX=:idx
					";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':idx' => $_REQUEST['idx']
						)
					);
					$result = "Done";
				// check if this was the last record
					$query = "
						SELECT
							COUNT(*)
						FROM
							qb_8d
						WHERE
							QBN=:qbn
					";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn']
						)
					);
				// yes, no more records -> delete 8D request
					if ($stmt->fetchColumn() == 0) {
				// reset 8d, 8d_ang and 8d_erh
						$query = "
							DELETE FROM 
								qb_def 
							WHERE 
								QBN=:qbn";
						$stmt = $db->prepare($query);
						$stmt->execute(
							array(
								':qbn' => $_REQUEST['qbn']
							)
						);
						$result	= 0;
					}
					return $result;
					break;					
				case "get_adtracking":
					$query = "
						SELECT 
							IDX, 
							8D_LINK, 
							8D_DATE,
							TPE
						FROM 
							qb_8d 
						WHERE 
							QBN=:qbn
						ORDER BY 
							IDX ASC
					";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn']
						)
					);
					$rows = array();
					while($r = $stmt->fetch(PDO::FETCH_ASSOC)) {
						$rows[] = $r;
					}
					$result = json_encode(Array($rows, $qb_support->qb_status($_REQUEST['qbn'])));
					return $result;
					break;				
				case "saveachtdtrack":
			// write log
					$qb_support->writelog($_REQUEST['qbn'], "A", "DEFINITIVE", "8D tracking added ", $_REQUEST['wht']);				
					$qb_support->qbactivity($_REQUEST['qbn']);	
					$query = "
						INSERT INTO 
							qb_8d
						(
							QBN,
							8D_LINK, 
							8D_DATE,
							TPE
						)
						VALUES
						(
							:qbn, 
							:wht, 
							:whn,
							'R'
						)
					";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn'],
							':wht' => $_REQUEST['wht'],
							':whn' => $_REQUEST['whn']
						)
					);					
					$result = "Done";
					return $result;	
					break;					
				case "setreminder":
			// write log
					$qb_support->writelog($_REQUEST['qbn'], "C", "DEFINITIVE", "Reminder for activity set for record ".$_REQUEST['id'], $_REQUEST['dat']);				
					$query = "
						UPDATE
							qb_docdef
						SET
							REMINDER=:rem
						WHERE
							IDX=:idx
					";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':rem' => $_REQUEST['dat'],
							':idx' => $_REQUEST['id'],
						)
					);							
					$result = "Done";
					return $result;	
					break;				
				case "getdata":
				// form specific data	
					$query = "SELECT 8D, 8D_AN, 8D_ERH FROM qb_def WHERE QBN=:qbn";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn']
						)
					);
					$row = $stmt->fetch(PDO::FETCH_ASSOC );	
				// get close status
					$query = "SELECT CSTATUS FROM qb_close WHERE QBN=:qbn";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn']
						)
					);
					$r = $stmt->fetch(PDO::FETCH_NUM);
					$a = ($r)?$r[0]:0;					
					$result = json_encode(Array($row, $qb_support->qb_status($_REQUEST['qbn']), $qb_support->qb_rtype($_REQUEST['qbn']), $a));
					return $result;	
					break;
				case "moveimm":
			// write log
					$qb_support->writelog($_REQUEST['qbn'], "D", "DEFINITIVE", "Activity moved to immediate actions", "", $_REQUEST['idx']);					
					$qb_support->qbactivity($_REQUEST['qbn']);
				// generate new unique ID
					$nid = uniqid('imm');
				// first get UID from docimm
					$query = "SELECT UID FROM qb_docdef WHERE IDX=:idx";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':idx' => $_REQUEST['idx']
						)
					);
					$uid = $stmt->fetchColumn();
				// then copy file links to docdef_files
					$query = "INSERT INTO qb_docimm_files (LUID, LINK) SELECT LUID, LINK FROM qb_docdef_files WHERE LUID=:uid";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':uid' => $uid
						)
					);		
				// now update LUID to new value
					$query = "UPDATE qb_docimm_files SET LUID=:luid WHERE LUID=:uid";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':uid' => $uid,
							':luid' => $nid
						)
					);				
				// and delete old files
					$query = "DELETE FROM qb_docdef_files WHERE LUID=:uid";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':uid' => $uid
						)
					);		
				// now copy basic data
					$query = "INSERT INTO qb_docimm (QBN, UID, WHT, WHN, LUPDATE, STAT, VISUM, UNTIL) 
						SELECT QBN, UID, WHT, WHN, NOW(), STAT, VISUM, UNTIL FROM qb_docdef WHERE IDX=:idx";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':idx' => $_REQUEST['idx']
						)
					);
					$insertId = $db->lastInsertId();
				// update UID
					$query = "UPDATE qb_docimm SET UID=:luid WHERE IDX=:lidx";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':luid' => $nid,
							':lidx' => $insertId
						)
					);
				// delete old dataset
					$query = "DELETE FROM qb_docdef WHERE IDX=:idx";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':idx' => $_REQUEST['idx']
						)
					);
				// done....
					$result = $nid;
					return $result;
					break;
				case "copyimm":
			// write log
					$qb_support->writelog($_REQUEST['qbn'], "C", "DEFINITIVE", "Activity copied to immediate actions", "", $_REQUEST['idx']);					
					$qb_support->qbactivity($_REQUEST['qbn']);
					$query = "SELECT WHT, WHN, STAT, VISUM, UNTIL FROM qb_docdef WHERE IDX=:idx";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':idx' => $_REQUEST['idx']
						)
					);
					$row = $stmt->fetch(PDO::FETCH_NUM );
					$uid = uniqid('imm');
					$query = "INSERT INTO qb_docimm (QBN, UID, WHT, WHN, LUPDATE, STAT, VISUM, UNTIL) 
						VALUES (:qbn, :uid, :wht, :whn, NOW(), :sts, :vis, :utl)";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn'],
							':uid' => $uid,
							':wht' => $row[0],
							':whn' => $row[1],
							':sts' => $row[2],
							':vis' => $row[3],
							':utl' => $row[4]
						)
					);
					$result = "Done";
					return $result;
					break;
				case "readlist":
			// work around with regexp to be compatible with old style of responsible (no user dropdown)
					$query = "
						SELECT 
							qb_docdef.IDX, 
							WHT, 
							DATE(WHN) AS WDATE, 
							DATE(LUPDATE) AS LUPDATE, 
							STAT, 
							COALESCE((SELECT CONCAT(NACHNAME, ', ',VORNAME) FROM qb_user WHERE LOGIN=VISUM), VISUM) AS VISUM, 
							UNTIL, 
							COALESCE(LINK, '') AS LINK, 
							UID,
							REMINDER,
              qb_docdef_files.IDX AS FIDX
						FROM 
							qb_docdef 
						LEFT JOIN 
							qb_docdef_files 
						ON 
							UID=LUID 
						WHERE 
							QBN=:qbn 
						ORDER BY " . $_REQUEST['orderby'] . " " . $_REQUEST['sorder'];					
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn'],
						)
					);
					$rows = array();
					while($r = $stmt->fetch(PDO::FETCH_ASSOC)) {
						$rows[] = $r;
					}
				// get teamapp status
					$query = "SELECT TEAMAPP FROM qb_imp WHERE QBN=:qbn";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn']
						)
					);
					$r = $stmt->fetch(PDO::FETCH_NUM);
					$a = ($r)?$r[0]:0;
				// get close status
					$query = "SELECT CSTATUS FROM qb_close WHERE QBN=:qbn";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn']
						)
					);
					$r = $stmt->fetch(PDO::FETCH_NUM);
					$b = ($r)?$r[0]:0;	
					$result = json_encode(Array($rows, $qb_support->qb_status($_REQUEST['qbn']), $qb_support->qb_weight($_REQUEST['qbn']), $a, $b));
					return $result;
					break;
				case "deletefile":
					$qb_support->qbactivity($_REQUEST['qbn']);
			// delete file
					$dfpath = "../files/" . $_REQUEST['qbn'] . '/' . $_REQUEST['fn'];
					unlink($dfpath);
					$query = "DELETE FROM qb_docdef_files WHERE IDX=:idx";
					$stmt = $db->prepare($query);
					$stmt->execute(array(':idx' => $_REQUEST['id']));
				// write log
					$qb_support->writelog($_REQUEST['qbn'], "D", "DEFINITVE", "File deleted for activity ".$_REQUEST['id'], $_REQUEST['fn']);
 					$result = "Done";						
					return $result;		
					break;
				case "savefiles":
					$qb_support->qbactivity($_REQUEST['qbn']);
					$query = "SELECT UID FROM qb_docdef WHERE IDX=:idx";
					$stmt = $db->prepare($query);
					$stmt->execute(array(':idx' => $_REQUEST['id']));
					$luid = $stmt->fetchColumn();
			// insert links into database on new record
					$files = json_decode($_REQUEST['fils'], true);
					foreach($files as $key=>$file) {
						$query = "INSERT INTO qb_docdef_files SET LUID=:lid, LINK=:lnk";
						$stmt = $db->prepare($query);
						$stmt->execute(array(':lid' => $luid, ':lnk' => $file));
				// write log
						$qb_support->writelog($_REQUEST['qbn'], "A", "DEFINITIVE", "File added for activity ".$luid, $file);							
					}
 					$result = "Done";
					return $result;
					break;
			// save new dataset
				case "savenew":
					$qb_support->qbactivity($_REQUEST['qbn']);
			// for manual QB: set whn = until
					$lid = uniqid('def');
					if ($qb_support->qb_status($_REQUEST['qbn']) == "M") {
						$query = "INSERT INTO qb_docdef (QBN, WHT, UNTIL, STAT, VISUM, WHN, LUPDATE, UID) 
							VALUES (:qbn, :wht, :utl, :sts, :vis, :utl, NOW(), :lid)";
						$stmt = $db->prepare($query);
						$stmt->execute(
							array(
								':qbn' => $_REQUEST['qbn'],
								':wht' => $_REQUEST['what'],
								':utl' => $_REQUEST['until'],
								':sts' => $_REQUEST['stat'],
								':vis' => $_REQUEST['visum'],
								':lid' => $lid
							)
						);
					} else {
						$query = "INSERT INTO qb_docdef (QBN, WHT, LUPDATE, UNTIL, STAT, VISUM, UID) 
							VALUES (:qbn, :wht, NOW(), :utl, :sts, :vis, :lid)";
						$stmt = $db->prepare($query);
						$stmt->execute(
							array(
								':qbn' => $_REQUEST['qbn'],
								':wht' => $_REQUEST['what'],
								':utl' => $_REQUEST['until'],
								':sts' => $_REQUEST['stat'],
								':vis' => $_REQUEST['visum'],
								':lid' => $lid
							)
						);
				// inform ai-owner if selected
						if ($_REQUEST['iai'] == 1) {
					// get ai owner data
							$query = "SELECT EMAIL, VORNAME, LANG FROM qb_user WHERE LOGIN=:lgi";
							$stmt = $db->prepare($query);
							$stmt->execute(array(':lgi' => $_REQUEST['visum']));
							$result = $stmt->fetch(PDO::FETCH_NUM );
						// load template file
							if ($result[2] == "") $result[2] = $qb_support->getOptions('fallbacklang', 'set');
							$template = file_get_contents($rel_path."mail/".$result[2].".definitive.ai_inform_new.html");
							$template = str_replace('{{username}}', $result[1], $template);
							$template = str_replace('{{formname}}', $ini_mmenu['definitiv'][$result[2]], $template);
							$template = str_replace('{{qbnummer}}', $_REQUEST['qbn'], $template);
							$template = str_replace('{{duedate}}', trim($_REQUEST['until']), $template);
							$template = str_replace('{{task}}', $_REQUEST['what'], $template);
							$template = str_replace('{{qblink}}', $relili . $_REQUEST['qbn'] . "&page=definitive", $template);
							preg_match('/<title>(.*)<\/title>/iU', $template, $subject);
							$subject = "QB".$_REQUEST['qbn'].": ".$subject[1];							
							$qb_support->templatemail($result[0], $subject, $template, "", "definitive_api:savenew");
						}						
					}
			// write log
					$qb_support->writelog($_REQUEST['qbn'], "A", "DEFINITIVE", "New activity added", $lid);						
					$result = $lid;
					return $result;
					break;
			// save edited docdef dataset
				case "saveedit":
			// write log
					$qb_support->writelog($_REQUEST['qbn'], "C", "DEFINITIVE", "Activity edited", $_REQUEST['ridx']);
					$qb_support->qbactivity($_REQUEST['qbn']);
					$infonclose = "";
			// for manual QB: set whn = until
					if ($qb_support->qb_status($_REQUEST['qbn']) == "M") {
						$query = "UPDATE qb_docdef SET WHT=:wht, LUPDATE=:utl, UNTIL=:utl, STAT=:sts, VISUM=:vis, WHN=:utl WHERE IDX=:idx";
						$stmt = $db->prepare($query);
						$stmt->execute(
							array(
								':idx' => $_REQUEST['ridx'],
								':wht' => $_REQUEST['what'],
								':utl' => $_REQUEST['until'],
								':sts' => $_REQUEST['stat'],
								':vis' => $_REQUEST['visum']
							)
						);				
					} else {
				// if inform pl on close is set get old status first
						if ($qb_support->getoptions("inform_qfleiter", "set") == "yes") {
							$query = "SELECT STAT FROM qb_docdef WHERE IDX=:idx";
							$stmt = $db->prepare($query);
							$stmt->execute(
								array(
									':idx' => $_REQUEST['ridx']
								)
							);
							$infonclose = $stmt->fetchColumn();
						}						
						$query = "UPDATE qb_docdef SET WHT=:wht, LUPDATE=NOW(), UNTIL=:utl, STAT=:sts, VISUM=:vis WHERE IDX=:idx";
						$stmt = $db->prepare($query);
						$stmt->execute(
							array(
								':idx' => $_REQUEST['ridx'],
								':wht' => $_REQUEST['what'],
								':utl' => $_REQUEST['until'],
								':sts' => $_REQUEST['stat'],
								':vis' => $_REQUEST['visum']
							)
						);
				// inform ai-owner if selected
						if ($_REQUEST['iai'] == 1) {
					// check if  ai-owner was changed
							if ($_REQUEST['oaio'] == $_REQUEST['visum']) {
						// no, is same -> get ai owner data
								$query = "SELECT EMAIL, VORNAME, LANG FROM qb_user WHERE LOGIN=:lgi";
								$stmt = $db->prepare($query);
								$stmt->execute(array(':lgi' => $_REQUEST['visum']));
								$result = $stmt->fetch(PDO::FETCH_NUM );
							// load template file
								if ($result[2] == "") $result[2] = $qb_support->getOptions('fallbacklang', 'set');
								$template = file_get_contents($rel_path."mail/".$result[2].".definitive.ai_inform_update.html");
								$template = str_replace('{{username}}', $result[1], $template);
								$template = str_replace('{{formname}}', $ini_mmenu['definitiv'][$result[2]], $template);
								$template = str_replace('{{qbnummer}}', $_REQUEST['qbn'], $template);
								$template = str_replace('{{duedate}}', trim($_REQUEST['until']), $template);
								$template = str_replace('{{task}}', $_REQUEST['what'], $template);
								$template = str_replace('{{qblink}}', $relili . $_REQUEST['qbn'] . "&page=definitive", $template);
								preg_match('/<title>(.*)<\/title>/iU', $template, $subject);
								$subject = "QB".$_REQUEST['qbn'].": ".$subject[1];							
								$qb_support->templatemail($result[0], $subject, $template, "", "definitive_api:saveedit.changedtask");
							} else {
						// yes, ai-owner changed -> get data of old and new ai owner
								$query = "
									SELECT 
										EMAIL, 
										VORNAME, 
										LANG,
										CONCAT(NACHNAME, ', ', VORNAME)
									FROM 
										qb_user 
									WHERE 
										LOGIN=:lgi								
								";
								$stmt = $db->prepare($query);
								$stmt->execute(array(':lgi' => $_REQUEST['visum']));
							// 1) inform new ai owner about task
								$result = $stmt->fetch(PDO::FETCH_NUM);
							// load template file
								if ($result[2] == "") $result[2] = $qb_support->getOptions('fallbacklang', 'set');
								$template = file_get_contents($rel_path."mail/".$result[2].".definitive.ai_inform_update_newowner.html");
								$template = str_replace('{{username}}', $result[1], $template);
								$template = str_replace('{{formname}}', $ini_mmenu['definitiv'][$result[2]], $template);
								$template = str_replace('{{qbnummer}}', $_REQUEST['qbn'], $template);
								$template = str_replace('{{duedate}}', $_REQUEST['until'], $template);
								$template = str_replace('{{task}}', $_REQUEST['what'], $template);
								$template = str_replace('{{qblink}}', $relili . $_REQUEST['qbn'] . "&page=definitive", $template);
								preg_match('/<title>(.*)<\/title>/iU', $template, $subject);
								$subject = "QB".$_REQUEST['qbn'].": ".$subject[1];							
								$qb_support->templatemail($result[0], $subject, $template, "", "definitive_api:saveedit.changedaiowner");
								$newusername = $result[3];
							// 2) inform old ai-owner about dimissal
								$query = "
									SELECT 
										EMAIL, 
										VORNAME, 
										LANG,
										CONCAT(NACHNAME, ', ', VORNAME)
									FROM 
										qb_user 
									WHERE 
										LOGIN=:lgi								
								";
								$stmt = $db->prepare($query);
								$stmt->execute(array(':lgi' => $_REQUEST['oaio']));							
								$result = $stmt->fetch(PDO::FETCH_NUM);
							// load template file
								if ($result[2] == "") $result[2] = $qb_support->getOptions('fallbacklang', 'set');
								$template = file_get_contents($rel_path."mail/".$result[2].".definitive.ai_inform_update_dismissal.html");
								$template = str_replace('{{username}}', $result[1], $template);
								$template = str_replace('{{formname}}', $ini_mmenu['definitiv'][$result[2]], $template);
								$template = str_replace('{{newuser}}', $newusername, $template);
								$template = str_replace('{{qbnummer}}', $_REQUEST['qbn'], $template);
								$template = str_replace('{{qblink}}', $relili . $_REQUEST['qbn'] . "&page=definitive", $template);
								preg_match('/<title>(.*)<\/title>/iU', $template, $subject);
								$subject = "QB".$_REQUEST['qbn'].": ".$subject[1];							
								$qb_support->templatemail($result[0], $subject, $template, "", "definitive_api:saveedit.dismissal");								
							}
						}						
					}
				// reset reminder is case is closed
					if ($_REQUEST['stat'] == "DONE") {
						$query = "UPDATE qb_docdef SET REMINDER='0000-00-00' WHERE IDX=:idx";
						$stmt = $db->prepare($query);
						$stmt->execute(
							array(
								':idx' => $_REQUEST['ridx']
							)
						);
					// inform pl if task closed and inform configured
						if ($qb_support->getoptions("inform_qfleiter", "set") == "yes") {
							if ($infonclose == "OPEN") {
							// old status open, new statu done -> inform pl
								$query = "SELECT EMAIL, VORNAME, LANG FROM qb_user LEFT JOIN qb_team ON LOGIN=NAME WHERE ROLLE='PL' AND QBN=:qbn";
								$stmt = $db->prepare($query);
								$stmt->execute(array(':qbn' => $_REQUEST['qbn']));
								$result = $stmt->fetch(PDO::FETCH_NUM );
								if ($result[2] == "") $result[2] = $qb_support->getOptions('fallbacklang', 'set');
							// load template file
								$template = file_get_contents($rel_path."mail/".$result[2].".definitive.ai_inform_done.html");
								$template = str_replace('{{username}}', $result[1], $template);
								$template = str_replace('{{formname}}', $ini_mmenu['definitiv'][$result[2]], $template);
								$template = str_replace('{{qbnummer}}', $_REQUEST['qbn'], $template);
								$template = str_replace('{{duedate}}', trim($_REQUEST['until']), $template);
								$template = str_replace('{{task}}', $_REQUEST['what'], $template);
								$template = str_replace('{{qblink}}', $relili . $_REQUEST['qbn'] . "&page=definitive", $template);
								preg_match('/<title>(.*)<\/title>/iU', $template, $subject);
								$subject = "QB".$_REQUEST['qbn'].": ".$subject[1];							
								$qb_support->templatemail($result[0], $subject, $template, "", "definitive_api:saveedit.closedtask");								
							}
						}						
					}
					$query = "SELECT UID FROM qb_docdef WHERE IDX=:idx";;
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':idx' => $_REQUEST['ridx']
						)
					);
					$result = $stmt->fetchColumn();
					return $result;
					break;
				case "deletefile":
			// write log
					$qb_support->writelog($_REQUEST['qbn'], "D", "DEFINITIVE", "File deleted", "", $_REQUEST['fn']);					
					$qb_support->qbactivity($_REQUEST['qbn']);
			// delete file
					$dfpath = "../files/" . $_REQUEST['qbn'] . '/' . $_REQUEST['fn'];
					unlink($dfpath);
					$result = $dfpath;
					return $result;
					break;
				case "deleterename":
					$qb_support->qbactivity($_REQUEST['qbn']);
			// delete files in edit mode: no direct delete, just mark them as deleted
					rename("../files/" . $_REQUEST['qbn'] . "/" . $_REQUEST['fn'], "../files/" . $_REQUEST['qbn'] . "/_dlt_" . $_REQUEST['fn']);
					$result = "Done";
					return $result;
					break;
				case "deleterecord":
			// write log
					$qb_support->writelog($_REQUEST['qbn'], "D", "DEFINITIVE", "Activity deleted", "", $_REQUEST['didx']);					
					$qb_support->qbactivity($_REQUEST['qbn']);
			// check for links and delete first
					$query = "SELECT LINK FROM qb_docdef_files WHERE LUID=:idx";		
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':idx' => $_REQUEST['didx']
						)
					);
					if ($stmt->rowCount() > 0) {
						while($row = $stmt->fetch(PDO::FETCH_NUM)) {
					// delete file
							$fullpath = "./files/" . $_REQUEST['qbn'] . "/".$row[0];
							unlink(".".$fullpath);					
						}		
					}
				// delete records from docdef_files
					$query = "DELETE FROM qb_docdef_files WHERE LUID=:idx";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':idx' => $_REQUEST['didx']
						)
					);					
				// now delete record
					$query = "DELETE FROM qb_docdef WHERE UID=:idx";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':idx' => $_REQUEST['didx']
						)
					);	
					$result = "Done";
					return $result;
					break;
				case "closerecord":
			// write log
					$qb_support->writelog($_REQUEST['qbn'], "C", "DEFINITIVE", "Activity closed", "", $_REQUEST['cidx']);					
					$qb_support->qbactivity($_REQUEST['qbn']);
			// set status from open to close
					$query = "
						UPDATE 
							qb_docdef 
						SET 
							STAT='DONE', 
							LUPDATE=NOW(),
							REMINDER='0000-00-00'
						WHERE 
							IDX=:idx
					";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':idx' => $_REQUEST['cidx']
						)
					);
				// inform pl if task closed and inform configured
					if ($qb_support->getoptions("inform_qfleiter", "set") == "yes") {
						$query = "SELECT WHT, UNTIL FROM qb_docdef WHERE IDX=:idx";	
						$stmt = $db->prepare($query);
						$stmt->execute(
							array(
								':idx' => $_REQUEST['cidx']
							)
						);
						list($what, $until) = $stmt->fetch(PDO::FETCH_NUM);
					// old status open, new statu done -> inform pl
						$query = "SELECT EMAIL, VORNAME, LANG FROM qb_user LEFT JOIN qb_team ON LOGIN=NAME WHERE ROLLE='PL' AND QBN=:qbn";
						$stmt = $db->prepare($query);
						$stmt->execute(array(':qbn' => $_REQUEST['qbn']));
						$result = $stmt->fetch(PDO::FETCH_NUM );
						if ($result[2] == "") $result[2] = $qb_support->getOptions('fallbacklang', 'set');
					// load template file
						$template = file_get_contents($rel_path."mail/".$result[2].".definitive.ai_inform_done.html");
						$template = str_replace('{{username}}', $result[1], $template);
						$template = str_replace('{{formname}}', $ini_mmenu['definitiv'][$result[2]], $template);
						$template = str_replace('{{qbnummer}}', $_REQUEST['qbn'], $template);
						$template = str_replace('{{duedate}}', $until, $template);
						$template = str_replace('{{task}}', $what, $template);
						$template = str_replace('{{qblink}}', $relili . $_REQUEST['qbn'] . "&page=definitive", $template);
						preg_match('/<title>(.*)<\/title>/iU', $template, $subject);
						$subject = "QB".$_REQUEST['qbn'].": ".$subject[1];							
						$qb_support->templatemail($result[0], $subject, $template, "", "definitive_api:closerecord.closedtask");
					}						
					$result = "Done";
					return $result;
					break;
				case "checkachtd":
					$query = "SELECT COUNT(*) FROM qb_def WHERE QBN=:qbn";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn']
						)
					);
					if ($stmt->fetchColumn() > 0) {
				// write log
						$qb_support->writelog($_REQUEST['qbn'], "C", "DEFINITIVE", "8D report update requested ");
						$result = "UPDATE";
						$query = "UPDATE qb_def SET 8D_AN=:ada, 8D=1 WHERE QBN=:qbn";
						$stmt = $db->prepare($query);
						$stmt->execute(
							array(
								':qbn' => $_REQUEST['qbn'],
								':ada' => $_REQUEST['ang']
							)
						);				
					} else {
				// write log
						$qb_support->writelog($_REQUEST['qbn'], "A", "DEFINITIVE", "New 8D report requested ");						
						$result = "INSERT";
						$query = "INSERT INTO qb_def (QBN, 8D, 8D_AN) VALUES(:qbn, 1, :ada)";
						$stmt = $db->prepare($query);
						$stmt->execute(
							array(
								':qbn' => $_REQUEST['qbn'],
								':ada' => $_REQUEST['ang']
							)
						);					
					}					
					return $result;
					break;
				case "saveaccdate":
			// write log
					$qb_support->writelog($_REQUEST['qbn'], "C", "DEFINITIVE", "8D acceptance date set", $_REQUEST['dat']);					
					$query = "UPDATE qb_def SET 8D_ERH=:dat WHERE QBN=:qbn";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn'],
							':dat' => $_REQUEST['dat']
						)
					);
				// check if tracking is enabled	
					if ($qb_support->getoptions('adtracking', 'set') == "yes") {
				// yes, add record to tracking
						$query = "
							INSERT INTO
								qb_8d
								(
									QBN,
									8D_LINK,
									8D_DATE,
									TPE
								)
							VALUES
								(
									:qbn,
									:txt,
									NOW(),
									'C'
								)
						";
						$stmt = $db->prepare($query);
						$stmt->execute(
							array(
								':qbn' => $_REQUEST['qbn'],
								':txt' => $_REQUEST['txt']
							)
						);						
					}				
					$qb_support->qbactivity($_REQUEST['qbn']);			
					$result = "Done";
					return $result;
					break;
				case "uncheckachtd":
			// write log
					$qb_support->writelog($_REQUEST['qbn'], "D", "DEFINITIVE", "8D request deleted");
			// 8d required unchecked -> delete all 8D files
					$query = "SELECT 8D_LINK FROM qb_8d WHERE QBN=:qbn AND TPE='F'";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn']
						)
					);
					while ($row = $stmt->fetch(PDO::FETCH_NUM)) {
						unlink("." . $row[0]);
					}
			// remove database entries
					$query = "DELETE FROM qb_8d WHERE QBN=:qbn";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn']
						)
					);
			// reset 8d, 8d_ang and 8d_erh
					$query = "DELETE FROM qb_def WHERE QBN=:qbn";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn']
						)
					);
					$qb_support->qbactivity($_REQUEST['qbn']);			
					$result = "Done";
					return $result;
					break;
				case "supplierdefined":
			// check if material number is defined
					$query = "SELECT MNR FROM qbbasic WHERE QBN=:qbn";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn']
						)
					);
					$row = $stmt->fetchColumn();
					if ($row != '0') {
				// yes, is defined, check if supplier is defined
						$query = "SELECT COALESCE(SUPPLIERNAME, 'N/A') FROM qbbasic LEFT JOIN qb_supplier ON SUPPLIER=SUPPLIERNR WHERE QBN=:qbn";
						$stmt = $db->prepare($query);
						$stmt->execute(
							array(
								':qbn' => $_REQUEST['qbn']
							)
						);
						$row = $stmt->fetchColumn();
						if ($row != "N/A") {
						// supplier is defined, check if tracking is enabled	
							if ($qb_support->getoptions('adtracking', 'set') == "yes") {
						// yes, add record to tracking
								$query = "
									INSERT INTO
										qb_8d
										(
											QBN,
											8D_LINK,
											8D_DATE,
											TPE
										)
									VALUES
										(
											:qbn,
											:txt,
											NOW(),
											'I'
										)
								";
								$stmt = $db->prepare($query);
								$stmt->execute(
									array(
										':qbn' => $_REQUEST['qbn'],
										':txt' => $_REQUEST['txt']
									)
								);						
							}						
						}
					}
					$result = $row;
					return $result;
					break;
				case "deleteachtd":
			// write log
					$qb_support->writelog($_REQUEST['qbn'], "D", "DEFINITIVE", "8D request deleted");				
					$qb_support->qbactivity($_REQUEST['qbn']);
			// check for links and delete first
					$query = "SELECT 8D_LINK FROM qb_8D WHERE IDX=:idx";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':idx' => $_REQUEST['idx']
						)
					);
					$row = $stmt->fetchColumn();
					unlink("." . $row);
					$query = "DELETE FROM qb_8D WHERE IDX=:idx";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':idx' => $_REQUEST['idx']
						)
					);
					$result = "." . $row[0];
					return $result;
					break;
				case "saveachtd":
			// write log
					$qb_support->writelog($_REQUEST['qbn'], "A", "DEFINITIVE", "8D file added ", $_REQUEST['fn']);				
					$qb_support->qbactivity($_REQUEST['qbn']);
					$query = "INSERT INTO qb_8d (8D_LINK, QBN, 8D_DATE) VALUES (:fin, :qbn, :dat)";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn'],
							':fin' => "./files/" . $_REQUEST['qbn'] . "/" . $_REQUEST['fn'],
							':dat' => date('Y-m-d')
						)
					);
					$result = $db->lastInsertId(); 
					return $result;
					break;
				case "getfiles":
					$query = "
						SELECT 
							IDX, 
							8D_LINK, 
							8D_DATE
						FROM 
							qb_8d 
						WHERE 
							QBN=:qbn AND 
							TPE='F' 
						ORDER BY 
							IDX DESC
					";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn']
						)
					);
					$rows = array();
					while($r = $stmt->fetch(PDO::FETCH_ASSOC)) {
						$rows[] = $r;
					}
					$result = json_encode(Array($rows, $qb_support->qb_status($_REQUEST['qbn'])));
					return $result;
					break;
				case "copymeasure":
			// write log
					$qb_support->writelog($_REQUEST['qbn'], "A", "DEFINITIVE", "Activity copied to implementation form");					
					$qb_support->qbactivity($_REQUEST['qbn']);		
					$query = "SELECT WHT, WHN FROM qb_docdef WHERE IDX=:idx";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':idx' => $_REQUEST['idx']
						)
					);
					$row = $stmt->fetch(PDO::FETCH_NUM);
					list($wht, $whn) = $row;
					$query = "SELECT COUNT(*) FROM qb_imp WHERE QBN=:qbn";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn']
						)
					);
					$row2 = $stmt->fetchColumn();
					if ($row2 == 0) {
						$query = "INSERT INTO qb_imp SET QBN=:qbn, DATE_REL_M=:whn, PLANNED_C_DATE=:whn, DESCRIPTION=:wht";
						$stmt = $db->prepare($query);
						$stmt->execute(
							array(
								':qbn' => $_REQUEST['qbn'],
								':whn' => $whn,
								':wht' => preg_replace('#<br\s*/?>#i', "", $wht)
							)
						);
					} else {
						$query = "UPDATE qb_imp SET DATE_REL_M=IF(DATE_REL_M='0000-00-00', :whn, DATE_REL_M), PLANNED_C_DATE=IF(PLANNED_C_DATE='0000-00-00', :whn, 
							PLANNED_C_DATE), DESCRIPTION=IF(DESCRIPTION='', :wht, CONCAT(DESCRIPTION, '\\r\\n', :wht)) WHERE QBN=:qbn";
						$stmt = $db->prepare($query);
						$stmt->execute(
							array(
								':qbn' => $_REQUEST['qbn'],
								':whn' => $whn,
								':wht' => preg_replace('#<br\s*/?>#i', "", $wht)
							)
						);	
					}
					$result = "Done";
					return $result;
					break;
			}
		}
	}
?>
