<?php
	include_once (dirname(__FILE__)."/../templates/db-def.php");
	global $rel_path;
	require_once ($rel_path."support.php");
	$qb_support = new QBSupport;

	$routine = new Doccom();
	echo $routine->execute();
	
	class Doccom {
		
		public function __construct() 
		{
		}
		
		public function execute()
		{	
			global $db, $debug, $qb_support;
	// called routine
			$sub_routine = $_REQUEST["routine"];
			switch ($sub_routine)
			{
				case "readlist":
			// read detail data sets
					$query = "SELECT qb_doccom.IDX, WHT, WHN, COALESCE(LINK, '') AS LINK, UID FROM qb_doccom LEFT JOIN " .
						"qb_doccom_files ON UID=LUID WHERE QBN=:qbn ORDER BY " . $_REQUEST['orderby'] . " " . $_REQUEST['sorder'];		
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn']
						)
					);
					$rows = array();
					while($r = $stmt->fetch(PDO::FETCH_ASSOC)) {
						$rows[] = $r;
					}
					$result = json_encode(Array($rows, $qb_support->qb_status($_REQUEST['qbn'])));
					return $result;		
					break;
				case "deletefile":
			// write log
					$qb_support->writelog($_REQUEST['qbn'], "D", "COMMUNICATION", "File deleted", "", $_REQUEST['fn']);					
					$qb_support->qbactivity($_REQUEST['qbn']);
			// delete file
					$dfpath = "../files/" . $_REQUEST['qbn'] . '/' . $_REQUEST['fn'];
					unlink($dfpath);
					$result = $dfpath;
					return $result;		
					break;
					
				case "setfilelinksonedit":
					$qb_support->qbactivity($_REQUEST['qbn']);
				// add new linkes to database
					if (isset($_REQUEST['tmpfls'])) {
						foreach ($_REQUEST['tmpfls'] as $nfn) {
							$query = "INSERT INTO qb_doccom_files SET LUID=:idx, LINK=:nfn";
							$stmt = $db->prepare($query);
							$stmt->execute(
								array(
									':idx' => $_REQUEST['lastid'],
									':nfn' => $nfn
								)
							);
					// write log
							$qb_support->writelog($_REQUEST['qbn'], "A", "COMMUNICATION", "File added", $nfn);								
						}
					}
				// ...and delete deleted files from server and database
					if (isset($_REQUEST['fbfr'])) {
						foreach ($_REQUEST['fbfr'] as $ofn) {
							unlink("../files/" . $_REQUEST['qbn'] . '/' . $ofn);
							$query = "DELETE FROM qb_doccom_files WHERE LUID=:idx AND LINK=:ofn";
							$stmt = $db->prepare($query);
							$stmt->execute(
								array(
									':idx' => $_REQUEST['lastid'],
									':ofn' => $ofn
								)
							);	
					// write log
							$qb_support->writelog($_REQUEST['qbn'], "D", "COMMUNICATION", "File deleted", "", $ofn);								
						}
					}
					$result = "Done";
					return $result;
					break;
				case "clearchangessoncancel":
			// remove all newly added files on cancel
					$qb_support->qbactivity($_REQUEST['qbn']);
					if (isset($_REQUEST['tmpfls'])) {
						foreach($_REQUEST['tmpfls'] AS $key=>$value) {
							unlink("../files/" . $_REQUEST['qbn'] . '/' . $value);
						}
					}
					$result = "Done";				
					return $result;		
					break;
				case "deleterecord":
			// write log
					$qb_support->writelog($_REQUEST['qbn'], "D", "COMMUNICATION", "Record deleted", "", $_REQUEST['didx']);					
					$qb_support->qbactivity($_REQUEST['qbn']);
			// check for links and delete first
					$query = "SELECT LINK FROM qb_doccom_files WHERE LUID=:idx";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':idx' => $_REQUEST['didx']
						)
					);
					if ($stmt->rowCount() > 0) {
						while($row = $stmt->fetch(PDO::FETCH_NUM)) {
							$fullpath = "./files/" . $_REQUEST['qbn'] . "/".$row[0];
							unlink(".".$fullpath);	
						}		
					}
			// now delete records from doccom_files
					$query = "DELETE FROM qb_doccom_files WHERE LUID=:idx";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':idx' => $_REQUEST['didx']
						)
					);
			// now delete record
					$query = "DELETE FROM qb_doccom WHERE UID=:idx";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':idx' => $_REQUEST['didx']
						)
					);
					$result = "Done";
					return $result;		
					break;
				case "clearfilesoncancel":
					$qb_support->qbactivity($_REQUEST['qbn']);
			// delete files from input field if form is cancelled
					if (isset($_REQUEST['tmpfls'])) {
						foreach($_REQUEST['tmpfls'] as $value) {  
							unlink ('../files/' . $_REQUEST['qbn'] . '/' . $value); 
						}
					}
					$result = "Done";
					return $result;		
					break;
				case "setfilelinksonsave":
					$qb_support->qbactivity($_REQUEST['qbn']);
			// insert links into database on new record
					if (isset($_REQUEST['tmpfls'])) {
						foreach($_REQUEST['tmpfls'] as $value) { 
							$query = "INSERT INTO qb_doccom_files (LUID, LINK) VALUES (:idx, :val)";
							$stmt = $db->prepare($query);
							$stmt->execute(
								array(
									':idx' => $_REQUEST['lastid'],
									':val' => $value
								)
							);
					// write log
							$qb_support->writelog($_REQUEST['qbn'], "A", "COMMUNICATION", "File added", $value);								
						}
					}
					$result = "Done";
					return $result;		
					break;
			// save new doccom dataset
				case "savenew":				
					$lid = uniqid('cst');
			// write log
					$qb_support->writelog($_REQUEST['qbn'], "A", "COMMUNICATION", "Record added", $lid);						
					$qb_support->qbactivity($_REQUEST['qbn']);
					$query = "INSERT INTO qb_doccom (QBN, WHT, WHN, UID) VALUES(:qbn, :wht, :whn, :lid)";			
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn'],
							':wht' => $_REQUEST['what'],
							':whn' => $_REQUEST['when'],
							':lid' => $lid
						)
					);
					$result = $lid;
					return $result;		
					break;
			// save edited doccom dataset
				case "saveedit":
			// write log
					$qb_support->writelog($_REQUEST['qbn'], "C", "COMMUNICATION", "Record changed", $_REQUEST['ridx']);					
					$qb_support->qbactivity($_REQUEST['qbn']);
					$query = "UPDATE qb_doccom SET WHT=:wht, WHN=:whn WHERE IDX=:idx";					
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':wht' => $_REQUEST['what'],
							':whn' => $_REQUEST['when'],
							':idx' => $_REQUEST['ridx']
						)
					);
					$query = "SELECT UID FROM qb_doccom WHERE IDX=:idx";;
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':idx' => $_REQUEST['ridx']
						)
					);
					$result = $stmt->fetchColumn();
					return $result;		
					break;
			}
		}			
	}
?>