<?php
	include_once (dirname(__FILE__)."/../templates/db-def.php");
	global $rel_path;
	require_once ($rel_path."support.php");
	$qb_support = new QBSupport;

	$routine = new Doccost();
	echo $routine->execute();
	
	class Doccost {
		
		public function __construct() 
		{
		}
		
		public function execute()
		{	
			global $db, $rel_path, $debug, $qb_support;
	// called routine
			$sub_routine = $_REQUEST["routine"];
			switch ($sub_routine)
			{
				case "getlist":
					$query = "
						SELECT 
							qb_doccost.IDX, 
							GRUND, 
							ART, 
							C_DATE, 
							MENGE, 
							COST, 
							CURRENCY, 
							FACTOR, 
							COALESCE(LINK, '') AS LINK, 
							UID, 
							COALESCE((SELECT CONCAT(NACHNAME, ', ', VORNAME) FROM qb_user WHERE LOGIN=WHO), '') AS WHO, 
							(MENGE*COST*FACTOR) AS SUM 
						FROM 
							qb_doccost 
						LEFT JOIN 
							qb_doccost_files 
						ON 
							UID=LUID 
						WHERE 
							QBN=:qbn 
						ORDER BY " . $_REQUEST['orderby'] . " " . $_REQUEST['sorder'];
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn']
						)
					);
					$rows = array();
					while($r = $stmt->fetch(PDO::FETCH_ASSOC)) {
						$rows[] = $r;
					}	
					$result = json_encode(Array($rows, $qb_support->qb_status($_REQUEST['qbn'])));
					return $result;		
					break;
				case "deleterecord":
					$qb_support->qbactivity($_REQUEST['qbn']);
			// check for links and delete first
					$query = "SELECT LINK FROM qb_doccost_files WHERE LUID=:uid";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':uid' => $_REQUEST['didx']
						)
					);
			// write log
					$qb_support->writelog($_REQUEST['qbn'], "A", "Costs", "Record deleted", "", $_REQUEST['didx']);						
					if ($stmt->rowCount() > 0) {
						while($row = $stmt->fetch(PDO::FETCH_NUM)) {
					// delete file
							$fullpath = "./files/" . $_REQUEST['qbn'] . "/".$row[0];
							unlink(".".$fullpath);	
						}		
					}
			// now delete records from docimm_files
					$query = "DELETE FROM qb_doccost_files WHERE LUID=:uid";		
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':uid' => $_REQUEST['didx']
						)
					);
			// now delete record
					$query = "DELETE FROM qb_doccost WHERE UID=:uid";		
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':uid' => $_REQUEST['didx']
						)
					);
					$result = "Done";
					return $result;		
					break;
			// save new dataset
				case "savenew":
					$lid = uniqid('cst');
			// write log
					$qb_support->writelog($_REQUEST['qbn'], "A", "Costs", "New record added", $lid);										
					$qb_support->qbactivity($_REQUEST['qbn']);
					$query = "INSERT INTO qb_doccost (QBN, GRUND, ART, C_DATE, MENGE, COST, CURRENCY, FACTOR, UID, WHO) 
						VALUES(:qbn, :wht, :art, :whn, :mge, :cst, :cur, :fac, :lid, :usr)";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn'],
							':wht' => $_REQUEST['grund'],
							':whn' => $_REQUEST['when'],
							':art' => $_REQUEST['art'],
							':mge' => $_REQUEST['menge'],
							':cst' => $_REQUEST['cost'],
							':cur' => $_REQUEST['currency'],
							':fac' => $_REQUEST['factor'],
							':lid' => $lid,
							':usr' => $_REQUEST['login']
						)
					);
					$result = $lid;
					return $result;		
					break;
			// save edited docimm dataset
				case "saveedit":
			// write log
					$qb_support->writelog($_REQUEST['qbn'], "C", "Costs", "Record changed", $_REQUEST['ridx']);					
					$qb_support->qbactivity($_REQUEST['qbn']);
					$query = "UPDATE qb_doccost SET GRUND=:wht, C_DATE=:whn, ART=:art, MENGE=:mge , COST=:cst , CURRENCY=:cur , FACTOR=:fac, WHO=:usr WHERE IDX=:idx";			
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':wht' => $_REQUEST['grund'],
							':whn' => $_REQUEST['when'],
							':art' => $_REQUEST['art'],
							':mge' => $_REQUEST['menge'],
							':cst' => $_REQUEST['cost'],
							':cur' => $_REQUEST['currency'],
							':fac' => $_REQUEST['factor'],
							':idx' => $_REQUEST['ridx'],
							':usr' => $_REQUEST['login']
						)
					);
					$query = "SELECT UID FROM qb_doccost WHERE IDX=:idx";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':idx' =>  $_REQUEST['ridx']
						)
					);
					$result = $stmt->fetchColumn();
					return $result;		
					break;					
				case "deletefile":
			// write log
					$qb_support->writelog($_REQUEST['qbn'], "A", "Costs", "File deleted", "", $_REQUEST['fn']);					
					$qb_support->qbactivity($_REQUEST['qbn']);
			// delete file
					$dfpath = $rel_path."files/" . $_REQUEST['qbn'] . '/' . $_REQUEST['fn'];
					unlink($dfpath);
					$result = $dfpath;
					return $result;		
					break;
				case "setfilelinksonedit":
					$qb_support->qbactivity($_REQUEST['qbn']);
				// add new linkes to database
					if (isset($_REQUEST['tmpfls'])) {
						foreach ($_REQUEST['tmpfls'] as $nfn) {
							$query = "INSERT INTO qb_doccost_files SET LUID=:idx, LINK=:nfn";
							$stmt = $db->prepare($query);
							$stmt->execute(
								array(
									':idx' => $_REQUEST['lastid'],
									':nfn' => $nfn
								)
							);
					// write log
							$qb_support->writelog($_REQUEST['qbn'], "A", "Costs", "File added", $nfn);							
						}
					}
				// ...and delete deleted files from server and database
					if (isset($_REQUEST['fbfr'])) {
						foreach ($_REQUEST['fbfr'] as $ofn) {
							unlink("../files/" . $_REQUEST['qbn'] . '/' . $ofn);
							$query = "DELETE FROM qb_doccost_files WHERE LUID=:idx AND LINK=:ofn";
							$stmt = $db->prepare($query);
							$stmt->execute(
								array(
									':idx' => $_REQUEST['lastid'],
									':ofn' => $ofn
								)
							);
					// write log
							$qb_support->writelog($_REQUEST['qbn'], "D", "Costs", "File deleted", "", $ofn);								
						}
					}
					$result = "Done";
					return $result;
					break;
				case "setfilelinksonsave":
					$qb_support->qbactivity($_REQUEST['qbn']);
			// insert links into database on new record
					if (isset($_REQUEST['tmpfls'])) {
						foreach($_REQUEST['tmpfls'] as $value) {  
							$query = "INSERT INTO qb_doccost_files (LUID, LINK) VALUES (:lid,:val)";
							$stmt = $db->prepare($query);
							$stmt->execute(
								array(
									':lid' => $_REQUEST['lastid'],
									':val' => $value
								)
							);
					// write log
							$qb_support->writelog($_REQUEST['qbn'], "A", "Costs", "File added changed", $value);							
						}
					}
					$result = "Done";
					return $result;		
					break;
				case "clearfilesoncancel":
					$qb_support->qbactivity($_REQUEST['qbn']);
			// delete files from input field if form is cancelled
					if (isset($_REQUEST['tmpfls'])) {
						foreach($_REQUEST['tmpfls'] as $value) {  
							unlink ('../files/' . $_REQUEST['qbn'] . '/' . $value); 
						}
					}
					$result = "Done";
					return $result;		
					break;
				case "clearchangessoncancel":
			// remove all newly added files on cancel
					$qb_support->qbactivity($_REQUEST['qbn']);
					if (isset($_REQUEST['tmpfls'])) {
						foreach($_REQUEST['tmpfls'] AS $key=>$value) {
							unlink("../files/" . $_REQUEST['qbn'] . '/' . $value);
						}
					}
					$result = "Done";				
					return $result;		
					break;				
			}
		}
	}
?>