<?php
	include_once (dirname(__FILE__)."/../templates/db-def.php");
	global $rel_path;
	require_once ($rel_path."support.php");
	$qb_support = new QBSupport;

	$routine = new Docmet();
	echo $routine->execute();
	
	class Docmet {
		
		public function __construct() 
		{
		}
		
		public function execute()
		{	
			global $db, $debug, $qb_support;
	// called routine
			$sub_routine = $_REQUEST["routine"];
			switch ($sub_routine)
			{
				case "readlist":
			// read detail data sets
					$query = "
						SELECT 
							qb_docmet.IDX, 
							WHT, 
							WHN, 
							COALESCE((SELECT CONCAT(NACHNAME, ', ', VORNAME) FROM qb_user WHERE LOGIN=VISUM), VISUM) AS VISUM, 
							COALESCE(LINK, '') AS LINK, 
							UID 
						FROM 
							qb_docmet 
						LEFT JOIN 
							qb_docmet_files 
						ON 
							UID=LUID 
						WHERE 
							QBN=:qbn 
						ORDER BY " . $_REQUEST['orderby'] . " " . $_REQUEST['sorder'];		
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn']
						)
					);
					$rows = array();
					while($r = $stmt->fetch(PDO::FETCH_ASSOC)) {
						$rows[] = $r;
					}
					$result = json_encode(Array($rows, $qb_support->qb_status($_REQUEST['qbn'])));
					return $result;		
					break;
				case "deletefile":
					$qb_support->qbactivity($_REQUEST['qbn']);
			// delete file
					$dfpath = "../files/" . $_REQUEST['qbn'] . '/' . $_REQUEST['fn'];
					unlink($dfpath);
			// write log
					$qb_support->writelog($_REQUEST['qbn'], "D", "MEETINGS", "File deleted", $_REQUEST['fn']);		
					break;
				case "deleterecord":
			// write log
					$qb_support->writelog($_REQUEST['qbn'], "D", "MEETINGS", "Record deleted", "", $_REQUEST['didx']);					
					$qb_support->qbactivity($_REQUEST['qbn']);
			// check for links and delete first
					$query = "SELECT LINK FROM qb_docmet_files WHERE LUID=:idx";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':idx' => $_REQUEST['didx']
						)
					);
					if ($stmt->rowCount() > 0) {
						while($row = $stmt->fetch(PDO::FETCH_NUM)) {
							$fullpath = "./files/" . $_REQUEST['qbn'] . "/".$row[0];
							@unlink(".".$fullpath);	
						}		
					}
			// now delete records from docmet_files
					$query = "DELETE FROM qb_docmet_files WHERE LUID=:idx";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':idx' => $_REQUEST['didx']
						)
					);
			// now delete record
					$query = "DELETE FROM qb_docmet WHERE UID=:idx";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':idx' => $_REQUEST['didx']
						)
					);
					$result = "Done";
					return $result;		
					break;					
				case "setfilelinksonedit":
					$qb_support->qbactivity($_REQUEST['qbn']);
				// add new linkes to database
					if (isset($_REQUEST['tmpfls'])) {
						foreach ($_REQUEST['tmpfls'] as $nfn) {
							$query = "INSERT INTO qb_docmet_files SET LUID=:idx, LINK=:nfn";
							$stmt = $db->prepare($query);
							$stmt->execute(
								array(
									':idx' => $_REQUEST['lastid'],
									':nfn' => $nfn
								)
							);
					// write log
							$qb_support->writelog($_REQUEST['qbn'], "A", "MEETINGS", "File added", $nfn);							
						}
					}
				// ...and delete deleted files from server and database
					if (isset($_REQUEST['fbfr'])) {
						foreach ($_REQUEST['fbfr'] as $ofn) {
							unlink("../files/" . $_REQUEST['qbn'] . '/' . $ofn);
							$query = "DELETE FROM qb_docmet_files WHERE LUID=:idx AND LINK=:ofn";
							$stmt = $db->prepare($query);
							$stmt->execute(
								array(
									':idx' => $_REQUEST['lastid'],
									':ofn' => $ofn
								)
							);
					// write log
							$qb_support->writelog($_REQUEST['qbn'], "D", "MEETINGS", "File deleted", "", $ofn);								
						}
					}
					$result = "Done";
					return $result;
					break;
				case "clearchangessoncancel":
			// remove all newly added files on cancel
					$qb_support->qbactivity($_REQUEST['qbn']);
					if (isset($_REQUEST['tmpfls'])) {
						foreach($_REQUEST['tmpfls'] AS $key=>$value) {
							unlink("../files/" . $_REQUEST['qbn'] . '/' . $value);
						}
					}
					$result = "Done";				
					return $result;		
					break;
				case "clearfilesoncancel":
					$qb_support->qbactivity($_REQUEST['qbn']);
			// delete files from input field if form is cancelled
					if (isset($_REQUEST['tmpfls'])) {
						foreach($_REQUEST['tmpfls'] as $value) {  
							unlink ('../files/' . $_REQUEST['qbn'] . '/' . $value); 
						}
					}
					$result = "Done";
					return $result;		
					break;
				case "setfilelinksonsave":
					$qb_support->qbactivity($_REQUEST['qbn']);
			// insert links into database on new record
					if (isset($_REQUEST['tmpfls'])) {
						foreach($_REQUEST['tmpfls'] as $value) { 
							$query = "INSERT INTO qb_docmet_files (LUID, LINK) VALUES (:idx, :val)";
							$stmt = $db->prepare($query);
							$stmt->execute(
								array(
									':idx' => $_REQUEST['lastid'],
									':val' => $value
								)
							);
					// write log
							$qb_support->writelog($_REQUEST['qbn'], "A", "MEETINGS", "File added", $value);							
						}
					}
					$result = "Done";
					return $result;		
					break;
			// save new docmet dataset
				case "savenew":
			// write log
					$qb_support->writelog($_REQUEST['qbn'], "A", "MEETINGS", "New record added");
					$qb_support->qbactivity($_REQUEST['qbn']);
					$lid = uniqid('met');
					$query = "INSERT INTO qb_docmet (QBN, WHT, WHN, VISUM, UID) VALUES(:qbn, :wht, :whn, :vis, :lid)";			
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn'],
							':wht' => $_REQUEST['what'],
							':whn' => $_REQUEST['when'],
							':vis' => $_REQUEST['visum'],
							':lid' => $lid
						)
					);
					$result = $lid;
					return $result;		
					break;
			// save edited docmet dataset
				case "saveedit":
			// write log
					$qb_support->writelog($_REQUEST['qbn'], "C", "MEETINGS", "Record changed", $_REQUEST['ridx']);
					$qb_support->qbactivity($_REQUEST['qbn']);
					$query = "UPDATE qb_docmet SET WHT=:wht, WHN=:whn, VISUM=:vis WHERE IDX=:idx";			
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':wht' => $_REQUEST['what'],
							':whn' => $_REQUEST['when'],
							':vis' => $_REQUEST['visum'],
							':idx' => $_REQUEST['ridx']
						)
					);
					$query = "SELECT UID FROM qb_docmet WHERE IDX=:idx";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':idx' => $_REQUEST['ridx']
						)
					);
					$result = $stmt->fetchColumn();
					return $result;		
					break;
			}
		}			
	}
?>