<?php
	include_once (dirname(__FILE__)."/../templates/db-def.php");
	global $rel_path;	
	require_once ($rel_path."support.php");
	
	$qb_support = new QBSupport;

	$routine = new Meta();
	echo $routine->execute();
	
	class Meta {
		
		public function __construct() 
		{
		}
		
		public function execute()
		{	
			global $db, $rel_path, $debug, $qb_support;
	// called routine
			$sub_routine = $_REQUEST["routine"];
			switch ($sub_routine)
			{
				case "getmeta":
			// load current meta data
					$query = "
						SELECT 
							IDX, 
							(SELECT TXT FROM qb_metadata WHERE REF=META) AS META
						FROM 
							qb_meta 
						WHERE 
							QBN=:qbn
					";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn']
						)
					);
					$rows = array();
					while($r = $stmt->fetch(PDO::FETCH_ASSOC)) {
						$rows[] = $r;
					}
					$result = json_encode(Array($rows, $qb_support->qb_status($_REQUEST['qbn'])));
					return $result;		
					break;
				case "addmeta":
					$qb_support->qbactivity($_REQUEST['qbn']);
			// add new meta data to QB
					$query = "INSERT INTO qb_meta (META, QBN) VALUES (:met, :qbn)";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn'],
							':met' => $_REQUEST['meta']
						)
					);
				// write log
					$qb_support->writelog($_REQUEST['qbn'], "A", "META", "Meta data added to q-case", $_REQUEST['meta']);						
					$result = $db->lastInsertId();				
					return json_encode(array($_REQUEST['meta'], $result));	
					break;
				case "delmeta":
				// write log
					$qb_support->writelog($_REQUEST['qbn'], "D", "META", "Meta data deleted from q-case", "", $_REQUEST['del']);										
					$qb_support->qbactivity($_REQUEST['qbn']);
			// delete meta data
					$query = "DELETE FROM qb_meta WHERE IDX=:idx";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':idx' => $_REQUEST['del']
						)
					);
					$result = "Done";
					return $result;		
					break;					
				case "addxml":
					$qb_support->qbactivity($_REQUEST['qbn']);
				// get new ref number
					$query = "
						SELECT 
							RIGHT(CONCAT('000', MAX(CAST(REF AS UNSIGNED))+1),3) 
						FROM 
							qb_metadata
					";
					$stmt = $db->query($query);
					$nv = $stmt->fetchColumn();
					$query = "
						INSERT INTO 
							qb_metadata 
						SET 
							REF=:ref,
							TXT=:txt
					";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':txt' => $_REQUEST['newmeta'],
							':ref' => $nv
						)
					);
			// add new meta data to QB
					$query = "INSERT INTO qb_meta (META, QBN) VALUES (:met, :qbn)";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn'],
							':met' => $nv
						)
					);
				// write log
					$qb_support->writelog($_REQUEST['qbn'], "A", "META", "Meta data added to q-case & tool", $nv);											
					$result = $db->lastInsertId();				
					return json_encode(array($nv, $_REQUEST['newmeta'], $result));
					break;
			}
		}
	}
?>