<?php
	include_once (dirname(__FILE__)."/../templates/db-def.php");
	global $rel_path;
	require_once ($rel_path."support.php");
	$qb_support = new QBSupport;

	$routine = new Docrew();
	echo $routine->execute();
	
	class Docrew {
		
		public function __construct() 
		{
		}
		
		public function execute()
		{	
			global $db, $debug, $qb_support;
	// called routine
			if (isset($_REQUEST['routine'])) {
				$sub_routine = $_REQUEST["routine"];
			} else {
				$json = file_get_contents('php://input');
				$obj = json_decode($json, true);
				$sub_routine = $obj["routine"];
			}
			switch ($sub_routine)
			{
				case "readlist":
			// read detail data sets
					$query = "
						SELECT
							IDX AS idx,
							(SELECT SUPPLIERNAME FROM qb_supplier WHERE SUPPLIERNR= SUPPLIER) AS suppliername, 
							ORDERNR AS ordernr, 
							DELIVERED AS menge, 
							RETURNED AS menge1, 
							DATE_OUT AS outdate, 
							DATE_IN AS indate, 
							(DELIVERED - RETURNED) AS offen 
						FROM 
							qb_nacharbeit 
						WHERE 
							QBN=:qbn
						ORDER BY
							offen DESC
					";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn']
						)
					);
					$rows = array();
					while($r = $stmt->fetch(PDO::FETCH_ASSOC)) {
						$rows[] = $r;
					}
					$result = json_encode($rows);
					return $result;		
					break;			
				case "allback":
					$qb_support->qbactivity($_REQUEST['qbn']);
					$query = "UPDATE qb_nacharbeit SET RETURNED=DELIVERED, DATE_IN=NOW() WHERE IDX=:idx";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':idx' => $_REQUEST['idx']
						)
					);
				// write log
					$qb_support->writelog($_REQUEST['qbn'], "C", "REWORK", "All parts back set");	
					break;
				case "delrework":			
					$qb_support->qbactivity($obj['qbn']);
					$query = "DELETE FROM qb_nacharbeit WHERE IDX=:idx";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':idx' => $obj['idx']
						)
					);
					$result = "Done";
					return $result;		
					break;
				case "savenew":
					$qb_support->qbactivity($obj['qbn']);
					$query = "
						INSERT INTO 
							qb_nacharbeit
							(
								QBN, 
								SUPPLIER, 
								ORDERNR, 
								DELIVERED, 
								RETURNED, 
								DATE_OUT, 
								DATE_IN
							) 
						VALUES 
							(
								:qbn, 
								:sup, 
								:sap, 
								:outm, 
								:inm,
								:outd, 
								:ind							
							)
					";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $obj['qbn'],
							':sup' => $obj['suppliername'],
							':sap' => $obj['ordernr'],
							':outm' => $obj['menge'],
							':inm' => $obj['menge1'],
							':outd' => $obj['out_org'],
							':ind' => $obj['in_org']							
						)
					);
				// write log
					$qb_support->writelog($obj['qbn'], "A", "REWORK", "Record added");	
					$result = "Done";
					return $result;		
					break;
				case "saveedit":
					$qb_support->qbactivity($obj['qbn']);
					$query = "
						UPDATE 
							qb_nacharbeit 
						SET
							RETURNED=:inm,
							DATE_IN=:ind
						WHERE 
							IDX=:idx
					";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':idx' => $obj['idx'],
							':inm' => $obj['menge1'],
							':ind' => $obj['in_org']
						)
					);
				// write log
					$qb_support->writelog($obj['qbn'], "C", "REWORK", "Record changed", $obj['idx']);						
					$result = "Done";
					return $result;		
					break;
			}
		}			
	}
?>