<?php
	include_once (dirname(__FILE__)."/../templates/db-def.php");
	global $rel_path;
	require_once ($rel_path."support.php");
	$qb_support = new QBSupport;
	
	$routine = new Fivewhy();
	echo $routine->execute();
	
	class Fivewhy {
		public function __construct() 
		{
		}
		
		public function execute()
		{	
			global $db, $rel_path, $debug, $qb_support;
			
	// called routine
			$sub_routine = $_REQUEST["routine"];
			switch ($sub_routine)
			{
				case "copyrootcause":
			// write log
					$qb_support->writelog($_REQUEST['qbn'], "C", "5WHY", "Root cause copied to closing form");				
					$qb_support->qbactivity($_REQUEST['qbn']);
					$query = "SELECT COUNT(*), FU FROM qb_close WHERE QBN=:qbn";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn']
						)
					);
					$row = $stmt->fetch(PDO::FETCH_NUM );			
					if ($row[0] > 0) {
						$query = "UPDATE qb_close SET FU=:root WHERE QBN=:qbn";
						$stmt = $db->prepare($query);
						$stmt->execute(
							array(
								':qbn' => $_REQUEST['qbn'],
								':root' => $row[1]."\n".$_REQUEST['root']
							)
						);				
					} else {
						$query = "INSERT INTO qb_close (QBN, FU) VALUES (:qbn, :root)";
						$stmt = $db->prepare($query);
						$stmt->execute(
							array(
								':qbn' => $_REQUEST['qbn'],
								':root' => $_REQUEST['root']
							)
						);					
					}
					$result = $row[0] . " - " . $row[1];					
					return $result;
					break;			
				case "deletecolumn":
			// write log
					$qb_support->writelog($_REQUEST['qbn'], "D", "5WHY", "Column deleted", "", $_REQUEST['col']);				
					$qb_support->qbactivity($_REQUEST['qbn']);
					$query = "SELECT WHYARRAY FROM qb_fivewhy WHERE QBN=:qbn";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn']
						)
					);
					$row = json_decode($stmt->fetchColumn(), true);			
					foreach($row as $singlerow) {
						unset($singlerow[$_REQUEST['col']]);		
						$i = 1;
						foreach($singlerow as $key=>$value) {
							if ($key != "id") {
								if ($key != "root") {
									$sw["w".$i]=$value;
								} else {
									$sw["root"]=$value;
								}
								$i++;
							} else {
								$sw["id"]=$value;
							}
						}
						$xw[] = $sw;
					}
					$rw = json_encode($xw);
					$query = "UPDATE qb_fivewhy SET WHYARRAY=:why WHERE QBN=:qbn";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn'],
							':why' => $rw
						)
					);					
					$result = "deleted column " . $_REQUEST['col'];
					return $result;
					break;					
				case "addcolumn":
			// write log
					$qb_support->writelog($_REQUEST['qbn'], "C", "5WHY", "Column added");				
					$qb_support->qbactivity($_REQUEST['qbn']);
					$query = "SELECT WHYARRAY FROM qb_fivewhy WHERE QBN=:qbn";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn']
						)
					);
					$row = json_decode($stmt->fetchColumn(), true);
					$newwhy = "w".(count($row[0])-1);
					$newarray = Array();
					foreach ($row as $key=>$value) {
						$value[$newwhy] = "";
						ksort($value);
						$a = array_shift($value);
						$b = array_shift($value);
						$value += Array("root"=>$b, "id"=>$a);
						$newarray[] = $value;
					}
					$newarray = json_encode($newarray);
					$query = "UPDATE qb_fivewhy SET WHYARRAY=:nwhy WHERE QBN=:qbn";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn'],
							':nwhy' => $newarray
						)
					);
					$result = "Done";
					return $result;
					break;
				case "reorder":
			// write log
					$qb_support->writelog($_REQUEST['qbn'], "C", "5WHY", "Rows re-ordered");
					$query = "SELECT WHYARRAY FROM qb_fivewhy WHERE QBN=:qbn";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn']
						)
					);
					$why = json_decode($stmt->fetchColumn(), true);
					$new = array_search($_REQUEST['newid'], array_column($why, 'id'));
					$old = array_search($_REQUEST['oldid'], array_column($why, 'id'));
					$output = array_slice($why, $old, 1);
					unset($why[$old]);
					array_splice($why, $new, 0, $output);
					$i = 10;
					foreach ($why as $key => $value) {
						$why[$key]['id'] = $i;
						$i = $i + 10;
					}
					$rw = json_encode($why);
					$query = "UPDATE qb_fivewhy SET WHYARRAY=:why WHERE QBN=:qbn";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn'],
							':why' => $rw
						)
					);	
					$result = "Done";					
					return $result;
					break;
				case "whysettings":
					$query = "SELECT WHYARRAY FROM qb_fivewhy WHERE QBN=:qbn";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn']
						)
					);			
					$result = json_encode(Array($stmt->rowCount(), $qb_support->qb_status($_REQUEST['qbn']), $stmt->fetchColumn()));
					return $result;
					break;					
				case "readwhystring":
					$query = "SELECT WHYARRAY FROM qb_fivewhy WHERE QBN=:qbn";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn']
						)
					);
					$rows = Array();
					if ($stmt->rowCount() == 0) {
						$rows = "0";
					} else {
						$rows = $stmt->fetchColumn();
					}
					return $rows;
					break;
				case "updatewhystring":
					$json = file_get_contents('php://input');
					$obj = json_decode($json, true);				
					$qb_support->qbactivity($obj['qbn']);
					$rowid = $obj['id'];
					unset ($obj['id']);
					$qbn = $obj['qbn'];
					unset ($obj['qbn']);
					$oper = $obj['oper'];
					unset ($obj['oper']);
					$query = "SELECT WHYARRAY FROM qb_fivewhy WHERE QBN=:qbn";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $qbn
						)
					);				
					$why=json_decode($stmt->fetchColumn(), true);
					$sw = Array();
					if ($oper == "del") {
						$i = 10;
						foreach($why as $row) {
							if ($row['id'] != $rowid) {
								$row['id'] = $i;
								$sw[] = $row;
								$i = $i + 10;
							}
						}
						if (count($sw) > 0) {
					// write log
							$qb_support->writelog($qbn, "D", "5WHY", "Row deleted", "", $rowid);								
					// entries left
							$query = "UPDATE qb_fivewhy SET WHYARRAY=:why WHERE QBN=:qbn";
							$rw = json_encode($sw);
							$stmt = $db->prepare($query);
							$stmt->execute(
								array(
									':qbn' => $qbn,
									':why' => $rw
								)
							);
						} else {
					// write log
							$qb_support->writelog($qbn, "D", "5WHY", "5Whys completely deleted ");									
					// no entry left
							$query = "DELETE FROM qb_fivewhy WHERE QBN=:qbn";
							$stmt = $db->prepare($query);
							$stmt->execute(
								array(
									':qbn' => $qbn
								)
							);						
						}
					} else if ($oper == "add") {
				// write log
						$qb_support->writelog($qbn, "A", "5WHY", "New Line added");								
					// new record added
						$lastrow = 0;
						if (count($why) > 0) {
							foreach($why as $row) {
								$sw[] = $row;
								$lastrow = $row['id'];
							}
							$lastrow = ($lastrow*1)+10;
							$obj['id'] = $lastrow;
							$sw[] = $obj;
							$query = "UPDATE qb_fivewhy SET WHYARRAY=:why WHERE QBN=:qbn";								
						} else {
							$lastrow = 10;
							$obj['id'] = $lastrow;
							$sw[] = $obj;								
							$query = "INSERT INTO qb_fivewhy (WHYARRAY, QBN) VALUES (:why, :qbn)";	
						}
						$rw = json_encode($sw);
						$stmt = $db->prepare($query);
						$stmt->execute(
							array(
								':qbn' => $qbn,
								':why' => $rw
							)
						);							
					} else if ($oper == "edit") {
					// edit record
						foreach($why as $row) {
							if ($row['id'] == $rowid) {
								$obj['id'] = $rowid;
								$sw[] = $obj;
							} else {
								$sw[] = $row;
							}
						}
				// write log
						$qb_support->writelog($qbn, "C", "5WHY", "Data changed");							
						$query = "UPDATE qb_fivewhy SET WHYARRAY=:why WHERE QBN=:qbn";
						$rw = json_encode($sw);
						$stmt = $db->prepare($query);
						$stmt->execute(
							array(
								':qbn' => $qbn,
								':why' => $rw
							)
						);					
					}	
					$result = "Done";
					return $result;
					break;
				case "recolumn":
			// write log
					$qb_support->writelog($_REQUEST['qbn'], "C", "5WHY", "Columns re-ordered");				
					$neworder = json_decode($_REQUEST['neworder'], true);			
					$query = "SELECT WHYARRAY FROM qb_fivewhy WHERE QBN=:qbn";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn']
						)
					);
					$oldstring =  $stmt->fetchColumn();
					$newstring = $oldstring;
					foreach ($neworder as $key=>$value) {
						if (($key+1) != $value) {
							$neww = '"_w'.$value.'"';
							$oldw = '"w'.($key+1).'"';							
							$newstring = str_replace($oldw, $neww, $newstring);								
						}
					}
					$newstring = str_replace('"_w', '"w', $newstring);					
					$newstring =json_decode($newstring, true);
					$newarray = Array();
					foreach ($newstring as $key=>$value) {		
						ksort($value);
						$a = array_shift($value);
						$b = array_shift($value);
						$value += Array("root"=>$b, "id"=>$a);
						$newarray[] = $value;
					}
					$newarray = json_encode($newarray);
					$query = "UPDATE qb_fivewhy SET WHYARRAY=:nwhy WHERE QBN=:qbn";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn'],
							':nwhy' => $newarray
						)
					);
					$result = "Done";
					return $result;
					break;					
			}
		}
	}
?>