<?php
	include_once (dirname(__FILE__)."/../templates/db-def.php");
	require_once ($rel_path."support.php");	
	$qb_support = new QBSupport;
	
	if (!isset($_SESSION)) session_start();

	$routine = new General();
	echo $routine->execute();
	
	class General {
		
		public function __construct() 
		{
		}
		
		public function execute()
		{	

			global $db, $rel_path, $debug, $db_path, $roleset, $qb_support, $rootlink;
	// called routine
			$sub_routine = $_REQUEST["routine"];
		
			switch ($sub_routine)
			{
				case "setlan":
					$_SESSION['lng'] = $_REQUEST['lng'];
					break;
// read general header data
				case "showflags":		
					$html = "<div id='flgpopup' class='flginfo'>";
					$query = "SELECT FLAGS FROM qb_user WHERE LOGIN=:lgi";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':lgi' => $_SESSION['lg']
						)
					);
					$result = str_split($stmt->fetchColumn());					
					$flags = parse_ini_file($rel_path.'xml/flags.ini', true);				
					foreach ($result as $key => $value)
					{				
						if ($value == "B") continue;
						if ($value == "C") continue;						
						$html .= "<span>- ".$flags[$value][$_SESSION['lng']]."</span><br />";
					}
					$html .= "</div>";			
					return $html;
					break;
				case "get_header_data":
				// define material name language
					$mncol = $qb_support->getLanMat($_REQUEST['qblan']);
				//	
					$ret = array();	
					$query = "SELECT RTYPE, LIGHT, QBSTATUS, QBREGDATE, LAST, DATEDIFF(NOW(), LAST) AS DD, CLSS FROM qbi WHERE QBN=:qbi";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbi' => $_REQUEST['qbn']
						)
					);
					$result = $stmt->fetchAll(PDO::FETCH_NUM );
          if (count($result) == 0) {
            $result[0] = array("", "", "", "", "", "", "");
          }
					list($ret["r_type"], $ret["qb_light"], $ret["qbsts"], $ret["reg_date"], $ret["last"], $ret["dd"], $ret["clss"]) = $result[0];
					$query = "SELECT CONCAT(VORNAME, ' ' , NACHNAME), IF(MNR='0','xxxxx-xxxxx',MNR), IF(MNR='0','xxxxx-xxxxx', 
						(SELECT TGRBZ_" . $mncol . " FROM qb_material WHERE TGR=MNR)), CRITERIUM, SHOWREQ, 
						REPREQ, BEST, MSTAT FROM qbbasic, qb_user WHERE QBN=:qbi and REQ=LOGIN";	
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbi' => $_REQUEST['qbn']
						)
					);			
					$result = $stmt->fetchAll(PDO::FETCH_NUM );
                    if (count($result) == 0) {
                        $result[0] = array("", "", "", "", "", "", "", "");
                    }                    
					list($ret["full_name"], $ret["mat_nr"], $ret["prod_bz"], $ret["crit"], $show, $ret["repreq"], $ret["best"], $ret["mstat"]) = $result[0];
					if ($show == 0) $ret["full_name"] = "********";
					$ret["progress"] = $qb_support->progress($_REQUEST['qbn']);					
					$result = json_encode($ret);
					return $result;		
					break;
				case "save_crm":
					$query = "
						UPDATE
							qbbasic
						SET
							BEST=:crm
						WHERE
							QBN=:qbn
					";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn'],
							':crm' => $_REQUEST['crm']
						)
					);
				// write log file
					$qb_support->writelog($_REQUEST['qbn'], "C", "HEADER", "CRM number changed", $_REQUEST['crm']);					
					break;
//
// qb number handling
//
				case "get_qbs":
					$query = "
						SELECT 
							QBN, 
							QBSTATUS, 
							IF(LIGHT=1,' *',IF(TOP=1,' !','')), 
							IF(LIGHT=1,'L',IF(TOP=1,'T',IF(RTYPE='V','V',IF(RTYPE='R','R','N')))) AS BC, 
							LIGHT,
							RTYPE,
							CLSS
						FROM 
							qbi 
						WHERE 
							QBN=:qbn
					";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn']
						)
					);
					$rows = array();
					while($r = $stmt->fetch(PDO::FETCH_NUM)) {
						$rows[] = array("id"=>$r[0], "text"=>$r[0] . $r[2], "status"=>$r[1], "bc"=>$r[3], "light"=>$r[4], "rtype"=>$r[5], "clss"=>$r[6]);
					}
					$result = json_encode($rows);
					return $result;		
					break;
				case "get_qb":
					$query = "
						SELECT 
							QBN, 
							QBSTATUS, 
							IF(LIGHT=1,' *',IF(TOP=1,' !','')), 
							IF(LIGHT=1,'L',IF(TOP=1,'T',IF(RTYPE='V','V',IF(RTYPE='R','R','N')))) AS BC, 
							LIGHT, 
							RTYPE,
							CLSS
						FROM 
							qbi 
						WHERE 
							QBSTATUS IN (".$_REQUEST['filter'].") AND 
							QBN LIKE '%".$_REQUEST['q']."%' 
						ORDER BY 
							QBN DESC
						LIMIT 0, 200
					";
					$stmt = $db->query($query);
					$rows = array();
					while($r = $stmt->fetch(PDO::FETCH_NUM)) {
						$rows[] = $r;
					}
					$result = json_encode($rows);
					return $result;					
					break;
//
// login / logout / lost password handling
//
				case "logout":
					session_destroy();
					$query = "SELECT FLAGS FROM qb_roles WHERE ROLE='USER'";
					$stmt = $db->query($query);
					$row1  = $stmt->fetch(PDO::FETCH_NUM );		
					$_SESSION['fn'] = "";			
					$_SESSION['rl'] = "USER";
					$_SESSION['fg'] = $row1[0];
					break;		
				case "checklogin":
                    return $qb_support->checklogin($_REQUEST['pwd'],$_REQUEST['login']);
					break;
                case "changepw":
                    return $qb_support->changepw($_REQUEST['pwd'], $_REQUEST['opwd'], $_REQUEST['mode']);
                    break;
				case "checkpw":
					$query = "SELECT COUNT(*) FROM qb_respw WHERE REQ=:usr AND UID=:uid";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':usr' => $_REQUEST['usr'],
							':uid' => $_REQUEST['uid']
						)
					);	
					$row = $stmt->fetchColumn();
					if ($row == 1) {						
                        $qb_support->setdefaultpw($_REQUEST['usr']);
						$query = "DELETE FROM qb_respw WHERE UID=:uid";
						$stmt = $db->prepare($query);
						$stmt->execute(
							array(
								':uid' => $_REQUEST['uid']
							)
						);					
						$result = "done";
					} else {
						$query = "UPDATE qb_respw SET CNTR=CNTR+1 WHERE UID=:uid";
						$stmt = $db->prepare($query);
						$stmt->execute(
							array(
								':uid' => $_REQUEST['uid']
							)
						);	
						$query = "SELECT CNTR FROM qb_respw WHERE UID=:uid";
						$stmt = $db->prepare($query);
						$stmt->execute(
							array(
								':uid' => $_REQUEST['uid']
							)
						);	
						$row = $stmt->fetchColumn();
						if ($row > 2) {
							$query = "DELETE FROM qb_respw WHERE  UID=:uid";
							$stmt = $db->prepare($query);
							$stmt->execute(
								array(
									':uid' => $_REQUEST['uid']
								)
							);	
							$result = "deleted";
						} else {
							$result = "notdone";
						}
					}
					return $result;		
					break;
				case "lostpw":
					global $rel_path;
			// delete old request (if any)
					$query = "DELETE FROM qb_respw WHERE REQ=:usr";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':usr' => $_REQUEST['usr']
						)
					);	
				// generate & save unique-Id
					$unid = md5(uniqid(microtime(),1).getenv("REMOTE_ADDR"));
					$query = "INSERT INTO qb_respw (REQ, UID, CNTR, EXPIRES) VALUES (:usr, :uid, 0, NOW())";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':usr' => $_REQUEST['usr'],
							':uid' => $unid
						)
					);
					$link = $rootlink . "res_pw.php?unid=" . $unid;
				// get user data
					$query = "SELECT EMAIL, VORNAME, LANG FROM qb_user WHERE LOGIN=:lgi";
					$stmt = $db->prepare($query);
					$stmt->execute(array(':lgi' => $_REQUEST['usr']));
					$result = $stmt->fetch(PDO::FETCH_NUM );
				// load template file
					if ($result[2] == "") $result[2] = $qb_support->getOptions('fallbacklang', 'set');
					$template = file_get_contents($rel_path."mail/".$result[2].".lost_password.html");
					$template = str_replace('{{username}}', $result[1], $template);
					$template = str_replace('{{resetlink}}', $link, $template);
					preg_match('/<title>(.*)<\/title>/iU', $template, $subject);
					$subject = $subject[1];							
					$qb_support->templatemail($result[0], $subject, $template, "", "general_api:lostpw");
					$result = "Done";
					return $result;		
					break;
//
// customer report request handling
//					
				case "addreportrequest":			
					$query = "UPDATE qbbasic SET REPREQ='Y' WHERE QBN=:qbn";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn']
						)
					);
				// write log file
					$qb_support->writelog($_REQUEST['qbn'], "C", "HEADER", "Customer report request changed", "NOT REQUIRED", "REQUIRED");
					$result = "Done";
					return $result;		
					break;					
				case "deletereportrequest":
					$query = "UPDATE qbbasic SET REPREQ='N' WHERE QBN=:qbn";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn']
						)
					);
				// write log file
					$qb_support->writelog($_REQUEST['qbn'], "C", "HEADER", "Customer report request changed", "REQUIRED", "NOT REQUIRED");				
					$result = "Done";
					return $result;		
					break;
//
// keep track handling
//
				case "getemail":
					$query = "
						SELECT 
							CONCAT(NACHNAME, ', ', VORNAME) AS FULLNAME, 
							LOGIN 
						FROM 
							qb_user 
						WHERE 
							ACTIVE = 1 AND 
							EMAIL NOT IN (SELECT EMAIL FROM qb_trackmail WHERE QBN=:qbn) 
						ORDER BY 
							NACHNAME
					";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn']
						)
					);	
					$rows = array();
					while($r = $stmt->fetch(PDO::FETCH_ASSOC)) {
						$rows[] = $r;
					}
					$result = json_encode($rows);
					return $result;		
					break;
				case "savetrackmail":
			// updated email
					$query = "UPDATE qb_trackmail SET EVENTS=:evn WHERE IDX=:idx";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':idx' => $_REQUEST['idx'],
							':evn' => $_REQUEST['evnt']
						)
					);
					$result = "Done";
					return $result;		
					break;
				case "newtrackmail":
			// new email
					$query = "INSERT INTO qb_trackmail SET QBN=:qbn, EMAIL=:ema, EVENTS=:evn";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qb'],
							':ema' => $_REQUEST['idx'],
							':evn' => $_REQUEST['evnt']
						)
					);
					$result = "Done";
					return $result;		
					break;
				case "deletetrackmail":
					$query = "DELETE FROM qb_trackmail WHERE IDX=:idx";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':idx' => $_REQUEST['idx']
						)
					);	
					$result = "Done";
					return $result;		
					break;
				case "trackmaillist":
					$query = "
						SELECT 
							IDX, 
							QBN, 
							(SELECT qb_user.EMAIL FROM qb_user WHERE LOGIN=qb_trackmail.EMAIL) AS EMAIL, 
							EVENTS 
						FROM 
							qb_trackmail 
						WHERE 
							QBN=:qbn
					";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn']
						)
					);	
					$rows = array();
					while($r = $stmt->fetch(PDO::FETCH_ASSOC)) {
						$rows[] = $r;
					}
					$result = json_encode($rows);
					return $result;		
					break;
// 
//
//	to be checked
//
//
				case "findwe":
					$query = "SELECT IDX, NACHNAME, VORNAME FROM qb_user WHERE ACTIVE = 1 AND DEPARTMENT='CEW' ORDER BY NACHNAME";
					$stmt = $db->query($query);
					$rows = array();
					while($r = $stmt->fetch(PDO::FETCH_ASSOC)) {
						$rows[] = $r;
					}
					$result = json_encode($rows);
					return $result;		
					break;
			// rename qb - check if number is OK
				case "checkrename":
					$query = "SELECT COUNT(*), COALESCE(QBSTATUS, 'F'), (SELECT MAX(QBN) FROM qbi) AS MQB FROM qbi WHERE QBN=:nqb";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':nqb' => $_REQUEST['newqb']
						)
					);
					$row = $stmt->fetch(PDO::FETCH_NUM);
					$result = $row[1] . ":" . $row[2];
					return $result;		
					break;
			// trigger emailing function
				case "eventmail2":
					$qb_support->event_mail2($_REQUEST['evnt'], $_REQUEST['qbn']);
					$result = "Done";
					return $result;		
					break;
				case "lookup":
			// define material name language
					$mncol = $qb_support->getLanMat($_REQUEST['qblan']);	
			// search for available material numbers
					$query = "SELECT TGR, TGRBZ_" . $mncol . " AS TGRBZ, MSTATUS FROM qb_material WHERE TGR LIKE :mst ORDER BY TGR";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':mst' => "%".$_REQUEST['mstr']."%"
						)
					);
					$rows = array();
					while($r = $stmt->fetch(PDO::FETCH_ASSOC)) {
						$rows[] = $r;
					}
					$result = json_encode($rows);
					return $result;		
					break;
				case "changemat":
                // get material status
                    $stmt = $db->prepare("SELECT MSTATUS FROM qb_material WHERE TGR=:mnr");
					$stmt->execute(array(':mnr' => $_REQUEST['midx']));
                    $mstat = $stmt->fetchColumn();
				// get old value for log file
					$stmt = $db->prepare("SELECT MNR, MSTAT FROM qbbasic WHERE QBN=:qbn");
					$stmt->execute(array(':qbn' => $_REQUEST['qbn']));
					$oc = $stmt->fetch(PDO::FETCH_NUM);
                    $mstatus = ($mstat=="")?$oc[1]:$mstat;          // fix for old data if no material status was set
				// save changed material number
					$query = "UPDATE qbbasic SET MNR=:mnr, MSTAT=:mst WHERE QBN=:qbn";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn'],
							':mnr' => $_REQUEST['midx'],
                            ':mst' => $mstatus
						)
					);
				// write log file
					$qb_support->writelog($_REQUEST['qbn'], "C", "HEADER", "Material number changed", $_REQUEST['midx'], $oc[0]);	
					$result = "Done";
					return $result;		
					break;
				case "getsites":
					$xmlstring = file_get_contents($rel_path."templates/8d_sender.xml");
					$FS = json_decode(json_encode((array) simplexml_load_string($xmlstring)), true);				
					$result = json_encode($FS);
					return $result;		
					break;					
			}
		}		
	}
?>