<?php
	include_once (dirname(__FILE__)."/../templates/db-def.php");
	global $rel_path;	
	require_once ($rel_path."support.php");
	$qb_support = new QBSupport;

	$routine = new Implement();
	echo $routine->execute();
	
	class Implement {
		
		public function __construct() 
		{
		}
		private function getteamcount($loc) {
			global $db;
		// get number of team members
			$query = "
				SELECT 
					COUNT(*) 
				FROM 
					qb_team 
				WHERE 
					QBN=:qbn AND 
					ROLLE='MEMBER'
			";
			$stmt = $db->prepare($query);
			$stmt->execute(
				array(
					':qbn' => $loc
				)
			);	
			$row = $stmt->fetch(PDO::FETCH_NUM );
			return ($row)?$row[0]:0;		
		}
		public function execute()
		{
			global $db, $debug, $qb_support, $relili, $rel_path, $c_scheme, $rootlink;	
	// called routine
			if (isset($_REQUEST['routine'])) {
				$sub_routine = $_REQUEST["routine"];
			} else {
				$json = file_get_contents('php://input');
				$obj = json_decode($json, true);
				$sub_routine = $obj["routine"];
			}
			switch ($sub_routine)
			{
				case "newrecord":
					$qb_support->qbactivity($_REQUEST['qbn']);
		// save form data
					$query = "SELECT COUNT(*) FROM qb_imp WHERE QBN=:qbn";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn']
						)
					);		
					if ($stmt->fetchColumn() == 0) {
				// write log
						$qb_support->writelog($_REQUEST['qbn'], "A", "IMPLEMENT", "Implementation description added");						
				// no data yet --> INSERT
						$query = "INSERT INTO qb_imp (DESCRIPTION, QBN) VALUES(:des, :qbn)";
						$stmt = $db->prepare($query);
						$stmt->execute(
							array(
								':qbn' => $_REQUEST['qbn'],
								':des' => $_REQUEST['des']
							)
						);
					} else {
				// write log
						$qb_support->writelog($_REQUEST['qbn'], "C", "IMPLEMENT", "Implementation description changed");						
				// data available --> UPDATE
						$query = "UPDATE qb_imp SET DESCRIPTION=:des WHERE QBN=:qbn";
						$stmt = $db->prepare($query);
						$stmt->execute(
							array(
								':qbn' => $_REQUEST['qbn'],
								':des' => $_REQUEST['des']
							)
						);					
					}
					break;						
				case "savepladate":
					$query = "SELECT COUNT(*), PLANNED_C_DATE FROM qb_imp WHERE QBN=:qbn";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn']
						)
					);
					$row = $stmt->fetch(PDO::FETCH_NUM);
					if ($row[0] == 0) {
				// write log
						$qb_support->writelog($_REQUEST['qbn'], "A", "IMPLEMENT", "Planned closure date added", $_REQUEST['dat']);
						$query = "INSERT INTO qb_imp (PLANNED_C_DATE, QBN) VALUES(:pla, :qbn)";
					} else {
				// write log
						$qb_support->writelog($_REQUEST['qbn'], "C", "IMPLEMENT", "Planned closure date changed", $_REQUEST['dat'], $row[1]);
						$query = "UPDATE qb_imp SET PLANNED_C_DATE=:pla WHERE QBN=:qbn";
					}
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn'],
							':pla' => $_REQUEST['dat']
						)
					);	
					break;
			// save presumable FFU
				case "saveffu":
				// check if record in qb_implement is already available
					$query = "SELECT COUNT(*), VFFU FROM qb_imp WHERE QBN=:qbn";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn']
						)
					);
					$row = $stmt->fetch(PDO::FETCH_NUM);
					if ($row[0] == 0) {
				// write log
						$qb_support->writelog($_REQUEST['qbn'], "A", "IMPLEMENT", "Presumable FFU set", $_REQUEST['dat']);										
						$query = "INSERT INTO qb_imp (VFFU, QBN) VALUES(:ffu, :qbn)";
					} else {
				// write log
						$qb_support->writelog($_REQUEST['qbn'], "C", "IMPLEMENT", "Presumable FFU changed", $_REQUEST['dat'], $row[1]);						
						$query = "UPDATE qb_imp SET VFFU=:ffu WHERE QBN=:qbn";
					}
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn'],
							':ffu' => $_REQUEST['dat']
						)
					);
				// check if record in qb_close is already available
					$query = "SELECT COUNT(*) FROM qb_close WHERE QBN=:qbn";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn']
						)
					);
					if ($stmt->fetchColumn() == 0) {
						$query = "INSERT INTO qb_close (FFU, QBN) VALUES(:ffu, :qbn)";
					} else {
						$query = "UPDATE qb_close SET FFU=:ffu WHERE QBN=:qbn";
					}
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn'],
							':ffu' => $_REQUEST['dat']
						)
					);					
					return "Done";		
					break;						
				case "saveusfdate":
					$query = "SELECT COUNT(*), DATE_REL_M FROM qb_imp WHERE QBN=:qbn";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn']
						)
					);
					$row = $stmt->fetch(PDO::FETCH_NUM);
					if ($row[0] == 0) {
				// write log
						$qb_support->writelog($_REQUEST['qbn'], "A", "IMPLEMENT", "Planned implementation date added", $_REQUEST['dat']);												
						$query = "INSERT INTO qb_imp (DATE_REL_M, QBN) VALUES(:usf, :qbn)";
					} else {
				// write log
						$qb_support->writelog($_REQUEST['qbn'], "C", "IMPLEMENT", "Planned implementation date changed", $_REQUEST['dat'], $row[1]);						
						$query = "UPDATE qb_imp SET DATE_REL_M=:usf WHERE QBN=:qbn";
					}
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn'],
							':usf' => $_REQUEST['dat']
						)
					);
					return "Done";		
					break;					
				case "getdata":
					$res = Array();
					$html = "";
					$query = "
						SELECT 
							DATE_REL_M, 
							PLANNED_C_DATE, 
							SEND_TO_SVT, 
							DATE_ACC_BY_SVT, 
							DESCRIPTION, 
							TEAMAPP, 
							REJECT, 
							OVERRULED, 
							VFFU
						FROM 
							qb_imp 
						WHERE 
							QBN=:qbn
					";				
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn']
						)
					);
					if($stmt->rowCount() > 0) {
						$row = $stmt->fetch(PDO::FETCH_NUM );					
						list($res['DRM'], $res['PCD'], $res['STS'], $res['ABS'], $res['DES'], $res['TAP'], $res['REJ'], $res['OVR'], $res['VFFU']) = $row;
				// get reject text
						if ($res['REJ'] > 0) {
							$query = "
								SELECT 
									REJDATE, 
									REJTEXT, 
									(SELECT CONCAT(NACHNAME, ', ', VORNAME) FROM qb_user WHERE LOGIN=REJLOGIN)
								FROM 
									qb_imp_rej
								WHERE 
									QBN=:qbn
								ORDER BY REJDATE DESC
							";				
							$stmt = $db->prepare($query);
							$stmt->execute(
								array(
									':qbn' => $_REQUEST['qbn']
								)
							);
							$html = "<div id='rejpopup' class='rejinfo'>";
							while($r = $stmt->fetch(PDO::FETCH_NUM)) {
								$html .= "<p style='margin-bottom: 2px;'>";
								$html .= "<label style='font-weight: bold;'>".$r[0]." - ".$r[2]."</label><br />";
								$html .= "<span>".$r[1]."</span>";
								$html .= "</p>";
							}
							$html .= "</div>";
						}
					} else {
						$res['REJ'] = 0;
						$res['TAP'] = 0;
						$res['OVR'] = "";
						$res['STS'] = "";
						$res['DRM'] = "0000-00-00";
						$res['PCD'] = "0000-00-00";
						$res['ABS'] = "0000-00-00";
						$res['DES'] = "";
						$res['VFFU'] = "";
					}
				// get number of team members
					$res['TC'] = $this->getteamcount($_REQUEST['qbn']);
					$qbs = $qb_support->qb_status($_REQUEST['qbn']);
					$asvt = array();
				// if team approval waiting for SVT release generate list of allowed approvers
					if (($res['TAP']*1) == 5) {
					// 1) original svt
						$query = "SELECT SVT FROM qbi WHERE QBN=:qbn";
						$stmt = $db->prepare($query);
						$stmt->execute(array(':qbn' => $_REQUEST['qbn']));
						$tsvt = $stmt->fetch(PDO::FETCH_NUM);
						$tsvt = $tsvt[0];
						array_push($asvt, $tsvt);
					// 2) representative (if defined)
						$query = "SELECT DSVT, COUNT(*) FROM qb_deputy WHERE SVT=:svt AND REP=1";
						$stmt = $db->prepare($query);
						$stmt->execute(array(':svt' => $tsvt));
						$tmp = $stmt->fetch(PDO::FETCH_NUM);
						if ($tmp[1] > 0) {
							array_push($asvt, $tmp[0]);
						}
					// 3) if deputy check for original svt
						$query = "SELECT SVT FROM qb_deputy WHERE DSVT=:svt";
						$stmt = $db->prepare($query);
						$stmt->execute(array(':svt' => $tsvt));
						while($tmp = $stmt->fetch(PDO::FETCH_NUM)) {
							array_push($asvt, $tmp[0]);
						}
					// remove duplicates
						$asvt = array_unique($asvt);
					}
					$result = json_encode(array($res, $qbs, $asvt, $html));
					return $result;		
					break;
				case "cancelteamstatus":
			// write log
					$qb_support->writelog($_REQUEST['qbn'], "A", "IMPLEMENT", "Implementation approval request to team cancelled");
				// load PL
					$query = "SELECT EMAIL FROM qb_user LEFT JOIN qb_team ON NAME=LOGIN WHERE QBN=:qbn AND ROLLE='PL'";			
					$stmt2 = $db->prepare($query);
					$stmt2->execute(array(':qbn' => $_REQUEST['qbn']));	
					$sender = $stmt2->fetchColumn();				
					$query = "SELECT VORNAME, EMAIL, LANG FROM qb_user LEFT JOIN qb_team ON NAME=LOGIN WHERE QBN=:qbn AND ROLLE='MEMBER'";		
					$stmt = $db->prepare($query);
					$stmt->execute(array(':qbn' => $_REQUEST['qbn']));
					while($result = $stmt->fetch(PDO::FETCH_NUM)) {	
					// load template file
						if ($result[2] == "") $result[2] = $qb_support->getOptions('fallbacklang', 'set');
						$template = file_get_contents($rel_path."mail/".$result[2].".implement.cancelteamstatus.html");
						$template = str_replace('{{qbnummer}}', $_REQUEST['qbn'], $template);
						$template = str_replace('{{username}}', $result[0], $template);
						$template = str_replace('{{qblink}}', $relili . $_REQUEST['qbn'] . "&page=basic", $template);
						preg_match('/<title>(.*)<\/title>/iU', $template, $subject);
						$subject = "QB".$_REQUEST['qbn'].": ".$subject[1];					
						$qb_support->templatemail($result[1], $subject, $template, $sender, "implement:cancelteamstatus");
					}
				// now delete entries from database
					$query = "DELETE FROM qb_imp_sts WHERE QBN=:qbn";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn']
						)
					);
				// update status
					$query = "UPDATE qb_imp SET TEAMAPP=0 WHERE QBN=:qbn";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn']
						)
					);
					$result = "Done";
					return $result;		
					break;
				case "getteamstatus":
					$query = "
						SELECT 
							CONCAT(VORNAME, ' ', NACHNAME) AS fname, 
							ST AS st, 
							DEL AS del, 
							INFORMED AS inf, 
							ANSWER AS ans,
							ST AS rs,
							LOGIN as lgi
						FROM 
							qb_imp_sts 
						LEFT JOIN 
							qb_user ON SU=LOGIN 
						WHERE 
							QBN=:qbn
					";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn']
						)
					);	
					$rows = array();
					while($r = $stmt->fetch(PDO::FETCH_ASSOC)) {
						$rows[] = $r;
					}
					$result = json_encode($rows);
					return $result;		
					break;
			// send request to SVT after overuling the team decision
				case "sendoverridesvt":
				// write log
					$qb_support->writelog($_REQUEST['qbn'], "A", "IMPLEMENT", "Implementation team decision overruled. Send", nl2br($_REQUEST['txt']));				
					$qb_support->qbactivity($_REQUEST['qbn']);
					$query = "UPDATE qb_imp set SEND_TO_SVT=:dat, TEAMAPP=5, OVERRULED=:ovr WHERE QBN=:qbn";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn'],
							':dat' => date('Y-m-d'),
							':ovr' => nl2br($_REQUEST['txt'])
						)
					);
				// inform SVT
					$qb_support->stsvt($_REQUEST['qbn'], "E5");
				// Event Mailing
					$qb_support->event_mail2("E5", $_REQUEST['qbn']);
					return $this->getteamcount($_REQUEST['qbn']);		
					break;
			// send request directly (or second time) to SVT		
				case "sendsvt":
			// write log
					$qb_support->writelog($_REQUEST['qbn'], "C", "IMPLEMENT", "Implementation approval request send to svt");				
					$query = "UPDATE qb_imp set SEND_TO_SVT=:dat, TEAMAPP=5 WHERE QBN=:qbn";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn'],
							':dat' => date('Y-m-d')
						)
					);
				// inform SVT
					$qb_support->stsvt($_REQUEST['qbn'], "E5");
				// Event Mailing
					$qb_support->event_mail2("E5", $_REQUEST['qbn']);
					$result = "Done";
					return $this->getteamcount($_REQUEST['qbn']);	
					break;
			// send approval request to one team member only
				case "sendteamsingle":
					$qb_support->qbactivity($_REQUEST['qbn']);
			// remove old vote from user
					$query = "DELETE FROM qb_imp_sts WHERE QBN=:qbn AND SU=:lgi";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn'],
							':lgi' => $_REQUEST['user']
						)
					);					
			// send request
					$query = "SELECT EMAIL FROM qb_user LEFT JOIN qb_team ON NAME=LOGIN WHERE QBN=:qbn AND ROLLE='PL'";					
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn']
						)
					);
					$sender = $stmt->fetchColumn();
					$query = "SELECT VORNAME, EMAIL, LANG FROM qb_user WHERE LOGIN=:lgi";		
					$stmt = $db->prepare($query);
					$stmt->execute(array(':lgi' => $_REQUEST['user']));
				// get individual token
					$unid = md5(uniqid(microtime(),1).getenv("REMOTE_ADDR"));
					$y_link = $rootlink . "voteimp.php?uid=" . $unid . "&vote=A";
					$n_link = $rootlink . "voteimp.php?uid=" . $unid . "&vote=R";				
					$query = "INSERT INTO qb_imp_sts (QBN, SU, ST, INFORMED, TOKEN) VALUES (:qbn, :sun, 'I', NOW(), :uid)";				
					$stmt2 = $db->prepare($query);
					$stmt2->execute(
						array(
							':qbn' => $_REQUEST['qbn'],
							':sun' => $_REQUEST['user'],
							':uid' => $unid
						)
					);
					$result = $stmt->fetch(PDO::FETCH_NUM);
				// write log
					$qb_support->writelog($_REQUEST['qbn'], "A", "IMPLEMENT", "Implementation approval request send to (single) user", $_REQUEST['user']);				
				// load template file
					if ($result[2] == "") $result[2] = $qb_support->getOptions('fallbacklang', 'set');
					$template = file_get_contents($rel_path."mail/".$result[2].".implement.send_vote.html");
					$template = str_replace('{{qbnummer}}', $_REQUEST['qbn'], $template);
					$template = str_replace('{{username}}', $result[0], $template);
					$template = str_replace('{{yescolor}}', $c_scheme['XO'], $template);
					$template = str_replace('{{yeslink}}', $y_link, $template);
					$template = str_replace('{{nocolor}}', $c_scheme['XW'], $template);
					$template = str_replace('{{nolink}}', $n_link, $template);
					$template = str_replace('{{qblink}}', $relili . $_REQUEST['qbn'] . "&page=basic", $template);
					preg_match('/<title>(.*)<\/title>/iU', $template, $subject);
					$subject = "QB".$_REQUEST['qbn'].": ".$subject[1];					
					$qb_support->templatemail($result[1], $subject, $template, $sender, "implement:send_vote");

				// set teamapp to 1 (= informed)
					$query = "UPDATE qb_imp SET TEAMAPP=1 WHERE QBN=:qbn";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn']
						)
					);
					$result = "Done";
					return $result;		
					break;					
			// send approval request to team
				case "sendteam":
					$qb_support->qbactivity($_REQUEST['qbn']);
			// check if resent - if yes delete old team data
					$query = "SELECT COUNT(*) FROM qb_imp_sts WHERE QBN=:qbn";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn']
						)
					);
					$row = $stmt->fetch(PDO::FETCH_NUM);
					if ($row[0] > 0) {
				// write log
						$qb_support->writelog($_REQUEST['qbn'], "C", "IMPLEMENT", "Implementation approval request re-send to team");
						$query = "DELETE FROM qb_imp_sts WHERE QBN=:qbn";
						$stmt = $db->prepare($query);
						$stmt->execute(
							array(
								':qbn' => $_REQUEST['qbn']
							)
						);
					} else {
				// write log
						$qb_support->writelog($_REQUEST['qbn'], "A", "IMPLEMENT", "Implementation approval request send to team");						
					}
			// send request
					$query = "SELECT EMAIL FROM qb_user LEFT JOIN qb_team ON NAME=LOGIN WHERE QBN=:qbn AND ROLLE='PL'";					
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn']
						)
					);
					$sender = $stmt->fetchColumn();
					$query = "SELECT VORNAME, EMAIL, LANG, LOGIN FROM qb_user LEFT JOIN qb_team ON NAME=LOGIN WHERE QBN=:qbn AND ROLLE='MEMBER'";		
					$stmt = $db->prepare($query);
					$stmt->execute(array(':qbn' => $_REQUEST['qbn']));
					while($result = $stmt->fetch(PDO::FETCH_NUM)) {
				// send individual email to each team member
						$unid = md5(uniqid(microtime(),1).getenv("REMOTE_ADDR"));
						$y_link = $rootlink . "voteimp.php?uid=" . $unid . "&vote=A";
						$n_link = $rootlink . "voteimp.php?uid=" . $unid . "&vote=R";				
						$query = "INSERT INTO qb_imp_sts (QBN, SU, ST, INFORMED, TOKEN) VALUES (:qbn, :sun, 'I', NOW(), :uid)";				
						$stmt2 = $db->prepare($query);
						$stmt2->execute(
							array(
								':qbn' => $_REQUEST['qbn'],
								':sun' => $result[3],
								':uid' => $unid
							)
						);						
					// load template file
						if ($result[2] == "") $result[2] = $qb_support->getOptions('fallbacklang', 'set');
						$template = file_get_contents($rel_path."mail/".$result[2].".implement.send_vote.html");
						$template = str_replace('{{qbnummer}}', $_REQUEST['qbn'], $template);
						$template = str_replace('{{username}}', $result[0], $template);
						$template = str_replace('{{yescolor}}', $c_scheme['XO'], $template);
						$template = str_replace('{{yeslink}}', $y_link, $template);
						$template = str_replace('{{nocolor}}', $c_scheme['XW'], $template);
						$template = str_replace('{{nolink}}', $n_link, $template);
						$template = str_replace('{{qblink}}', $relili . $_REQUEST['qbn'] . "&page=basic", $template);
						preg_match('/<title>(.*)<\/title>/iU', $template, $subject);
						$subject = "QB".$_REQUEST['qbn'].": ".$subject[1];					
						$qb_support->templatemail($result[1], $subject, $template, $sender, "implement:send_vote");
					}
				// set teamapp to 1 (= informed)
					$query = "UPDATE qb_imp SET TEAMAPP=1 WHERE QBN=:qbn";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn']
						)
					);
					$result = "Done";
					return $result;		
					break;
			// reject by SVT
				case "mailreject":
				// write log
					$qb_support->writelog($_REQUEST['qbn'], "A", "IMPLEMENT:", "Team implementation request rejected by Q-Case responsible");
					$qb_support->qbactivity($_REQUEST['qbn']);
			// SVT rejected technical closure, delete sent date
					$query = "UPDATE qb_imp set SEND_TO_SVT='0000-00-00', INFO='0000-00-00', TEAMAPP=3, REJECT=(REJECT+1) WHERE QBN=:qbn";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn']
						)
					);
			// write log file for rejects
					$query = "INSERT INTO qb_imp_rej SET REJDATE=NOW(), QBN=:qbn, REJLOGIN=:svt, REJTEXT=:rtxt";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn'],
							':svt' => $_SESSION['lg'],
							':rtxt' => $_REQUEST['txt']
						)
					);
			// inform PL about rejection
					$query = "SELECT EMAIL, VORNAME, LANG FROM qb_user, qb_team WHERE QBN=:qbn AND ROLLE='PL' and NAME=LOGIN";
					$stmt = $db->prepare($query);
					$stmt->execute(array(':qbn' => $_REQUEST['qbn']));
					$result = $stmt->fetch(PDO::FETCH_NUM );
				// load template file
					if ($result[2] == "") $result[2] = $qb_support->getOptions('fallbacklang', 'set');
					$template = file_get_contents($rel_path."mail/".$result[2].".implement.svt_reject.html");
					$template = str_replace('{{qbnummer}}', $_REQUEST['qbn'], $template);
					$template = str_replace('{{username}}', $result[1], $template);
					$template = str_replace('{{reason}}', $_REQUEST['txt'], $template);
					$template = str_replace('{{qblink}}', $relili . $_REQUEST['qbn'] . "&page=basic", $template);
					preg_match('/<title>(.*)<\/title>/iU', $template, $subject);
					$subject = "QB".$_REQUEST['qbn'].": ".$subject[1];
				// get sender email
					$query = "SELECT EMAIL FROM qb_user, qbi WHERE SVT=LOGIN AND QBN=:qbn";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn']
						)
					);	
					$svt = $stmt->fetchColumn();
				// send mail
					$qb_support->templatemail($result[0], $subject, $template, $svt, "implement_api:mailreject");
					return $this->getteamcount($_REQUEST['qbn']);
					break;
				case "approvedbysvt":
			// write log
					$qb_support->writelog($_REQUEST['qbn'], "C", "IMPLEMENT", "Implementation approval request approved by Q-Case responsible");	
					$qb_support->qbactivity($_REQUEST['qbn']);
		// SVT approved technical closure
					$query = "UPDATE qb_imp set DATE_ACC_BY_SVT=:dat, INFO='0000-00-00', TEAMAPP=4 WHERE QBN=:qbn";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn'],
							':dat' => date('Y-m-d')
						)
					);
			// change QB status from "open" to "technically closed"
					$query = "UPDATE qbi SET QBSTATUS='S' WHERE QBN=:qbn";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn']
						)
					);				
			// inform PL
				// inform pl that technical closure is accepted
					$query = "SELECT VORNAME, EMAIL, LANG FROM qb_user, qb_team WHERE QBN='" . $_REQUEST['qbn'] . "' AND ROLLE='PL' and NAME=LOGIN";
					$stmt = $db->prepare($query);
					$stmt->execute(array(':qbn' => $_REQUEST['qbn']));
					$result = $stmt->fetch(PDO::FETCH_NUM);					
				// load template file
					if ($result[2] == "") $result[2] = $qb_support->getOptions('fallbacklang', 'set');
					$template = file_get_contents($rel_path."mail/".$result[2].".implement.svt_accept.html");
					$template = str_replace('{{qbnummer}}', $_REQUEST['qbn'], $template);
					$template = str_replace('{{username}}', $result[0], $template);
					$template = str_replace('{{qblink}}', $relili . $_REQUEST['qbn'] . "&page=basic", $template);
					preg_match('/<title>(.*)<\/title>/iU', $template, $subject);
					$subject = "QB".$_REQUEST['qbn'].": ".$subject[1];					
					$qb_support->templatemail($result[1], $subject, $template, "", "implement:svt_accept");		
					return $this->getteamcount($_REQUEST['qbn']);	
					break;
		// check if all mandatory inputs are done before sending to SVT				
				case "checkrules":
			// check for standard immediate actions
					$query = "SELECT WES, ERSATZ, SONDERFREIGABE, CUS_BET, MIM, LPSG48, LPSK48 FROM qb_imm WHERE QBN=:qbn";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn']
						)
					);
					$row = $stmt->fetch(PDO::FETCH_NUM );
					if (($row[0]+$row[1]+$row[2]+$row[3]+$row[4]+$row[5]+$row[6]) == 0) {
						$result = 'no_std_action';
						return $result;
					}
			// check for open immediate actions
					$query = "SELECT COUNT(*) FROM qb_docimm WHERE STAT='OPEN' AND QBN=:qbn";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn']
						)
					);
					if ($stmt->fetchColumn() > 0) {
						$result = 'open_topics';
						return $result;
					}
			// check if customer and salesorg is filled if ffinder end customer		
					$query = "SELECT RTYPE, CUSTOMER, SALESORG FROM qbi LEFT JOIN qbbasic ON qbi.QBN=qbbasic.QBN WHERE qbi.QBN=:qbn";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn']
						)
					);
					$row = $stmt->fetch(PDO::FETCH_NUM );	
					if (($row[0] == "C") AND (($row[1] == '') OR ($row[2] == ''))) {
						$result = 'no_ekd';
						return $result;
					}
				// check for mandatory team if set			
					if ($qb_support->getoptions('mandatoryteam', 'set') == "yes") {
						$query = "SELECT MANDARRAY FROM qb_man WHERE QBN=:qbn";
						$stmt = $db->prepare($query);
						$stmt->execute(
							array(
								':qbn' => $_REQUEST['qbn']
							)
						);			
						$mnd = json_decode($stmt->fetchColumn(), true);
						$mnd = $mnd[0];
					// remove functions that are no longer active
						$Mandatory = parse_ini_file($rel_path.'xml/mandatory.ini', true);
						foreach($mnd as $array_key=>$array_item) {
							foreach($Mandatory as $key=>$value){
								if ($array_key == $key) {
									if ($value['inuse'] == "N") $mnd[$array_key] = "0";
								}
							}
						}
					// remove all not required functions
						foreach($mnd as $array_key=>$array_item) {
							if($mnd[$array_key] == "0") unset($mnd[$array_key]);
						}
					// now check if available
						$teamav = 0;
						foreach ($mnd as $key=>$value) {
							$query = "SELECT IF ('" . $key . "' IN (SELECT SHORT FROM qb_user, qb_team, qb_mantrans WHERE NAME=LOGIN AND qb_user.DEPARTMENT=qb_mantrans.DEPARTMENT AND QBN=:qbn), 0, 1)";
							$stmt = $db->prepare($query);
							$stmt->execute(
								array(
									':qbn' => $_REQUEST['qbn']
								)
							);						
							$teamav += $stmt->fetchColumn();
						}
						if ($teamav != 0) {
							$result = 'team_not_complete';
							return $result;
						}
					}
			// check for 5why
					$query = "SELECT COUNT(*), WHYARRAY FROM qb_fivewhy WHERE QBN=:qbn";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn']
						)
					);
					$row = $stmt->fetch(PDO::FETCH_NUM );
					if ($row[0] == 0) {
						$result = 'no_three_why';
						return $result;
					}
				// check entries
					$options  = json_decode( $row[1], TRUE );
					$ccount = Array();
					for ($i=0; $i<count($options);$i++) {
						$j=0;
						foreach ($options[$i] as $value) {
							$ccount[$j] = (empty($ccount[$j]))?strlen($value):($ccount[$j]+strlen($value));
							$j++;
						}
					}	
				// now check if there are empty fields
					$empty = false;
					for ($i=0; $i<count($ccount);$i++) {
						if ($ccount[$i] == 0) $empty = true;
					}
					if ($empty) {
						$result = 'no_three_why';
						return $result;
					}
			// check for q-case leader
					$query = "SELECT COUNT(NAME) FROM qb_team WHERE QBN=:qbn AND ROLLE='PL'";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn']
						)
					);	
					if ($stmt->fetchColumn() == 0) {
						$result = 'pl_first';
						return $result;
					}
			// check for svt
					$query = "SELECT SVT FROM qbi WHERE QBN=:qbn";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn']
						)
					);	
					if ($stmt->fetchColumn() == '') {
						$result = 'svt_first';
						return $result;
					}					
			// check for vko
					$query = "SELECT CUSTOMER, SALESORG FROM qbbasic WHERE QBN=:qbn";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn']
						)
					);
					$row = $stmt->fetch(PDO::FETCH_NUM );				
					if ($row[0] != '' AND $row[1] == '') {
						$result = 'no_vko';
						return $result;
					}				
					$result = "OK";
					return $result;
					break;
			}
		}
	}
?>