<?php
	include_once (dirname(__FILE__)."/../templates/db-def.php");
	require_once ($rel_path."support.php");
	$qb_support = new QBSupport;

	$routine = new Index();
	echo $routine->execute();
	
	class Index {
		
		public function __construct() 
		{
		}
		
		public function execute()
		{	
			global $db, $rel_path, $debug, $qb_support, $timezone;
	// called routine
			$sub_routine = $_REQUEST["routine"];
			switch ($sub_routine)
			{		
				case "newwe":
				// generate new QB number
					$query = "SELECT COALESCE((MAX(QBI)+1),1) FROM qbi WHERE QBY=:qby";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qby' => date('Y')
						)
					);
					$ni = substr("0000" . $stmt->fetchColumn(), -4);
					$qbi = date('Y') . "_" . $ni;
				// insert into QB-Index table
					$query = "INSERT INTO qbi (QBI, QBY, QBN, QBDATE, QBREGDATE, QBSTATUS, RTYPE) VALUES (:qbi, :qby, :qbn, :qbd, :qbr, 'N', :typ)";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbi' => $ni, 
							':qby' => date('Y'),
							':qbn' => $qbi,
							':qbd' => date('Y-m-d'),
							':qbr' => $_REQUEST['reg_date'],
							':typ' => $_REQUEST['r_type']
						)
					);
				// get material status
					$stmt = $db->prepare("SELECT MSTATUS FROM qb_material WHERE TGR=:tgr");
					$stmt->execute(array(':tgr' => $_REQUEST['mat_sel']));
					$mstat = $stmt->fetchColumn();					
				// insert details into detail table
					$query = "
						INSERT INTO 
							qbbasic 
								(
									QBN, 
									REQ, 
									MNR, 
									DESCRIPTION, 
									CRITERIUM, 
									LFS_NR, 
									MSTAT, 
									TEST_FAIL,
									DEL_COUNT,
									TEST_COUNT,
									SUPPLIER
								) 
						VALUES 
							(
								:qbi, 
								:req, 
								:mnr, 
								:des, 
								:krt, 
								:lfs,
								:mst,
								:def,
								:lief,
								:test,
								:sup								
							)
					";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbi' => $qbi, 
							':req' => $_REQUEST['requestor'], 
							':mnr' => $_REQUEST['mat_sel'],
							':des' => $_REQUEST['des'],
							':krt' => $_REQUEST['kriterium'],
							':lfs' => $_REQUEST['bstlfnr'],
							':mst' => $mstat,
							':def' => $_REQUEST['def'],
							':lief' => $_REQUEST['lief'],
							':test' => $_REQUEST['test'],
							':sup' => $_REQUEST['sup']							
						)
					);
				// setup initial mandatory team
					if ($qb_support->getoptions('mandatoryteam', 'set') == "yes"){		// only if mandatory team is enabled
						$Conf_man = parse_ini_file($rel_path.'xml/mandatory.ini', true);
						$mstr = "[{";
						foreach($Conf_man as $key=>$value){
							if ($value['inuse'] == "Y") {
								$mstr.='"'.$key.'":"1",';
							}
						}
						$mstr = substr($mstr, 0, -1)."}]";
						$query = "INSERT INTO qb_man (QBN, MANDARRAY) VALUES(:qbn, :mnd)";
						$stmt = $db->prepare($query);
						$stmt->execute(
							array(
								':qbn' => $qbi,
								':mnd' => $mstr
							)
						);
					}
					$qb_support->qbactivity($qbi);
				// Event Mailing
					$qb_support->event_mail2("E1", $qbi);
				// write log file
					$qb_support->writelog($qbi, "A", "INDEX", "QB opened by ".$_REQUEST['requestor']);				
					return "Done";
					break;
				case "newqb":
				// generate new QB number
					$query = "SELECT COALESCE((MAX(QBI)+1),1) FROM qbi WHERE QBY=:qby";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qby' => date('Y')
						)
					);
					$ni = substr("0000" . $stmt->fetchColumn(), -4);
					$qbi = date('Y') . "_" . $ni;
				// insert into QB-Index table
					$query = "INSERT INTO qbi (QBI, QBY, QBN, QBDATE, QBREGDATE, QBSTATUS, RTYPE) VALUES (:qbi, :qby, :qbn, :qbd, :qbr, :sts, :typ)";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbi' => $ni, 
							':qby' => date('Y'),
							':qbn' => $qbi,
							':qbd' => date('Y-m-d'),
							':qbr' => $_REQUEST['reg_date'],
							':sts' => "N",
							':typ' => $_REQUEST['r_type']
						)
					);
				// get material status
					$stmt = $db->prepare("SELECT MSTATUS FROM qb_material WHERE TGR=:tgr");
					$stmt->execute(array(':tgr' => $_REQUEST['mat_sel']));
					$mstat = $stmt->fetchColumn();
				// insert details into detail table
					$query = "
						INSERT INTO 
							qbbasic 
							(
								QBN, 
								REQ, 
								SHOWREQ, 
								REQINFO, 
								MNR, 
								DESCRIPTION, 
								CRITERIUM, 
								LFS_NR, 
								REPREQ, 
								MSTAT, 
								CLOSEMAIL, 
								CUSTOMER, 
								SALESORG, 
								TEST_FAIL
							) 
						VALUES 
							(
								:qbi,
								:req,
								:vis,
								:kpt,
								:mnr,
								:des,
								:krt,
								:lfs,
								:rrq,
								:mst,
								:clm,
								:cus,
								:vko,
								:def
							)
					";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbi' => $qbi, 
							':req' => $_REQUEST['requestor'], 
							':vis' => $_REQUEST['unsichtbar'],
							':kpt' => $_REQUEST['kptrk'],
							':mnr' => $_REQUEST['mat_sel'],
							':des' => $_REQUEST['des'],
							':krt' => $_REQUEST['kriterium'],
							':lfs' => $_REQUEST['bstlfnr'],
							':rrq' => $_REQUEST['rrq'],
							':mst' => $mstat,
							':clm' => $_REQUEST['clm'],
							':cus' => $_REQUEST['cus'],
							':vko' => $_REQUEST['vko'],
							':def' => $_REQUEST['def']							
						)
					);
			// insert as PL if requested
					if ($_REQUEST['qbleader'] == 1) {
						$query = "INSERT INTO qb_team (QBN, ROLLE, NAME, INFORMED) VALUES (:qbn, 'PL', :login, NOW())";
						$stmt = $db->prepare($query);
						$stmt->execute(
							array(
								':login' => $_REQUEST['requestor'],
								':qbn' => $qbi
							)
						);
						$qb_support->writelog($qbi, "A", "Team", $_REQUEST['requestor']." set as Q-Team leader by option 'assign myself'.");	
					// check if user has role and if not make him USER
						$query = "SELECT USR, FLAGS FROM qb_user WHERE LOGIN=:login";
						$stmt = $db->prepare($query);
						$stmt->execute(
							array(
								':login' => $_REQUEST['requestor']
							)
						);
						$row = $stmt->fetch(PDO::FETCH_NUM);
						list ($usr, $flag) = $row;
						if ($usr == '') {
							$query = "UPDATE qb_user SET USR = 'USER' WHERE LOGIN=:login";
							$stmt = $db->prepare($query);
							$stmt->execute(
								array(
									':login' => $_REQUEST['requestor']
								)
							);
						}
					// now check is user has role "F"
						if (!in_array("F", str_split($flag))) {
							$query = "UPDATE qb_user SET FLAGS = CONCAT(FLAGS, 'F') WHERE LOGIN=:login";
							$stmt = $db->prepare($query);
							$stmt->execute(
								array(
									':login' => $_REQUEST['requestor']
								)
							);							
						}
					// set QB status to "open" (since PL is already assigned)
						$query = "UPDATE qbi SET QBSTATUS='O' WHERE QBN=:qbn";
						$stmt = $db->prepare($query);
						$stmt->execute(
							array(
								':qbn' => $qbi
							)
						);
					}
				// setup initial mandatory team
					if ($qb_support->getoptions('mandatoryteam', 'set') == "yes"){		// only if mandatory team is enabled
						$Conf_man = parse_ini_file($rel_path.'xml/mandatory.ini', true);
						$mstr = "[{";
						foreach($Conf_man as $key=>$value){
							if ($value['inuse'] == "Y") {
								$mstr.='"'.$key.'":"1",';
							}
						}
						$mstr = substr($mstr, 0, -1)."}]";
						$query = "INSERT INTO qb_man (QBN, MANDARRAY) VALUES(:qbn, :mnd)";
						$stmt = $db->prepare($query);
						$stmt->execute(
							array(
								':qbn' => $qbi,
								':mnd' => $mstr
							)
						);
					}				
				// add to team if requested
					if ($_REQUEST['addteam'] == 1) {
						$query = "INSERT INTO qb_team (QBN, NAME, ROLLE) VALUES(:qbn, :login, 'MEMBER')";
						$stmt = $db->prepare($query);
						$stmt->execute(
							array(
								':login' => $_REQUEST['requestor'],
								':qbn' => $qbi
							)
						);
					}					
					$qb_support->qbactivity($qbi);
				// Event Mailing
					$qb_support->event_mail2("E1", $qbi);				
				// confirmation mail requested?
					if ($_REQUEST['cmail'] == 1) {
						$query = "SELECT SENDERMAIL FROM qb_conf";
						$stmt = $db->query($query);
						$sendermail = $stmt->fetchColumn();
				// get email address of requestor
						$query = "SELECT EMAIL, VORNAME, LANG FROM qb_user WHERE LOGIN=:lgi";
						$stmt = $db->prepare($query);
						$stmt->execute(array(':lgi' => $_REQUEST['requestor']));
						$result = $stmt->fetch(PDO::FETCH_NUM );
						if ($result[0] != '') {
							global $relili;	
							$link = $relili . $qbi;
						// load template file
							if ($result[2] == "") $result[2] = $qb_support->getOptions('fallbacklang', 'set');
							$template = file_get_contents($rel_path."mail/".$result[2].".index.confirm_qbopen.html");
							$template = str_replace('{{username}}', $result[1], $template);
							$template = str_replace('{{qbnummer}}', $qbi, $template);
							$template = str_replace('{{qblink}}', $link, $template);
							preg_match('/<title>(.*)<\/title>/iU', $template, $subject);
							$subject = "QB".$qbi.": ".$subject[1];							
							$subject = $subject[1];							
							$qb_support->templatemail($result[0], $subject, $template, "", "index_api:newqb_confirmation_mail");
						}
					}
				// write log file
					$req = ($_REQUEST['unsichtbar']==0)?"*****":$_REQUEST['requestor'];
					$qb_support->writelog($qbi, "A", "INDEX", "QB opened by ".$req);				
					return $qbi;		
					break;				
			}
		}
	}
?>