<?php
	include_once (dirname(__FILE__)."/../templates/db-def.php");
	global $rel_path;	
	require_once ($rel_path."support.php");
	$qb_support = new QBSupport;

	$routine = new Material();
	echo $routine->execute();
	
	class Material {
		
		public function __construct() 
		{
		}

		private function searchAllDB($search){
			global $db;
			$out = 0;
			$sql = "show tables";
			$rs = $db->query($sql);
			if($rs->rowCount() > 0){
				while($r = $rs->fetch(PDO::FETCH_NUM)){
					$table = $r[0];
					$sql_search = "select * from ".$table." where ";
					$sql_search_fields = Array();
					$sql2 = "SHOW COLUMNS FROM ".$table;
					$rs2 = $db->query($sql2);
					if($rs2->rowCount() > 0){
						while($r2 = $rs2->fetch(PDO::FETCH_NUM)){
							$colum = $r2[0];
							$sql_search_fields[] = $colum." like('%".$search."%')";
						}
					}
					$sql_search .= implode(" OR ", $sql_search_fields);
					$rs3 = $db->query($sql_search);
					$out += $rs3->rowCount();
				}
			}
			return $out;
		}
		
		public function execute()
		{	
			global $db, $debug, $qb_support, $rel_path;
	// called routine
			if (isset($_REQUEST['routine'])) {
				$sub_routine = $_REQUEST["routine"];
			} else {
				$json = file_get_contents('php://input');
				$obj = json_decode($json, true);
				$sub_routine = $obj["routine"];
			}
			switch ($sub_routine)
			{
				case "getsortiments":
					$FS = parse_ini_file($rel_path.'xml/sortimente.ini', true);
					$selopt = "'':'',";
					foreach($FS as $key=>$value) {
						$selopt.=$key.":'".$value[$_REQUEST['qblan']]."',";
					}
					$result = trim($selopt, ",");
					return $result;	
					break;
				case "readmaterial":
					$query[] = "
						SELECT 
							IDX AS id, 
							TGR AS tgr, 
							TGRBZ_1 AS tgr_n1, 
							TGRBZ_2 AS tgr_n2,
							WGR AS wgr, 
							MSTATUS AS mstat,
							ACTIVE AS active 
						FROM 
							qb_material 
					";
				// generate order & limit
					$order_str = "ORDER BY " . $_REQUEST['sidx'] . " " . $_REQUEST['sord'];
					$limit_str = " LIMIT " . ($_REQUEST['page']-1)*$_REQUEST['rows'] . ", " . $_REQUEST['rows'];
				// compile query string
					$querystr = $qb_support->makequery(json_encode($query), json_encode($_REQUEST));
				// get total rows first (only query string)			
					$stmt = $db->query($querystr);				
					$num_records = $stmt->rowCount();
					$num_pages = ceil($num_records/$_REQUEST['rows']);
				// now get result (query string with iorder and limit)		
					$stmt = $db->query($querystr . " " . $order_str . " " . $limit_str);
					$rows = array();
					while($r = $stmt->fetch(PDO::FETCH_ASSOC)) {
						$rows[] = $r;
					}
					$ret = Array();
					$ret['total'] = $num_pages;
					$ret['page'] = $_REQUEST['page'];
					$ret['records'] = $num_records;
					$ret['rows'] = $rows;					
					$result = json_encode($ret);
					return $result;	
					break;			
				case "editmaterial":
					$query = "
						UPDATE 
							qb_material 
						SET 
							TGRBZ_1=:n1, 
							TGRBZ_2=:n2, 
							MSTATUS=:mst, 
							WGR=:wgr,
							ACTIVE=1
						WHERE 
							TGR=:mnr";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':mnr' => $obj['tgr'],
							':mst' => $obj['mstat'],
							':wgr' => $obj['wgr'],
							':n1' => $obj['tgr_n1'],
							':n2' => $obj['tgr_n2']
						)
					);	
					$result = "Updated " . $obj['tgr'];
					return $result;		
					break;			
				case "addmaterial":
					$query = "SELECT COUNT(*) FROM qb_material WHERE TGR=:mnr";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':mnr' => strtolower($obj['tgr'])
						)
					);
				// material number is available, check if part is deleted
					if ($stmt->fetchColumn() > 0) {
						$query = "SELECT ACTIVE FROM qb_material WHERE TGR=:mnr";
						$stmt = $db->prepare($query);
						$stmt->execute(
							array(
								':mnr' => strtolower($obj['tgr'])
							)
						);
						if ($stmt->fetchColumn() == 1) {
							http_response_code(409);
							return "";
						} else {
							http_response_code(405);
							return "";						
						}
					} else {
						$query = "INSERT INTO qb_material (TGR, TGRBZ_1, TGRBZ_2, MSTATUS, WGR) VALUES (:mnr, :n1, :n2, :mst, :wgr)";
						$stmt = $db->prepare($query);
						$stmt->execute(
							array(
								':mnr' => $obj['tgr'],
								':mst' => $obj['mstat'],
								':wgr' => $obj['wgr'],
								':n1' => $obj['tgr_n1'],
								':n2' => $obj['tgr_n2']
							)
						);
						http_response_code(200);
						return "";
					}
					break;			
				case "deletematerial":
					$query = "UPDATE qb_material SET ACTIVE=0 WHERE TGR=:mnr";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':mnr' => $obj['tgr']
						)
					);
					return "Done";		
					break;
				case "undelete":
					$query = "UPDATE qb_material SET ACTIVE=1 WHERE TGR=:mnr";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':mnr' => $_REQUEST['tgr']
						)
					);
					return "Done";		
					break;					
			}
		}		
	}
?>