<?php
	include_once (dirname(__FILE__)."/../templates/db-def.php");
	global $rel_path;	
	require_once ($rel_path."support.php");
	$qb_support = new QBSupport;
	
	$routine = new Mysvt();
	echo $routine->execute();
	
	class Mysvt {
		
		public function __construct() 
		{
		}
		
		public function execute()
		{	
			global $db, $debug, $qb_support;
	// called routine
			if (isset($_REQUEST['routine'])) {
				$sub_routine = $_REQUEST["routine"];
			} else {
				$json = file_get_contents('php://input');
				$obj = json_decode($json, true);
				$sub_routine = $obj["routine"];
			}
			switch ($sub_routine)
			{
//
// getlist 				- list all defined deputies
// adddeputy			-	add new deputy to list
// deldeputy			-	delete deputy to list
// updself				-	toggle if deputies may exchange themselves
// getself				-	get setting if deputies may exchange themselves
// vacationrep		-	togge vacation representative
// resetpassword	-	reset password of user
//
				case "getlist":
					$query = "
						SELECT
							DSVT AS dsvt, 
							REP as r1,
							EX as ex,
							VORNAME AS vorname, 
							NACHNAME AS nachname
						FROM
							qb_deputy
						LEFT JOIN
							qb_user
						ON
							DSVT=LOGIN
						WHERE 
							SVT=:svt
						ORDER BY 
							r1 DESC, DSVT ASC";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':svt' => $_REQUEST['lgi']
						)
					);
					$rows = array();
					while($r = $stmt->fetch(PDO::FETCH_ASSOC)) {
						$rows[] = $r;
					}	
					$result = json_encode($rows);
					return $result;		
					break;
				case "adddeputy":
				// insert into qb_deputy
					$query = "INSERT INTO qb_deputy (SVT, DSVT, EX) VALUES (:svt, :usr, COALESCE(:ex, 0))";		
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':svt' => $obj['lgi'],
							':ex' => $obj['ex'],
							':usr' => $obj['login']
						)
					);
				// check for deputy flag
					$query = "SELECT FLAGS FROM qb_user WHERE LOGIN=:login";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':login' => $obj['login']
						)
					);
					$row = $stmt->fetch(PDO::FETCH_NUM);
					if (!in_array("D", str_split($row[0]))) {
						$query = "UPDATE qb_user SET FLAGS = CONCAT(FLAGS, 'D') WHERE LOGIN=:login";
						$stmt = $db->prepare($query);
						$stmt->execute(
							array(
								':login' => $obj['login']
							)
						);							
					}				
				// check if deputy SVT has already a password (anyone can be deputy, even admins)
					$query = "
						SELECT 
							COALESCE(LENGTH(PASSWORD), 0), 
							COUNT(LOGIN) 
						FROM 
							qb_user 
						WHERE 
							LOGIN=:usr
					";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':usr' => $obj['login']
						)
					);
					$row = $stmt->fetch(PDO::FETCH_NUM );
					if ($row[0] == 0) {
				// no, passord length is 0 - set initial password
            $qb_support->setdefaultpw($obj['login']);
					}
					$result = "Done";
					return $result;		
					break;
				case "deldeputy":
				// update qbi, change svt to original svt if delegated (for all open cases)
					$query = "
						UPDATE
							qbi
						SET
							SVT=DELEGATE,
							DELEGATE=''
						WHERE
							SVT=:svt AND
							DELEGATE=:delg AND
							QBSTATUS != 'C'
					";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':delg' => $obj['lgi'],
							':svt' => $obj['dsvt']
						)
					);
				// delete from deputy table			
					$query = "
						DELETE FROM 
							qb_deputy 
						WHERE 
							SVT=:svt AND 
							DSVT=:usr
					";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':svt' => $obj['lgi'],
							':usr' => $obj['dsvt']
						)
					);					
				// check if user was only deputy
					$query = "
						SELECT
							COUNT(*)
						FROM
							qb_deputy 
						WHERE 
							DSVT=:usr
					";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':usr' => $obj['dsvt']
						)
					);
					$row = $stmt->fetch(PDO::FETCH_NUM);
					if ($row[0] == 0) {
				// yes, is only deputy -> reset deputy role
						$query = "
							UPDATE
								qb_user
							SET
								FLAGS = REPLACE(FLAGS, 'D', '')
							WHERE
								LOGIN=:usr
						";
						$stmt = $db->prepare($query);
						$stmt->execute(
							array(
								':usr' => $obj['dsvt']
							)
						);
					}
				// check if password is still needed
					$query = "
						SELECT 
							USR, 
							PASSWORD 
						FROM 
							qb_user
						WHERE
							LOGIN=:usr
					";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':usr' => $obj['dsvt']
						)
					);
					$row = $stmt->fetch(PDO::FETCH_NUM );
				// only user or QL (no special role)
					if (($row[0] == 8) OR ($row[0] == 16)) {
						if ($qb_support->getoptions('forcelogin', 'set') != "yes") {
					// no force login -> delete password
							$query = "UPDATE qb_user SET PASSWORD='' WHERE LOGIN=:usr";
							$stmt = $db->prepare($query);
							$stmt->execute(
								array(
									':usr' => $obj['dsvt']
								)
							);					
						}
					}
					$result = "Done";
					return $result;		
					break;					
				case "updself":
					$query = "UPDATE qb_deputy SET EX=:ex WHERE SVT=:svt";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':svt' => $_REQUEST['login'],
							':ex' => $_REQUEST['exv']
						)
					);
					$result = "Done";
					return $result;		
					break;
				case "getself":
					$query = "
						SELECT 
							EX
						FROM	
							qb_deputy 
						WHERE 
							SVT=:svt
					";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':svt' => $_REQUEST['login']
						)
					);
					$r = $stmt->fetch(PDO::FETCH_NUM);
					$result = $r[0];
					return $result;		
					break;					
				case "vacationrep":
				// reset vacation representative
					if ($_POST['sts'] == 1) {
						$query = "UPDATE qb_deputy SET REP='0' WHERE SVT=:svt AND DSVT=:usr";
						$stmt = $db->prepare($query);
						$stmt->execute(
							array(
								':svt' => $_SESSION['lg'],
								':usr' => $_REQUEST['usr']
							)
						);
					} else {
				// set representative
						$query = "UPDATE qb_deputy SET REP='0' WHERE SVT=:svt";
						$stmt = $db->prepare($query);
						$stmt->execute(
							array(
								':svt' => $_SESSION['lg']
							)
						);
						$query = "UPDATE qb_deputy SET REP='1' WHERE SVT=:svt AND DSVT=:usr";
						$stmt = $db->prepare($query);
						$stmt->execute(
							array(
								':svt' => $_SESSION['lg'],
								':usr' => $_REQUEST['usr']
							)
						);			
					}
					$result = "Done";
					return $result;		
					break;
				case "resetpassword":
				// reset user password
          $qb_support->setdefaultpw($_REQUEST['usr']);
					$result = "Done";
					return $result;		
					break;
			}
		}
	}
?>