<?php
	include_once (dirname(__FILE__)."/../templates/db-def.php");
	require_once ($rel_path."support.php");
	$qb_support = new QBSupport;
	require_once ($rel_path."templates/color_scheme.php");
	
    $refcur = $qb_support->getOptions("refcurrency", "display");
    $refdec = $qb_support->getOptions("refcurrency", "decimals");
    $reftho = $qb_support->getOptions("refcurrency", "thousands");
    
	$qbn = filter_input(INPUT_GET,"qb",FILTER_SANITIZE_STRING);
	$lng = $_REQUEST['qblan'];
// general translations
	$ini_acostcont = parse_ini_file($rel_path.'i18n/a_costcont.ini', true);	
	$ini_costart = parse_ini_file($rel_path.'xml/cost_art.ini', true);
	$cal = parse_ini_file($rel_path.'i18n/calendar.ini', true);
	$cal = explode(",", $cal['monthNamesShort'][$lng]);
	
	$query = "SELECT COMPANYLOGO FROM qb_conf";
	$stmt = $db->query($query);
	$companylogo = $stmt->fetchColumn();

	//include fpdf class
	require_once($rel_path."tcpdf/tcpdf.php");

// myfpdf extends fpdf class, it is used to draw the header and footer
	class MYPDF extends TCPDF {
		//Page header
		public function Header() {
			global $companylogo, $qbn, $ini_acostcont, $rel_path, $lng;
		// Logo
		// Logo
			$image_file = dirname(__FILE__)."/../templates/".$companylogo;
			$image_file = $rel_path."templates/".$companylogo;
			$ext = explode(".", $companylogo);
			$ext = array_pop($ext);	
			$this->Image($image_file, 10, 6, 25, '', $ext, '', 'T', false, 300, '', false, false, 0, false, false, false);
		// Set font
			$this->SetFont('helvetica','B',12); 
		// Title
			$this->Cell(0, 10, utf8_decode($ini_acostcont['f_cost'][$lng]) . " " . $ini_acostcont['qbn'][$lng] . " " . $qbn, 0, 0, 'R', false, '', 0, true, 'T', 'B');	
		}		

		// Page footer
		public function Footer() {
			// Position at 15 mm from bottom
			$this->SetY(-15);
			// Set font
			$this->SetFont('helvetica', 'I', 8);
			// Page number
			$this->Cell(0, 10, 'Page '.$this->getAliasNumPage().'/'.$this->getAliasNbPages(), 0, false, 'C', 0, '', 0, false, 'T', 'M');
		}
	}
?>
<?php
// prepare data
//Instanciation of inherited class
	$pdf = new MYPDF("L", "mm", "A4", true, 'UTF-8', false);
	$pdf->SetCreator("QMMS");
	$pdf->SetTitle($ini_acostcont['qbn'][$lng] ." ". $qbn);
	
// set header and footer fonts
	$pdf->setHeaderFont(Array(PDF_FONT_NAME_MAIN, '', PDF_FONT_SIZE_MAIN));
	$pdf->setFooterFont(Array(PDF_FONT_NAME_DATA, '', PDF_FONT_SIZE_DATA));

// set default monospaced font
	$pdf->SetDefaultMonospacedFont(PDF_FONT_MONOSPACED);
	
// set margins
	$pdf->SetMargins('10', '18', '10');
	$pdf->SetFooterMargin(PDF_MARGIN_FOOTER);

// set auto page breaks
	$pdf->SetAutoPageBreak(TRUE, PDF_MARGIN_BOTTOM);

// set some language-dependent strings (optional)
	require_once($rel_path.'tcpdf/'.$lng.'.php');
	$pdf->setLanguageArray($l);

// add a page
	$pdf->AddPage();

// get data
	$query = "SELECT GRUND, ART, C_DATE, MENGE, COST, CURRENCY, FACTOR FROM qb_doccost WHERE QBN=:qbn ORDER BY ART, C_DATE ASC";
	$stmt = $db->prepare($query);
	$stmt->execute(
		array(
			':qbn' => $_REQUEST['qb']
		)
	);
	$cart = "";
	$cnt = 0;
	$sum = 0;
	$totsum = 0;
	while($row = $stmt->fetch(PDO::FETCH_NUM)) {
		if ($cart <> $row[1]) {
			$pdf->SetFillColor(255, 255, 255);
			if ($cnt > 0) {
				$pdf->Cell(245,5,'', 'T', 0, 'L', true);
				$pdf->SetFont('','B',10);
				$pdf->SetTextColor(0,0,192);
				$pdf->Cell(0,7,number_format($sum, 2, $refdec, $reftho) . " " . $refcur, 'T', 1, 'R', true);
				$pdf->SetTextColor(0,0,0);
				$pdf->SetFont('','',10);
				$totsum += $sum;
				$sum = 0;
			}
			$cnt++;
			$pdf->SetFont('','',10);
			$pdf->Cell(0,5,'', '', 1, 'L', true);
			$cart = $row[1];
			$pdf->SetFillColor(221, 221, 221);
			$pdf->Cell(0,5,utf8_decode($ini_costart[$row[1]][$lng]), 'TBLR', 1, 'L', true);
		}
		$h1 = explode("-", $row[2]);
		if ($row[2] == "0000-00-00") {
			$dt = "-";
		} else {		
			$dt = $h1[0] . "-" . $cal[$h1[1]-1] . "-" . $h1[2];
		}
		$pdf->SetFillColor(255, 255, 255);
		$pdf->SetFont('','',10);
		$height = ceil(max(5, $pdf->getStringHeight(30, utf8_decode($dt)), $pdf->getStringHeight(183, str_replace("<br />", "", $row[0])), $pdf->getStringHeight(30, number_format(($row[3]*$row[4]), 2, $refdec, $reftho) . " " . $row[5]), $pdf->getStringHeight(30, number_format(($row[3]*$row[4]*$row[6]), 2, $refdec, $reftho) . " " . $refcur)));	
		$pdf->MultiCell(30, $height, utf8_decode($dt),'TBLR','L', true, 0);
		$pdf->MultiCell(183, $height, str_replace("<br />", "", $row[0]),'TBR','L', true, 0);
		$pdf->MultiCell(32, $height, number_format(($row[3]*$row[4]), 2, $refdec, $reftho) . " " . $row[5],'TB','R', true, 0);
		$pdf->MultiCell(32, $height, number_format(($row[3]*$row[4]*$row[6]), 2, $refdec, $reftho) . " " . $refcur,'TBLR','R', 1);
		$sum += ($row[3]*$row[4]*$row[6]);
	}

	$pdf->Cell(245,5,'', 'T', 0, 'L', true);
	$pdf->SetFont('','B',10);
	$pdf->SetTextColor(0,0,192);
	$pdf->Cell(0,7,number_format($sum, 2, $refdec, $reftho) . " " . $refcur, 'T', 1, 'R', true);
	$pdf->SetTextColor(0,0,0);
	$pdf->SetFont('','',10);	

	$pdf->Cell(245,5,'', '', 0, 'L', true);
	$pdf->SetFont('','B',10);
	$pdf->SetTextColor(192,0,0);
	$pdf->Cell(0,7,number_format($totsum+$sum, 2, $refdec, $reftho) . " " . $refcur, 'T', 1, 'R', true);
	$pdf->SetTextColor(0,0,0);
	$pdf->SetFont('','',10);
// generate file
	$pdf->Output();
?>
