<?php
	include_once (dirname(__FILE__)."/../templates/db-def.php");
	global $rel_path;	
	require_once ($rel_path."support.php");
	$qb_support = new QBSupport;
	
	$routine = new Purcont();
	echo $routine->execute();
	
	class Purcont {
		
		public function __construct() 
		{
		}
		
		public function execute()
		{	
			global $db, $debug, $qb_support;
	// called routine
			$sub_routine = $_REQUEST["routine"];
			switch ($sub_routine)
			{
				case "search":
				// define material name language
					$mncol = $qb_support->getLanMat($_REQUEST['qblan']);
				// decode date
					$query[] = "
						SELECT 
							qb_close.QBN AS qbn, 
							SUPPLIERNAME AS supplier, 
							COALESCE(TGR, 'N/A') AS tgr,
							COALESCE(TGRBZ_" . $mncol . ", 'N/A') AS tgr_n, 
							LFS_NR AS lfs
						FROM 
							qb_close 
						LEFT JOIN 
							qbbasic ON qb_close.QBN=qbbasic.QBN 
						LEFT JOIN 
							qbi ON qbi.QBN=qbbasic.QBN 
						LEFT JOIN 
							qb_supplier ON SUPPLIER=SUPPLIERNR 
						LEFT JOIN 
							qb_material ON MNR=TGR 
						WHERE 
							FFU='SUP' AND 
							QBREGDATE>=:sdat AND 
							QBREGDATE<=:edat AND 
							QBSTATUS='C' AND 
							SUPPLIERNAME<>'' 
					";
				// generate order & limit
					$order_str = "ORDER BY " . $_REQUEST['sidx'] . " " . $_REQUEST['sord'];
					$limit_str = " LIMIT " . ($_REQUEST['page']-1)*$_REQUEST['rows'] . ", " . $_REQUEST['rows'];
				// compile query string
					$querystr = $qb_support->makequery(json_encode($query), json_encode($_REQUEST));
				// get total rows first (only query string)
					$stmt = $db->prepare($querystr);
					$stmt->execute(
						array(
							':sdat' => $_REQUEST['sdate'] . "-01",
							':edat' => $_REQUEST['edate'] . "-31"
						)
					);					
					$num_records = $stmt->rowCount();
					$num_pages = ceil($num_records/$_REQUEST['rows']);
				// now get result (query string with iorder and limit)		
					$stmt = $db->prepare($querystr . " " . $order_str . " " . $limit_str);					
					$stmt->execute(
						array(
							':sdat' => $_REQUEST['sdate'] . "-01",
							':edat' => $_REQUEST['edate'] . "-31"
						)
					);	
					$rows = array();
					while($r = $stmt->fetch(PDO::FETCH_ASSOC)) {
						$rows[] = $r;
					}	
					$ret = Array();
					$ret['total'] = $num_pages;
					$ret['page'] = $_REQUEST['page'];
					$ret['records'] = $num_records;
					$ret['rows'] = $rows;					
					$result = json_encode($ret);
					return $result;	
					break;
			}
		}			
	}
?>