<?php
	include_once (dirname(__FILE__)."/../templates/db-def.php");
	global $rel_path;	
	require_once ($rel_path."support.php");
	$qb_support = new QBSupport;
	
	$routine = new Roles();
	echo $routine->execute();
	
	class Roles {
		
		public function __construct() 
		{
		}
		
		public function gettable() {
			global $db, $c_scheme, $rel_path, $qb_support;
			$flags = parse_ini_file($rel_path.'xml/flags.ini', true);
			foreach ($flags as $key => $value)
			{
				$start[$key]  = $value['order'];
			}								
			array_multisort($start, SORT_ASC, $flags);
			$ini_roles = parse_ini_file($rel_path.'i18n/roles.ini', true);			
			$query = "SELECT IDX, ROLE, FLAGS, MASTER, DFLT FROM qb_roles WHERE MASTER != 3 ORDER BY ORDR ASC";		// master ==3 means "no show"
			$stmt = $db->query($query);
			$i = 0;
			while($r = $stmt->fetch(PDO::FETCH_NUM)) {				
		// alternating background color
				if ($i % 2 != 0) {
					echo "<tr id='r".$r[0]."'>";
				} else {
					echo "<tr id='r".$r[0]."' style='background-color: ".$c_scheme['IE'].";'>";
				}
		// only roles with master == 0 are cusomized roles and can be deleted
				if ($r[3] == 0) {
					echo "<th style='background-color: ".$c_scheme['M5'].";'><span class='icn_delete_b_n clckbtn' data-type='title' data-lan='rem' onclick='del_role(this)' title=''></span></th>";
				} else {
					echo "<th style='background-color: ".$c_scheme['M5'].";'><span style='display:inline-block; width: 16px;'></span></th>";
				}
				echo "<th class='row-header'>".$r[1]."</th>";
		// cycle trough flags
				foreach ($flags as $key => $value) {
					if ($r[3] == 0) {
						if ($value['rights'] == "Y") {
				// customized role -> allow edit on all flags
							if ($key == "B") continue;				// special handling for reports
							if ($key == "C") continue;			// special handling for costs
							if (!$qb_support->checkflag("Y") AND ($key == "Y")) continue;	// admin rights only for admins
							echo "<td>";
							if (in_array($key, str_split($r[2]))) {
								echo "<span id='r".$r[0]."_c".$key."' data-checked='true' style='cursor: pointer;' class='icn_checkboxchecked_c_n clckbtn vam' onclick='change_box(this)'></span>";
							} else {
								echo "<span id='r".$r[0]."_c".$key."' data-checked='false' style='cursor: pointer;' class='icn_checkboxempty_c_n clckbtn vam' onclick='change_box(this)'></span>";
							}
							echo "</td>";
						}
					} else {
						if ($value['rights'] == "Y") {									
				// default role -> allow edit on flags only which are not default
							if ($key == "B") continue;				// special handling for reports
							if ($key == "C") continue;			// special handling for costs
							if (!$qb_support->checkflag("Y") AND ($key == "Y")) continue;	// admin rights only for admins
							echo "<td>";
							if (in_array($key, str_split($r[2]))) {
						// if default value disable box
								if (in_array($key, str_split($r[4]))) {
									echo "<span id='r".$r[0]."_c".$key."' data-checked='true' style='cursor: default;' class='icn_checkboxchecked_r3_n clckbtn vam'></span>";
								} else {
									echo "<span id='r".$r[0]."_c".$key."' data-checked='true' style='cursor: pointer;' class='icn_checkboxchecked_c_n clckbtn vam' onclick='change_box(this)'></span>";
								}
							} else {
								echo "<span id='r".$r[0]."_c".$key."' data-checked='false' style='cursor: pointer;' class='icn_checkboxempty_c_n clckbtn vam' onclick='change_box(this)'></span>";
							}
							echo "</td>";
						}
					}
				}
				echo "<td style='background-color: ".$c_scheme['M5']."; border: 0px;'><span class='icn_loop_b_n clckbtn' data-type='title' data-lan='apply' onclick='apply_role(this)' title='".$ini_roles['apply'][$_SESSION['lng']]."'></span></td>";
				echo "</tr>";
				$i++;
			}		
		}
		
		public function execute()
		{	
			global $db, $debug, $qb_support;
	// called routine
			$sub_routine = $_REQUEST["routine"];
			switch ($sub_routine)
			{
				case "saveflags":
					$query = "UPDATE qb_roles SET FLAGS=:flgs WHERE IDX=:idx";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':idx' => $_REQUEST['id'],
							':flgs' => $_REQUEST['flags']
						)
					);					
					return "Done";		
					break;
				case "newrole":
					$stmt = $db->query("SELECT MAX(ORDR)+1 FROM qb_roles");
					$newordr = $stmt->fetchColumn();
					$query = "INSERT INTO qb_roles (ROLE, ORDR) VALUES (:nme, :nwo)";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':nme' => $_REQUEST['nme'],
							':nwo' => $newordr
						)
					);
					return $this->gettable();
					break;
				case "applyrole":
					$query = "SELECT ROLE, FLAGS FROM qb_roles WHERE IDX=:idx";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':idx' => $_REQUEST['idx']
						)
					);
					$r = $stmt->fetch(PDO::FETCH_NUM);
					list ($role, $flags) = $r;
					$query = "UPDATE qb_user SET FLAGS=:flg WHERE USR=:rle";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':flg' => $flags,
							':rle' => $role
						)
					);
					return $stmt->rowCount();
					break;					
				case "delrole":
					$query = "SELECT COUNT(*) FROM qb_user, qb_roles WHERE USR=ROLE AND qb_roles.IDX=:idx GROUP BY USR";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':idx' => $_REQUEST['idx']
						)
					);
					$r = $stmt->fetchColumn();			
					if (!$r) {
				// role not used -> delete
						$query = "DELETE FROM qb_roles WHERE IDX=:idx";
						$stmt = $db->prepare($query);
						$stmt->execute(
							array(
								':idx' => $_REQUEST['idx']
							)
						);
						return $this->gettable();						
					} else {
						return "NOK";
					}
					break;						
			}
		}
	}
?>