<?php
	include_once (dirname(__FILE__)."/../templates/db-def.php");
	global $rel_path;	
	require_once ($rel_path."support.php");
	$qb_support = new QBSupport;
	
	$routine = new Mysvt();
	echo $routine->execute();
	
	class Mysvt {
		
		public function __construct() 
		{
		}
		
		public function execute()
		{	
			global $db, $debug, $qb_support;
	// called routine
			if (isset($_REQUEST['routine'])) {
				$sub_routine = $_REQUEST["routine"];
			} else {
				$json = file_get_contents('php://input');
				$obj = json_decode($json, true);
				$sub_routine = $obj["routine"];
			}
			switch ($sub_routine)
			{
//
// getlist 			- 	list all defined deputies
// resetrep			-	reset all representatives
// setrep			-	set representative
// getsvt			-	get list off all svt without already defined deputies and svt itself
// addrep			-	add representative
//
				case "getlist":
					$query = "
						SELECT
							DSVT AS login,
							NACHNAME AS nachname,
							VORNAME AS vorname,
							USR AS role,
							REP as r1
						FROM
							qb_deputy
						LEFT JOIN
							qb_user
						ON
							DSVT=LOGIN
						WHERE 
							SVT=:svt
						ORDER BY 
							DSVT ASC";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':svt' => $_REQUEST['substitute']
						)
					);
					$rows = array();
					while($r = $stmt->fetch(PDO::FETCH_ASSOC)) {
						$rows[] = $r;
					}	
					$result = json_encode($rows);
					return $result;		
					break;
				case "resetrep":
					$query = "
						UPDATE
							qb_deputy
						SET
							REP=0
						WHERE
							SVT=:svt
					";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':svt' => $_REQUEST['substitute']
						)
					);					
					$result = "Done";
					return $result;		
					break;
				case "setrep":
				// reset old deputies (if any)
					$query = "
						UPDATE
							qb_deputy
						SET
							REP=0
						WHERE
							SVT=:svt
					";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':svt' => $_REQUEST['substitute']
						)
					);		
				// set representative
					$query = "
						UPDATE 
							qb_deputy 
						SET 
							REP='1' 
						WHERE 
							SVT=:svt AND 
							DSVT=:usr
					";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':svt' => $_REQUEST['substitute'],
							':usr' => $_REQUEST['usr']
						)
					);
					$result = "Done";
					return $result;		
					break;
				case "getsvt":
					$query = "
						SELECT 
							LOGIN,
							CONCAT(NACHNAME, ', ', VORNAME)
						FROM 
							qb_user
						WHERE 
							FLAGS LIKE '%V%' AND
                            LOGIN NOT IN (SELECT DSVT FROM qb_deputy WHERE SVT=:svt) AND
							LOGIN != :svt
						ORDER BY
							NACHNAME
					";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':svt' => $_REQUEST['svt']
						)
					);
					$result = "<select><option value=''>...</option>";
					while($r = $stmt->fetch(PDO::FETCH_NUM)) {
						$result .= "<option value='".$r[0]."'>".$r[1]."</option>";
					}
					$result .= "</select>";
					return $result;		
					break;
				case "addrep":			
				// reset old deputies (if any)
					$query = "
						UPDATE
							qb_deputy
						SET
							REP=0
						WHERE
							SVT=:svt
					";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':svt' => $obj['svt']
						)
					);		
				// set representative
					$query = "
						INSERT INTO 
							qb_deputy 
							(
								SVT, 
								DSVT,
								REP
							)
						VALUES
							(
								:svt,
								:usr,
								1
							)
					";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':svt' => $obj['svt'],
							':usr' => $obj['login']
						)
					);					
					$result = "Done";
					return $result;		
					break;
			}
		}
	}
?>