﻿<?php
	include_once (dirname(__FILE__)."/../templates/db-def.php");
	global $rel_path;	
	require_once ($rel_path."support.php");
	$qb_support = new QBSupport;
	
	$routine = new Supplier();
	echo $routine->execute();
	
	class Supplier {
		
		public function __construct() 
		{
		}
		
		private function searchAllDB($search){
			global $db;
			$out = 0;
			$sql = "show tables";
			$rs = $db->query($sql);
			if($rs->rowCount() > 0){
				while($r = $rs->fetch(PDO::FETCH_NUM)){
					$table = $r[0];
					$sql_search = "select * from ".$table." where ";
					$sql_search_fields = Array();
					$sql2 = "SHOW COLUMNS FROM ".$table;
					$rs2 = $db->query($sql2);
					if($rs2->rowCount() > 0){
						while($r2 = $rs2->fetch(PDO::FETCH_NUM)){
							$colum = $r2[0];
							$sql_search_fields[] = $colum." like('%".$search."%')";
						}
					}
					$sql_search .= implode(" OR ", $sql_search_fields);
					$rs3 = $db->query($sql_search);
					$out += $rs3->rowCount();
				}
			}
			return $out;
		}
		
		public function execute()
		{	
			global $db, $debug, $qb_support;
	// called routine
			if (isset($_REQUEST['routine'])) {
				$sub_routine = $_REQUEST["routine"];
			} else {
				$json = file_get_contents('php://input');
				$obj = json_decode($json, true);
				$sub_routine = $obj["routine"];
			}
			switch ($sub_routine)
			{
				case "readsupplier":
			// list all supplier in database
					$query[] = "
						SELECT 
							IDX AS id, 
							SUPPLIERNR AS creditnr, 
							SUPPLIERNAME AS suppliername, 
							COALESCE((SELECT COUNTRY FROM qb_ccode WHERE CODE=LAND), '') AS country,
              SCLASS AS sclass,
							ACTIVE AS rshort
						FROM 
							qb_supplier 
					";
				// generate order & limit
					$order_str = "ORDER BY " . $_REQUEST['sidx'] . " " . $_REQUEST['sord'];
					$limit_str = " LIMIT " . ($_REQUEST['page']-1)*$_REQUEST['rows'] . ", " . $_REQUEST['rows'];
				// compile query string
					$querystr = $qb_support->makequery(json_encode($query), json_encode($_REQUEST));
				// get total rows first (only query string)
					$stmt = $db->query($querystr);				
					$num_records = $stmt->rowCount();
					$num_pages = ceil($num_records/$_REQUEST['rows']);
				// now get result (query string with iorder and limit)		
					$stmt = $db->query($querystr . " " . $order_str . " " . $limit_str);
					$rows = array();
					while($r = $stmt->fetch(PDO::FETCH_ASSOC)) {
						$rows[] = $r;
					}
					$ret = Array();
					$ret['total'] = $num_pages;
					$ret['page'] = $_REQUEST['page'];
					$ret['records'] = $num_records;
					$ret['rows'] = $rows;					
					$result = json_encode($ret);
					return $result;		
					break;
				case "erasesupplier":
					if (Admin::searchAllDB($_REQUEST['creditnr']) > 1) {
						$result = "Fail";
					} else {				
						$query = "DELETE FROM qb_supplier WHERE SUPPLIERNR=:cre";
						$stmt = $db->prepare($query);
						$stmt->execute(
							array(
								':cre' => $_REQUEST['creditnr']
							)
						);					
						$result = "Done";
					}
					return $result;		
					break;					
				case "adminupdate":			
					unset($obj['routine']);
			// check if login is already available
					$query = "SELECT COUNT(*) FROM qb_supplier WHERE SUPPLIERNR=:cre";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':cre' => $obj['creditnr']
						)
					);
					if ($stmt->fetchColumn() > 0) {
						http_response_code(409);
						return "";
					} else {
					// qb_supplier
						$query = "UPDATE qb_supplier SET SUPPLIERNR=:new WHERE SUPPLIERNR=:old";
						$stmt = $db->prepare($query);
						$stmt->execute(array(':new' => $obj['creditnr'], ':old' => $obj['old']));
					// qb_basic
						$query = "UPDATE qb_basic SET SUPPLIER=:new WHERE SUPPLIER=:old";
						$stmt = $db->prepare($query);
						$stmt->execute(array(':new' => $obj['creditnr'], ':old' => $obj['old']));
					// qb_purkpi
						$query = "UPDATE qb_purkpi SET SUPNR=:new WHERE SUPNR=:old";
						$stmt = $db->prepare($query);
						$stmt->execute(array(':new' => $obj['creditnr'], ':old' => $obj['old']));
					// qb_nacharbeit
						$query = "UPDATE qb_nacharbeit SET SUPPLIER=:new WHERE SUPPLIER=:old";
						$stmt = $db->prepare($query);
						$stmt->execute(array(':new' => $obj['creditnr'], ':old' => $obj['old']));							
					}
					$result = "Done";
					return $result;		
					break;					
				case "deletesupplier":			
			// set ACTIVE to "0"
					$query = "UPDATE qb_supplier SET ACTIVE=0 WHERE SUPPLIERNR=:cre";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':cre' => $obj['creditor']
						)
					);
					$result = "Done";
					return $result;		
					break;
			// update supplier data
				case "updatesupplier":
				// update user details		
					$query = "UPDATE qb_supplier SET SUPPLIERNAME=:nme, LAND=:vn, SCLASS=:nn, ACTIVE=1 WHERE SUPPLIERNR=:sup";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':sup' => $obj['creditnr'],
							':nme' => $obj['suppliername'],
              ':nn' => $obj['sclass'],
							':vn' => $obj['country']
						)
					);
					$result = "Done";
					return $result;		
					break;
				case "addsupplier":
			// check if creditor number is already available
					$query = "SELECT COUNT(*) FROM qb_supplier WHERE SUPPLIERNR=:sup";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':sup' => $obj['creditnr']
						)
					);
					if ($stmt->fetchColumn() > 0) {
						http_response_code(409);
						return "";					
					} else {
						$query = "INSERT INTO qb_supplier (SUPPLIERNR, SUPPLIERNAME, LAND, SCLASS) 
							VALUES (:sup, :nme, :vn, :nn)";	
						$stmt = $db->prepare($query);
						$stmt->execute(
							array(
								':sup' => $obj['creditnr'],
								':nme' => $obj['suppliername'],
								':vn' => $obj['country'],
                ':nn' => $obj['sclass']
							)
						);
					}
					return "Done";
					break;
			}
		}
	}
?>