<?php
// this generates the excel
	include_once (dirname(__FILE__)."/../templates/db-def.php");
	global $rel_path;	
	require_once ($rel_path."support.php");
	$qb_support = new QBSupport;
	
	$lng = $_REQUEST['qblan'];
// translation for type
	$ini_svtcont = parse_ini_file($rel_path.'i18n/svtcont.ini', true);	
	$ini_qbtype = parse_ini_file($rel_path.'xml/qb_type.ini', true);
	
// extract data
	$filters = (json_decode($_REQUEST['filters'], true));
	$datas = (json_decode($_REQUEST['datas'], true));
	$titles = (json_decode($_REQUEST['titles'], true));
	$fields = (json_decode($_REQUEST['fields'], true));
	$total_rows = count($datas);

/** Include PhpSpreadsheet */
  require $rel_path.'phpspreadsheet/autoload.php';

  use PhpOffice\PhpSpreadsheet\Spreadsheet;
  use PhpOffice\PhpSpreadsheet\Style\Border;
  use PhpOffice\PhpSpreadsheet\Style\Color;
  use PhpOffice\PhpSpreadsheet\Style\Font;
  use PhpOffice\PhpSpreadsheet\Writer\Xlsx;

  $spreadsheet = new Spreadsheet();
  $spreadsheet->getActiveSheet()->getPageSetup()->setOrientation(\PhpOffice\PhpSpreadsheet\Worksheet\PageSetup::ORIENTATION_LANDSCAPE);
  $spreadsheet->getActiveSheet()->getPageSetup()->setPaperSize(\PhpOffice\PhpSpreadsheet\Worksheet\PageSetup::PAPERSIZE_A4);
  $spreadsheet->getProperties()->setCreator("QB-oot")->setTitle("Sortimentscontolling");
  $spreadsheet->getDefaultStyle()->getFont()->setName('Arial')->setSize(11);
  $sheet = $spreadsheet->getActiveSheet();
	
// define formats
  $styleThinBlackBorderOutline = [
    'borders' => [
      'borderStyle' => \PhpOffice\PhpSpreadsheet\Style\Border::BORDER_THIN,
      'color' => ['argb' => 'FF000000']
    ]
  ];  
  $styleThickBlackBorderOutline = [
    'borders' => [
      'borderStyle' => \PhpOffice\PhpSpreadsheet\Style\Border::BORDER_MEDIUM,
      'color' => ['argb' => 'FF000000']
    ]
  ]; 
  $styleGreyBackground = [
    'fill' => [
      'fillType' => \PhpOffice\PhpSpreadsheet\Style\Fill::FILL_SOLID,
      'color' => ['argb' => 'FFCCCCCC']
    ]
  ];
  $styleFilterBackground = [
    'fill' => [
      'fillType' => \PhpOffice\PhpSpreadsheet\Style\Fill::FILL_SOLID,
      'color' => ['argb' => 'FFEBF1DE']
    ]
  ]; 
  $styleHyperlink = [
    'font' => [
      'alignment' => ['horizontal' => \PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER],
      'color' => ['argb' => 'FF0000FF'],
      'underline' => Font::UNDERLINE_SINGLE
    ]
  ];
	
// insert filter settings
	$sheet->setCellValue("A1", $ini_svtcont['filter'][$lng]);
	$sheet->getStyle('A1')->getFont()->setBold(true)->setSize(12);
	$sheet->mergeCells('A1:B1');
	$sheet->getStyle('A1:B1')->applyFromArray($styleThickBlackBorderOutline);
	$sheet->setCellValue("A2", $ini_svtcont['date'][$lng]);
	$sheet->setCellValue("B2", $_REQUEST['exdate']);
	$sheet->setCellValue("A3", $ini_svtcont['qbn'][$lng]);
	$sheet->setCellValue("B3", isset($filters['qbn'])?$filters['qbn']:"");
	$sheet->setCellValue("A4", $ini_svtcont['type'][$lng]);
	$sheet->setCellValue("B4", isset($filters['qbtype'])?$filters['qbtype']:"");
	$sheet->setCellValue("A5", $ini_svtcont['svt'][$lng]);
	$sheet->setCellValue("B5", isset($filters['svt'])?$filters['svt']:"");
	$sheet->setCellValue("A6", $ini_svtcont['wgr'][$lng]);
	$sheet->setCellValue("B6", isset($filters['wgr'])?$filters['wgr']:"");	
	$sheet->setCellValue("A7", $ini_svtcont['generated'][$lng]);	
	$sheet->setCellValue("B7", date('Y-M-d H:i:s', time()));
	$sheet->setCellValue("A8", $ini_svtcont['found_datasets'][$lng]);
	$sheet->setCellValue("B8", $total_rows);
// format filter box	
	$sheet->getStyle('B8')->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_LEFT);	
	$sheet->getStyle('B8')->getFont()->setBold(true);	
	$sheet->getStyle('B2:B8')->getFont()->setItalic(true);
	$sheet->getStyle('A1:B8')->applyFromArray($styleFilterBackground)->applyFromArray($styleThickBlackBorderOutline);
	
// generate headlines
	$i = 1;
	$start_row = 10;
	
	foreach ($titles as $title) {
		$sheet->setCellValue(chr(64+$i).$start_row, $title);
		$i++;
	}
// format headlines
	$sheet->getStyle('A'.$start_row.':'.chr(64+count($titles)).$start_row)->applyFromArray($styleThinBlackBorderOutline);
	$sheet->getStyle('A'.$start_row.':'.chr(64+count($titles)).$start_row)->applyFromArray($styleGreyBackground);
	$sheet->getStyle('A'.$start_row.':'.chr(64+count($titles)).$start_row)->getFont()->setBold(true)->setName('Arial')->setSize(10)->getColor()->setARGB('FF0000FF');
	$sheet->getStyle('A'.$start_row.':'.chr(64+count($titles)).$start_row)->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_LEFT);	

	$data_row = $start_row + 1;
	global $relili;
	foreach ($datas as $row) {
		$i = 1;
		foreach($row as $key => $value) {
      $richText = new \PhpOffice\PhpSpreadsheet\RichText\RichText();
      $richText->createText($value);
      $sheet->setCellValue(chr(64+$i).$data_row, $richText);
			if ($key == "qbn") {
				$sheet->getCell(chr(64+$i).$data_row)->getHyperlink()->setUrl('http://' . $relili . $value);
        $sheet->getStyle(chr(64+$i).$data_row)->applyFromArray($styleHyperlink);
			}
			$i++;
		}
		$data_row++;
	}
	
// set autofilter
	$sheet->setAutoFilter('A'.$start_row.':'.chr(64+count($titles)).$start_row);
	
// format columns
	$i = 1;
	foreach ($titles as $title) {
		$sheet->getColumnDimension(chr(64+$i))->setAutoSize(true);
		$i++;	
	}

// Rename worksheet
	$sheet->setTitle($ini_svtcont['sortimentscontrolling'][$lng]);

// Set active sheet index to the first sheet, so Excel opens this as the first sheet
	$spreadsheet->setActiveSheetIndex(0);

// Redirect output to a client’s web browser (Excel2007)
	header('Content-Type: application/vnd.openxmlformats-officedocument.spreadsheetml.sheet');
	header('Content-Disposition: attachment;filename="qb-svtcont.xlsx"');
	header('Cache-Control: max-age=0');

  $writer = new Xlsx($spreadsheet);
  $writer->save('php://output');
	exit;
?>
