<?php
	include_once (dirname(__FILE__)."/../templates/db-def.php");
	global $rel_path;	
	require_once ($rel_path."support.php");
	$qb_support = new QBSupport;
	
	$routine = new SVT_dlz();
	echo $routine->execute();
	
	class SVT_dlz {
		
		public function __construct() 
		{
		}
		
		public function execute()
		{	
			global $db, $debug, $qb_support;
	// called routine
			$sub_routine = $_REQUEST["routine"];
			switch ($sub_routine)
			{
				case "n2cl":
			// complete cycle time
					$query = "
						SELECT 
							DATEDIFF(GQ_DATE, QBREGDATE) AS DD, 
							COUNT(DATEDIFF(GQ_DATE, QBREGDATE)) 
						FROM 
							qbi, 
							qb_close 
						WHERE 
							QBSTATUS='C' AND
							qbi.QBN = qb_close.QBN AND 
							LIGHT=1 AND 
							QBREGDATE>=:sdat AND 
							QBREGDATE<=:edat AND 
							SVT=:svt 
						GROUP BY 
							DD 
						ORDER BY 
							DD ASC 
						LIMIT 0, 20
					";				
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':sdat' => $_REQUEST['from'],
							':edat' => $_REQUEST['to'],
							':svt' => $_REQUEST['login']
						)
					);
					$r = Array();
					while($row = $stmt->fetch(PDO::FETCH_NUM)) {
						$r[] = $row;
					}
					if (count($r) > 0) {
						$query = "
							SELECT 
								COUNT(GQ_DATE) 
							FROM 
								qbi, 
								qb_close 
							WHERE 
								QBSTATUS='C' AND 
								qbi.QBN = qb_close.QBN AND 
								LIGHT=1 AND 
								QBREGDATE>=:sdat AND 
								QBREGDATE<=:edat AND 
								DATEDIFF(GQ_DATE, QBREGDATE)>:dif AND 
								SVT=:svt
						";
						$stmt = $db->prepare($query);
						$stmt->execute(
							array(
								':sdat' => $_REQUEST['from'],
								':edat' => $_REQUEST['to'],
								':svt' => $_REQUEST['login'],
								':dif' => $r[count($r)-1][0]
							)
						);		
						$row = $stmt->fetch(PDO::FETCH_NUM );
						if ($row[0] > 0) {
							$r[] = Array(">".$r[count($r)-1][0], $row[0]);
						}
					}
					$result = json_encode($r);
					return $result;		
					break;
				case "n2c":
			// complete cycle time
					$query = "
						SELECT 
							DATEDIFF(GQ_DATE, QBREGDATE) AS DD, 
							COUNT(DATEDIFF(GQ_DATE, QBREGDATE)) 
						FROM 
							qbi, 
							qb_close 
						WHERE 
							QBSTATUS='C' AND 
							qbi.QBN = qb_close.QBN AND 
							LIGHT<>1 AND 
							QBREGDATE>=:sdat AND 
							QBREGDATE<=:edat AND 
							SVT=:svt 
						GROUP BY 
							DD 
						ORDER BY 
							DD ASC 
						LIMIT 0, 20
					";			
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':sdat' => $_REQUEST['from'],
							':edat' => $_REQUEST['to'],
							':svt' => $_REQUEST['login']
						)
					);
					$r = Array();
					while($row = $stmt->fetch(PDO::FETCH_NUM)) {
						$r[] = $row;
					}
					if (count($r) > 0) {
						$query = "
							SELECT 
								COUNT(GQ_DATE) 
							FROM 
								qbi, 
								qb_close 
							WHERE 
								QBSTATUS='C' AND 
								qbi.QBN = qb_close.QBN AND 
								LIGHT<>1 AND 
								QBREGDATE>=:sdat AND 
								QBREGDATE<=:edat AND 
								DATEDIFF(GQ_DATE, QBREGDATE)>:dif AND 
								SVT=:svt
						";
						$stmt = $db->prepare($query);
						$stmt->execute(
							array(
								':sdat' => $_REQUEST['from'],
								':edat' => $_REQUEST['to'],
								':svt' => $_REQUEST['login'],
								':dif' => $r[count($r)-1][0]
							)
						);		
						$row = $stmt->fetch(PDO::FETCH_NUM );
						if ($row[0] > 0) {
							$r[] = Array(">".$r[count($r)-1][0], $row[0]);
						}
					}
					$result = json_encode($r);
					return $result;		
					break;
				case "n2t":
			// cycle time new to technically closed
					$query = "
						SELECT 
							DATEDIFF(DATE_ACC_BY_SVT, QBREGDATE) AS DD, 
							COUNT(DATEDIFF(DATE_ACC_BY_SVT, QBREGDATE)) 
						FROM 
							qb_imp 
						LEFT JOIN 
							qbi ON qbi.QBN=qb_imp.QBN 
						WHERE 
							QBSTATUS='S' AND 
							LIGHT<>1 AND 
							QBREGDATE>=:sdat AND 
							QBREGDATE<=:edat AND 
							SVT=:svt 
						GROUP BY 
							DD 
						ORDER BY 
							DD ASC 
						LIMIT 0, 20
					";		
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':sdat' => $_REQUEST['from'],
							':edat' => $_REQUEST['to'],
							':svt' => $_REQUEST['login']
						)
					);
					$r = Array();
					while($row = $stmt->fetch(PDO::FETCH_NUM)) {
						$r[] = $row;
					}
					if (count($r) > 0) {
						$query = "
							SELECT 
								COUNT(DATE_ACC_BY_SVT) 
							FROM 
								qb_imp 
							LEFT JOIN 
								qbi ON qbi.QBN=qb_imp.QBN 
							WHERE 
								QBSTATUS='S' AND 
								LIGHT<>1 AND 
								QBREGDATE>=:sdat AND 
								QBREGDATE<=:edat AND 
								DATEDIFF(DATE_ACC_BY_SVT, QBREGDATE)>:dif AND 
								SVT=:svt";
						$stmt = $db->prepare($query);
						$stmt->execute(
							array(
								':sdat' => $_REQUEST['from'],
								':edat' => $_REQUEST['to'],
								':svt' => $_REQUEST['login'],
								':dif' => $r[count($r)-1][0]
							)
						);		
						$row = $stmt->fetch(PDO::FETCH_NUM );
						if ($row[0] > 0) {
							$r[] = Array(">".$r[count($r)-1][0], $row[0]);
						}
					}
					$result = json_encode($r);
					return $result;		
					break;
				case "t2c":
			// complete cycle time
					$query = "
						SELECT 
							DATEDIFF(GQ_DATE, DATE_ACC_BY_SVT) AS DD, 
							COUNT(DATEDIFF(GQ_DATE, DATE_ACC_BY_SVT)) 
						FROM 
							qbi, 
							qb_imp, 
							qb_close 
						WHERE 
							QBSTATUS='C' AND 
							qbi.QBN = qb_close.QBN AND 
							qb_imp.QBN = qb_close.QBN AND 
							LIGHT<>1 AND 
							QBREGDATE>=:sdat AND 
							QBREGDATE<=:edat AND 
							SVT=:svt 
						GROUP BY 
							DD 
						ORDER BY 
							DD ASC 
						LIMIT 0, 20";			
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':sdat' => $_REQUEST['from'],
							':edat' => $_REQUEST['to'],
							':svt' => $_REQUEST['login']
						)
					);
					$r = Array();
					while($row = $stmt->fetch(PDO::FETCH_NUM)) {
						$r[] = $row;
					}
					if (count($r) > 1) {
						$query = "
							SELECT 
								COUNT(GQ_DATE) 
							FROM 
								qbi, 
								qb_imp, 
								qb_close 
							WHERE 
								QBSTATUS='C' AND 
								qbi.QBN = qb_close.QBN AND 
								qb_imp.QBN = qb_close.QBN AND 
								LIGHT<>1 AND 
								QBREGDATE>=:sdat AND 
								QBREGDATE<=:edat AND 
								DATEDIFF(GQ_DATE, DATE_ACC_BY_SVT)>:dif AND 
								SVT=:svt
						";
						$stmt = $db->prepare($query);
						$stmt->execute(
							array(
								':sdat' => $_REQUEST['from'],
								':edat' => $_REQUEST['to'],
								':svt' => $_REQUEST['login'],
								':dif' => $r[count($r)-1][0]
							)
						);		
						$row = $stmt->fetch(PDO::FETCH_NUM );
						if ($row[0] > 0) {
							$r[] = Array(">".$r[count($r)-1][0], $row[0]);
						}
					}			
					$result = json_encode($r);
					return $result;		
					break;
			}
		}		
	}
?>	