<?php
	include_once (dirname(__FILE__)."/../templates/db-def.php");
	require_once ($rel_path."support.php");
	$qb_support = new QBSupport;
			
	$routine = new Team();
	echo $routine->execute();
	
	class Team {
		
		public function __construct() 
		{
		}
		
		public function execute()
		{	
			global $db, $debug, $qb_support, $rootlink, $c_scheme, $relili, $rel_path;
	// called routine
			$ini_team = parse_ini_file($rel_path.'i18n/team.ini', true);
			$sub_routine = $_REQUEST["routine"];
			switch ($sub_routine)
			{
				case "getform":
					$ret = array();	
				// form specific data		
					$query = "
						SELECT 
							COALESCE(CONCAT(NACHNAME, ', ', VORNAME), ''), 
							TOP, 
							SVTI, 
							LOGIN, 
							LIGHT,
							QBSTATUS
						FROM 
							qbi 
							LEFT JOIN qb_user ON SVT=LOGIN 
						WHERE 
							QBN=:qbn";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn']
						)
					);
					$row = $stmt->fetch(PDO::FETCH_NUM );
					list($ret["svt"], $ret["top_qb"], $ret["svti"], $ret["svtidx"], $ret["qb_light"], $ret["qb_status"]) = $row;
					$query = "
						SELECT 
							CONCAT(NACHNAME, ', ', VORNAME), 
							INFORMED,
							LOGIN,
							REGION 
						FROM 
							qb_user, qb_team 
						WHERE 
							QBN=:qbn AND 
							ROLLE='PL' AND 
							NAME=LOGIN";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn']
						)
					);
					$row = $stmt->fetch(PDO::FETCH_NUM );
					list($ret["pl"], $ret["pli"], $ret["pllogin"], $ret["plregion"]) = $row;
				// exchange of deputies allowed?
					$ret["exchange"] = 0;
					if ($qb_support->checkflag("D")) {
						$query = "SELECT COALESCE(EX, 0), SVT, COUNT(*) FROM qb_deputy WHERE DSVT=:dsvt";
						$stmt = $db->prepare($query);
						$stmt->execute(
							array(
								':dsvt' => $_REQUEST['login']
							)
						);
						$row = $stmt->fetch(PDO::FETCH_NUM );
						$ret["exchange"] = ($row[0]==1)?1:0;
						if ($ret["exchange"]) {
					// if allowed then check if actual svt is also deputy
							$query = "SELECT COUNT(*) FROM qb_deputy WHERE DSVT=:dsvt AND SVT=:svt";
							$stmt = $db->prepare($query);
							$stmt->execute(
								array(
									':dsvt' => $_REQUEST['login'],
									':svt' => $row[1]
								)
							);
							$ret["exchange"] = ($stmt->fetchColumn()==1)?1:0;			
						}
					}
					$query = "
						SELECT 
							COUNT(*), 
							DATE_FORMAT(COALESCE(MAX(INFORMED), '0000-00-00'), '%Y-%m-%d') 
						FROM 
							qb_team 
						WHERE 
							QBN=:qbn AND 
							ROLLE='MEMBER'";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn']
						)
					);
					$row = $stmt->fetch(PDO::FETCH_NUM );
					list($ret["teamcount"], $ret["teaminfo"]) = $row;
					$query = "
						SELECT 
							(SELECT COUNT(*) FROM qb_def WHERE QBN=:qbn)  + 
							(SELECT COUNT(*) FROM qb_fivewhy WHERE QBN=:qbn) + 
							(SELECT COUNT(*) FROM qb_docimm WHERE QBN=:qbn) + 
							(SELECT COUNT(*) FROM qb_docdef WHERE QBN=:qbn)
					";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn']
						)
					);
					$ret["immclose"] = $stmt->fetchColumn();
					$result = json_encode(Array($ret, $qb_support->qb_status($_REQUEST['qbn']), $qb_support->qb_rtype($_REQUEST['qbn'])));				
					return $result;		
					break;				
				case "smember":
					$query = "
						SELECT 
							CONCAT(NACHNAME,', ', VORNAME), LOGIN, NACHNAME, VORNAME, DEPARTMENT, REGION 
						FROM 
							qb_user 
						WHERE 
							(NACHNAME LIKE :nme OR VORNAME LIKE :nme) AND 
							LOGIN NOT IN (SELECT NAME FROM qb_team WHERE QBN=:qbn) AND
							ACTIVE=1
						ORDER BY 
							NACHNAME
					";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':nme' => '%'.$_REQUEST['nme'].'%',
							':qbn' => $_REQUEST['qbn']
						)
					);
					$rows = array();
					while($r = $stmt->fetch(PDO::FETCH_NUM)) {
						$rows[] = $r;
					}
					$result = json_encode($rows);
					return $result;		
					break;
			// email to single user							
				case "mailsingle":
					$qb_support->qbactivity($_REQUEST['qbn']);
			// write log file
					$qb_support->writelog($_REQUEST['qbn'], "A", "Team", $_REQUEST['idx']." informed on team assignment");					
				// set infromed date
					$query = "UPDATE qb_team SET INFORMED=NOW() WHERE QBN=:qbn AND NAME=:nme";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn'],
							':nme' => $_REQUEST['idx']
						)
					);
				// get pl
					$query = "SELECT EMAIL FROM qb_user LEFT JOIN qb_team ON NAME=LOGIN WHERE QBN=:qbn AND ROLLE='PL'";			
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn']
						)
					);
					$row = $stmt->fetch(PDO::FETCH_NUM);
					$sender = $row[0];
					$query = "SELECT VORNAME, EMAIL, LANG FROM qb_user WHERE LOGIN=:idx";
					$stmt = $db->prepare($query);
					$stmt->execute(array(':idx' => $_REQUEST['idx']));
					$result = $stmt->fetch(PDO::FETCH_NUM);					
				// load template file
					if ($result[2] == "") $result[2] = $qb_support->getOptions('fallbacklang', 'set');
					$template = file_get_contents($rel_path."mail/".$result[2].".team.inform_team_assignment.html");
					$template = str_replace('{{qbnummer}}', $_REQUEST['qbn'], $template);
					$template = str_replace('{{username}}', $result[0], $template);
					$template = str_replace('{{qblink}}', $relili . $_REQUEST['qbn'] . "&page=basic", $template);
					preg_match('/<title>(.*)<\/title>/iU', $template, $subject);
					$subject = $ini_team["qbshort"][$_SESSION["lng"]].$_REQUEST['qbn'].": ".$subject[1];					
					$qb_support->templatemail($result[1], $subject, $template, $sender, "team:mailsingle");				
					$result = "Done";
					return $result;				
					break;		
				case "showsvt":
					$query = "
						SELECT 
							CHANGEDATE AS changedate, 
							COALESCE((SELECT CONCAT(NACHNAME, ', ', VORNAME) FROM qb_user WHERE LOGIN=OLDSVT), '-') AS old,
							(SELECT CONCAT(NACHNAME, ', ', VORNAME) FROM qb_user WHERE LOGIN=NEWSVT) AS new,
							(SELECT CONCAT(NACHNAME, ', ', VORNAME) FROM qb_user WHERE LOGIN=CHANGER) AS changer 
						FROM 
							qb_svtchange 
						WHERE 
							QBN=:qbn 
						ORDER BY 
							CHANGEDATE DESC
					";				
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn']
						)
					);
					$rows = array();
					while($r = $stmt->fetch(PDO::FETCH_ASSOC)) {
						$rows[] = $r;
					}
					$result = json_encode($rows);
					return $result;		
					break;
				case "showpl":
					$query = "
						SELECT 
							CHANGEDATE AS changedate, 
							COALESCE((SELECT CONCAT(NACHNAME, ', ', VORNAME) FROM qb_user WHERE LOGIN=OLDPL), '-') AS old,
							COALESCE((SELECT CONCAT(NACHNAME, ', ', VORNAME) FROM qb_user WHERE LOGIN=NEWPL), '-') AS new,
							(SELECT CONCAT(NACHNAME, ', ', VORNAME) FROM qb_user WHERE LOGIN=CHANGER) AS changer 
						FROM 
							qb_plchange 
						WHERE 
							QBN=:qbn 
						ORDER BY 
							CHANGEDATE DESC
					";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn']
						)
					);
					$rows = array();
					while($r = $stmt->fetch(PDO::FETCH_ASSOC)) {
						$rows[] = $r;
					}
					$result = json_encode($rows);
					return $result;		
					break;			
		// qb type changed
				case "qblight":
					$qb_support->qbactivity($_REQUEST['qbn']);
				// set or reset mandatory team
					if ($_REQUEST['set'] == 1) {
				// write log
						$qb_support->writelog($_REQUEST['qbn'], "C", "Team", "Q-Case grading changed", "LIGHT", "NORMAL");
						$query = "UPDATE qbi SET LIGHT=1, QBSTATUS='S' WHERE QBN=:qbn";	
						$stmt = $db->prepare($query);
						$stmt->execute(
							array(
								':qbn' => $_REQUEST['qbn']
							)
						);
				// clear entries in 5why and qb_imp_sts
						$query = "DELETE FROM qb_fivewhy WHERE QBN=:qbn";
						$stmt = $db->prepare($query);
						$stmt->execute(
							array(
								':qbn' => $_REQUEST['qbn']
							)
						);
						$query = "DELETE FROM qb_imp_sts WHERE QBN=:qbn";
						$stmt = $db->prepare($query);
						$stmt->execute(
							array(
								':qbn' => $_REQUEST['qbn']
							)
						);
					// copy data from qb_docimm / qb_docimm_files to qb_docdef / qb_docdef_files
						// copy data to qb_docdef_files
						$query = "INSERT INTO qb_docdef_files (LUID, LINK) SELECT LUID, LINK FROM qb_docimm_files LEFT JOIN qb_docimm ON UID=LUID WHERE QBN=:qbn";
						$stmt = $db->prepare($query);
						$stmt->execute(
							array(
								':qbn' => $_REQUEST['qbn']
							)
						);
						// delete data from qb_docimm_files
						$query = "DELETE qb_docimm_files.* FROM qb_docimm_files LEFT JOIN qb_docimm ON UID=LUID WHERE QBN=:qbn";
						$stmt = $db->prepare($query);
						$stmt->execute(
							array(
								':qbn' => $_REQUEST['qbn']
							)
						);
						// copy data to qb_docdef
						$query = "INSERT INTO qb_docdef (QBN, UID, WHT, WHN, STAT, VISUM, UNTIL, INFO) SELECT QBN, UID, WHT, WHN, STAT, VISUM, UNTIL, INFO 
							FROM qb_docimm WHERE QBN=:qbn";
						$stmt = $db->prepare($query);
						$stmt->execute(
							array(
								':qbn' => $_REQUEST['qbn']
							)
						);
						// delete data from qb_docimm
						$query = "DELETE FROM qb_docimm WHERE QBN=:qbn";
						$stmt = $db->prepare($query);
						$stmt->execute(
							array(
								':qbn' => $_REQUEST['qbn']
							)
						);		
				// reset mandatory team if enabled
						if ($qb_support->getoptions('mandatoryteam', 'set') == "yes") {		// only if mandatory team is enabled
							$Conf_man = parse_ini_file($rel_path.'xml/mandatory.ini', true);
							$mstr = "[{";
							foreach($Conf_man as $key=>$value){
								if ($value['inuse'] == "Y") {
									$mstr.='"'.$key.'":"0",';
								}
							}
							$mstr = substr($mstr, 0, -1)."}]";
							$query = "UPDATE qb_man SET MANDARRAY=:mnd WHERE QBN=:qbn";
							$stmt = $db->prepare($query);
							$stmt->execute(
								array(
									':qbn' => $_REQUEST['qbn'],
									':mnd' => $mstr
								)
							);
						}						
					} else {
				// write log
						$qb_support->writelog($_REQUEST['qbn'], "C", "Team", "Q-Case grading changed", "NORMAL", "LIGHT");						
						$query = "UPDATE qbi SET LIGHT=0, QBSTATUS='O' WHERE QBN=:qbn";	
						$stmt = $db->prepare($query);
						$stmt->execute(
							array(
								':qbn' => $_REQUEST['qbn']
							)
						);
				// set mandatory team if enabled
						if ($qb_support->getoptions('mandatoryteam', 'set') == "yes") {		// only if mandatory team is enabled
							$Conf_man = parse_ini_file($rel_path.'xml/mandatory.ini', true);
							$mstr = "[{";
							foreach($Conf_man as $key=>$value){
								if ($value['inuse'] == "Y") {
									$mstr.='"'.$key.'":"1",';
								}
							}
							$mstr = substr($mstr, 0, -1)."}]";
							$query = "UPDATE qb_man SET MANDARRAY=:mnd WHERE QBN=:qbn";
							$stmt = $db->prepare($query);
							$stmt->execute(
								array(
									':qbn' => $_REQUEST['qbn'],
									':mnd' => $mstr
								)
							);
						}							
					}
					$result = "Done";
					return $result;		
					break;
				case "topqb":
					$qb_support->qbactivity($_REQUEST['qbn']);
			// toggle top QB
					$query = "UPDATE qbi SET TOP=:set WHERE QBN=:qbn";	
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn'],
							':set' => $_REQUEST['set']
						)
					);
			// write log
					if ($_REQUEST['set'] == 1) {
						$qb_support->writelog($_REQUEST['qbn'], "C", "Team", "Q-Case grading changed", "TOP", "NORMAL");
					} else {
						$qb_support->writelog($_REQUEST['qbn'], "C", "Team", "Q-Case grading changed", "NORMAL", "TOP");
					}
					break;
				case "setinformteam":
					$qb_support->qbactivity($_REQUEST['qbn']);
				// set infromed date
					$query = "UPDATE qb_team SET INFORMED=NOW() WHERE QBN=:qbn AND ROLLE='MEMBER'";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn']
						)
					);
					$result = "Done";
					return $result;		
					break;
				case "infoteam":
				// write log file
					$qb_support->writelog($_REQUEST['qbn'], "A", "Team", "Info send to team", $_REQUEST['txt']);
					$query = "SELECT EMAIL FROM qb_user WHERE LOGIN=:sen";
					$stmt = $db->prepare($query);
					$stmt->execute(array(':sen' => $_REQUEST['sen']));
					$row = $stmt->fetch(PDO::FETCH_NUM );
					$sender = $row[0];
					$query = "SELECT VORNAME, EMAIL, LANG FROM qb_team, qb_user WHERE QBN=:qbn AND ROLLE='MEMBER' AND NAME=LOGIN";
					$stmt = $db->prepare($query);
					$stmt->execute(array(':qbn' => $_REQUEST['qbn']));
					while ($result = $stmt->fetch(PDO::FETCH_NUM)) {
					// load template file
						if ($result[2] == "") $result[2] = $qb_support->getOptions('fallbacklang', 'set');
						$template = file_get_contents($rel_path."mail/".$result[2].".team.info_to_team.html");
						$template = str_replace('{{qbnummer}}', $_REQUEST['qbn'], $template);
						$template = str_replace('{{username}}', $result[0], $template);
						$template = str_replace('{{qbmessage}}', $_REQUEST['txt'], $template);
						$template = str_replace('{{qblink}}', $relili . $_REQUEST['qbn'] . "&page=basic", $template);
						$subject = $ini_team["qbshort"][$_SESSION["lng"]].$_REQUEST['qbn'].": ".$_REQUEST['sub'];					
						$qb_support->templatemail($result[1], $subject, $template, $sender, "team:infoteam");
					}			
					$result = "Done";
					return $result;		
					break;
			// inform complete team on assignment
				case "mailteam":
					$qb_support->qbactivity($_REQUEST['qbn']);
				// get pl
					$query = "SELECT EMAIL FROM qb_user LEFT JOIN qb_team ON NAME=LOGIN WHERE QBN=:qbn AND ROLLE='PL'";			
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn']
						)
					);
					$row = $stmt->fetch(PDO::FETCH_NUM);
					$sender = $row[0];
					$query = "SELECT VORNAME, EMAIL, LANG FROM qb_team, qb_user WHERE QBN=:qbn AND ROLLE='MEMBER' AND NAME=LOGIN";
					$stmt = $db->prepare($query);
					$stmt->execute(array(':qbn' => $_REQUEST['qbn']));
					while ($result = $stmt->fetch(PDO::FETCH_NUM)) {
					// load template file
						if ($result[2] == "") $result[2] = $qb_support->getOptions('fallbacklang', 'set');
						$template = file_get_contents($rel_path."mail/".$result[2].".team.inform_team_assignment.html");
						$template = str_replace('{{qbnummer}}', $_REQUEST['qbn'], $template);
						$template = str_replace('{{username}}', $result[0], $template);
						$template = str_replace('{{qblink}}', $relili . $_REQUEST['qbn'] . "&page=basic", $template);
						preg_match('/<title>(.*)<\/title>/iU', $template, $subject);
						$subject = $ini_team["qbshort"][$_SESSION["lng"]].$_REQUEST['qbn'].": ".$subject[1];					
						$qb_support->templatemail($result[1], $subject, $template, $sender, "team:mailteam");
				// write log file
						$qb_support->writelog($_REQUEST['qbn'], "A", "Team", "Info of team assignment send to ".$result[1]);
					}
					$result = "Done";
					return $result;		
					break;
				case "adddata":
					$qb_support->qbactivity($_REQUEST['qbn']);
					if ($qb_support->qb_status($_REQUEST['qbn']) == "M") {
						$inf = $_REQUEST['svti'];		// if manual QB set nominated & informed date to svti date
						$nom = $_REQUEST['svti'];
					} else {
						$inf = "0000-00-00 00:00:00";	
						$nom = date('Y-m-d H:i:s');
					}
				// check if team approval is available (diff in days or -1 if no dataset available
					$query = "SELECT COALESCE(DATEDIFF(NOW(), MAX(INFORMED)), -1) FROM qb_imp_sts WHERE QBN=:qbn";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn']
						)
					);
					$row = $stmt->fetch(PDO::FETCH_NUM );
				// check status for team approval (0 = no team approval - do nothing, 1 - team approval from today - add as informed and send email, 2 - team approval older than 1 day ago / add as later added
					$sts = 0;
					if ($row[0] > -1) {
						if ($row[0] == 0) {
							$sts = 1;
						} else {
							$sts = 2;
						}
					}
					$query = "SELECT EMAIL FROM qb_user LEFT JOIN qb_team ON NAME=LOGIN WHERE QBN=:qbn AND ROLLE='PL'";			
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn']
						)
					);
					$row = $stmt->fetch(PDO::FETCH_NUM);
					$pl = $row[0];					
					foreach ($_REQUEST['idxs'] as $key) {
				// add team member
						$query = "
							INSERT INTO 
								qb_team 
								(
									QBN, 
									NAME, 
									ROLLE, 
									NOMINATED,
									INFORMED
								) 
							VALUES
								(
									:qbn, 
									:key, 
									'MEMBER', 
									:nom,
									:inf
								)
						";
						$stmt = $db->prepare($query);
						$stmt->execute(
							array(
								':qbn' => $_REQUEST['qbn'],
								':key' => $key,
								':nom' => $nom,
								':inf' => $inf
							)
						);
					// write log file
						$qb_support->writelog($_REQUEST['qbn'], "A", "Team", $key. " added to team");						
						if ($sts == 1) {
					// if date of today insert as "informed"
							$unid = md5(uniqid(microtime(),1).getenv("REMOTE_ADDR"));
							$y_link = $rootlink . "voteimp.php?uid=" . $unid . "&vote=A";
							$n_link = $rootlink . "voteimp.php?uid=" . $unid . "&vote=R";			
							$query = "INSERT INTO qb_imp_sts (QBN, SU, ST, INFORMED, TOKEN) VALUES (:qbn, :key, 'I', NOW(), :uid)";
							$stmt = $db->prepare($query);
							$stmt->execute(
								array(
									':qbn' => $_REQUEST['qbn'],
									':key' => $key,
									':uid' => $unid
								)
							);
					// generate email
							$query = "SELECT EMAIL, VORNAME, LANG FROM qb_user WHERE LOGIN=:key";
							$stmt = $db->prepare($query);
							$stmt->execute(array(':key' => $key));
							$result = $stmt->fetch(PDO::FETCH_NUM );
							if ($result[2] == "") $result[2] = $qb_support->getOptions('fallbacklang', 'set');
							$template = file_get_contents($rel_path."mail/".$result[2].".implement.send_vote.html");
							$template = str_replace('{{username}}', $result[1], $template);
							$template = str_replace('{{qbnummer}}', $_REQUEST['qbn'], $template);
							$template = str_replace('{{yescolor}}', $c_scheme['SC'], $template);
							$template = str_replace('{{nocolor}}', $c_scheme['SO'], $template);
							$template = str_replace('{{yeslink}}', $y_link, $template);
							$template = str_replace('{{nolink}}', $n_link, $template);							
							$template = str_replace('{{qblink}}', $relili . $_REQUEST['qbn'] . "&page=basic", $template);
							preg_match('/<title>(.*)<\/title>/iU', $template, $subject);
							$subject = $ini_team["qbshort"][$_SESSION["lng"]].$_REQUEST['qbn'].": ".$subject[1];							
							$qb_support->templatemail($result[0], $subject, $template, "", "team_api:send_vote");
						} elseif ($sts == 2) {
					// insert as "added later"
							$query = "INSERT INTO qb_imp_sts (QBN, SU, ST) VALUES (:qbn, :key, 'S')";
							$stmt = $db->prepare($query);
							$stmt->execute(
								array(
									':qbn' => $_REQUEST['qbn'],
									':key' => $key
								)
							);
						}
					}
					$query = "
						SELECT 
							IF((SELECT COUNT(*) FROM qb_team WHERE INFORMED!='0000-00-00 00:00:00' AND QBN=:qbn AND ROLLE<>'PL') >0, 1,0) AS INF 
						FROM 
							qb_team 
						WHERE 
							QBN=:qbn AND 
							ROLLE<>'PL'
					";												
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn']
						)
					);					
					$result = $stmt->fetchColumn();
					return $result;		
					break;			
				case "delusr":
					$qb_support->qbactivity($_REQUEST['qbn']);
			// write log file
					$qb_support->writelog($_REQUEST['qbn'], "D", "Team", $_REQUEST['idx']." deleted from Q-case team");					
			// delete team member		
					$query = "DELETE FROM qb_team WHERE NAME=:idx AND QBN=:qbn";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn'],
							':idx' => $_REQUEST['idx']
						)
					);
			// check if member is part of approval team
					$query = "SELECT COUNT(*), IDX, ST FROM qb_imp_sts WHERE SU=:idx AND QBN=:qbn";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn'],
							':idx' => $_REQUEST['idx']
						)
					);
					$row = $stmt->fetch(PDO::FETCH_NUM);
					if ($row[0] > 0) {
				// yes, is part of approval team, check if already voted
						if ($row[2] == 'I') {
					// no, just informed - set status to "no vote" and delete
							$query = "UPDATE qb_imp_sts SET DEL='X', TOKEN='', ST='X' WHERE IDX=:idx";
							$stmt = $db->prepare($query);
							$stmt->execute(
								array(
									':idx' => $row[1]
								)
							);			
						} else {
					// yes, vote done, just mark as deleted
							$query = "UPDATE qb_imp_sts SET DEL='X' WHERE IDX=:idx";
							$stmt = $db->prepare($query);
							$stmt->execute(
								array(
									':idx' => $row[1]
								)
							);
						}
					}
					$result = $_REQUEST['idx'];
					return $result;		
					break;			
				case "getdata":
			// get individual team data		
					$query = "SELECT IDX, NACHNAME, VORNAME, DEPARTMENT FROM qb_user WHERE IDX=:idx";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':idx' => $_REQUEST['idx']
						)
					);
					$rows = array();
					while($r = $stmt->fetch(PDO::FETCH_ASSOC)) {
						$rows[] = $r;
					}
					$result = json_encode($rows);
					return $result;		
					break;
				case "savesvt":
					$qb_support->qbactivity($_REQUEST['qbn']);
			// save svt	
					if ($qb_support->qb_status($_REQUEST['qbn']) != "M") {
			// get svt data
						$query = "SELECT EMAIL, VORNAME, LANG, CONCAT(NACHNAME, ', ', VORNAME) FROM qb_user WHERE LOGIN=:svt";
						$stmt = $db->prepare($query);
						$stmt->execute(array(':svt' => $_REQUEST['svt']));
						$selectedsvt = $stmt->fetch(PDO::FETCH_NUM );
			// check if vacation representative is defined
						$query = "SELECT COUNT(DSVT), DSVT, CONCAT(NACHNAME, ', ', VORNAME) FROM qb_deputy LEFT JOIN qb_user on DSVT=LOGIN WHERE SVT=:svt AND REP='1'";
						$stmt = $db->prepare($query);
						$stmt->execute(
							array(
								':svt' => $_REQUEST['svt']
							)
						);				
						$row = $stmt->fetch(PDO::FETCH_NUM);
						$orgrep = 0;
						if ($row[0] > 0) {
			// yes, inform original SVT
							$orgrep = 1;
							$orgsvt = $_REQUEST['svt'];
					// load template file
							if ($selectedsvt[2] == "") $selectedsvt[2] = $qb_support->getOptions('fallbacklang', 'set');
							$template = file_get_contents($rel_path."mail/".$selectedsvt[2].".team.inform_new_svt_but_vacation.html");
							$template = str_replace('{{username}}', $selectedsvt[1], $template);
							$template = str_replace('{{qbnummer}}', $_REQUEST['qbn'], $template);
							$template = str_replace('{{representative}}', $row[2], $template);
							$template = str_replace('{{login}}', $_SESSION['fn'], $template);
							$template = str_replace('{{qblink}}', $relili . $_REQUEST['qbn'] . "&page=basic", $template);
							preg_match('/<title>(.*)<\/title>/iU', $template, $subject);
							$subject = $ini_team["qbshort"][$_SESSION["lng"]].$_REQUEST['qbn'].": ".$subject[1];							
							$qb_support->templatemail($selectedsvt[0], $subject, $template, "", "team_api:informnewsvtbutvacation");	
							$_REQUEST['svt'] = $row[1];
						}					
			// get old svt (if set)
						$query = "SELECT SVT, SVTI, VORNAME, EMAIL, LANG FROM qbi LEFT JOIN qb_user ON SVT=LOGIN WHERE QBN=:qbn";
						$stmt = $db->prepare($query);
						$stmt->execute(
							array(
								':qbn' => $_REQUEST['qbn']
							)
						);				
						$row = $stmt->fetch(PDO::FETCH_NUM);
			// write log
						$query = "INSERT INTO qb_svtchange SET QBN=:qbn, OLDSVT=:osv, NEWSVT=:nsv, CHANGER=:chn";
						$stmt = $db->prepare($query);
						$stmt->execute(
							array(
								':qbn' => $_REQUEST['qbn'],
								':osv' => $row[0],
								':nsv' => $_REQUEST['svt'],
								':chn' => $_SESSION['lg']
							)
						);
				// write log file
						if ($orgrep == 0) {			// no substitue
							$qb_support->writelog($_REQUEST['qbn'], "C", "Team", "Q-case responsible assigned", $_REQUEST['svt'], $row[0]);
						} else {
							$qb_support->writelog($_REQUEST['qbn'], "C", "Team", "Q-case responsible assigned", $orgsvt, $row[0]);
							$qb_support->writelog($_REQUEST['qbn'], "C", "Team", "Q-case responsible changed to representative changed by SYSTEM, initiated", $_REQUEST['svt'], $orgsvt);
						}
			// check if old svt was defined and if yes send notification of dismissal (if not changer itself)
						if (($row[0] != '') AND ($_SESSION['lg'] != $row[0])) {
							if ($row[4] == "") $row[4] = $qb_support->getOptions('fallbacklang', 'set');
							$template = file_get_contents($rel_path."mail/".$row[4].".team.inform_svt_dismissal.html");
							$template = str_replace('{{username}}', $row[2], $template);
							$template = str_replace('{{qbnummer}}', $_REQUEST['qbn'], $template);
							$template = str_replace('{{newsvt}}', $selectedsvt[3], $template);
							$template = str_replace('{{login}}', $_SESSION['fn'], $template);
							$template = str_replace('{{qblink}}', $relili . $_REQUEST['qbn'] . "&page=basic", $template);
							preg_match('/<title>(.*)<\/title>/iU', $template, $subject);
							$subject = $ini_team["qbshort"][$_SESSION["lng"]].$_REQUEST['qbn'].": ".$subject[1];							
							$qb_support->templatemail($row[3], $subject, $template, "", "team_api:informsvtdismissal");							
						}
			// set new svt
						$query = "UPDATE qbi SET SVT=:svt, SVTI=NOW(), IC=0 WHERE QBN=:qbn";
						$stmt = $db->prepare($query);
						$stmt->execute(
							array(
								':svt' => $_REQUEST['svt'],
								':qbn' => $_REQUEST['qbn']
							)
						);
			// inform new svt
						$query = "SELECT EMAIL, VORNAME, LANG, CONCAT(NACHNAME, ', ', VORNAME) FROM qb_user WHERE LOGIN=:svt";
						$stmt = $db->prepare($query);
						$stmt->execute(array(':svt' => $_REQUEST['svt']));
						$result = $stmt->fetch(PDO::FETCH_NUM );
						if ($result[2] == "") $result[2] = $qb_support->getOptions('fallbacklang', 'set');
						$template = file_get_contents($rel_path."mail/".$result[2].".team.inform_new_svt.html");
						$template = str_replace('{{username}}', $result[1], $template);
						$template = str_replace('{{qbnummer}}', $_REQUEST['qbn'], $template);
						$template = str_replace('{{login}}', $_SESSION['fn'], $template);
						$template = str_replace('{{qblink}}', $relili . $_REQUEST['qbn'] . "&page=basic", $template);
						preg_match('/<title>(.*)<\/title>/iU', $template, $subject);
						$subject = $ini_team["qbshort"][$_SESSION["lng"]].$_REQUEST['qbn'].": ".$subject[1];							
						$qb_support->templatemail($result[0], $subject, $template, "", "team_api:informnewsvt");
						$return_svt = $result[3];
					} else {			
						$query = "UPDATE qbi SET SVT=:svt WHERE QBN=:qbn";
						$stmt = $db->prepare($query);
						$stmt->execute(
							array(
								':svt' => $_REQUEST['svt'],
								':qbn' => $_REQUEST['qbn']
							)
						);
						$query = "SELECT CONCAT(NACHNAME, ', ', VORNAME) FROM qb_user WHERE LOGIN=:svt";
						$stmt = $db->prepare($query);
						$stmt->execute(array(':svt' => $_REQUEST['svt']));
						$result = $stmt->fetch(PDO::FETCH_NUM );
						$return_svt = $result[0];
					}
			// check if deputy SVT
					$query = "SELECT COUNT(SVT) FROM qb_deputy WHERE SVT=:svt AND DSVT=:dsv";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':svt' => $_SESSION['lg'],
							':dsv' => $_REQUEST['svt']
						)
					);
					$row = $stmt->fetch(PDO::FETCH_NUM);
					if ($row[0] == 0) {
				// no, no deputy -> delete DEPUTY field in qbi (just for safety reasons, may be it was set before)
						$query = "UPDATE qbi SET DELEGATE='' WHERE QBN=:qbn";
						$stmt = $db->prepare($query);
						$stmt->execute(
							array(
								':qbn' => $_REQUEST['qbn']
							)
						);
					} else {
				// yes, set DEPUTY
						$query = "UPDATE qbi SET DELEGATE=:del WHERE QBN=:qbn";
						$stmt = $db->prepare($query);
						$stmt->execute(
							array(
								':del' => $_SESSION['lg'],
								':qbn' => $_REQUEST['qbn']
							)
						);
					}
					$result = $return_svt;
					return $result;		
					break;
				case "loadmandteam":
					global $rel_path;
					$mnd_team = parse_ini_file($rel_path.'xml/mandatory.ini', true);		
		// list all existing team members
					$query = "SELECT MANDARRAY FROM qb_man WHERE QBN=:qbn";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn']
						)
					);			
					$mnd = json_decode($stmt->fetchColumn(), true);
					$newmnd = array();
			// check for undeletable if configured	
          $force_team = parse_ini_file($rel_path.'xml/force.ini', true);
          $force = array();
          if ($qb_support->getOptions('forcerole', 'useit') == "yes") {    
            if (isset($force_team[$_REQUEST['plr']])) {
              if (isset($force_team[$_REQUEST['plr']][$_REQUEST['rtype']])) {
                $force = explode(":", $force_team[$_REQUEST['plr']][$_REQUEST['rtype']]);
              }
            }
          }

			// return
			// "0" if not needed
			// "1" if needed but not available yet
			// "2" if needed and available
			// "3" if undeletable and not available yet
			// "4" if undeleteable and available						
					foreach ($mnd[0] as $key=>$value) {
						$status = 0;					
						if (in_array($key, $force)) {				
					// this in an "undeleteable" team function
							$query = "SELECT IF (:key IN (SELECT SHORT FROM qb_user, qb_team, qb_mantrans WHERE NAME=LOGIN AND qb_user.DEPARTMENT=qb_mantrans.DEPARTMENT AND QBN=:qbn), 4, 3)";
							$stmt = $db->prepare($query);
							$stmt->execute(
								array(
									':qbn' => $_REQUEST['qbn'],
									':key' => $key
								)
							);						
							$status = $stmt->fetchColumn();					
						} else {
							if ($value != 0) {
								$query = "SELECT IF (:key IN (SELECT SHORT FROM qb_user, qb_team, qb_mantrans WHERE NAME=LOGIN AND qb_user.DEPARTMENT=qb_mantrans.DEPARTMENT AND QBN=:qbn), 2, 1)";
								$stmt = $db->prepare($query);
								$stmt->execute(
									array(
										':qbn' => $_REQUEST['qbn'],
										':key' => $key
									)
								);						
								$status = $stmt->fetchColumn();
							}
						}
						if ($mnd_team[$key]['inuse'] == "Y") {
							$newmnd[] = Array("$key", $mnd_team[$key][$_SESSION['lng']], $status);
							$status = 0;
						}
					}
					$result = json_encode($newmnd);
					return $result;		
					break;
				case "existteam":
			// list all existing team members
					$query = "
						SELECT 
							LOGIN, 
							NACHNAME, 
							VORNAME, 
							DEPARTMENT, 
							COALESCE(DATE(INFORMED), '-') AS INFORMED, 
							REGION,
							COALESCE(NOMINATED, '-') AS NOMINATED
						FROM 
							qb_team, 
							qb_user 
						WHERE 
							NAME=LOGIN AND 
							QBN=:qbn AND 
							ROLLE<>'PL' 
						ORDER BY 
							NACHNAME
					";											
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn']
						)
					);
					$rows = array();			
					while($r = $stmt->fetch(PDO::FETCH_ASSOC)) {
						$rows[] = $r;
					}
					$query = "
						SELECT 
							(SELECT COUNT(*) FROM qb_team WHERE QBN=:qbn AND ROLLE<>'PL') AS TC, 
							(SELECT COUNT(*) FROM qb_team WHERE INFORMED!='0000-00-00 00:00:00' AND QBN=:qbn AND ROLLE<>'PL') AS TI
					";												
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn']
						)
					);
					$row = $stmt->fetch(PDO::FETCH_NUM);		
					$result = json_encode(Array($rows, $row, $qb_support->qb_status($_REQUEST['qbn'])));
					return $result;		
					break;
				case "savemand":
					$qb_support->qbactivity($_REQUEST['qbn']);
				// get old value for log file
					$stmt = $db->prepare("SELECT MANDARRAY FROM qb_man WHERE QBN=:qbn");
					$stmt->execute(array(':qbn' => $_REQUEST['qbn']));
					$oc = $stmt->fetch(PDO::FETCH_NUM);	
				// write log file
					$qb_support->writelog($_REQUEST['qbn'], "C", "Team", "Mandatory team changed", $_REQUEST['mstr'], $oc[0]);
			// save new mandatory settings
					$query = "UPDATE qb_man SET MANDARRAY=:val WHERE QBN=:qbn";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':val' => $_REQUEST['mstr'],
							':qbn' => $_REQUEST['qbn']
						)
					);
					break;
				case "immclose":
				// immediate closure by SVT
					$qb_support->qbactivity($_REQUEST['qbn']);
				// write log file
					$qb_support->writelog($_REQUEST['qbn'], "A", "Team", "Q-Case immediately closed");
				// fill table qb_imp
					$query = "SELECT COUNT(*) FROM qb_imp WHERE QBN=:qbn";
					$stmt = $db->prepare($query);
					$stmt->execute(array(':qbn' => $_REQUEST['qbn']));
					$row = $stmt->fetch(PDO::FETCH_NUM);
					if ($row[0] == 0) {
					// INSERT
						$query = "
							INSERT INTO 
								qb_imp 
								(
									QBN, 
									DATE_REL_M, 
									PLANNED_C_DATE, 
									SEND_TO_SVT, 
									DATE_ACC_BY_SVT, 
									DESCRIPTION,
									TEAMAPP
								) 
							VALUES 
								(
									:qbn, 
									:dat, 
									:dat, 
									:dat, 
									:dat, 
									:res,
									4
								)
						";
					} else {
					// UPDATE
						$query = "
							UPDATE 
								qb_imp 
							SET 
								DATE_REL_M=:dat, 
								PLANNED_C_DATE=:dat, 
								SEND_TO_SVT=:dat, 
								DATE_ACC_BY_SVT=:dat, 
								DESCRIPTION=:res,
								TEAMAPP=4
							WHERE 
								QBN=:qbn
						";					
					}
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn'],
							':dat' => date('Y-m-d', time()),
							':res' => $_REQUEST['reason']
						)
					);
				// fill table qb_close
					$query = "SELECT COUNT(*) FROM qb_close WHERE QBN=:qbn";
					$stmt = $db->prepare($query);
					$stmt->execute(array(':qbn' => $_REQUEST['qbn']));
					$row = $stmt->fetch(PDO::FETCH_NUM);
					if ($row[0] == 0) {
				// INSERT
						$query = "
							INSERT INTO 
								qb_close
								(
									QBN,
									FU,
									VB,
									LAF,
									FFU,
									VG_DATE,
									CL_DATE,
									GQ_DATE,
									CLOSEDBY,
									CSTATUS
								)
							VALUES
								(
									:qbn,
									:res, 
									:res, 
									:res, 
									'NA', 
									:dat, 
									:dat, 
									:dat,
									:cls,
									6
								)
						";				
					} else {
				// UPDATE
						$query = "
							UPDATE 
								qb_close 
							SET 
								FU=:res, 
								VB=:res, 
								LAF=:res, 
								FFU='NA', 
								VG_DATE=:dat, 
								CL_DATE=:dat, 
								GQ_DATE=:dat,
								CLOSEDBY=:cls,
								CSTATUS=6
							WHERE 
								QBN=:qbn
						";
					}			
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn'],
							':dat' => date('Y-m-d', time()),
							':res' => $_REQUEST['reason'],
							':cls' => $_REQUEST['login']
						)
					);					
				// set status to closed and set failure codes to "XX"
					$query = "
						UPDATE 
							qbi 
						SET 
							QBSTATUS='C', 
							SVT=:cls, 
							BB='XX', 
							CC='XX', 
							DDDD='XXXX',
							RATING=0,
							CLSS='R'
						WHERE 
							QBN=:qbn
					";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn'],
							':cls' => $_REQUEST['login']
						)
					);
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn'],
							':cls' => $_REQUEST['login']
						)
					);					
					$result = "Done";
					return $result;		
					break;
				case "selectpl":
		// list available PLs
					$query = "
						SELECT 
							CONCAT(NACHNAME, ', ', VORNAME) AS NAME, 
							LOGIN AS IDX,
							'P' AS STS
						FROM 
							qb_user 
						WHERE 
							FLAGS LIKE '%F%' AND
							LOGIN NOT IN (SELECT NAME FROM qb_team WHERE QBN=:qbn AND ROLLE<>'PL')
						ORDER BY 
							NACHNAME
					";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn']
						)
					);
					$rows = array();
					while($r = $stmt->fetch(PDO::FETCH_NUM)) {
						$rows[] = $r;
					}
					$result = json_encode($rows);
					return $result;		
					break;
				case "savepl":		
					$qb_support->qbactivity($_REQUEST['qbn']);
			// get old pl befor saving the new
					$query = "
						SELECT 
							COUNT(NAME), NAME, EMAIL, VORNAME, LANG, CONCAT(NACHNAME, ', ', VORNAME), LOGIN 
						FROM 
							qb_team LEFT JOIN qb_user ON NAME=LOGIN
						WHERE
							ROLLE='PL' AND QBN=:qbn
					";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn']
						)
					);
					$oldpl = $stmt->fetch(PDO::FETCH_NUM);
			// write log file
					if ($_REQUEST['pl'] == -1) {		// old PL deleted
						$qb_support->writelog($_REQUEST['qbn'], "D", "Team", "Q-case leader deleted", "", $oldpl[6]);
					} else {
						$qb_support->writelog($_REQUEST['qbn'], "C", "Team", "Q-case leader changed", $_REQUEST['pl'], $oldpl[6]);
					}
		// delete old PL
					$query = "DELETE FROM qb_team WHERE ROLLE='PL' AND QBN=:qbn";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn']
						)
					);
			// inform old PL (if defined) about dismissal
					if ($oldpl[0] != 0) {
						$query = "SELECT CONCAT(NACHNAME, ', ', VORNAME) FROM qb_user WHERE LOGIN=:plm";
						$stmt = $db->prepare($query);
						$stmt->execute(array(':plm' => $_REQUEST['pl']));
						$result = $stmt->fetchColumn();
						if ($oldpl[4] == "") $oldpl[4] = $qb_support->getOptions('fallbacklang', 'set');
						$template = file_get_contents($rel_path."mail/".$oldpl[4].".team.inform_pl_dismissal.html");
						$template = str_replace('{{username}}', $oldpl[3], $template);
						$template = str_replace('{{qbnummer}}', $_REQUEST['qbn'], $template);
						$template = str_replace('{{newpl}}', ($_REQUEST['pl'] == -1)?'NA':$result, $template);
						$template = str_replace('{{login}}', $_SESSION['fn'], $template);
						$template = str_replace('{{qblink}}', $relili . $_REQUEST['qbn'] . "&page=basic", $template);
						preg_match('/<title>(.*)<\/title>/iU', $template, $subject);
						$subject = $ini_team["qbshort"][$_SESSION["lng"]].$_REQUEST['qbn'].": ".$subject[1];							
						$qb_support->templatemail($oldpl[2], $subject, $template, "", "team_api:informpldismissal");
					}
					if ($_REQUEST['pl'] != -1) {						
			// save pl if not "delete" selected
						$query = "INSERT INTO qb_team (NAME, ROLLE, QBN, INFORMED) VALUES(:plm, 'PL', :qbn, NOW())";
						$stmt = $db->prepare($query);
						$stmt->execute(
							array(
								':plm' => $_REQUEST['pl'],
								':qbn' => $_REQUEST['qbn']
							)
						);
						$query = "SELECT REGION, EMAIL, LANG, VORNAME,CONCAT(NACHNAME, ', ', VORNAME) FROM qb_user WHERE LOGIN=:plm";
						$stmt = $db->prepare($query);
						$stmt->execute(
							array(
								':plm' => $_REQUEST['pl']
							)
						);
						$newpl = $stmt->fetch(PDO::FETCH_NUM);			
				// inform new PL about assignment
						if ($newpl[2] == "") $newpl[2] = $qb_support->getOptions('fallbacklang', 'set');
						$template = file_get_contents($rel_path."mail/".$newpl[2].".team.inform_new_pl.html");
						$template = str_replace('{{username}}', $newpl[3], $template);
						$template = str_replace('{{qbnummer}}', $_REQUEST['qbn'], $template);
						$template = str_replace('{{login}}', $_SESSION['fn'], $template);
						$template = str_replace('{{qblink}}', $relili . $_REQUEST['qbn'] . "&page=basic", $template);
						preg_match('/<title>(.*)<\/title>/iU', $template, $subject);
						$subject = $ini_team["qbshort"][$_SESSION["lng"]].$_REQUEST['qbn'].": ".$subject[1];							
						$qb_support->templatemail($newpl[1], $subject, $template, "", "team_api:informnewpl");						
						$result = $newpl[0];
					} else {
						$result = "";
					}
		// write log
					$query = "INSERT INTO qb_plchange SET QBN=:qbn, NEWPL=:npl, OLDPL=:opl, CHANGER=:chn";	
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn'],
							':npl' => ($_REQUEST['pl']!=-1)?$_REQUEST['pl']:"",
							':opl' => (isset($oldpl[1]))?$oldpl[1]:"-",
							':chn' => $_SESSION['lg']
						)
					);	
		// change qb status to "open"
          $oldqbstatus = $qb_support->qb_status($_REQUEST['qbn']);
					if (!in_array($oldqbstatus, Array("M", "S", "C"))) {
						if ($_REQUEST['pl'] != -1) {
							$query = "UPDATE qbi SET QBSTATUS='O' WHERE QBN=:qbn";
              $qb_support->writelog($_REQUEST['qbn'], "C", "Team", "Q-case status changed after new PL assignment", $oldqbstatus, 'O');
						} else {
			// if PL was deleted set status back do "N"
							$query = "UPDATE qbi SET QBSTATUS='N' WHERE QBN=:qbn";
              $qb_support->writelog($_REQUEST['qbn'], "C", "Team", "Q-case status changed after PL deleted", $oldqbstatus, 'N');              
						}
						$stmt = $db->prepare($query);
						$stmt->execute(
							array(
								':qbn' => $_REQUEST['qbn']
							)
						);	
					}	else {
            $qb_support->writelog($_REQUEST['qbn'], "C", "Team", "Q-case status not changed after PL assignment", $oldqbstatus);
          }
					return $result;		
					break;
		// inform deleted user only if already informed
				case "informdeluser":
					$query = "SELECT VORNAME, EMAIL, LANG FROM qb_user WHERE LOGIN=:idx";
					$stmt = $db->prepare($query);
					$stmt->execute(array(':idx' => $_REQUEST['idx']));
					$result = $stmt->fetch(PDO::FETCH_NUM);
				// load template file
					if ($result[2] == "") $result[2] = $qb_support->getOptions('fallbacklang', 'set');
					$template = file_get_contents($rel_path."mail/".$result[2].".team.inform_team_dismissal.html");
					$template = str_replace('{{qbnummer}}', $_REQUEST['qbn'], $template);
					$template = str_replace('{{username}}', $result[0], $template);
					$template = str_replace('{{qblink}}', $relili . $_REQUEST['qbn'] . "&page=basic", $template);
					preg_match('/<title>(.*)<\/title>/iU', $template, $subject);
					$subject = $ini_team["qbshort"][$_SESSION["lng"]].$_REQUEST['qbn'].": ".$subject[1];					
					$qb_support->templatemail($result[1], $subject, $template, "", "team:informdeluser");
					return "Done";
					break;				
			}
		}
	}
?>