<?php
	include_once (dirname(__FILE__)."/../templates/db-def.php");
	global $rel_path;
	require_once ($rel_path."support.php");
	$qb_support = new QBSupport;

	$routine = new Validate();
	echo $routine->execute();
	
	class Validate {
		
		public function __construct() 
		{
		}
		
		public function execute()
		{	
			global $db, $debug, $qb_support, $timezone;
	// called routine
			$sub_routine = $_REQUEST["routine"];
			switch ($sub_routine)
			{
				case "getdata":
					$res = Array();					
					$query = "
						SELECT 
							CHECK_NEXT_WE, 
							WE_OK, 
							WE_DATE, 
							OTHER_TEST, 
							TEST_OK, 
							V_DATE,
							DOOT
						FROM 
							qb_val
						WHERE 
							QBN=:qbn
					";				
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn']
						)
					);
					if($stmt->rowCount() > 0) {
						$row = $stmt->fetch(PDO::FETCH_NUM );					
						list($res['CNW'], $res['WOK'], $res['WED'], $res['OTT'], $res['TOK'], $res['VDA'], $res['DOOT']) = $row;
					} else {
						$res['CNW'] = 0;
						$res['WOK'] = 0;
						$res['WED'] = "";
						$res['OTT'] = "";
						$res['TOK'] = 0;
						$res['DOOT'] = 0;
						$res['VDA'] = "0000-00-00";
					}
					$result = json_encode(Array($res, $qb_support->qb_status($_REQUEST['qbn'])));				
					return $result;
				case "doot":
					$qb_support->qbactivity($_REQUEST['qbn']);
					$query  = "SELECT * FROM qb_val WHERE QBN=:qbn";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn']
						)
					);		
					if ($stmt->rowCount() > 0) {
						if ($_REQUEST['wep'] == 1) {
							$qb_support->writelog($_REQUEST['qbn'], "C", "VALIDATE", "Do other test set");
						} else {
							$qb_support->writelog($_REQUEST['qbn'], "C", "VALIDATE", "Do other test unset");						
						}
						$query = "UPDATE qb_val SET DOOT=:wep WHERE QBN=:qbn";
					} else {
						$qb_support->writelog($_REQUEST['qbn'], "A", "VALIDATE", "Do other test set");						
						$query = "INSERT INTO qb_val (DOOT, QBN) VALUES(:wep, :qbn)";
					}
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn'],
							':wep' => $_REQUEST['wep']
						)
					);
					if ($_REQUEST['wep'] == 0) {
						$query = "UPDATE qb_val SET TEST_OK=0, V_DATE='0000-00-00', OTHER_TEST='' WHERE QBN=:qbn";
						$stmt = $db->prepare($query);
						$stmt->execute(
							array(
								':qbn' => $_REQUEST['qbn']
							)
						);						
					}
					$result = "Done";
					return $result;		
					break;				
				case "cnwe":
					$qb_support->qbactivity($_REQUEST['qbn']);
					$query  = "SELECT * FROM qb_val WHERE QBN=:qbn";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn']
						)
					);		
					if ($stmt->rowCount() > 0) {
			// write log
						if ($_REQUEST['wep'] == 1) {
							$qb_support->writelog($_REQUEST['qbn'], "C", "VALIDATE", "Incoming inspection set");
						} else {
							$qb_support->writelog($_REQUEST['qbn'], "C", "VALIDATE", "Incoming inspection unset");						
						}
						$query = "UPDATE qb_val SET CHECK_NEXT_WE=:wep WHERE QBN=:qbn";
					} else {
			// write log
						$qb_support->writelog($_REQUEST['qbn'], "A", "VALIDATE", "Check next incoming delivery set");												
						$query = "INSERT INTO qb_val (CHECK_NEXT_WE, QBN) VALUES(:wep, :qbn)";
					}
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn'],
							':wep' => $_REQUEST['wep']
						)
					);
					if ($_REQUEST['wep'] == 0) {
						$query = "UPDATE qb_val SET WE_OK=0, WE_DATE='0000-00-00' WHERE QBN=:qbn";
						$stmt = $db->prepare($query);
						$stmt->execute(
							array(
								':qbn' => $_REQUEST['qbn']
							)
						);						
					}
					$result = "Done";
					return $result;		
					break;
				case "cweok":
					$qb_support->qbactivity($_REQUEST['qbn']);
					$query = "UPDATE qb_val SET WE_OK=:wep, WE_DATE=NOW() WHERE QBN=:qbn";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn'],
							':wep' => $_REQUEST['wep']
						)
					);
					if ($_REQUEST['wep'] == 1) {
						$qb_support->writelog($_REQUEST['qbn'], "C", "VALIDATE", "Incoming inspection OK set", date('Y-m-d'));						
					} else {
						$qb_support->writelog($_REQUEST['qbn'], "C", "VALIDATE", "Incoming inspection OK unset");						
					}
					date_default_timezone_set($timezone);					
					$result = date("Y-m-d");
					return $result;		
					break;
				case "savewedate":
			// write log
					$qb_support->writelog($_REQUEST['qbn'], "C", "VALIDATE", "Incoming inspection date set", $_REQUEST['dat']);									
					$query = "UPDATE qb_val SET WE_DATE=:dat WHERE QBN=:qbn";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn'],
							':dat' => $_REQUEST['dat']
						)
					);					
					$result = "Done";
					return $result;		
					break;	
				case "savevdatedate":
			// write log
					$qb_support->writelog($_REQUEST['qbn'], "C", "VALIDATE", "Verification date of other test set", $_REQUEST['dat']);									
					$qb_support->qbactivity($_REQUEST['qbn']);
					$query = "UPDATE qb_val SET V_DATE=:dat, OTHER_TEST=:ott, TEST_OK=1 WHERE QBN=:qbn";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn'],
							':dat' => $_REQUEST['dat'],
							':ott' => $_REQUEST['ott']
						)
					);					
					$result = "Done";
					return $result;		
					break;				
				case "otest":
					$qb_support->qbactivity($_REQUEST['qbn']);
					$query  = "SELECT * FROM qb_val WHERE QBN=:qbn";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn']
						)
					);		
					if ($stmt->rowCount() > 0) {
						$qb_support->writelog($_REQUEST['qbn'], "C", "VALIDATE", "Incoming inspection other test changed");
						$query = "UPDATE qb_val SET OTHER_TEST=:ott WHERE QBN=:qbn";
					} else {
						$qb_support->writelog($_REQUEST['qbn'], "A", "VALIDATE", "Incoming inspection other test entered");						
						$query = "INSERT INTO qb_val (OTHER_TEST, QBN) VALUES(:ott, :qbn)";
					}
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn'],
							':ott' => $_REQUEST['ott']
						)
					);
					if (trim($_REQUEST['ott']) == "") {
						$query = "UPDATE qb_val SET TEST_OK=:wep, V_DATE='0000-00-00' WHERE QBN=:qbn";
						$stmt = $db->prepare($query);
						$stmt->execute(
							array(
								':qbn' => $_REQUEST['qbn'],
								':wep' => 0
							)
						);						
					}					
					$result = "Done";
					return $result;		
					break;
				case "cottok":
					$qb_support->qbactivity($_REQUEST['qbn']);
					$query = "UPDATE qb_val SET TEST_OK=:tok, V_DATE=NOW(), OTHER_TEST=:ott WHERE QBN=:qbn";
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn'],
							':tok' => $_REQUEST['tok'],
							':ott' => $_REQUEST['ott']
						)
					);
					if ($_REQUEST['tok'] == 1) {
						$qb_support->writelog($_REQUEST['qbn'], "C", "VALIDATE", "Incoming inspection other test OK set", date('Y-m-d'));
					} else {
						$qb_support->writelog($_REQUEST['qbn'], "C", "VALIDATE", "Incoming inspection other test OK unset");						
					}
					date_default_timezone_set($timezone);					
					$result = date("Y-m-d");
					return $result;		
					break;					
			}
		}
	}
?>								