<?php
	include_once (dirname(__FILE__)."/../templates/db-def.php");
	global $rel_path;
	require_once ($rel_path."support.php");
	$qb_support = new QBSupport;

	$routine = new Vote();
	echo $routine->execute();
	
	class Vote {
		
		public function __construct() 
		{
		}
		
		public function execute()
		{	
			global $db, $debug, $qb_support, $timezone, $rel_path, $relili;
	// called routine
			$sub_routine = $_REQUEST["routine"];
			switch ($sub_routine)
			{
				case "setteamstatus":
					$query = "SELECT SU FROM qb_imp_sts WHERE IDX=:idx";
					$stmt = $db->prepare($query);
					$stmt->execute(array(':idx' => $_REQUEST['idx']));
					$row = $stmt->fetch(PDO::FETCH_NUM);
			// write log
					$qb_support->writelog($_REQUEST['qbn'], "A", "IMMEDIATE", $row[0]." voted for implementation", $_REQUEST['vte']);
			// write vote in database				
					$query = "UPDATE qb_imp_sts SET ST=:vot, TOKEN='', ANSWER=NOW() WHERE IDX=:idx";							
					$stmt = $db->prepare($query);					
					$stmt->execute(
						array(
							':vot' => $_REQUEST['vte'],
							':idx' => $_REQUEST['idx']
						)
					);
			// check overall status
					$query = "SELECT (SELECT COUNT(*) FROM qb_imp_sts WHERE ST='R' AND DEL='' AND QBN=:qbn) AS REJ, (SELECT COUNT(*) FROM qb_imp_sts WHERE 
						(ST='A' OR ST='N') AND DEL='' AND QBN=:qbn) AS ACC, (SELECT COUNT(*) FROM qb_imp_sts WHERE QBN=:qbn AND DEL='' AND ST<>'S') AS TOT";				
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn']
						)
					);
					$row = $stmt->fetch(PDO::FETCH_NUM );					
					if	(($row[0]*1+$row[1]*1) == $row[2]*1) {				
				// all votes done, now check what to do
						if ($row[1] == $row[2]) {
					// write log
							$qb_support->writelog($_REQUEST['qbn'], "A", "IMMEDIATE", "All votes done and positive");
					// all votes positive, set teamapp to 5 (sent to svt)
							$query = "UPDATE qb_imp SET TEAMAPP=5 WHERE QBN=:qbn";
							$stmt = $db->prepare($query);
							$stmt->execute(
								array(
									':qbn' => $_REQUEST['qbn']
								)
							);
					// all votes "accepted" -> inform SVT
							$query = "UPDATE qb_imp set SEND_TO_SVT=:dat WHERE QBN=:qbn";
							$stmt = $db->prepare($query);
							$stmt->execute(
								array(
									':qbn' => $_REQUEST['qbn'],
									':dat' => date('Y-m-d')
								)
							);
					// write log
							$qb_support->writelog($_REQUEST['qbn'], "A", "IMMEDIATE", "Q-case responsible informed about positive vote", date('Y-m-d'));
					// inform SVT
							$qb_support->stsvt($_REQUEST['qbn'], "E5");
					// Event Mailing
							$qb_support->event_mail2("E5", $_REQUEST['qbn']);
						} else {			
					// not all votes positive, set teamapop to 2
							$query = "UPDATE qb_imp SET TEAMAPP=2 WHERE QBN=:qbn";
							$stmt = $db->prepare($query);
							$stmt->execute(
								array(
									':qbn' => $_REQUEST['qbn']
								)
							);	
					// write log
							$qb_support->writelog($_REQUEST['qbn'], "A", "IMMEDIATE", "All votes done but not all positive");
					// write log
							$qb_support->writelog($_REQUEST['qbn'], "A", "IMMEDIATE", "Q-case leader informed about rejection", date('Y-m-d'));
					// not all accepted -> inform PL
							$qb_support->ifplrej($_REQUEST['qbn']);
						}
					}
					return "Done";
					break;
				case "setteamstatus2":
			// reject of vote - send mail to PL
				// load PL
					$query = "SELECT EMAIL, VORNAME FROM qb_user LEFT JOIN qb_team ON NAME=LOGIN WHERE QBN=:qbn AND ROLLE='PL'";			
					$stmt2 = $db->prepare($query);
					$stmt2->execute(array(':qbn' => $_REQUEST['qbn']));	
					list($sender, $vn) = $stmt2->fetch(PDO::FETCH_NUM);				
					$query = "SELECT VORNAME, EMAIL, LANG, LOGIN FROM qb_user LEFT JOIN qb_imp_sts ON SU=LOGIN WHERE TOKEN=:tkn";		
					$stmt = $db->prepare($query);
					$stmt->execute(array(':tkn' => $_REQUEST['tkn']));
					$result = $stmt->fetch(PDO::FETCH_NUM);
			// write log
					$qb_support->writelog($_REQUEST['qbn'], "A", "IMMEDIATE", $result[3]." rejected the implementation", $_REQUEST['cmt']);									
				// load template file
					if ($result[2] == "") $result[2] = $qb_support->getOptions('fallbacklang', 'set');
					$template = file_get_contents($rel_path."mail/".$result[2].".voteimp.rejectimplementation.html");
					$template = str_replace('{{qbnummer}}', $_REQUEST['qbn'], $template);
					$template = str_replace('{{reason}}', $_REQUEST['cmt'], $template);
					$template = str_replace('{{username}}', $vn, $template);
					$template = str_replace('{{qblink}}', $relili . $_REQUEST['qbn'] . "&page=basic", $template);
					preg_match('/<title>(.*)<\/title>/iU', $template, $subject);
					$subject = "QB".$_REQUEST['qbn'].": ".$subject[1];					
					$qb_support->templatemail($sender, $subject, $template, $result[1], "voteimp:rejectimplementation");		
			// write vote in database				
					$query = "UPDATE qb_imp_sts SET ST=:vot, TOKEN='', ANSWER=NOW() WHERE IDX=:idx";							
					$stmt = $db->prepare($query);					
					$test = $stmt->execute(
						array(
							':vot' => $_REQUEST['vte'],
							':idx' => $_REQUEST['idx']
						)
					);
			// check overall status
					$query = "SELECT (SELECT COUNT(*) FROM qb_imp_sts WHERE ST='R' AND DEL='' AND QBN=:qbn) AS REJ, (SELECT COUNT(*) FROM qb_imp_sts WHERE 
						(ST='A' OR ST='N') AND DEL='' AND QBN=:qbn) AS ACC, (SELECT COUNT(*) FROM qb_imp_sts WHERE QBN=:qbn AND DEL='' AND ST<>'S') AS TOT";				
					$stmt = $db->prepare($query);
					$stmt->execute(
						array(
							':qbn' => $_REQUEST['qbn']
						)
					);
					$row = $stmt->fetch(PDO::FETCH_NUM );					
					if	(($row[0]*1+$row[1]*1) == $row[2]*1) {				
				// all votes done, now check what to do
						if ($row[1] == $row[2]) {
					// write log
							$qb_support->writelog($_REQUEST['qbn'], "A", "IMMEDIATE", "All votes done and positive");							
					// all votes positive, set teamapp to 5 (sent to svt)
							$query = "UPDATE qb_imp SET TEAMAPP=5 WHERE QBN=:qbn";
							$stmt = $db->prepare($query);
							$stmt->execute(
								array(
									':qbn' => $_REQUEST['qbn']
								)
							);
					// write log
							$qb_support->writelog($_REQUEST['qbn'], "A", "IMMEDIATE", "Q-case responsible informed about positive vote", date('Y-m-d'));							
					// all votes "accepted" -> inform SVT
							$query = "UPDATE qb_imp set SEND_TO_SVT=:dat WHERE QBN=:qbn";
							$stmt = $db->prepare($query);
							$stmt->execute(
								array(
									':qbn' => $_REQUEST['qbn'],
									':dat' => date('Y-m-d')
								)
							);
					// inform SVT
							$qb_support->stsvt($_REQUEST['qbn'], "E5");
					// Event Mailing
							$qb_support->event_mail2("E5", $_REQUEST['qbn']);
						} else {			
					// not all votes positive, set teamapop to 2
							$query = "UPDATE qb_imp SET TEAMAPP=2 WHERE QBN=:qbn";
							$stmt = $db->prepare($query);
							$stmt->execute(
								array(
									':qbn' => $_REQUEST['qbn']
								)
							);	
					// write log
							$qb_support->writelog($_REQUEST['qbn'], "A", "IMMEDIATE", "All votes done but not all positive");
					// write log
							$qb_support->writelog($_REQUEST['qbn'], "A", "IMMEDIATE", "Q-case leader informed about rejection", date('Y-m-d'));								
					// not all accepted -> inform PL
							$qb_support->ifplrej($_REQUEST['qbn']);
						}
					}
					return "Done";
					break;					
			}
		}
	}
?>								