<!DOCTYPE html>
<html>
<head>
	<meta http-equiv="X-UA-Compatible" content="IE=Edge" />
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />	
	<?php 
		include_once(dirname(__FILE__)."/tools/all_header.php"); 
		global $c_scheme, $timezone, $rel_path;
		if (!$qb_support->checkflag("YW")) header("Location: basic.php"); 
	?>	
	<script>
		var js_debug = false;
		$data_changed = false;
	</script>
	
    <title>Track</title>
	
	<link rel="stylesheet" href="./css/qb.php" />
	<link rel="stylesheet" href="./jqGrid_5.2.1/css/ui.jqgrid.css" />
	<style>	
		.ui-jqgrid tr.jqgrow td{
			white-space:nowrap;
			height: 18px !important;
		}
		#pager_left{
			padding-top: 5px;
		}		
	</style>
	
	<script src="./jquery/jquery.min.js"></script>
	<script src="./jquery/jquery-migrate-1.2.1.min.js"></script>	
	<script src="./jquery/jquery-ui.min.js"></script>
	<script src="./jquery/qb_js.js"></script>
	
	<?php 
		foreach(explode(":", $qb_support->getLanOnly()) as $key=>$value) {
			echo '<script src="./jqGrid_5.2.1/js/i18n/grid.locale-' . $value . '.js"></script>';
		}
	?>
	<script src="./jqGrid_5.2.1/js/jquery.jqGrid.min.js"></script>	

	<script>
	// load translation and save in localTranslation
		<?php	
			$ini_track = parse_ini_file($rel_path.'i18n/track.ini', true);	
			echo "localTranslation = {};";
			foreach($ini_track as $key=>$value){
				$add = "";
				foreach($value AS $lan=>$trans){
					$add .= "'".$lan."':'".$trans."',";
				}
				echo "localTranslation['".$key."']={".rtrim($add, ',')."};";
			}
			$ini_qbstatus = parse_ini_file($rel_path.'xml/qb_status.ini', true);
			echo "qbstatusTranslation = {};";
			foreach($ini_qbstatus as $key=>$value){
				$add = "";
				foreach($value AS $lan=>$trans){
					$add .= "'".$lan."':'".$trans."',";
				}
				echo "qbstatusTranslation['".$key."']={".rtrim($add, ',')."};";			
			}		
		?>
	</script>
</head>
<body>
	<div id="container">
		<?php 
			$active_menu = 4;
			include_once($rel_path.'/tools/header.php');
		?> 
		<div id="contents">
			<?php 
				echo "<div id='mainnav'>". $qb_support->get_main_menu($active_menu) . "</div>";
			?>
			<div class="dtop">
				<?php include_once($rel_path.'/html/systemmenu.php');	?>		
				<span data-type="span" data-lan="track"></span>
			</div>
			<div class="tabs_container">
				<div style="margin-left: 5px;" >
					<table id="list"></table> 
					<div id="pager"></div> 
				</div>
			</div>
		</div>
		<?php include_once($rel_path.'/footer.php'); ?> 
	</div>
	<script>
		var rowsToColor = [];
		
		function load_page() {
			fill_grid();
		}	
		function c_lan() {
			translate_header($globlan);	
			translate_mainmenu($globlan);
			translate_system($globlan);
			$.each($('#container *').filter(function(){return $(this).data('lan') !== undefined;}), function() {			
				switch ($(this).data("type")) {
					case "text":		
						$(this).text(localTranslation[$(this).data("lan")][$globlan]);
						break;
					case "title":				
						$(this).attr("title", localTranslation[$(this).data("lan")][$globlan]);
						break;
					case "date":
						$(this).val(localizedate($($(this).data("lan")).val()));
						break;						
				}
			});	
			$.jgrid.setRegional('list',{regional: $globlan});
			$("#list").jqGrid('setLabel', "qbn", localTranslation["qbn"][$globlan])
				.jqGrid('setLabel', "svt", localTranslation["svt"][$globlan])
				.jqGrid('setLabel', "tgr", localTranslation["imat"][$globlan])
				.jqGrid('setLabel', "tgr_n", localTranslation["imatname"][$globlan])
				.jqGrid('setLabel', "qbstatus", localTranslation["status"][$globlan])
				.jqGrid('setLabel', "track", localTranslation["track"][$globlan]);			
			$("#list").trigger("reloadGrid");			
		}	
		function StatusFormatter (cellvalue, options, rowObject)
		{
			var ctext = qbstatusTranslation[cellvalue][$globlan];
			return ctext;
		}
		function TrackFormatter(cellvalue, options, rowObject) {
			if (cellvalue != "0") {
				rowsToColor[rowsToColor.length] = options.rowId;
				return "<span class='icn_ok_be_n clckbtn'></span>";
			} else {
				return "";
			}
		}
		function ComFormatter(cellvalue, options, rowObject) {
			if (rowObject['track'] == "0") {
				return "";
			} else if (rowObject['track'] == "1") {
				return "<span class='icn_warning_r_n hlpcrsr' title='"+cellvalue.replace(/'/g,"")+"'></span>";
			} else if (rowObject['track'] == "2") {
				return "<span class='icn_warning_r_n hlpcrsr' title='sup_trk_txt'></span>";
			}
		}		
		function fill_grid() {
			$("#loading").show();
			cmTemplate = {
				editable: false,
				sorttype:'string',
				searchoptions: {
					sopt:['cn'], 
					clearSearch: false
				}
			};
			obj = {
				url:  "./tools/track_api.php",
				postData: {
					routine : "getlist",
					qblan: $globlan
				},
				contentType: "application/json",
				datatype: "json",
				jsonReader: {
					id: "id",
					repeatitems: true
				},
				mtype: "POST",
				colNames: [
					localTranslation["qbn"][$globlan],
					localTranslation["svt"][$globlan],
					localTranslation["imat"][$globlan],
					localTranslation["imatname"][$globlan],
					localTranslation["status"][$globlan],
					localTranslation["track"][$globlan],
					"",
					""
				],
				colModel: [
					{ 
						name: "qbn", 
						template: cmTemplate,
						width: 90
					},
					{ 
						name: "svt", 
						template: cmTemplate,
						width: 170
					},
					{
						name: "tgr", 
						template: cmTemplate,
						width: 170
					},
					{ 
						name: "tgr_n",
						template: cmTemplate,
						width: 290
					},
					{ 
						name: "qbstatus", 
						template: cmTemplate,
						width: 130,
						formatter: StatusFormatter
					},
					{
						name: "track", 
						template: cmTemplate,
						width: 50,
						search: false,
						sort: false,
						align: "center",
						formatter: TrackFormatter
					},
					{
						name: "trackcom",
						template: cmTemplate,					
						width: 25,
						search: false,
						sort: false,
						align: "center",
						formatter: ComFormatter					
					},
					{
						name: "sts",
						hidden: true
					}
				],
				regional: $globlan,
				storeNavOptions: true,			
				loadonce: false,
				pager: "#pager",
				recordpos: "left",
				height: 510,
				rowNum: 100,
				rowList: [10, 100, 500, 1000, 1500],
				hoverrows: false,
				rownumbers: true,
				sortname: "qbn",
				sortorder: "desc",
				viewrecords: true,
				gridview: true,
				autoencode: true,
				ignoreCase:true,
				loadui: "block",
				loadComplete: function() {
					$("th[role='columnheader']")
						.unbind("mouseenter")
						.unbind("mouseleave");

					var rows = $("#list").getDataIDs();
					for(a=0;a<rows.length;a++)
					{
						row = $("#list").getRowData(rows[a]);
						switch(row.sts) {
							case "N":
								$("#list").setCell (rows[a], 'qbstatus','',{'background':'<?php echo $c_scheme['SN']; ?>'});
								break;					
							case "O":
								$("#list").setCell (rows[a], 'qbstatus','',{'background':'<?php echo $c_scheme['SO']; ?>'});
								break;
							case "S":
								$("#list").setCell (rows[a], 'qbstatus','',{'background':'<?php echo $c_scheme['ST']; ?>'});
								break;
							case "C":
								$("#list").setCell (rows[a], 'qbstatus','',{'background':'<?php echo $c_scheme['SC']; ?>'});
								break;
						}
					}
					for (var i = 0; i < rowsToColor.length; i++) {
	//					$("#" + rowsToColor[i]).find("td").css("background", "<?php echo $c_scheme['M1']; ?>");
					}	
				},
				gridComplete: function(data) {
					$(".ui-search-toolbar input[role='textbox']")
						.css("width", "92%")
						.css("background", "<?php echo $c_scheme['M5']; ?>")
						.css("padding", "2px");	
				},			
				onCellSelect: function(rowid, iCol, cellcontent, e) {
			// set or unset track			
					if (iCol == 6) {
						if (cellcontent.length != 0) {								
							$.ajax({
								type: "POST",
								cache: false,
								url:  "./tools/track_api.php",
								data: { 
									routine: "resettrack",
									qbn: $("#list").jqGrid("getRowData", rowid)['qbn']
								},
								success: function(result)
								{
									rowsToColor = [];
									$("#list").setGridParam({datatype:'json'}).trigger('reloadGrid');
								}
							});					
						} else {
							jTextfield('','', localTranslation["remark"][$globlan], function(r) {
								if (r) {						
									$.ajax({
										type: "POST",
										cache: false,
										url:  "./tools/track_api.php",
										data: { 
											routine: "settrack",
											cmnt: $.trim(r),
											qbn: $("#list").jqGrid("getRowData", rowid)['qbn']
										},
										success: function(result)
										{
											rowsToColor = [];
											$("#list").setGridParam({datatype:'json'}).trigger('reloadGrid');
										}
									});
								}
							});
						}
					} else if (iCol == 7) {			
			// click on comment
						if (cellcontent.length != 0) {
							jTextfield(localTranslation["remark"][$globlan],$($("#list").jqGrid("getRowData", rowid)['trackcom']).attr("title"), localTranslation["remark"][$globlan], function(r) {
								if (r) {						
									$.ajax({
										type: "POST",
										cache: false,
										url:  "./tools/track_api.php",
										data: { 
											routine: "newcomment",
											cmnt: $.trim(r),
											qbn: $("#list").jqGrid("getRowData", rowid)['qbn']
										},
										success: function(result)
										{
											rowsToColor = [];
											$("#list").setGridParam({datatype:'json'}).trigger('reloadGrid');
										}
									});
								}
							});					
						}
					} else {
			// click on any other cell
						return false;
					}
				}		
			};
			list1 = $("#list").jqGrid(obj)
				.jqGrid('filterToolbar',{searchOperators : false, searchOnEnter: false})
				.navGrid('#pager', {refresh: false, search: false, edit: false, del: false, add: false});
			$("#loading").hide();
		}	
		load_page();
	</script>
</body>
</html>
