﻿//Prevents backspace except in the case of textareas and text inputs to prevent user navigation.
$(document).keydown(function (e) {
	var preventKeyPress;
	if (e.keyCode == 8) {
		var d = e.srcElement || e.target;
		switch (d.tagName.toUpperCase()) {
			case 'TEXTAREA':
				preventKeyPress = d.readOnly || d.disabled;
				break;
			case 'INPUT':
				preventKeyPress = d.readOnly || d.disabled ||
					(d.attributes["type"] && $.inArray(d.attributes["type"].value.toLowerCase(), ["radio", "checkbox", "submit", "button"]) >= 0);
				break;
			case 'DIV':
				preventKeyPress = d.readOnly || d.disabled || !(d.attributes["contentEditable"] && d.attributes["contentEditable"].value == "true");
				break;
			default:
				preventKeyPress = true;
				break;
		}
	}
	else
		preventKeyPress = false;

	if (preventKeyPress)
		e.preventDefault();
});
function htmlEscape(value) {
	return $('<div/>').text(value).html();
}
function htmlDecode(value) {
    return $('<div/>').html(value).text();
}
jQuery.fn.visible = function() {
	return this.css('visibility', 'visible');
};
jQuery.fn.invisible = function() {
	return this.css('visibility', 'hidden');
};

$(document).ready(function(){
	$("body").append('<div id="loading" style="display: none;"><div class="loading-container"><img src="./img/loader.gif"/></div></div>');
});

function generalizedate(loc) {
	$mnth = loc.split("-");
	if ($.isNumeric($mnth[1])) {
		return $mnth[0]+"-"+("0"+$mnth[1]).slice(-2)+"-"+$mnth[2];
	} else {
		$nm = ("0"+(($.inArray($mnth[1], calTranslation["monthNamesShort"][$globlan]) % 12) + 1)).slice(-2);
		return $mnth[0]+"-"+$nm+"-"+$mnth[2];
	}
}
function localizetime(loc) {
	if ((loc == "") || (loc === null)) return "";
	if (loc.substring(0, 10) == "0000-00-00") {
		return "";
	} else {
		$mnth = loc.split("-");
		return $mnth[0]+"-"+ calTranslation["monthNamesShort"][$globlan][$mnth[1]-1]+"-"+$mnth[2];
	}
}
function localizedate(loc) {
	if ((loc == "") || (loc === null)) return "";
	loc = loc.substring(0, 10);
	if (loc == "0000-00-00") {
		return "";
	} else {
		$mnth = loc.split("-");
		return $mnth[0]+"-"+ calTranslation["monthNamesShort"][$globlan][$mnth[1]-1]+"-"+$mnth[2];
	}
}
// Check if string is non-blank
var isNonblank_re    = /\S/;
function isNonblank (s) {
   return String (s).search (isNonblank_re) != -1
}
// Check if string is a whole number(digits only).
var isWhole_re       = /^\s*\d+\s*$/;
function isWhole (s) {
   return String(s).search (isWhole_re) != -1
}
// check 0-9 digit
function regIsDigit(fData)
{
    var reg = new RegExp("^[0-9]$");
    return (reg.test(fData));
}
// checks that an input string is an integer, with an optional +/- sign character.
var isInteger_re     = /^\s*(\+|-)?\d+\s*$/;
function isInteger (s) {
   return String(s).search (isInteger_re) != -1
}
// check is number
function regIsNumber(fData)
{
    var reg = new RegExp("^[-]?[0-9]+[\.]?[0-9]+$");
    return reg.test(fData)
}
// Check if string is currency
var isCurrency_re    = /^\s*(\+|-)?((\d+(\.\d\d)?)|(\.\d\d))\s*$/;
function isCurrency (s) {
   return String(s).search (isCurrency_re) != -1
}
// checks that an input string looks like a valid email address.
var isEmail_re       = /^\s*[\w\-\+_]+(\.[\w\-\+_]+)*\@[\w\-\+_]+\.[\w\-\+_]+(\.[\w\-\+_]+)*\s*$/;
function isEmail (s) {
   return String(s).search (isEmail_re) != -1;
}
// Checks that an input string is a decimal number, with an optional +/- sign character.
var isDecimal_re     = /^\s*(\+|-)?((\d+(\.\d+)?)|(\.\d+))\s*$/;
function isDecimal (s) {
   return String(s).search (isDecimal_re) != -1
}
// converts rgb to hex if needed
function rgb2hex(rgb) {
     if (  rgb.search("rgb") == -1 ) {
          return rgb.toUpperCase();
     } else {
          rgb = rgb.match(/^rgba?\((\d+),\s*(\d+),\s*(\d+)(?:,\s*(\d+))?\)$/);
          function hex(x) {
               return ("0" + parseInt(x).toString(16)).slice(-2);
          }
          return ("#" + hex(rgb[1]) + hex(rgb[2]) + hex(rgb[3])).toUpperCase(); 
     }
}
// alerts
!function(p){p.alerts={verticalOffset:-75,horizontalOffset:0,repositionOnResize:!0,overlayOpacity:.01,overlayColor:"#FFF",draggable:!0,okButton:"&nbsp;OK&nbsp;",cancelButton:"&nbsp;Cancel&nbsp;",dialogClass:null,alert:function(e,o,t){null==o&&(o="Alert"),p.alerts._show(o,e,null,"alert",function(p){t&&t(p)})},confirm:function(e,o,t){null==o&&(o="Confirm"),p.alerts._show(o,e,null,"confirm",function(p){t&&t(p)})},prompt:function(e,o,t,s){null==t&&(t="Prompt"),p("body").append('<div id="ovrly"><div class="loading-container"></div></div>'),p.alerts._show(t,e,o,"prompt",function(p){s&&s(p)})},clink:function(e,o,t,s){null==t&&(t="Link"),p.alerts._show(t,e,o,"clink",function(p){s&&s(p)})},password:function(e,o,t,s){null==t&&(t="Password"),p("body").append('<div id="ovrly"><div class="loading-container"></div></div>'),p.alerts._show(t,e,o,"password",function(p){s&&s(p)})},textfield:function(e,o,t,s){null==t&&(t="Textfield"),p.alerts._show(t,e,o,"textfield",function(p){s&&s(p)})},_show:function(e,o,t,s,n){p.alerts._hide(),p.alerts._overlay("show"),p("BODY").append('<div id="popup_container"><h1 id="popup_title"></h1><div id="popup_content"><div id="popup_message" style="display: inline-block; vertical-align: middle;" ></div></div></div>'),p.alerts.dialogClass&&p("#popup_container").addClass(p.alerts.dialogClass);var i=p.browser.msie&&parseInt(p.browser.version)<=6?"absolute":"fixed";switch(p("#popup_container").css({position:i,zIndex:99999,padding:0,margin:0}),p("#popup_title").text(e),p("#popup_content").addClass(s),p("#popup_message").text(o),p("#popup_container").css({minWidth:p("#popup_container").outerWidth(),maxWidth:p("#popup_container").outerWidth()}),p("#popup_message").css("width",p("#popup_content").css("width").substr(0,p("#popup_content").css("width").length-2)-40),p.alerts._reposition(),p.alerts._maintainPosition(!0),s){case"alert":p("#popup_message").parent().prepend('<span class="icna_warning_x_n" style="margin-right: 20px;"></span>'),p("#popup_message").after('<div id="popup_panel"><span class="spanbutton" id="popup_ok" style="width: 100px;" >'+p.alerts.okButton+"</span></div>"),p("#popup_message").css("width",p("#popup_content").css("width").slice(0,-2)-50+"px"),p("#popup_ok").click(function(){p.alerts._hide(),n(!0)}),p("#popup_ok").focus().keypress(function(e){(13==e.keyCode||27==e.keyCode)&&p("#popup_ok").trigger("click")});break;case"prompt":p("#popup_message").parent().prepend('<span class="icna_question_x_n" style="margin-right: 20px;"></span>'),p("#popup_message").append('<input type="text" style="width: 200px; margin-bottom: 10px;" id="popup_prompt" />').after('<br /><div id="popup_panel"><span class="spanbutton" id="popup_ok" style="width: 100px;" >'+p.alerts.okButton+'</span><span class="spanbutton" id="popup_cancel" style="width: 100px; margin-left: 20px;" >'+p.alerts.cancelButton+"</span></div>"),p("#popup_message").css("width",p("#popup_content").css("width").slice(0,-2)-50+"px"),p("#popup_ok").click(function(){var e=p("#popup_prompt").val();p.alerts._hide(),p("#ovrly").remove(),n&&n(e)}),p("#popup_cancel").click(function(){p.alerts._hide(),p("#ovrly").remove(),n&&n(null)}),p("#popup_prompt, #popup_ok, #popup_cancel").keypress(function(e){13==e.keyCode&&p("#popup_ok").trigger("click"),27==e.keyCode&&p("#popup_cancel").trigger("click")}),t&&p("#popup_prompt").val(t),p("#popup_prompt").focus().select();break;case"confirm":p("#popup_message").parent().prepend('<span class="icna_question_x_n posrel" style="margin-right: 20px;"></span>'),p("#popup_message").after('<br /><div id="popup_panel"><span class="spanbutton" id="popup_ok" style="width: 100px;" >'+p.alerts.okButton+'</span><span class="spanbutton" id="popup_cancel" style="width: 100px; margin-left: 20px;" >'+p.alerts.cancelButton+"</span></div>"),p("#popup_message").css("width",p("#popup_content").css("width").substr(0,p("#popup_content").css("width").length-2)-50),p("#popup_ok").click(function(){p.alerts._hide(),n&&n(!0)}),p("#popup_cancel").click(function(){p.alerts._hide(),n&&n(!1)}),p("#popup_ok").focus(),p("#popup_ok, #popup_cancel").keypress(function(e){13==e.keyCode&&p("#popup_ok").trigger("click"),27==e.keyCode&&p("#popup_cancel").trigger("click")});break;case"clink":p("#popup_message").parent().prepend('<span class="icn3_link_b_n" style="position: relative; top: -30px; margin-right: 20px;"></span>'),p("#popup_message").append('<br /><input type="text" size="30" id="popup_prompt" readonly /><br /><br />').after('<div id="popup_panel"><span class="spanbutton" id="popup_ok" style="width: 100px;" >'+p.alerts.okButton+"</span></div>"),p("#popup_message").css("width","500px"),p("#popup_prompt").css("width","460px"),p("#popup_ok").click(function(){var e=p("#popup_prompt").val();p.alerts._hide(),n&&n(e)}),p("#popup_ok, #popup_cancel").keypress(function(e){13==e.keyCode&&p("#popup_ok").trigger("click")}),t&&p("#popup_prompt").val(t),p("#popup_prompt").focus().select();break;case"password":p("#popup_message").parent().prepend('<span class="icn3_key_b_n" style="position: relative;top:6px;"></span>'),p("#popup_message").append('<input type="password" size="25" id="popup_ppassword" />').after('<br /><div id="popup_panel"><span class="spanbutton" id="popup_ok" style="width: 100px;" >'+p.alerts.okButton+'</span><span class="spanbutton" id="popup_cancel" style="width: 100px; margin-left: 20px;" >'+p.alerts.cancelButton+"</span></div>"),p("#popup_ppassword").width(p("#popup_message").width()),p("#popup_message").css("width",p("#popup_content").css("width").slice(0,-2)-50+"px"),p("#popup_ok").click(function(){var e=p("#popup_ppassword").val();p.alerts._hide(),p("#ovrly").remove(),n&&n(e)}),p("#popup_cancel").click(function(){p.alerts._hide(),p("#ovrly").remove(),n&&n(null)}),p("#popup_ppassword, #popup_ok, #popup_cancel").keypress(function(e){13==e.keyCode&&p("#popup_ok").trigger("click"),27==e.keyCode&&p("#popup_cancel").trigger("click")}),t&&p("#popup_ppassword").val(t),p("#popup_ppassword").focus().select();break;case"textfield":p("#popup_message").parent().prepend('<span class="icn3_text_x_n" style="position: relative;top:-35px;left:-10px;"></span>'),p("#popup_message").append('<textarea cols="60" rows="5" style="resize: none;" id="popup_textfield" />').after('<br /><div id="popup_panel"><span class="spanbutton" id="popup_ok" style="width: 100px;" >'+p.alerts.okButton+'</span><span class="spanbutton" id="popup_cancel" style="width: 100px; margin-left: 20px;" >'+p.alerts.cancelButton+"</span></div>"),p("#popup_textfield").width(p("#popup_message").width()),p("#popup_ok").click(function(){var e=p("#popup_textfield").val();p.alerts._hide(),n&&n(e)}),p("#popup_cancel").click(function(){p.alerts._hide(),n&&n(null)}),p("#popup_textfield, #popup_ok, #popup_cancel").keypress(function(e){27==e.keyCode&&p("#popup_cancel").trigger("click")}),t&&p("#popup_textfield").val(t),p("#popup_textfield").focus().select()}if(p.alerts.draggable)try{p("#popup_container").draggable({handle:p("#popup_title")}),p("#popup_title").css({cursor:"move"})}catch(a){}},_hide:function(){p("#popup_container").remove(),p.alerts._overlay("hide"),p.alerts._maintainPosition(!1)},_overlay:function(e){switch(e){case"show":p.alerts._overlay("hide"),p("BODY").append('<div id="popup_overlay"></div>'),p("#popup_overlay").css({position:"absolute",zIndex:99998,top:"0px",left:"0px",width:"100%",height:p(document).height(),background:p.alerts.overlayColor,opacity:p.alerts.overlayOpacity});break;case"hide":p("#popup_overlay").remove()}},_reposition:function(){var e=p(window).height()/2-p("#popup_container").outerHeight()/2+p.alerts.verticalOffset,o=p(window).width()/2-p("#popup_container").outerWidth()/2+p.alerts.horizontalOffset;0>e&&(e=0),0>o&&(o=0),p.browser.msie&&parseInt(p.browser.version)<=6&&(e+=p(window).scrollTop()),p("#popup_container").css({top:e+"px",left:o+"px"}),p("#popup_overlay").height(p(document).height())},_maintainPosition:function(e){if(p.alerts.repositionOnResize)switch(e){case!0:p(window).bind("resize",p.alerts._reposition);break;case!1:p(window).unbind("resize",p.alerts._reposition)}}},jAlert=function(e,o,t){p.alerts.alert(e,o,t)},jConfirm=function(e,o,t){p.alerts.confirm(e,o,t)},jPrompt=function(e,o,t,s){p.alerts.prompt(e,o,t,s)},jLink=function(e,o,t,s){p.alerts.clink(e,o,t,s)},jPassword=function(e,o,t,s){p.alerts.password(e,o,t,s)},jTextfield=function(e,o,t,s){p.alerts.textfield(e,o,t,s)}}(jQuery);
// custom select
(function(a){a.fn.extend({customSelect:function(c){if(typeof document.body.style.maxHeight==="undefined"){return this}var e={customClass:"customSelect",mapClass:true,mapStyle:true},c=a.extend(e,c),d=c.customClass,f=function(h,k){var g=h.find(":selected"),j=k.children(":first"),i=g.html()||"&nbsp;";j.html(i);if(g.attr("disabled")){k.addClass(b("DisabledOption"))}else{k.removeClass(b("DisabledOption"))}setTimeout(function(){k.removeClass(b("Open"));a(document).off("mouseup.customSelect")},60)},b=function(g){return d+g};return this.each(function(){var g=a(this),i=a("<span />").addClass(b("Inner")),h=a("<span />");g.after(h.append(i));h.addClass(d);if(c.mapClass){h.addClass(g.attr("class"))}if(c.mapStyle){h.attr("style",g.attr("style"))}g.addClass("hasCustomSelect").on("render.customSelect",function(){f(g,h);g.css("width","");var k=parseInt(g.outerWidth(),10)-(parseInt(h.outerWidth(),10)-parseInt(h.width(),10));h.css({display:"inline-block"});var j=h.outerHeight();if(g.attr("disabled")){h.addClass(b("Disabled"))}else{h.removeClass(b("Disabled"))}i.css({width:k,display:"inline-block"});g.css({"-webkit-appearance":"menulist-button",width:h.outerWidth(),position:"absolute",opacity:0,height:j,fontSize:h.css("font-size")})}).on("change.customSelect",function(){h.addClass(b("Changed"));f(g,h)}).on("keyup.customSelect",function(j){if(!h.hasClass(b("Open"))){g.trigger("blur.customSelect");g.trigger("focus.customSelect")}else{if(j.which==13||j.which==27){f(g,h)}}}).on("mousedown.customSelect",function(){h.removeClass(b("Changed"))}).on("mouseup.customSelect",function(j){if(!h.hasClass(b("Open"))){if(a("."+b("Open")).not(h).length>0&&typeof InstallTrigger!=="undefined"){g.trigger("focus.customSelect")}else{h.addClass(b("Open"));j.stopPropagation();a(document).one("mouseup.customSelect",function(k){if(k.target!=g.get(0)&&a.inArray(k.target,g.find("*").get())<0){g.trigger("blur.customSelect")}else{f(g,h)}})}}}).on("focus.customSelect",function(){h.removeClass(b("Changed")).addClass(b("Focus"))}).on("blur.customSelect",function(){h.removeClass(b("Focus")+" "+b("Open"))}).on("mouseenter.customSelect",function(){h.addClass(b("Hover"))}).on("mouseleave.customSelect",function(){h.removeClass(b("Hover"))}).trigger("render.customSelect")})}})})(jQuery);
// base64
jQuery.base64=(function($){var _PADCHAR="=",_ALPHA="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",_VERSION="1.0";function _getbyte64(s,i){var idx=_ALPHA.indexOf(s.charAt(i));if(idx===-1){throw"Cannot decode base64"}return idx}function _decode(s){var pads=0,i,b10,imax=s.length,x=[];s=String(s);if(imax===0){return s}if(imax%4!==0){throw"Cannot decode base64"}if(s.charAt(imax-1)===_PADCHAR){pads=1;if(s.charAt(imax-2)===_PADCHAR){pads=2}imax-=4}for(i=0;i<imax;i+=4){b10=(_getbyte64(s,i)<<18)|(_getbyte64(s,i+1)<<12)|(_getbyte64(s,i+2)<<6)|_getbyte64(s,i+3);x.push(String.fromCharCode(b10>>16,(b10>>8)&255,b10&255))}switch(pads){case 1:b10=(_getbyte64(s,i)<<18)|(_getbyte64(s,i+1)<<12)|(_getbyte64(s,i+2)<<6);x.push(String.fromCharCode(b10>>16,(b10>>8)&255));break;case 2:b10=(_getbyte64(s,i)<<18)|(_getbyte64(s,i+1)<<12);x.push(String.fromCharCode(b10>>16));break}return x.join("")}function _getbyte(s,i){var x=s.charCodeAt(i);if(x>255){throw"INVALID_CHARACTER_ERR: DOM Exception 5"}return x}function _encode(s){if(arguments.length!==1){throw"SyntaxError: exactly one argument required"}s=String(s);var i,b10,x=[],imax=s.length-s.length%3;if(s.length===0){return s}for(i=0;i<imax;i+=3){b10=(_getbyte(s,i)<<16)|(_getbyte(s,i+1)<<8)|_getbyte(s,i+2);x.push(_ALPHA.charAt(b10>>18));x.push(_ALPHA.charAt((b10>>12)&63));x.push(_ALPHA.charAt((b10>>6)&63));x.push(_ALPHA.charAt(b10&63))}switch(s.length-imax){case 1:b10=_getbyte(s,i)<<16;x.push(_ALPHA.charAt(b10>>18)+_ALPHA.charAt((b10>>12)&63)+_PADCHAR+_PADCHAR);break;case 2:b10=(_getbyte(s,i)<<16)|(_getbyte(s,i+1)<<8);x.push(_ALPHA.charAt(b10>>18)+_ALPHA.charAt((b10>>12)&63)+_ALPHA.charAt((b10>>6)&63)+_PADCHAR);break}return x.join("")}return{decode:_decode,encode:_encode,VERSION:_VERSION}}(jQuery));
/*!
jQuery UI Virtual Keyboard
Version 1.18.9 minified (MIT License)
Caret code modified from jquery.caret.1.02.js (MIT License)
*/
;(function(e){e.keyboard=function(b,m){var a=this,d;a.$el=e(b);a.el=b;a.$el.data("keyboard",a);a.init=function(){a.options=d=e.extend(!0,{},e.keyboard.defaultOptions,m);a.shiftActive=a.altActive=a.metaActive=a.sets=a.capsLock=!1;a.lastKeyset=[!1,!1,!1];a.rows=["","-shift","-alt","-alt-shift"];e('\x3c!--[if lte IE 8]><script>jQuery("body").addClass("oldie");\x3c/script><![endif]--\x3e\x3c!--[if IE]><script>jQuery("body").addClass("ie");\x3c/script><![endif]--\x3e').appendTo("body").remove();a.msie= e("body").hasClass("oldie");a.allie=e("body").hasClass("ie");a.inPlaceholder=a.$el.attr("placeholder")||"";a.watermark="undefined"!==typeof document.createElement("input").placeholder&&""!==a.inPlaceholder;a.regex=e.keyboard.comboRegex;a.decimal=/^\./.test(d.display.dec)?!0:!1;a.repeatTime=1E3/(d.repeatRate||20);d.preventDoubleEventTime=d.preventDoubleEventTime||100;a.isOpen=!1;a.wheel=e.isFunction(e.fn.mousewheel);a.alwaysAllowed=[20,33,34,35,36,37,38,39,40,45,46];a.$keyboard=[];a.temp=e('<input style="position:absolute;left:-9999em;top:-9999em;" type="text" value="testing">').appendTo("body").caret(3, 3);a.checkCaret=d.lockInput||3!==a.temp.hide().show().caret().start?!0:!1;a.temp.remove();a.lastCaret={start:0,end:0};a.temp=["",0,0];e.each("initialized beforeVisible visible hidden canceled accepted beforeClose".split(" "),function(h,c){e.isFunction(d[c])&&a.$el.bind(c+".keyboard",d[c])});d.alwaysOpen&&(d.stayOpen=!0);e(document).bind(["mousedown","keyup","touchstart","checkkeyboard",""].join(".keyboard "),function(d){a.opening||(a.escClose(d),d.target&&e(d.target).hasClass("ui-keyboard-input")&& (d=e(d.target).data("keyboard"),d===a&&d.options.openOn&&d.focusOn()))});a.$el.addClass("ui-keyboard-input "+d.css.input).attr({"aria-haspopup":"true",role:"textbox"});(a.$el.is(":disabled")||a.$el.attr("readonly")&&!a.$el.hasClass("ui-keyboard-lockedinput"))&&a.$el.addClass("ui-keyboard-nokeyboard");d.openOn&&a.$el.bind(d.openOn+".keyboard",function(){a.focusOn()});a.watermark||""!==a.$el.val()||""===a.inPlaceholder||""===a.$el.attr("placeholder")||a.$el.addClass("ui-keyboard-placeholder").val(a.inPlaceholder); a.$el.trigger("initialized.keyboard",[a,a.el]);d.alwaysOpen&&a.reveal()};a.setCurrent=function(){e(".ui-keyboard-has-focus").removeClass("ui-keyboard-has-focus");e(".ui-keyboard-input-current").removeClass("ui-keyboard-input-current");a.$el.addClass("ui-keyboard-input-current");a.$keyboard.addClass("ui-keyboard-has-focus");a.isCurrent(!0);a.isOpen=!0};a.isCurrent=function(d){var c=e.keyboard.currentKeyboard||!1;d?c=e.keyboard.currentKeyboard=a.el:!1===d&&c===a.el&&(c=e.keyboard.currentKeyboard=""); return c===a.el};a.isVisible=function(){return a.$keyboard&&a.$keyboard.length?a.$keyboard.is(":visible"):!1};a.focusOn=function(){a.$el.is(":visible")&&setTimeout(function(){a.lastCaret=a.$el.caret()},20);a.isVisible()||(clearTimeout(a.timer),a.reveal());d.alwaysOpen&&a.setCurrent()};a.reveal=function(){var h;a.opening=!0;e(".ui-keyboard").not(".ui-keyboard-always-open").remove();if(a.$el.is(":disabled")||a.$el.attr("readonly")&&!a.$el.hasClass("ui-keyboard-lockedinput"))a.$el.addClass("ui-keyboard-nokeyboard"); else return a.$el.removeClass("ui-keyboard-nokeyboard"),d.openOn&&a.$el.unbind(d.openOn+".keyboard"),a.$keyboard&&(!a.$keyboard||a.$keyboard.length&&!e.contains(document.body,a.$keyboard[0]))||a.startup(),a.watermark||a.el.value!==a.inPlaceholder||a.$el.removeClass("ui-keyboard-placeholder").val(""),a.originalContent=a.$el.val(),a.$preview.val(a.originalContent),d.acceptValid&&a.checkValid(),d.resetDefault&&(a.shiftActive=a.altActive=a.metaActive=!1,a.showKeySet()),d.appendLocally||"body"!==d.appendTo|| a.$keyboard.css({position:"absolute",left:0,top:0}),a.$el.trigger("beforeVisible.keyboard",[a,a.el]),a.setCurrent(),a.$keyboard.show(),d.usePreview&&a.msie&&("undefined"===typeof a.width&&(a.$preview.hide(),a.width=Math.ceil(a.$keyboard.width()),a.$preview.show()),a.$preview.width(a.width)),a.position=d.position,e.ui&&e.ui.position&&!e.isEmptyObject(a.position)&&(a.position.of=a.position.of||a.$el.data("keyboardPosition")||a.$el,a.position.collision=a.position.collision||"flipfit flipfit",a.$keyboard.position(a.position)), a.checkDecimal(),a.lineHeight=parseInt(a.$preview.css("lineHeight"),10)||parseInt(a.$preview.css("font-size"),10)+4,d.caretToEnd&&(h=a.originalContent.length,a.lastCaret={start:h,end:h}),a.allie&&(h=a.lastCaret.start||a.originalContent.length,h={start:h,end:h},a.lastCaret||(a.lastCaret=h),0===a.lastCaret.end&&0<a.lastCaret.start&&(a.lastCaret.end=a.lastCaret.start),0>a.lastCaret.start&&(a.lastCaret=h)),setTimeout(function(){a.opening=!1;d.initialFocus&&a.$preview.focus().caret(a.lastCaret);a.$el.trigger("visible.keyboard", [a,a.el])},10),a};a.startup=function(){a.$keyboard&&a.$keyboard.length||("custom"===d.layout&&(d.layoutHash="custom"+a.customHash()),a.layout="custom"===d.layout?d.layoutHash:d.layout,"undefined"===typeof e.keyboard.builtLayouts[a.layout]&&(e.isFunction(d.create)&&d.create(a),a.$keyboard.length||a.buildKeyboard()),a.$keyboard=e.keyboard.builtLayouts[a.layout].$keyboard.clone(),d.usePreview?(a.$preview=a.$el.clone(!1).removeAttr("id").removeClass("ui-keyboard-placeholder ui-keyboard-input").addClass("ui-keyboard-preview "+ d.css.input).attr("tabindex","-1").show(),e("<div />").addClass("ui-keyboard-preview-wrapper").append(a.$preview).prependTo(a.$keyboard)):(a.$preview=a.$el,e.isEmptyObject(a.position)||(d.position.at=d.position.at2)));a.preview=a.$preview[0];a.$decBtn=a.$keyboard.find(".ui-keyboard-dec");(d.enterNavigation||"TEXTAREA"===a.el.tagName)&&a.alwaysAllowed.push(13);d.lockInput&&a.$preview.addClass("ui-keyboard-lockedinput").attr({readonly:"readonly"});a.bindKeyboard();a.$keyboard.appendTo(d.appendLocally? a.$el.parent():d.appendTo||"body");a.bindKeys();e.ui&&e.ui.position&&!e.isEmptyObject(a.position)&&e(window).bind("resize.keyboard",function(){a.isVisible()&&a.$keyboard.position(a.position)})};a.bindKeyboard=function(){var h=e.keyboard.builtLayouts[a.layout];a.$preview.unbind("keypress keyup keydown mouseup touchend ".split(" ").join(".keyboard ")).bind("keypress.keyboard",function(c){var g=a.lastKey=String.fromCharCode(c.charCode||c.which);a.$lastKey=[];a.checkCaret&&(a.lastCaret=a.$preview.caret()); a.capsLock=65<=g&&90>=g&&!c.shiftKey||97<=g&&122>=g&&c.shiftKey?!0:!1;if(d.restrictInput){if((8===c.which||0===c.which)&&e.inArray(c.keyCode,a.alwaysAllowed))return;-1===e.inArray(g,h.acceptedKeys)&&c.preventDefault()}else if((c.ctrlKey||c.metaKey)&&(97===c.which||99===c.which||118===c.which||120<=c.which&&122>=c.which))return;h.hasMappedKeys&&h.mappedKeys.hasOwnProperty(g)&&(a.lastKey=h.mappedKeys[g],a.insertText(a.lastKey),c.preventDefault());a.checkMaxLength()}).bind("keyup.keyboard",function(c){switch(c.which){case 9:if(a.tab&& d.tabNavigation&&!d.lockInput){if(a.shiftActive=c.shiftKey,c=e.keyboard.keyaction.tab(a),a.tab=!1,!c)return!1}else c.preventDefault();break;case 27:return a.close(),!1}clearTimeout(a.throttled);a.throttled=setTimeout(function(){a.isVisible()&&a.checkCombos()},100);a.checkMaxLength();e.isFunction(d.change)&&d.change(e.Event("change"),a,a.el);a.$el.trigger("change.keyboard",[a,a.el])}).bind("keydown.keyboard",function(c){switch(c.which){case 8:e.keyboard.keyaction.bksp(a,null,c);c.preventDefault(); break;case 9:return a.tab=!0,!1;case 13:e.keyboard.keyaction.enter(a,null,c);break;case 20:a.shiftActive=a.capsLock=!a.capsLock;a.showKeySet(this);break;case 86:if(c.ctrlKey||c.metaKey){if(d.preventPaste){c.preventDefault();break}a.checkCombos()}}}).bind("mouseup.keyboard touchend.keyboard",function(){a.checkCaret&&(a.lastCaret=a.$preview.caret())});a.$keyboard.bind("mousedown.keyboard click.keyboard touchstart.keyboard",function(c){c.stopPropagation();a.isCurrent()||(a.reveal(),e(document).trigger("checkkeyboard.keyboard"))}); d.preventPaste&&(a.$preview.bind("contextmenu.keyboard",function(a){a.preventDefault()}),a.$el.bind("contextmenu.keyboard",function(a){a.preventDefault()}))};a.bindKeys=function(){var h=(d.keyBinding+" repeater mouseenter mouseleave touchstart mousewheel mouseup click ").split(" ").join(".keyboard ")+"mouseleave.kb mousedown.kb touchstart.kb touchend.kb touchmove.kb touchcancel.kb ";a.$allKeys=a.$keyboard.find("button.ui-keyboard-button").unbind(h).bind(d.keyBinding.split(" ").join(".keyboard ")+ ".keyboard repeater.keyboard",function(c){if(!a.$keyboard.is(":visible"))return!1;var g;g=e(this);var h=g.attr("data-action"),b=(new Date).getTime(),h=":"===h?":":h.split(":")[0];if(!(b-(a.lastEventTime||0)<d.preventDoubleEventTime)){a.lastEventTime=b;a.$preview.focus();a.$lastKey=g;a.lastKey=g.attr("data-curtxt");a.checkCaret&&a.$preview.caret(a.lastCaret);h.match("meta")&&(h="meta");if(e.keyboard.keyaction.hasOwnProperty(h)&&e(this).hasClass("ui-keyboard-actionkey")){if(!1===e.keyboard.keyaction[h](a, this,c))return!1}else"undefined"!==typeof h&&(g=a.lastKey=a.wheel&&!e(this).hasClass("ui-keyboard-actionkey")?a.lastKey:h,a.insertText(g),a.capsLock||d.stickyShift||c.shiftKey||(a.shiftActive=!1,a.showKeySet(this)));a.$preview.focus().caret(a.lastCaret);a.checkCombos();a.checkMaxLength();e.isFunction(d.change)&&d.change(e.Event("change"),a,a.el);a.$el.trigger("change.keyboard",[a,a.el]);c.preventDefault()}}).bind("mouseenter.keyboard mouseleave.keyboard touchstart.keyboard",function(c){if(a.isCurrent()){var h= e(this),b=h.data("layers")||a.getLayers(h);h.data("layers",b=e.grep(b,function(a,c){return e.inArray(a,b)===c}));"mouseenter"!==c.type&&"touchstart"!==c.type||"password"===a.el.type||h.hasClass(d.css.buttonDisabled)||h.addClass(d.css.buttonHover).attr("title",function(h,e){return a.wheel&&""===e&&a.sets&&1<b.length&&"touchstart"!==c.type?d.wheelMessage:e});"mouseleave"===c.type&&(h.data({curtxt:h.data("original"),curnum:0}),h.removeClass("password"===a.el.type?"":d.css.buttonHover).attr("title",function(a, c){return c===d.wheelMessage?"":c}).find("span").html(h.data("original")))}}).bind("mousewheel.keyboard",function(c,d){if(a.wheel){var h,b,f=e(this);b=f.data("layers")||a.getLayers(f);1<b.length?(h=f.data("curnum")+(0<d)?-1:1,h>b.length-1&&(h=0),0>h&&(h=b.length-1)):h=0;f.data({curnum:h,layers:b,curtxt:b[h]});f.find("span").html(b[h]);return!1}}).bind("mouseup.keyboard mouseleave.kb touchend.kb touchmove.kb touchcancel.kb",function(c){/(mouseleave|touchend|touchcancel)/.test(c.type)?e(this).removeClass(d.css.buttonHover): (a.isVisible()&&a.isCurrent()&&a.$preview.focus(),a.checkCaret&&a.$preview.caret(a.lastCaret));a.mouseRepeat=[!1,""];clearTimeout(a.repeater);return!1}).bind("click.keyboard",function(){return!1}).not(".ui-keyboard-actionkey").add(".ui-keyboard-tab, .ui-keyboard-bksp, .ui-keyboard-space, .ui-keyboard-enter",a.$keyboard).bind("mousedown.kb touchstart.kb",function(){if(0!==d.repeatRate){var c=e(this);a.mouseRepeat=[!0,c];setTimeout(function(){a.mouseRepeat[0]&&a.mouseRepeat[1]===c&&a.repeatKey(c)}, d.repeatDelay)}return!1})};a.insertText=function(d){var c,b;b=a.$preview.val();var e=a.$preview.caret(),k=a.$preview.scrollLeft();c=a.$preview.scrollTop();var f=b.length;e.end<e.start&&(e.end=e.start);e.start>f&&(e.end=e.start=f);"TEXTAREA"===a.preview.tagName&&(a.msie&&"\n"===b.substr(e.start,1)&&(e.start+=1,e.end+=1),b=b.split("\n").length-1,a.preview.scrollTop=0<b?a.lineHeight*b:c);c="bksp"===d&&e.start===e.end?!0:!1;d="bksp"===d?"":d;b=e.start+(c?-1:d.length);k+=parseInt(a.$preview.css("fontSize"), 10)*("bksp"===d?-1:1);a.$preview.val(a.$preview.val().substr(0,e.start-(c?1:0))+d+a.$preview.val().substr(e.end)).scrollLeft(k).caret(b,b);a.lastCaret={start:b,end:b}};a.checkMaxLength=function(){var h,c=a.$preview.val();!1!==d.maxLength&&c.length>d.maxLength&&(h=Math.min(a.$preview.caret().start,d.maxLength),a.$preview.val(c.substring(0,d.maxLength)),a.$preview.caret(h,h),a.lastCaret={start:h,end:h});a.$decBtn.length&&a.checkDecimal()};a.repeatKey=function(d){d.trigger("repeater.keyboard");a.mouseRepeat[0]&& (a.repeater=setTimeout(function(){a.repeatKey(d)},a.repeatTime))};a.showKeySet=function(b){var c="",e=(a.shiftActive?1:0)+(a.altActive?2:0);a.shiftActive||(a.capsLock=!1);if(a.metaActive){if(c=b&&b.name&&/meta/.test(b.name)?b.name:"",""===c?c=!0===a.metaActive?"":a.metaActive:a.metaActive=c,!d.stickyShift&&a.lastKeyset[2]!==a.metaActive||(a.shiftActive||a.altActive)&&!a.$keyboard.find(".ui-keyboard-keyset-"+c+a.rows[e]).length)a.shiftActive=a.altActive=!1}else!d.stickyShift&&a.lastKeyset[2]!==a.metaActive&& a.shiftActive&&(a.shiftActive=a.altActive=!1);e=(a.shiftActive?1:0)+(a.altActive?2:0);c=0!==e||a.metaActive?""===c?"":"-"+c:"-default";a.$keyboard.find(".ui-keyboard-keyset"+c+a.rows[e]).length?(a.$keyboard.find(".ui-keyboard-alt, .ui-keyboard-shift, .ui-keyboard-actionkey[class*=meta]").removeClass(d.css.buttonAction).end().find(".ui-keyboard-alt")[a.altActive?"addClass":"removeClass"](d.css.buttonAction).end().find(".ui-keyboard-shift")[a.shiftActive?"addClass":"removeClass"](d.css.buttonAction).end().find(".ui-keyboard-lock")[a.capsLock? "addClass":"removeClass"](d.css.buttonAction).end().find(".ui-keyboard-keyset").hide().end().find(".ui-keyboard-keyset"+c+a.rows[e]).show().end().find(".ui-keyboard-actionkey.ui-keyboard"+c).addClass(d.css.buttonAction),a.lastKeyset=[a.shiftActive,a.altActive,a.metaActive]):(a.shiftActive=a.lastKeyset[0],a.altActive=a.lastKeyset[1],a.metaActive=a.lastKeyset[2])};a.checkCombos=function(){if(!a.isVisible())return a.$preview.val();var b,c,g,l,k=a.$preview.val(),f=a.$preview.caret(),m=e.keyboard.builtLayouts[a.layout], p=k.length;f.end<f.start&&(f.end=f.start);f.start>p&&(f.end=f.start=p);a.msie&&"\n"===k.substr(f.start,1)&&(f.start+=1,f.end+=1);d.useCombos&&(a.msie?k=k.replace(a.regex,function(a,c,b){return d.combos.hasOwnProperty(c)?d.combos[c][b]||a:a}):a.$preview.length&&(g=f.start-(0<=f.start-2?2:0),a.$preview.caret(g,f.end),l=(a.$preview.caret().text||"").replace(a.regex,function(a,c,b){return d.combos.hasOwnProperty(c)?d.combos[c][b]||a:a}),a.$preview.val(a.$preview.caret().replace(l)),k=a.$preview.val())); if(d.restrictInput&&""!==k){g=k;c=m.acceptedKeys.length;for(b=0;b<c;b++)""!==g&&(l=m.acceptedKeys[b],0<=k.indexOf(l)&&(/[\[|\]|\\|\^|\$|\.|\||\?|\*|\+|\(|\)|\{|\}]/g.test(l)&&(l="\\"+l),g=g.replace(new RegExp(l,"g"),"")));""!==g&&(k=k.replace(g,""))}f.start+=k.length-p;f.end+=k.length-p;a.$preview.val(k);a.$preview.caret(f.start,f.end);a.preview.scrollTop=a.lineHeight*(k.substring(0,f.start).split("\n").length-1);a.lastCaret={start:f.start,end:f.end};d.acceptValid&&a.checkValid();return k};a.checkValid= function(){var b=!0;d.validate&&"function"===typeof d.validate&&(b=d.validate(a,a.$preview.val(),!1));a.$keyboard.find(".ui-keyboard-accept")[b?"removeClass":"addClass"]("ui-keyboard-invalid-input")[b?"addClass":"removeClass"]("ui-keyboard-valid-input")};a.checkDecimal=function(){a.decimal&&/\./g.test(a.preview.value)||!a.decimal&&/\,/g.test(a.preview.value)?a.$decBtn.attr({disabled:"disabled","aria-disabled":"true"}).removeClass(d.css.buttonDefault+" "+d.css.buttonHover).addClass(d.css.buttonDisabled): a.$decBtn.removeAttr("disabled").attr({"aria-disabled":"false"}).addClass(d.css.buttonDefault).removeClass(d.css.buttonDisabled)};a.getLayers=function(a){var c;c=a.attr("data-pos");return a.closest(".ui-keyboard").find('button[data-pos="'+c+'"]').map(function(){return e(this).find("> span").html()}).get()};a.switchInput=function(b,c){if("function"===typeof d.switchInput)d.switchInput(a,b,c);else{a.$keyboard.hide();var g;g=!1;var l=e("button, input, textarea, a").filter(":visible"),k=l.index(a.$el)+ (b?1:-1);a.$keyboard.show();k>l.length-1&&(g=d.stopAtEnd,k=0);0>k&&(g=d.stopAtEnd,k=l.length-1);if(!g){c=a.close(c);if(!c)return;(g=l.eq(k).data("keyboard"))&&g.options.openOn.length?g.focusOn():l.eq(k).focus()}}return!1};a.close=function(b){if(a.isOpen){clearTimeout(a.throttled);var c=b?a.checkCombos():a.originalContent;if(b&&d.validate&&"function"===typeof d.validate&&!d.validate(a,c,!0)&&(c=a.originalContent,b=!1,d.cancelClose))return;a.isCurrent(!1);a.isOpen=!1;a.$preview.val(c);a.$el.removeClass("ui-keyboard-input-current ui-keyboard-autoaccepted").addClass(b? !0===b?"":"ui-keyboard-autoaccepted":"").trigger(d.alwaysOpen?"":"beforeClose.keyboard",[a,a.el,b||!1]).val(c).scrollTop(a.el.scrollHeight).trigger(b?"accepted.keyboard":"canceled.keyboard",[a,a.el]).trigger(d.alwaysOpen?"inactive.keyboard":"hidden.keyboard",[a,a.el]).blur();d.openOn&&(a.timer=setTimeout(function(){a.$el.bind(d.openOn+".keyboard",function(){a.focusOn()});e(":focus")[0]===a.el&&a.$el.blur()},500));!d.alwaysOpen&&a.$keyboard&&(a.$keyboard.remove(),a.$keyboard=[]);a.watermark||""!== a.el.value||""===a.inPlaceholder||a.$el.addClass("ui-keyboard-placeholder").val(a.inPlaceholder);a.$el.trigger("change")}return!!b};a.accept=function(){return a.close(!0)};a.escClose=function(b){if(b&&"keyup"===b.type)return 27===b.which?a.close():"";a.isOpen&&(!a.isCurrent()&&a.isOpen||a.isOpen&&b.target!==a.el&&!d.stayOpen)&&(a.allie&&b.preventDefault(),a.close(d.autoAccept?"true":!1))};a.keyBtn=e("<button />").attr({role:"button",type:"button","aria-disabled":"false",tabindex:"-1"}).addClass("ui-keyboard-button"); a.addKey=function(b,c,g){var l,k,f;c=!0===g?b:d.display[c]||b;var m=!0===g?b.charCodeAt(0):b;/\(.+\)/.test(c)&&(k=c.replace(/\(([^()]+)\)/,""),l=c.match(/\(([^()]+)\)/)[1],c=k,f=k.split(":"),k=""!==f[0]&&1<f.length?f[0]:k,e.keyboard.builtLayouts[a.layout].mappedKeys[l]=k);f=c.split(":");""===f[0]&&""===f[1]&&(c=":");c=""!==f[0]&&1<f.length?e.trim(f[0]):c;l=1<f.length?e.trim(f[1]).replace(/_/g," ")||"":"";k=1<c.length?" ui-keyboard-widekey":"";k+=g?"":" ui-keyboard-actionkey";return a.keyBtn.clone().attr({"data-value":c, name:m,"data-pos":a.temp[1]+","+a.temp[2],title:l,"data-action":b,"data-original":c,"data-curtxt":c,"data-curnum":0}).addClass((""===m?"":"ui-keyboard-"+m+k+" ")+d.css.buttonDefault).html("<span>"+c+"</span>").appendTo(a.temp[0])};a.customHash=function(){var a,c,b;c=d.customLayout;b=[];var e=[];for(a in c)c.hasOwnProperty(a)&&b.push(c[a]);e=e.concat.apply(e,b).join(" ");if(Array.prototype.reduce)return e.split("").reduce(function(a,c){a=(a<<5)-a+c.charCodeAt(0);return a&a},0);c=0;if(0===e.length)return c; for(a=0;a<e.length;a++)b=e.charCodeAt(a),c=(c<<5)-c+b,c&=c;return c};a.buildKeyboard=function(){var b,c,g,m,k,f,n,p,q,s=0,r=e.keyboard.builtLayouts[a.layout]={mappedKeys:{},acceptedKeys:[]},t=r.acceptedKeys=[],u=e("<div />").addClass("ui-keyboard "+d.css.container+(d.alwaysOpen?" ui-keyboard-always-open":"")).attr({role:"textbox"}).hide();"custom"!==d.layout&&e.keyboard.layouts.hasOwnProperty(d.layout)||(d.layout="custom",e.keyboard.layouts.custom=d.customLayout||{"default":["{cancel}"]});e.each(e.keyboard.layouts[d.layout], function(r,v){if(""!==r)for(s++,m=e("<div />").attr("name",r).addClass("ui-keyboard-keyset ui-keyboard-keyset-"+r).appendTo(u)["default"===r?"show":"hide"](),g=0;g<v.length;g++){f=e.trim(v[g]).replace(/\{(\.?)[\s+]?:[\s+]?(\.?)\}/g,"{$1:$2}");p=f.split(/\s+/);for(n=0;n<p.length;n++)if(a.temp=[m,g,n],k=!1,0!==p[n].length)if(/^\{\S+\}$/.test(p[n]))if(c=p[n].match(/^\{(\S+)\}$/)[1].toLowerCase(),/\!\!/.test(c)&&(c=c.replace("!!",""),k=!0),/^sp:((\d+)?([\.|,]\d+)?)(em|px)?$/.test(c)&&(q=parseFloat(c.replace(/,/, ".").match(/^sp:((\d+)?([\.|,]\d+)?)(em|px)?$/)[1]||0),e("<span>&nbsp;</span>").width(c.match("px")?q+"px":2*q+"em").addClass("ui-keyboard-button ui-keyboard-spacer").appendTo(m)),/^empty(:((\d+)?([\.|,]\d+)?)(em|px)?)?$/.test(c)&&(q=/:/.test(c)?parseFloat(c.replace(/,/,".").match(/^empty:((\d+)?([\.|,]\d+)?)(em|px)?$/)[1]||0):"",a.addKey(""," ").addClass(d.css.buttonDisabled+" "+d.css.buttonEmpty).attr("aria-disabled",!0).width(q?c.match("px")?q+"px":2*q+"em":"")),/^meta\d+\:?(\w+)?/.test(c))a.addKey(c, c);else switch(c){case "a":case "accept":a.addKey("accept",c).addClass(d.css.buttonAction);break;case "alt":case "altgr":a.addKey("alt","alt");break;case "b":case "bksp":a.addKey("bksp",c);break;case "c":case "cancel":a.addKey("cancel",c).addClass(d.css.buttonAction);break;case "combo":a.addKey("combo","combo").addClass(d.css.buttonAction);break;case "dec":t.push(a.decimal?".":",");a.addKey("dec","dec");break;case "e":case "enter":a.addKey("enter",c).addClass(d.css.buttonAction);break;case "s":case "shift":a.addKey("shift", c);break;case "sign":t.push("-");a.addKey("sign","sign");break;case "space":t.push(" ");a.addKey("space","space");break;case "t":case "tab":a.addKey("tab",c);break;default:if(e.keyboard.keyaction.hasOwnProperty(c))a.addKey(c,c)[k?"addClass":"removeClass"](d.css.buttonAction)}else b=p[n],t.push(":"===b?b:b.split(":")[0]),a.addKey(b,b,!0);m.find(".ui-keyboard-button:last").after('<br class="ui-keyboard-button-endrow">')}});1<s&&(a.sets=!0);r.hasMappedKeys=!e.isEmptyObject(r.mappedKeys);return r.$keyboard= u};a.destroy=function(){e(document).unbind("mousedown.keyboard keyup.keyboard touchstart.keyboard");a.$keyboard.length&&a.$keyboard.remove();var b=e.trim(d.openOn+" accepted beforeClose canceled change contextmenu hidden initialized keydown keypress keyup visible ").split(" ").join(".keyboard ");a.$el.removeClass("ui-keyboard-input ui-keyboard-lockedinput ui-keyboard-placeholder ui-keyboard-notallowed ui-keyboard-always-open "+d.css.input).removeAttr("aria-haspopup").removeAttr("role").unbind(b+".keyboard").removeData("keyboard")}; a.init()};e.keyboard.keyaction={accept:function(b){b.close(!0);return!1},alt:function(b,e){b.altActive=!b.altActive;b.showKeySet(e)},bksp:function(b){b.insertText("bksp")},cancel:function(b){b.close();return!1},clear:function(b){b.$preview.val("")},combo:function(b){var e=!b.options.useCombos;b.options.useCombos=e;b.$keyboard.find(".ui-keyboard-combo").toggleClass(b.options.css.buttonAction,e);e&&b.checkCombos();return!1},dec:function(b){b.insertText(b.decimal?".":",")},"default":function(b,e){b.shiftActive= b.altActive=b.metaActive=!1;b.showKeySet(e)},enter:function(b,m,a){m=b.el.tagName;var d=b.options;if(a.shiftKey)return d.enterNavigation?b.switchInput(!a[d.enterMod],!0):b.close(!0);if(d.enterNavigation&&("TEXTAREA"!==m||a[d.enterMod]))return b.switchInput(!a[d.enterMod],d.autoAccept?"true":!1);"TEXTAREA"===m&&e(a.target).closest("button").length&&b.insertText(" \n")},lock:function(b,e){b.lastKeyset[0]=b.shiftActive=b.capsLock=!b.capsLock;b.showKeySet(e)},left:function(b){var e=b.$preview.caret(); 0<=e.start-1&&(b.lastCaret={start:e.start-1,end:e.start-1})},meta:function(b,m){b.metaActive=e(m).hasClass(b.options.css.buttonAction)?!1:!0;b.showKeySet(m)},next:function(b){b.switchInput(!0,b.options.autoAccept);return!1},prev:function(b){b.switchInput(!1,b.options.autoAccept);return!1},right:function(b){var e=b.$preview.caret();e.start+1<=b.$preview.val().length&&(b.lastCaret={start:e.start+1,end:e.start+1})},shift:function(b,e){b.lastKeyset[0]=b.shiftActive=!b.shiftActive;b.showKeySet(e)},sign:function(b){/^\-?\d*\.?\d*$/.test(b.$preview.val())&& b.$preview.val(-1*b.$preview.val())},space:function(b){b.insertText(" ")},tab:function(b){var e=b.options;if("INPUT"===b.el.tagName)return e.tabNavigation?b.switchInput(!b.shiftActive,!0):!1;b.insertText("\t")}};e.keyboard.builtLayouts={};e.keyboard.layouts={alpha:{"default":["` 1 2 3 4 5 6 7 8 9 0 - = {bksp}","{tab} a b c d e f g h i j [ ] \\","k l m n o p q r s ; ' {enter}","{shift} t u v w x y z , . / {shift}","{accept} {space} {cancel}"],shift:["~ ! @ # $ % ^ & * ( ) _ + {bksp}","{tab} A B C D E F G H I J { } |", 'K L M N O P Q R S : " {enter}',"{shift} T U V W X Y Z < > ? {shift}","{accept} {space} {cancel}"]},qwerty:{"default":["` 1 2 3 4 5 6 7 8 9 0 - = {bksp}","{tab} q w e r t y u i o p [ ] \\","a s d f g h j k l ; ' {enter}","{shift} z x c v b n m , . / {shift}","{accept} {space} {cancel}"],shift:["~ ! @ # $ % ^ & * ( ) _ + {bksp}","{tab} Q W E R T Y U I O P { } |",'A S D F G H J K L : " {enter}',"{shift} Z X C V B N M < > ? {shift}","{accept} {space} {cancel}"]},international:{"default":["` 1 2 3 4 5 6 7 8 9 0 - = {bksp}", "{tab} q w e r t y u i o p [ ] \\","a s d f g h j k l ; ' {enter}","{shift} z x c v b n m , . / {shift}","{accept} {alt} {space} {alt} {cancel}"],shift:["~ ! @ # $ % ^ & * ( ) _ + {bksp}","{tab} Q W E R T Y U I O P { } |",'A S D F G H J K L : " {enter}',"{shift} Z X C V B N M < > ? {shift}","{accept} {alt} {space} {alt} {cancel}"],alt:["~ \u00a1 \u00b2 \u00b3 \u00a4 \u20ac \u00bc \u00bd \u00be \u2018 \u2019 \u00a5 \u00d7 {bksp}","{tab} \u00e4 \u00e5 \u00e9 \u00ae \u00fe \u00fc \u00fa \u00ed \u00f3 \u00f6 \u00ab \u00bb \u00ac", "\u00e1 \u00df \u00f0 f g h j k \u00f8 \u00b6 \u00b4 {enter}","{shift} \u00e6 x \u00a9 v b \u00f1 \u00b5 \u00e7 > \u00bf {shift}","{accept} {alt} {space} {alt} {cancel}"],"alt-shift":["~ \u00b9 \u00b2 \u00b3 \u00a3 \u20ac \u00bc \u00bd \u00be \u2018 \u2019 \u00a5 \u00f7 {bksp}","{tab} \u00c4 \u00c5 \u00c9 \u00ae \u00de \u00dc \u00da \u00cd \u00d3 \u00d6 \u00ab \u00bb \u00a6","\u00c4 \u00a7 \u00d0 F G H J K \u00d8 \u00b0 \u00a8 {enter}","{shift} \u00c6 X \u00a2 V B \u00d1 \u00b5 \u00c7 . \u00bf {shift}", "{accept} {alt} {space} {alt} {cancel}"]},colemak:{"default":["` 1 2 3 4 5 6 7 8 9 0 - = {bksp}","{tab} q w f p g j l u y ; [ ] \\","{bksp} a r s t d h n e i o ' {enter}","{shift} z x c v b k m , . / {shift}","{accept} {space} {cancel}"],shift:["~ ! @ # $ % ^ & * ( ) _ + {bksp}","{tab} Q W F P G J L U Y : { } |",'{bksp} A R S T D H N E I O " {enter}',"{shift} Z X C V B K M < > ? {shift}","{accept} {space} {cancel}"]},dvorak:{"default":["` 1 2 3 4 5 6 7 8 9 0 [ ] {bksp}","{tab} ' , . p y f g c r l / = \\", "a o e u i d h t n s - {enter}","{shift} ; q j k x b m w v z {shift}","{accept} {space} {cancel}"],shift:["~ ! @ # $ % ^ & * ( ) { } {bksp}",'{tab} " < > P Y F G C R L ? + |',"A O E U I D H T N S _ {enter}","{shift} : Q J K X B M W V Z {shift}","{accept} {space} {cancel}"]},num:{"default":"= ( ) {b};{clear} / * -;7 8 9 +;4 5 6 {sign};1 2 3 %;0 . {a} {c}".split(";")}};e.keyboard.defaultOptions={layout:"qwerty",customLayout:null,position:{of:null,my:"center top",at:"center top",at2:"center bottom"}, usePreview:!0,alwaysOpen:!1,initialFocus:!0,stayOpen:!1,display:{a:"\u2714:Accept (Shift-Enter)",accept:"Accept:Accept (Shift-Enter)",alt:"Alt:\u2325 AltGr",b:"\u232b:Backspace",bksp:"Bksp:Backspace",c:"\u2716:Cancel (Esc)",cancel:"Cancel:Cancel (Esc)",clear:"C:Clear",combo:"\u00f6:Toggle Combo Keys",dec:".:Decimal",e:"\u23ce:Enter",empty:"\u00a0",enter:"Enter:Enter \u23ce",left:"\u2190",lock:"Lock:\u21ea Caps Lock",next:"Next \u21e8",prev:"\u21e6 Prev",right:"\u2192",s:"\u21e7:Shift",shift:"Shift:Shift", sign:"\u00b1:Change Sign",space:"&nbsp;:Space",t:"\u21e5:Tab",tab:"\u21e5 Tab:Tab"},wheelMessage:"Use mousewheel to see other keys",css:{input:"ui-widget-content ui-corner-all",container:"ui-widget-content ui-widget ui-corner-all ui-helper-clearfix",buttonDefault:"ui-state-default ui-corner-all",buttonHover:"ui-state-hover",buttonAction:"ui-state-active",buttonDisabled:"ui-state-disabled",buttonEmpty:"ui-keyboard-empty"},autoAccept:!1,lockInput:!1,restrictInput:!1,acceptValid:!1,cancelClose:!0,tabNavigation:!1, enterNavigation:!1,enterMod:"altKey",stopAtEnd:!0,appendLocally:!1,appendTo:"body",stickyShift:!0,preventPaste:!1,caretToEnd:!1,maxLength:!1,repeatDelay:500,repeatRate:20,resetDefault:!1,openOn:"focus",keyBinding:"mousedown touchstart",useCombos:!0,combos:{"`":{a:"\u00e0",A:"\u00c0",e:"\u00e8",E:"\u00c8",i:"\u00ec",I:"\u00cc",o:"\u00f2",O:"\u00d2",u:"\u00f9",U:"\u00d9",y:"\u1ef3",Y:"\u1ef2"},"'":{a:"\u00e1",A:"\u00c1",e:"\u00e9",E:"\u00c9",i:"\u00ed",I:"\u00cd",o:"\u00f3",O:"\u00d3",u:"\u00fa",U:"\u00da", y:"\u00fd",Y:"\u00dd"},'"':{a:"\u00e4",A:"\u00c4",e:"\u00eb",E:"\u00cb",i:"\u00ef",I:"\u00cf",o:"\u00f6",O:"\u00d6",u:"\u00fc",U:"\u00dc",y:"\u00ff",Y:"\u0178"},"^":{a:"\u00e2",A:"\u00c2",e:"\u00ea",E:"\u00ca",i:"\u00ee",I:"\u00ce",o:"\u00f4",O:"\u00d4",u:"\u00fb",U:"\u00db",y:"\u0177",Y:"\u0176"},"~":{a:"\u00e3",A:"\u00c3",e:"\u1ebd",E:"\u1ebc",i:"\u0129",I:"\u0128",o:"\u00f5",O:"\u00d5",u:"\u0169",U:"\u0168",y:"\u1ef9",Y:"\u1ef8",n:"\u00f1",N:"\u00d1"}},validate:function(b,e,a){return!0}};e.keyboard.comboRegex= /([`\'~\^\"ao])([a-z])/mig;e.keyboard.currentKeyboard="";e.fn.keyboard=function(b){return this.each(function(){e(this).data("keyboard")||new e.keyboard(this,b)})};e.fn.getkeyboard=function(){return this.data("keyboard")}})(jQuery);
(function(e,b,m,a){e.fn.caret=function(d,e){if("undefined"===typeof this[0]||this.is(":hidden")||"hidden"===this.css("visibility"))return this;var c,g,l,k,f;f=document.selection;var n=this[0],p=n.scrollTop,q=!1,s=!0;try{q="undefined"!==typeof n.selectionStart}catch(r){s=!1}"object"===typeof d&&d.start&&d.end?(g=d.start,k=d.end):"number"===typeof d&&"number"===typeof e&&(g=d,k=e);if(s&&"undefined"!==typeof g)return q?(n.selectionStart=g,n.selectionEnd=k):(f=n.createTextRange(),f.collapse(!0),f.moveStart("character", g),f.moveEnd("character",k-g),f.select()),(this.is(":visible")||"hidden"!==this.css("visibility"))&&this.focus(),n.scrollTop=p,this;q?(c=n.selectionStart,l=n.selectionEnd):f?"TEXTAREA"===n.tagName?(k=this.val(),g=f[m](),f=g[a](),f.moveToElementText(n),f.setEndPoint("EndToEnd",g),c=f.text.replace(/\r/g,"\n")[b],l=c+g.text.replace(/\r/g,"\n")[b]):(k=this.val().replace(/\r/g,"\n"),g=f[m]()[a](),g.moveEnd("character",k[b]),c=""===g.text?k[b]:k.lastIndexOf(g.text),g=f[m]()[a](),g.moveStart("character", -k[b]),l=g.text[b]):(c=0,l=(n.value||"").length);f=(n.value||"").substring(c,l);return{start:c,end:l,text:f,replace:function(a){return n.value.substring(0,c)+a+n.value.substring(l,n.value[b])}}}})(jQuery,"length","createRange","duplicate");
/* jQuery UI Virtual Keyboard Typing Simulator v1.4 for Keyboard v1.18+ only (3/1/2014) */
;(function(g){g.fn.addTyping=function(k){var l={showTyping:!0,delay:250};return this.each(function(){var a=g(this).data("keyboard");a&&(a.typing_options=g.extend({},l,k),a.typing_keymap={" ":"space",'"':"34","'":"39","&nbsp;":"space","\b":"bksp","\n":"Enter","\r":"Enter","\t":"tab"},a.typing_xref={8:"bksp",9:"tab",13:"enter",32:"space"},a.typing_event=!1,a.typing_setup=function(){(a.$preview?a.$preview:a.$el).bind("keyup.keyboard",function(b){37<=b.which&&40>=b.which||(16===b.which&&(a.shiftActive= !1),18===b.which&&(a.altActive=!1),16!==b.which&&18!==b.which)||(a.showKeySet(),setTimeout(function(){a.$preview.focus()},200))}).bind("keydown.keyboard",function(b){b.temp=!1;16===b.which&&(b.temp=a.shiftActive?!1:!0,a.shiftActive=!0);18===b.which&&(b.temp=a.altActive?!1:!0,a.altActive=!0);b.temp&&(a.showKeySet(),a.$preview.focus());a.typing_event=!0;8!==b.which&&9!==b.which||a.typeIn("",a.typing_options.delay||250,function(){a.typing_event=!1},b)}).bind("keypress.keyboard",function(b){a.typing_event&& !a.options.lockInput&&a.typeIn("",a.typing_options.delay||250,function(){a.typing_event=!1},b)})},a.typeIn=function(b,e,f,c){if(a.isVisible()){var d=a.typing_options,h=g.keyboard.builtLayouts[a.layout].mappedKeys;!0!==a.typing_options.init&&(d.init=!0,d.text=b,d.len=b.length,d.delay=e||300,d.current=0,d.callback=f);b=d.text.substring(d.current,++d.current);e=a.$keyboard.find(".ui-keyboard-keyset");f='.ui-keyboard-button[data-value="'+(a.typing_keymap.hasOwnProperty(b)?a.typing_keymap[b]:b)+'"]';a.typing_event&& c&&(a.typing_xref.hasOwnProperty(c.keyCode||c.which)?f=".ui-keyboard-"+a.typing_xref[c.keyCode||c.which]:(f=String.fromCharCode(c.charCode||c.which),f=h.hasOwnProperty(f)?'.ui-keyboard-button[data-value="'+h[f]+'"]':".ui-keyboard-"+(c.charCode||c.which)));c=e.filter(":visible").find(f);c.length?a.typing_simulateKey(c,b):(a.typing_event?c=e.find(f):(c=a.typing_keymap.hasOwnProperty(b)?a.typing_keymap[b]:b.charCodeAt(0),"bksp"===c&&(b=c),c=e.find(".ui-keyboard-"+c)),e=c.closest(".ui-keyboard-keyset"), e.attr("name")?(e=e.attr("name"),a.shiftActive=/shift/.test(e),a.altActive=/alt/.test(e),a.metaActive=a.lastKeyset[2]=e.match(/meta\d+/)||!1,a.showKeySet({name:a.metaActive}),a.typing_simulateKey(c,b)):a.typing_event||(a.insertText(b),a.checkCombos()));d.current<d.len?a.isVisible()&&setTimeout(function(){a.typeIn()},d.delay):(d.init=!1,g.isFunction(d.callback)&&setTimeout(function(){d.callback(a)},d.delay))}else a.typing_options.init=!1,clearTimeout(a.typing_timer)},a.typing_simulateKey=function(b, e){var f=b.length;f&&b.filter(":visible").trigger("mouseenter.keyboard");a.typing_timer=setTimeout(function(){f&&setTimeout(function(){b.trigger("mouseleave.keyboard")},a.typing_options.delay/3);a.isVisible()&&!a.typing_event&&(a.insertText(e),a.checkCombos())},a.typing_options.delay/3)},a.typing_options.showTyping&&(a.options.alwaysOpen&&a.isVisible()&&a.typing_setup(),a.$el.bind("visible.keyboard",function(){a.typing_setup()})))})}})(jQuery);
/*!
jQuery yellowFade plugin Version: 1.0.0
Copyright (c) 2012 Andrey Sidorov, licensed under MIT license.
https://github.com/morr/jquery.yellowFade/
*/
!function(n){function r(n){function r(n){return isNaN(n)?"00":c[(n-n%16)/16]+c[n%16]}var c=["0","1","2","3","4","5","6","7","8","9","a","b","c","d","e","f"];return n=n.match(/^rgb\((\d+),\s*(\d+),\s*(\d+)\)$/),"#"+r(n[1])+r(n[2])+r(n[3])}n.fn.yellowFade=function(){return this.each(function(){var c=n(this);c.stop(!0,!0);var a=c.css("background-color"),o=!1;("transparent"==a||""==a||"rgba(0, 0, 0, 0)"==a)&&(a="#FFFFFF",o=!0),a.match(/^rgb\(/)&&(a=r(a)),c.css("background-color","#3C9DD2").animate({"background-color":a},1500,function(){o&&n(this).css("background-color","transparent")})})}}(jQuery);
/*! jquery.ui.checklist3 */
!function(e){e.widget("ui.checkList",{options:{col2:"",listItems:[],selectedItems:[],effect:"blink",filtertxt:"filter",tfilter:!1,colopts:1,radio:!1,tdback:"#FFFFFF",tdhigh:"#CCCCCC",headertxt:"",onChange:{},objTable:"",icount:0,r_cb:!0,prefix:"",altrows:!1,evenrow:"#B3B3B3",oddrow:"#E6E6E6",cbbgr:"transparent",locked:!1},_create:function(){var t=this,c=t.options,a=t.element,s=e("<div/>").addClass("checkList");if(c.objTable=e("<table/>").addClass("table"),c.tfilter){var o=e("<div/>").addClass("toolbar"),n=e("<input/>").attr("type","text").addClass("txtFilter").keyup(function(){t._filter(e(this).val())});o.append(e("<div/>").addClass("filterbox").text(c.filtertxt).append(n)),s.append(o)}s.append(c.objTable),a.append(s),t.loadList()},_addItem:function(t){var c=this,a=c.options,s=c.element,o=a.prefix+"itm"+a.icount++,n=e("<tr/>"),i=e("<span />").attr("id",o).css("margin-right","5px").css("background-color",a.cbbgr).addClass("icn_checkboxempty_c_n clckbtn chk").attr("data-text",t.text).attr("data-value",t.value).attr("data-help",t.help).attr("data-checked",!1);a.r_cb||i.css("visibility","hidden"),n.append(e("<td/>").append(i));var d=e("<label/>").attr("for",o).text(t.text);if(n.append(e("<td/>").append(d)),2==a.colopts){var d=e("<label/>").attr("for",o).text(t.text2);void 0==typeof col2?n.append(e('<td style="border-left: 1px solid black; padding-left: 5px;" />').append(d)):n.append(e('<td style="border-left: 1px solid black; padding-left: 5px;" class="col2" />').append(d))}a.objTable.append(n),s.delegate("#"+o,"click",function(){c._selChange("#"+o)})},loadList:function(){var t=this,c=t.options;t.element;c.objTable.empty(),e.each(c.listItems,function(){t._addItem(this)})},_selChange:function(t){var c=this,a=c.options;c.element;if(a.locked)return!1;if(a.radio){if(1==e(t).data("checked"))return!1;sts=a.objTable.find(t).data("checked"),a.objTable.find(".chk").data("checked",!1).removeClass("icn_checkboxchecked_c_n").addClass("icn_checkboxempty_c_n"),a.objTable.find(t).data("checked",!sts),sts?a.objTable.find(t).removeClass("icn_checkboxchecked_c_n").addClass("icn_checkboxempty_c_n"):a.objTable.find(t).removeClass("icn_checkboxempty_c_n").addClass("icn_checkboxchecked_c_n")}else void 0!==t&&(sts=e(t).data("checked"),sts?e(t).data("checked",!1).removeClass("icn_checkboxchecked_c_n").addClass("icn_checkboxempty_c_n"):e(t).data("checked",!0).removeClass("icn_checkboxempty_c_n").addClass("icn_checkboxchecked_c_n"));a.selectedItems=[],a.objTable.find(".chk").each(function(){e(this).data("checked")?(a.selectedItems.push({text:e(this).attr("data-text"),value:e(this).attr("data-value")}),e(this).parent().css("background-color",a.tdhigh).siblings().css("background-color",a.tdhigh)):a.altrows?e(this).attr("id").split("itm")[1]%2==0?e(this).parent().css("background-color",a.evenrow).siblings().css("background-color",a.evenrow):e(this).parent().css("background-color",a.oddrow).siblings().css("background-color",a.oddrow):e(this).parent().css("background-color",a.tdback).siblings().css("background-color",a.tdback)}),a.onChange.call(void 0,t)},_filter:function(t){var c=this,a=c.options;c.element;a.objTable.find(".chk").each(function(){e(this).attr("data-text").toLowerCase().indexOf(t.toLowerCase())>-1?e(this).parent().parent().show("none"==a.effect?null:a.effect):e(this).parent().parent().hide("none"==a.effect?null:a.effect)})},getSelection:function(){var e=this,t=e.options;e.element;return t.selectedItems},getOptions:function(){var e=this,t=e.options;return t},getOption:function(e){var t=this,c=t.options;return c[e]},setOption:function(e){var t=this,c=t.options;t.element;e=e.split(":");var a=e[0],s=e[1];return"true"==s&&(s=!0),"false"==s&&(s=!1),t.options[a]=s,c[a]},setSelection:function(t){var c=this,a=c.options,s=c.element;""!=t&&($tdimg=e(s).find("span[data-value='"+t+"']"),$tdimg.data("checked",!0).removeClass("icn_checkboxempty_c_n").addClass("icn_checkboxchecked_c_n"),e($tdimg).parent().css("background-color",a.tdhigh).siblings().css("background-color",a.tdhigh))},resetSelection:function(t){var c=this,a=c.options,s=c.element;""!=t&&($tdimg=e(s).find("span[data-value='"+t+"']"),$tdimg.data("checked",!1).removeClass("icn_checkboxchecked_c_n").addClass("icn_checkboxempty_c_n"),a.altrows?e($tdimg).attr("id").split("itm")[1]%2==0?e($tdimg).parent().css("background-color",a.evenrow).siblings().css("background-color",a.evenrow):e($tdimg).parent().css("background-color",a.oddrow).siblings().css("background-color",a.oddrow):e($tdimg).parent().css("background-color",a.tdback).siblings().css("background-color",a.tdback))},resetAll:function(){var t=this,c=t.options,a=t.element;e(a).find("span").each(function(){e(this).data("checked",!1).removeClass("icn_checkboxchecked_c_n").addClass("icn_checkboxempty_c_n"),c.altrows?e(this).attr("id").split("itm")[1]%2==0?e(this).parent().css("background-color",c.evenrow).siblings().css("background-color",c.evenrow):e(this).parent().css("background-color",c.oddrow).siblings().css("background-color",c.oddrow):e(this).parent().css("background-color",c.tdback).siblings().css("background-color",c.tdback)})},setData:function(e){var t=this,c=t.options;t.element;c.listItems=e,t.loadList(),t._selChange()}})}(jQuery);
/*!
jQuery number plug-in 2.1.5
Copyright 2012, Digital Fusion
Licensed under the MIT license
*/
!function(e){"use strict";function t(e,t){if(this.createTextRange){var a=this.createTextRange();a.collapse(!0),a.moveStart("character",e),a.moveEnd("character",t-e),a.select()}else this.setSelectionRange&&(this.focus(),this.setSelectionRange(e,t))}function a(e){var t=this.value.length;if(e="start"==e.toLowerCase()?"Start":"End",document.selection){var a,i,n,l=document.selection.createRange();return a=l.duplicate(),a.expand("textedit"),a.setEndPoint("EndToEnd",l),i=a.text.length-l.text.length,n=i+l.text.length,"Start"==e?i:n}return"undefined"!=typeof this["selection"+e]&&(t=this["selection"+e]),t}var i={codes:{46:127,188:44,109:45,190:46,191:47,192:96,220:92,222:39,221:93,219:91,173:45,187:61,186:59,189:45,110:46},shifts:{96:"~",49:"!",50:"@",51:"#",52:"$",53:"%",54:"^",55:"&",56:"*",57:"(",48:")",45:"_",61:"+",91:"{",93:"}",92:"|",59:":",39:'"',44:"<",46:">",47:"?"}};e.fn.number=function(n,l,s,r){r="undefined"==typeof r?",":r,s="undefined"==typeof s?".":s,l="undefined"==typeof l?0:l;var u="\\u"+("0000"+s.charCodeAt(0).toString(16)).slice(-4),h=new RegExp("[^"+u+"0-9]","g"),o=new RegExp(u,"g");return n===!0?this.is("input:text")?this.on({"keydown.format":function(n){var u=e(this),h=u.data("numFormat"),o=n.keyCode?n.keyCode:n.which,c="",v=a.apply(this,["start"]),d=a.apply(this,["end"]),p="",f=!1;if(i.codes.hasOwnProperty(o)&&(o=i.codes[o]),!n.shiftKey&&o>=65&&90>=o?o+=32:!n.shiftKey&&o>=69&&105>=o?o-=48:n.shiftKey&&i.shifts.hasOwnProperty(o)&&(c=i.shifts[o]),""==c&&(c=String.fromCharCode(o)),8!=o&&45!=o&&127!=o&&c!=s&&!c.match(/[0-9]/)){var g=n.keyCode?n.keyCode:n.which;if(46==g||8==g||127==g||9==g||27==g||13==g||(65==g||82==g||80==g||83==g||70==g||72==g||66==g||74==g||84==g||90==g||61==g||173==g||48==g)&&(n.ctrlKey||n.metaKey)===!0||(86==g||67==g||88==g)&&(n.ctrlKey||n.metaKey)===!0||g>=35&&39>=g||g>=112&&123>=g)return;return n.preventDefault(),!1}if(0==v&&d==this.value.length?8==o?(v=d=1,this.value="",h.init=l>0?-1:0,h.c=l>0?-(l+1):0,t.apply(this,[0,0])):c==s?(v=d=1,this.value="0"+s+new Array(l+1).join("0"),h.init=l>0?1:0,h.c=l>0?-(l+1):0):45==o?(v=d=2,this.value="-0"+s+new Array(l+1).join("0"),h.init=l>0?1:0,h.c=l>0?-(l+1):0,t.apply(this,[2,2])):(h.init=l>0?-1:0,h.c=l>0?-l:0):h.c=d-this.value.length,h.isPartialSelection=v==d?!1:!0,l>0&&c==s&&v==this.value.length-l-1)h.c++,h.init=Math.max(0,h.init),n.preventDefault(),f=this.value.length+h.c;else if(45!=o||0==v&&0!=this.value.indexOf("-"))if(c==s)h.init=Math.max(0,h.init),n.preventDefault();else if(l>0&&127==o&&v==this.value.length-l-1)n.preventDefault();else if(l>0&&8==o&&v==this.value.length-l)n.preventDefault(),h.c--,f=this.value.length+h.c;else if(l>0&&127==o&&v>this.value.length-l-1){if(""===this.value)return;"0"!=this.value.slice(v,v+1)&&(p=this.value.slice(0,v)+"0"+this.value.slice(v+1),u.val(p)),n.preventDefault(),f=this.value.length+h.c}else if(l>0&&8==o&&v>this.value.length-l){if(""===this.value)return;"0"!=this.value.slice(v-1,v)&&(p=this.value.slice(0,v-1)+"0"+this.value.slice(v),u.val(p)),n.preventDefault(),h.c--,f=this.value.length+h.c}else 127==o&&this.value.slice(v,v+1)==r?n.preventDefault():8==o&&this.value.slice(v-1,v)==r?(n.preventDefault(),h.c--,f=this.value.length+h.c):l>0&&v==d&&this.value.length>l+1&&v>this.value.length-l-1&&isFinite(+c)&&!n.metaKey&&!n.ctrlKey&&!n.altKey&&1===c.length&&(p=d===this.value.length?this.value.slice(0,v-1):this.value.slice(0,v)+this.value.slice(v+1),this.value=p,f=v);else n.preventDefault();f!==!1&&t.apply(this,[f,f]),u.data("numFormat",h)},"keyup.format":function(i){var n,s=e(this),r=s.data("numFormat"),u=i.keyCode?i.keyCode:i.which,h=a.apply(this,["start"]),o=a.apply(this,["end"]);0!==h||0!==o||189!==u&&109!==u||(s.val("-"+s.val()),h=1,r.c=1-this.value.length,r.init=1,s.data("numFormat",r),n=this.value.length+r.c,t.apply(this,[n,n])),""===this.value||(48>u||u>57)&&(96>u||u>105)&&8!==u&&46!==u&&110!==u||(s.val(s.val()),l>0&&(r.init<1?(h=this.value.length-l-(r.init<0?1:0),r.c=h-this.value.length,r.init=1,s.data("numFormat",r)):h>this.value.length-l&&8!=u&&(r.c++,s.data("numFormat",r))),46!=u||r.isPartialSelection||(r.c++,s.data("numFormat",r)),n=this.value.length+r.c,t.apply(this,[n,n]))},"paste.format":function(t){var a=e(this),i=t.originalEvent,n=null;return window.clipboardData&&window.clipboardData.getData?n=window.clipboardData.getData("Text"):i.clipboardData&&i.clipboardData.getData&&(n=i.clipboardData.getData("text/plain")),a.val(n),t.preventDefault(),!1}}).each(function(){var t=e(this).data("numFormat",{c:-(l+1),decimals:l,thousands_sep:r,dec_point:s,regex_dec_num:h,regex_dec:o,init:this.value.indexOf(".")?!0:!1});""!==this.value&&t.val(t.val())}):this.each(function(){var t=e(this),a=+t.text().replace(h,"").replace(o,".");t.number(isFinite(a)?+a:0,l,s,r)}):this.text(e.number.apply(window,arguments))};var n=null,l=null;e.isPlainObject(e.valHooks.text)?(e.isFunction(e.valHooks.text.get)&&(n=e.valHooks.text.get),e.isFunction(e.valHooks.text.set)&&(l=e.valHooks.text.set)):e.valHooks.text={},e.valHooks.text.get=function(t){var a,i=e(t),l=i.data("numFormat");return l?""===t.value?"":(a=+t.value.replace(l.regex_dec_num,"").replace(l.regex_dec,"."),(0===t.value.indexOf("-")?"-":"")+(isFinite(a)?a:0)):e.isFunction(n)?n(t):void 0},e.valHooks.text.set=function(t,a){var i=e(t),n=i.data("numFormat");if(n){var s=e.number(a,n.decimals,n.dec_point,n.thousands_sep);return e.isFunction(l)?l(t,s):t.value=s}return e.isFunction(l)?l(t,a):void 0},e.number=function(e,t,a,i){i="undefined"==typeof i?"1000"!==new Number(1e3).toLocaleString()?new Number(1e3).toLocaleString().charAt(1):"":i,a="undefined"==typeof a?new Number(.1).toLocaleString().charAt(1):a,t=isFinite(+t)?Math.abs(t):0;var n="\\u"+("0000"+a.charCodeAt(0).toString(16)).slice(-4),l="\\u"+("0000"+i.charCodeAt(0).toString(16)).slice(-4);e=(e+"").replace(".",a).replace(new RegExp(l,"g"),"").replace(new RegExp(n,"g"),".").replace(new RegExp("[^0-9+-Ee.]","g"),"");var s=isFinite(+e)?+e:0,r="",u=function(e,t){return""+ +(Math.round((""+e).indexOf("e")>0?e:e+"e+"+t)+"e-"+t)};return r=(t?u(s,t):""+Math.round(s)).split("."),r[0].length>3&&(r[0]=r[0].replace(/\B(?=(?:\d{3})+(?!\d))/g,i)),(r[1]||"").length<t&&(r[1]=r[1]||"",r[1]+=new Array(t-r[1].length+1).join("0")),r.join(a)}}(jQuery);