﻿//Prevents backspace except in the case of textareas and text inputs to prevent user navigation.
$(document).keydown(function (e) {
	var preventKeyPress;
	if (e.keyCode == 8) {
		var d = e.srcElement || e.target;
		switch (d.tagName.toUpperCase()) {
			case 'TEXTAREA':
				preventKeyPress = d.readOnly || d.disabled;
				break;
			case 'INPUT':
				preventKeyPress = d.readOnly || d.disabled ||
					(d.attributes["type"] && $.inArray(d.attributes["type"].value.toLowerCase(), ["radio", "checkbox", "submit", "button"]) >= 0);
				break;
			case 'DIV':
				preventKeyPress = d.readOnly || d.disabled || !(d.attributes["contentEditable"] && d.attributes["contentEditable"].value == "true");
				break;
			default:
				preventKeyPress = true;
				break;
		}
	}
	else
		preventKeyPress = false;

	if (preventKeyPress)
		e.preventDefault();
});
function htmlEscape(value) {
	return $('<div/>').text(value).html();
}
function htmlDecode(value) {
    return $('<div/>').html(value).text();
}
jQuery.fn.visible = function() {
	return this.css('visibility', 'visible');
};
jQuery.fn.invisible = function() {
	return this.css('visibility', 'hidden');
};

$(document).ready(function(){
	$("body").append('<div id="loading" style="display: none;"><div class="loading-container"><img src="./img/loader.gif"/></div></div>');
});

function generalizedate(loc) {
	$mnth = loc.split("-");
	if ($.isNumeric($mnth[1])) {
		return $mnth[0]+"-"+("0"+$mnth[1]).slice(-2)+"-"+$mnth[2];
	} else {
		$nm = ("0"+(($.inArray($mnth[1], calTranslation["monthNamesShort"][$globlan]) % 12) + 1)).slice(-2);
		return $mnth[0]+"-"+$nm+"-"+$mnth[2];
	}
}
function localizetime(loc) {
	if ((loc == "") || (loc === null)) return "";
	if (loc.substring(0, 10) == "0000-00-00") {
		return "";
	} else {
		$mnth = loc.split("-");
		return $mnth[0]+"-"+ calTranslation["monthNamesShort"][$globlan][$mnth[1]-1]+"-"+$mnth[2];
	}
}
function localizedate(loc) {
	if ((loc == "") || (loc === null)) return "";
	loc = loc.substring(0, 10);
	if (loc == "0000-00-00") {
		return "";
	} else {
		$mnth = loc.split("-");
		return $mnth[0]+"-"+ calTranslation["monthNamesShort"][$globlan][$mnth[1]-1]+"-"+$mnth[2];
	}
}
// Check if string is non-blank
var isNonblank_re    = /\S/;
function isNonblank (s) {
   return String (s).search (isNonblank_re) != -1
}
// Check if string is a whole number(digits only).
var isWhole_re       = /^\s*\d+\s*$/;
function isWhole (s) {
   return String(s).search (isWhole_re) != -1
}
// check 0-9 digit
function regIsDigit(fData)
{
    var reg = new RegExp("^[0-9]$");
    return (reg.test(fData));
}
// checks that an input string is an integer, with an optional +/- sign character.
var isInteger_re     = /^\s*(\+|-)?\d+\s*$/;
function isInteger (s) {
   return String(s).search (isInteger_re) != -1
}
// check is number
function regIsNumber(fData)
{
    var reg = new RegExp("^[-]?[0-9]+[\.]?[0-9]+$");
    return reg.test(fData)
}
// Check if string is currency
var isCurrency_re    = /^\s*(\+|-)?((\d+(\.\d\d)?)|(\.\d\d))\s*$/;
function isCurrency (s) {
   return String(s).search (isCurrency_re) != -1
}
// checks that an input string looks like a valid email address.
var isEmail_re       = /^\s*[\w\-\+_]+(\.[\w\-\+_]+)*\@[\w\-\+_]+\.[\w\-\+_]+(\.[\w\-\+_]+)*\s*$/;
function isEmail (s) {
   return String(s).search (isEmail_re) != -1;
}
// Checks that an input string is a decimal number, with an optional +/- sign character.
var isDecimal_re     = /^\s*(\+|-)?((\d+(\.\d+)?)|(\.\d+))\s*$/;
function isDecimal (s) {
   return String(s).search (isDecimal_re) != -1
}
// converts rgb to hex if needed
function rgb2hex(rgb) {
     if (  rgb.search("rgb") == -1 ) {
          return rgb.toUpperCase();
     } else {
          rgb = rgb.match(/^rgba?\((\d+),\s*(\d+),\s*(\d+)(?:,\s*(\d+))?\)$/);
          function hex(x) {
               return ("0" + parseInt(x).toString(16)).slice(-2);
          }
          return ("#" + hex(rgb[1]) + hex(rgb[2]) + hex(rgb[3])).toUpperCase(); 
     }
}
// alerts
!function(p){p.alerts={verticalOffset:-75,horizontalOffset:0,repositionOnResize:!0,overlayOpacity:.01,overlayColor:"#FFF",draggable:!0,okButton:"&nbsp;OK&nbsp;",cancelButton:"&nbsp;Cancel&nbsp;",dialogClass:null,alert:function(e,o,t){null==o&&(o="Alert"),p.alerts._show(o,e,null,"alert",function(p){t&&t(p)})},confirm:function(e,o,t){null==o&&(o="Confirm"),p.alerts._show(o,e,null,"confirm",function(p){t&&t(p)})},prompt:function(e,o,t,s){null==t&&(t="Prompt"),p("body").append('<div id="ovrly"><div class="loading-container"></div></div>'),p.alerts._show(t,e,o,"prompt",function(p){s&&s(p)})},clink:function(e,o,t,s){null==t&&(t="Link"),p.alerts._show(t,e,o,"clink",function(p){s&&s(p)})},password:function(e,o,t,s){null==t&&(t="Password"),p("body").append('<div id="ovrly"><div class="loading-container"></div></div>'),p.alerts._show(t,e,o,"password",function(p){s&&s(p)})},textfield:function(e,o,t,s){null==t&&(t="Textfield"),p.alerts._show(t,e,o,"textfield",function(p){s&&s(p)})},_show:function(e,o,t,s,n){p.alerts._hide(),p.alerts._overlay("show"),p("BODY").append('<div id="popup_container"><h1 id="popup_title"></h1><div id="popup_content"><div id="popup_message" style="display: inline-block; vertical-align: middle;" ></div></div></div>'),p.alerts.dialogClass&&p("#popup_container").addClass(p.alerts.dialogClass);var i=p.browser.msie&&parseInt(p.browser.version)<=6?"absolute":"fixed";switch(p("#popup_container").css({position:i,zIndex:99999,padding:0,margin:0}),p("#popup_title").text(e),p("#popup_content").addClass(s),p("#popup_message").text(o),p("#popup_container").css({minWidth:p("#popup_container").outerWidth(),maxWidth:p("#popup_container").outerWidth()}),p("#popup_message").css("width",p("#popup_content").css("width").substr(0,p("#popup_content").css("width").length-2)-40),p.alerts._reposition(),p.alerts._maintainPosition(!0),s){case"alert":p("#popup_message").parent().prepend('<span class="icna_warning_x_n" style="margin-right: 20px;"></span>'),p("#popup_message").after('<div id="popup_panel"><span class="spanbutton" id="popup_ok" style="width: 100px;" >'+p.alerts.okButton+"</span></div>"),p("#popup_message").css("width",p("#popup_content").css("width").slice(0,-2)-50+"px"),p("#popup_ok").click(function(){p.alerts._hide(),n(!0)}),p("#popup_ok").focus().keypress(function(e){(13==e.keyCode||27==e.keyCode)&&p("#popup_ok").trigger("click")});break;case"prompt":p("#popup_message").parent().prepend('<span class="icna_question_x_n" style="margin-right: 20px;"></span>'),p("#popup_message").append('<input type="text" style="width: 200px; margin-bottom: 10px;" id="popup_prompt" />').after('<br /><div id="popup_panel"><span class="spanbutton" id="popup_ok" style="width: 100px;" >'+p.alerts.okButton+'</span><span class="spanbutton" id="popup_cancel" style="width: 100px; margin-left: 20px;" >'+p.alerts.cancelButton+"</span></div>"),p("#popup_message").css("width",p("#popup_content").css("width").slice(0,-2)-50+"px"),p("#popup_ok").click(function(){var e=p("#popup_prompt").val();p.alerts._hide(),p("#ovrly").remove(),n&&n(e)}),p("#popup_cancel").click(function(){p.alerts._hide(),p("#ovrly").remove(),n&&n(null)}),p("#popup_prompt, #popup_ok, #popup_cancel").keypress(function(e){13==e.keyCode&&p("#popup_ok").trigger("click"),27==e.keyCode&&p("#popup_cancel").trigger("click")}),t&&p("#popup_prompt").val(t),p("#popup_prompt").focus().select();break;case"confirm":p("#popup_message").parent().prepend('<span class="icna_question_x_n posrel" style="margin-right: 20px;"></span>'),p("#popup_message").after('<br /><div id="popup_panel"><span class="spanbutton" id="popup_ok" style="width: 100px;" >'+p.alerts.okButton+'</span><span class="spanbutton" id="popup_cancel" style="width: 100px; margin-left: 20px;" >'+p.alerts.cancelButton+"</span></div>"),p("#popup_message").css("width",p("#popup_content").css("width").substr(0,p("#popup_content").css("width").length-2)-50),p("#popup_ok").click(function(){p.alerts._hide(),n&&n(!0)}),p("#popup_cancel").click(function(){p.alerts._hide(),n&&n(!1)}),p("#popup_ok").focus(),p("#popup_ok, #popup_cancel").keypress(function(e){13==e.keyCode&&p("#popup_ok").trigger("click"),27==e.keyCode&&p("#popup_cancel").trigger("click")});break;case"clink":p("#popup_message").parent().prepend('<span class="icn3_link_b_n" style="position: relative; top: -30px; margin-right: 20px;"></span>'),p("#popup_message").append('<br /><input type="text" size="30" id="popup_prompt" readonly /><br /><br />').after('<div id="popup_panel"><span class="spanbutton" id="popup_ok" style="width: 100px;" >'+p.alerts.okButton+"</span></div>"),p("#popup_message").css("width","500px"),p("#popup_prompt").css("width","460px"),p("#popup_ok").click(function(){var e=p("#popup_prompt").val();p.alerts._hide(),n&&n(e)}),p("#popup_ok, #popup_cancel").keypress(function(e){13==e.keyCode&&p("#popup_ok").trigger("click")}),t&&p("#popup_prompt").val(t),p("#popup_prompt").focus().select();break;case"password":p("#popup_message").parent().prepend('<span class="icn3_key_b_n" style="position: relative;top:6px;"></span>'),p("#popup_message").append('<input type="password" size="25" id="popup_ppassword" />').after('<br /><div id="popup_panel"><span class="spanbutton" id="popup_ok" style="width: 100px;" >'+p.alerts.okButton+'</span><span class="spanbutton" id="popup_cancel" style="width: 100px; margin-left: 20px;" >'+p.alerts.cancelButton+"</span></div>"),p("#popup_ppassword").width(p("#popup_message").width()),p("#popup_message").css("width",p("#popup_content").css("width").slice(0,-2)-50+"px"),p("#popup_ok").click(function(){var e=p("#popup_ppassword").val();p.alerts._hide(),p("#ovrly").remove(),n&&n(e)}),p("#popup_cancel").click(function(){p.alerts._hide(),p("#ovrly").remove(),n&&n(null)}),p("#popup_ppassword, #popup_ok, #popup_cancel").keypress(function(e){13==e.keyCode&&p("#popup_ok").trigger("click"),27==e.keyCode&&p("#popup_cancel").trigger("click")}),t&&p("#popup_ppassword").val(t),p("#popup_ppassword").focus().select();break;case"textfield":p("#popup_message").parent().prepend('<span class="icn3_text_x_n" style="position: relative;top:-35px;left:-10px;"></span>'),p("#popup_message").append('<textarea cols="60" rows="5" style="resize: none;" id="popup_textfield" />').after('<br /><div id="popup_panel"><span class="spanbutton" id="popup_ok" style="width: 100px;" >'+p.alerts.okButton+'</span><span class="spanbutton" id="popup_cancel" style="width: 100px; margin-left: 20px;" >'+p.alerts.cancelButton+"</span></div>"),p("#popup_textfield").width(p("#popup_message").width()),p("#popup_ok").click(function(){var e=p("#popup_textfield").val();p.alerts._hide(),n&&n(e)}),p("#popup_cancel").click(function(){p.alerts._hide(),n&&n(null)}),p("#popup_textfield, #popup_ok, #popup_cancel").keypress(function(e){27==e.keyCode&&p("#popup_cancel").trigger("click")}),t&&p("#popup_textfield").val(t),p("#popup_textfield").focus().select()}if(p.alerts.draggable)try{p("#popup_container").draggable({handle:p("#popup_title")}),p("#popup_title").css({cursor:"move"})}catch(a){}},_hide:function(){p("#popup_container").remove(),p.alerts._overlay("hide"),p.alerts._maintainPosition(!1)},_overlay:function(e){switch(e){case"show":p.alerts._overlay("hide"),p("BODY").append('<div id="popup_overlay"></div>'),p("#popup_overlay").css({position:"absolute",zIndex:99998,top:"0px",left:"0px",width:"100%",height:p(document).height(),background:p.alerts.overlayColor,opacity:p.alerts.overlayOpacity});break;case"hide":p("#popup_overlay").remove()}},_reposition:function(){var e=p(window).height()/2-p("#popup_container").outerHeight()/2+p.alerts.verticalOffset,o=p(window).width()/2-p("#popup_container").outerWidth()/2+p.alerts.horizontalOffset;0>e&&(e=0),0>o&&(o=0),p.browser.msie&&parseInt(p.browser.version)<=6&&(e+=p(window).scrollTop()),p("#popup_container").css({top:e+"px",left:o+"px"}),p("#popup_overlay").height(p(document).height())},_maintainPosition:function(e){if(p.alerts.repositionOnResize)switch(e){case!0:p(window).bind("resize",p.alerts._reposition);break;case!1:p(window).unbind("resize",p.alerts._reposition)}}},jAlert=function(e,o,t){p.alerts.alert(e,o,t)},jConfirm=function(e,o,t){p.alerts.confirm(e,o,t)},jPrompt=function(e,o,t,s){p.alerts.prompt(e,o,t,s)},jLink=function(e,o,t,s){p.alerts.clink(e,o,t,s)},jPassword=function(e,o,t,s){p.alerts.password(e,o,t,s)},jTextfield=function(e,o,t,s){p.alerts.textfield(e,o,t,s)}}(jQuery);
// dropzone
(function(){var e,t,i,n,r,s,o,l,a=[].slice,u={}.hasOwnProperty,p=function(e,t){function i(){this.constructor=e}for(var n in t)u.call(t,n)&&(e[n]=t[n]);return i.prototype=t.prototype,e.prototype=new i,e.__super__=t.prototype,e};o=function(){},t=function(){function e(){}return e.prototype.addEventListener=e.prototype.on,e.prototype.on=function(e,t){return this._callbacks=this._callbacks||{},this._callbacks[e]||(this._callbacks[e]=[]),this._callbacks[e].push(t),this},e.prototype.emit=function(){var e,t,i,n,r,s;if(n=arguments[0],e=2<=arguments.length?a.call(arguments,1):[],this._callbacks=this._callbacks||{},i=this._callbacks[n])for(r=0,s=i.length;s>r;r++)t=i[r],t.apply(this,e);return this},e.prototype.removeListener=e.prototype.off,e.prototype.removeAllListeners=e.prototype.off,e.prototype.removeEventListener=e.prototype.off,e.prototype.off=function(e,t){var i,n,r,s,o;if(!this._callbacks||0===arguments.length)return this._callbacks={},this;if(n=this._callbacks[e],!n)return this;if(1===arguments.length)return delete this._callbacks[e],this;for(r=s=0,o=n.length;o>s;r=++s)if(i=n[r],i===t){n.splice(r,1);break}return this},e}(),e=function(e){function i(e,t){var r,s,o;if(this.element=e,this.version=i.version,this.defaultOptions.previewTemplate=this.defaultOptions.previewTemplate.replace(/\n*/g,""),this.clickableElements=[],this.listeners=[],this.files=[],"string"==typeof this.element&&(this.element=document.querySelector(this.element)),!this.element||null==this.element.nodeType)throw new Error("Invalid dropzone element.");if(this.element.dropzone)throw new Error("Dropzone already attached.");if(i.instances.push(this),this.element.dropzone=this,r=null!=(o=i.optionsForElement(this.element))?o:{},this.options=n({},this.defaultOptions,r,null!=t?t:{}),this.options.forceFallback||!i.isBrowserSupported())return this.options.fallback.call(this);if(null==this.options.url&&(this.options.url=this.element.getAttribute("action")),!this.options.url)throw new Error("No URL provided.");if(this.options.acceptedFiles&&this.options.acceptedMimeTypes)throw new Error("You can't provide both 'acceptedFiles' and 'acceptedMimeTypes'. 'acceptedMimeTypes' is deprecated.");this.options.acceptedMimeTypes&&(this.options.acceptedFiles=this.options.acceptedMimeTypes,delete this.options.acceptedMimeTypes),this.options.method=this.options.method.toUpperCase(),(s=this.getExistingFallback())&&s.parentNode&&s.parentNode.removeChild(s),this.options.previewsContainer!==!1&&(this.options.previewsContainer?this.previewsContainer=i.getElement(this.options.previewsContainer,"previewsContainer"):this.previewsContainer=this.element),this.options.clickable&&(this.options.clickable===!0?this.clickableElements=[this.element]:this.clickableElements=i.getElements(this.options.clickable,"clickable")),this.init()}var n,r;return p(i,e),i.prototype.Emitter=t,i.prototype.events=["drop","dragstart","dragend","dragenter","dragover","dragleave","addedfile","removedfile","thumbnail","error","errormultiple","processing","processingmultiple","uploadprogress","totaluploadprogress","sending","sendingmultiple","success","successmultiple","canceled","canceledmultiple","complete","completemultiple","reset","maxfilesexceeded","maxfilesreached","queuecomplete"],i.prototype.defaultOptions={url:null,method:"post",withCredentials:!1,parallelUploads:2,uploadMultiple:!1,maxFilesize:256,paramName:"file",createImageThumbnails:!0,maxThumbnailFilesize:10,thumbnailWidth:120,thumbnailHeight:120,filesizeBase:1e3,maxFiles:null,filesizeBase:1e3,params:{},clickable:!0,ignoreHiddenFiles:!0,acceptedFiles:null,acceptedMimeTypes:null,autoProcessQueue:!0,autoQueue:!0,addRemoveLinks:!1,previewsContainer:null,capture:null,dictDefaultMessage:"Drop files here to upload",dictFallbackMessage:"Your browser does not support drag'n'drop file uploads.",dictFallbackText:"Please use the fallback form below to upload your files like in the olden days.",dictFileTooBig:"File is too big ({{filesize}}MiB). Max filesize: {{maxFilesize}}MiB.",dictInvalidFileType:"You can't upload files of this type.",dictResponseError:"Server responded with {{statusCode}} code.",dictCancelUpload:"Cancel upload",dictCancelUploadConfirmation:"Are you sure you want to cancel this upload?",dictRemoveFile:"Remove file",dictRemoveFileConfirmation:null,dictMaxFilesExceeded:"You can not upload any more files.",accept:function(e,t){return t()},init:function(){return o},forceFallback:!1,fallback:function(){var e,t,n,r,s,o;for(this.element.className=""+this.element.className+" dz-browser-not-supported",o=this.element.getElementsByTagName("div"),r=0,s=o.length;s>r;r++)e=o[r],/(^| )dz-message($| )/.test(e.className)&&(t=e,e.className="dz-message");return t||(t=i.createElement('<div class="dz-message"><span></span></div>'),this.element.appendChild(t)),n=t.getElementsByTagName("span")[0],n&&(n.textContent=this.options.dictFallbackMessage),this.element.appendChild(this.getFallbackForm())},resize:function(e){var t,i,n;return t={srcX:0,srcY:0,srcWidth:e.width,srcHeight:e.height},i=e.width/e.height,t.optWidth=this.options.thumbnailWidth,t.optHeight=this.options.thumbnailHeight,null==t.optWidth&&null==t.optHeight?(t.optWidth=t.srcWidth,t.optHeight=t.srcHeight):null==t.optWidth?t.optWidth=i*t.optHeight:null==t.optHeight&&(t.optHeight=1/i*t.optWidth),n=t.optWidth/t.optHeight,e.height<t.optHeight||e.width<t.optWidth?(t.trgHeight=t.srcHeight,t.trgWidth=t.srcWidth):i>n?(t.srcHeight=e.height,t.srcWidth=t.srcHeight*n):(t.srcWidth=e.width,t.srcHeight=t.srcWidth/n),t.srcX=(e.width-t.srcWidth)/2,t.srcY=(e.height-t.srcHeight)/2,t},drop:function(e){return this.element.classList.remove("dz-drag-hover")},dragstart:o,dragend:function(e){return this.element.classList.remove("dz-drag-hover")},dragenter:function(e){return this.element.classList.add("dz-drag-hover")},dragover:function(e){return this.element.classList.add("dz-drag-hover")},dragleave:function(e){return this.element.classList.remove("dz-drag-hover")},paste:o,reset:function(){return this.element.classList.remove("dz-started")},addedfile:function(e){var t,n,r,s,o,l,a,u,p,d,c,h,m;if(this.element===this.previewsContainer&&this.element.classList.add("dz-started"),this.previewsContainer){for(e.previewElement=i.createElement(this.options.previewTemplate.trim()),e.previewTemplate=e.previewElement,this.previewsContainer.appendChild(e.previewElement),d=e.previewElement.querySelectorAll("[data-dz-name]"),s=0,a=d.length;a>s;s++)t=d[s],t.textContent=e.name;for(c=e.previewElement.querySelectorAll("[data-dz-size]"),o=0,u=c.length;u>o;o++)t=c[o],t.innerHTML=this.filesize(e.size);for(this.options.addRemoveLinks&&(e._removeLink=i.createElement('<a class="dz-remove" href="javascript:undefined;" data-dz-remove>'+this.options.dictRemoveFile+"</a>"),e.previewElement.appendChild(e._removeLink)),n=function(t){return function(n){return n.preventDefault(),n.stopPropagation(),e.status===i.UPLOADING?i.confirm(t.options.dictCancelUploadConfirmation,function(){return t.removeFile(e)}):t.options.dictRemoveFileConfirmation?i.confirm(t.options.dictRemoveFileConfirmation,function(){return t.removeFile(e)}):t.removeFile(e)}}(this),h=e.previewElement.querySelectorAll("[data-dz-remove]"),m=[],l=0,p=h.length;p>l;l++)r=h[l],m.push(r.addEventListener("click",n));return m}},removedfile:function(e){var t;return e.previewElement&&null!=(t=e.previewElement)&&t.parentNode.removeChild(e.previewElement),this._updateMaxFilesReachedClass()},thumbnail:function(e,t){var i,n,r,s;if(e.previewElement){for(e.previewElement.classList.remove("dz-file-preview"),s=e.previewElement.querySelectorAll("[data-dz-thumbnail]"),n=0,r=s.length;r>n;n++)i=s[n],i.alt=e.name,i.src=t;return setTimeout(function(t){return function(){return e.previewElement.classList.add("dz-image-preview")}}(this),1)}},error:function(e,t){var i,n,r,s,o;if(e.previewElement){for(e.previewElement.classList.add("dz-error"),"String"!=typeof t&&t.error&&(t=t.error),s=e.previewElement.querySelectorAll("[data-dz-errormessage]"),o=[],n=0,r=s.length;r>n;n++)i=s[n],o.push(i.textContent=t);return o}},errormultiple:o,processing:function(e){return e.previewElement&&(e.previewElement.classList.add("dz-processing"),e._removeLink)?e._removeLink.textContent=this.options.dictCancelUpload:void 0},processingmultiple:o,uploadprogress:function(e,t,i){var n,r,s,o,l;if(e.previewElement){for(o=e.previewElement.querySelectorAll("[data-dz-uploadprogress]"),l=[],r=0,s=o.length;s>r;r++)n=o[r],"PROGRESS"===n.nodeName?l.push(n.value=t):l.push(n.style.width=""+t+"%");return l}},totaluploadprogress:o,sending:o,sendingmultiple:o,success:function(e){return e.previewElement?e.previewElement.classList.add("dz-success"):void 0},successmultiple:o,canceled:function(e){return this.emit("error",e,"Upload canceled.")},canceledmultiple:o,complete:function(e){return e._removeLink&&(e._removeLink.textContent=this.options.dictRemoveFile),e.previewElement?e.previewElement.classList.add("dz-complete"):void 0},completemultiple:o,maxfilesexceeded:o,maxfilesreached:o,queuecomplete:o,previewTemplate:'<div class="dz-preview dz-file-preview">\n  <div class="dz-image"><img data-dz-thumbnail /></div>\n  <div class="dz-details">\n    <div class="dz-size"><span data-dz-size></span></div>\n    <div class="dz-filename"><span data-dz-name></span></div>\n  </div>\n  <div class="dz-progress"><span class="dz-upload" data-dz-uploadprogress></span></div>\n  <div class="dz-error-message"><span data-dz-errormessage></span></div>\n  <div class="dz-success-mark">\n    <svg width="54px" height="54px" viewBox="0 0 54 54" version="1.1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" xmlns:sketch="http://www.bohemiancoding.com/sketch/ns">\n      <title>Check</title>\n      <defs></defs>\n      <g id="Page-1" stroke="none" stroke-width="1" fill="none" fill-rule="evenodd" sketch:type="MSPage">\n        <path d="M23.5,31.8431458 L17.5852419,25.9283877 C16.0248253,24.3679711 13.4910294,24.366835 11.9289322,25.9289322 C10.3700136,27.4878508 10.3665912,30.0234455 11.9283877,31.5852419 L20.4147581,40.0716123 C20.5133999,40.1702541 20.6159315,40.2626649 20.7218615,40.3488435 C22.2835669,41.8725651 24.794234,41.8626202 26.3461564,40.3106978 L43.3106978,23.3461564 C44.8771021,21.7797521 44.8758057,19.2483887 43.3137085,17.6862915 C41.7547899,16.1273729 39.2176035,16.1255422 37.6538436,17.6893022 L23.5,31.8431458 Z M27,53 C41.3594035,53 53,41.3594035 53,27 C53,12.6405965 41.3594035,1 27,1 C12.6405965,1 1,12.6405965 1,27 C1,41.3594035 12.6405965,53 27,53 Z" id="Oval-2" stroke-opacity="0.198794158" stroke="#747474" fill-opacity="0.816519475" fill="#FFFFFF" sketch:type="MSShapeGroup"></path>\n      </g>\n    </svg>\n  </div>\n  <div class="dz-error-mark">\n    <svg width="54px" height="54px" viewBox="0 0 54 54" version="1.1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" xmlns:sketch="http://www.bohemiancoding.com/sketch/ns">\n      <title>Error</title>\n      <defs></defs>\n      <g id="Page-1" stroke="none" stroke-width="1" fill="none" fill-rule="evenodd" sketch:type="MSPage">\n        <g id="Check-+-Oval-2" sketch:type="MSLayerGroup" stroke="#747474" stroke-opacity="0.198794158" fill="#FFFFFF" fill-opacity="0.816519475">\n          <path d="M32.6568542,29 L38.3106978,23.3461564 C39.8771021,21.7797521 39.8758057,19.2483887 38.3137085,17.6862915 C36.7547899,16.1273729 34.2176035,16.1255422 32.6538436,17.6893022 L27,23.3431458 L21.3461564,17.6893022 C19.7823965,16.1255422 17.2452101,16.1273729 15.6862915,17.6862915 C14.1241943,19.2483887 14.1228979,21.7797521 15.6893022,23.3461564 L21.3431458,29 L15.6893022,34.6538436 C14.1228979,36.2202479 14.1241943,38.7516113 15.6862915,40.3137085 C17.2452101,41.8726271 19.7823965,41.8744578 21.3461564,40.3106978 L27,34.6568542 L32.6538436,40.3106978 C34.2176035,41.8744578 36.7547899,41.8726271 38.3137085,40.3137085 C39.8758057,38.7516113 39.8771021,36.2202479 38.3106978,34.6538436 L32.6568542,29 Z M27,53 C41.3594035,53 53,41.3594035 53,27 C53,12.6405965 41.3594035,1 27,1 C12.6405965,1 1,12.6405965 1,27 C1,41.3594035 12.6405965,53 27,53 Z" id="Oval-2" sketch:type="MSShapeGroup"></path>\n        </g>\n      </g>\n    </svg>\n  </div>\n</div>'},n=function(){var e,t,i,n,r,s,o;for(n=arguments[0],i=2<=arguments.length?a.call(arguments,1):[],s=0,o=i.length;o>s;s++){t=i[s];for(e in t)r=t[e],n[e]=r}return n},i.prototype.getAcceptedFiles=function(){var e,t,i,n,r;for(n=this.files,r=[],t=0,i=n.length;i>t;t++)e=n[t],e.accepted&&r.push(e);return r},i.prototype.getRejectedFiles=function(){var e,t,i,n,r;for(n=this.files,r=[],t=0,i=n.length;i>t;t++)e=n[t],e.accepted||r.push(e);return r},i.prototype.getFilesWithStatus=function(e){var t,i,n,r,s;for(r=this.files,s=[],i=0,n=r.length;n>i;i++)t=r[i],t.status===e&&s.push(t);return s},i.prototype.getQueuedFiles=function(){return this.getFilesWithStatus(i.QUEUED)},i.prototype.getUploadingFiles=function(){return this.getFilesWithStatus(i.UPLOADING)},i.prototype.getActiveFiles=function(){var e,t,n,r,s;for(r=this.files,s=[],t=0,n=r.length;n>t;t++)e=r[t],(e.status===i.UPLOADING||e.status===i.QUEUED)&&s.push(e);return s},i.prototype.init=function(){var e,t,n,r,s,o,l;for("form"===this.element.tagName&&this.element.setAttribute("enctype","multipart/form-data"),this.element.classList.contains("dropzone")&&!this.element.querySelector(".dz-message")&&this.element.appendChild(i.createElement('<div class="dz-default dz-message"><span>'+this.options.dictDefaultMessage+"</span></div>")),this.clickableElements.length&&(n=function(e){return function(){return e.hiddenFileInput&&document.body.removeChild(e.hiddenFileInput),e.hiddenFileInput=document.createElement("input"),e.hiddenFileInput.setAttribute("type","file"),(null==e.options.maxFiles||e.options.maxFiles>1)&&e.hiddenFileInput.setAttribute("multiple","multiple"),e.hiddenFileInput.className="dz-hidden-input",null!=e.options.acceptedFiles&&e.hiddenFileInput.setAttribute("accept",e.options.acceptedFiles),null!=e.options.capture&&e.hiddenFileInput.setAttribute("capture",e.options.capture),e.hiddenFileInput.style.visibility="hidden",e.hiddenFileInput.style.position="absolute",e.hiddenFileInput.style.top="0",e.hiddenFileInput.style.left="0",e.hiddenFileInput.style.height="0",e.hiddenFileInput.style.width="0",document.body.appendChild(e.hiddenFileInput),e.hiddenFileInput.addEventListener("change",function(){var t,i,r,s;if(i=e.hiddenFileInput.files,i.length)for(r=0,s=i.length;s>r;r++)t=i[r],e.addFile(t);return n()})}}(this))(),this.URL=null!=(o=window.URL)?o:window.webkitURL,l=this.events,r=0,s=l.length;s>r;r++)e=l[r],this.on(e,this.options[e]);return this.on("uploadprogress",function(e){return function(){return e.updateTotalUploadProgress()}}(this)),this.on("removedfile",function(e){return function(){return e.updateTotalUploadProgress()}}(this)),this.on("canceled",function(e){return function(t){return e.emit("complete",t)}}(this)),this.on("complete",function(e){return function(t){return 0===e.getUploadingFiles().length&&0===e.getQueuedFiles().length?setTimeout(function(){return e.emit("queuecomplete")},0):void 0}}(this)),t=function(e){return e.stopPropagation(),e.preventDefault?e.preventDefault():e.returnValue=!1},this.listeners=[{element:this.element,events:{dragstart:function(e){return function(t){return e.emit("dragstart",t)}}(this),dragenter:function(e){return function(i){return t(i),e.emit("dragenter",i)}}(this),dragover:function(e){return function(i){var n;try{n=i.dataTransfer.effectAllowed}catch(r){}return i.dataTransfer.dropEffect="move"===n||"linkMove"===n?"move":"copy",t(i),e.emit("dragover",i)}}(this),dragleave:function(e){return function(t){return e.emit("dragleave",t)}}(this),drop:function(e){return function(i){return t(i),e.drop(i)}}(this),dragend:function(e){return function(t){return e.emit("dragend",t)}}(this)}}],this.clickableElements.forEach(function(e){return function(t){return e.listeners.push({element:t,events:{click:function(n){return t!==e.element||n.target===e.element||i.elementInside(n.target,e.element.querySelector(".dz-message"))?e.hiddenFileInput.click():void 0}}})}}(this)),this.enable(),this.options.init.call(this)},i.prototype.destroy=function(){var e;return this.disable(),this.removeAllFiles(!0),(null!=(e=this.hiddenFileInput)?e.parentNode:void 0)&&(this.hiddenFileInput.parentNode.removeChild(this.hiddenFileInput),this.hiddenFileInput=null),delete this.element.dropzone,i.instances.splice(i.instances.indexOf(this),1)},i.prototype.updateTotalUploadProgress=function(){var e,t,i,n,r,s,o,l;if(n=0,i=0,e=this.getActiveFiles(),e.length){for(l=this.getActiveFiles(),s=0,o=l.length;o>s;s++)t=l[s],n+=t.upload.bytesSent,i+=t.upload.total;r=100*n/i}else r=100;return this.emit("totaluploadprogress",r,i,n)},i.prototype._getParamName=function(e){return"function"==typeof this.options.paramName?this.options.paramName(e):""+this.options.paramName+(this.options.uploadMultiple?"["+e+"]":"")},i.prototype.getFallbackForm=function(){var e,t,n,r;return(e=this.getExistingFallback())?e:(n='<div class="dz-fallback">',this.options.dictFallbackText&&(n+="<p>"+this.options.dictFallbackText+"</p>"),n+='<input type="file" name="'+this._getParamName(0)+'" '+(this.options.uploadMultiple?'multiple="multiple"':void 0)+' /><input type="submit" value="Upload!"></div>',t=i.createElement(n),"FORM"!==this.element.tagName?(r=i.createElement('<form action="'+this.options.url+'" enctype="multipart/form-data" method="'+this.options.method+'"></form>'),r.appendChild(t)):(this.element.setAttribute("enctype","multipart/form-data"),this.element.setAttribute("method",this.options.method)),null!=r?r:t)},i.prototype.getExistingFallback=function(){var e,t,i,n,r,s;for(t=function(e){var t,i,n;for(i=0,n=e.length;n>i;i++)if(t=e[i],/(^| )fallback($| )/.test(t.className))return t},s=["div","form"],n=0,r=s.length;r>n;n++)if(i=s[n],e=t(this.element.getElementsByTagName(i)))return e},i.prototype.setupEventListeners=function(){var e,t,i,n,r,s,o;for(s=this.listeners,o=[],n=0,r=s.length;r>n;n++)e=s[n],o.push(function(){var n,r;n=e.events,r=[];for(t in n)i=n[t],r.push(e.element.addEventListener(t,i,!1));return r}());return o},i.prototype.removeEventListeners=function(){var e,t,i,n,r,s,o;for(s=this.listeners,o=[],n=0,r=s.length;r>n;n++)e=s[n],o.push(function(){var n,r;n=e.events,r=[];for(t in n)i=n[t],r.push(e.element.removeEventListener(t,i,!1));return r}());return o},i.prototype.disable=function(){var e,t,i,n,r;for(this.clickableElements.forEach(function(e){return e.classList.remove("dz-clickable")}),this.removeEventListeners(),n=this.files,r=[],t=0,i=n.length;i>t;t++)e=n[t],r.push(this.cancelUpload(e));return r},i.prototype.enable=function(){return this.clickableElements.forEach(function(e){return e.classList.add("dz-clickable")}),this.setupEventListeners()},i.prototype.filesize=function(e){var t,i,n,r,s,o,l,a;for(o=["TB","GB","MB","KB","b"],n=r=null,i=l=0,a=o.length;a>l;i=++l)if(s=o[i],t=Math.pow(this.options.filesizeBase,4-i)/10,e>=t){n=e/Math.pow(this.options.filesizeBase,4-i),r=s;break}return n=Math.round(10*n)/10,"<strong>"+n+"</strong> "+r},i.prototype._updateMaxFilesReachedClass=function(){return null!=this.options.maxFiles&&this.getAcceptedFiles().length>=this.options.maxFiles?(this.getAcceptedFiles().length===this.options.maxFiles&&this.emit("maxfilesreached",this.files),this.element.classList.add("dz-max-files-reached")):this.element.classList.remove("dz-max-files-reached")},i.prototype.drop=function(e){var t,i;e.dataTransfer&&(this.emit("drop",e),t=e.dataTransfer.files,t.length&&(i=e.dataTransfer.items,i&&i.length&&null!=i[0].webkitGetAsEntry?this._addFilesFromItems(i):this.handleFiles(t)))},i.prototype.paste=function(e){var t,i;if(null!=(null!=e&&null!=(i=e.clipboardData)?i.items:void 0))return this.emit("paste",e),t=e.clipboardData.items,t.length?this._addFilesFromItems(t):void 0},i.prototype.handleFiles=function(e){var t,i,n,r;for(r=[],i=0,n=e.length;n>i;i++)t=e[i],r.push(this.addFile(t));return r},i.prototype._addFilesFromItems=function(e){var t,i,n,r,s;for(s=[],n=0,r=e.length;r>n;n++)i=e[n],null!=i.webkitGetAsEntry&&(t=i.webkitGetAsEntry())?t.isFile?s.push(this.addFile(i.getAsFile())):t.isDirectory?s.push(this._addFilesFromDirectory(t,t.name)):s.push(void 0):null!=i.getAsFile&&(null==i.kind||"file"===i.kind)?s.push(this.addFile(i.getAsFile())):s.push(void 0);return s},i.prototype._addFilesFromDirectory=function(e,t){var i,n;return i=e.createReader(),n=function(e){return function(i){var n,r,s;for(r=0,s=i.length;s>r;r++)n=i[r],n.isFile?n.file(function(i){return e.options.ignoreHiddenFiles&&"."===i.name.substring(0,1)?void 0:(i.fullPath=""+t+"/"+i.name,e.addFile(i))}):n.isDirectory&&e._addFilesFromDirectory(n,""+t+"/"+n.name)}}(this),i.readEntries(n,function(e){return"undefined"!=typeof console&&null!==console&&"function"==typeof console.log?console.log(e):void 0})},i.prototype.accept=function(e,t){return e.size>1024*this.options.maxFilesize*1024?t(this.options.dictFileTooBig.replace("{{filesize}}",Math.round(e.size/1024/10.24)/100).replace("{{maxFilesize}}",this.options.maxFilesize)):i.isValidFile(e,this.options.acceptedFiles)?null!=this.options.maxFiles&&this.getAcceptedFiles().length>=this.options.maxFiles?(t(this.options.dictMaxFilesExceeded.replace("{{maxFiles}}",this.options.maxFiles)),this.emit("maxfilesexceeded",e)):this.options.accept.call(this,e,t):t(this.options.dictInvalidFileType)},i.prototype.addFile=function(e){return e.upload={progress:0,total:e.size,bytesSent:0},this.files.push(e),e.status=i.ADDED,this.emit("addedfile",e),this._enqueueThumbnail(e),this.accept(e,function(t){return function(i){return i?(e.accepted=!1,t._errorProcessing([e],i)):(e.accepted=!0,t.options.autoQueue&&t.enqueueFile(e)),t._updateMaxFilesReachedClass()}}(this))},i.prototype.enqueueFiles=function(e){var t,i,n;for(i=0,n=e.length;n>i;i++)t=e[i],this.enqueueFile(t);return null},i.prototype.enqueueFile=function(e){if(e.status!==i.ADDED||e.accepted!==!0)throw new Error("This file can't be queued because it has already been processed or was rejected.");return e.status=i.QUEUED,this.options.autoProcessQueue?setTimeout(function(e){return function(){return e.processQueue()}}(this),0):void 0},i.prototype._thumbnailQueue=[],i.prototype._processingThumbnail=!1,i.prototype._enqueueThumbnail=function(e){return this.options.createImageThumbnails&&e.type.match(/image.*/)&&e.size<=1024*this.options.maxThumbnailFilesize*1024?(this._thumbnailQueue.push(e),setTimeout(function(e){return function(){return e._processThumbnailQueue()}}(this),0)):void 0},i.prototype._processThumbnailQueue=function(){return this._processingThumbnail||0===this._thumbnailQueue.length?void 0:(this._processingThumbnail=!0,this.createThumbnail(this._thumbnailQueue.shift(),function(e){return function(){return e._processingThumbnail=!1,e._processThumbnailQueue()}}(this)))},i.prototype.removeFile=function(e){return e.status===i.UPLOADING&&this.cancelUpload(e),this.files=l(this.files,e),this.emit("removedfile",e),0===this.files.length?this.emit("reset"):void 0},i.prototype.removeAllFiles=function(e){var t,n,r,s;for(null==e&&(e=!1),s=this.files.slice(),n=0,r=s.length;r>n;n++)t=s[n],(t.status!==i.UPLOADING||e)&&this.removeFile(t);return null},i.prototype.createThumbnail=function(e,t){var i;return i=new FileReader,i.onload=function(n){return function(){return"image/svg+xml"===e.type?(n.emit("thumbnail",e,i.result),void(null!=t&&t())):n.createThumbnailFromUrl(e,i.result,t)}}(this),i.readAsDataURL(e)},i.prototype.createThumbnailFromUrl=function(e,t,i){var n;return n=document.createElement("img"),n.onload=function(t){return function(){var r,o,l,a,u,p,d,c;return e.width=n.width,e.height=n.height,l=t.options.resize.call(t,e),null==l.trgWidth&&(l.trgWidth=l.optWidth),null==l.trgHeight&&(l.trgHeight=l.optHeight),r=document.createElement("canvas"),o=r.getContext("2d"),r.width=l.trgWidth,r.height=l.trgHeight,s(o,n,null!=(u=l.srcX)?u:0,null!=(p=l.srcY)?p:0,l.srcWidth,l.srcHeight,null!=(d=l.trgX)?d:0,null!=(c=l.trgY)?c:0,l.trgWidth,l.trgHeight),a=r.toDataURL("image/png"),t.emit("thumbnail",e,a),null!=i?i():void 0}}(this),null!=i&&(n.onerror=i),n.src=t},i.prototype.processQueue=function(){var e,t,i,n;if(t=this.options.parallelUploads,i=this.getUploadingFiles().length,e=i,!(i>=t)&&(n=this.getQueuedFiles(),n.length>0)){if(this.options.uploadMultiple)return this.processFiles(n.slice(0,t-i));for(;t>e;){if(!n.length)return;this.processFile(n.shift()),e++}}},i.prototype.processFile=function(e){return this.processFiles([e])},i.prototype.processFiles=function(e){var t,n,r;for(n=0,r=e.length;r>n;n++)t=e[n],t.processing=!0,t.status=i.UPLOADING,this.emit("processing",t);return this.options.uploadMultiple&&this.emit("processingmultiple",e),this.uploadFiles(e)},i.prototype._getFilesWithXhr=function(e){var t,i;return i=function(){var i,n,r,s;for(r=this.files,s=[],i=0,n=r.length;n>i;i++)t=r[i],t.xhr===e&&s.push(t);return s}.call(this)},i.prototype.cancelUpload=function(e){var t,n,r,s,o,l,a;if(e.status===i.UPLOADING){for(n=this._getFilesWithXhr(e.xhr),r=0,o=n.length;o>r;r++)t=n[r],t.status=i.CANCELED;for(e.xhr.abort(),s=0,l=n.length;l>s;s++)t=n[s],this.emit("canceled",t);this.options.uploadMultiple&&this.emit("canceledmultiple",n)}else((a=e.status)===i.ADDED||a===i.QUEUED)&&(e.status=i.CANCELED,this.emit("canceled",e),this.options.uploadMultiple&&this.emit("canceledmultiple",[e]));return this.options.autoProcessQueue?this.processQueue():void 0},r=function(){var e,t;return t=arguments[0],e=2<=arguments.length?a.call(arguments,1):[],"function"==typeof t?t.apply(this,e):t},i.prototype.uploadFile=function(e){return this.uploadFiles([e])},i.prototype.uploadFiles=function(e){var t,s,o,l,a,u,p,d,c,h,m,f,g,v,y,F,w,E,b,C,k,z,L,x,T,A,D,S,_,M,U,N,I,R;for(b=new XMLHttpRequest,C=0,x=e.length;x>C;C++)t=e[C],t.xhr=b;f=r(this.options.method,e),w=r(this.options.url,e),b.open(f,w,!0),b.withCredentials=!!this.options.withCredentials,y=null,o=function(i){return function(){var n,r,s;for(s=[],n=0,r=e.length;r>n;n++)t=e[n],s.push(i._errorProcessing(e,y||i.options.dictResponseError.replace("{{statusCode}}",b.status),b));return s}}(this),F=function(i){return function(n){var r,s,o,l,a,u,p,d,c;if(null!=n)for(s=100*n.loaded/n.total,o=0,u=e.length;u>o;o++)t=e[o],t.upload={progress:s,total:n.total,bytesSent:n.loaded};else{for(r=!0,s=100,l=0,p=e.length;p>l;l++)t=e[l],(100!==t.upload.progress||t.upload.bytesSent!==t.upload.total)&&(r=!1),t.upload.progress=s,t.upload.bytesSent=t.upload.total;if(r)return}for(c=[],a=0,d=e.length;d>a;a++)t=e[a],c.push(i.emit("uploadprogress",t,s,t.upload.bytesSent));return c}}(this),b.onload=function(t){return function(n){var r;if(e[0].status!==i.CANCELED&&4===b.readyState){if(y=b.responseText,b.getResponseHeader("content-type")&&~b.getResponseHeader("content-type").indexOf("application/json"))try{y=JSON.parse(y)}catch(s){n=s,y="Invalid JSON response from server."}return F(),200<=(r=b.status)&&300>r?t._finished(e,y,n):o()}}}(this),b.onerror=function(t){return function(){return e[0].status!==i.CANCELED?o():void 0}}(this),v=null!=(_=b.upload)?_:b,v.onprogress=F,u={Accept:"application/json","Cache-Control":"no-cache","X-Requested-With":"XMLHttpRequest"},this.options.headers&&n(u,this.options.headers);for(l in u)a=u[l],b.setRequestHeader(l,a);if(s=new FormData,this.options.params){M=this.options.params;for(m in M)E=M[m],s.append(m,E)}for(k=0,T=e.length;T>k;k++)t=e[k],this.emit("sending",t,b,s);if(this.options.uploadMultiple&&this.emit("sendingmultiple",e,b,s),"FORM"===this.element.tagName)for(U=this.element.querySelectorAll("input, textarea, select, button"),z=0,A=U.length;A>z;z++)if(d=U[z],c=d.getAttribute("name"),h=d.getAttribute("type"),"SELECT"===d.tagName&&d.hasAttribute("multiple"))for(N=d.options,L=0,D=N.length;D>L;L++)g=N[L],g.selected&&s.append(c,g.value);else(!h||"checkbox"!==(I=h.toLowerCase())&&"radio"!==I||d.checked)&&s.append(c,d.value);for(p=S=0,R=e.length-1;R>=0?R>=S:S>=R;p=R>=0?++S:--S)s.append(this._getParamName(p),e[p],e[p].name);return b.send(s)},i.prototype._finished=function(e,t,n){var r,s,o;for(s=0,o=e.length;o>s;s++)r=e[s],r.status=i.SUCCESS,this.emit("success",r,t,n),this.emit("complete",r);return this.options.uploadMultiple&&(this.emit("successmultiple",e,t,n),this.emit("completemultiple",e)),this.options.autoProcessQueue?this.processQueue():void 0},i.prototype._errorProcessing=function(e,t,n){var r,s,o;for(s=0,o=e.length;o>s;s++)r=e[s],r.status=i.ERROR,this.emit("error",r,t,n),this.emit("complete",r);return this.options.uploadMultiple&&(this.emit("errormultiple",e,t,n),this.emit("completemultiple",e)),this.options.autoProcessQueue?this.processQueue():void 0},i}(t),e.version="4.0.1",e.options={},e.optionsForElement=function(t){return t.getAttribute("id")?e.options[i(t.getAttribute("id"))]:void 0},e.instances=[],e.forElement=function(e){if("string"==typeof e&&(e=document.querySelector(e)),null==(null!=e?e.dropzone:void 0))throw new Error("No Dropzone found for given element. This is probably because you're trying to access it before Dropzone had the time to initialize. Use the `init` option to setup any additional observers on your Dropzone.");return e.dropzone},e.autoDiscover=!0,e.discover=function(){var t,i,n,r,s,o;for(document.querySelectorAll?n=document.querySelectorAll(".dropzone"):(n=[],t=function(e){var t,i,r,s;for(s=[],i=0,r=e.length;r>i;i++)t=e[i],/(^| )dropzone($| )/.test(t.className)?s.push(n.push(t)):s.push(void 0);return s},t(document.getElementsByTagName("div")),t(document.getElementsByTagName("form"))),o=[],r=0,s=n.length;s>r;r++)i=n[r],e.optionsForElement(i)!==!1?o.push(new e(i)):o.push(void 0);return o},e.blacklistedBrowsers=[/opera.*Macintosh.*version\/12/i],e.isBrowserSupported=function(){var t,i,n,r,s;if(t=!0,window.File&&window.FileReader&&window.FileList&&window.Blob&&window.FormData&&document.querySelector)if("classList"in document.createElement("a"))for(s=e.blacklistedBrowsers,n=0,r=s.length;r>n;n++)i=s[n],i.test(navigator.userAgent)&&(t=!1);else t=!1;else t=!1;return t},l=function(e,t){var i,n,r,s;for(s=[],n=0,r=e.length;r>n;n++)i=e[n],i!==t&&s.push(i);return s},i=function(e){return e.replace(/[\-_](\w)/g,function(e){return e.charAt(1).toUpperCase()})},e.createElement=function(e){var t;return t=document.createElement("div"),t.innerHTML=e,t.childNodes[0]},e.elementInside=function(e,t){if(e===t)return!0;for(;e=e.parentNode;)if(e===t)return!0;return!1},e.getElement=function(e,t){var i;if("string"==typeof e?i=document.querySelector(e):null!=e.nodeType&&(i=e),null==i)throw new Error("Invalid `"+t+"` option provided. Please provide a CSS selector or a plain HTML element.");return i},e.getElements=function(e,t){var i,n,r,s,o,l,a,u;if(e instanceof Array){r=[];try{for(s=0,l=e.length;l>s;s++)n=e[s],r.push(this.getElement(n,t))}catch(p){i=p,r=null}}else if("string"==typeof e)for(r=[],u=document.querySelectorAll(e),o=0,a=u.length;a>o;o++)n=u[o],r.push(n);else null!=e.nodeType&&(r=[e]);if(null==r||!r.length)throw new Error("Invalid `"+t+"` option provided. Please provide a CSS selector, a plain HTML element or a list of those.");return r},e.confirm=function(e,t,i){return window.confirm(e)?t():null!=i?i():void 0},e.isValidFile=function(e,t){var i,n,r,s,o;if(!t)return!0;for(t=t.split(","),n=e.type,i=n.replace(/\/.*$/,""),s=0,o=t.length;o>s;s++)if(r=t[s],r=r.trim(),"."===r.charAt(0)){if(-1!==e.name.toLowerCase().indexOf(r.toLowerCase(),e.name.length-r.length))return!0}else if(/\/\*$/.test(r)){if(i===r.replace(/\/.*$/,""))return!0}else if(n===r)return!0;return!1},"undefined"!=typeof jQuery&&null!==jQuery&&(jQuery.fn.dropzone=function(t){return this.each(function(){return new e(this,t)})}),"undefined"!=typeof module&&null!==module?module.exports=e:window.Dropzone=e,e.ADDED="added",e.QUEUED="queued",e.ACCEPTED=e.QUEUED,e.UPLOADING="uploading",e.PROCESSING=e.UPLOADING,e.CANCELED="canceled",e.ERROR="error",e.SUCCESS="success",r=function(e){var t,i,n,r,s,o,l,a,u,p;for(l=e.naturalWidth,o=e.naturalHeight,i=document.createElement("canvas"),i.width=1,i.height=o,n=i.getContext("2d"),n.drawImage(e,0,0),r=n.getImageData(0,0,1,o).data,
p=0,s=o,a=o;a>p;)t=r[4*(a-1)+3],0===t?s=a:p=a,a=s+p>>1;return u=a/o,0===u?1:u},s=function(e,t,i,n,s,o,l,a,u,p){var d;return d=r(t),e.drawImage(t,i,n,s,o,l,a,u,p/d)},n=function(e,t){var i,n,r,s,o,l,a,u,p;if(r=!1,p=!0,n=e.document,u=n.documentElement,i=n.addEventListener?"addEventListener":"attachEvent",a=n.addEventListener?"removeEventListener":"detachEvent",l=n.addEventListener?"":"on",s=function(i){return"readystatechange"!==i.type||"complete"===n.readyState?(("load"===i.type?e:n)[a](l+i.type,s,!1),!r&&(r=!0)?t.call(e,i.type||i):void 0):void 0},o=function(){var e;try{u.doScroll("left")}catch(t){return e=t,void setTimeout(o,50)}return s("poll")},"complete"!==n.readyState){if(n.createEventObject&&u.doScroll){try{p=!e.frameElement}catch(d){}p&&o()}return n[i](l+"DOMContentLoaded",s,!1),n[i](l+"readystatechange",s,!1),e[i](l+"load",s,!1)}},e._autoDiscoverFunction=function(){return e.autoDiscover?e.discover():void 0},n(window,e._autoDiscoverFunction)}).call(this);
// custom select
(function(a){a.fn.extend({customSelect:function(c){if(typeof document.body.style.maxHeight==="undefined"){return this}var e={customClass:"customSelect",mapClass:true,mapStyle:true},c=a.extend(e,c),d=c.customClass,f=function(h,k){var g=h.find(":selected"),j=k.children(":first"),i=g.html()||"&nbsp;";j.html(i);if(g.attr("disabled")){k.addClass(b("DisabledOption"))}else{k.removeClass(b("DisabledOption"))}setTimeout(function(){k.removeClass(b("Open"));a(document).off("mouseup.customSelect")},60)},b=function(g){return d+g};return this.each(function(){var g=a(this),i=a("<span />").addClass(b("Inner")),h=a("<span />");g.after(h.append(i));h.addClass(d);if(c.mapClass){h.addClass(g.attr("class"))}if(c.mapStyle){h.attr("style",g.attr("style"))}g.addClass("hasCustomSelect").on("render.customSelect",function(){f(g,h);g.css("width","");var k=parseInt(g.outerWidth(),10)-(parseInt(h.outerWidth(),10)-parseInt(h.width(),10));h.css({display:"inline-block"});var j=h.outerHeight();if(g.attr("disabled")){h.addClass(b("Disabled"))}else{h.removeClass(b("Disabled"))}i.css({width:k,display:"inline-block"});g.css({"-webkit-appearance":"menulist-button",width:h.outerWidth(),position:"absolute",opacity:0,height:j,fontSize:h.css("font-size")})}).on("change.customSelect",function(){h.addClass(b("Changed"));f(g,h)}).on("keyup.customSelect",function(j){if(!h.hasClass(b("Open"))){g.trigger("blur.customSelect");g.trigger("focus.customSelect")}else{if(j.which==13||j.which==27){f(g,h)}}}).on("mousedown.customSelect",function(){h.removeClass(b("Changed"))}).on("mouseup.customSelect",function(j){if(!h.hasClass(b("Open"))){if(a("."+b("Open")).not(h).length>0&&typeof InstallTrigger!=="undefined"){g.trigger("focus.customSelect")}else{h.addClass(b("Open"));j.stopPropagation();a(document).one("mouseup.customSelect",function(k){if(k.target!=g.get(0)&&a.inArray(k.target,g.find("*").get())<0){g.trigger("blur.customSelect")}else{f(g,h)}})}}}).on("focus.customSelect",function(){h.removeClass(b("Changed")).addClass(b("Focus"))}).on("blur.customSelect",function(){h.removeClass(b("Focus")+" "+b("Open"))}).on("mouseenter.customSelect",function(){h.addClass(b("Hover"))}).on("mouseleave.customSelect",function(){h.removeClass(b("Hover"))}).trigger("render.customSelect")})}})})(jQuery);
// base64
jQuery.base64=(function($){var _PADCHAR="=",_ALPHA="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",_VERSION="1.0";function _getbyte64(s,i){var idx=_ALPHA.indexOf(s.charAt(i));if(idx===-1){throw"Cannot decode base64"}return idx}function _decode(s){var pads=0,i,b10,imax=s.length,x=[];s=String(s);if(imax===0){return s}if(imax%4!==0){throw"Cannot decode base64"}if(s.charAt(imax-1)===_PADCHAR){pads=1;if(s.charAt(imax-2)===_PADCHAR){pads=2}imax-=4}for(i=0;i<imax;i+=4){b10=(_getbyte64(s,i)<<18)|(_getbyte64(s,i+1)<<12)|(_getbyte64(s,i+2)<<6)|_getbyte64(s,i+3);x.push(String.fromCharCode(b10>>16,(b10>>8)&255,b10&255))}switch(pads){case 1:b10=(_getbyte64(s,i)<<18)|(_getbyte64(s,i+1)<<12)|(_getbyte64(s,i+2)<<6);x.push(String.fromCharCode(b10>>16,(b10>>8)&255));break;case 2:b10=(_getbyte64(s,i)<<18)|(_getbyte64(s,i+1)<<12);x.push(String.fromCharCode(b10>>16));break}return x.join("")}function _getbyte(s,i){var x=s.charCodeAt(i);if(x>255){throw"INVALID_CHARACTER_ERR: DOM Exception 5"}return x}function _encode(s){if(arguments.length!==1){throw"SyntaxError: exactly one argument required"}s=String(s);var i,b10,x=[],imax=s.length-s.length%3;if(s.length===0){return s}for(i=0;i<imax;i+=3){b10=(_getbyte(s,i)<<16)|(_getbyte(s,i+1)<<8)|_getbyte(s,i+2);x.push(_ALPHA.charAt(b10>>18));x.push(_ALPHA.charAt((b10>>12)&63));x.push(_ALPHA.charAt((b10>>6)&63));x.push(_ALPHA.charAt(b10&63))}switch(s.length-imax){case 1:b10=_getbyte(s,i)<<16;x.push(_ALPHA.charAt(b10>>18)+_ALPHA.charAt((b10>>12)&63)+_PADCHAR+_PADCHAR);break;case 2:b10=(_getbyte(s,i)<<16)|(_getbyte(s,i+1)<<8);x.push(_ALPHA.charAt(b10>>18)+_ALPHA.charAt((b10>>12)&63)+_ALPHA.charAt((b10>>6)&63)+_PADCHAR);break}return x.join("")}return{decode:_decode,encode:_encode,VERSION:_VERSION}}(jQuery));
/*!
jQuery UI Virtual Keyboard
Version 1.18.9 minified (MIT License)
Caret code modified from jquery.caret.1.02.js (MIT License)
*/
;(function(e){e.keyboard=function(b,m){var a=this,d;a.$el=e(b);a.el=b;a.$el.data("keyboard",a);a.init=function(){a.options=d=e.extend(!0,{},e.keyboard.defaultOptions,m);a.shiftActive=a.altActive=a.metaActive=a.sets=a.capsLock=!1;a.lastKeyset=[!1,!1,!1];a.rows=["","-shift","-alt","-alt-shift"];e('\x3c!--[if lte IE 8]><script>jQuery("body").addClass("oldie");\x3c/script><![endif]--\x3e\x3c!--[if IE]><script>jQuery("body").addClass("ie");\x3c/script><![endif]--\x3e').appendTo("body").remove();a.msie= e("body").hasClass("oldie");a.allie=e("body").hasClass("ie");a.inPlaceholder=a.$el.attr("placeholder")||"";a.watermark="undefined"!==typeof document.createElement("input").placeholder&&""!==a.inPlaceholder;a.regex=e.keyboard.comboRegex;a.decimal=/^\./.test(d.display.dec)?!0:!1;a.repeatTime=1E3/(d.repeatRate||20);d.preventDoubleEventTime=d.preventDoubleEventTime||100;a.isOpen=!1;a.wheel=e.isFunction(e.fn.mousewheel);a.alwaysAllowed=[20,33,34,35,36,37,38,39,40,45,46];a.$keyboard=[];a.temp=e('<input style="position:absolute;left:-9999em;top:-9999em;" type="text" value="testing">').appendTo("body").caret(3, 3);a.checkCaret=d.lockInput||3!==a.temp.hide().show().caret().start?!0:!1;a.temp.remove();a.lastCaret={start:0,end:0};a.temp=["",0,0];e.each("initialized beforeVisible visible hidden canceled accepted beforeClose".split(" "),function(h,c){e.isFunction(d[c])&&a.$el.bind(c+".keyboard",d[c])});d.alwaysOpen&&(d.stayOpen=!0);e(document).bind(["mousedown","keyup","touchstart","checkkeyboard",""].join(".keyboard "),function(d){a.opening||(a.escClose(d),d.target&&e(d.target).hasClass("ui-keyboard-input")&& (d=e(d.target).data("keyboard"),d===a&&d.options.openOn&&d.focusOn()))});a.$el.addClass("ui-keyboard-input "+d.css.input).attr({"aria-haspopup":"true",role:"textbox"});(a.$el.is(":disabled")||a.$el.attr("readonly")&&!a.$el.hasClass("ui-keyboard-lockedinput"))&&a.$el.addClass("ui-keyboard-nokeyboard");d.openOn&&a.$el.bind(d.openOn+".keyboard",function(){a.focusOn()});a.watermark||""!==a.$el.val()||""===a.inPlaceholder||""===a.$el.attr("placeholder")||a.$el.addClass("ui-keyboard-placeholder").val(a.inPlaceholder); a.$el.trigger("initialized.keyboard",[a,a.el]);d.alwaysOpen&&a.reveal()};a.setCurrent=function(){e(".ui-keyboard-has-focus").removeClass("ui-keyboard-has-focus");e(".ui-keyboard-input-current").removeClass("ui-keyboard-input-current");a.$el.addClass("ui-keyboard-input-current");a.$keyboard.addClass("ui-keyboard-has-focus");a.isCurrent(!0);a.isOpen=!0};a.isCurrent=function(d){var c=e.keyboard.currentKeyboard||!1;d?c=e.keyboard.currentKeyboard=a.el:!1===d&&c===a.el&&(c=e.keyboard.currentKeyboard=""); return c===a.el};a.isVisible=function(){return a.$keyboard&&a.$keyboard.length?a.$keyboard.is(":visible"):!1};a.focusOn=function(){a.$el.is(":visible")&&setTimeout(function(){a.lastCaret=a.$el.caret()},20);a.isVisible()||(clearTimeout(a.timer),a.reveal());d.alwaysOpen&&a.setCurrent()};a.reveal=function(){var h;a.opening=!0;e(".ui-keyboard").not(".ui-keyboard-always-open").remove();if(a.$el.is(":disabled")||a.$el.attr("readonly")&&!a.$el.hasClass("ui-keyboard-lockedinput"))a.$el.addClass("ui-keyboard-nokeyboard"); else return a.$el.removeClass("ui-keyboard-nokeyboard"),d.openOn&&a.$el.unbind(d.openOn+".keyboard"),a.$keyboard&&(!a.$keyboard||a.$keyboard.length&&!e.contains(document.body,a.$keyboard[0]))||a.startup(),a.watermark||a.el.value!==a.inPlaceholder||a.$el.removeClass("ui-keyboard-placeholder").val(""),a.originalContent=a.$el.val(),a.$preview.val(a.originalContent),d.acceptValid&&a.checkValid(),d.resetDefault&&(a.shiftActive=a.altActive=a.metaActive=!1,a.showKeySet()),d.appendLocally||"body"!==d.appendTo|| a.$keyboard.css({position:"absolute",left:0,top:0}),a.$el.trigger("beforeVisible.keyboard",[a,a.el]),a.setCurrent(),a.$keyboard.show(),d.usePreview&&a.msie&&("undefined"===typeof a.width&&(a.$preview.hide(),a.width=Math.ceil(a.$keyboard.width()),a.$preview.show()),a.$preview.width(a.width)),a.position=d.position,e.ui&&e.ui.position&&!e.isEmptyObject(a.position)&&(a.position.of=a.position.of||a.$el.data("keyboardPosition")||a.$el,a.position.collision=a.position.collision||"flipfit flipfit",a.$keyboard.position(a.position)), a.checkDecimal(),a.lineHeight=parseInt(a.$preview.css("lineHeight"),10)||parseInt(a.$preview.css("font-size"),10)+4,d.caretToEnd&&(h=a.originalContent.length,a.lastCaret={start:h,end:h}),a.allie&&(h=a.lastCaret.start||a.originalContent.length,h={start:h,end:h},a.lastCaret||(a.lastCaret=h),0===a.lastCaret.end&&0<a.lastCaret.start&&(a.lastCaret.end=a.lastCaret.start),0>a.lastCaret.start&&(a.lastCaret=h)),setTimeout(function(){a.opening=!1;d.initialFocus&&a.$preview.focus().caret(a.lastCaret);a.$el.trigger("visible.keyboard", [a,a.el])},10),a};a.startup=function(){a.$keyboard&&a.$keyboard.length||("custom"===d.layout&&(d.layoutHash="custom"+a.customHash()),a.layout="custom"===d.layout?d.layoutHash:d.layout,"undefined"===typeof e.keyboard.builtLayouts[a.layout]&&(e.isFunction(d.create)&&d.create(a),a.$keyboard.length||a.buildKeyboard()),a.$keyboard=e.keyboard.builtLayouts[a.layout].$keyboard.clone(),d.usePreview?(a.$preview=a.$el.clone(!1).removeAttr("id").removeClass("ui-keyboard-placeholder ui-keyboard-input").addClass("ui-keyboard-preview "+ d.css.input).attr("tabindex","-1").show(),e("<div />").addClass("ui-keyboard-preview-wrapper").append(a.$preview).prependTo(a.$keyboard)):(a.$preview=a.$el,e.isEmptyObject(a.position)||(d.position.at=d.position.at2)));a.preview=a.$preview[0];a.$decBtn=a.$keyboard.find(".ui-keyboard-dec");(d.enterNavigation||"TEXTAREA"===a.el.tagName)&&a.alwaysAllowed.push(13);d.lockInput&&a.$preview.addClass("ui-keyboard-lockedinput").attr({readonly:"readonly"});a.bindKeyboard();a.$keyboard.appendTo(d.appendLocally? a.$el.parent():d.appendTo||"body");a.bindKeys();e.ui&&e.ui.position&&!e.isEmptyObject(a.position)&&e(window).bind("resize.keyboard",function(){a.isVisible()&&a.$keyboard.position(a.position)})};a.bindKeyboard=function(){var h=e.keyboard.builtLayouts[a.layout];a.$preview.unbind("keypress keyup keydown mouseup touchend ".split(" ").join(".keyboard ")).bind("keypress.keyboard",function(c){var g=a.lastKey=String.fromCharCode(c.charCode||c.which);a.$lastKey=[];a.checkCaret&&(a.lastCaret=a.$preview.caret()); a.capsLock=65<=g&&90>=g&&!c.shiftKey||97<=g&&122>=g&&c.shiftKey?!0:!1;if(d.restrictInput){if((8===c.which||0===c.which)&&e.inArray(c.keyCode,a.alwaysAllowed))return;-1===e.inArray(g,h.acceptedKeys)&&c.preventDefault()}else if((c.ctrlKey||c.metaKey)&&(97===c.which||99===c.which||118===c.which||120<=c.which&&122>=c.which))return;h.hasMappedKeys&&h.mappedKeys.hasOwnProperty(g)&&(a.lastKey=h.mappedKeys[g],a.insertText(a.lastKey),c.preventDefault());a.checkMaxLength()}).bind("keyup.keyboard",function(c){switch(c.which){case 9:if(a.tab&& d.tabNavigation&&!d.lockInput){if(a.shiftActive=c.shiftKey,c=e.keyboard.keyaction.tab(a),a.tab=!1,!c)return!1}else c.preventDefault();break;case 27:return a.close(),!1}clearTimeout(a.throttled);a.throttled=setTimeout(function(){a.isVisible()&&a.checkCombos()},100);a.checkMaxLength();e.isFunction(d.change)&&d.change(e.Event("change"),a,a.el);a.$el.trigger("change.keyboard",[a,a.el])}).bind("keydown.keyboard",function(c){switch(c.which){case 8:e.keyboard.keyaction.bksp(a,null,c);c.preventDefault(); break;case 9:return a.tab=!0,!1;case 13:e.keyboard.keyaction.enter(a,null,c);break;case 20:a.shiftActive=a.capsLock=!a.capsLock;a.showKeySet(this);break;case 86:if(c.ctrlKey||c.metaKey){if(d.preventPaste){c.preventDefault();break}a.checkCombos()}}}).bind("mouseup.keyboard touchend.keyboard",function(){a.checkCaret&&(a.lastCaret=a.$preview.caret())});a.$keyboard.bind("mousedown.keyboard click.keyboard touchstart.keyboard",function(c){c.stopPropagation();a.isCurrent()||(a.reveal(),e(document).trigger("checkkeyboard.keyboard"))}); d.preventPaste&&(a.$preview.bind("contextmenu.keyboard",function(a){a.preventDefault()}),a.$el.bind("contextmenu.keyboard",function(a){a.preventDefault()}))};a.bindKeys=function(){var h=(d.keyBinding+" repeater mouseenter mouseleave touchstart mousewheel mouseup click ").split(" ").join(".keyboard ")+"mouseleave.kb mousedown.kb touchstart.kb touchend.kb touchmove.kb touchcancel.kb ";a.$allKeys=a.$keyboard.find("button.ui-keyboard-button").unbind(h).bind(d.keyBinding.split(" ").join(".keyboard ")+ ".keyboard repeater.keyboard",function(c){if(!a.$keyboard.is(":visible"))return!1;var g;g=e(this);var h=g.attr("data-action"),b=(new Date).getTime(),h=":"===h?":":h.split(":")[0];if(!(b-(a.lastEventTime||0)<d.preventDoubleEventTime)){a.lastEventTime=b;a.$preview.focus();a.$lastKey=g;a.lastKey=g.attr("data-curtxt");a.checkCaret&&a.$preview.caret(a.lastCaret);h.match("meta")&&(h="meta");if(e.keyboard.keyaction.hasOwnProperty(h)&&e(this).hasClass("ui-keyboard-actionkey")){if(!1===e.keyboard.keyaction[h](a, this,c))return!1}else"undefined"!==typeof h&&(g=a.lastKey=a.wheel&&!e(this).hasClass("ui-keyboard-actionkey")?a.lastKey:h,a.insertText(g),a.capsLock||d.stickyShift||c.shiftKey||(a.shiftActive=!1,a.showKeySet(this)));a.$preview.focus().caret(a.lastCaret);a.checkCombos();a.checkMaxLength();e.isFunction(d.change)&&d.change(e.Event("change"),a,a.el);a.$el.trigger("change.keyboard",[a,a.el]);c.preventDefault()}}).bind("mouseenter.keyboard mouseleave.keyboard touchstart.keyboard",function(c){if(a.isCurrent()){var h= e(this),b=h.data("layers")||a.getLayers(h);h.data("layers",b=e.grep(b,function(a,c){return e.inArray(a,b)===c}));"mouseenter"!==c.type&&"touchstart"!==c.type||"password"===a.el.type||h.hasClass(d.css.buttonDisabled)||h.addClass(d.css.buttonHover).attr("title",function(h,e){return a.wheel&&""===e&&a.sets&&1<b.length&&"touchstart"!==c.type?d.wheelMessage:e});"mouseleave"===c.type&&(h.data({curtxt:h.data("original"),curnum:0}),h.removeClass("password"===a.el.type?"":d.css.buttonHover).attr("title",function(a, c){return c===d.wheelMessage?"":c}).find("span").html(h.data("original")))}}).bind("mousewheel.keyboard",function(c,d){if(a.wheel){var h,b,f=e(this);b=f.data("layers")||a.getLayers(f);1<b.length?(h=f.data("curnum")+(0<d)?-1:1,h>b.length-1&&(h=0),0>h&&(h=b.length-1)):h=0;f.data({curnum:h,layers:b,curtxt:b[h]});f.find("span").html(b[h]);return!1}}).bind("mouseup.keyboard mouseleave.kb touchend.kb touchmove.kb touchcancel.kb",function(c){/(mouseleave|touchend|touchcancel)/.test(c.type)?e(this).removeClass(d.css.buttonHover): (a.isVisible()&&a.isCurrent()&&a.$preview.focus(),a.checkCaret&&a.$preview.caret(a.lastCaret));a.mouseRepeat=[!1,""];clearTimeout(a.repeater);return!1}).bind("click.keyboard",function(){return!1}).not(".ui-keyboard-actionkey").add(".ui-keyboard-tab, .ui-keyboard-bksp, .ui-keyboard-space, .ui-keyboard-enter",a.$keyboard).bind("mousedown.kb touchstart.kb",function(){if(0!==d.repeatRate){var c=e(this);a.mouseRepeat=[!0,c];setTimeout(function(){a.mouseRepeat[0]&&a.mouseRepeat[1]===c&&a.repeatKey(c)}, d.repeatDelay)}return!1})};a.insertText=function(d){var c,b;b=a.$preview.val();var e=a.$preview.caret(),k=a.$preview.scrollLeft();c=a.$preview.scrollTop();var f=b.length;e.end<e.start&&(e.end=e.start);e.start>f&&(e.end=e.start=f);"TEXTAREA"===a.preview.tagName&&(a.msie&&"\n"===b.substr(e.start,1)&&(e.start+=1,e.end+=1),b=b.split("\n").length-1,a.preview.scrollTop=0<b?a.lineHeight*b:c);c="bksp"===d&&e.start===e.end?!0:!1;d="bksp"===d?"":d;b=e.start+(c?-1:d.length);k+=parseInt(a.$preview.css("fontSize"), 10)*("bksp"===d?-1:1);a.$preview.val(a.$preview.val().substr(0,e.start-(c?1:0))+d+a.$preview.val().substr(e.end)).scrollLeft(k).caret(b,b);a.lastCaret={start:b,end:b}};a.checkMaxLength=function(){var h,c=a.$preview.val();!1!==d.maxLength&&c.length>d.maxLength&&(h=Math.min(a.$preview.caret().start,d.maxLength),a.$preview.val(c.substring(0,d.maxLength)),a.$preview.caret(h,h),a.lastCaret={start:h,end:h});a.$decBtn.length&&a.checkDecimal()};a.repeatKey=function(d){d.trigger("repeater.keyboard");a.mouseRepeat[0]&& (a.repeater=setTimeout(function(){a.repeatKey(d)},a.repeatTime))};a.showKeySet=function(b){var c="",e=(a.shiftActive?1:0)+(a.altActive?2:0);a.shiftActive||(a.capsLock=!1);if(a.metaActive){if(c=b&&b.name&&/meta/.test(b.name)?b.name:"",""===c?c=!0===a.metaActive?"":a.metaActive:a.metaActive=c,!d.stickyShift&&a.lastKeyset[2]!==a.metaActive||(a.shiftActive||a.altActive)&&!a.$keyboard.find(".ui-keyboard-keyset-"+c+a.rows[e]).length)a.shiftActive=a.altActive=!1}else!d.stickyShift&&a.lastKeyset[2]!==a.metaActive&& a.shiftActive&&(a.shiftActive=a.altActive=!1);e=(a.shiftActive?1:0)+(a.altActive?2:0);c=0!==e||a.metaActive?""===c?"":"-"+c:"-default";a.$keyboard.find(".ui-keyboard-keyset"+c+a.rows[e]).length?(a.$keyboard.find(".ui-keyboard-alt, .ui-keyboard-shift, .ui-keyboard-actionkey[class*=meta]").removeClass(d.css.buttonAction).end().find(".ui-keyboard-alt")[a.altActive?"addClass":"removeClass"](d.css.buttonAction).end().find(".ui-keyboard-shift")[a.shiftActive?"addClass":"removeClass"](d.css.buttonAction).end().find(".ui-keyboard-lock")[a.capsLock? "addClass":"removeClass"](d.css.buttonAction).end().find(".ui-keyboard-keyset").hide().end().find(".ui-keyboard-keyset"+c+a.rows[e]).show().end().find(".ui-keyboard-actionkey.ui-keyboard"+c).addClass(d.css.buttonAction),a.lastKeyset=[a.shiftActive,a.altActive,a.metaActive]):(a.shiftActive=a.lastKeyset[0],a.altActive=a.lastKeyset[1],a.metaActive=a.lastKeyset[2])};a.checkCombos=function(){if(!a.isVisible())return a.$preview.val();var b,c,g,l,k=a.$preview.val(),f=a.$preview.caret(),m=e.keyboard.builtLayouts[a.layout], p=k.length;f.end<f.start&&(f.end=f.start);f.start>p&&(f.end=f.start=p);a.msie&&"\n"===k.substr(f.start,1)&&(f.start+=1,f.end+=1);d.useCombos&&(a.msie?k=k.replace(a.regex,function(a,c,b){return d.combos.hasOwnProperty(c)?d.combos[c][b]||a:a}):a.$preview.length&&(g=f.start-(0<=f.start-2?2:0),a.$preview.caret(g,f.end),l=(a.$preview.caret().text||"").replace(a.regex,function(a,c,b){return d.combos.hasOwnProperty(c)?d.combos[c][b]||a:a}),a.$preview.val(a.$preview.caret().replace(l)),k=a.$preview.val())); if(d.restrictInput&&""!==k){g=k;c=m.acceptedKeys.length;for(b=0;b<c;b++)""!==g&&(l=m.acceptedKeys[b],0<=k.indexOf(l)&&(/[\[|\]|\\|\^|\$|\.|\||\?|\*|\+|\(|\)|\{|\}]/g.test(l)&&(l="\\"+l),g=g.replace(new RegExp(l,"g"),"")));""!==g&&(k=k.replace(g,""))}f.start+=k.length-p;f.end+=k.length-p;a.$preview.val(k);a.$preview.caret(f.start,f.end);a.preview.scrollTop=a.lineHeight*(k.substring(0,f.start).split("\n").length-1);a.lastCaret={start:f.start,end:f.end};d.acceptValid&&a.checkValid();return k};a.checkValid= function(){var b=!0;d.validate&&"function"===typeof d.validate&&(b=d.validate(a,a.$preview.val(),!1));a.$keyboard.find(".ui-keyboard-accept")[b?"removeClass":"addClass"]("ui-keyboard-invalid-input")[b?"addClass":"removeClass"]("ui-keyboard-valid-input")};a.checkDecimal=function(){a.decimal&&/\./g.test(a.preview.value)||!a.decimal&&/\,/g.test(a.preview.value)?a.$decBtn.attr({disabled:"disabled","aria-disabled":"true"}).removeClass(d.css.buttonDefault+" "+d.css.buttonHover).addClass(d.css.buttonDisabled): a.$decBtn.removeAttr("disabled").attr({"aria-disabled":"false"}).addClass(d.css.buttonDefault).removeClass(d.css.buttonDisabled)};a.getLayers=function(a){var c;c=a.attr("data-pos");return a.closest(".ui-keyboard").find('button[data-pos="'+c+'"]').map(function(){return e(this).find("> span").html()}).get()};a.switchInput=function(b,c){if("function"===typeof d.switchInput)d.switchInput(a,b,c);else{a.$keyboard.hide();var g;g=!1;var l=e("button, input, textarea, a").filter(":visible"),k=l.index(a.$el)+ (b?1:-1);a.$keyboard.show();k>l.length-1&&(g=d.stopAtEnd,k=0);0>k&&(g=d.stopAtEnd,k=l.length-1);if(!g){c=a.close(c);if(!c)return;(g=l.eq(k).data("keyboard"))&&g.options.openOn.length?g.focusOn():l.eq(k).focus()}}return!1};a.close=function(b){if(a.isOpen){clearTimeout(a.throttled);var c=b?a.checkCombos():a.originalContent;if(b&&d.validate&&"function"===typeof d.validate&&!d.validate(a,c,!0)&&(c=a.originalContent,b=!1,d.cancelClose))return;a.isCurrent(!1);a.isOpen=!1;a.$preview.val(c);a.$el.removeClass("ui-keyboard-input-current ui-keyboard-autoaccepted").addClass(b? !0===b?"":"ui-keyboard-autoaccepted":"").trigger(d.alwaysOpen?"":"beforeClose.keyboard",[a,a.el,b||!1]).val(c).scrollTop(a.el.scrollHeight).trigger(b?"accepted.keyboard":"canceled.keyboard",[a,a.el]).trigger(d.alwaysOpen?"inactive.keyboard":"hidden.keyboard",[a,a.el]).blur();d.openOn&&(a.timer=setTimeout(function(){a.$el.bind(d.openOn+".keyboard",function(){a.focusOn()});e(":focus")[0]===a.el&&a.$el.blur()},500));!d.alwaysOpen&&a.$keyboard&&(a.$keyboard.remove(),a.$keyboard=[]);a.watermark||""!== a.el.value||""===a.inPlaceholder||a.$el.addClass("ui-keyboard-placeholder").val(a.inPlaceholder);a.$el.trigger("change")}return!!b};a.accept=function(){return a.close(!0)};a.escClose=function(b){if(b&&"keyup"===b.type)return 27===b.which?a.close():"";a.isOpen&&(!a.isCurrent()&&a.isOpen||a.isOpen&&b.target!==a.el&&!d.stayOpen)&&(a.allie&&b.preventDefault(),a.close(d.autoAccept?"true":!1))};a.keyBtn=e("<button />").attr({role:"button",type:"button","aria-disabled":"false",tabindex:"-1"}).addClass("ui-keyboard-button"); a.addKey=function(b,c,g){var l,k,f;c=!0===g?b:d.display[c]||b;var m=!0===g?b.charCodeAt(0):b;/\(.+\)/.test(c)&&(k=c.replace(/\(([^()]+)\)/,""),l=c.match(/\(([^()]+)\)/)[1],c=k,f=k.split(":"),k=""!==f[0]&&1<f.length?f[0]:k,e.keyboard.builtLayouts[a.layout].mappedKeys[l]=k);f=c.split(":");""===f[0]&&""===f[1]&&(c=":");c=""!==f[0]&&1<f.length?e.trim(f[0]):c;l=1<f.length?e.trim(f[1]).replace(/_/g," ")||"":"";k=1<c.length?" ui-keyboard-widekey":"";k+=g?"":" ui-keyboard-actionkey";return a.keyBtn.clone().attr({"data-value":c, name:m,"data-pos":a.temp[1]+","+a.temp[2],title:l,"data-action":b,"data-original":c,"data-curtxt":c,"data-curnum":0}).addClass((""===m?"":"ui-keyboard-"+m+k+" ")+d.css.buttonDefault).html("<span>"+c+"</span>").appendTo(a.temp[0])};a.customHash=function(){var a,c,b;c=d.customLayout;b=[];var e=[];for(a in c)c.hasOwnProperty(a)&&b.push(c[a]);e=e.concat.apply(e,b).join(" ");if(Array.prototype.reduce)return e.split("").reduce(function(a,c){a=(a<<5)-a+c.charCodeAt(0);return a&a},0);c=0;if(0===e.length)return c; for(a=0;a<e.length;a++)b=e.charCodeAt(a),c=(c<<5)-c+b,c&=c;return c};a.buildKeyboard=function(){var b,c,g,m,k,f,n,p,q,s=0,r=e.keyboard.builtLayouts[a.layout]={mappedKeys:{},acceptedKeys:[]},t=r.acceptedKeys=[],u=e("<div />").addClass("ui-keyboard "+d.css.container+(d.alwaysOpen?" ui-keyboard-always-open":"")).attr({role:"textbox"}).hide();"custom"!==d.layout&&e.keyboard.layouts.hasOwnProperty(d.layout)||(d.layout="custom",e.keyboard.layouts.custom=d.customLayout||{"default":["{cancel}"]});e.each(e.keyboard.layouts[d.layout], function(r,v){if(""!==r)for(s++,m=e("<div />").attr("name",r).addClass("ui-keyboard-keyset ui-keyboard-keyset-"+r).appendTo(u)["default"===r?"show":"hide"](),g=0;g<v.length;g++){f=e.trim(v[g]).replace(/\{(\.?)[\s+]?:[\s+]?(\.?)\}/g,"{$1:$2}");p=f.split(/\s+/);for(n=0;n<p.length;n++)if(a.temp=[m,g,n],k=!1,0!==p[n].length)if(/^\{\S+\}$/.test(p[n]))if(c=p[n].match(/^\{(\S+)\}$/)[1].toLowerCase(),/\!\!/.test(c)&&(c=c.replace("!!",""),k=!0),/^sp:((\d+)?([\.|,]\d+)?)(em|px)?$/.test(c)&&(q=parseFloat(c.replace(/,/, ".").match(/^sp:((\d+)?([\.|,]\d+)?)(em|px)?$/)[1]||0),e("<span>&nbsp;</span>").width(c.match("px")?q+"px":2*q+"em").addClass("ui-keyboard-button ui-keyboard-spacer").appendTo(m)),/^empty(:((\d+)?([\.|,]\d+)?)(em|px)?)?$/.test(c)&&(q=/:/.test(c)?parseFloat(c.replace(/,/,".").match(/^empty:((\d+)?([\.|,]\d+)?)(em|px)?$/)[1]||0):"",a.addKey(""," ").addClass(d.css.buttonDisabled+" "+d.css.buttonEmpty).attr("aria-disabled",!0).width(q?c.match("px")?q+"px":2*q+"em":"")),/^meta\d+\:?(\w+)?/.test(c))a.addKey(c, c);else switch(c){case "a":case "accept":a.addKey("accept",c).addClass(d.css.buttonAction);break;case "alt":case "altgr":a.addKey("alt","alt");break;case "b":case "bksp":a.addKey("bksp",c);break;case "c":case "cancel":a.addKey("cancel",c).addClass(d.css.buttonAction);break;case "combo":a.addKey("combo","combo").addClass(d.css.buttonAction);break;case "dec":t.push(a.decimal?".":",");a.addKey("dec","dec");break;case "e":case "enter":a.addKey("enter",c).addClass(d.css.buttonAction);break;case "s":case "shift":a.addKey("shift", c);break;case "sign":t.push("-");a.addKey("sign","sign");break;case "space":t.push(" ");a.addKey("space","space");break;case "t":case "tab":a.addKey("tab",c);break;default:if(e.keyboard.keyaction.hasOwnProperty(c))a.addKey(c,c)[k?"addClass":"removeClass"](d.css.buttonAction)}else b=p[n],t.push(":"===b?b:b.split(":")[0]),a.addKey(b,b,!0);m.find(".ui-keyboard-button:last").after('<br class="ui-keyboard-button-endrow">')}});1<s&&(a.sets=!0);r.hasMappedKeys=!e.isEmptyObject(r.mappedKeys);return r.$keyboard= u};a.destroy=function(){e(document).unbind("mousedown.keyboard keyup.keyboard touchstart.keyboard");a.$keyboard.length&&a.$keyboard.remove();var b=e.trim(d.openOn+" accepted beforeClose canceled change contextmenu hidden initialized keydown keypress keyup visible ").split(" ").join(".keyboard ");a.$el.removeClass("ui-keyboard-input ui-keyboard-lockedinput ui-keyboard-placeholder ui-keyboard-notallowed ui-keyboard-always-open "+d.css.input).removeAttr("aria-haspopup").removeAttr("role").unbind(b+".keyboard").removeData("keyboard")}; a.init()};e.keyboard.keyaction={accept:function(b){b.close(!0);return!1},alt:function(b,e){b.altActive=!b.altActive;b.showKeySet(e)},bksp:function(b){b.insertText("bksp")},cancel:function(b){b.close();return!1},clear:function(b){b.$preview.val("")},combo:function(b){var e=!b.options.useCombos;b.options.useCombos=e;b.$keyboard.find(".ui-keyboard-combo").toggleClass(b.options.css.buttonAction,e);e&&b.checkCombos();return!1},dec:function(b){b.insertText(b.decimal?".":",")},"default":function(b,e){b.shiftActive= b.altActive=b.metaActive=!1;b.showKeySet(e)},enter:function(b,m,a){m=b.el.tagName;var d=b.options;if(a.shiftKey)return d.enterNavigation?b.switchInput(!a[d.enterMod],!0):b.close(!0);if(d.enterNavigation&&("TEXTAREA"!==m||a[d.enterMod]))return b.switchInput(!a[d.enterMod],d.autoAccept?"true":!1);"TEXTAREA"===m&&e(a.target).closest("button").length&&b.insertText(" \n")},lock:function(b,e){b.lastKeyset[0]=b.shiftActive=b.capsLock=!b.capsLock;b.showKeySet(e)},left:function(b){var e=b.$preview.caret(); 0<=e.start-1&&(b.lastCaret={start:e.start-1,end:e.start-1})},meta:function(b,m){b.metaActive=e(m).hasClass(b.options.css.buttonAction)?!1:!0;b.showKeySet(m)},next:function(b){b.switchInput(!0,b.options.autoAccept);return!1},prev:function(b){b.switchInput(!1,b.options.autoAccept);return!1},right:function(b){var e=b.$preview.caret();e.start+1<=b.$preview.val().length&&(b.lastCaret={start:e.start+1,end:e.start+1})},shift:function(b,e){b.lastKeyset[0]=b.shiftActive=!b.shiftActive;b.showKeySet(e)},sign:function(b){/^\-?\d*\.?\d*$/.test(b.$preview.val())&& b.$preview.val(-1*b.$preview.val())},space:function(b){b.insertText(" ")},tab:function(b){var e=b.options;if("INPUT"===b.el.tagName)return e.tabNavigation?b.switchInput(!b.shiftActive,!0):!1;b.insertText("\t")}};e.keyboard.builtLayouts={};e.keyboard.layouts={alpha:{"default":["` 1 2 3 4 5 6 7 8 9 0 - = {bksp}","{tab} a b c d e f g h i j [ ] \\","k l m n o p q r s ; ' {enter}","{shift} t u v w x y z , . / {shift}","{accept} {space} {cancel}"],shift:["~ ! @ # $ % ^ & * ( ) _ + {bksp}","{tab} A B C D E F G H I J { } |", 'K L M N O P Q R S : " {enter}',"{shift} T U V W X Y Z < > ? {shift}","{accept} {space} {cancel}"]},qwerty:{"default":["` 1 2 3 4 5 6 7 8 9 0 - = {bksp}","{tab} q w e r t y u i o p [ ] \\","a s d f g h j k l ; ' {enter}","{shift} z x c v b n m , . / {shift}","{accept} {space} {cancel}"],shift:["~ ! @ # $ % ^ & * ( ) _ + {bksp}","{tab} Q W E R T Y U I O P { } |",'A S D F G H J K L : " {enter}',"{shift} Z X C V B N M < > ? {shift}","{accept} {space} {cancel}"]},international:{"default":["` 1 2 3 4 5 6 7 8 9 0 - = {bksp}", "{tab} q w e r t y u i o p [ ] \\","a s d f g h j k l ; ' {enter}","{shift} z x c v b n m , . / {shift}","{accept} {alt} {space} {alt} {cancel}"],shift:["~ ! @ # $ % ^ & * ( ) _ + {bksp}","{tab} Q W E R T Y U I O P { } |",'A S D F G H J K L : " {enter}',"{shift} Z X C V B N M < > ? {shift}","{accept} {alt} {space} {alt} {cancel}"],alt:["~ \u00a1 \u00b2 \u00b3 \u00a4 \u20ac \u00bc \u00bd \u00be \u2018 \u2019 \u00a5 \u00d7 {bksp}","{tab} \u00e4 \u00e5 \u00e9 \u00ae \u00fe \u00fc \u00fa \u00ed \u00f3 \u00f6 \u00ab \u00bb \u00ac", "\u00e1 \u00df \u00f0 f g h j k \u00f8 \u00b6 \u00b4 {enter}","{shift} \u00e6 x \u00a9 v b \u00f1 \u00b5 \u00e7 > \u00bf {shift}","{accept} {alt} {space} {alt} {cancel}"],"alt-shift":["~ \u00b9 \u00b2 \u00b3 \u00a3 \u20ac \u00bc \u00bd \u00be \u2018 \u2019 \u00a5 \u00f7 {bksp}","{tab} \u00c4 \u00c5 \u00c9 \u00ae \u00de \u00dc \u00da \u00cd \u00d3 \u00d6 \u00ab \u00bb \u00a6","\u00c4 \u00a7 \u00d0 F G H J K \u00d8 \u00b0 \u00a8 {enter}","{shift} \u00c6 X \u00a2 V B \u00d1 \u00b5 \u00c7 . \u00bf {shift}", "{accept} {alt} {space} {alt} {cancel}"]},colemak:{"default":["` 1 2 3 4 5 6 7 8 9 0 - = {bksp}","{tab} q w f p g j l u y ; [ ] \\","{bksp} a r s t d h n e i o ' {enter}","{shift} z x c v b k m , . / {shift}","{accept} {space} {cancel}"],shift:["~ ! @ # $ % ^ & * ( ) _ + {bksp}","{tab} Q W F P G J L U Y : { } |",'{bksp} A R S T D H N E I O " {enter}',"{shift} Z X C V B K M < > ? {shift}","{accept} {space} {cancel}"]},dvorak:{"default":["` 1 2 3 4 5 6 7 8 9 0 [ ] {bksp}","{tab} ' , . p y f g c r l / = \\", "a o e u i d h t n s - {enter}","{shift} ; q j k x b m w v z {shift}","{accept} {space} {cancel}"],shift:["~ ! @ # $ % ^ & * ( ) { } {bksp}",'{tab} " < > P Y F G C R L ? + |',"A O E U I D H T N S _ {enter}","{shift} : Q J K X B M W V Z {shift}","{accept} {space} {cancel}"]},num:{"default":"= ( ) {b};{clear} / * -;7 8 9 +;4 5 6 {sign};1 2 3 %;0 . {a} {c}".split(";")}};e.keyboard.defaultOptions={layout:"qwerty",customLayout:null,position:{of:null,my:"center top",at:"center top",at2:"center bottom"}, usePreview:!0,alwaysOpen:!1,initialFocus:!0,stayOpen:!1,display:{a:"\u2714:Accept (Shift-Enter)",accept:"Accept:Accept (Shift-Enter)",alt:"Alt:\u2325 AltGr",b:"\u232b:Backspace",bksp:"Bksp:Backspace",c:"\u2716:Cancel (Esc)",cancel:"Cancel:Cancel (Esc)",clear:"C:Clear",combo:"\u00f6:Toggle Combo Keys",dec:".:Decimal",e:"\u23ce:Enter",empty:"\u00a0",enter:"Enter:Enter \u23ce",left:"\u2190",lock:"Lock:\u21ea Caps Lock",next:"Next \u21e8",prev:"\u21e6 Prev",right:"\u2192",s:"\u21e7:Shift",shift:"Shift:Shift", sign:"\u00b1:Change Sign",space:"&nbsp;:Space",t:"\u21e5:Tab",tab:"\u21e5 Tab:Tab"},wheelMessage:"Use mousewheel to see other keys",css:{input:"ui-widget-content ui-corner-all",container:"ui-widget-content ui-widget ui-corner-all ui-helper-clearfix",buttonDefault:"ui-state-default ui-corner-all",buttonHover:"ui-state-hover",buttonAction:"ui-state-active",buttonDisabled:"ui-state-disabled",buttonEmpty:"ui-keyboard-empty"},autoAccept:!1,lockInput:!1,restrictInput:!1,acceptValid:!1,cancelClose:!0,tabNavigation:!1, enterNavigation:!1,enterMod:"altKey",stopAtEnd:!0,appendLocally:!1,appendTo:"body",stickyShift:!0,preventPaste:!1,caretToEnd:!1,maxLength:!1,repeatDelay:500,repeatRate:20,resetDefault:!1,openOn:"focus",keyBinding:"mousedown touchstart",useCombos:!0,combos:{"`":{a:"\u00e0",A:"\u00c0",e:"\u00e8",E:"\u00c8",i:"\u00ec",I:"\u00cc",o:"\u00f2",O:"\u00d2",u:"\u00f9",U:"\u00d9",y:"\u1ef3",Y:"\u1ef2"},"'":{a:"\u00e1",A:"\u00c1",e:"\u00e9",E:"\u00c9",i:"\u00ed",I:"\u00cd",o:"\u00f3",O:"\u00d3",u:"\u00fa",U:"\u00da", y:"\u00fd",Y:"\u00dd"},'"':{a:"\u00e4",A:"\u00c4",e:"\u00eb",E:"\u00cb",i:"\u00ef",I:"\u00cf",o:"\u00f6",O:"\u00d6",u:"\u00fc",U:"\u00dc",y:"\u00ff",Y:"\u0178"},"^":{a:"\u00e2",A:"\u00c2",e:"\u00ea",E:"\u00ca",i:"\u00ee",I:"\u00ce",o:"\u00f4",O:"\u00d4",u:"\u00fb",U:"\u00db",y:"\u0177",Y:"\u0176"},"~":{a:"\u00e3",A:"\u00c3",e:"\u1ebd",E:"\u1ebc",i:"\u0129",I:"\u0128",o:"\u00f5",O:"\u00d5",u:"\u0169",U:"\u0168",y:"\u1ef9",Y:"\u1ef8",n:"\u00f1",N:"\u00d1"}},validate:function(b,e,a){return!0}};e.keyboard.comboRegex= /([`\'~\^\"ao])([a-z])/mig;e.keyboard.currentKeyboard="";e.fn.keyboard=function(b){return this.each(function(){e(this).data("keyboard")||new e.keyboard(this,b)})};e.fn.getkeyboard=function(){return this.data("keyboard")}})(jQuery);
(function(e,b,m,a){e.fn.caret=function(d,e){if("undefined"===typeof this[0]||this.is(":hidden")||"hidden"===this.css("visibility"))return this;var c,g,l,k,f;f=document.selection;var n=this[0],p=n.scrollTop,q=!1,s=!0;try{q="undefined"!==typeof n.selectionStart}catch(r){s=!1}"object"===typeof d&&d.start&&d.end?(g=d.start,k=d.end):"number"===typeof d&&"number"===typeof e&&(g=d,k=e);if(s&&"undefined"!==typeof g)return q?(n.selectionStart=g,n.selectionEnd=k):(f=n.createTextRange(),f.collapse(!0),f.moveStart("character", g),f.moveEnd("character",k-g),f.select()),(this.is(":visible")||"hidden"!==this.css("visibility"))&&this.focus(),n.scrollTop=p,this;q?(c=n.selectionStart,l=n.selectionEnd):f?"TEXTAREA"===n.tagName?(k=this.val(),g=f[m](),f=g[a](),f.moveToElementText(n),f.setEndPoint("EndToEnd",g),c=f.text.replace(/\r/g,"\n")[b],l=c+g.text.replace(/\r/g,"\n")[b]):(k=this.val().replace(/\r/g,"\n"),g=f[m]()[a](),g.moveEnd("character",k[b]),c=""===g.text?k[b]:k.lastIndexOf(g.text),g=f[m]()[a](),g.moveStart("character", -k[b]),l=g.text[b]):(c=0,l=(n.value||"").length);f=(n.value||"").substring(c,l);return{start:c,end:l,text:f,replace:function(a){return n.value.substring(0,c)+a+n.value.substring(l,n.value[b])}}}})(jQuery,"length","createRange","duplicate");
/* jQuery UI Virtual Keyboard Typing Simulator v1.4 for Keyboard v1.18+ only (3/1/2014) */
;(function(g){g.fn.addTyping=function(k){var l={showTyping:!0,delay:250};return this.each(function(){var a=g(this).data("keyboard");a&&(a.typing_options=g.extend({},l,k),a.typing_keymap={" ":"space",'"':"34","'":"39","&nbsp;":"space","\b":"bksp","\n":"Enter","\r":"Enter","\t":"tab"},a.typing_xref={8:"bksp",9:"tab",13:"enter",32:"space"},a.typing_event=!1,a.typing_setup=function(){(a.$preview?a.$preview:a.$el).bind("keyup.keyboard",function(b){37<=b.which&&40>=b.which||(16===b.which&&(a.shiftActive= !1),18===b.which&&(a.altActive=!1),16!==b.which&&18!==b.which)||(a.showKeySet(),setTimeout(function(){a.$preview.focus()},200))}).bind("keydown.keyboard",function(b){b.temp=!1;16===b.which&&(b.temp=a.shiftActive?!1:!0,a.shiftActive=!0);18===b.which&&(b.temp=a.altActive?!1:!0,a.altActive=!0);b.temp&&(a.showKeySet(),a.$preview.focus());a.typing_event=!0;8!==b.which&&9!==b.which||a.typeIn("",a.typing_options.delay||250,function(){a.typing_event=!1},b)}).bind("keypress.keyboard",function(b){a.typing_event&& !a.options.lockInput&&a.typeIn("",a.typing_options.delay||250,function(){a.typing_event=!1},b)})},a.typeIn=function(b,e,f,c){if(a.isVisible()){var d=a.typing_options,h=g.keyboard.builtLayouts[a.layout].mappedKeys;!0!==a.typing_options.init&&(d.init=!0,d.text=b,d.len=b.length,d.delay=e||300,d.current=0,d.callback=f);b=d.text.substring(d.current,++d.current);e=a.$keyboard.find(".ui-keyboard-keyset");f='.ui-keyboard-button[data-value="'+(a.typing_keymap.hasOwnProperty(b)?a.typing_keymap[b]:b)+'"]';a.typing_event&& c&&(a.typing_xref.hasOwnProperty(c.keyCode||c.which)?f=".ui-keyboard-"+a.typing_xref[c.keyCode||c.which]:(f=String.fromCharCode(c.charCode||c.which),f=h.hasOwnProperty(f)?'.ui-keyboard-button[data-value="'+h[f]+'"]':".ui-keyboard-"+(c.charCode||c.which)));c=e.filter(":visible").find(f);c.length?a.typing_simulateKey(c,b):(a.typing_event?c=e.find(f):(c=a.typing_keymap.hasOwnProperty(b)?a.typing_keymap[b]:b.charCodeAt(0),"bksp"===c&&(b=c),c=e.find(".ui-keyboard-"+c)),e=c.closest(".ui-keyboard-keyset"), e.attr("name")?(e=e.attr("name"),a.shiftActive=/shift/.test(e),a.altActive=/alt/.test(e),a.metaActive=a.lastKeyset[2]=e.match(/meta\d+/)||!1,a.showKeySet({name:a.metaActive}),a.typing_simulateKey(c,b)):a.typing_event||(a.insertText(b),a.checkCombos()));d.current<d.len?a.isVisible()&&setTimeout(function(){a.typeIn()},d.delay):(d.init=!1,g.isFunction(d.callback)&&setTimeout(function(){d.callback(a)},d.delay))}else a.typing_options.init=!1,clearTimeout(a.typing_timer)},a.typing_simulateKey=function(b, e){var f=b.length;f&&b.filter(":visible").trigger("mouseenter.keyboard");a.typing_timer=setTimeout(function(){f&&setTimeout(function(){b.trigger("mouseleave.keyboard")},a.typing_options.delay/3);a.isVisible()&&!a.typing_event&&(a.insertText(e),a.checkCombos())},a.typing_options.delay/3)},a.typing_options.showTyping&&(a.options.alwaysOpen&&a.isVisible()&&a.typing_setup(),a.$el.bind("visible.keyboard",function(){a.typing_setup()})))})}})(jQuery);
/*!
jQuery yellowFade plugin Version: 1.0.0
Copyright (c) 2012 Andrey Sidorov, licensed under MIT license.
https://github.com/morr/jquery.yellowFade/
*/
!function(n){function r(n){function r(n){return isNaN(n)?"00":c[(n-n%16)/16]+c[n%16]}var c=["0","1","2","3","4","5","6","7","8","9","a","b","c","d","e","f"];return n=n.match(/^rgb\((\d+),\s*(\d+),\s*(\d+)\)$/),"#"+r(n[1])+r(n[2])+r(n[3])}n.fn.yellowFade=function(){return this.each(function(){var c=n(this);c.stop(!0,!0);var a=c.css("background-color"),o=!1;("transparent"==a||""==a||"rgba(0, 0, 0, 0)"==a)&&(a="#FFFFFF",o=!0),a.match(/^rgb\(/)&&(a=r(a)),c.css("background-color","#3C9DD2").animate({"background-color":a},1500,function(){o&&n(this).css("background-color","transparent")})})}}(jQuery);
/*! jquery.ui.checklist3 */
!function(e){e.widget("ui.checkList",{options:{col2:"",listItems:[],selectedItems:[],effect:"blink",filtertxt:"filter",tfilter:!1,colopts:1,radio:!1,tdback:"#FFFFFF",tdhigh:"#CCCCCC",headertxt:"",onChange:{},objTable:"",icount:0,r_cb:!0,prefix:"",altrows:!1,evenrow:"#B3B3B3",oddrow:"#E6E6E6",cbbgr:"transparent",locked:!1},_create:function(){var t=this,c=t.options,a=t.element,s=e("<div/>").addClass("checkList");if(c.objTable=e("<table/>").addClass("table"),c.tfilter){var o=e("<div/>").addClass("toolbar"),n=e("<input/>").attr("type","text").addClass("txtFilter").keyup(function(){t._filter(e(this).val())});o.append(e("<div/>").addClass("filterbox").text(c.filtertxt).append(n)),s.append(o)}s.append(c.objTable),a.append(s),t.loadList()},_addItem:function(t){var c=this,a=c.options,s=c.element,o=a.prefix+"itm"+a.icount++,n=e("<tr/>"),i=e("<span />").attr("id",o).css("margin-right","5px").css("background-color",a.cbbgr).addClass("icn_checkboxempty_c_n clckbtn chk").attr("data-text",t.text).attr("data-value",t.value).attr("data-help",t.help).attr("data-checked",!1);a.r_cb||i.css("visibility","hidden"),n.append(e("<td/>").append(i));var d=e("<label/>").attr("for",o).text(t.text);if(n.append(e("<td/>").append(d)),2==a.colopts){var d=e("<label/>").attr("for",o).text(t.text2);void 0==typeof col2?n.append(e('<td style="border-left: 1px solid black; padding-left: 5px;" />').append(d)):n.append(e('<td style="border-left: 1px solid black; padding-left: 5px;" class="col2" />').append(d))}a.objTable.append(n),s.delegate("#"+o,"click",function(){c._selChange("#"+o)})},loadList:function(){var t=this,c=t.options;t.element;c.objTable.empty(),e.each(c.listItems,function(){t._addItem(this)})},_selChange:function(t){var c=this,a=c.options;c.element;if(a.locked)return!1;if(a.radio){if(1==e(t).data("checked"))return!1;sts=a.objTable.find(t).data("checked"),a.objTable.find(".chk").data("checked",!1).removeClass("icn_checkboxchecked_c_n").addClass("icn_checkboxempty_c_n"),a.objTable.find(t).data("checked",!sts),sts?a.objTable.find(t).removeClass("icn_checkboxchecked_c_n").addClass("icn_checkboxempty_c_n"):a.objTable.find(t).removeClass("icn_checkboxempty_c_n").addClass("icn_checkboxchecked_c_n")}else void 0!==t&&(sts=e(t).data("checked"),sts?e(t).data("checked",!1).removeClass("icn_checkboxchecked_c_n").addClass("icn_checkboxempty_c_n"):e(t).data("checked",!0).removeClass("icn_checkboxempty_c_n").addClass("icn_checkboxchecked_c_n"));a.selectedItems=[],a.objTable.find(".chk").each(function(){e(this).data("checked")?(a.selectedItems.push({text:e(this).attr("data-text"),value:e(this).attr("data-value")}),e(this).parent().css("background-color",a.tdhigh).siblings().css("background-color",a.tdhigh)):a.altrows?e(this).attr("id").split("itm")[1]%2==0?e(this).parent().css("background-color",a.evenrow).siblings().css("background-color",a.evenrow):e(this).parent().css("background-color",a.oddrow).siblings().css("background-color",a.oddrow):e(this).parent().css("background-color",a.tdback).siblings().css("background-color",a.tdback)}),a.onChange.call(void 0,t)},_filter:function(t){var c=this,a=c.options;c.element;a.objTable.find(".chk").each(function(){e(this).attr("data-text").toLowerCase().indexOf(t.toLowerCase())>-1?e(this).parent().parent().show("none"==a.effect?null:a.effect):e(this).parent().parent().hide("none"==a.effect?null:a.effect)})},getSelection:function(){var e=this,t=e.options;e.element;return t.selectedItems},getOptions:function(){var e=this,t=e.options;return t},getOption:function(e){var t=this,c=t.options;return c[e]},setOption:function(e){var t=this,c=t.options;t.element;e=e.split(":");var a=e[0],s=e[1];return"true"==s&&(s=!0),"false"==s&&(s=!1),t.options[a]=s,c[a]},setSelection:function(t){var c=this,a=c.options,s=c.element;""!=t&&($tdimg=e(s).find("span[data-value='"+t+"']"),$tdimg.data("checked",!0).removeClass("icn_checkboxempty_c_n").addClass("icn_checkboxchecked_c_n"),e($tdimg).parent().css("background-color",a.tdhigh).siblings().css("background-color",a.tdhigh))},resetSelection:function(t){var c=this,a=c.options,s=c.element;""!=t&&($tdimg=e(s).find("span[data-value='"+t+"']"),$tdimg.data("checked",!1).removeClass("icn_checkboxchecked_c_n").addClass("icn_checkboxempty_c_n"),a.altrows?e($tdimg).attr("id").split("itm")[1]%2==0?e($tdimg).parent().css("background-color",a.evenrow).siblings().css("background-color",a.evenrow):e($tdimg).parent().css("background-color",a.oddrow).siblings().css("background-color",a.oddrow):e($tdimg).parent().css("background-color",a.tdback).siblings().css("background-color",a.tdback))},resetAll:function(){var t=this,c=t.options,a=t.element;e(a).find("span").each(function(){e(this).data("checked",!1).removeClass("icn_checkboxchecked_c_n").addClass("icn_checkboxempty_c_n"),c.altrows?e(this).attr("id").split("itm")[1]%2==0?e(this).parent().css("background-color",c.evenrow).siblings().css("background-color",c.evenrow):e(this).parent().css("background-color",c.oddrow).siblings().css("background-color",c.oddrow):e(this).parent().css("background-color",c.tdback).siblings().css("background-color",c.tdback)})},setData:function(e){var t=this,c=t.options;t.element;c.listItems=e,t.loadList(),t._selChange()}})}(jQuery);
/*!
jQuery number plug-in 2.1.5
Copyright 2012, Digital Fusion
Licensed under the MIT license
*/
!function(e){"use strict";function t(e,t){if(this.createTextRange){var a=this.createTextRange();a.collapse(!0),a.moveStart("character",e),a.moveEnd("character",t-e),a.select()}else this.setSelectionRange&&(this.focus(),this.setSelectionRange(e,t))}function a(e){var t=this.value.length;if(e="start"==e.toLowerCase()?"Start":"End",document.selection){var a,i,n,l=document.selection.createRange();return a=l.duplicate(),a.expand("textedit"),a.setEndPoint("EndToEnd",l),i=a.text.length-l.text.length,n=i+l.text.length,"Start"==e?i:n}return"undefined"!=typeof this["selection"+e]&&(t=this["selection"+e]),t}var i={codes:{46:127,188:44,109:45,190:46,191:47,192:96,220:92,222:39,221:93,219:91,173:45,187:61,186:59,189:45,110:46},shifts:{96:"~",49:"!",50:"@",51:"#",52:"$",53:"%",54:"^",55:"&",56:"*",57:"(",48:")",45:"_",61:"+",91:"{",93:"}",92:"|",59:":",39:'"',44:"<",46:">",47:"?"}};e.fn.number=function(n,l,s,r){r="undefined"==typeof r?",":r,s="undefined"==typeof s?".":s,l="undefined"==typeof l?0:l;var u="\\u"+("0000"+s.charCodeAt(0).toString(16)).slice(-4),h=new RegExp("[^"+u+"0-9]","g"),o=new RegExp(u,"g");return n===!0?this.is("input:text")?this.on({"keydown.format":function(n){var u=e(this),h=u.data("numFormat"),o=n.keyCode?n.keyCode:n.which,c="",v=a.apply(this,["start"]),d=a.apply(this,["end"]),p="",f=!1;if(i.codes.hasOwnProperty(o)&&(o=i.codes[o]),!n.shiftKey&&o>=65&&90>=o?o+=32:!n.shiftKey&&o>=69&&105>=o?o-=48:n.shiftKey&&i.shifts.hasOwnProperty(o)&&(c=i.shifts[o]),""==c&&(c=String.fromCharCode(o)),8!=o&&45!=o&&127!=o&&c!=s&&!c.match(/[0-9]/)){var g=n.keyCode?n.keyCode:n.which;if(46==g||8==g||127==g||9==g||27==g||13==g||(65==g||82==g||80==g||83==g||70==g||72==g||66==g||74==g||84==g||90==g||61==g||173==g||48==g)&&(n.ctrlKey||n.metaKey)===!0||(86==g||67==g||88==g)&&(n.ctrlKey||n.metaKey)===!0||g>=35&&39>=g||g>=112&&123>=g)return;return n.preventDefault(),!1}if(0==v&&d==this.value.length?8==o?(v=d=1,this.value="",h.init=l>0?-1:0,h.c=l>0?-(l+1):0,t.apply(this,[0,0])):c==s?(v=d=1,this.value="0"+s+new Array(l+1).join("0"),h.init=l>0?1:0,h.c=l>0?-(l+1):0):45==o?(v=d=2,this.value="-0"+s+new Array(l+1).join("0"),h.init=l>0?1:0,h.c=l>0?-(l+1):0,t.apply(this,[2,2])):(h.init=l>0?-1:0,h.c=l>0?-l:0):h.c=d-this.value.length,h.isPartialSelection=v==d?!1:!0,l>0&&c==s&&v==this.value.length-l-1)h.c++,h.init=Math.max(0,h.init),n.preventDefault(),f=this.value.length+h.c;else if(45!=o||0==v&&0!=this.value.indexOf("-"))if(c==s)h.init=Math.max(0,h.init),n.preventDefault();else if(l>0&&127==o&&v==this.value.length-l-1)n.preventDefault();else if(l>0&&8==o&&v==this.value.length-l)n.preventDefault(),h.c--,f=this.value.length+h.c;else if(l>0&&127==o&&v>this.value.length-l-1){if(""===this.value)return;"0"!=this.value.slice(v,v+1)&&(p=this.value.slice(0,v)+"0"+this.value.slice(v+1),u.val(p)),n.preventDefault(),f=this.value.length+h.c}else if(l>0&&8==o&&v>this.value.length-l){if(""===this.value)return;"0"!=this.value.slice(v-1,v)&&(p=this.value.slice(0,v-1)+"0"+this.value.slice(v),u.val(p)),n.preventDefault(),h.c--,f=this.value.length+h.c}else 127==o&&this.value.slice(v,v+1)==r?n.preventDefault():8==o&&this.value.slice(v-1,v)==r?(n.preventDefault(),h.c--,f=this.value.length+h.c):l>0&&v==d&&this.value.length>l+1&&v>this.value.length-l-1&&isFinite(+c)&&!n.metaKey&&!n.ctrlKey&&!n.altKey&&1===c.length&&(p=d===this.value.length?this.value.slice(0,v-1):this.value.slice(0,v)+this.value.slice(v+1),this.value=p,f=v);else n.preventDefault();f!==!1&&t.apply(this,[f,f]),u.data("numFormat",h)},"keyup.format":function(i){var n,s=e(this),r=s.data("numFormat"),u=i.keyCode?i.keyCode:i.which,h=a.apply(this,["start"]),o=a.apply(this,["end"]);0!==h||0!==o||189!==u&&109!==u||(s.val("-"+s.val()),h=1,r.c=1-this.value.length,r.init=1,s.data("numFormat",r),n=this.value.length+r.c,t.apply(this,[n,n])),""===this.value||(48>u||u>57)&&(96>u||u>105)&&8!==u&&46!==u&&110!==u||(s.val(s.val()),l>0&&(r.init<1?(h=this.value.length-l-(r.init<0?1:0),r.c=h-this.value.length,r.init=1,s.data("numFormat",r)):h>this.value.length-l&&8!=u&&(r.c++,s.data("numFormat",r))),46!=u||r.isPartialSelection||(r.c++,s.data("numFormat",r)),n=this.value.length+r.c,t.apply(this,[n,n]))},"paste.format":function(t){var a=e(this),i=t.originalEvent,n=null;return window.clipboardData&&window.clipboardData.getData?n=window.clipboardData.getData("Text"):i.clipboardData&&i.clipboardData.getData&&(n=i.clipboardData.getData("text/plain")),a.val(n),t.preventDefault(),!1}}).each(function(){var t=e(this).data("numFormat",{c:-(l+1),decimals:l,thousands_sep:r,dec_point:s,regex_dec_num:h,regex_dec:o,init:this.value.indexOf(".")?!0:!1});""!==this.value&&t.val(t.val())}):this.each(function(){var t=e(this),a=+t.text().replace(h,"").replace(o,".");t.number(isFinite(a)?+a:0,l,s,r)}):this.text(e.number.apply(window,arguments))};var n=null,l=null;e.isPlainObject(e.valHooks.text)?(e.isFunction(e.valHooks.text.get)&&(n=e.valHooks.text.get),e.isFunction(e.valHooks.text.set)&&(l=e.valHooks.text.set)):e.valHooks.text={},e.valHooks.text.get=function(t){var a,i=e(t),l=i.data("numFormat");return l?""===t.value?"":(a=+t.value.replace(l.regex_dec_num,"").replace(l.regex_dec,"."),(0===t.value.indexOf("-")?"-":"")+(isFinite(a)?a:0)):e.isFunction(n)?n(t):void 0},e.valHooks.text.set=function(t,a){var i=e(t),n=i.data("numFormat");if(n){var s=e.number(a,n.decimals,n.dec_point,n.thousands_sep);return e.isFunction(l)?l(t,s):t.value=s}return e.isFunction(l)?l(t,a):void 0},e.number=function(e,t,a,i){i="undefined"==typeof i?"1000"!==new Number(1e3).toLocaleString()?new Number(1e3).toLocaleString().charAt(1):"":i,a="undefined"==typeof a?new Number(.1).toLocaleString().charAt(1):a,t=isFinite(+t)?Math.abs(t):0;var n="\\u"+("0000"+a.charCodeAt(0).toString(16)).slice(-4),l="\\u"+("0000"+i.charCodeAt(0).toString(16)).slice(-4);e=(e+"").replace(".",a).replace(new RegExp(l,"g"),"").replace(new RegExp(n,"g"),".").replace(new RegExp("[^0-9+-Ee.]","g"),"");var s=isFinite(+e)?+e:0,r="",u=function(e,t){return""+ +(Math.round((""+e).indexOf("e")>0?e:e+"e+"+t)+"e-"+t)};return r=(t?u(s,t):""+Math.round(s)).split("."),r[0].length>3&&(r[0]=r[0].replace(/\B(?=(?:\d{3})+(?!\d))/g,i)),(r[1]||"").length<t&&(r[1]=r[1]||"",r[1]+=new Array(t-r[1].length+1).join("0")),r.join(a)}}(jQuery);